(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4114,        111]
NotebookOptionsPosition[      3383,         89]
NotebookOutlinePosition[      3817,        106]
CellTagsIndexPosition[      3774,        103]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"RREFFreqs", " ", "=", " ", 
  RowBox[{"Last", "[", 
   RowBox[{"Transpose", "[", 
    RowBox[{"RowReduce", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", "eigenv", "]"}], ",", 
        RowBox[{"{", "eigenf", "}"}]}], "]"}], "]"}], "]"}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.916366584416212*^9, 3.916366615280507*^9}, {
  3.91636665532215*^9, 3.9163668132481036`*^9}, {3.9163669206321516`*^9, 
  3.916366945519141*^9}, {3.9163669902795706`*^9, 3.9163669941670184`*^9}, {
  3.9163671488720713`*^9, 3.916367149582344*^9}, {3.916367180479287*^9, 
  3.9163672391509953`*^9}, {3.9163673242629004`*^9, 3.9163673278544955`*^9}},
 CellLabel->
  "In[122]:=",ExpressionUUID->"6800cf54-af3b-4531-99b0-ac5ea5bbd571"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"298.7534853438485`", ",", 
   RowBox[{"-", "343.9528034949026`"}], ",", 
   RowBox[{"-", "128.92478710854365`"}], ",", 
   RowBox[{"-", "75.12023060995679`"}], ",", "112.88441629935245`", ",", 
   RowBox[{"-", "2.8119788208024015`"}], ",", "185.58642568488554`", ",", 
   "346.82946382346785`", ",", 
   RowBox[{"-", "59.390311688257704`"}], ",", "29.197436441898095`", ",", 
   RowBox[{"-", "1.3124359114056274`"}], ",", "0.39081733417342107`", ",", 
   RowBox[{"-", "84.46389942050497`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.916366596022523*^9, 3.916366615850251*^9}, {
   3.9163666651698914`*^9, 3.9163667066661196`*^9}, {3.9163667388623714`*^9, 
   3.9163668138425016`*^9}, {3.916366924205514*^9, 3.916366946057427*^9}, 
   3.916366994807184*^9, 3.916367187451166*^9, {3.9163672175271463`*^9, 
   3.916367239711875*^9}, 3.9163673285357137`*^9},
 CellLabel->
  "Out[122]=",ExpressionUUID->"504b4787-b60a-47a2-af13-2d11122172aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["VariablesAsTimeBased"], "Input",
 CellChangeTimes->{{3.9163671123119583`*^9, 3.9163671228789563`*^9}},
 CellLabel->
  "In[117]:=",ExpressionUUID->"e26f05d6-4488-449a-a3e5-f99bc9c2dcd8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"yKS", "[", "t", "]"}], ",", 
   RowBox[{"xIM", "[", "t", "]"}], ",", 
   RowBox[{"yIM", "[", "t", "]"}], ",", 
   RowBox[{"zIM", "[", "t", "]"}], ",", 
   RowBox[{"pitchIM", "[", "t", "]"}], ",", 
   RowBox[{"yawIM", "[", "t", "]"}], ",", 
   RowBox[{"rollIM", "[", "t", "]"}], ",", 
   RowBox[{"xTM", "[", "t", "]"}], ",", 
   RowBox[{"yTM", "[", "t", "]"}], ",", 
   RowBox[{"zTM", "[", "t", "]"}], ",", 
   RowBox[{"pitchTM", "[", "t", "]"}], ",", 
   RowBox[{"yawTM", "[", "t", "]"}], ",", 
   RowBox[{"rollTM", "[", "t", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.916367110007394*^9, 3.9163671236483555`*^9}},
 CellLabel->
  "Out[117]=",ExpressionUUID->"322d1b7b-b487-4ed6-ab50-3787b13bf97a"]
}, Open  ]]
},
WindowSize->{1269.375, 711.375},
WindowMargins->{{71.625, Automatic}, {12, Automatic}},
Magnification->0.75,
FrontEndVersion->"13.1 for Microsoft Windows (64-bit) (August 22, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"ab4e7486-32cf-407f-a806-3265898d8194"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 812, 17, 21, "Input",ExpressionUUID->"6800cf54-af3b-4531-99b0-ac5ea5bbd571"],
Cell[1395, 41, 978, 17, 35, "Output",ExpressionUUID->"504b4787-b60a-47a2-af13-2d11122172aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2410, 63, 199, 3, 21, "Input",ExpressionUUID->"e26f05d6-4488-449a-a3e5-f99bc9c2dcd8"],
Cell[2612, 68, 755, 18, 35, "Output",ExpressionUUID->"322d1b7b-b487-4ed6-ab50-3787b13bf97a"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

