(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1767654,      38691]
NotebookOptionsPosition[   1724273,      37779]
NotebookOutlinePosition[   1724763,      37798]
CellTagsIndexPosition[   1724720,      37795]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\

SUMCON
User Interface Package\
\>", "Subtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.5714901739760427`*^9, 3.5714901855827065`*^9}, {
  3.5714910854841785`*^9, 3.5714910877443075`*^9}, {3.639788072646676*^9, 
  3.639788072746682*^9}},ExpressionUUID->"3091ae98-696a-4d43-b3ae-\
dd0105fcabd5"],

Cell[CellGroupData[{

Cell["Start Menu", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5714902042837763`*^9, 
  3.571490206002875*^9}},ExpressionUUID->"4a1c4c0b-40f3-417f-b036-\
6a9c25f71c8f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$VersionSUMCON", "=", "\"\<1.5.0\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570165804528378*^9, 3.5701658306448717`*^9}, {
   3.5856286838974113`*^9, 3.5856286840574207`*^9}, {3.58781367579626*^9, 
   3.5878136784074097`*^9}, {3.590664268677844*^9, 3.5906642688048515`*^9}, {
   3.595218856047539*^9, 3.595218856354557*^9}, 3.6005563137163763`*^9, {
   3.6397881029614105`*^9, 3.639788103081417*^9}, {3.716516663420473*^9, 
   3.716516663831242*^9}, {3.718411636955944*^9, 3.718411639909487*^9}, {
   3.7184155102818604`*^9, 3.718415511052107*^9}, 3.9156635176520863`*^9, {
   3.918068801120966*^9, 
   3.9180688027538147`*^9}},ExpressionUUID->"af1266f6-03d1-4d9f-83db-\
4451ba460049"],

Cell[CellGroupData[{

Cell["Start Menu", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570195631828402*^9, 
  3.570195636265656*^9}},ExpressionUUID->"e25414ee-49e9-48a6-9349-\
4f1595638a7b"],

Cell[CellGroupData[{

Cell["Start Menu", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5672676051910734`*^9, 3.567267617056752*^9}, {
  3.5672679600253687`*^9, 3.5672679608244143`*^9}, {3.5701102435079865`*^9, 
  3.570110244602049*^9}},ExpressionUUID->"d70b95e9-5651-4766-89e9-\
158e57d3972e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$StartSUMCON", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Define"}]}], " ", 
          RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"ValueQ", "[", "tabviewctrl", "]"}], "]"}], ",", 
           RowBox[{"tabviewctrl", "=", "1"}]}], "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"Tabview", " ", "Control", " ", "Number"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"ValueQ", "[", "calcdone", "]"}], "]"}], ",", 
           RowBox[{"calcdone", "=", "False"}]}], "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"Calculated", " ", "or", " ", "not"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Menu"}]}], " ", 
            RowBox[{"Contents", "--"}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", "mod$MenuTopFrame"}], ",", 
        "\[IndentingNewLine]", "mod$MenuSaveLoad", ",", "\[IndentingNewLine]", 
        RowBox[{"TabView", "[", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Model Construction\>\"", ",", "Bold"}], "]"}], 
             "\[Rule]", "mod$MenuModelConstruction"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Calculation Result\>\"", ",", "Bold"}], "]"}], 
             "\[Rule]", "mod$MenuCalculationResult"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Export Model\>\"", ",", "Bold"}], "]"}], "\[Rule]",
              "mod$MenuExportModel"}]}], "\[IndentingNewLine]", "}"}], ",", 
          RowBox[{"Dynamic", "[", "tabviewctrl", "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Window"}]}], " ", 
         RowBox[{"Settings", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowFrameElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<CloseBox\>\"", ",", "\"\<ResizeArea\>\"", ",", "\"\<ZoomBox\>\"",
          ",", "\"\<MinimizeBox\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"920", ",", "600"}], "}"}]}], ",", 
      RowBox[{"WindowMargins", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowTitle", "\[Rule]", 
       RowBox[{"\"\<SUMCON Version:\>\"", "<>", "$VersionSUMCON"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570036512226287*^9, 3.570036657274584*^9}, {
   3.5700366987219543`*^9, 3.570036738090206*^9}, {3.570036976132821*^9, 
   3.5700369833612347`*^9}, {3.5700372655043726`*^9, 
   3.5700372783071046`*^9}, {3.5700374187501373`*^9, 3.570037425862544*^9}, {
   3.570037626914044*^9, 3.5700376359455605`*^9}, {3.570037758407565*^9, 
   3.5700377773906507`*^9}, {3.5700379119943495`*^9, 3.57003791498252*^9}, {
   3.57003800221751*^9, 3.570038010925008*^9}, {3.5700381252195454`*^9, 
   3.570038133155999*^9}, {3.570038188556168*^9, 3.5700381957775807`*^9}, {
   3.570039028310199*^9, 3.570039041663963*^9}, {3.5700394139692574`*^9, 
   3.570039440255761*^9}, {3.5700394754037714`*^9, 3.5700395220214376`*^9}, {
   3.5700395901343336`*^9, 3.570039650021759*^9}, {3.570039692436185*^9, 
   3.5700396948093204`*^9}, {3.570039788723692*^9, 3.5700397898287554`*^9}, {
   3.570039836044399*^9, 3.570039838636547*^9}, {3.570039886998313*^9, 
   3.570039915842963*^9}, {3.5700401578588057`*^9, 3.570040171062561*^9}, {
   3.570040332470793*^9, 3.5700403332968397`*^9}, {3.570040368451851*^9, 
   3.5700404599950867`*^9}, {3.570079899670907*^9, 3.5700799285065565`*^9}, {
   3.5700800007106867`*^9, 3.570080019535763*^9}, {3.5700801101749473`*^9, 
   3.5700801311381464`*^9}, {3.5700808025455484`*^9, 3.570080802675556*^9}, {
   3.570080869802396*^9, 3.570080897482979*^9}, {3.5700810292705164`*^9, 
   3.5700810796844*^9}, {3.5700811464402184`*^9, 3.5700811561097713`*^9}, {
   3.5700951724649725`*^9, 3.5700951879488583`*^9}, {3.5700952379437175`*^9, 
   3.5700952639792066`*^9}, {3.570095310806885*^9, 3.57009531230097*^9}, {
   3.5700954082284575`*^9, 3.5700955198828435`*^9}, {3.5700956025845737`*^9, 
   3.570095607752869*^9}, {3.5700956493892508`*^9, 3.57009572770373*^9}, {
   3.5700960804929085`*^9, 3.570096101434106*^9}, {3.570096184883879*^9, 
   3.5700961927273283`*^9}, {3.5700962525577497`*^9, 
   3.5700962526547556`*^9}, {3.570096318802539*^9, 3.570096377371889*^9}, {
   3.570096526672428*^9, 3.570096652646634*^9}, {3.5700976923150997`*^9, 
   3.570097739454796*^9}, {3.5700977840243444`*^9, 3.5700978048465357`*^9}, {
   3.570098100943472*^9, 3.570098105546735*^9}, {3.5700981706534586`*^9, 
   3.5700984628281703`*^9}, {3.5700984958090568`*^9, 3.570098496936121*^9}, {
   3.5700985300050125`*^9, 3.5700985347792854`*^9}, {3.57009856668311*^9, 
   3.570098580609907*^9}, 3.5700986692889795`*^9, {3.5700987976613216`*^9, 
   3.570098877944914*^9}, {3.5700989222474475`*^9, 3.570098994220564*^9}, {
   3.5700990371190176`*^9, 3.570099052566901*^9}, {3.5700992229796486`*^9, 
   3.5700993755763764`*^9}, {3.570099457238047*^9, 3.5700994613332815`*^9}, {
   3.5700995291121583`*^9, 3.5700995428249426`*^9}, {3.570099636924325*^9, 
   3.5700997415133066`*^9}, 3.57009979629244*^9, {3.5700999711254396`*^9, 
   3.5700999976639576`*^9}, {3.570100081112731*^9, 3.5701003240076237`*^9}, {
   3.5701003620037966`*^9, 3.57010051154035*^9}, {3.5701005783801727`*^9, 
   3.570100579641245*^9}, {3.5701007380683064`*^9, 3.570100895047285*^9}, {
   3.570100929940281*^9, 3.5701010305340347`*^9}, {3.570101149048813*^9, 
   3.570101169779999*^9}, {3.5701012186927967`*^9, 3.5701012259992146`*^9}, {
   3.570103104226643*^9, 3.570103204319368*^9}, {3.570103250997038*^9, 
   3.570103334620821*^9}, {3.5701034165855093`*^9, 3.5701034331534567`*^9}, {
   3.5701034728927298`*^9, 3.570103550493168*^9}, {3.5701036020401163`*^9, 
   3.57010361626693*^9}, {3.5701036825177193`*^9, 3.5701036849118567`*^9}, {
   3.570103715233591*^9, 3.570103774715993*^9}, {3.5701038119811244`*^9, 
   3.570103844738998*^9}, {3.5701039208723526`*^9, 3.5701039527761774`*^9}, {
   3.570104099933594*^9, 3.5701041858625093`*^9}, {3.5701042188913984`*^9, 
   3.5701042484780903`*^9}, {3.570104282611043*^9, 3.5701042890954137`*^9}, 
   3.570104337690193*^9, {3.570104370287058*^9, 3.5701044936041107`*^9}, {
   3.5701045369535904`*^9, 3.570104634927194*^9}, {3.5701046731683817`*^9, 
   3.5701047158728237`*^9}, {3.5701047710229783`*^9, 3.570104786372856*^9}, {
   3.5701048208558283`*^9, 3.5701048272921968`*^9}, {3.5701048803272305`*^9, 
   3.570104894764056*^9}, {3.5701049266738815`*^9, 3.5701049289620123`*^9}, {
   3.5701049807249727`*^9, 3.5701050326129403`*^9}, {3.5701050765964565`*^9, 
   3.5701051366558914`*^9}, {3.5701051780262575`*^9, 
   3.5701052555976944`*^9}, {3.570105291819766*^9, 3.5701053132979946`*^9}, {
   3.5701053634398627`*^9, 3.5701053741384745`*^9}, {3.5701085977728558`*^9, 
   3.570108600979039*^9}, {3.5701114479068747`*^9, 3.5701114507310357`*^9}, {
   3.5701213140211835`*^9, 3.5701213523063736`*^9}, {3.5701330306493363`*^9, 
   3.570133031141365*^9}, {3.5701330673244343`*^9, 3.5701330819462705`*^9}, {
   3.5701659950642757`*^9, 3.5701660376707134`*^9}, {3.5701708875171084`*^9, 
   3.570170918592886*^9}, {3.5701709586371765`*^9, 3.5701710170755186`*^9}, {
   3.570171176928662*^9, 3.5701711787997684`*^9}, {3.5701955847747107`*^9, 
   3.5701955873978605`*^9}, {3.5702550526218824`*^9, 
   3.5702550586278925`*^9}, {3.5702882173845177`*^9, 3.570288220478695*^9}, {
   3.5702973360960784`*^9, 3.570297396495533*^9}, {3.5702974316585445`*^9, 
   3.570297523077773*^9}, {3.570297559620863*^9, 3.5702975912356715`*^9}, {
   3.5702976406284966`*^9, 3.570297661246676*^9}, {3.570363860191163*^9, 
   3.570363948461211*^9}, {3.5703640003881817`*^9, 3.5703640123258643`*^9}, {
   3.570364294631011*^9, 3.5703642983982267`*^9}, {3.570379090506908*^9, 
   3.5703790932100625`*^9}, {3.5706407604510975`*^9, 3.570640781376294*^9}, {
   3.5706410999515157`*^9, 3.570641101679614*^9}, {3.570642330433895*^9, 
   3.570642330920923*^9}, {3.570708842253481*^9, 3.5707088453076563`*^9}, {
   3.5707117032931232`*^9, 3.570711714009736*^9}, {3.5707257460649676`*^9, 
   3.570725799733037*^9}, {3.570770527482097*^9, 3.5707705346935096`*^9}, {
   3.570770649361068*^9, 3.570770680912873*^9}, 3.5707709595548105`*^9, 
   3.5707710609836116`*^9, {3.570855899583596*^9, 3.570855925378072*^9}, {
   3.5708594859987273`*^9, 3.5708594862287407`*^9}, {3.571057532280692*^9, 
   3.571057539673115*^9}, 3.571231779270361*^9, {3.571231811454202*^9, 
   3.5712318182035885`*^9}, {3.571300104816359*^9, 3.571300134310046*^9}, 
   3.5713381000092044`*^9, {3.571338156261422*^9, 3.57133816147572*^9}, {
   3.5713385548302183`*^9, 3.5713385551952395`*^9}, {3.5713398012515097`*^9, 
   3.5713398264889536`*^9}, {3.571339974083395*^9, 3.571339978171629*^9}, {
   3.5713401598110185`*^9, 3.5713401647443004`*^9}, 3.5713403738622613`*^9, {
   3.5713405189285583`*^9, 3.571340539946761*^9}, 3.5713413761495886`*^9, {
   3.571430334696435*^9, 3.5714303426848917`*^9}, {3.5714707828259325`*^9, 
   3.5714708095614614`*^9}, {3.571470883872712*^9, 3.5714708841557283`*^9}, {
   3.585630716095646*^9, 3.585630722859033*^9}, {3.585630755567904*^9, 
   3.5856309066395445`*^9}, {3.5856309606096315`*^9, 
   3.5856309607806416`*^9}, {3.585631030023602*^9, 3.585631052809905*^9}, {
   3.585631187117587*^9, 3.585631191119816*^9}, {3.585631483026512*^9, 
   3.5856315104260793`*^9}, {3.5856315940168605`*^9, 
   3.5856316721933317`*^9}, {3.5856317246003294`*^9, 
   3.5856318075440736`*^9}, {3.5856318623202066`*^9, 
   3.5856320113377295`*^9}, {3.585632163504433*^9, 3.585632174160043*^9}, {
   3.5856324053672667`*^9, 3.58563244633461*^9}, {3.5856324973715296`*^9, 
   3.5856325164366198`*^9}, {3.5856325470233693`*^9, 3.585632575929023*^9}, {
   3.585632752559125*^9, 3.585632803580044*^9}, {3.58563286786172*^9, 
   3.585632867964726*^9}, {3.5856329315633636`*^9, 3.585632976142914*^9}, {
   3.585633033182176*^9, 3.5856330775167117`*^9}, {3.585633112208696*^9, 
   3.585633116685952*^9}, {3.5856331779024534`*^9, 3.5856332746389866`*^9}, {
   3.585633356102646*^9, 3.585633369423408*^9}, {3.5856334103327475`*^9, 
   3.585633450372038*^9}, {3.585633484939015*^9, 3.585633547663603*^9}, {
   3.5856338305047803`*^9, 3.5856339446583095`*^9}, {3.585634025895956*^9, 
   3.585634027380041*^9}, {3.5856342191740108`*^9, 3.585634247556634*^9}, {
   3.585634287421914*^9, 3.585634415745254*^9}, {3.585634472446497*^9, 
   3.5856344726545095`*^9}, {3.5856946746435137`*^9, 3.585694689725376*^9}, {
   3.5856957812928104`*^9, 3.5856957835859413`*^9}, {3.585695838423078*^9, 
   3.5856958401781783`*^9}, {3.5856960320401525`*^9, 3.5856961015121255`*^9}, 
   3.585696813270836*^9, 3.5857185312740345`*^9, {3.585718623370302*^9, 
   3.585718623579314*^9}, {3.5857186794925127`*^9, 3.585718703870907*^9}, {
   3.585718761167184*^9, 3.585718909147648*^9}, {3.585718983331891*^9, 
   3.5857190061531963`*^9}, {3.5857192204184513`*^9, 3.585719221982541*^9}, {
   3.585719297821879*^9, 3.5857194839645257`*^9}, {3.585719601728261*^9, 
   3.585719791159096*^9}, {3.5857198365156903`*^9, 3.585719882997349*^9}, {
   3.5857199364544067`*^9, 3.5857199756526484`*^9}, {3.5857217065006475`*^9, 
   3.585721724236662*^9}, {3.5857281788348436`*^9, 3.58572840291266*^9}, {
   3.5857284699254932`*^9, 3.585728646207576*^9}, {3.5857320625669804`*^9, 
   3.5857320701334133`*^9}, {3.5857383444792852`*^9, 
   3.5857383463223906`*^9}, {3.5857388804379406`*^9, 
   3.5857389081555257`*^9}, {3.585738974701332*^9, 3.5857389930853834`*^9}, {
   3.5857391074999275`*^9, 3.5857391079529533`*^9}, {3.585886767102229*^9, 
   3.585886770646432*^9}, {3.585886801582201*^9, 3.5858868346290913`*^9}, {
   3.586650985084099*^9, 3.5866509885212955`*^9}, {3.586651021910205*^9, 
   3.586651083320718*^9}, {3.5866511377508307`*^9, 3.586651260840871*^9}, {
   3.586651631845091*^9, 3.586651659866694*^9}, {3.586651711449644*^9, 
   3.586651870728755*^9}, {3.5905594202514505`*^9, 3.590559512677737*^9}, {
   3.5905595707540593`*^9, 3.5905595724401555`*^9}, {3.5906526624477215`*^9, 
   3.590652740916209*^9}, {3.590779831747761*^9, 3.590779878153415*^9}, {
   3.5952188715574265`*^9, 3.5952188742445803`*^9}, {3.5952189078155003`*^9, 
   3.5952189202402105`*^9}, {3.5952189508489614`*^9, 3.595218980573662*^9}, {
   3.5952190521077533`*^9, 3.5952190533128223`*^9}, {3.5952191491643047`*^9, 
   3.595219250894123*^9}, {3.5952193271734858`*^9, 3.59521937864443*^9}, {
   3.595219453637719*^9, 3.5952194856925526`*^9}, {3.595219547326078*^9, 
   3.5952195647570753`*^9}, 3.595219776635194*^9},
 CellLabel->"In[4]:=",ExpressionUUID->"6626af03-fc37-4b7a-ac37-aa60372d7bbc"]
}, Closed]],

Cell[CellGroupData[{

Cell["Top Frame", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.595218996526574*^9, 
  3.595218999816762*^9}},ExpressionUUID->"93520f58-7c71-448d-be15-\
c39584e21063"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuTopFrame", ":=", "\[IndentingNewLine]", 
   RowBox[{"TableForm", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Image", "[", 
        RowBox[{"titleSUMCON", ",", 
         RowBox[{"ImageSize", "\[Rule]", "320"}]}], "]"}], ",", 
       RowBox[{"(*", 
        RowBox[{"Title", " ", "Image"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"\"\<SUMCON Version: \>\"", "<>", "$VersionSUMCON"}], 
             ",", "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
           RowBox[{"(*", "Version", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<About SUMCON\>\"", ",", "Bold", ",", "Black"}],
                   "]"}], ",", "mod$AboutSUMCON", ",", 
                 RowBox[{"(*", 
                  RowBox[{"About", " ", "SUMCON"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                 ",", 
                 RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Version Info\>\"", ",", "Bold", ",", "Black"}],
                   "]"}], ",", "mod$VersionInfo", ",", 
                 RowBox[{"(*", 
                  RowBox[{"Version", " ", "Info"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                 ",", 
                 RowBox[{"Background", "\[Rule]", "Cyan"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Refresh\>\"", ",", "Bold", ",", "White"}], 
                  "]"}], ",", 
                 RowBox[{"DialogReturn", "[", "mod$StartSUMCON", "]"}], ",", 
                 RowBox[{"(*", 
                  RowBox[{"Quit", " ", "Button"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                 ",", 
                 RowBox[{"Background", "\[Rule]", "Red"}]}], "]"}]}], "}"}], 
             "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5952190034459696`*^9, 3.595219009722329*^9}, {
  3.6689828975538163`*^9, 3.6689828976368213`*^9}, {3.918070236912775*^9, 
  3.9180702414415455`*^9}},ExpressionUUID->"5e418d84-8508-4740-a4e7-\
e5d5f6674531"]
}, Closed]],

Cell[CellGroupData[{

Cell["Save and Load", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.595219030479516*^9, 
  3.595219032680642*^9}},ExpressionUUID->"206ae7b7-99ae-476a-a502-\
648eb983c387"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuSaveLoad", ":=", "\[IndentingNewLine]", 
    RowBox[{"TableForm", "[", 
     RowBox[{"{", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Button", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<New Model\>\"", ",", "Bold", ",", "Black"}], "]"}], 
          ",", "mod$NewModel", ",", "\[IndentingNewLine]", 
          RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Button", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<Load Model\>\"", ",", "Bold", ",", "White"}], "]"}], 
          ",", "mod$LoadModel", ",", "\[IndentingNewLine]", 
          RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Button", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<Save Model\>\"", ",", "Bold", ",", "Black"}], "]"}], 
          ",", "mod$SaveModel", ",", "\[IndentingNewLine]", 
          RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
          RowBox[{"Background", "\[Rule]", "Yellow"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Dynamic", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ValueQ", "[", "save$FileName", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"save$FileName", "<>", "\"\<.m\>\""}], ",", "Black"}], 
            "]"}], ",", 
           RowBox[{"save$FileName", ";", "\"\<\>\""}]}], "]"}], "]"}]}], 
       "}"}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5952190347357597`*^9, 3.5952190601152115`*^9}, {
  3.5952191385166955`*^9, 3.595219139261738*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"c59bf594-c53d-43c0-8cff-d684991f7f0d"]
}, Closed]],

Cell[CellGroupData[{

Cell["Tab1: Model Construction", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5952192576645107`*^9, 3.5952192616077356`*^9}, {
  3.5952195279799714`*^9, 
  3.595219529982086*^9}},ExpressionUUID->"9b918f18-5fc7-455b-96d9-\
26424a7a006d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuModelConstruction", ":=", "\[IndentingNewLine]", 
   RowBox[{"TableForm", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "1."}]}], " ", "Define", " ", "Rigid", " ", 
        RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Item", "[", 
       RowBox[{
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Step 1. Define Rigid Bodies\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"870", ",", "30"}], "}"}]}], ",", 
          RowBox[{"Alignment", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"0", ",", "0", ",", "0.3"}], "]"}]}]}], "]"}], ",", 
      "\"\<\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"TableForm", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TableForm", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<1-1 \\nSet Body Names\>\"", ",", "Bold", ",", "Black"}],
                  "]"}], ",", "mod$SetBodyNames", ",", "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"Set", " ", "Mass"}], " ", "&"}], " ", "MoI"}], 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<1-2 \\nSet Mass & MoI\>\"", ",", "Bold", ",", "Black"}],
                  "]"}], ",", "mod$SetMassMoI", ",", "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Set", " ", "Body", " ", "Shapes"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<1-3 \\nSet Body Shapes\>\"", ",", "Bold", ",", 
                  "Black"}], "]"}], ",", "mod$SetBodyShapes", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Set", " ", "Initial", " ", "Position"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<1-4 \\nSet Initial Position\>\"", ",", "Bold", ",", 
                  "Black"}], "]"}], ",", "mod$SetInitPos", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.6", ",", "0.7"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "}"}], 
            "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
           "mod$ShowBodyList"}], "\[IndentingNewLine]", "}"}], "}"}], ",", 
        RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], ",", 
      "\"\<\>\"", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "2."}]}], " ", "Define", " ", 
         RowBox[{"Connections", "--"}]}], "-"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Item", "[", 
       RowBox[{
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Step 2. Define Connections\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"870", ",", "30"}], "}"}]}], ",", 
          RowBox[{"Alignment", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"0", ",", "0.3", ",", "0"}], "]"}]}]}], "]"}], ",", 
      "\"\<\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"TableForm", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TableForm", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Set", " ", "Material"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Set Material Properties\>\"", ",", "Bold", ",", "White",
                   ",", "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Define", " ", "Wires"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<2-1 \\nDefine Wires\>\"", ",", "Bold", ",", "Black"}], 
                 "]"}], ",", "mod$DefineWires", ",", "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "1", ",", "0.6"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<2-2 \\nDefine Vertical Springs\>\"", ",", "Bold", ",", 
                  "Black"}], "]"}], ",", "mod$DefineVertSprings", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.9", ",", "0.6"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<2-3 \\nDefine Inverted Pendulum\>\"", ",", "Bold", ",", 
                  "Black"}], "]"}], ",", "mod$DefineIP", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<2-4 \\nDefine Heat Links\>\"", ",", "Bold", ",", 
                  "Black"}], "]"}], ",", "mod$DefineHeatLinks", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<2-5 \\nDefine Damper\>\"", ",", "Bold", ",", "Black"}], 
                 "]"}], ",", "mod$DefineDamper", ",", "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "}"}], 
            "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
           "mod$ShowConnectionList"}], "\[IndentingNewLine]", "}"}], "}"}], 
        ",", 
        RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], ",", 
      "\"\<\>\"", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "3."}]}], " ", "Start", " ", 
         RowBox[{"Calculation", " ", "--"}]}], "-"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Item", "[", 
       RowBox[{
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Step 3. Start Calculation\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"580", ",", "30"}], "}"}]}], ",", 
          RowBox[{"Alignment", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.3", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
      "\"\<\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"TableForm", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"Button", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Construct Model\>\"", ",", "Bold", ",", "White"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(", 
             RowBox[{"mod$StartCalc", ";", 
              RowBox[{"calcdone", "=", "True"}], ";", 
              RowBox[{"tabviewctrl", "=", "2"}], ";"}], ")"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
            RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
            RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
            RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
          "\[IndentingNewLine]", "}"}], "}"}], ",", 
        RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.595219263745858*^9, 3.595219284496045*^9}, {
  3.716516801987238*^9, 3.7165168216065807`*^9}, {3.716517010459958*^9, 
  3.716517011384234*^9}, {3.716517328710108*^9, 3.7165173293696957`*^9}, {
  3.718414548706048*^9, 3.7184145511260242`*^9}, {3.718414753096977*^9, 
  3.718414803363906*^9}, {3.718414853078367*^9, 3.718414912719192*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"0d5ae563-c5b0-409b-898a-4d3c377c037c"]
}, Closed]],

Cell[CellGroupData[{

Cell["Tab2: Calculation Result", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5952194075100813`*^9, 3.59521941623358*^9}, {
  3.5952195318601933`*^9, 
  3.5952195330362606`*^9}},ExpressionUUID->"24623df1-9f9f-447b-8194-\
51e73ec03a4c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuCalculationResult", ":=", "\[IndentingNewLine]", 
    RowBox[{"Dynamic", "[", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", "calcdone", "]"}], ",", 
       RowBox[{"calcdone", ";", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
       RowBox[{"calcdone", ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Basic"}]}], " ", 
             RowBox[{"Info", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Item", "[", 
            RowBox[{
             RowBox[{"Pane", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Model Basic Information\>\"", ",", "\[IndentingNewLine]",
                  "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"870", ",", "30"}], "}"}]}], ",", 
               RowBox[{"Alignment", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.5", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
           "\"\<\>\"", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Degrees of Freedom:\>\"", ",", "Bold"}], 
                    "]"}], "}"}], "}"}], "]"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "allvars", "]"}], ",", 
                    "\"\<State Variables\>\""}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "allparams", "]"}], ",", 
                    "\"\<Input Variables\>\""}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "allfloats", "]"}], ",", 
                    "\"\<Float Variables\>\""}], "}"}]}], "}"}], "]"}], "}"}],
                    ",", "\[IndentingNewLine]", 
                   RowBox[{"{", "\"\<\>\"", "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Ground Position:\>\"", ",", "Bold"}], "]"}], 
                    "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"Pane", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"makesub", "[", 
                    RowBox[{"allparams", ",", "\[IndentingNewLine]", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"allparams", "/.", "subdefparams"}], ",", 
                    "0.0001"}], "]"}]}], "]"}], ",", "6", ",", "6", ",", "1", 
                    ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], "]"}], 
                    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", "\"\<\>\"", "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Equilibrium Point:\>\"", ",", "Bold"}], 
                    "]"}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"Pane", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"makesub", "[", 
                    RowBox[{
                    RowBox[{"Join", "[", 
                    RowBox[{"allvars", ",", "allfloats"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Join", "[", 
                    RowBox[{"allvars", ",", "allfloats"}], "]"}], "/.", 
                    "subminvars"}], ",", "0.0001"}], "]"}]}], "]"}], ",", "6",
                     ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], "]"}], 
                    "\[IndentingNewLine]", "}"}]}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"steadyplot", "[", 
                 RowBox[{"subminvars", ",", 
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"200", ",", "400"}], "}"}]}]}], "]"}]}], 
               "\[IndentingNewLine]", "}"}], "}"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], ",", 
           "\"\<\>\"", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Freq"}]}], " ", "Plot", " ", 
              RowBox[{"Tool", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"mod$MenuFreqPlotSymbolSetting", ";", 
            RowBox[{"(*", 
             RowBox[{"symbol", " ", "setting"}], "*)"}], 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Frequency Domain Plot Tool\>\"", ",", 
                  "\[IndentingNewLine]", "Bold", ",", "Italic", ",", 
                  "White"}], "]"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"RGBColor", "[", 
                RowBox[{"0", ",", "0.5", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
           "\"\<\>\"", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
             "mod$MenuFreqPlotChooseMode", ",", "\[IndentingNewLine]", 
              "mod$MenuFreqPlotInput", ",", "\[IndentingNewLine]", 
              "mod$MenuFreqPlotOutput", ",", "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                 "mod$MenuFreqPlotFreq", ",", "\[IndentingNewLine]", 
                  "mod$MenuFreqPlotFreqStep"}], "\[IndentingNewLine]", "}"}], 
                "}"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{"mod$MenuFreqPlotPlot", ",", "\[IndentingNewLine]", 
                   RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    "mod$MenuFreqPlotAddClear", ",", "\[IndentingNewLine]", 
                    "mod$MenuFreqPlotAppearance", ",", "\[IndentingNewLine]", 
                    "mod$MenuFreqPlotNameList"}], "\[IndentingNewLine]", 
                    "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], ",", 
                RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "]"}], ",", "\"\<\>\"", ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Eigen"}]}], " ", 
              RowBox[{"Plot", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"mod$MenuEigenPlotSymbolSetting", ";", 
            RowBox[{"(*", 
             RowBox[{"symbol", " ", "setting"}], "*)"}], 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Eigen Modes\>\"", ",", "\[IndentingNewLine]", "Bold", 
                  ",", "Italic", ",", "White"}], "]"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"RGBColor", "[", 
                RowBox[{"0", ",", "0", ",", "0.5"}], "]"}]}]}], "]"}]}], ",", 
           "\"\<\>\"", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"mod$MenuEigenPlotModeList", ",", "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                  "mod$MenuEigenPlotChoose", ",", "\[IndentingNewLine]", 
                   "mod$MenuEigenPlotSetting"}], "\[IndentingNewLine]", "}"}],
                  "}"}], ",", 
                RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], ",", 
              "\[IndentingNewLine]", "mod$MenuEigenPlot3DPlot"}], 
             "\[IndentingNewLine]", "}"}], "]"}], ",", "\"\<\>\""}], 
          "\[IndentingNewLine]", "}"}], "]"}]}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5952194191247454`*^9, 3.5952194404559655`*^9}, {
   3.5952196053603973`*^9, 3.5952196070084915`*^9}, {3.595219686514039*^9, 
   3.5952197005458417`*^9}, {3.595219900333269*^9, 3.5952199343162127`*^9}, {
   3.5952201244000845`*^9, 3.5952202369215207`*^9}, {3.5952958569549255`*^9, 
   3.5952958582820015`*^9}, {3.59529598921049*^9, 3.595296014869958*^9}, {
   3.5952960681510053`*^9, 3.595296069191065*^9}, {3.5952961050271144`*^9, 
   3.595296129927539*^9}, {3.595296174206071*^9, 3.5952961751721263`*^9}, {
   3.5952962180245776`*^9, 3.595296224419943*^9}, {3.5952962986031866`*^9, 
   3.5952963717733717`*^9}, 3.595296413818776*^9, {3.5952980905186777`*^9, 
   3.5952981021923456`*^9}, 3.5952981713403006`*^9, {3.595298286110865*^9, 
   3.5952982942073283`*^9}, {3.595298350304537*^9, 3.5952983724628043`*^9}, {
   3.595298413926176*^9, 3.5952984361054444`*^9}, {3.595300100613649*^9, 
   3.595300101486699*^9}, {3.595300156683856*^9, 3.5953002212085466`*^9}, {
   3.5953002753536434`*^9, 3.5953003206252327`*^9}, {3.5953004065001445`*^9, 
   3.595300456805022*^9}, 3.595300500389515*^9, {3.595300532460349*^9, 
   3.5953005729606657`*^9}, {3.5953006451427937`*^9, 
   3.5953006459278393`*^9}, {3.6397803322909536`*^9, 
   3.6397803362511797`*^9}, {3.6397805989042025`*^9, 3.639780626811799*^9}, {
   3.639781000838192*^9, 3.639781001590235*^9}, {3.639781187784885*^9, 
   3.6397811885189266`*^9}, {3.6397813124980183`*^9, 
   3.6397813633479266`*^9}, {3.6397814043782735`*^9, 
   3.6397814078384714`*^9}, {3.639782158198389*^9, 3.639782160095498*^9}, {
   3.6397823900646515`*^9, 3.6397824460648546`*^9}, {3.63978252868258*^9, 
   3.639782559594348*^9}, {3.639782618631725*^9, 3.6397826715547514`*^9}, {
   3.6397827346313596`*^9, 3.639782757603674*^9}, {3.6397828255395594`*^9, 
   3.6397828272156553`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"d30b85a7-0425-4d11-b481-695b9fa35cf0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module for Tab2 Freq Plot", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.59529615391191*^9, 3.595296157002087*^9}, {
  3.5953006064505816`*^9, 
  3.5953006085747023`*^9}},ExpressionUUID->"952d402e-c454-4062-9fae-\
805020da3547"],

Cell[CellGroupData[{

Cell["Symbol Setting", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952964296996846`*^9, 
  3.5952964363550653`*^9}},ExpressionUUID->"b895e37e-fc6b-40f0-92ec-\
431cea6f4ad5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotSymbolSetting", ":=", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tfk", "]"}], "]"}], ",", 
        RowBox[{"calc$tfk", "=", "1"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$tfFi", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      RowBox[{"calc$tfFo", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfGi", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";", 
      RowBox[{"calc$tfGo", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$sni", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";", 
      RowBox[{"calc$sno", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tnT", "]"}], "]"}], ",", 
        RowBox[{"calc$tnT", "=", "300"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$tnb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "fmin", "]"}], "]"}], ",", 
        RowBox[{"fmin", "=", "0.01"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "fmax", "]"}], "]"}], ",", 
        RowBox[{"fmax", "=", "100."}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "ngrid", "]"}], "]"}], ",", 
        RowBox[{"ngrid", "=", "1001"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "fgridtype", "]"}], "]"}], ",", 
        RowBox[{"fgridtype", "=", "True"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tfplot", "]"}], "]"}], ",", 
        RowBox[{"calc$tfplot", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$psdplot", "]"}], "]"}], ",", 
        RowBox[{"calc$psdplot", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tfname", "]"}], "]"}], ",", 
        RowBox[{"calc$tfname", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$psdname", "]"}], "]"}], ",", 
        RowBox[{"calc$psdname", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tfsel", "]"}], "]"}], ",", 
        RowBox[{"calc$tfsel", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$psdsel", "]"}], "]"}], ",", 
        RowBox[{"calc$psdsel", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tfshow", "]"}], "]"}], ",", 
        RowBox[{"calc$tfshow", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$psdshow", "]"}], "]"}], ",", 
        RowBox[{"calc$psdshow", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$tfline", "]"}], "]"}], ",", 
        RowBox[{"calc$tfline", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$psdline", "]"}], "]"}], ",", 
        RowBox[{"calc$psdline", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$combif", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$combin", "]"}], "]"}], ",", 
        RowBox[{"calc$combin", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"allvars", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "+", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"allvars", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$combif2", "=", "False"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"**", "**"}], "*", "VERSION", " ", "1.3"}], "******)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$combout", "]"}], "]"}], ",", 
        RowBox[{"calc$combout", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"allvars", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "+", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"allvars", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$xrange", "]"}], "]"}], ",", 
        RowBox[{"calc$xrange", "=", "Automatic"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$yrange", "]"}], "]"}], ",", 
        RowBox[{"calc$yrange", "=", "Automatic"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"amplabel", "=", "\"\<Amplitude\>\""}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$lgndpos", "]"}], "]"}], ",", 
        RowBox[{"calc$lgndpos", "=", 
         RowBox[{"{", 
          RowBox[{"0.35", ",", "0.3"}], "}"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$legend", "]"}], "]"}], ",", 
        RowBox[{"calc$legend", "=", "True"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"Set", " ", "temp", " ", "symbol"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "temp$xrange", "]"}], "]"}], ",", 
        RowBox[{"temp$xrange", "=", 
         RowBox[{"{", 
          RowBox[{"0.01", ",", "100."}], "}"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "temp$yrange", "]"}], "]"}], ",", 
        RowBox[{"temp$yrange", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1.", "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"-", "10"}], ")"}]}]}], ",", 
           RowBox[{"1.", "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", "2", ")"}]}]}]}], "}"}]}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952961624904013`*^9, 3.5952961855877223`*^9}, 
   3.595296321463494*^9, 3.5952964363550653`*^9, {3.5952983851645308`*^9, 
   3.595298390830855*^9}, {3.5953001166935687`*^9, 3.595300116880579*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"d15393bc-cbcd-4c1a-99cf-dda03c612b60"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Choose mode", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.595296442285404*^9, 
  3.595296449359809*^9}},ExpressionUUID->"9487aa2b-1486-40b0-91cf-\
04683bd3a040"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotChooseMode", ":=", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "calc$tfk", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
               "1", "\[Rule]", 
                "\"\<Frequency Responce to External Force/Torque\>\""}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
               "2", "\[Rule]", 
                "\"\<Frequency Responce to Ground Motion\>\""}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"3", "\[Rule]", "\"\<Seismic Noise Plot\>\""}], ",", 
               RowBox[{"4", "\[Rule]", "\"\<Thermal Noise Plot\>\""}]}], 
              "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Set Seismic Spectrum\>\"", ",", "Bold", ",", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "]"}], ",", 
              "mod$SetSeism", ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"calc$tfk", "\[Equal]", "3"}], ",", 
                 RowBox[{"GrayLevel", "[", "0.1", "]"}], ",", 
                 RowBox[{"GrayLevel", "[", "0.7", "]"}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"calc$tfk", "\[Equal]", "3"}]}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], ",", 
        RowBox[{"TableAlignments", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "850"}], ",", 
      RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952963175632706`*^9, 3.5952963424016914`*^9}, 
   3.595296449359809*^9},
 CellLabel->"In[10]:=",ExpressionUUID->"4f9cdc59-c138-44a1-8e7f-4d0bd2508622"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Input", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952980624290714`*^9, 
  3.5952980672673483`*^9}},ExpressionUUID->"9b965755-cc41-4302-a366-\
34f0d21e4942"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotInput", ":=", 
    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
     RowBox[{"Panel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "\[Rule]", 
            RowBox[{"TableForm", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Input:\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfFi", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                     ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"Dynamic", "[", "calc$combif", "]"}], "]"}], ",", 
                    RowBox[{"Style", "[", "\"\<Combined Input:\>\"", "]"}]}], 
                    "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$combin", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "3."}], "}"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], ",", 
              RowBox[{"TableAlignments", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"2", "\[Rule]", 
            RowBox[{"TableForm", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Input:\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfGi", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "6", ",", "6", ",", 
                    "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
              RowBox[{"TableAlignments", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"3", "\[Rule]", 
            RowBox[{"TableForm", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Input:\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$sni", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "6", ",", "6", ",", 
                    "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Add Seismic Spectrum Plot\>\"", ",", "Bold", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                   "mod$AddSeismPlot", ",", "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "1.", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TableAlignments", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"4", "\[Rule]", 
            RowBox[{"TableForm", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Temperature:\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "calc$tnT", "]"}], ",", "Number", 
                   ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\"\<K\>\""}], "\[IndentingNewLine]", "}"}], "}"}], ",", 
              RowBox[{"TableAlignments", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}]}], "}"}], 
         ",", "calc$tfk", ",", 
         RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "850"}], ",", 
       RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952963897884016`*^9, 3.5952964227922897`*^9}, 
   3.5952980672673483`*^9},
 CellLabel->"In[11]:=",ExpressionUUID->"dc09617a-f2eb-4a65-b085-eeeb276a9e46"]
}, Closed]],

Cell[CellGroupData[{

Cell["Output", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952980721996303`*^9, 3.595298074137741*^9}, 
   3.595298149014024*^9},ExpressionUUID->"886ee2e8-e58f-4a8c-9a49-\
2a061fd7913a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuFreqPlotOutput", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"**", "**", "Conbined"}], " ", "output", " ", 
                  "from", " ", "v1", ".3"}], "*****)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfFo", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                    ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                   RowBox[{"{", "}"}]}], "]"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"Dynamic", "[", "calc$combif2", "]"}], "]"}], ",", 
                    RowBox[{"Style", "[", "\"\<Combined Output:\>\"", "]"}]}],
                     "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$combout", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "3."}], "}"}]}]}], "]"}]}], 
                  "\[IndentingNewLine]", "}"}], "]"}]}], 
               "\[IndentingNewLine]", "}"}], "}"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"2", "\[Rule]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfGo", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                    ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                   RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"3", "\[Rule]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$sno", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                    ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                   RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"4", "\[Rule]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tnb", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                    ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                   RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", "}"}], ",", "calc$tfk", ",", 
        RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "850"}], ",", 
      RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952981156701164`*^9, 3.595298149014024*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"c8b53d9c-214e-4e0e-b6b8-ac087d7e4018"]
}, Closed]],

Cell[CellGroupData[{

Cell["Frequency Setup", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952982452915306`*^9, 
  3.595298265304675*^9}},ExpressionUUID->"c60b2f94-6a12-47ba-b6a8-\
56451c48c61b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuFreqPlotFreq", ":=", "\[IndentingNewLine]", 
   RowBox[{"Panel", "[", 
    RowBox[{
     RowBox[{"TableForm", "[", 
      RowBox[{"{", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Frequency:\>\"", ",", "Bold"}], "]"}], ",", 
         RowBox[{"InputField", "[", 
          RowBox[{
           RowBox[{"Dynamic", "[", "fmin", "]"}], ",", "Number", ",", 
           RowBox[{"FieldSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<-\>\"", 
         ",", "\[IndentingNewLine]", 
         RowBox[{"InputField", "[", 
          RowBox[{
           RowBox[{"Dynamic", "[", "fmax", "]"}], ",", "Number", ",", 
           RowBox[{"FieldSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<Hz\>\""}],
         "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True,
 CellChangeTimes->{{3.595298225122377*^9, 3.5952982670817766`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"2ce67c05-12a5-4b22-89a7-2d752d41c0e6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Frequency Step Setup", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952983284932895`*^9, 
  3.5952983361017246`*^9}},ExpressionUUID->"7c8a91dd-8c1e-4e94-ab50-\
c95df67bc41d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuFreqPlotFreqStep", ":=", "\[IndentingNewLine]", 
   RowBox[{"Panel", "[", 
    RowBox[{
     RowBox[{"TableForm", "[", 
      RowBox[{"{", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Step:\>\"", ",", "Bold"}], "]"}], ",", 
         RowBox[{"InputField", "[", 
          RowBox[{
           RowBox[{"Dynamic", "[", "ngrid", "]"}], ",", "Number", ",", 
           RowBox[{"FieldSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Checkbox", "[", 
          RowBox[{"Dynamic", "[", "fgridtype", "]"}], "]"}], ",", 
         "\"\<Logarithmic\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"Checkbox", "[", 
          RowBox[{"Dynamic", "[", 
           RowBox[{
            RowBox[{"Not", "[", "fgridtype", "]"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"fgridtype", "=", 
               RowBox[{"Not", "[", "#", "]"}]}], ")"}], "&"}]}], "]"}], "]"}],
          ",", "\"\<Linear\>\""}], "\[IndentingNewLine]", "}"}], "}"}], "]"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"ImageSize", "\[Rule]", "542"}], ",", 
     RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952983131284103`*^9, 3.5952983361017246`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"bdb5fa4a-20b0-4775-92a6-27638244e2a3"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plot", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True,
 CellChangeTimes->{{3.595298453437436*^9, 3.595298454749511*^9}, 
   3.5953000256413608`*^9},ExpressionUUID->"e86c9e54-9244-4e2e-b5c3-\
e644c41ef717"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotPlot", ":=", "\[IndentingNewLine]", 
    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
     RowBox[{"Panel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
            RowBox[{"TableForm", "[", 
             RowBox[{"{", 
              RowBox[{
              "mod$MenuFreqPlotPlotMoreButtonTF", ",", 
               "mod$MenuFreqPlotPlotTF"}], "}"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"False", "\[Rule]", "\[IndentingNewLine]", 
            RowBox[{"TableForm", "[", 
             RowBox[{"{", 
              RowBox[{
              "mod$MenuFreqPlotPlotMoreButtonPSD", ",", 
               "mod$MenuFreqPlotPlotPSD"}], "}"}], "]"}]}]}], 
          "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{
          RowBox[{"calc$tfk", "\[Equal]", "1"}], "||", 
          RowBox[{"calc$tfk", "\[Equal]", "2"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "510"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952984703014*^9, 3.595298487122362*^9}, {
   3.5952985613456078`*^9, 3.5952986546699457`*^9}, {3.595298726342045*^9, 
   3.5952987792380705`*^9}, {3.5952988174272547`*^9, 3.5952988181782975`*^9}, 
   3.595298859251647*^9, {3.595299203833356*^9, 3.5952992930994616`*^9}, {
   3.5952993579191694`*^9, 3.59529940023759*^9}, {3.595299439819854*^9, 
   3.595299442470005*^9}, {3.595299986027095*^9, 3.595299988838256*^9}, {
   3.5953000256413608`*^9, 3.5953000563261156`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"3e52d33f-5d99-4246-acfd-cb354ea5746c"]
}, Closed]],

Cell[CellGroupData[{

Cell["TF Plot", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952993041770954`*^9, 3.595299307546288*^9}, 
   3.5953000186249595`*^9},ExpressionUUID->"7c0f3251-3764-4716-a17c-\
65732f0136d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotPlotTF", ":=", "\[IndentingNewLine]", 
    RowBox[{"TableForm", "[", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"Magnitude", " ", "Plot"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"takemag", "[", 
          RowBox[{"calc$tfplot", ",", "calc$tfshow"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Join", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$legend", "&&", 
              RowBox[{"Not", "[", 
               RowBox[{
                RowBox[{"Length", "[", "calc$tfname", "]"}], "\[Equal]", 
                "0"}], "]"}], "&&", 
              RowBox[{"MemberQ", "[", 
               RowBox[{"calc$tfshow", ",", "True"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"PlotLegend", "\[Rule]", 
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                   "]"}], ",", "Null"}], "]"}]}], ",", 
               RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
               RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"LegendTextSpace", "\[Rule]", "2.5"}], ",", 
               RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
               RowBox[{"LegendPosition", "\[Rule]", "calc$lgndpos"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"LegendSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"0.2", "+", 
                   RowBox[{"0.023", "*", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}], "]"}]}]}], ",", 
                  RowBox[{"0.08", "*", 
                   RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}]}]}], "}"}]}]}], "}"}], ",", 
             RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
           "baseoptmag", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"calc$xrange", ",", "calc$yrange"}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", "calc$tfline", "]"}], "\[Equal]", 
                 "0"}], ",", "Thick", ",", "\[IndentingNewLine]", 
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfline", "]"}]}], "}"}]}], 
                   "]"}], ",", "Null"}], "]"}]}], "]"}]}]}], "}"}]}], "]"}]}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"Phase", " ", "Plot"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{
         RowBox[{"takephs", "[", 
          RowBox[{"calc$tfplot", ",", "calc$tfshow"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Join", "[", 
          RowBox[{"baseoptphs", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"calc$xrange", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", "calc$tfline", "]"}], "\[Equal]", 
                 "0"}], ",", "Thick", ",", "\[IndentingNewLine]", 
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfline", "]"}]}], "}"}]}], 
                   "]"}], ",", "Null"}], "]"}]}], "]"}]}]}], "}"}]}], "]"}]}],
         "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952993107934732`*^9, 3.5952993431733255`*^9}, {
   3.595299458400916*^9, 3.595299559132678*^9}, {3.5952997127554646`*^9, 
   3.595299713704519*^9}, {3.5952997674395924`*^9, 3.5952997781762066`*^9}, {
   3.595299891071664*^9, 3.5952998929677725`*^9}, 3.5953000186249595`*^9},
 CellLabel->"In[16]:=",ExpressionUUID->"184d3d0e-9165-492b-8016-87038b301f72"]
}, Closed]],

Cell[CellGroupData[{

Cell["PSD Plot", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.595299843780959*^9, 3.5952998453560486`*^9}, 
   3.5952999293808546`*^9},ExpressionUUID->"f30d3b9b-abfe-47dc-9485-\
324dee2335b4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuFreqPlotPlotPSD", ":=", "\[IndentingNewLine]", 
   RowBox[{"TableForm", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"takepsd", "[", 
        RowBox[{"calc$psdplot", ",", "calc$psdshow"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"calc$legend", "&&", 
            RowBox[{"Not", "[", 
             RowBox[{
              RowBox[{"Length", "[", "calc$psdname", "]"}], "\[Equal]", "0"}],
              "]"}], "&&", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"calc$psdshow", ",", "True"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"PlotLegend", "\[Rule]", 
              RowBox[{"DeleteCases", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                 "]"}], ",", "Null"}], "]"}]}], ",", 
             RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
             RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"LegendTextSpace", "\[Rule]", "2.5"}], ",", 
             RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
             RowBox[{"LegendPosition", "\[Rule]", "calc$lgndpos"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"LegendSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"0.2", "+", 
                 RowBox[{"0.023", "*", 
                  RowBox[{"Max", "[", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}], "]"}]}]}], ",", 
                RowBox[{"0.08", "*", 
                 RowBox[{"Sum", "[", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                  "]"}]}]}], "}"}]}]}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
         "baseoptpsd", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"calc$xrange", ",", "calc$yrange"}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "calc$psdline", "]"}], "\[Equal]", 
               "0"}], ",", "Thick", ",", "\[IndentingNewLine]", 
              RowBox[{"DeleteCases", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdline", "]"}]}], "}"}]}], 
                 "]"}], ",", "Null"}], "]"}]}], "]"}]}]}], "}"}]}], "]"}]}], 
      "]"}], "\[IndentingNewLine]", "}"}], "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.595299846164095*^9, 3.5952999293808546`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"b34ca7b9-1f03-40cf-8d37-d168c3a687f0"]
}, Closed]],

Cell[CellGroupData[{

Cell["More Button", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952987874245386`*^9, 3.59529878901963*^9}, 
   3.595298852366253*^9},ExpressionUUID->"d67c3afb-f4fd-4f0c-b924-\
de685df1aa67"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotPlotMoreButtonTF", ":=", "\[IndentingNewLine]", 
    RowBox[{"Button", "[", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Open New Window\>\"", ",", "Small", ",", "Bold"}], "]"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"CreateDocument", "[", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "ExpressionCell", "[", "\[IndentingNewLine]", 
         "mod$MenuFreqPlotPlotTF", "\[IndentingNewLine]", "]"}], "}"}], 
       "\[IndentingNewLine]", "]"}], ",", 
      RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
      RowBox[{"Background", "\[Rule]", 
       RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
      RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952987978261337`*^9, 3.595298852366253*^9}, {
  3.595299131404213*^9, 3.595299141254777*^9}, {3.595299943700674*^9, 
  3.5952999627497635`*^9}, {3.5952999977327642`*^9, 3.5952999984668064`*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"217e6b93-9655-4e78-855c-5213628b750a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotPlotMoreButtonPSD", ":=", "\[IndentingNewLine]", 
    RowBox[{"Button", "[", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Open New Window\>\"", ",", "Small", ",", "Bold"}], "]"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"CreateDocument", "[", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "ExpressionCell", "[", "\[IndentingNewLine]", 
         "mod$MenuFreqPlotPlotPSD", "\[IndentingNewLine]", "]"}], "}"}], 
       "\[IndentingNewLine]", "]"}], ",", 
      RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
      RowBox[{"Background", "\[Rule]", 
       RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
      RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5952987978261337`*^9, 3.595298852366253*^9}, {
  3.595299131404213*^9, 3.595299141254777*^9}, {3.595299943700674*^9, 
  3.5953000055302105`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"858bd446-4207-434e-801d-88015ef6f499"]
}, Closed]],

Cell[CellGroupData[{

Cell["Add / Clear Button", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.595300238878557*^9, 3.59530024522592*^9}, 
   3.595300331997883*^9},ExpressionUUID->"fe397cd6-afa3-43b5-912b-\
59df0f36d0ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotAddClear", ":=", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Add Plot\>\"", ",", "Bold", ",", "Black"}], "]"}],
               ",", "mod$CalcFreqPlot", ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
              RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Clear Plot\>\"", ",", "Bold", ",", "White"}], 
               "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"calc$tfk", "\[Equal]", "1"}], "||", 
                 RowBox[{"calc$tfk", "\[Equal]", "2"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"calc$tfplot", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$tfname", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$tfsel", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$tfshow", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$tfline", "=", 
                  RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"calc$psdplot", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$psdname", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$psdsel", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$psdshow", "=", 
                  RowBox[{"{", "}"}]}], ";", 
                 RowBox[{"calc$psdline", "=", 
                  RowBox[{"{", "}"}]}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", "Red"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], "]"}], "\[IndentingNewLine]", 
        "}"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "332"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.5953002480150795`*^9, 3.595300248472106*^9}, {
   3.595300281339986*^9, 3.595300294069714*^9}, 3.595300331997883*^9},
 CellLabel->"In[20]:=",ExpressionUUID->"ed92d9de-87b6-44de-91f0-3439a52ffb81"]
}, Closed]],

Cell[CellGroupData[{

Cell["Appearance", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True,
 CellChangeTimes->{{3.595300336358133*^9, 3.5953003377302113`*^9}, 
   3.595300424909198*^9},ExpressionUUID->"730df074-201b-47aa-90e8-\
610abd49a6fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuFreqPlotAppearance", ":=", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Checkbox", "[", 
              RowBox[{"Dynamic", "[", "calc$legend", "]"}], "]"}], ",", 
             "\"\<Show Legend\>\""}], "\[IndentingNewLine]", "}"}], "}"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Set x-range\>\"", ",", "Bold", ",", "White", ",", 
                  "Small"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", "temp$xrange", "]"}], "\[Equal]", 
                    "2"}], "&&", 
                   RowBox[{
                    RowBox[{"temp$xrange", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "<", 
                    RowBox[{"temp$xrange", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"calc$xrange", "=", "temp$xrange"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0", ",", "0.2", ",", "0"}], "]"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "temp$xrange", "]"}], ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"18.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Auto\>\"", ",", "Bold", ",", "Black", ",", "Small"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"calc$xrange", "=", "Automatic"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Set y-range\>\"", ",", "Bold", ",", "White", ",", 
                  "Small"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", "temp$yrange", "]"}], "\[Equal]", 
                    "2"}], "&&", 
                   RowBox[{
                    RowBox[{"temp$yrange", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "<", 
                    RowBox[{"temp$yrange", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"calc$yrange", "=", "temp$yrange"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0", ",", "0", ",", "0.2"}], "]"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "temp$yrange", "]"}], ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"18.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Auto\>\"", ",", "Bold", ",", "Black", ",", "Small"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"calc$yrange", "=", "Automatic"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], "}"}]}],
            "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "332"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True,
 CellChangeTimes->{{3.5953003411994095`*^9, 3.595300341844446*^9}, {
  3.59530041882685*^9, 3.595300424909198*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"5dc4c4a9-93dd-41a3-b5c6-5ab5e789bb62"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Graph name list", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.595300464570466*^9, 3.5953004674516306`*^9}, 
   3.595300516951462*^9},ExpressionUUID->"31342342-a441-4ffa-aa97-\
3ed0ec469199"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuFreqPlotNameList", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Pane", "[", 
          RowBox[{
           RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "calc$tfname", "]"}], "\[Equal]", 
                   "0"}], ",", "\"\<No Plot\>\"", ",", "\[IndentingNewLine]", 
                  RowBox[{"TableForm", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"18.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "White", ",", 
                    "Gray"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Line Style\>\"", ",", "Bold", ",", "Black", ",", 
                    "Small"}], "]"}], ",", 
                    RowBox[{"mod$FPLineStyle", "[", "n", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", "None"}]}], "]"}]}], 
                 "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"False", "\[Rule]", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "calc$psdname", "]"}], "\[Equal]", 
                   "0"}], ",", "\"\<No Plot\>\"", ",", "\[IndentingNewLine]", 
                  RowBox[{"TableForm", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"18.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "White", ",", 
                    "Gray"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Line Style\>\"", ",", "Bold", ",", "Black", ",", 
                    "Small"}], "]"}], ",", 
                    RowBox[{"mod$FPLineStyle", "[", "n", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", "None"}]}], "]"}]}], 
                 "]"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
             RowBox[{
              RowBox[{"calc$tfk", "\[Equal]", "1"}], "||", 
              RowBox[{"calc$tfk", "\[Equal]", "2"}]}]}], "]"}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"310", ",", "230"}], "}"}]}], ",", 
           RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Sum\>\"", ",", "Bold", ",", "Black"}], "]"}], 
               ",", "mod$FPSum", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0.7", ",", "1", ",", "0.7"}], "]"}]}]}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<x Factor\>\"", ",", "Bold", ",", "Black"}], 
                "]"}], ",", "mod$FPFactor", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"1", ",", "0.7", ",", "0.7"}], "]"}]}]}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Inverse\>\"", ",", "Bold", ",", "Black"}], "]"}],
                ",", "mod$FPInverse", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0.7", ",", "0.7", ",", "1"}], "]"}]}]}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Multiply\>\"", ",", "Bold", ",", "Black"}], 
                "]"}], ",", "mod$FPMultiply", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"1", ",", "0.5", ",", "1"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<RMS\>\"", ",", "Bold", ",", "Black"}], "]"}], 
               ",", "mod$FPRMS", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"1", ",", "1", ",", "0.7"}], "]"}]}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Hide\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPHide", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"GrayLevel", "[", "0.2", "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Show\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPShow", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0.5", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Delete\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPDelete", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", "Red"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPSave", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", "Blue"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPLoad", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Export\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPExport", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0.2", ",", "0", ",", "0.5"}], "]"}]}]}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Import\>\"", ",", "Bold", ",", "White"}], "]"}], 
               ",", "mod$FPImport", ",", "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0.5", ",", "0", ",", "0.2"}], "]"}]}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "332"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.5953004699447737`*^9, 3.5953004705248065`*^9}, {
  3.59530050432574*^9, 3.595300516951462*^9}, {3.595300836818757*^9, 
  3.5953008934629974`*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"710f0388-645e-499d-a16c-f6b9d0f03677"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Module for Tab2 Eigen Plot", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5953006127799435`*^9, 
  3.5953006213374324`*^9}},ExpressionUUID->"42b3dde6-7c84-4c45-b05c-\
1a0a1cf3f79a"],

Cell[CellGroupData[{

Cell["Symbol Setting", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5953006251396503`*^9, 3.5953006314240093`*^9}, 
   3.59530066605299*^9},ExpressionUUID->"ec1b9afb-5ef6-433a-b94e-\
e3880b98b0a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuEigenPlotSymbolSetting", ":=", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$eigenTA", "]"}], "]"}], ",", 
        RowBox[{"calc$eigenTA", "=", "0.2"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$eigenPA", "]"}], "]"}], ",", 
        RowBox[{"calc$eigenPA", "=", "0.5"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$eigenIS", "]"}], "]"}], ",", 
        RowBox[{"calc$eigenIS", "=", "150"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$eigenDET", "]"}], "]"}], ",", 
        RowBox[{"calc$eigenDET", "=", "10"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$eigenP", "]"}], "]"}], ",", 
        RowBox[{"calc$eigenP", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "eigenf", "]"}], "}"}]}], "]"}]}]}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "temp$eigenP", "]"}], "]"}], ",", 
        RowBox[{"temp$eigenP", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "eigenf", "]"}], "}"}]}], "]"}]}]}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$maxx", "]"}], "]"}], ",", 
        RowBox[{"calc$maxx", "=", "2.5"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$maxz", "]"}], "]"}], ",", 
        RowBox[{"calc$maxz", "=", "2.5"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$ytop", "]"}], "]"}], ",", 
        RowBox[{"calc$ytop", "=", "1.0"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"ValueQ", "[", "calc$ybottom", "]"}], "]"}], ",", 
        RowBox[{"calc$ybottom", "=", 
         RowBox[{"-", "2.5"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
     ")"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.5953006525112157`*^9, 3.59530066605299*^9}, {
  3.639785141160005*^9, 3.6397851607541256`*^9}, {3.639785627322812*^9, 
  3.6397856439027605`*^9}, {3.6397861794933944`*^9, 3.639786185418733*^9}, {
  3.6397862758279047`*^9, 3.639786282381279*^9}, {3.6397863348502803`*^9, 
  3.639786364257962*^9}, {3.639786396617813*^9, 3.6397864069104023`*^9}, {
  3.639786459115388*^9, 3.639786473716223*^9}, {3.639786665762207*^9, 
  3.6397866901136003`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"68c09324-c99c-4edb-9b4a-aee9db2d15c8"]
}, Closed]],

Cell[CellGroupData[{

Cell["Eigen mode list", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.639782473599429*^9, 
  3.6397824848460727`*^9}},ExpressionUUID->"6a05f918-94da-4252-b215-\
c9b6752283ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuEigenPlotModeList", ":=", "\[IndentingNewLine]", 
    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
     RowBox[{"Panel", "[", "\[IndentingNewLine]", 
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Eigen Mode List\>\"", ",", "Bold", ",", 
               RowBox[{"RGBColor", "[", 
                RowBox[{"0", ",", "0", ",", "0.3"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", "\"\<(Threshold Amplitude:\>\"", ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$eigenTA", "]"}], ",", "Number", 
               ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<)\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Pane", "[", 
          RowBox[{
           RowBox[{"eigenmodetable", "[", 
            RowBox[{
            "eigenf", ",", "CorrectedModeQ", ",", "eigenv", ",", 
             "calc$eigenTA"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"832", ",", "150"}], "}"}]}], ",", 
           RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.6397824848460727`*^9, 3.6397825142367535`*^9}, 
   3.6397829144156427`*^9, 3.9161892346325254`*^9, 
   3.9161892656243076`*^9},ExpressionUUID->"df60c679-d797-4aa7-a763-\
4c7a1786908f"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Eigen mode choose", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True,
 CellChangeTimes->{{3.6397825781914115`*^9, 
  3.639782600278675*^9}},ExpressionUUID->"cabc9598-60cc-4fc2-9111-\
a4b60bf75369"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuEigenPlotChoose", ":=", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Eigen Mode 3D Plot\>\"", ",", "Bold", ",", 
               RowBox[{"RGBColor", "[", 
                RowBox[{"0.3", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Show\>\"", ",", "Small", ",", "Bold", ",", "White"}], 
                "]"}], ",", 
               RowBox[{"calc$eigenP", "=", "temp$eigenP"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
               ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"GrayLevel", "[", "0.1", "]"}]}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Checkbox", "[", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$eigenP", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                  ",", 
                  RowBox[{"ToString", "[", "n", "]"}]}], "}"}], "}"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "eigenf", "]"}]}], "}"}]}], "]"}], ",",
             "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
            RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "450"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True,
 CellChangeTimes->{{3.639782589210042*^9, 3.639782600278675*^9}, {
   3.639782657759963*^9, 3.63978265823299*^9}, 3.6397829186368837`*^9, 
   3.6397829649805346`*^9, 3.6397830880605745`*^9, {3.639783186984233*^9, 
   3.6397831909344587`*^9}, {3.6397832272785373`*^9, 3.639783230799739*^9}, {
   3.6397832789664936`*^9, 3.639783279238509*^9}, {3.639784472464758*^9, 
   3.6397845100319066`*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"f471a6b2-0818-4080-b259-31320afc4db6"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Eigen plot setting", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.6397827013074536`*^9, 3.6397827189904647`*^9}, {
  3.639782790147535*^9, 
  3.6397827909545813`*^9}},ExpressionUUID->"3dfb8762-abc8-485e-bbf1-\
f46a488a929c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuEigenPlotSetting", ":=", "\[IndentingNewLine]", 
    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Amplitude:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$eigenPA", "]"}], ",", "Number", 
               ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<\>\"",
              ",", "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Image Size:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$eigenIS", "]"}], ",", "Number", 
               ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Marker Position:\>\"", ",", "Bold"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$maxx", "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$maxz", "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y+:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$ytop", "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y-:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$ybottom", "]"}], ",", "Number", 
               ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Plot Timeout:\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "calc$eigenDET", "]"}], ",", "Number", 
               ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<sec\>\""}], "}"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
        "}"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "392"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True,
 CellChangeTimes->{{3.6397826891687593`*^9, 3.6397827189904647`*^9}, {
  3.6397855328504086`*^9, 3.6397856121379433`*^9}, {3.639785676366617*^9, 
  3.6397856765186257`*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"0cebfc10-4113-4c32-becb-93bff39aef64"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Eigen mode 3D plot", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True,
 CellChangeTimes->{{3.639782794468782*^9, 
  3.639782803278286*^9}},ExpressionUUID->"a3ca49e7-0963-4a00-be32-\
49da56d5e8d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MenuEigenPlot3DPlot", ":=", "\[IndentingNewLine]", 
    RowBox[{"Style", "[", 
     RowBox[{
      RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
       RowBox[{"Panel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{
             RowBox[{"DeleteCases", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$eigenP", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], 
                  "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"l", ",", 
                   RowBox[{"Length", "[", "eigenf", "]"}]}], "}"}]}], "]"}], 
               ",", "0"}], "]"}], "===", 
             RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
            RowBox[{"Partition", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"eigenf", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "0.001"}], "]"}], 
                    "]"}], "<>", "\"\<Hz\>\""}], ",", "15"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<More\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"CreateDocument", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"ExpressionCell", "[", 
                    RowBox[{"eigenplot", "[", 
                    RowBox[{"eigenv", ",", "calc$eigenPA", ",", "n", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "calc$eigenIS"}]}], "]"}],
                     "]"}], "}"}], "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], 
                    "]"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"eigenplot", "[", 
                    RowBox[{"eigenv", ",", "calc$eigenPA", ",", "n", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "calc$eigenIS"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"viewQ", "[", 
                    RowBox[{
                    RowBox[{"important", "[", 
                    RowBox[{"eigenv", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "optr", ",", 
                    "optp"}], "]"}]}], "]"}]}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"DeleteCases", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$eigenP", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"l", ",", 
                    RowBox[{"Length", "[", "eigenf", "]"}]}], "}"}]}], "]"}], 
                    ",", "0"}], "]"}]}], "}"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"IntegerPart", "[", 
               RowBox[{"840", "/", 
                RowBox[{"(", 
                 RowBox[{"calc$eigenIS", "+", "10"}], ")"}]}], "]"}], ",", 
              RowBox[{"IntegerPart", "[", 
               RowBox[{"840", "/", 
                RowBox[{"(", 
                 RowBox[{"calc$eigenIS", "+", "10"}], ")"}]}], "]"}], ",", 
              "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], "\[IndentingNewLine]", "]"}], ",", 
           "\"\<3D plots are shown here.\>\""}], "]"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "850"}]}], "\[IndentingNewLine]", 
        "]"}], "\[IndentingNewLine]", "]"}], ",", 
      RowBox[{"DynamicEvaluationTimeout", "\[Rule]", "calc$eigenDET"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True,
 CellChangeTimes->{{3.639782803278286*^9, 3.6397828125628166`*^9}, {
  3.6397854387370253`*^9, 3.6397854867497716`*^9}, {3.639785756293189*^9, 
  3.6397857637616158`*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"8b0e5c4c-59df-40f1-9d9b-65ad280970f8"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tab3: Export Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5952194993823357`*^9, 3.5952195013814497`*^9}, {
  3.595219535435398*^9, 
  3.595219537029489*^9}},ExpressionUUID->"100f9dad-4e44-473f-ae8b-\
9aba65ad6b24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MenuExportModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "[", "calcdone", "]"}], ",", 
      RowBox[{"calcdone", ";", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"calcdone", ";", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Export", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Item", "[", 
           RowBox[{
            RowBox[{"Pane", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<  Mathematica Export\>\"", ",", "\[IndentingNewLine]", 
                "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"870", ",", "30"}], "}"}]}], ",", 
              RowBox[{"Alignment", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.2", ",", "0.1", ",", "0.1"}], "]"}]}]}], "]"}], ",", 
          "\"\<\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Export matrices and variables in Mathematica Format:\>\"", 
            ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Export Suspension Model\>\"", ",", "Bold", ",", 
                  "White"}], "]"}], ",", "\[IndentingNewLine]", 
                "mod$ExportModel", ",", 
                RowBox[{"(*", 
                 RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
                RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0.2", ",", "0", ",", "0"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
                RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
              "\[IndentingNewLine]", "}"}], "}"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
          "\"\<\>\"", ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Item", "[", 
           RowBox[{
            RowBox[{"Pane", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<  MATLAB Export - Legacy Version\>\"", ",", 
                "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
               "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"870", ",", "30"}], "}"}]}], ",", 
              RowBox[{"Alignment", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.1", ",", "0.2", ",", "0.1"}], "]"}]}]}], "]"}], ",", 
          "\"\<\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Export ABCD matrices in a format that can be read in \
MATLAB:\>\"", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Export Suspension Model\>\"", ",", "Bold", ",", 
                  "White"}], "]"}], ",", "\[IndentingNewLine]", 
                "mod$MATLABExport", ",", 
                RowBox[{"(*", 
                 RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
                RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"0", ",", "0.2", ",", "0"}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
                RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
              "\[IndentingNewLine]", "}"}], "}"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
          "\"\<\>\"", ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Item", "[", 
           RowBox[{
            RowBox[{"Pane", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<  MATLAB Export - Perry's Version\>\"", ",", 
                "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
               "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"870", ",", "30"}], "}"}]}], ",", 
              RowBox[{"Alignment", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
               RowBox[{"0", "/", "255"}], ",", 
               RowBox[{"150", "/", "255"}], ",", 
               RowBox[{"240", "/", "255"}]}], "]"}]}]}], "]"}], ",", 
          "\"\<\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Export ABCD matrices as a series of csv files to be read by \
MATLAB:\>\"", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Export Suspension Model\>\"", ",", "Bold", ",", 
                  "White"}], "]"}], ",", "\[IndentingNewLine]", 
                "mod$PerryMATLABExport", ",", 
                RowBox[{"(*", 
                 RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
                RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{
                   RowBox[{"0", "/", "255"}], ",", 
                   RowBox[{"150", "/", "255"}], ",", 
                   RowBox[{"240", "/", "255"}]}], "]"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
                RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
              "\[IndentingNewLine]", "}"}], "}"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}], 
         "\[IndentingNewLine]", "}"}], "]"}]}]}], "\[IndentingNewLine]", 
     "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5952195041856103`*^9, 3.595219512970113*^9}, 
   3.59521981555742*^9, {3.9167949164177713`*^9, 3.916794952257712*^9}, 
   3.916795085088632*^9, 3.9167952806376767`*^9, {3.9167953537002754`*^9, 
   3.916795412158995*^9}, {3.9167954444284596`*^9, 
   3.916795509253895*^9}},ExpressionUUID->"7bef3e00-d441-4280-b61c-\
806b5e4421ad"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Information", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714902577508345`*^9, 
  3.571490266956361*^9}},ExpressionUUID->"e137d486-9575-4deb-bc44-\
dcc0d21e8680"],

Cell[CellGroupData[{

Cell["About SUMCON", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571340636932308*^9, 
  3.5713406389914255`*^9}},ExpressionUUID->"3a317e72-680f-4c81-a08f-\
b4f3057aed0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$AboutSUMCON", ":=", 
   RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"titleSUMCON", "=", 
        RowBox[{"Import", "[", "\"\<SUMCON.PNG\>\"", "]"}]}], ";", 
       RowBox[{"(*", 
        RowBox[{"Import", " ", "Title"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Top"}]}], " ", 
          RowBox[{"Frame", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Image", "[", 
            RowBox[{"titleSUMCON", ",", 
             RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Suspension Model Constructor\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<Version: \>\"", "<>", "$VersionSUMCON"}], ",", 
           "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Originally Programmed by Takanori Sekiguchi and Mark Barton\>\
\"", ",", "\[IndentingNewLine]", 
           "\"\<Takanori Email (Legacy): tseki@icrr.u-tokyo.ac.jp\>\"", ",", 
           "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Updated by Perry William Fox Forsyth (P.W.F.Forsyth) - \
Version 1.5.0 (2024-02-28)\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Contact: u5024171@anu.edu.au\>\"", ",", 
           "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Last Update: 28/02/2024\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Last Updated with Wolfram Mathematica 13.1.0\>\"", ",", 
           "\[IndentingNewLine]", 
           "\"\<Versions of Mathematica earlier than this may not function as \
intended.\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
     ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<SUMCON\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571340646772871*^9, 3.5713406547983303`*^9}, {
  3.5713406966577244`*^9, 3.571340883031384*^9}, {3.571340917273343*^9, 
  3.5713410114387283`*^9}, {3.585888318763979*^9, 3.5858884514305673`*^9}, {
  3.586652223415927*^9, 3.5866522817792654`*^9}, {3.918070187176998*^9, 
  3.9180704239845176`*^9}},ExpressionUUID->"6f2b6b02-770f-4257-957d-\
f580af4659cd"]
}, Closed]],

Cell[CellGroupData[{

Cell["Version Info", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571340636932308*^9, 3.5713406389914255`*^9}, {
  3.571341091232292*^9, 
  3.5713410961005707`*^9}},ExpressionUUID->"809f4596-440f-4c5a-af75-\
eb1652a3a62a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$VersionInfo", ":=", 
   RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"titleSUMCON", "=", 
        RowBox[{"Import", "[", "\"\<SUMCON.PNG\>\"", "]"}]}], ";", 
       RowBox[{"(*", 
        RowBox[{"Import", " ", "Title"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Top"}]}], " ", 
          RowBox[{"Frame", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Image", "[", 
            RowBox[{"titleSUMCON", ",", 
             RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Pane", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TableForm", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.5.0 Release (28/02/2024)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Added option to lock individual DoF to ground.\>\"", 
                 ",", "\[IndentingNewLine]", 
                 "\"\<* Added filled cylinders to body shapes list.\>\"", ",",
                  "\[IndentingNewLine]", 
                 "\"\<* Added the option to add vertical springs between \
bodies without needing to add a suspension wire between them.\>\"", ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Added Q-value predictions to the eiganmode list.\>\"",
                  ",", "\[IndentingNewLine]", 
                 "\"\<* Added a new way to export the model to MATLAB by \
generating a simple function and matrix files to a given directory.\>\"", ",",
                  "\[IndentingNewLine]", 
                 "\"\<* Altered body rotations to be extrinsically defined in \
kinematic equations.\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Altered several checks which would refuse to generate \
a model if certain arbitary parameters were not met.\>\"", ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Altered how comments are associated and now do not \
inherit between fields.\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Fixed a several typos and errors that disabled \
features in v1.4.\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Heatlinks are no longer required to add dampers.\>\"",
                  ",", "\[IndentingNewLine]", 
                 "\"\<Note - Older models may need regenerating by opening \
and saving each tab.\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.4 Release (31/10/2017)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Support for comments added by Mark B. \>\"", ",", 
                 "\n", "\t\t    ", 
                 "\"\<* Some Japanese English typos were corrected.\>\"", ",",
                  "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.32 Release (05/02/2015)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Improve interface to accelerate Eigen Plots.\>\"", 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.31 Release (05/02/2014)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Add 'Z ONLY' output in MATALB Export module.\>\"", 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.3 Release (06/12/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Add combined output in 'Frequency Response to \
External Force/Torque'.\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Fix bugs happening in save/load model.'\>\"", ",", 
                 "\[IndentingNewLine]", "\"\<\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.2 Release (13/10/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Fix bugs for newly introduced functions in v1.1.\>\"",
                  ",", "\[IndentingNewLine]", 
                 "\"\<* Introduce 'Import' button to the 'Frequency Domain \
Plot Tools'\>\"", ",", "\[IndentingNewLine]", "\"\<\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.1 Release (16/08/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Introduce the Tab-View interface.\>\"", ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Add 'Export' button to the 'Frequency Domain Plot \
Tools'\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Add 'Export Model' section for other \
applications.\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Fix bugs for Macintosh users.\>\"", ",", 
                 "\[IndentingNewLine]", "\"\<\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.0 Release (22/03/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", "\"\<* Beta version released.\>\""}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"TableAlignments", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"Left", ",", "Top"}], "}"}]}]}], "]"}], ",", 
             RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
     ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Version Information\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAmIQHbP7xppTs185vum+uRZEi/CIbgbRkoyJp0C01f4V
50C0AFfeLRA9QcHlFZj/N431NJCuCJqlzr39leOdZD4tEL2JseEXD5Ce17Kc
iRdIfztYvl8XSB9WNX8Lonm+NX8C0YbpRp9B9O+8Cfc7gfRbHdf3IFrLecUX
EN3yuv47iJ7yTewPiH5Rs+E/iF7Bu91rwoFXjrOyZ8WDaIdfXDrVJ4Hq3Dx0
QfRrjz5TEH3l4GQwLfd5RzmIfnaNswFEmy5VUG+5/Mpx5YMwfRAtf/GwV4Tc
a8cOFs8AEL3hVk6PvOFbR2/mLf0g+lO84kwQ/bnSfRWILr+ruw5EP/Cb+gVE
5yh+YVAA0vP3FwmA6KKHv+RAtEpfgwaIDkvW0wXRWgwhRmB1meJWikBaSeO6
A4iuibnvAqK1t/n5guhbZj8CQfQr7dxoEA0AigrQpw==
  "],ExpressionUUID->"7ec23a9a-c194-44cd-85f1-8ed5f3cf8a2c"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Save & Load Model", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490282922274*^9, 
  3.5714902867994957`*^9}},ExpressionUUID->"fed2f8e8-19ce-4826-9f79-\
5a3ce5539492"],

Cell[CellGroupData[{

Cell["Save Function", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5856372418869*^9, 
  3.585637244038023*^9}},ExpressionUUID->"ee86c526-10cd-4c51-bc72-\
287bbb6455a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$ListSave", "[", 
    RowBox[{"file_", ",", "list_"}], "]"}], ":=", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"Save", "[", 
      RowBox[{"file", ",", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"list", "[", 
         RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585637244627057*^9, 3.5856372851143723`*^9}, {
  3.585637349972082*^9, 3.5856374107665596`*^9}, {3.5856377033182926`*^9, 
  3.5856377093436375`*^9}, {3.585637755012249*^9, 3.5856377573783846`*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"9f306d74-928b-4766-beeb-5312409194f7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Save Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5702971671724167`*^9, 
  3.570297169398544*^9}},ExpressionUUID->"9ad011ea-d59a-4792-9e2e-\
0f97faa99447"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SaveModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$saveQ", "=", "False"}], ";", "\[IndentingNewLine]", 
        RowBox[{"saveparamnames", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Names", "[", "\"\<save$*\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<calc$*\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<matK@\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<matG@\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<matM@\>\"", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<allvars\>\"", ",", "\"\<allparams\>\"", ",", 
             "\"\<allfloats\>\"", ",", "\"\<subdefparams\>\"", ",", 
             "\"\<subminvars\>\"", ",", "\"\<eigenf\>\"", ",", 
             "\"\<eigenv\>\"", ",", "\"\<bodylist\>\"", ",", 
             "\"\<wirelist\>\"", ",", "\"\<calcdone\>\""}], "}"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ValueQ", "[", "save$FileName", "]"}], ",", 
          RowBox[{"temp$FileName", "=", "save$FileName"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "temp$FileName", "]"}], ",", 
            RowBox[{"temp$FileName", "=", "\"\<\>\""}]}], "]"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Save Model\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$FileName", "]"}], ",", "String", 
             ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"30.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"StringLength", "[", "temp$FileName", "]"}], 
                 "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                   ",", 
                   RowBox[{
                   "\"\<save\>\"", "<>", "sepchar", "<>", "temp$FileName", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"temp$saveQ", "=", "True"}], ",", 
                 RowBox[{
                  RowBox[{"save$FileName", "=", "temp$FileName"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamlist"}], "]"}], ";"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"mod$ListSave", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamnames"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"PaneSelector", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<Do you really want to overwrite?\>\"", ",", "Red", ",",
                    "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"save$FileName", "=", "temp$FileName"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamlist"}], "]"}], "]"}], ","}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"mod$ListSave", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamnames"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                   RowBox[{"temp$saveQ", "=", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
            RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", "temp$saveQ", 
          ",", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", "=", "n"}], "}"}], ",", 
                RowBox[{"Button", "[", 
                 RowBox[{
                  RowBox[{"StringDrop", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$FileName", "=", 
                   RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], ",", 
                  RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], "]"}], 
              "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"FileNames", "[", 
                  RowBox[{"\"\<*.m\>\"", ",", 
                   RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                 "]"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"550", ",", "400"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"600", ",", "650"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Save Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.579318697254388*^9, 3.5793187226368394`*^9}, {3.585629975834306*^9, 
   3.585630077335111*^9}, {3.585630263322749*^9, 3.5856302650288467`*^9}, {
   3.5856347455931206`*^9, 3.585634746358164*^9}, {3.5856353565610657`*^9, 
   3.5856355069106655`*^9}, {3.5856355566455097`*^9, 
   3.5856355660450478`*^9}, {3.585635610080566*^9, 3.585635658069311*^9}, {
   3.5856357377588687`*^9, 3.585635817647438*^9}, {3.58563590002215*^9, 
   3.5856359428636003`*^9}, {3.5856359867011075`*^9, 
   3.5856360252073097`*^9}, {3.5856360552850304`*^9, 
   3.5856361583309245`*^9}, {3.585636317472027*^9, 3.5856363238123894`*^9}, {
   3.5856364294044285`*^9, 3.585636439427002*^9}, 3.585636492519039*^9, {
   3.585636950592239*^9, 3.58563700270922*^9}, {3.585637094659479*^9, 
   3.585637144719342*^9}, 3.585637196055279*^9, {3.585637449364767*^9, 
   3.5856374776803865`*^9}, {3.5856375144344893`*^9, 3.585637561091158*^9}, {
   3.585637860668292*^9, 3.585637863355446*^9}, {3.5856380848111124`*^9, 
   3.5856380884463205`*^9}, {3.5856384303908787`*^9, 3.585638439748414*^9}, {
   3.585638581349513*^9, 3.585638740808634*^9}, {3.5856388057633486`*^9, 
   3.5856388302697506`*^9}, 3.58563889827264*^9, {3.585638963856391*^9, 
   3.5856389724948854`*^9}, {3.585639055678643*^9, 3.5856390565096903`*^9}, {
   3.585720099535734*^9, 3.585720101754861*^9}, {3.585720135956817*^9, 
   3.5857201360708237`*^9}, {3.5857201760161085`*^9, 3.5857201880968*^9}, {
   3.585720245394077*^9, 3.5857202455090837`*^9}, {3.585721771782381*^9, 
   3.5857217758776155`*^9}, {3.5857249762436657`*^9, 3.58572498051191*^9}, {
   3.585725308349661*^9, 3.5857253088116875`*^9}, {3.585727970873949*^9, 
   3.5857280054689274`*^9}, {3.585773203829859*^9, 3.5857732212408547`*^9}, {
   3.585773341354725*^9, 3.585773342283778*^9}, {3.595301074403346*^9, 
   3.595301078414576*^9}, {3.5953011846596527`*^9, 3.5953012446330833`*^9}, {
   3.5953012816181984`*^9, 3.595301281738205*^9}, 3.5953013410645986`*^9, {
   3.595301506500061*^9, 3.5953016010794706`*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"27202074-1c1b-4109-8628-8016c3a69048"]
}, Closed]],

Cell[CellGroupData[{

Cell["Load Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703648112755613`*^9, 
  3.5703648131296673`*^9}},ExpressionUUID->"7f8b2047-7d08-4645-a215-\
176611d8e5d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$LoadModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ValueQ", "[", "save$FileName", "]"}], ",", 
          RowBox[{"temp$FileName", "=", "save$FileName"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "temp$FileName", "]"}], ",", 
            RowBox[{"temp$FileName", "=", "\"\<\>\""}]}], "]"}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
          "*", "Version", " ", 
          RowBox[{
          "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
            "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
          "*", "Version", " ", 
          RowBox[{
          "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
            "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Load Model\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$Load", "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"30.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"Not", "[", 
                 RowBox[{
                  RowBox[{"StringLength", "[", "temp$Load", "]"}], "\[Equal]",
                   "0"}], "]"}], ",", 
                RowBox[{"Get", "[", 
                 RowBox[{
                  RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                   "sepchar", "<>", "temp$Load", "<>", "\"\<.m\>\""}], 
                 "]"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "}"}], 
         "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", "=", "n"}], "}"}], ",", 
                RowBox[{"Button", "[", 
                 RowBox[{
                  RowBox[{"StringDrop", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$Load", "=", 
                   RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], ",", 
                  RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], "]"}], 
              "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"FileNames", "[", 
                  RowBox[{"\"\<*.m\>\"", ",", 
                   RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                 "]"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"550", ",", "400"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"600", ",", "650"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.5703648187229877`*^9, 
   3.570364842461345*^9}, {3.5703650147151976`*^9, 3.570365221167006*^9}, {
   3.571491889628173*^9, 3.5714919173387575`*^9}, {3.579318727822136*^9, 
   3.579318738045721*^9}, {3.5856378415101967`*^9, 3.585637880435423*^9}, {
   3.585637912451254*^9, 3.585637917376536*^9}, {3.5856935124470396`*^9, 
   3.5856935130710754`*^9}, {3.585720252369476*^9, 3.585720256195695*^9}, {
   3.5857203031763816`*^9, 3.585720327810791*^9}, {3.5857203659619727`*^9, 
   3.5857203671100388`*^9}, {3.585720445584527*^9, 3.585720452507923*^9}, {
   3.5953016660081844`*^9, 3.595301668884349*^9}, {3.5953017046333933`*^9, 
   3.595301751289062*^9}, {3.5953018297485495`*^9, 3.5953018474225607`*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"a486a8ae-3691-4b00-8ec3-75db62dcae3f"]
}, Closed]],

Cell[CellGroupData[{

Cell["New Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703648112755613`*^9, 3.5703648131296673`*^9}, {
  3.5858856211936865`*^9, 
  3.5858856216377125`*^9}},ExpressionUUID->"1eafc14e-a176-4669-a1a5-\
cba07cb73d4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewModel", ":=", 
   RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Do you want to clear all the setting and start a new model?\>\"", 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<OK\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"calcdone", "=", "False"}], ";", 
                RowBox[{"Clear", "[", 
                 RowBox[{"\"\<save$*\>\"", ",", "\"\<calc$*\>\""}], "]"}], 
                ";"}], ")"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Model\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571340646772871*^9, 3.5713406547983303`*^9}, {
  3.5713406966577244`*^9, 3.571340883031384*^9}, {3.571340917273343*^9, 
  3.5713410114387283`*^9}, {3.585886997498407*^9, 3.585887124057646*^9}, {
  3.5858871885563345`*^9, 3.585887198684914*^9}, {3.5858872351259985`*^9, 
  3.585887318957793*^9}, {3.5858873639403667`*^9, 3.5858873869406815`*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"f8b9fb38-9924-46d0-8fa3-4516271d672e"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1. Define Bodies", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.567267260762373*^9, 3.5672672628784943`*^9}, {
   3.567267513410824*^9, 3.567267558324393*^9}, 3.571490196526333*^9, {
   3.5714902918937874`*^9, 3.5714903042524943`*^9}, {3.716516684167289*^9, 
   3.716516686092642*^9}, 
   3.71841455270389*^9},ExpressionUUID->"0e05e1df-5b81-4450-9d95-\
409df2d61901"],

Cell[CellGroupData[{

Cell["1-1 Define Body Names", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701196462297916`*^9, 3.570119669842142*^9}, {
   3.718291962853812*^9, 3.718291963989316*^9}, 
   3.718414554695867*^9},ExpressionUUID->"34f3ef9d-567b-48bd-bc3d-\
8cf1704c7eae"],

Cell[CellGroupData[{

Cell["Define Body Names", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567054229706352*^9, 3.5670542365717444`*^9}, {
   3.5701196762995114`*^9, 3.570119679530696*^9}, {3.718291967009993*^9, 
   3.71829196826577*^9}, 
   3.7184145568146467`*^9},ExpressionUUID->"3a027f48-a2b0-4d6b-9671-\
3632abbac7bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetBodyNames", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Define Body Names\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Load"}]}], " ", 
           RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"nMax", "=", "25"}], ",", "len"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], ",", 
            " ", 
            RowBox[{"load", " ", "it"}]}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ValueQ", "[", "save$bdn", "]"}], ",", 
             RowBox[{
              RowBox[{"len", "=", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
               "Accounting", " ", "for", " ", "legacy", " ", "saves"}], " ", 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{"Do", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "<", " ", 
                   "6"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "6"}], 
                    "]"}]}], ";"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ";"}]}], "]"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", "len"}], "}"}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
               "Include", " ", "comments", " ", "as", " ", "third", " ", 
                "column", " ", "temporarily"}], " ", "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"temp$temp$bdn", "=", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ValueQ", "[", "save$bdn$comments", "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Join", "[", 
                  RowBox[{"save$bdn", ",", 
                   RowBox[{"save$bdn$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", 
                    RowBox[{"{", "2", "}"}]}], "]"}], "]"}], ",", "2"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Join", "[", 
                  RowBox[{"save$bdn", ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\"\<\>\"", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}], 
                   ",", "2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Pad", "/", "trim"}], " ", "list", " ", "to", " ", 
                "nMax"}], " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"len", "<", "nMax"}], ",", "\[IndentingNewLine]", 
                RowBox[{"temp$bdn", "=", 
                 RowBox[{"Join", "[", 
                  RowBox[{"temp$temp$bdn", ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", "6"}], "]"}], ",", "\"\<\>\"", ",", 
                    "\"\<\>\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"nMax", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"temp$bdn", "=", 
                 RowBox[{"temp$temp$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ";;", "nMax"}], "]"}], "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Do", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "<", " ", 
                   "6"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "6"}], 
                    "]"}]}], ";"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ";"}]}], "]"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", "len"}], "}"}]}], "]"}], ";"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"If", " ", "not"}], ",", " ", 
               RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"temp$bdn", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{"True", ",", "6"}], "]"}], ",", "\"\<g\>\"", ",", 
                   "\"\<\>\""}], "}"}], "}"}], ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", "6"}], "]"}], ",", "\"\<\>\"", ",", 
                    "\"\<\>\""}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"nMax", "-", "1"}], "}"}]}], "]"}]}], "]"}]}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Input"}]}], " ", "Field", " ", 
              RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Partition", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Table", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"Transpose", "[", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10."}], "}"}]}]}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", "nMax"}], "}"}]}], "]"}], ",", "1"}], 
                "]"}], ",", "7", ",", "7", ",", "1", ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", "Center"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<xGND\>\"", ",", "\"\<yGND\>\"", ",", "\"\<zGND\>\"", 
                    ",", "\"\<pitchGND\>\"", ",", "\"\<yawGND\>\"", ",", 
                    "\"\<rollGND\>\"", ",", "\"\<Name\>\""}], "}"}], ",", 
                    RowBox[{"{", "5", "}"}]}], "]"}], ",", "1"}], "]"}]}], 
               "}"}]}]}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"(*", 
                RowBox[{"Save", " ", "Button"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"temp$temp$bdn", "=", 
                 RowBox[{"DeleteCases", "[", 
                  RowBox[{
                   RowBox[{"DeleteCases", "[", 
                    RowBox[{"temp$bdn", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", "6"}], "]"}], ",", "\"\<\>\"", ",", 
                    RowBox[{"x_", "?", "StringQ"}]}], "}"}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{"True", ",", "6"}], "]"}], ",", "\"\<\>\"", ",", 
                    RowBox[{"x_", "?", "StringQ"}]}], "}"}]}], "]"}]}], ";", 
                RowBox[{"save$bdn", " ", "=", " ", 
                 RowBox[{"temp$temp$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", 
                    RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"save$bdn$comments", " ", "=", " ", 
                 RowBox[{"temp$temp$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "]"}]}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", 
      RowBox[{"(*", 
       RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<1-1 Set Body Names\>\""}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566889731755993*^9, 3.5668897823058844`*^9}, {
   3.566889828859547*^9, 3.566889886714856*^9}, {3.5668899175776215`*^9, 
   3.5668901655738063`*^9}, {3.566890196972602*^9, 3.566890199961773*^9}, {
   3.5668903236848497`*^9, 3.5668903462531404`*^9}, {3.5668904168021755`*^9, 
   3.566890551243865*^9}, {3.566890625559116*^9, 3.566890628851304*^9}, {
   3.5668906610411453`*^9, 3.5668906778621073`*^9}, {3.566890768100269*^9, 
   3.566890784114185*^9}, {3.5668908451256742`*^9, 3.5668908877861147`*^9}, 
   3.566891015361411*^9, 3.566891047194232*^9, {3.566891183957054*^9, 
   3.5668912099195395`*^9}, {3.5668912400952654`*^9, 3.566891244621524*^9}, {
   3.5668915432576056`*^9, 3.5668915449367013`*^9}, {3.566891715968484*^9, 
   3.5668918358523407`*^9}, {3.5668918709093456`*^9, 
   3.5668919456306195`*^9}, {3.5668919801025915`*^9, 
   3.5668920205259037`*^9}, {3.5668921640831146`*^9, 
   3.5668921784709373`*^9}, {3.5669005192484193`*^9, 
   3.5669005275928965`*^9}, {3.566900766911585*^9, 3.5669007676166253`*^9}, {
   3.566900884500311*^9, 3.5669008846533194`*^9}, {3.5669009277877865`*^9, 
   3.5669009420656033`*^9}, {3.566900976717585*^9, 3.566900990180355*^9}, {
   3.5669011295833282`*^9, 3.566901154485753*^9}, {3.5669013452236624`*^9, 
   3.566901441446166*^9}, {3.5669015126182365`*^9, 3.566901578348996*^9}, {
   3.56690206340174*^9, 3.5669021167747927`*^9}, {3.5670472309350452`*^9, 
   3.5670472422206907`*^9}, {3.567049068330138*^9, 3.567049128459577*^9}, {
   3.567049167883832*^9, 3.5670491697939415`*^9}, {3.567049214166479*^9, 
   3.5670492154155507`*^9}, {3.567049277939127*^9, 3.567049311335037*^9}, {
   3.5670493673282394`*^9, 3.5670494751234055`*^9}, {3.5670495188559065`*^9, 
   3.5670495276194077`*^9}, {3.5670499046279716`*^9, 
   3.5670499125794263`*^9}, {3.5670500075978613`*^9, 3.567050082795162*^9}, {
   3.567050121957402*^9, 3.567050142257563*^9}, {3.5670502103874598`*^9, 
   3.567050320436754*^9}, {3.5670503781780567`*^9, 3.5670503853374662`*^9}, 
   3.567050423894672*^9, {3.5670506654214864`*^9, 3.5670506813283963`*^9}, {
   3.56705071234017*^9, 3.5670507706615057`*^9}, {3.567050872177312*^9, 
   3.567050989024996*^9}, {3.5670512359771204`*^9, 3.567051292753368*^9}, {
   3.567051650941855*^9, 3.5670516674888015`*^9}, {3.5670524229500113`*^9, 
   3.567052430582448*^9}, {3.5670524819683867`*^9, 3.567052544048938*^9}, {
   3.5670526884181952`*^9, 3.567052698854792*^9}, {3.567052773789078*^9, 
   3.5670528319914074`*^9}, 3.567052865848344*^9, {3.567053705189351*^9, 
   3.5670537075144844`*^9}, {3.567054056444442*^9, 3.567054063632853*^9}, {
   3.5670541466215997`*^9, 3.567054200316671*^9}, {3.567054378205846*^9, 
   3.5670546294832177`*^9}, {3.567054679642087*^9, 3.567054696184033*^9}, {
   3.5670547766336346`*^9, 3.5670547894463673`*^9}, {3.5670548916962156`*^9, 
   3.5670549191477857`*^9}, {3.5670563032379513`*^9, 3.567056423484829*^9}, {
   3.5670564615200043`*^9, 3.567056466460287*^9}, {3.567056530281937*^9, 
   3.5670566018970337`*^9}, {3.5670569741953278`*^9, 
   3.5670570850906706`*^9}, {3.567059166334711*^9, 3.5670592158985453`*^9}, {
   3.5670592793491745`*^9, 3.567059317689368*^9}, {3.567063087771004*^9, 
   3.5670630892320876`*^9}, {3.5670695474044743`*^9, 
   3.5670695492815814`*^9}, {3.5670988132317157`*^9, 3.5670988150248184`*^9}, 
   3.5672318299772635`*^9, {3.5675807247684803`*^9, 3.5675807249994936`*^9}, {
   3.5675809545326223`*^9, 3.567580954762635*^9}, {3.567583195411793*^9, 
   3.567583198890992*^9}, {3.5677724913907447`*^9, 3.5677724953469715`*^9}, {
   3.5699565775988846`*^9, 3.569956584503279*^9}, {3.569956662001712*^9, 
   3.5699566621487207`*^9}, {3.5699568606800756`*^9, 3.569956868180505*^9}, {
   3.569956970692368*^9, 3.569956971515415*^9}, {3.569957391410432*^9, 
   3.5699573941355877`*^9}, {3.570108567824143*^9, 3.570108571947379*^9}, {
   3.5701086204881554`*^9, 3.5701086333298893`*^9}, {3.570108671639081*^9, 
   3.570108769759693*^9}, {3.5701088095399685`*^9, 3.570108919817276*^9}, {
   3.5701089890182343`*^9, 3.570109147034272*^9}, {3.5701092402196016`*^9, 
   3.5701096738074017`*^9}, {3.5701097936652575`*^9, 
   3.5701099566595798`*^9}, {3.570110027697643*^9, 3.570110118155817*^9}, {
   3.5701101625923586`*^9, 3.5701102234848413`*^9}, {3.5701104149297915`*^9, 
   3.5701104659137077`*^9}, {3.5701104982435565`*^9, 
   3.5701105330135455`*^9}, {3.570110563092266*^9, 3.5701105957101316`*^9}, {
   3.57011071282583*^9, 3.5701107517620573`*^9}, {3.5701107860690193`*^9, 
   3.5701107892742023`*^9}, {3.5701108256222816`*^9, 
   3.5701109027606936`*^9}, {3.5701109455571413`*^9, 3.570110986883505*^9}, {
   3.570111044172782*^9, 3.570111048875051*^9}, {3.570117373417794*^9, 
   3.5701173736888094`*^9}, 3.5702570696466265`*^9, {3.57025710547989*^9, 
   3.570257131344735*^9}, 3.5702574571669073`*^9, {3.570257683322505*^9, 
   3.5702576836657057`*^9}, {3.5702578161879377`*^9, 
   3.5702578271391573`*^9}, {3.570258174272167*^9, 3.5702581759413705`*^9}, {
   3.716933912347349*^9, 3.716933914621703*^9}, {3.718292018118973*^9, 
   3.7182920439975147`*^9}, {3.718292086413354*^9, 3.718292130219105*^9}, {
   3.718292222422163*^9, 3.718292234415168*^9}, {3.718292361919437*^9, 
   3.7182923726261883`*^9}, {3.718292480618029*^9, 3.718292528039014*^9}, 
   3.718292606076235*^9, 3.718293102045081*^9, {3.71829313311635*^9, 
   3.718293201674995*^9}, {3.718293398749775*^9, 3.718293447931233*^9}, {
   3.71829349347027*^9, 3.7182935882118607`*^9}, {3.718294357468465*^9, 
   3.718294367411809*^9}, {3.718294578978734*^9, 3.718294580338463*^9}, {
   3.718294618897223*^9, 3.718294646973011*^9}, {3.718294683675057*^9, 
   3.7182946874844637`*^9}, {3.7182948229638968`*^9, 
   3.7182949652357264`*^9}, {3.7182949971391907`*^9, 3.718295135329595*^9}, {
   3.7182951717207327`*^9, 3.7182951903864937`*^9}, {3.718295316148354*^9, 
   3.718295378398569*^9}, {3.7182954118697987`*^9, 3.7182954935907297`*^9}, {
   3.718295540816484*^9, 3.718295636086973*^9}, {3.718295668347316*^9, 
   3.7182959082817707`*^9}, {3.718295943054408*^9, 3.718295977354754*^9}, {
   3.71829602766181*^9, 3.7182960280178423`*^9}, {3.718296159769166*^9, 
   3.718296186743444*^9}, {3.7182963503353*^9, 3.7182964068599586`*^9}, {
   3.7182966576848593`*^9, 3.718296696147336*^9}, {3.718296786870356*^9, 
   3.718296808410697*^9}, {3.71829691673097*^9, 3.718296927233522*^9}, {
   3.718297373955674*^9, 3.71829737590703*^9}, 3.718414558433135*^9, 
   3.915679442613426*^9, 3.9156794975803213`*^9, 3.9156795420925493`*^9, {
   3.9156796174203644`*^9, 3.915679618668188*^9}, 3.915679658772713*^9, {
   3.9156797316999183`*^9, 3.915679734908459*^9}, {3.9156797814678383`*^9, 
   3.9156797890906553`*^9}, {3.9156798500368834`*^9, 
   3.9156798514972525`*^9}, {3.9156799024438753`*^9, 
   3.9156799030034657`*^9}, {3.915680332705494*^9, 3.915680364265806*^9}, {
   3.915680419069379*^9, 3.9156804720675125`*^9}, 3.9156806329810896`*^9, {
   3.915680722852749*^9, 3.9156807298879795`*^9}, {3.915680828278874*^9, 
   3.9156808791367283`*^9}, {3.9156810212840915`*^9, 3.91568102214247*^9}, {
   3.9156812162746696`*^9, 3.9156812742281113`*^9}, {3.915681325682868*^9, 
   3.915681338234744*^9}, {3.9156813823960233`*^9, 3.915681400534292*^9}, {
   3.915681488569914*^9, 3.9156814926197543`*^9}, {3.915681527824884*^9, 
   3.9156816075857124`*^9}, 3.9156816841915064`*^9, {3.9156818603480473`*^9, 
   3.9156819621393642`*^9}, {3.915682040044133*^9, 3.9156821387130766`*^9}, {
   3.9156821909765434`*^9, 3.915682253919569*^9}, {3.9156823671790113`*^9, 
   3.915682398198474*^9}, {3.915682507833609*^9, 3.9156825201395845`*^9}, {
   3.9156825866077642`*^9, 3.915682664053095*^9}, 3.915683647257141*^9, {
   3.91573712588958*^9, 3.9157372261918917`*^9}, 3.9157373889129906`*^9, {
   3.915737473520359*^9, 3.9157374782234707`*^9}, {3.9157375139523635`*^9, 
   3.915737519024436*^9}, {3.915737555685402*^9, 3.9157375785034018`*^9}, {
   3.9157376402483397`*^9, 3.9157376471459465`*^9}, {3.9157377369450035`*^9, 
   3.91573779080752*^9}, {3.9157378550959578`*^9, 3.9157379068884535`*^9}, {
   3.9157380060983477`*^9, 3.9157380196080694`*^9}, 3.9157380601679516`*^9, {
   3.9157381140313544`*^9, 3.9157381278389006`*^9}, {3.915738557614732*^9, 
   3.915738732198265*^9}, 3.915738765160174*^9, {3.915739762644328*^9, 
   3.9157397990232487`*^9}, {3.9157398651756735`*^9, 
   3.9157399059641075`*^9}, {3.915739985957896*^9, 3.9157399907489433`*^9}, {
   3.9157400749165497`*^9, 3.915740087171923*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"1a04c0a7-3582-43cb-a90d-531bea18f599"],

Cell[BoxData["mod$SaveModel"], "Input",ExpressionUUID->"79962ed3-4d99-48c4-b01d-3886f311e1aa"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1-2 Set Mass and MoI", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570119686677105*^9, 
  3.5701196953676023`*^9}},ExpressionUUID->"a5516b51-b213-42b0-a003-\
c0a0d911b599"],

Cell[CellGroupData[{

Cell["Set Mass and Moment of Inertia", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567054972779853*^9, 3.567054976693077*^9}, {
  3.567055022497697*^9, 3.567055048023157*^9}, {3.5670553367586718`*^9, 
  3.5670553505304594`*^9}, {3.5670554993419704`*^9, 3.567055508455492*^9}, {
  3.5670555953084598`*^9, 3.5670555993806925`*^9}, {3.5670558599685974`*^9, 
  3.5670558686600947`*^9}, {3.5670569156809807`*^9, 
  3.567056916226012*^9}},ExpressionUUID->"1617e38a-c4d8-4279-95d9-\
6c24464e07a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetMassMoI", ":=", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"--", 
        RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
       RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], "||", 
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been",
          " ", "set", " ", "yet"}], ",", " ", 
        RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Beep", "[", "]"}], ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Set Body Names First.\>\"", ",", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", 
              RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TextCell", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Set Masses and Moments of Inertia\>\"", ",", 
               "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
              "]"}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Load"}]}], " ", 
              RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"len0", "=", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], ",", "len"}], 
              "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                RowBox[{
                 RowBox[{"len", "=", 
                  RowBox[{"Length", "[", "save$mass", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"len", "<", "len0"}], ",", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$mass", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"save$mass", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"temp$mass", "=", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
                ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"If", " ", "not"}], ",", " ", 
                  RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"temp$mass", "=", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", "len0", "}"}]}], "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"ValueQ", "[", "save$mass$comments", "]"}], ",", 
                RowBox[{
                 RowBox[{"len", "=", 
                  RowBox[{"Length", "[", "save$mass$comments", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"len", "<", "len0"}], ",", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$mass$comments", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"save$mass$comments", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<\>\"", ",", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"\"\<\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"temp$mass$comments", "=", 
                    RowBox[{"save$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
                ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"If", " ", "not"}], ",", " ", 
                  RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"temp$mass$comments", "=", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\"\<\>\"", ",", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"\"\<\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", "len0", "}"}]}], "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Logic"}]}], " ", "List", " ", "for", " ", 
                 RowBox[{"Opener", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"temp$massopn", "=", 
               RowBox[{"Table", "[", 
                RowBox[{"False", ",", 
                 RowBox[{"{", "len0", "}"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                 RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Copy", " ", "&"}], " ", "Paste"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$masscopy", "=", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ";", 
                    RowBox[{"temp$mass$commentscopy", "=", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Paste\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "temp$masscopy", "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", "temp$masscopy"}], 
                    ";", 
                    RowBox[{
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                    "temp$mass$commentscopy"}]}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Mass", " ", "&"}], " ", "Diagonal", " ", "MoI"}],
                     "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "String", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "String", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "String", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}]}], "]"}], "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"MoI", " ", "Off"}], "-", 
                    RowBox[{"Diagonal", " ", "Part"}]}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Opener", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$massopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", 
                    RowBox[{"PaneSelector", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"False", "\[Rule]", "\"\<Off-Diag\>\""}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"True", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m", ",", "l"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "70."}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m", ",", "l"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "70."}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"And", "@@", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], "]"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m", ",", "l"}], "]"}], "]"}],
                     "]"}]}], "]"}], "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"l", ",", "3"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}],
                     "}"}]}], "}"}]}]}], "]"}]}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$massopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}]}], 
                   "}"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                RowBox[{"TableHeadings", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{
                    "\"\<Copy\>\"", ",", "\"\<Paste\>\"", ",", "\"\<Mass\>\"",
                     ",", "\"\<Ixx\>\"", ",", "\"\<Iyy\>\"", ",", 
                    "\"\<Izz\>\"", ",", "\"\<\>\"", ",", "\"\<I Matrix\>\""}],
                     "}"}]}], "}"}]}]}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"--", 
                RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
              RowBox[{"Button", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"If", " ", "mass"}], " ", "&"}], " ", "MoI", " ", 
                    "diagonals", " ", "are", " ", "not", " ", "positive", " ",
                     "number"}], ",", " ", 
                   RowBox[{"return", " ", "Error"}]}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "||", 
                    RowBox[{"(", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
                    "False"}], "]"}], "&&", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}], ",", "False"}], "]"}], "&&", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}], ",", "False"}], "]"}], "&&", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}], ",", "False"}], "]"}], "&&", 
                    "\[IndentingNewLine]", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "2"}], "]"}], "]"}],
                     "]"}], "&&", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "3"}], "]"}], "]"}],
                     "]"}], "&&", "\[IndentingNewLine]", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "1"}], "]"}], "]"}],
                     "]"}], "&&", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "3"}], "]"}], "]"}],
                     "]"}], "&&", "\[IndentingNewLine]", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "1"}], "]"}], "]"}],
                     "]"}], "&&", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "2"}], "]"}], "]"}],
                     "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$mass", "]"}]}], "}"}]}], 
                    "]"}], ",", "False"}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Beep", "[", "]"}], ";", 
                    RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Mass and diagonal parts of MoI matrices should be \
positive numbers.\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}], ";"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", 
                    RowBox[{
                    RowBox[{"save$mass", "=", "temp$mass"}], ";", 
                    RowBox[{
                    "save$mass$comments", "=", "temp$mass$comments"}]}], 
                    "]"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"(*", 
                RowBox[{"Save", " ", "Button"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{"\"\<Cancel\>\"", ",", 
                 RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
            "]"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
            RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"WindowElements", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
            ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WindowSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"700", ",", "500"}], "}"}]}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<1-2 Set Mass & MoI\>\""}]}], 
        "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567055520333172*^9, 3.5670555248434296`*^9}, {
   3.5670558779396257`*^9, 3.567055932130725*^9}, {3.567056182813063*^9, 
   3.567056187139311*^9}, 3.5670566443634624`*^9, {3.5670581487965107`*^9, 
   3.5670587302207665`*^9}, {3.567058803921982*^9, 3.5670588119104385`*^9}, {
   3.5670588537588325`*^9, 3.5670589617560096`*^9}, {3.567059001927307*^9, 
   3.567059019322302*^9}, {3.5670590584755416`*^9, 3.567059058761558*^9}, {
   3.5670593830151043`*^9, 3.567059434116027*^9}, {3.5670595428712473`*^9, 
   3.567059603217699*^9}, {3.567059707460662*^9, 3.5670597122009325`*^9}, {
   3.567060226661358*^9, 3.567060227207389*^9}, {3.5670606357247553`*^9, 
   3.5670606437432137`*^9}, 3.5670609417812605`*^9, 3.567061001332667*^9, {
   3.567061150497198*^9, 3.567061150770214*^9}, {3.5670613553849173`*^9, 
   3.567061355524925*^9}, {3.567061387575759*^9, 3.567061424517872*^9}, {
   3.5670633500420055`*^9, 3.5670633775415783`*^9}, 3.5670636045785637`*^9, {
   3.5670636804029007`*^9, 3.5670638187628145`*^9}, {3.5670638497815886`*^9, 
   3.567063928781107*^9}, 3.56706395907484*^9, {3.567063999954178*^9, 
   3.5670640061345315`*^9}, {3.5670640580745025`*^9, 3.5670641192009983`*^9}, 
   3.5670641706839433`*^9, {3.5670642353536425`*^9, 3.56706423967789*^9}, {
   3.567064314740183*^9, 3.56706433112612*^9}, {3.567064548991581*^9, 
   3.567064565017498*^9}, {3.567064611320146*^9, 3.567064612807231*^9}, {
   3.567064902398795*^9, 3.567065019369485*^9}, {3.567065596597501*^9, 
   3.5670656689066367`*^9}, {3.567065711905096*^9, 3.5670657416497974`*^9}, {
   3.5670657824121284`*^9, 3.5670658866440907`*^9}, {3.567065916858819*^9, 
   3.5670659470505457`*^9}, {3.5670659975034313`*^9, 3.567066003233759*^9}, {
   3.5670661904354663`*^9, 3.5670661955657597`*^9}, {3.5670663202768927`*^9, 
   3.567066324293123*^9}, {3.5670675069927692`*^9, 3.567067598707015*^9}, {
   3.5670676669759197`*^9, 3.56706801769998*^9}, {3.567068108545176*^9, 
   3.567068111212329*^9}, {3.5670682431428747`*^9, 3.5670683206973104`*^9}, {
   3.567068414414671*^9, 3.56706847541916*^9}, 3.5670686101768675`*^9, {
   3.5670686645959806`*^9, 3.567068669089237*^9}, {3.5670688623632917`*^9, 
   3.567068895080163*^9}, {3.5670689271639986`*^9, 3.5670691770242896`*^9}, {
   3.5670692500364656`*^9, 3.567069271147673*^9}, {3.5670693073207417`*^9, 
   3.567069469048992*^9}, {3.567069539006994*^9, 3.567069543327241*^9}, {
   3.567090487899534*^9, 3.5670905052035236`*^9}, {3.567091483629486*^9, 
   3.567091491153917*^9}, {3.5670987037624545`*^9, 3.5670987249196644`*^9}, {
   3.5670988066163373`*^9, 3.5670988275795364`*^9}, 3.5672318360226088`*^9, {
   3.5672318756848774`*^9, 3.5672318763709164`*^9}, {3.5672682685640163`*^9, 
   3.5672682806397066`*^9}, {3.56757862480637*^9, 3.5675786315697565`*^9}, {
   3.569956662215724*^9, 3.569956662775756*^9}, {3.570111098880911*^9, 
   3.570111229019355*^9}, {3.5701112930080147`*^9, 3.570111333427326*^9}, {
   3.5701115179308796`*^9, 3.5701115697008405`*^9}, {3.570111609715129*^9, 
   3.570111613905369*^9}, {3.570111682311281*^9, 3.570111960362185*^9}, {
   3.570111993455078*^9, 3.5701130609221334`*^9}, {3.570113098172264*^9, 
   3.5701131684722853`*^9}, {3.57011323098186*^9, 3.5701134073899508`*^9}, {
   3.570113438781746*^9, 3.570113472016647*^9}, 3.5701135733714437`*^9, {
   3.570117346523256*^9, 3.570117370587632*^9}, {3.5701174590056896`*^9, 
   3.57011751600895*^9}, {3.5701176756260796`*^9, 3.570117720781662*^9}, {
   3.570117785852384*^9, 3.5701180329145155`*^9}, {3.570118099153304*^9, 
   3.5701182520800505`*^9}, {3.5701182901072254`*^9, 3.570118367001624*^9}, {
   3.5701184361575794`*^9, 3.570118507201643*^9}, {3.570118616106872*^9, 
   3.570118869096342*^9}, {3.5701189181261463`*^9, 3.5701189631647224`*^9}, {
   3.5701190263013334`*^9, 3.5701191941779356`*^9}, {3.5701193124386997`*^9, 
   3.5701193450215635`*^9}, {3.5701193937343493`*^9, 
   3.5701193938583565`*^9}, {3.570123091038823*^9, 3.5701230918458695`*^9}, {
   3.5702570698650274`*^9, 3.570257070738629*^9}, {3.57025710549549*^9, 
   3.57025710560469*^9}, {3.570257152716773*^9, 3.5702571668971977`*^9}, {
   3.5702574571981077`*^9, 3.5702574573229074`*^9}, {3.5702578898494673`*^9, 
   3.570257900847487*^9}, {3.570258150747326*^9, 3.570258195675405*^9}, {
   3.5702865435847816`*^9, 3.570286623331343*^9}, {3.570286655882205*^9, 
   3.570286785118597*^9}, {3.5702870349238853`*^9, 3.5702870361549554`*^9}, {
   3.570287128345228*^9, 3.570287130766367*^9}, {3.5702875797850494`*^9, 
   3.570287581864168*^9}, {3.595308656697029*^9, 3.59530866790267*^9}, 
   3.716517354024122*^9, 3.7165174460462227`*^9, {3.716517507627367*^9, 
   3.716517519533148*^9}, {3.716520116137863*^9, 3.716520136460363*^9}, {
   3.716520220423888*^9, 3.716520308113654*^9}, {3.716520344262974*^9, 
   3.716520437572386*^9}, {3.7165204696716146`*^9, 3.716520472701623*^9}, {
   3.7165205163247137`*^9, 3.7165206847370358`*^9}, {3.716520765998948*^9, 
   3.716520798635436*^9}, {3.7165209191693974`*^9, 3.7165209287773848`*^9}, {
   3.716521110454996*^9, 3.716521116785063*^9}, {3.7165211608018303`*^9, 
   3.716521250338278*^9}, {3.716521325117766*^9, 3.716521353419209*^9}, {
   3.7165245896584473`*^9, 3.716524611287586*^9}, {3.716524697570674*^9, 
   3.716524700069563*^9}, {3.716524780374488*^9, 3.716524780956072*^9}, {
   3.716524890166424*^9, 3.716524892515568*^9}, {3.716525032234343*^9, 
   3.7165250903908663`*^9}, {3.716525149232582*^9, 3.716525150105753*^9}, 
   3.716525237772563*^9, {3.716526884736437*^9, 3.7165268984504023`*^9}, {
   3.716588620827124*^9, 3.716588621879071*^9}, {3.716588701234415*^9, 
   3.716588712123042*^9}, {3.7165887604157753`*^9, 3.716588781578168*^9}, {
   3.716588813073647*^9, 3.71658883427232*^9}, {3.71666619719351*^9, 
   3.7166662386757307`*^9}, {3.716666312442862*^9, 3.716666319092462*^9}, {
   3.716933949484786*^9, 3.716933951526277*^9}, 3.716950594561469*^9, {
   3.915845512204971*^9, 3.9158455939361577`*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"6fc46225-0ec4-44c0-80a4-188d7d7520ed"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["1-3 Set Body Shapes", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701197012959414`*^9, 
  3.570119715169735*^9}},ExpressionUUID->"7bc459f1-20d7-44df-8b14-\
bc4c95fc8960"],

Cell[CellGroupData[{

Cell["Create 3D shapes in the module", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701199716324034`*^9, 3.5701199995960026`*^9}, {
  3.5701200842258434`*^9, 
  3.570120086864994*^9}},ExpressionUUID->"307e9add-a288-45ef-80cb-\
f198a7950362"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$Create3DShapeEx", "[", 
     RowBox[{"shp_", ",", "dim_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"mod$Create3DShape", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "shp", ",", "dim"}], 
       "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.0"}], ",", 
         RowBox[{"+", "0.0"}], ",", 
         RowBox[{"+", "0.0"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", 
     "}"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567101580216978*^9, 3.5671017881248703`*^9}, 
   3.570120003405221*^9, {3.5701200422844443`*^9, 3.570120043509515*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"c31a30f9-aa56-4e76-9610-f526eb0ec3b1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Body Shapes", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567268075509974*^9, 
  3.5672680797332153`*^9}},ExpressionUUID->"9ced4761-9fcb-4e09-b808-\
4f4d34d50293"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetBodyShapes", ":=", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"--", 
        RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
       RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been",
          " ", "set", " ", "yet"}], ",", " ", 
        RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Beep", "[", "]"}], ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Set Body Name First.\>\"", ",", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", 
              RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TextCell", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Set Appearance of Bodies\>\"", ",", "\[IndentingNewLine]", 
               "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Load"}]}], " ", 
              RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"len0", "=", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], ",", "len"}], 
              "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"ValueQ", "[", "save$shape", "]"}], ",", 
                RowBox[{
                 RowBox[{"len", "=", 
                  RowBox[{"Length", "[", "save$shape", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"len", "<", "len0"}], ",", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$shape", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"save$shape", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Cuboid\>\"", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0.2", ",", 
                    RowBox[{"{", "5", "}"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"temp$shape", "=", 
                    RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
                ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"If", " ", "not"}], ",", " ", 
                  RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"temp$shape", "=", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\"\<Cuboid\>\"", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0.2", ",", 
                    RowBox[{"{", "5", "}"}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", "len0", "}"}]}], "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"ValueQ", "[", "save$shape$comments", "]"}], ",", 
                RowBox[{"temp$shape$comments", "=", "save$shape$comments"}], 
                ",", 
                RowBox[{"temp$shape$comments", "=", 
                 RowBox[{"temp$shape", "/.", 
                  RowBox[{
                   RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
                   "\"\<\>\""}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Logic"}]}], " ", "List", " ", "for", " ", 
                 RowBox[{"Opener", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"temp$shapeopn", "=", 
               RowBox[{"Table", "[", 
                RowBox[{"False", ",", 
                 RowBox[{"{", "len0", "}"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                 RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Copy", " ", "&"}], " ", "Paste"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$shapecopy", "=", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ";", 
                    RowBox[{"temp$shape$commentcopy", "=", 
                    RowBox[{"temp$shape$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Paste\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "temp$shapecopy", "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", "temp$shapecopy"}], 
                    ";", 
                    RowBox[{
                    RowBox[{"temp$shape$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                    "temp$shape$commentcopy"}]}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Select", " ", "Menu"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "list$BodyShape"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Dimension", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"list$ShapeDimNote", "[", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", "Small"}], "]"}], 
                    "]"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "5"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shape$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shape$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "5"}], "}"}]}], "]"}]}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Opener", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Opener", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shapeopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Show", " ", "Image"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"False", "\[Rule]", "\"\<Show Image\>\""}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"True", "\[Rule]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Show", "[", 
                    RowBox[{
                    RowBox[{"Graphics3D", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"mod$Create3DShapeEx", "[", 
                    RowBox[{
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                    RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}]}],
                     "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shapeopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}]}], 
                   "}"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                RowBox[{"TableHeadings", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{
                    "\"\<Copy\>\"", ",", "\"\<Paste\>\"", ",", 
                    "\"\<Select Shape\>\"", ",", "\"\<Dimension\>\"", ",", 
                    "\"\<\>\"", ",", "\"\<Appearance\>\""}], "}"}]}], 
                  "}"}]}]}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"--", 
                RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
              RowBox[{"Button", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"DialogReturn", "[", 
                  RowBox[{
                   RowBox[{"save$shape", "=", "temp$shape"}], ";", 
                   RowBox[{
                   "save$shape$comments", "=", "temp$shape$comments"}]}], 
                  "]"}]}], "]"}], ",", 
               RowBox[{"(*", 
                RowBox[{"Save", " ", "Button"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{"\"\<Cancel\>\"", ",", 
                 RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
            "]"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
            RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"WindowElements", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
            ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WindowSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"700", ",", "500"}], "}"}]}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<1-3 Set Body Shapes\>\""}]}], 
        "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567055520333172*^9, 3.5670555248434296`*^9}, {
   3.5670558779396257`*^9, 3.567055932130725*^9}, {3.567056182813063*^9, 
   3.567056187139311*^9}, 3.5670566443634624`*^9, {3.5670581487965107`*^9, 
   3.5670587302207665`*^9}, {3.567058803921982*^9, 3.5670588119104385`*^9}, {
   3.5670588537588325`*^9, 3.5670589617560096`*^9}, {3.567059001927307*^9, 
   3.567059019322302*^9}, {3.5670590584755416`*^9, 3.567059058761558*^9}, {
   3.5670593830151043`*^9, 3.567059434116027*^9}, {3.5670595428712473`*^9, 
   3.567059603217699*^9}, {3.567059707460662*^9, 3.5670597122009325`*^9}, {
   3.567060226661358*^9, 3.567060227207389*^9}, {3.5670606357247553`*^9, 
   3.5670606437432137`*^9}, 3.5670609417812605`*^9, 3.567061001332667*^9, {
   3.567061150497198*^9, 3.567061150770214*^9}, {3.5670613553849173`*^9, 
   3.567061355524925*^9}, {3.567061387575759*^9, 3.567061424517872*^9}, {
   3.5670633500420055`*^9, 3.5670633775415783`*^9}, 3.5670636045785637`*^9, {
   3.5670636804029007`*^9, 3.5670638187628145`*^9}, {3.5670638497815886`*^9, 
   3.567063928781107*^9}, 3.56706395907484*^9, {3.567063999954178*^9, 
   3.5670640061345315`*^9}, {3.5670640580745025`*^9, 3.5670641192009983`*^9}, 
   3.5670641706839433`*^9, {3.5670642353536425`*^9, 3.56706423967789*^9}, {
   3.567064314740183*^9, 3.56706433112612*^9}, {3.567064548991581*^9, 
   3.567064565017498*^9}, {3.567064611320146*^9, 3.567064612807231*^9}, {
   3.567064902398795*^9, 3.567065019369485*^9}, {3.567065596597501*^9, 
   3.5670656689066367`*^9}, {3.567065711905096*^9, 3.5670657416497974`*^9}, {
   3.5670657824121284`*^9, 3.5670658866440907`*^9}, {3.567065916858819*^9, 
   3.5670659470505457`*^9}, {3.5670659975034313`*^9, 3.567066003233759*^9}, {
   3.5670661904354663`*^9, 3.5670661955657597`*^9}, {3.5670663202768927`*^9, 
   3.567066324293123*^9}, {3.5670675069927692`*^9, 3.567067598707015*^9}, {
   3.5670676669759197`*^9, 3.56706801769998*^9}, {3.567068108545176*^9, 
   3.567068111212329*^9}, {3.5670682431428747`*^9, 3.5670683206973104`*^9}, {
   3.567068414414671*^9, 3.56706847541916*^9}, 3.5670686101768675`*^9, {
   3.5670686645959806`*^9, 3.567068669089237*^9}, {3.5670688623632917`*^9, 
   3.567068895080163*^9}, {3.5670689271639986`*^9, 3.5670691770242896`*^9}, {
   3.5670692500364656`*^9, 3.567069271147673*^9}, {3.5670693073207417`*^9, 
   3.567069469048992*^9}, {3.567069539006994*^9, 3.567069543327241*^9}, {
   3.567090444980079*^9, 3.5670904649422207`*^9}, {3.5670905333541336`*^9, 
   3.567090563293846*^9}, {3.5670914503725843`*^9, 3.5670914592450914`*^9}, {
   3.5670915105160246`*^9, 3.567091618231185*^9}, {3.5670917137466483`*^9, 
   3.567091789984009*^9}, {3.5670918421489925`*^9, 3.5670918458102016`*^9}, {
   3.567092176110094*^9, 3.567092186929713*^9}, {3.5670922182145023`*^9, 
   3.567092241057809*^9}, {3.567092996697029*^9, 3.567093119393047*^9}, 
   3.5670931894590545`*^9, {3.5670932797072163`*^9, 3.5670935092773466`*^9}, {
   3.567093654951679*^9, 3.567093755084406*^9}, {3.5670937974358287`*^9, 
   3.567093799099924*^9}, {3.567093950472582*^9, 3.5670939796342497`*^9}, {
   3.5670941232434635`*^9, 3.5670941821438327`*^9}, 3.5670942179358797`*^9, {
   3.5670942556630373`*^9, 3.5670942593822503`*^9}, {3.5670942899519987`*^9, 
   3.567094307139982*^9}, {3.5670944897134247`*^9, 3.567094490188452*^9}, {
   3.567094547893752*^9, 3.5670946682946386`*^9}, {3.567095293093375*^9, 
   3.5670953103213606`*^9}, {3.567095348912568*^9, 3.5670954705565257`*^9}, {
   3.5670955036294174`*^9, 3.567095656592166*^9}, {3.5670957176716595`*^9, 
   3.567095773636861*^9}, {3.567095938562294*^9, 3.567096032784683*^9}, 
   3.567096063686451*^9, {3.567096100428552*^9, 3.5670962011343126`*^9}, {
   3.567096253801325*^9, 3.567096278110715*^9}, {3.567096358340304*^9, 
   3.5670963617594995`*^9}, {3.567096410583292*^9, 3.567096444675242*^9}, {
   3.567096610764742*^9, 3.5670966134628963`*^9}, {3.5670967938452134`*^9, 
   3.567096802363701*^9}, {3.567096909543831*^9, 3.567096918315333*^9}, {
   3.5670969603037343`*^9, 3.5670969632779045`*^9}, {3.567097011998691*^9, 
   3.5670970244844055`*^9}, {3.567097072088128*^9, 3.5670970914532356`*^9}, {
   3.5670976252167654`*^9, 3.5670976353923473`*^9}, {3.567097667903207*^9, 
   3.567097698838976*^9}, {3.567097759654454*^9, 3.5670978055200777`*^9}, {
   3.5670978510326815`*^9, 3.5670978549879074`*^9}, {3.5670980200573487`*^9, 
   3.5670980317550178`*^9}, {3.5670981970864744`*^9, 3.567098278614137*^9}, {
   3.5670983616778884`*^9, 3.567098363352984*^9}, {3.5670984308388443`*^9, 
   3.567098433270983*^9}, {3.5670985192048984`*^9, 3.5670985229391117`*^9}, 
   3.5670987370393577`*^9, {3.5670987972067995`*^9, 3.5670988009340124`*^9}, {
   3.5671003597491713`*^9, 3.567100380722371*^9}, {3.5671004184245276`*^9, 
   3.567100615730813*^9}, 3.567100651384852*^9, {3.567100687743932*^9, 
   3.567100745723248*^9}, {3.567101093120118*^9, 3.5671011546336365`*^9}, 
   3.5671011984991455`*^9, {3.5671012407245607`*^9, 3.5671012607477055`*^9}, {
   3.567101315767853*^9, 3.567101321784197*^9}, {3.567101520685573*^9, 
   3.5671015418017807`*^9}, {3.5671017771772437`*^9, 3.567101865103273*^9}, {
   3.567102415409748*^9, 3.5671024156377616`*^9}, {3.5671025468692675`*^9, 
   3.5671025910957975`*^9}, {3.567102639850586*^9, 3.5671026434807935`*^9}, {
   3.5671555645104213`*^9, 3.567155577049138*^9}, {3.567231564016051*^9, 
   3.5672316306178603`*^9}, {3.5672317404441423`*^9, 
   3.5672317876028395`*^9}, {3.567268316896781*^9, 3.567268327166368*^9}, {
   3.5699566628167586`*^9, 3.569956663219782*^9}, {3.570120195685219*^9, 
   3.5701207812767124`*^9}, {3.5701208136185627`*^9, 
   3.5701209070399055`*^9}, {3.570120967830383*^9, 3.5701210718123302`*^9}, {
   3.5701211230252595`*^9, 3.570121286418605*^9}, {3.570121451235032*^9, 
   3.5701214534801607`*^9}, {3.570121492571396*^9, 3.570121570347845*^9}, {
   3.570121610599147*^9, 3.570121615753442*^9}, {3.5701217066816425`*^9, 
   3.5701217151381264`*^9}, {3.5701218090534983`*^9, 
   3.5701218100085526`*^9}, {3.570122014081225*^9, 3.570122018817496*^9}, {
   3.5701220536414876`*^9, 3.570122068144317*^9}, {3.5701221195712585`*^9, 
   3.5701221461527786`*^9}, {3.570122181055775*^9, 3.5701222088593655`*^9}, {
   3.5701222496186967`*^9, 3.570122283015607*^9}, {3.570122349175391*^9, 
   3.5701223495274115`*^9}, {3.570122401672394*^9, 3.5701224179603252`*^9}, {
   3.57012247381752*^9, 3.570122500845066*^9}, {3.5701226102173223`*^9, 
   3.570122638198922*^9}, {3.5701227110780907`*^9, 3.5701227164043956`*^9}, {
   3.5701227529174843`*^9, 3.5701228089966917`*^9}, {3.570122867955064*^9, 
   3.57012286806607*^9}, {3.570122909389434*^9, 3.570122932557759*^9}, {
   3.570122969553875*^9, 3.570123010224201*^9}, {3.570123042501047*^9, 
   3.57012308380641*^9}, {3.570123188256384*^9, 3.57012354590584*^9}, {
   3.5701236827696686`*^9, 3.5701236929092484`*^9}, {3.570123780318248*^9, 
   3.570123793807019*^9}, {3.5701238574616604`*^9, 3.570123888868457*^9}, {
   3.5701239434995813`*^9, 3.5701239443786316`*^9}, {3.570123974630362*^9, 
   3.5701239880831313`*^9}, {3.570124055978015*^9, 3.5701240634244404`*^9}, {
   3.5701241075829663`*^9, 3.57012419121775*^9}, {3.570124242944709*^9, 
   3.5701242432127237`*^9}, {3.5701243902621346`*^9, 
   3.5701243903801413`*^9}, {3.570124426178189*^9, 3.570124427172246*^9}, 
   3.5701840374442415`*^9, {3.5702570709726295`*^9, 3.5702571045594883`*^9}, 
   3.570257457354108*^9, {3.570257506930995*^9, 3.5702575077733965`*^9}, 
   3.5702579193491197`*^9, 3.5702582835503592`*^9, {3.5702869473978786`*^9, 
   3.5702869745134296`*^9}, {3.57028705545706*^9, 3.5702870622254467`*^9}, {
   3.5702871481053586`*^9, 3.57028714987846*^9}, {3.5702875105590897`*^9, 
   3.570287513202241*^9}, {3.5702875878495107`*^9, 3.570287589608611*^9}, {
   3.570288479908533*^9, 3.5702884853008423`*^9}, {3.716664933377219*^9, 
   3.7166650100684853`*^9}, 3.716665066097024*^9, {3.71666512324506*^9, 
   3.716665254686805*^9}, {3.716665314097826*^9, 3.716665322515531*^9}, 
   3.716665577709282*^9, {3.716665703970995*^9, 3.716665720361401*^9}, {
   3.716665927662356*^9, 3.716665946946851*^9}, 3.716950619598897*^9},
 CellLabel->"In[38]:=",ExpressionUUID->"4b7ddd5e-d124-454b-bbbe-ce71f66da179"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1-4 Set Initial Position", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570855048759932*^9, 
  3.5708550551202955`*^9}},ExpressionUUID->"b8f79e62-f1a2-4b8a-bf67-\
b5c4dceb7e85"],

Cell[CellGroupData[{

Cell["Set Initial Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708550606736135`*^9, 3.570855062665727*^9}, {
  3.716516692612124*^9, 
  3.71651670209243*^9}},ExpressionUUID->"90c15b69-5d16-4402-832f-\
40f7b9076839"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetInitPos", ":=", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"--", 
        RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
       RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], "||", 
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been",
          " ", "set", " ", "yet"}], ",", " ", 
        RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Beep", "[", "]"}], ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Set Body Name First.\>\"", ",", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TextCell", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Set Initial Position of Rigid Bodies\>\"", ",", 
              "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
             "]"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Load"}]}], " ", 
             RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"len0", "=", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], ",", "len"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ValueQ", "[", "save$initpos", "]"}], ",", 
               RowBox[{
                RowBox[{"len", "=", 
                 RowBox[{"Length", "[", "save$initpos", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"len", "<", "len0"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$initpos", "=", 
                   RowBox[{"Join", "[", 
                    RowBox[{"save$initpos", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}], ",", 
                    RowBox[{"{", "3", "}"}]}], "]"}]}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$initpos", "=", 
                   RowBox[{"save$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
               ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"If", " ", "not"}], ",", " ", 
                 RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"temp$initpos", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"{", "len0", "}"}], ",", 
                  RowBox[{"{", "3", "}"}]}], "]"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ValueQ", "[", "save$initpos$comments", "]"}], ",", 
               RowBox[{
                RowBox[{"len", "=", 
                 RowBox[{"Length", "[", "save$initpos$comments", "]"}]}], ";",
                 "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"len", "<", "len0"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$initpos$comments", "=", 
                   RowBox[{"Join", "[", 
                    RowBox[{"save$initpos$comments", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"\"\<\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}], ",", 
                    RowBox[{"{", "3", "}"}]}], "]"}]}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$initpos$comments", "=", 
                   RowBox[{"save$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
               ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"If", " ", "not"}], ",", " ", 
                 RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"temp$initpos$comments", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"\"\<\>\"", ",", 
                  RowBox[{"{", "len0", "}"}], ",", 
                  RowBox[{"{", "3", "}"}]}], "]"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{
                RowBox[{"--", 
                 RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$initpos$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "!=", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableAlignments", "\[Rule]", "Center"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"None", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Name\>\"", ",", "\"\<x [mm]\>\"", ",", 
                    "\"\<y [mm]\>\"", ",", "\"\<z [mm]\>\""}], "}"}]}], 
                    "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"Graphics3D", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"mod$Create3DShape", "[", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$initpos", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                    RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"150", ",", "350"}], "}"}]}]}], "]"}], "]"}]}], 
                 "}"}], "}"}], "\[IndentingNewLine]", ",", 
               RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{"{", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                RowBox[{"DialogReturn", "[", 
                 RowBox[{"(*", 
                  RowBox[{"Save", " ", "Button"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$initpos", "=", "temp$initpos"}], ";", 
                  RowBox[{
                  "save$initpos$comments", "=", "temp$initpos$comments"}]}], 
                 "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{"\"\<Cancel\>\"", ",", 
                RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
           "]"}]}], "}"}], ",", 
        RowBox[{"(*", 
         RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
           RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"WindowElements", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
           ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"WindowSize", "\[Rule]", "Automatic"}], ",", 
        RowBox[{
        "WindowTitle", "\[Rule]", "\"\<1-4 Set Initial Position\>\""}]}], 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566889731755993*^9, 3.5668897823058844`*^9}, {
   3.566889828859547*^9, 3.566889886714856*^9}, {3.5668899175776215`*^9, 
   3.5668901655738063`*^9}, {3.566890196972602*^9, 3.566890199961773*^9}, {
   3.5668903236848497`*^9, 3.5668903462531404`*^9}, {3.5668904168021755`*^9, 
   3.566890551243865*^9}, {3.566890625559116*^9, 3.566890628851304*^9}, {
   3.5668906610411453`*^9, 3.5668906778621073`*^9}, {3.566890768100269*^9, 
   3.566890784114185*^9}, {3.5668908451256742`*^9, 3.5668908877861147`*^9}, 
   3.566891015361411*^9, 3.566891047194232*^9, {3.566891183957054*^9, 
   3.5668912099195395`*^9}, {3.5668912400952654`*^9, 3.566891244621524*^9}, {
   3.5668915432576056`*^9, 3.5668915449367013`*^9}, {3.566891715968484*^9, 
   3.5668918358523407`*^9}, {3.5668918709093456`*^9, 
   3.5668919456306195`*^9}, {3.5668919801025915`*^9, 
   3.5668920205259037`*^9}, {3.5668921640831146`*^9, 
   3.5668921784709373`*^9}, {3.5669005192484193`*^9, 
   3.5669005275928965`*^9}, {3.566900766911585*^9, 3.5669007676166253`*^9}, {
   3.566900884500311*^9, 3.5669008846533194`*^9}, {3.5669009277877865`*^9, 
   3.5669009420656033`*^9}, {3.566900976717585*^9, 3.566900990180355*^9}, {
   3.5669011295833282`*^9, 3.566901154485753*^9}, {3.5669013452236624`*^9, 
   3.566901441446166*^9}, {3.5669015126182365`*^9, 3.566901578348996*^9}, {
   3.56690206340174*^9, 3.5669021167747927`*^9}, {3.5670472309350452`*^9, 
   3.5670472422206907`*^9}, {3.567049068330138*^9, 3.567049128459577*^9}, {
   3.567049167883832*^9, 3.5670491697939415`*^9}, {3.567049214166479*^9, 
   3.5670492154155507`*^9}, {3.567049277939127*^9, 3.567049311335037*^9}, {
   3.5670493673282394`*^9, 3.5670494751234055`*^9}, {3.5670495188559065`*^9, 
   3.5670495276194077`*^9}, {3.5670499046279716`*^9, 
   3.5670499125794263`*^9}, {3.5670500075978613`*^9, 3.567050082795162*^9}, {
   3.567050121957402*^9, 3.567050142257563*^9}, {3.5670502103874598`*^9, 
   3.567050320436754*^9}, {3.5670503781780567`*^9, 3.5670503853374662`*^9}, 
   3.567050423894672*^9, {3.5670506654214864`*^9, 3.5670506813283963`*^9}, {
   3.56705071234017*^9, 3.5670507706615057`*^9}, {3.567050872177312*^9, 
   3.567050989024996*^9}, {3.5670512359771204`*^9, 3.567051292753368*^9}, {
   3.567051650941855*^9, 3.5670516674888015`*^9}, {3.5670524229500113`*^9, 
   3.567052430582448*^9}, {3.5670524819683867`*^9, 3.567052544048938*^9}, {
   3.5670526884181952`*^9, 3.567052698854792*^9}, {3.567052773789078*^9, 
   3.5670528319914074`*^9}, 3.567052865848344*^9, {3.567053705189351*^9, 
   3.5670537075144844`*^9}, {3.567054056444442*^9, 3.567054063632853*^9}, {
   3.5670541466215997`*^9, 3.567054200316671*^9}, {3.567054378205846*^9, 
   3.5670546294832177`*^9}, {3.567054679642087*^9, 3.567054696184033*^9}, {
   3.5670547766336346`*^9, 3.5670547894463673`*^9}, {3.5670548916962156`*^9, 
   3.5670549191477857`*^9}, {3.5670563032379513`*^9, 3.567056423484829*^9}, {
   3.5670564615200043`*^9, 3.567056466460287*^9}, {3.567056530281937*^9, 
   3.5670566018970337`*^9}, {3.5670569741953278`*^9, 
   3.5670570850906706`*^9}, {3.567059166334711*^9, 3.5670592158985453`*^9}, {
   3.5670592793491745`*^9, 3.567059317689368*^9}, {3.567063087771004*^9, 
   3.5670630892320876`*^9}, {3.5670695474044743`*^9, 
   3.5670695492815814`*^9}, {3.5670988132317157`*^9, 3.5670988150248184`*^9}, 
   3.5672318299772635`*^9, {3.5675807247684803`*^9, 3.5675807249994936`*^9}, {
   3.5675809545326223`*^9, 3.567580954762635*^9}, {3.567583195411793*^9, 
   3.567583198890992*^9}, {3.5677724913907447`*^9, 3.5677724953469715`*^9}, {
   3.5699565775988846`*^9, 3.569956584503279*^9}, {3.569956662001712*^9, 
   3.5699566621487207`*^9}, {3.5699568606800756`*^9, 3.569956868180505*^9}, {
   3.569956970692368*^9, 3.569956971515415*^9}, {3.569957391410432*^9, 
   3.5699573941355877`*^9}, {3.570108567824143*^9, 3.570108571947379*^9}, {
   3.5701086204881554`*^9, 3.5701086333298893`*^9}, {3.570108671639081*^9, 
   3.570108769759693*^9}, {3.5701088095399685`*^9, 3.570108919817276*^9}, {
   3.5701089890182343`*^9, 3.570109147034272*^9}, {3.5701092402196016`*^9, 
   3.5701096738074017`*^9}, {3.5701097936652575`*^9, 
   3.5701099566595798`*^9}, {3.570110027697643*^9, 3.570110118155817*^9}, {
   3.5701101625923586`*^9, 3.5701102234848413`*^9}, {3.5701104149297915`*^9, 
   3.5701104659137077`*^9}, {3.5701104982435565`*^9, 
   3.5701105330135455`*^9}, {3.570110563092266*^9, 3.5701105957101316`*^9}, {
   3.57011071282583*^9, 3.5701107517620573`*^9}, {3.5701107860690193`*^9, 
   3.5701107892742023`*^9}, {3.5701108256222816`*^9, 
   3.5701109027606936`*^9}, {3.5701109455571413`*^9, 3.570110986883505*^9}, {
   3.570111044172782*^9, 3.570111048875051*^9}, {3.570117373417794*^9, 
   3.5701173736888094`*^9}, 3.5702570696466265`*^9, {3.57025710547989*^9, 
   3.570257131344735*^9}, 3.5702574571669073`*^9, {3.570257683322505*^9, 
   3.5702576836657057`*^9}, {3.5702578161879377`*^9, 
   3.5702578271391573`*^9}, {3.570258174272167*^9, 3.5702581759413705`*^9}, {
   3.5708550866380987`*^9, 3.5708551138786564`*^9}, {3.570855166882688*^9, 
   3.570855499589718*^9}, {3.570855561307248*^9, 3.570855683934262*^9}, {
   3.5708557194402924`*^9, 3.5708558090084157`*^9}, {3.5708559609121037`*^9, 
   3.5708559618801594`*^9}, {3.5708560326702085`*^9, 
   3.5708560507162404`*^9}, {3.5708560929396553`*^9, 
   3.5708561001480675`*^9}, {3.5708561439325724`*^9, 
   3.5708562367258797`*^9}, {3.5708588794250336`*^9, 
   3.5708588877475095`*^9}, {3.5708590995616245`*^9, 
   3.5708591056989756`*^9}, {3.5708592453199615`*^9, 
   3.5708592707004128`*^9}, {3.5708594662465973`*^9, 
   3.5708594683887205`*^9}, {3.570859593586881*^9, 3.5708596692262077`*^9}, {
   3.570859776865364*^9, 3.570859813602465*^9}, {3.5708598579119997`*^9, 
   3.570859874768964*^9}, {3.571748437943918*^9, 3.5717485503903503`*^9}, {
   3.5856953080847445`*^9, 3.585695312837016*^9}, 3.595308748087256*^9, {
   3.716527432300497*^9, 3.716527481750806*^9}, {3.716527517931451*^9, 
   3.716527677369933*^9}, {3.716527709004735*^9, 3.716527763475952*^9}, {
   3.716527801965069*^9, 3.7165278122817783`*^9}, {3.716527871012189*^9, 
   3.716527932525202*^9}, {3.716527963555147*^9, 3.7165279737250233`*^9}, {
   3.716528019213956*^9, 3.71652804919471*^9}, {3.7165281091110153`*^9, 
   3.71652812260843*^9}, {3.716528178359338*^9, 3.716528180202545*^9}, {
   3.7165282642910757`*^9, 3.7165282712637444`*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"687ca59c-a81b-4bdd-97ec-5eb42024c07a"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1-L Show Body List", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701244725708427`*^9, 3.570124479552242*^9}, {
  3.570127979301416*^9, 
  3.57012797972544*^9}},ExpressionUUID->"de9c977e-ac99-4ba1-91ff-\
9ffb162c0640"],

Cell[CellGroupData[{

Cell["Show Body List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570124483440464*^9, 
  3.570124486847659*^9}},ExpressionUUID->"340cf913-40a3-449e-8d4d-\
0ad8f1dddc18"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ShowBodyList", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", 
    RowBox[{"Pane", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Body:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ValueQ", "[", "save$bdn", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"StringJoin", "[", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], ",", 
                    "\"\<O\>\"", ",", "\"\<X\>\""}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                    ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                    ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                    ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$shape", "]"}], ",", 
                   RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"save$shape", ";", "\"\<\>\""}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Min", "[", 
                  RowBox[{
                   RowBox[{"Length", "[", "save$bdn", "]"}], ",", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                    RowBox[{"Length", "[", "save$mass", "]"}], ",", "30"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$shape", "]"}], ",", 
                    RowBox[{"Length", "[", "save$shape", "]"}], ",", "30"}], 
                    "]"}]}], "]"}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<GND\>\"", ",", "\"\<Name\>\"", ",", "\"\<M [kg]\>\"", 
                    ",", "\"\<Ixx [kgm2]\>\"", ",", "\"\<Iyy [kgm2]\>\"", 
                    ",", "\"\<Izz [kgm2]\>\"", ",", "\"\<Shape\>\""}], 
                   "}"}]}], "]"}]}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$bdn", ";", "\"\<No Data\>\""}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"640", ",", "200"}], "}"}]}], ",", 
      RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwdxV1IEwEAB/Chw2wixoQYTYVBujHFLUd+IdPLYDYPC43WrGUut1CGbjHK
00HDYehD2VJQr4gkyDZzyCLc6GGD6iGlkLW1R8Wv9DTUaWYjmPffw4+fSN/V
aEjhcDj5LJwZ2/jVPc4QND2VRrEbb4ycwjlZE3w8JswX4HSNJHnJ7oAMb91+
knzpguI8fiWZJzHXMa/Bdby3rXhx7agdXzNpzPifxdGPv0dfD+BHTv1jTMYn
h/BPSj2Ba+5v+XCDJ7yKzTbVOj4IVTG4Ym17Gwc7Mvaxupv7B3ckBs/2sMvF
djH+ka1Q4rhguBqTsbAKv+tVkrhGy1zHdy/qtDii/zqF+aRgBt/zbr7HViUv
gP0FFreNffly5TQmPjV58U3PFx+mi8fmcCyv/xtO+9zpGqUZolEUdmPTkM7A
e8EQQv8ZI64WjZjwYe+OFT89sUfh5z5ZDzbXl/XhcieRPHguIs2cZQi3qqwQ
rzgpSSE7t1UuxTbHg2K88yEhx+oFey2uvOpqwMHAFS1+1r7ZjOc+LtzC8dNv
WvBL5UwXXqWiFmw/Sv07XfSbaCv1/Md3Lnm5HvYQWXUSJ4QPc3FB2JWHjwGs
ujBg
  "],
 CellLabel->"In[40]:=",ExpressionUUID->"9c0c258b-2cbf-4dde-9cfe-5d7679996d48"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2. Set Connections", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571490330353987*^9, 3.571490337102373*^9}, 
   3.716517017426588*^9},ExpressionUUID->"31572cfd-9fc3-4af3-b8c0-\
0d1384782b0a"],

Cell[CellGroupData[{

Cell["2-0 Set Material", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570170752819404*^9, 
  3.5701707579336967`*^9}},ExpressionUUID->"bc30de0f-ba08-40cd-a8bb-\
eb2c20965266"],

Cell[CellGroupData[{

Cell["Material List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567573964046789*^9, 
  3.5675739700521326`*^9}},ExpressionUUID->"b580b1ff-dc6e-4fa9-afcb-\
d187ef509033"],

Cell[BoxData[
 RowBox[{
  RowBox[{"list$Material", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Maraging Steel\>\"", ",", "8.0", ",", "195", ",", "0.3", ",", "1.",
        ",", 
       RowBox[{"-", "3"}], ",", "\"\<Virgo Data\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<C-70 Steel\>\"", ",", "7.8", ",", "200", ",", "0.3", ",", "3.", 
       ",", 
       RowBox[{"-", "4"}], ",", "\"\<LIGO-G050087-00\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Tungsten\>\"", ",", "19.3", ",", "411", ",", "0.28", ",", "1.", 
       ",", 
       RowBox[{"-", "4"}], ",", "\"\<Wikipedia\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Copper Beryllium\>\"", ",", "8.4", ",", "134", ",", "0.3", ",", 
       "5.", ",", 
       RowBox[{"-", "6"}], ",", "\"\<www.alb-copperalloys.com\>\""}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Sapphire\>\"", ",", "3.98", ",", "345", ",", "0.3", ",", "2.", ",", 
       RowBox[{"-", "7"}], ",", "\"\<www.crystalsystems.com\>\""}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Bolfur\>\"", ",", "7.6", ",", "157", ",", "0.3", ",", "1.", ",", 
       RowBox[{"-", "3"}], ",", "\"\<www.alb-copperalloys.com\>\""}], "}"}]}],
     "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5675739843249493`*^9, 3.5675740997565517`*^9}, {
   3.5675747052121816`*^9, 3.5675747080793457`*^9}, 3.567575071324122*^9, {
   3.5675777611419706`*^9, 3.5675778356582327`*^9}, {3.567577886800158*^9, 
   3.567577947608636*^9}, {3.5675786941133337`*^9, 3.5675787759100122`*^9}, {
   3.5675788174383874`*^9, 3.5675788491312003`*^9}, {3.5675788882594385`*^9, 
   3.5675790742260747`*^9}, {3.567616802799167*^9, 3.5676168088525133`*^9}, {
   3.5702873722531796`*^9, 3.5702873906102295`*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"515c91a6-57a1-4a25-a637-d0c0afee3ed5"],

Cell["\<\
** Poisson Ratio of the Maraging Steel Wire **
I adopt an abnormal PoissonR = 0.9 because it fits Virgo' s cables \
(assembled). The value is abnormal, maybe it 
depend on electrical cabling, but it fits the measurements and the lowest \
freq change is relevant for yaw.
We can decide to adopt standard 0.3 but expecting such a change once \
assembled.                    by E. Majorana\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.567574838073781*^9, 
  3.5675748721867323`*^9}},ExpressionUUID->"2db7c11b-36f3-4490-bb03-\
3d88593e4735"]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Material Parameters", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.5675792567965174`*^9, 
  3.567579291544505*^9}},ExpressionUUID->"15f05588-adf9-4abd-a5e3-\
f8510e09b17f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetMaterial", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Set Material Properties\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "Material", " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Button", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<Define New Material\>\"", ",", "White", ",", "Bold"}],
            "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"temp$mat", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\>\"", ",", "1.", ",", "100", ",", "0.3", ",", "1", ",", 
              RowBox[{"-", "3"}], ",", "\"\<\>\""}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Import"}]}], " ", 
           RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ValueQ", "[", "save$mat", "]"}], ",", 
           RowBox[{"temp$mat", "=", "save$mat"}], ",", 
           RowBox[{"temp$mat", "=", "list$Material"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Main"}]}], " ", "Input", " ", 
            RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$mat", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$mat", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$mat", ",", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"15.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"2.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<E\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"2.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
                  "}"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"30.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "temp$mat", "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"TableHeadings", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"None", ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", 
                 "\"\<Name\>\"", ",", "\"\<Dens[g/cm3]\>\"", ",", 
                 "\"\<E [GPa]\>\"", ",", "\"\<Poisson\>\"", ",", 
                 "\"\<Loss\>\"", ",", "\"\<MEMO\>\""}], "}"}]}], "}"}]}]}], 
           "]"}], "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"save$mat", "=", "temp$mat"}], "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", 
      RowBox[{"(*", 
       RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Set Material\>\""}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.5675792721453953`*^9, 3.5675794350997157`*^9}, 
   3.5675794753400173`*^9, {3.5675795142242413`*^9, 3.5675796910273542`*^9}, {
   3.5675797717049685`*^9, 3.567579856487818*^9}, {3.56758002367538*^9, 
   3.567580026804559*^9}, {3.567580104688014*^9, 3.567580112764476*^9}, {
   3.5675801536498146`*^9, 3.56758017332294*^9}, {3.5675802519094343`*^9, 
   3.567580256169678*^9}, {3.5675803848410378`*^9, 3.567580388537249*^9}, {
   3.567580462695491*^9, 3.5675804642105775`*^9}, {3.567580633812278*^9, 
   3.5675806558315372`*^9}, {3.567580993376844*^9, 3.5675811181659813`*^9}, {
   3.5675811663287363`*^9, 3.5675811984375725`*^9}, {3.5675812373267975`*^9, 
   3.567581244840227*^9}, {3.567581335587417*^9, 3.567581341198738*^9}, {
   3.567581394187769*^9, 3.567581437810264*^9}, {3.56758176153078*^9, 
   3.5675817626978464`*^9}, {3.5675817992679386`*^9, 3.567581819547098*^9}, {
   3.567582484090108*^9, 3.5675825735412245`*^9}, {3.5675826180937724`*^9, 
   3.5675826200208826`*^9}, {3.567583092284895*^9, 3.567583096783152*^9}, {
   3.567583213499828*^9, 3.5675832931993866`*^9}, {3.5675833260542655`*^9, 
   3.567583364409459*^9}, {3.567583426525012*^9, 3.5675834639271517`*^9}, {
   3.5675835994159007`*^9, 3.5675835995829105`*^9}, 3.5675836382421217`*^9, {
   3.5699566632557836`*^9, 3.5699566634797964`*^9}, {3.5701327414847975`*^9, 
   3.570132746904107*^9}, {3.5701328218923965`*^9, 3.570132825665612*^9}, {
   3.5701712102365665`*^9, 3.570171251187909*^9}, {3.5701713221899705`*^9, 
   3.5701713935300508`*^9}, {3.5701714284570484`*^9, 
   3.5701715055774593`*^9}, {3.5701715377903023`*^9, 
   3.5701715763345065`*^9}, {3.5701717276001587`*^9, 
   3.5701719152758927`*^9}, {3.5701719925633135`*^9, 
   3.5701719948924465`*^9}, {3.570172098504373*^9, 3.5701721000264597`*^9}, {
   3.570172133854395*^9, 3.570172173845682*^9}, {3.570172222452462*^9, 
   3.570172227882773*^9}, {3.5701722675450416`*^9, 3.5701723822065997`*^9}, {
   3.5701724458952427`*^9, 3.5701724698236113`*^9}, {3.570172566338132*^9, 
   3.5701725975879188`*^9}, {3.570172633431969*^9, 3.5701726363571367`*^9}, {
   3.57017272785737*^9, 3.5701727320406094`*^9}, {3.5701729609917045`*^9, 
   3.570172986997192*^9}, {3.5701730251143723`*^9, 3.5701730519509068`*^9}, {
   3.5702570625486145`*^9, 3.5702570638746166`*^9}, {3.570257104606288*^9, 
   3.5702571047154884`*^9}, {3.570257187411234*^9, 3.5702572188452888`*^9}, {
   3.570257457369708*^9, 3.5702574574165077`*^9}, {3.5702579329055433`*^9, 
   3.570257950221574*^9}, {3.5702582112286325`*^9, 3.5702582234278536`*^9}, {
   3.5702583286500387`*^9, 3.570258336356452*^9}, {3.5702872099448957`*^9, 
   3.5702872270088716`*^9}, {3.5702872696663113`*^9, 
   3.5702873403273535`*^9}, {3.5702875968200235`*^9, 
   3.5702875983371105`*^9}, {3.716529974356192*^9, 3.716530116631537*^9}, {
   3.716530205052101*^9, 3.716530248214477*^9}, {3.716530287902678*^9, 
   3.716530297948145*^9}, {3.716530354418939*^9, 3.716530355674233*^9}, {
   3.71653043529074*^9, 3.7165304428867207`*^9}, 3.716530514810894*^9, {
   3.716950674019495*^9, 3.716950703488172*^9}, 3.718414559783855*^9},
 CellLabel->"In[42]:=",ExpressionUUID->"db5a891d-31f0-4a13-8966-535086849e00"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2-1 Define Wires", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701197337367964`*^9, 3.570119744717425*^9}, 
   3.718415054990674*^9},ExpressionUUID->"4c0ab940-b2b2-4c24-91e2-\
46f38e9cbd17"],

Cell[CellGroupData[{

Cell["Define Wires", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, 
   3.718415055757513*^9},ExpressionUUID->"bcd64e29-898c-47f0-b108-\
514a121f3008"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DefineWires", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "&&", 
       RowBox[{"ValueQ", "[", "save$shape", "]"}]}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been", 
        " ", "set", " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Define Bodies First.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
       "*", "Version", " ", 
       RowBox[{
       "1.2", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "Wire", " ", "Version", " ", "1.2", " ", "Compliance", " ", "Check"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"save$wire2", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "5"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"save$wire2", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "0."}], "]"}]}], 
          "]"}], ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$wire2", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
        "*", "Version", " ", 
        RowBox[{
        "1.2", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
          "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tabviewwire", "=", "1"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", 
               RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TextCell", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Define Wires\>\"", ",", "\[IndentingNewLine]", "Bold", ",",
                "Italic", ",", "Black"}], "]"}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.6", ",", "1.0", ",", "0.6"}], "]"}]}]}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "New"}]}], " ", "Wire", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Create New Wire Group\>\"", ",", "Bold", ",", "White"}],
                  "]"}], ",", "mod$NewWires", ",", "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Set Material Properties\>\"", ",", "Bold", ",", "Black",
                   ",", "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"TabView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Edit\\nEach\\nWire\>\"", ",", "Bold"}], "]"}], 
               "\[Rule]", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Load"}]}], " ", 
                    RowBox[{"Lists", "--"}]}], "-"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
                    RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$wire", "]"}], ",", 
                    RowBox[{"temp$wire", "=", "save$wire"}], ",", 
                    RowBox[{"temp$wire", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$wire$comments", "]"}], ",", 
                    RowBox[{"temp$wire$comments", "=", "save$wire$comments"}],
                     ",", 
                    RowBox[{"temp$wire$comments", "=", 
                    RowBox[{
                    RowBox[{"temp$wire", "/.", 
                    RowBox[{
                    RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
                    "\"\<\>\""}]}], "/.", 
                    RowBox[{
                    RowBox[{"x_", "?", "StringQ"}], "\[Rule]", 
                    "\"\<\>\""}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                    RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Delete", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$wire", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$wire", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                    RowBox[{"temp$wire$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$wire$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$wire", ",", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$wire$comments", ",", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Name", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "\[NotEqual]", 
                    "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "SP"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "SP"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Material", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "4"}], "]"}], 
                    "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    "\"\<E\>\"", ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
                    "]"}], "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Length", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Diameter", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Neck", " ", "L"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Neck", " ", "D"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Tension", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "Clamp", " ", "Vector"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "11", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "11", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "11", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "Clamp", " ", "Vector"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "12", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "12", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "12", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Longitudinal", " ", "Stiffness"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "14"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "14"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "14"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Torsional", " ", "Stiffness"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "15"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "15"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "15"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$wire", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"None", ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", 
                    "\"\<Name\>\"", ",", "\"\<U Body\>\"", ",", 
                    "\"\<U Clamp Pos [mm]\>\"", ",", "\"\<L Body\>\"", ",", 
                    "\"\<L Clamp Pos [mm]\>\"", ",", "\"\<Mat\>\"", ",", 
                    "\[IndentingNewLine]", "\"\<E [GPa]\>\"", ",", 
                    "\"\<Poission R\>\"", ",", "\"\<Loss [rad]\>\"", ",", 
                    "\"\<L [m]\>\"", ",", "\"\<D [mm]\>\"", ",", 
                    "\"\<NL [mm]\>\"", ",", "\"\<ND [mm]\>\"", ",", 
                    "\"\<T [N]\>\"", ",", "\[IndentingNewLine]", 
                    "\"\<Upper Clamp Direction\>\"", ",", 
                    "\"\<Lower Clamp Direction\>\"", ",", "\"\<ks [N/m]\>\"", 
                    ",", "\"\<kt [Nm/rad]\>\""}], "}"}]}], "}"}]}]}], "]"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
                    RowBox[{"Button", "--"}]}], "-"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"TableForm", "[", 
                   RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"save$wire", "=", "temp$wire"}], ";", 
                    RowBox[{"save$wire$comments", "=", "temp$wire$comments"}],
                     ";", 
                    RowBox[{"save$wire2", "=", "temp$wire2"}], ";", 
                    RowBox[{
                    "save$wire2$comments", "=", "temp$wire2$comments"}], 
                    ";"}], ")"}], "]"}]}], "]"}], ",", 
                    RowBox[{"(*", 
                    RowBox[{"Save", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", 
                    RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], 
                    "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
              ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"WIRE", " ", "LIST", " ", "2"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Create\\nWire\\nGroups\>\"", ",", "Bold"}], 
                "]"}], "\[Rule]", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Load"}]}], " ", 
                    RowBox[{"Lists", "--"}]}], "-"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$wire2", "]"}], ",", 
                    RowBox[{"temp$wire2", "=", "save$wire2"}], ",", 
                    RowBox[{"temp$wire2", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$wire2$comments", "]"}], ",", 
                    RowBox[{
                    "temp$wire2$comments", "=", "save$wire2$comments"}], ",", 
                    RowBox[{
                    RowBox[{"temp$wire2$comments", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire2", "/.", 
                    RowBox[{
                    RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
                    "\"\<\>\""}]}], "/.", 
                    RowBox[{"False", "\[Rule]", "\"\<\>\""}]}], "/.", 
                    RowBox[{"True", "\[Rule]", "\"\<\>\""}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$wire2$comments2", " ", "=", " ", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\"\<\>\"", "}"}], ",", 
                    RowBox[{"Length", "[", "temp$wire2$comments", "]"}]}], 
                    "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Delete", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$wire2", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$wire2", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                    RowBox[{"temp$wire2$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$wire2$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$wire2", ",", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$wire2$comments", ",", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditWires", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Wire", " ", "Number"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", "Comment", " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Suspension", " ", "Point", " ", "Parameters"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}]}]}], ")"}], "&"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "6"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Material", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Length", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Diameter", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "2"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Tension", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$wire2", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"None", ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Del\>\"", ",", "\"\<Duplicate\>\"", ",", 
                    "\"\<Edit\>\"", ",", "\"\<Num\>\"", ",", "\"\<U Body\>\"",
                     ",", "\"\<L Body\>\"", ",", "\"\<Comment\>\"", ",", 
                    "\"\<Clamp Position Parameters [mm]\>\"", ",", 
                    "\"\<Material\>\"", ",", "\[IndentingNewLine]", 
                    "\"\<L [m]\>\"", ",", "\"\<D [mm]\>\"", ",", 
                    "\"\<T [N]\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}], 
                  ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"TableForm", "[", 
                   RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Reflect Changes to Wire List\>\"", ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"(", 
                    RowBox[{"mod$ReflectWires", ";", 
                    RowBox[{"tabviewwire", "=", "1"}], ";"}], ")"}]}], "]"}], 
                    "}"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "}"}], "]"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{"Dynamic", "[", "tabviewwire", "]"}], ",", 
            RowBox[{"ControlPlacement", "\[Rule]", "Left"}]}], "]"}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
           RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"WindowElements", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
           ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
        RowBox[{"WindowSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"800", ",", "500"}], "}"}]}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<2-1 Define Wires\>\""}], ",", 
        " ", 
        RowBox[{"WindowFrameElements", "\[Rule]", 
         RowBox[{"{", "\"\<ZoomBox\>\"", "}"}]}]}], "]"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701955273954287`*^9, 
   3.5701955277364483`*^9}, {3.570216424314905*^9, 3.570216442094922*^9}, {
   3.5702566636907125`*^9, 3.570256665968316*^9}, {3.5702570641086173`*^9, 
   3.57025706566862*^9}, {3.5702571047466884`*^9, 3.5702571049494886`*^9}, {
   3.5702572278309045`*^9, 3.570257263773368*^9}, {3.5702574574633083`*^9, 
   3.5702574577129087`*^9}, {3.5702579587703886`*^9, 3.570257998924859*^9}, {
   3.5702582260174584`*^9, 3.570258233255871*^9}, {3.5702583058115983`*^9, 
   3.570258307948802*^9}, 3.570258349242075*^9, {3.5702875373536224`*^9, 
   3.5702875654512296`*^9}, {3.5702876290248656`*^9, 3.570287645410803*^9}, {
   3.5702879106109715`*^9, 3.570287971276441*^9}, {3.5702880162440133`*^9, 
   3.5702880371722107`*^9}, {3.570302318259042*^9, 3.570302383474772*^9}, {
   3.570302423439058*^9, 3.570302543292913*^9}, {3.5703037621316266`*^9, 
   3.5703037641937447`*^9}, {3.5709809514120283`*^9, 
   3.5709810215690413`*^9}, {3.571491709991898*^9, 3.5714917125750456`*^9}, {
   3.585713407444968*^9, 3.5857139025842886`*^9}, {3.585713991655383*^9, 
   3.5857141381857643`*^9}, {3.585714200102306*^9, 3.585714246440956*^9}, {
   3.5857142942306895`*^9, 3.585714340970363*^9}, {3.5857143984616513`*^9, 
   3.585714471482828*^9}, {3.5857145056757836`*^9, 3.585714558619812*^9}, {
   3.585714699360862*^9, 3.5857147096874523`*^9}, {3.585714903828557*^9, 
   3.585714910281926*^9}, {3.5857149624689107`*^9, 3.585714976281701*^9}, {
   3.5857150109826856`*^9, 3.5857150882961073`*^9}, {3.5857157845339303`*^9, 
   3.5857157919533544`*^9}, {3.5857158434823017`*^9, 3.585715889940959*^9}, 
   3.5857160224865403`*^9, {3.5857161840357804`*^9, 3.5857161928262835`*^9}, {
   3.585716318953497*^9, 3.5857163270899625`*^9}, {3.585887815347185*^9, 
   3.585887826895846*^9}, {3.585887861317815*^9, 3.585887865136033*^9}, {
   3.5878137175816503`*^9, 3.5878137249660726`*^9}, 3.5878160707982464`*^9, 
   3.5894240365879784`*^9, {3.5907767113102818`*^9, 3.5907767372627664`*^9}, {
   3.590776772709794*^9, 3.5907767872526255`*^9}, {3.5907768389905853`*^9, 
   3.590776870939412*^9}, {3.5907770667226105`*^9, 3.590777079637349*^9}, {
   3.590777790893031*^9, 3.5907777926771326`*^9}, {3.6723746675543623`*^9, 
   3.672374702547364*^9}, {3.672374855349104*^9, 3.6723748594883404`*^9}, 
   3.7165169901142683`*^9, {3.716532920251121*^9, 3.716532921392849*^9}, {
   3.716583707057884*^9, 3.716583712739278*^9}, {3.716583747982366*^9, 
   3.7165837582338037`*^9}, {3.716583791128182*^9, 3.716583811371942*^9}, {
   3.716583866973469*^9, 3.7165838969760523`*^9}, {3.7165839419690733`*^9, 
   3.716583972753151*^9}, {3.716589106718216*^9, 3.716589107078236*^9}, {
   3.716589233769396*^9, 3.716589260545013*^9}, {3.716589735485771*^9, 
   3.716589755993451*^9}, {3.7165902174745817`*^9, 3.716590227587831*^9}, {
   3.716590259267469*^9, 3.716590260119238*^9}, {3.716591145601266*^9, 
   3.716591204697071*^9}, {3.716591296633951*^9, 3.716591370281238*^9}, {
   3.71659141145862*^9, 3.716591443072958*^9}, {3.716591482735271*^9, 
   3.716591493097571*^9}, {3.716591531149291*^9, 3.7165917027775097`*^9}, {
   3.716591735215453*^9, 3.716591848497529*^9}, {3.7165919140754957`*^9, 
   3.7165921509795027`*^9}, {3.71659231240021*^9, 3.71659235955586*^9}, {
   3.716593188160688*^9, 3.7165932203358927`*^9}, {3.716593271263853*^9, 
   3.716593478481036*^9}, 3.716596231500204*^9, {3.716597027581381*^9, 
   3.716597029538652*^9}, 3.71659736913418*^9, {3.716597675502318*^9, 
   3.716598007119104*^9}, {3.716605848868375*^9, 3.716605981032703*^9}, {
   3.716606272397957*^9, 3.716606299263229*^9}, {3.716607066027207*^9, 
   3.716607081933305*^9}, {3.716607728597088*^9, 3.716607770282022*^9}, {
   3.716669517623982*^9, 3.71666952291778*^9}, {3.716677502700941*^9, 
   3.716677539572691*^9}, {3.716677593243455*^9, 3.716677603099334*^9}, 
   3.716887880024929*^9, {3.716887918108203*^9, 3.716887927031147*^9}, {
   3.7168879665375566`*^9, 3.716887981636633*^9}, {3.716933725054949*^9, 
   3.7169337256370296`*^9}, {3.71693376450114*^9, 3.7169337879951973`*^9}, {
   3.716933843787895*^9, 3.716933856844187*^9}, {3.716950746120627*^9, 
   3.716950760476802*^9}, {3.718305173441148*^9, 3.718305239332821*^9}, {
   3.71830527735077*^9, 3.718305333740095*^9}, {3.718306300864633*^9, 
   3.718306324649104*^9}, 3.7183064385193443`*^9, {3.718306708960911*^9, 
   3.718306719333309*^9}, 3.718306758561573*^9, {3.718306820436172*^9, 
   3.718307089727098*^9}, 3.7183071397446632`*^9, {3.718414404310964*^9, 
   3.718414406137311*^9}, 3.71841456337506*^9, {3.718415056885784*^9, 
   3.718415075951947*^9}, {3.916788851664853*^9, 3.9167888675774508`*^9}, {
   3.916789008167426*^9, 3.9167890111434155`*^9}, 3.916789104320201*^9, {
   3.916789185605873*^9, 3.9167891932806683`*^9}, {3.9167893971457224`*^9, 
   3.916789434745866*^9}},ExpressionUUID->"4ce7f721-03f0-4ad9-88a8-\
cb726c190668"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Edit Wire", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
   3.585715102063895*^9, 3.5857151025759244`*^9}, 
   3.9167885242802024`*^9},ExpressionUUID->"33b9d309-61af-4510-a4d3-\
4cbd01849526"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditWires", "[", "nw_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Define New Wire Groups\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Import"}]}], " ", "Material", " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
          RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "wire", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"temp$newwire", "=", 
         RowBox[{"temp$wire2", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newwire$comment", "=", 
         RowBox[{"temp$wire2$comments", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Number"}]}], " ", "of", " ", 
           RowBox[{"Wires", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<How many wires for suspension?\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Attached"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set attaching bodies\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Upper body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Lower body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Clamp"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set clamp position\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "1", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"Version", " ", "1.2"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TableForm", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ")"}], "&"}]}], 
                    "]"}]}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Enabled", "\[Rule]", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}], 
                    "]"}], "]"}]}], "]"}]}]}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"3", "D", " ", "Graphics"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
               "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "Infinity", ",", "0"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Select"}]}], " ", 
          RowBox[{"Material", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Select Material\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set Material Properties\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"PopupMenu", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"n", "\[Rule]", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
              "]"}], ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "4"}], "]"}], "]"}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "5"}], "]"}], "]"}], 
                  "]"}], ",", "\"\<E\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "6"}], "]"}], "]"}], 
                  "]"}]}], "}"}], "}"}], "]"}]}], "}"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Material\>\"", ",", "\"\<Young [GPa]\>\"", ",", 
               "\"\<Poisson\>\"", ",", "\"\<Loss [rad]\>\""}], "}"}]}], 
            "}"}]}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Dimension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Wire Dimension\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Variable Thickness\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "6"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Wire Length with Tension\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", "meter"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "meter"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], ",", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Length [m]\>\"", ",", "\"\<Diam [mm]\>\"", ",", 
              "\"\<Neck L[mm]\>\"", ",", "\"\<Neck D[mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Stiffness", "--"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Wire Dimension\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireStiff", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "\"\<Longitudinal Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Torsional Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Nm/rad\>\""}], "\[IndentingNewLine]", "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Tension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Tension on Each Wire\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate From Suspended Mass\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireTension", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<N\>\"", 
           ",", "\[IndentingNewLine]", "\"\<(\>\"", ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "7", "]"}], "]"}], "/", "g"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "g"}]}], ")"}], "&"}]}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kgw)\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Wire", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Finish\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$wire2", "[", 
                RowBox[{"[", "nw", "]"}], "]"}], "=", "temp$newwire"}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"800", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Wire Registration\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.57019536883836*^9, 
   3.5701953742146673`*^9}, {3.5701954808607674`*^9, 
   3.5701954946425557`*^9}, {3.5702570659338207`*^9, 
   3.5702570660898204`*^9}, {3.570257104996289*^9, 3.570257105136689*^9}, {
   3.5702572681569757`*^9, 3.5702572939282207`*^9}, {3.5702574577909083`*^9, 
   3.5702574579313087`*^9}, {3.57025800494647*^9, 3.5702580258193064`*^9}, {
   3.57025823832588*^9, 3.5702582468278947`*^9}, 3.5702583104604063`*^9, {
   3.5702877658946943`*^9, 3.570287780072505*^9}, {3.570287843959159*^9, 
   3.5702878457942643`*^9}, {3.5702884671558037`*^9, 
   3.5702884672758107`*^9}, {3.5703042639543295`*^9, 3.570304319841526*^9}, {
   3.5709795615205307`*^9, 3.5709797878724775`*^9}, {3.5709798430276327`*^9, 
   3.570979885228046*^9}, {3.5709804815281525`*^9, 3.570980483118243*^9}, {
   3.5857151050440655`*^9, 3.585715189546899*^9}, {3.5907769788735857`*^9, 
   3.5907769917693233`*^9}, {3.5907771163234477`*^9, 
   3.5907771215517464`*^9}, {3.716961157275049*^9, 3.716961171722761*^9}, {
   3.716961249541197*^9, 3.716961255269796*^9}, 3.718414565511396*^9},
 CellLabel->"In[44]:=",ExpressionUUID->"783aa336-3919-4928-9852-bab4f8c7d6cb"]
}, Closed]],

Cell[CellGroupData[{

Cell["New wire", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 
  3.5676241367076426`*^9}},ExpressionUUID->"c5f82d4f-032d-4d76-a924-\
9323e8238e5c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewWires", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Create New Wire Group\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Import"}]}], " ", "Material", " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
          RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "wire", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"temp$newwire", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "2", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "5."}], "mm"}], ",", 
             RowBox[{"5.", "mm"}], ",", 
             RowBox[{"200.", "mm"}], ",", 
             RowBox[{"50.", "mm"}], ",", "0.", ",", 
             RowBox[{"0.", "mm"}]}], "}"}], ",", "1", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1.", "meter"}], ",", 
             RowBox[{"1.", "mm"}], ",", 
             RowBox[{"20.", "mm"}], ",", 
             RowBox[{"1.", "mm"}], ",", "False", ",", "True"}], "}"}], ",", 
           "0.", ",", 
           RowBox[{"{", 
            RowBox[{"0.", ",", "0."}], "}"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"temp$newwire$comments", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "temp$newwire", "]"}]}], "}"}]}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Number"}]}], " ", "of", " ", 
           RowBox[{"Wires", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<How many wires for suspension?\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Attached"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set attaching bodies\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Upper body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Lower body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Clamp"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set clamp position\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "1", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"Version", " ", "1.2"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TableForm", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ")"}], "&"}]}], 
                    "]"}]}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Enabled", "\[Rule]", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}], 
                    "]"}], "]"}]}], "]"}]}]}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"3", "D", " ", "Graphics"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
               "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "Infinity", ",", "0"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Select"}]}], " ", 
          RowBox[{"Material", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Select Material\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set Material Properties\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"PopupMenu", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"n", "\[Rule]", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
              "]"}], ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "4"}], "]"}], "]"}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "5"}], "]"}], "]"}], 
                  "]"}], ",", "\"\<E\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "6"}], "]"}], "]"}], 
                  "]"}]}], "}"}], "}"}], "]"}]}], "}"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Material\>\"", ",", "\"\<Young [GPa]\>\"", ",", 
               "\"\<Poisson\>\"", ",", "\"\<Loss [rad]\>\""}], "}"}]}], 
            "}"}]}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Dimension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Wire Dimension\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Variable Thickness\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "6"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Wire Length with Tension\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", "meter"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "meter"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], ",", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Length [m]\>\"", ",", "\"\<Diam [mm]\>\"", ",", 
              "\"\<Neck L[mm]\>\"", ",", "\"\<Neck D[mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Stiffness", "--"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Wire Dimension\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireStiff", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "\"\<Longitudinal Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Torsional Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Nm/rad\>\""}], "\[IndentingNewLine]", "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Tension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Tension on Each Wire\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate From Suspended Mass\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireTension", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<N\>\"", 
           ",", "\[IndentingNewLine]", "\"\<(\>\"", ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "7", "]"}], "]"}], "/", "g"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "g"}]}], ")"}], "&"}]}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kgw)\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Wire", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "mod$CreateWires", "]"}]}], "]"}], 
           ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"800", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Wire Registration\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.57019536883836*^9, 
   3.5701953742146673`*^9}, {3.5701954808607674`*^9, 
   3.5701954946425557`*^9}, {3.5702570659338207`*^9, 
   3.5702570660898204`*^9}, {3.570257104996289*^9, 3.570257105136689*^9}, {
   3.5702572681569757`*^9, 3.5702572939282207`*^9}, {3.5702574577909083`*^9, 
   3.5702574579313087`*^9}, {3.57025800494647*^9, 3.5702580258193064`*^9}, {
   3.57025823832588*^9, 3.5702582468278947`*^9}, 3.5702583104604063`*^9, {
   3.5702877658946943`*^9, 3.570287780072505*^9}, {3.570287843959159*^9, 
   3.5702878457942643`*^9}, {3.5702884671558037`*^9, 
   3.5702884672758107`*^9}, {3.5703042639543295`*^9, 3.570304319841526*^9}, {
   3.5709795615205307`*^9, 3.5709797878724775`*^9}, {3.5709798430276327`*^9, 
   3.570979885228046*^9}, {3.5709804815281525`*^9, 3.570980483118243*^9}, 
   3.590777229882943*^9, {3.5907773249873824`*^9, 3.5907773271805077`*^9}, {
   3.7169612870010767`*^9, 3.716961293479706*^9}, {3.7184144492535553`*^9, 
   3.718414451945025*^9}, {3.9167786279574547`*^9, 3.9167786770102873`*^9}, 
   3.916778779544833*^9},ExpressionUUID->"179656ea-065b-46d7-bf4c-\
50181f17bdbc"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Wire Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570979796106949*^9, 
  3.57097980067021*^9}},ExpressionUUID->"19fc63c2-deaa-4d9c-990c-\
e66c22f86862"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcWireStiff", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"temp$newwire", "[", 
       RowBox[{"[", 
        RowBox[{"8", ",", "1"}], "]"}], "]"}], "=", 
      RowBox[{
       RowBox[{"save$mat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
       RowBox[{"GPa", "/", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", 
            RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
               RowBox[{"2", "*", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "3"}], "]"}], "]"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"N", "[", "Pi", "]"}], "*", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "2"}], "/", 
                "4"}]}], ")"}]}], "+", "\[IndentingNewLine]", 
            RowBox[{"2", "*", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", 
                RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"N", "[", "Pi", "]"}], "*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "^", "2"}], "/", 
                 "4"}]}], ")"}]}]}]}], ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", 
              RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"N", "[", "Pi", "]"}], "*", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "2"}], "/", 
               "4"}]}], ")"}]}], ")"}]}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"temp$newwire", "[", 
       RowBox[{"[", 
        RowBox[{"8", ",", "2"}], "]"}], "]"}], "=", 
      RowBox[{
       RowBox[{"save$mat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
       RowBox[{
        RowBox[{
         RowBox[{"GPa", "/", "2"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"save$mat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "5", "]"}], "]"}], ",", "4"}], "]"}], "]"}]}], 
          ")"}]}], "/", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", 
            RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
               RowBox[{"2", "*", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "3"}], "]"}], "]"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"N", "[", "Pi", "]"}], "*", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "4"}], "/", 
                "32"}]}], ")"}]}], "+", "\[IndentingNewLine]", 
            RowBox[{"2", "*", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", 
                RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"N", "[", "Pi", "]"}], "*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "^", "4"}], "/", 
                 "32"}]}], ")"}]}]}]}], ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", 
              RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"N", "[", "Pi", "]"}], "*", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "4"}], "/", 
               "32"}]}], ")"}]}], ")"}]}], "]"}]}]}]}], ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5709798033593636`*^9, 3.5709798038553915`*^9}, {
  3.5709799682387943`*^9, 3.570980099580306*^9}, {3.570980154143427*^9, 
  3.5709803245071716`*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"47c08da7-c900-4009-ade6-351d57c7df13"]
}, Closed]],

Cell[CellGroupData[{

Cell["Suspension Point Note List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701741454214497`*^9, 
  3.5701741607833285`*^9}},ExpressionUUID->"82d03065-f27e-4a31-bb77-\
9ee0b843ae85"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$SPNoteList", "[", "num_", "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"num", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", "\"\<(Unused)\>\"", ",", 
        "\"\<(Unused)\>\"", ",", "\"\<(Unused)\>\"", ",", 
        "\"\<(Unused)\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"num", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", 
        "\"\<X-distance between upper SP & upper body's COM [mm]\>\"", ",", 
        "\[IndentingNewLine]", 
        "\"\<X-distance between lower SP & lower body's COM [mm]\>\"", ",", 
        "\"\<(Unused)\>\"", ",", "\"\<(Unused)\>\""}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"num", "\[Equal]", "3"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", 
        "\"\<Horizontal radial distance from body's COM [mm]\>\"", ",", 
        "\"\<(Unused)\>\"", ",", "\[IndentingNewLine]", 
        "\"\<Rotation angle in the horizontal plane [deg]\>\"", ",", 
        "\"\<(Unused)\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"num", "\[Equal]", "4"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", "\"\<X-distance from body's COM [mm]\>\"",
         ",", "\[IndentingNewLine]", 
        "\"\<Z-distance from body's COM [mm]\>\"", ",", "\"\<(Unused)\>\"", 
        ",", "\[IndentingNewLine]", 
        "\"\<Upper SP Z-translation from COM [mm]\>\""}], "}"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570174101156918*^9, 3.570174116435792*^9}, {
   3.570174188575918*^9, 3.5701745819814196`*^9}, {3.570174618259495*^9, 
   3.5701747329990573`*^9}, 3.5701797121388483`*^9, {3.5701828840252695`*^9, 
   3.570182940029473*^9}, {3.5907771515694637`*^9, 3.5907771962380185`*^9}, {
   3.590777903683482*^9, 3.590777910876893*^9}, {3.716960039621052*^9, 
   3.7169600654399652`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"6863ae44-55e8-4ad5-992e-f6263adea802"]
}, Closed]],

Cell[CellGroupData[{

Cell["Wire Tension", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570182016943675*^9, 
  3.570182019214805*^9}},ExpressionUUID->"417b9bfc-d183-4451-a618-\
b6bf0706ada0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcWireTension", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Check the masses suspended below the wires:\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Logic"}]}], " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$wten", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Check"}]}], " ", "List", " ", "for", " ", 
           RowBox[{"Calculation", "--"}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Checkbox", "[", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wten", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                ",", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Calculator", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Total Mass:\>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"temp$wten", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{"save$mass", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
            "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"N", "[", 
                 RowBox[{"Sum", "[", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$wten", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                  "]"}], "]"}], "*", 
                RowBox[{
                 RowBox[{"g", "/", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "/", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                   "1"}], "]"}]}]}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "200"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Set Material\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567619871576691*^9, 3.5676198722027273`*^9}, {
  3.567619997598899*^9, 3.5676203137319813`*^9}, {3.5676203764675694`*^9, 
  3.5676206381485367`*^9}, {3.5676208095553403`*^9, 3.567620820959993*^9}, {
  3.567621207597107*^9, 3.5676212144885015`*^9}, {3.5676230352136407`*^9, 
  3.567623041119979*^9}, {3.567623212578786*^9, 3.5676232129498067`*^9}, {
  3.5676236755552664`*^9, 3.567623675748277*^9}, {3.5699566678150444`*^9, 
  3.5699566678410463`*^9}, {3.5701820424861364`*^9, 3.570182046428362*^9}, {
  3.570182090922907*^9, 3.570182221552378*^9}, {3.570182279862713*^9, 
  3.570182436566676*^9}, {3.57018247439384*^9, 3.57018257824578*^9}, {
  3.5701826349120207`*^9, 3.5701826645597167`*^9}, {3.5701826995467176`*^9, 
  3.5701827056060643`*^9}, {3.5703039054448233`*^9, 3.5703039907997055`*^9}, {
  3.570304040115526*^9, 3.5703041123386574`*^9}, {3.5703042363787518`*^9, 
  3.570304236488758*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"9afc08ab-0f9c-4da2-be01-6ec87bfd4457"]
}, Closed]],

Cell[CellGroupData[{

Cell["Create Wire Group", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567099102884283*^9, 3.567099110037692*^9}, {
  3.5670992402151375`*^9, 3.56709925476797*^9}, {3.567573948274887*^9, 
  3.5675739511100492`*^9}, {3.567579173882775*^9, 3.567579176994953*^9}, {
  3.5675792201244197`*^9, 3.567579224485669*^9}, {3.718308922940803*^9, 
  3.718308926217972*^9}},ExpressionUUID->"acb86d86-35a2-463c-811e-\
2cdc74525ff9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CreateWires", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP1wire", "[", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP1wire", "[", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP2wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP2wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"normalize", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "]"}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"-", 
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}]}], ",", "0"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"normalize", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"+", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "]"}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}], ",", "0"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"mod$SP4wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{"Version", " ", "1.2"}], "*)"}], "+", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "6"}], "]"}], "]"}]}], "}"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP4wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "4"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"temp$wire2", ",", "temp$newwire"}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Generating", " ", "comments", " ", "for", " ", "each", " ", "field"}],
        " ", "*)"}], 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"temp$wire$comments", ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"temp$wire", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"Length", "[", "temp$wire", "]"}], ",", "n"}], 
                 "]"}], "]"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"temp$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"Length", "[", "temp$wire", "]"}], "]"}], "]"}], 
               "]"}]}], "}"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"temp$newwire", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"temp$wire2$comments", ",", "temp$newwire$comments"}], "]"}], 
      ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567618157334642*^9, 3.567618258146408*^9}, {
   3.567618355662986*^9, 3.567618461073015*^9}, {3.567618491184737*^9, 
   3.5676185795717926`*^9}, {3.567618624034336*^9, 3.5676186266424847`*^9}, {
   3.5676187344916534`*^9, 3.5676187401169753`*^9}, {3.567618896051894*^9, 
   3.567618972341258*^9}, {3.5676191966360865`*^9, 3.5676195070508413`*^9}, 
   3.567619592230714*^9, {3.5676198814002533`*^9, 3.567619987000293*^9}, {
   3.567621351097315*^9, 3.567621408168579*^9}, {3.567623199136017*^9, 
   3.5676232109566927`*^9}, {3.5699566678530464`*^9, 3.569956669069116*^9}, {
   3.5701903245018406`*^9, 3.570190480182745*^9}, {3.570190589032971*^9, 
   3.5701907067267027`*^9}, {3.570190747578039*^9, 3.57019079549678*^9}, {
   3.5701908712851143`*^9, 3.570190932990644*^9}, {3.5701915114917326`*^9, 
   3.5701915852189493`*^9}, {3.570191853197277*^9, 3.570191870340257*^9}, {
   3.570192092464962*^9, 3.5701921016844893`*^9}, {3.5701921626209745`*^9, 
   3.570192223443454*^9}, {3.570302578468925*^9, 3.57030262682069*^9}, {
   3.5703027102984653`*^9, 3.5703027446594305`*^9}, {3.5703029463839684`*^9, 
   3.5703030484998093`*^9}, 3.570303087227024*^9, {3.570303123898122*^9, 
   3.570303130546502*^9}, {3.5703032863314123`*^9, 3.5703033136609755`*^9}, {
   3.5703035871816196`*^9, 3.5703036585237007`*^9}, {3.5709805445897593`*^9, 
   3.57098071541553*^9}, {3.570981455965887*^9, 3.57098146003712*^9}, {
   3.57098150251355*^9, 3.5709815068317966`*^9}, {3.5857146194552917`*^9, 
   3.585714662110731*^9}, 3.5857160733314486`*^9, {3.590777616816074*^9, 
   3.590777618712182*^9}, {3.9167788009537363`*^9, 3.9167788135596905`*^9}, {
   3.916778966506438*^9, 3.91677909718664*^9}, {3.916779489273725*^9, 
   3.9167794950675507`*^9}, {3.916779668163395*^9, 3.916779692195653*^9}, {
   3.9167860978273573`*^9, 3.916786162740096*^9}, {3.9167862526309776`*^9, 
   3.916786262798488*^9}, 3.916786548370043*^9, {3.916786670158448*^9, 
   3.9167867015883017`*^9}},ExpressionUUID->"86865263-2b19-4ff5-abcc-\
eb58db9bff1b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Reflect Changes to Wire List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857147485516753`*^9, 3.5857147508178053`*^9}, {
  3.585714873905845*^9, 
  3.5857148802872105`*^9}},ExpressionUUID->"b7f5a1ce-dc5d-4dad-a3af-\
b57c97b11560"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ReflectWires", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"temp$newwire", ",", "temp$newwire$comment"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"temp$wire", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"temp$wire$comments", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"temp$newwire", "=", 
          RowBox[{"temp$wire2", "[", 
           RowBox[{"[", "m", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"temp$newwire$comment", "=", 
          RowBox[{"temp$wire2$comments", "[", 
           RowBox[{"[", "m", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Do", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP1wire", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP1wire", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                   RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", 
                    RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
               ";"}], "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ";"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Do", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP2wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP2wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"normalize", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "]"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}]}], ",", "0"}], "}"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"normalize", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"+", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "]"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}], ",", "0"}], "}"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", 
                    RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
               ";"}], "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ";"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Do", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP3wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP3wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", 
                    RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
               ";"}], "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ";"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Do", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"mod$SP4wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Version", " ", "1.2"}], "*)"}], "+", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "6"}], "]"}], "]"}]}], "}"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"mod$SP4wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                    "<>", "\"\<-\>\"", "<>", 
                    RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
               ";"}], "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", "4"}], "}"}]}], "]"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "temp$wire2", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"temp$wire$comments", ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"temp$wire", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"Length", "[", "temp$wire", "]"}], ",", "n"}], 
                 "]"}], "]"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"temp$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"Length", "[", "temp$wire", "]"}], "]"}], "]"}], 
               "]"}]}], "}"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"temp$newwire", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567618157334642*^9, 3.567618258146408*^9}, {
   3.567618355662986*^9, 3.567618461073015*^9}, {3.567618491184737*^9, 
   3.5676185795717926`*^9}, {3.567618624034336*^9, 3.5676186266424847`*^9}, {
   3.5676187344916534`*^9, 3.5676187401169753`*^9}, {3.567618896051894*^9, 
   3.567618972341258*^9}, {3.5676191966360865`*^9, 3.5676195070508413`*^9}, 
   3.567619592230714*^9, {3.5676198814002533`*^9, 3.567619987000293*^9}, {
   3.567621351097315*^9, 3.567621408168579*^9}, {3.567623199136017*^9, 
   3.5676232109566927`*^9}, {3.5699566678530464`*^9, 3.569956669069116*^9}, {
   3.5701903245018406`*^9, 3.570190480182745*^9}, {3.570190589032971*^9, 
   3.5701907067267027`*^9}, {3.570190747578039*^9, 3.57019079549678*^9}, {
   3.5701908712851143`*^9, 3.570190932990644*^9}, {3.5701915114917326`*^9, 
   3.5701915852189493`*^9}, {3.570191853197277*^9, 3.570191870340257*^9}, {
   3.570192092464962*^9, 3.5701921016844893`*^9}, {3.5701921626209745`*^9, 
   3.570192223443454*^9}, {3.570302578468925*^9, 3.57030262682069*^9}, {
   3.5703027102984653`*^9, 3.5703027446594305`*^9}, {3.5703029463839684`*^9, 
   3.5703030484998093`*^9}, 3.570303087227024*^9, {3.570303123898122*^9, 
   3.570303130546502*^9}, {3.5703032863314123`*^9, 3.5703033136609755`*^9}, {
   3.5703035871816196`*^9, 3.5703036585237007`*^9}, {3.5709805445897593`*^9, 
   3.57098071541553*^9}, {3.570981455965887*^9, 3.57098146003712*^9}, {
   3.57098150251355*^9, 3.5709815068317966`*^9}, {3.5857146194552917`*^9, 
   3.585714662110731*^9}, {3.5857147583892384`*^9, 3.585714849666459*^9}, {
   3.5907775604958525`*^9, 3.5907775993070726`*^9}, {3.716608095247223*^9, 
   3.716608153722847*^9}, {3.7166084695740023`*^9, 3.716608500165225*^9}, {
   3.716608800501918*^9, 3.7166088258591146`*^9}, {3.7166088678704844`*^9, 
   3.7166089790142612`*^9}, {3.716609013941684*^9, 3.716609024033503*^9}, {
   3.7166090550585737`*^9, 3.716609085215686*^9}, {3.716609181524588*^9, 
   3.716609188532035*^9}, 3.716609463128811*^9, {3.716609595879138*^9, 
   3.716609604079028*^9}, {3.71667697220198*^9, 3.716677007108885*^9}, {
   3.7166770646731243`*^9, 3.716677155409552*^9}, {3.916787339310071*^9, 
   3.916787348358081*^9}, {3.916788069735552*^9, 3.9167880731035633`*^9}, {
   3.916788373168485*^9, 3.9167883928934145`*^9}, {3.916788581144162*^9, 
   3.9167886224575596`*^9}},ExpressionUUID->"d4c95ded-b7f6-4f2e-9028-\
0412809beafe"]
}, Closed]],

Cell[CellGroupData[{

Cell["Create 3D shapes Wires", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567099102884283*^9, 3.567099110037692*^9}, {
  3.5670992402151375`*^9, 3.56709925476797*^9}, {3.567573948274887*^9, 
  3.5675739511100492`*^9}},ExpressionUUID->"5cc7aace-6a0b-4187-b9aa-\
0de9c035ad89"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DrawWires", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ru", "=", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           RowBox[{"temp$newwire", "[", 
            RowBox[{"[", 
             RowBox[{"4", ",", "6"}], "]"}], "]"}]}]}], "}"}]}], ",", 
       RowBox[{"rl", "=", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           RowBox[{"temp$newwire", "[", 
            RowBox[{"[", 
             RowBox[{"6", ",", "1"}], "]"}], "]"}]}], ",", "0"}], "}"}]}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Join", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Wire"}]}], " ", 
         RowBox[{"Drawing", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP1wire", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP1wire", "[", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP2wire", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP2wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP3wire", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP4wire", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP4wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "4"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Suspension"}]}], " ", "Point", " ", 
          RowBox[{"Drawing", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP1wire", "[", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP1wire", "[", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", "1"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP2wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP2wire", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", "1"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP3wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP3wire", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", "1"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP4wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP4wire", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "4"}], "}"}]}], "]"}], ",", "1"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ","}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Point", "[", "ru", "]"}], ",", 
         RowBox[{"Point", "[", "rl", "]"}]}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"Opacity", "[", "0.5", "]"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"mod$Create3DShape", "[", 
          RowBox[{"ru", ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"mod$Create3DShape", "[", 
          RowBox[{"rl", ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
          "]"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5670991129788604`*^9, 3.56709914532271*^9}, {
   3.5670991824098315`*^9, 3.5670994584046173`*^9}, {3.567100100357335*^9, 
   3.5671001871372986`*^9}, {3.5671002327669086`*^9, 
   3.5671003436832523`*^9}, {3.567358412979867*^9, 3.5673584563383474`*^9}, {
   3.5673585771762586`*^9, 3.5673587813949394`*^9}, {3.5673588334849186`*^9, 
   3.5673589541708217`*^9}, {3.5673589955221868`*^9, 
   3.5673592005639143`*^9}, {3.5673592357089243`*^9, 
   3.5673592860628047`*^9}, {3.5673593208547945`*^9, 3.567359388902687*^9}, {
   3.5673594206105003`*^9, 3.5673594879573526`*^9}, {3.567359542009444*^9, 
   3.567359619516877*^9}, {3.567359666829583*^9, 3.5673596943671584`*^9}, {
   3.5673598561764135`*^9, 3.5673599255453806`*^9}, {3.5673599780753856`*^9, 
   3.5673599964554367`*^9}, {3.567360366902625*^9, 3.5673603752471027`*^9}, {
   3.5673609025692635`*^9, 3.567360924802535*^9}, {3.5673615750917296`*^9, 
   3.5673615910466423`*^9}, {3.567361622292429*^9, 3.56736185413769*^9}, {
   3.567361908312789*^9, 3.5673619143141317`*^9}, {3.567615885943726*^9, 
   3.567615996490049*^9}, {3.567616115560859*^9, 3.567616123887336*^9}, {
   3.5676162928860016`*^9, 3.567616296561212*^9}, 3.567616366495212*^9, {
   3.5676164922614055`*^9, 3.5676165110284786`*^9}, {3.567617953036957*^9, 
   3.567617957035186*^9}, {3.5701761038494654`*^9, 3.5701762142167783`*^9}, {
   3.570176260174407*^9, 3.5701763478424215`*^9}, {3.5701841544039307`*^9, 
   3.570184158814183*^9}, {3.570184286507487*^9, 3.5701843130960073`*^9}, {
   3.5701847888162174`*^9, 3.5701851710230784`*^9}, {3.570185205428046*^9, 
   3.5701853772298727`*^9}, {3.5701854096137247`*^9, 
   3.5701854097907352`*^9}, {3.5701855016609898`*^9, 
   3.5701855109815226`*^9}, {3.5701857359003873`*^9, 3.570185755336499*^9}, {
   3.5701860232788243`*^9, 3.5701861074326377`*^9}, {3.570187229231801*^9, 
   3.5701872368282356`*^9}, {3.5857153483809834`*^9, 
   3.5857153852550926`*^9}, {3.585715415438819*^9, 3.585715415600828*^9}, {
   3.5857154595893445`*^9, 3.585715533480571*^9}, {3.5857155913368797`*^9, 
   3.5857155913968835`*^9}, {3.59077729504467*^9, 3.590777306319315*^9}, {
   3.5907774130534196`*^9, 3.590777416049591*^9}, {3.5907779690122185`*^9, 
   3.590777969232231*^9}, {3.590778367455008*^9, 3.5907783705531855`*^9}, {
   3.590778417785887*^9, 3.590778450623765*^9}, {3.7166100867756453`*^9, 
   3.716610087792*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"fb18e3d7-da4f-4924-be42-2a0c3b956159"]
}, Closed]],

Cell[CellGroupData[{

Cell["Wire Suspension Point Generator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570184461728509*^9, 
  3.5701844669178057`*^9}},ExpressionUUID->"9549b122-60ab-4177-8b5e-\
7764b54dbdeb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP1wire", "[", "dy_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "dy", ",", "0"}], "}"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570184319186356*^9, 3.570184402754136*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"a611256e-dc25-444f-b692-7eb03fad556d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP2wire", "[", 
    RowBox[{"dy_", ",", "dx_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "dx"}], ",", "dy", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dx"}], ",", "dy", ",", "0"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701844066083565`*^9, 3.570184430823741*^9}, {
  3.5701846199525585`*^9, 3.5701846230667367`*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"d6b71f48-2798-430b-b7b9-21771aa044e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP3wire", "[", 
    RowBox[{"dy_", ",", "dr_", ",", "th_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "dr"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"th", "+", 
          RowBox[{"0", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}], ",", "dy",
        ",", 
       RowBox[{
        RowBox[{"-", "dr"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"th", "+", 
          RowBox[{"0", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "dr"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"th", "+", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}], ",", "dy",
        ",", 
       RowBox[{
        RowBox[{"-", "dr"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"th", "+", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "dr"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"th", "+", 
          RowBox[{"4", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}], ",", "dy",
        ",", 
       RowBox[{
        RowBox[{"-", "dr"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"th", "+", 
          RowBox[{"4", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}]}], "}"}]}],
     "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567359702105601*^9, 3.567359729621175*^9}, {
  3.567359803294389*^9, 3.5673598456598115`*^9}, {3.567360005560958*^9, 
  3.5673600216548777`*^9}, {3.5676161036421776`*^9, 3.567616109404507*^9}, {
  3.5701844339569206`*^9, 3.5701844438014836`*^9}, {3.5701846389646463`*^9, 
  3.570184649443246*^9}, {3.570185080158881*^9, 3.5701850810519323`*^9}, {
  3.5702896902927637`*^9, 3.570289693676957*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"817d396c-6c79-4d85-969c-e759a662b860"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP4wire", "[", 
    RowBox[{"dx_", ",", "dy_", ",", "dz_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dx"}], ",", "dy", ",", 
       RowBox[{"-", "dz"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dx"}], ",", "dy", ",", 
       RowBox[{"+", "dz"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "dx"}], ",", "dy", ",", 
       RowBox[{"+", "dz"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "dx"}], ",", "dy", ",", 
       RowBox[{"-", "dz"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567359946716592*^9, 3.567359969746909*^9}, {
  3.5701844453525724`*^9, 3.570184455162133*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"464f0559-f9e9-40b4-a1d5-ec98b405f9c9"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-2 Define Vertical Springs", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570194431878769*^9, 3.5701944384821463`*^9}, 
   3.7184150948908787`*^9},ExpressionUUID->"049cd18d-8eb5-42db-923a-\
3e1694ee681c"],

Cell[CellGroupData[{

Cell["Define Vertical Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
   3.570194453170987*^9, 3.570194456945203*^9}, 
   3.718415096125683*^9},ExpressionUUID->"34b4be68-a521-4f8d-be89-\
cd40d2eca1fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DefineVertSprings", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Main"}]}], " ", 
      RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Define Vertical Springs\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.9", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "Wire", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Define New Wire Spring\>\"", ",", "Bold", ",", "White"}], 
              "]"}], ",", "mod$NewVertSprings", ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Define New Body Spring\>\"", ",", "Bold", ",", "White"}], 
              "]"}], ",", "mod$NewBodySprings", ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}]}], 
          "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Load"}]}], " ", 
          RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ValueQ", "[", "save$vspr", "]"}], ",", 
          RowBox[{"temp$vspr", "=", "save$vspr"}], ",", 
          RowBox[{"temp$vspr", "=", 
           RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ValueQ", "[", "save$vspr$comments", "]"}], ",", 
          RowBox[{"temp$vspr$comments", "=", "save$vspr$comments"}], ",", 
          RowBox[{"temp$vspr$comments", "=", 
           RowBox[{
            RowBox[{"temp$vspr", "/.", 
             RowBox[{
              RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
              "\"\<\>\""}]}], "/.", 
            RowBox[{
             RowBox[{"x_", "?", "StringQ"}], "\[Rule]", "\"\<\>\""}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ValueQ", "[", "save$bspr", "]"}], ",", 
          RowBox[{"temp$bspr", "=", "save$bspr"}], ",", 
          RowBox[{"temp$bspr", "=", 
           RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ValueQ", "[", "save$bspr$comments", "]"}], ",", 
          RowBox[{"temp$bspr$comments", "=", "save$bspr$comments"}], ",", 
          RowBox[{"temp$bspr$comments", "=", 
           RowBox[{
            RowBox[{"temp$bspr", "/.", 
             RowBox[{
              RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
              "\"\<\>\""}]}], "/.", 
            RowBox[{
             RowBox[{"x_", "?", "StringQ"}], "\[Rule]", "\"\<\>\""}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Input"}]}], " ", "Field", " ", "for", " ", "Wire", 
           " ", "Based", " ", "Vertical", " ", 
           RowBox[{"Springs", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Dynamic", "[", 
         RowBox[{"TableForm", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"n", "=", "n"}], "}"}], ",", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"temp$vspr", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$vspr", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                    RowBox[{"temp$vspr$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$vspr$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"n", "=", "n"}], "}"}], ",", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$vspr", ",", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$vspr$comments", ",", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"n", "=", "n"}], "}"}], ",", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                   RowBox[{"mod$EditVertSprings", "[", "n", "]"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", "Name", "*)"}], "\[IndentingNewLine]", 
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", "Position", "*)"}], "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "13"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "\[Rule]", "\"\<Upper SP\>\""}], ",", 
                    RowBox[{"2", "\[Rule]", "\"\<Lower SP\>\""}]}], "}"}]}], 
                    "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", "k", "*)"}], "\[IndentingNewLine]", 
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", "fp", "*)"}], "\[IndentingNewLine]", 
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", "Q", "*)"}], "\[IndentingNewLine]", 
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}]}]}],
                     "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}]}]}],
                     "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "temp$vspr", "]"}]}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"TableHeadings", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"None", ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", 
                "\"\<Edit\>\"", ",", "\"\<Name\>\"", ",", "\"\<Position\>\"", 
                ",", "\"\<k [N/m]\>\"", ",", "\"\<fp [N]\>\"", ",", 
                "\"\<Q\>\"", ",", "\"\<CoP [dB]\>\"", ",", 
                "\"\<Direction\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", "for", " ", "Body", 
          " ", "Vertical", " ", 
          RowBox[{"Springs", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", "=", "n"}], "}"}], ",", 
                RowBox[{"Button", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"temp$bspr", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$bspr", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                   RowBox[{"temp$bspr$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$bspr$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], "]"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", "=", "n"}], "}"}], ",", 
                RowBox[{"Button", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$bspr", ",", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                   RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$bspr$comments", ",", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], "]"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", "=", "n"}], "}"}], ",", 
                RowBox[{"Button", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                  RowBox[{"mod$EditBodySprings", "[", "n", "]"}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], "]"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "Name", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"OpenerView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                   RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                  "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "Position", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], 
               "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "k", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"OpenerView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                 "}"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                   RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                  "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "fp", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"OpenerView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                 "}"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                   RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                  "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "Q", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"OpenerView", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                 "}"}], ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bspr$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                   RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                  "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "temp$bspr", "]"}]}], "}"}]}], "]"}], 
          ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", "\"\<Edit\>\"",
                ",", "\"\<Name\>\"", ",", "\"\<Position\>\"", ",", 
               "\"\<k [N/m]\>\"", ",", "\"\<fp [N]\>\"", ",", "\"\<Q\>\""}], 
              "}"}]}], "}"}]}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"save$vspr", "=", "temp$vspr"}], ";", 
               RowBox[{"save$vspr$comments", "=", "temp$vspr$comments"}], ";", 
               RowBox[{"save$bspr", "=", "temp$bspr"}], ";", 
               RowBox[{"save$bspr$comments", "=", "temp$bspr$comments"}]}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"800", ",", "500"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", "\"\<2-2 Define Vertical Springs\>\""}], ",", 
     " ", 
     RowBox[{"WindowFrameElements", "\[Rule]", 
      RowBox[{"{", "\"\<ZoomBox\>\"", "}"}]}]}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{"Cancel", " ", "Button"}], "*)"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702162782515507`*^9, 
   3.5702163782442703`*^9}, {3.570216470777563*^9, 3.5702164805631227`*^9}, {
   3.5702165658460007`*^9, 3.5702165893283434`*^9}, {3.5702570661210203`*^9, 
   3.570257066994622*^9}, {3.570257105167889*^9, 3.5702571052302895`*^9}, {
   3.5702572996222305`*^9, 3.570257307718645*^9}, {3.570257457962509*^9, 
   3.570257458009309*^9}, {3.570258035319723*^9, 3.570258059655766*^9}, {
   3.5702582488402987`*^9, 3.5702582525687046`*^9}, 3.570258288557968*^9, 
   3.5702583537504826`*^9, {3.5702883642379174`*^9, 3.5702884028931284`*^9}, {
   3.57030447482839*^9, 3.570304474942397*^9}, {3.5703045983484554`*^9, 
   3.5703046211247582`*^9}, {3.570553900822813*^9, 3.5705539016648607`*^9}, {
   3.57063896965767*^9, 3.5706389827284174`*^9}, {3.5857164149669886`*^9, 
   3.585716452993164*^9}, {3.5857164843139553`*^9, 3.5857164872691245`*^9}, {
   3.5857180469773345`*^9, 3.5857180558798437`*^9}, 3.6726270788899946`*^9, {
   3.7166102208780203`*^9, 3.7166102691703987`*^9}, {3.7166103332182503`*^9, 
   3.716610393994597*^9}, {3.7166104288606167`*^9, 3.716610509910202*^9}, {
   3.7166105710070066`*^9, 3.716610580201353*^9}, {3.716616108993369*^9, 
   3.716616261162943*^9}, {3.7166163236509953`*^9, 3.716616327280601*^9}, {
   3.716616392903431*^9, 3.716616399364732*^9}, {3.716616450421049*^9, 
   3.7166164678239307`*^9}, {3.716616527331872*^9, 3.71661660999214*^9}, {
   3.716616783306395*^9, 3.7166168039398937`*^9}, {3.7166168376118526`*^9, 
   3.7166168441952553`*^9}, {3.71693499156918*^9, 3.716935025375844*^9}, {
   3.71693511572806*^9, 3.7169351858400393`*^9}, {3.7183514263034067`*^9, 
   3.718351485002963*^9}, {3.718351530959867*^9, 3.7183515469264097`*^9}, {
   3.718351682070277*^9, 3.718351697267215*^9}, {3.718351808887476*^9, 
   3.718351885988038*^9}, 3.7183519670991077`*^9, {3.7183877513747*^9, 
   3.718387755603117*^9}, 3.718414567433325*^9, {3.718415097479665*^9, 
   3.7184151150093822`*^9}, {3.9156528822624245`*^9, 3.915652891943386*^9}, {
   3.915653050160104*^9, 3.9156530607200837`*^9}, {3.91565313647094*^9, 
   3.9156531641912174`*^9}, 3.915653214451412*^9, {3.9156641340438175`*^9, 
   3.91566415725776*^9}, {3.9156643267686663`*^9, 3.915664384555648*^9}, {
   3.915664434706643*^9, 3.915664442246852*^9}, {3.915664503908945*^9, 
   3.915664515011263*^9}, {3.915664572883497*^9, 3.9156645901134596`*^9}, {
   3.9156646514753485`*^9, 3.915664671347626*^9}, 3.915664744053607*^9, {
   3.915664827593024*^9, 3.9156649665221167`*^9}, {3.9156652991911736`*^9, 
   3.915665309252742*^9}, {3.9156659293608427`*^9, 3.9156659295128016`*^9}, {
   3.9156659894430285`*^9, 3.9156659961268635`*^9}, {3.9157528672973776`*^9, 
   3.915752867826393*^9}, {3.9158509797822065`*^9, 3.915850989467747*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"1d8bc925-a8c2-4dc3-bc09-099f97106cbd"]
}, Closed]],

Cell[CellGroupData[{

Cell["New Wire Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.9156531846403427`*^9, 
  3.9156531867048903`*^9}},ExpressionUUID->"ccd3e479-5f09-4242-aee2-\
d4255070c90e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewVertSprings", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Define New Vertical Spring\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "spring", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newvspr", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0.", ",", "0.", ",", "True", ",", 
           RowBox[{"-", "60"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "\"\<\>\"", ",", 
           "1000."}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newvspr$comment", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"temp$newvspr", "/.", 
             RowBox[{
              RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
              "\"\<\>\""}]}], "/.", 
            RowBox[{"True", "\[Rule]", "\"\<\>\""}]}], "/.", 
           RowBox[{"False", "\[Rule]", "\"\<\>\""}]}], "/.", 
          RowBox[{
           RowBox[{"x_", "?", "StringQ"}], "\[Rule]", "\"\<\>\""}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Spring Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"OpenerView", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr$comment", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr$comment", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], "\[NotEqual]", 
             "\"\<\>\""}], ",", 
            RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
           "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"SP", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose wire suspension point where spring is inserted.\>\"", 
           ",", "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "13"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], 
              "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<Upper SP\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Lower SP\>\""}]}], "}"}]}], 
            "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Prestress", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness & Prestress\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from wire tension & resonant frequency\>\"", ",", 
           "Bold", ",", "Black", ",", "Small"}], "]"}], ",", 
         "\[IndentingNewLine]", "mod$CalcSprStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Stiffness:\>\"", ",", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr$comment", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr$comment", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<N/m\>\""}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Prestress:\>\"", ",", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr$comment", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr$comment", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<N\>\""}], "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"OpenerView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newvspr", "[", 
                  RowBox[{"[", "9", "]"}], "]"}], "]"}], ",", "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newvspr$comment", "[", 
                  RowBox[{"[", "9", "]"}], "]"}], "]"}], ",", "String", ",", 
                RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newvspr$comment", "[", 
                  RowBox[{"[", "9", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "\"\<\>\""}], ",", 
               RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
              "]"}]}]}], "]"}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", "Percussion", " ", 
          RowBox[{"Effect", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Effect\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.7", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "5", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newvspr", "[", 
                   RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Enabled", "\[Rule]", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newvspr$comment", "[", 
                   RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Enabled", "\[Rule]", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], "]"}]}]}], "]"}]}], "}"}],
              ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newvspr$comment", "[", 
                   RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
                 "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", "\"\<dB\>\""}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Working"}]}], " ", 
          RowBox[{"Direction", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Working Direction\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"7", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                 ",", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newvspr$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"7", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                 ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newvspr$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"7", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                 "\[NotEqual]", "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Spring", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$vspr", ",", "temp$newvspr"}], "]"}], ";", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$vspr$comments", ",", "temp$newvspr$comment"}], 
                "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Vertical Springs\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.570257067213022*^9, 
   3.570257068086624*^9}, {3.570257105261489*^9, 3.57025710533949*^9}, {
   3.5702573125858536`*^9, 3.570257336999896*^9}, {3.570257458024909*^9, 
   3.5702574580717087`*^9}, {3.5702580709989862`*^9, 
   3.5702580875506153`*^9}, {3.5702582550335093`*^9, 3.5702582593079166`*^9}, 
   3.570258291365973*^9, 3.570258355528886*^9, {3.570304447263814*^9, 
   3.570304447391821*^9}, {3.5706390399486904`*^9, 3.5706391762724876`*^9}, {
   3.570639328539197*^9, 3.5706395632336206`*^9}, {3.5706396124144335`*^9, 
   3.570639663527357*^9}, {3.5706397247278576`*^9, 3.5706397343694086`*^9}, {
   3.5706398445457106`*^9, 3.5706398470598545`*^9}, {3.5706400506705003`*^9, 
   3.570640052520606*^9}, {3.717787939387054*^9, 3.71778803080227*^9}, {
   3.717788190270791*^9, 3.717788309947618*^9}, {3.717788372232687*^9, 
   3.717788402934331*^9}, {3.717788432947249*^9, 3.71778848466883*^9}, {
   3.7177885654099503`*^9, 3.7177885861978197`*^9}, {3.7177886411663027`*^9, 
   3.717788649370262*^9}, {3.7177887053317842`*^9, 3.7177887620557213`*^9}, {
   3.7177888001644163`*^9, 3.7177888223686857`*^9}, {3.71778896018932*^9, 
   3.717788961452676*^9}, {3.717789033045116*^9, 3.717789037933939*^9}, {
   3.7177892326371613`*^9, 3.717789233954543*^9}, {3.717789264226914*^9, 
   3.7177893103199587`*^9}, {3.7177893767419767`*^9, 3.717789394396644*^9}, {
   3.717789426414238*^9, 3.71778943251462*^9}, {3.717789502824121*^9, 
   3.717789511323758*^9}, {3.717789610591189*^9, 3.717789614961069*^9}, 
   3.7177897740155373`*^9, {3.718352081444909*^9, 3.7183521097880096`*^9}, {
   3.718352142841688*^9, 3.7183521547252607`*^9}, {3.718352220156172*^9, 
   3.7183522301550083`*^9}, {3.718387702908506*^9, 3.718387729894586*^9}, 
   3.718414568239217*^9},
 CellLabel->"In[57]:=",ExpressionUUID->"ac1ab41c-b09a-4ff0-8b7c-bc03d8c7efb3"]
}, Closed]],

Cell[CellGroupData[{

Cell["New Body Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.9156531962488685`*^9, 
  3.91565319727267*^9}},ExpressionUUID->"1e0265c9-7f1d-4b15-a2ef-\
11a1269b45f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewBodySprings", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Define New Body Spring\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "spring", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newbspr", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "0", ",", "0.", ",", "\"\<\>\"", ",", "1000."}],
           "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newbspr$comment", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"temp$newbspr", "/.", 
             RowBox[{
              RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
              "\"\<\>\""}]}], "/.", 
            RowBox[{"True", "\[Rule]", "\"\<\>\""}]}], "/.", 
           RowBox[{"False", "\[Rule]", "\"\<\>\""}]}], "/.", 
          RowBox[{
           RowBox[{"x_", "?", "StringQ"}], "\[Rule]", "\"\<\>\""}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Spring Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"OpenerView", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr$comment", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr$comment", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}], "\[NotEqual]", 
             "\"\<\>\""}], ",", 
            RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
           "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"SP", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Linking Bodies\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Upper body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Lower body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"OpenerView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr$comment", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
                RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr$comment", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "\"\<\>\""}], ",", 
               RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
              "]"}]}]}], "]"}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Prestress", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness & Prestress\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate by load\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "\[IndentingNewLine]", "mod$CalcBSprStiff", 
         ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Stiffness:\>\"", ",", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<N/m\>\""}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Prestress:\>\"", ",", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<N\>\""}], "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Spring", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$bspr", ",", "temp$newbspr"}], "]"}], ";", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$bspr$comments", ",", "temp$newbspr$comment"}], 
                "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "550"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Body Springs\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.570257067213022*^9, 
   3.570257068086624*^9}, {3.570257105261489*^9, 3.57025710533949*^9}, {
   3.5702573125858536`*^9, 3.570257336999896*^9}, {3.570257458024909*^9, 
   3.5702574580717087`*^9}, {3.5702580709989862`*^9, 
   3.5702580875506153`*^9}, {3.5702582550335093`*^9, 3.5702582593079166`*^9}, 
   3.570258291365973*^9, 3.570258355528886*^9, {3.570304447263814*^9, 
   3.570304447391821*^9}, {3.5706390399486904`*^9, 3.5706391762724876`*^9}, {
   3.570639328539197*^9, 3.5706395632336206`*^9}, {3.5706396124144335`*^9, 
   3.570639663527357*^9}, {3.5706397247278576`*^9, 3.5706397343694086`*^9}, {
   3.5706398445457106`*^9, 3.5706398470598545`*^9}, {3.5706400506705003`*^9, 
   3.570640052520606*^9}, {3.717787939387054*^9, 3.71778803080227*^9}, {
   3.717788190270791*^9, 3.717788309947618*^9}, {3.717788372232687*^9, 
   3.717788402934331*^9}, {3.717788432947249*^9, 3.71778848466883*^9}, {
   3.7177885654099503`*^9, 3.7177885861978197`*^9}, {3.7177886411663027`*^9, 
   3.717788649370262*^9}, {3.7177887053317842`*^9, 3.7177887620557213`*^9}, {
   3.7177888001644163`*^9, 3.7177888223686857`*^9}, {3.71778896018932*^9, 
   3.717788961452676*^9}, {3.717789033045116*^9, 3.717789037933939*^9}, {
   3.7177892326371613`*^9, 3.717789233954543*^9}, {3.717789264226914*^9, 
   3.7177893103199587`*^9}, {3.7177893767419767`*^9, 3.717789394396644*^9}, {
   3.717789426414238*^9, 3.71778943251462*^9}, {3.717789502824121*^9, 
   3.717789511323758*^9}, {3.717789610591189*^9, 3.717789614961069*^9}, 
   3.7177897740155373`*^9, {3.718352081444909*^9, 3.7183521097880096`*^9}, {
   3.718352142841688*^9, 3.7183521547252607`*^9}, {3.718352220156172*^9, 
   3.7183522301550083`*^9}, {3.718387702908506*^9, 3.718387729894586*^9}, 
   3.718414568239217*^9, {3.9156532009414454`*^9, 3.915653268828719*^9}, 
   3.91565333334158*^9, {3.9156534979636574`*^9, 3.915653498541345*^9}, 
   3.9156535315750017`*^9, {3.9156536026949253`*^9, 3.9156536337272573`*^9}, {
   3.9156537713081417`*^9, 3.915653815307395*^9}, {3.9156538473800707`*^9, 
   3.9156538498720117`*^9}, {3.915653884074549*^9, 3.9156539033630953`*^9}, {
   3.9156559331799035`*^9, 3.9156559492385263`*^9}, 3.9156561148276825`*^9, {
   3.9156563335136557`*^9, 3.915656375019107*^9}, 3.915662235626543*^9, {
   3.9156622662334785`*^9, 3.915662268282201*^9}, {3.915662667471455*^9, 
   3.9156627235205765`*^9}, {3.915663870275416*^9, 3.9156638919027033`*^9}, {
   3.915663936470886*^9, 3.91566396173468*^9}, {3.915852425447437*^9, 
   3.9158524369986467`*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"ec75003a-ec58-4c01-9c49-ae6fceb3fce5"]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Wire Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.585716469899131*^9, 
  3.585716470346156*^9}, {3.9157528868887725`*^9, 
  3.9157528877044735`*^9}},ExpressionUUID->"1ecdc448-7f42-4b9d-a844-\
32b9fcbad528"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditVertSprings", "[", "nw_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Edit Vertical Spring\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "spring", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newvspr", "=", 
         RowBox[{"temp$vspr", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newvspr$comment", "=", 
         RowBox[{"temp$vspr$comments", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Spring Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"OpenerView", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr$comment", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr$comment", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], "\[NotEqual]", 
             "\"\<\>\""}], ",", 
            RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
           "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"SP", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose wire suspension point where spring is inserted.\>\"", 
           ",", "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "13"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], 
              "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<Upper SP\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Lower SP\>\""}]}], "}"}]}], 
            "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Prestress", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness & Prestress\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from wire tension & resonant frequency\>\"", ",", 
           "Bold", ",", "Black", ",", "Small"}], "]"}], ",", 
         "\[IndentingNewLine]", "mod$CalcSprStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Stiffness:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Prestress:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"InputField", "[", 
           RowBox[{
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], ",", "Number", ",", 
            RowBox[{"FieldSize", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], "}"}], "}"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", "Percussion", " ", 
          RowBox[{"Effect", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Effect\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.7", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "5", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
           "\"\<dB\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Working"}]}], " ", 
          RowBox[{"Direction", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Working Direction\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"m", "=", "m"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", 
                  RowBox[{"7", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], ",", 
             "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Spring", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$vspr", "[", 
                 RowBox[{"[", "nw", "]"}], "]"}], "=", "temp$newvspr"}], ";", 
               RowBox[{
                RowBox[{"temp$vspr$comments", "[", 
                 RowBox[{"[", "nw", "]"}], "]"}], "=", 
                "temp$newvspr$comment"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Vertical Springs\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.570257067213022*^9, 
   3.570257068086624*^9}, {3.570257105261489*^9, 3.57025710533949*^9}, {
   3.5702573125858536`*^9, 3.570257336999896*^9}, {3.570257458024909*^9, 
   3.5702574580717087`*^9}, {3.5702580709989862`*^9, 
   3.5702580875506153`*^9}, {3.5702582550335093`*^9, 3.5702582593079166`*^9}, 
   3.570258291365973*^9, 3.570258355528886*^9, {3.570304447263814*^9, 
   3.570304447391821*^9}, {3.5706390399486904`*^9, 3.5706391762724876`*^9}, {
   3.570639328539197*^9, 3.5706395632336206`*^9}, {3.5706396124144335`*^9, 
   3.570639663527357*^9}, {3.5706397247278576`*^9, 3.5706397343694086`*^9}, {
   3.5706398445457106`*^9, 3.5706398470598545`*^9}, {3.5706400506705003`*^9, 
   3.570640052520606*^9}, {3.5857164750984282`*^9, 3.585716526430364*^9}, {
   3.7183522876812696`*^9, 3.7183522989279337`*^9}, {3.718352359589047*^9, 
   3.7183524157620068`*^9}, 3.718352668215143*^9, {3.718352776832547*^9, 
   3.7183527773970957`*^9}, {3.718352873466457*^9, 3.71835287431635*^9}, {
   3.718352945420343*^9, 3.718352948489361*^9}, {3.718353012294263*^9, 
   3.718353034415903*^9}, {3.718387636720849*^9, 3.7183876711272078`*^9}, {
   3.915656301207374*^9, 3.9156563082290945`*^9}, 3.9156563483243637`*^9},
 CellLabel->"In[59]:=",ExpressionUUID->"a17d2261-5b03-4aec-948f-998420cbdc71"]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Body Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.585716469899131*^9, 
  3.585716470346156*^9}, {3.9157528818797674`*^9, 
  3.915752883208035*^9}},ExpressionUUID->"50edf168-8498-4568-9cd8-\
ec380f89f5bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditBodySprings", "[", "nw_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Edit Body Spring\>\"", ",", "\[IndentingNewLine]", "Bold", ",",
            "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "spring", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newbspr", "=", 
         RowBox[{"temp$bspr", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newbspr$comment", " ", "=", " ", 
         RowBox[{"temp$bspr$comments", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Spring Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"OpenerView", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr$comment", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr$comment", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}], "\[NotEqual]", 
             "\"\<\>\""}], ",", 
            RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
           "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"SP", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Linking Bodies\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Upper body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Lower body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newbspr", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"OpenerView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr$comment", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
                RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr$comment", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "\"\<\>\""}], ",", 
               RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
              "]"}]}]}], "]"}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Prestress", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness & Prestress\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate by load\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "\[IndentingNewLine]", "mod$CalcBSprStiff", 
         ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Stiffness:\>\"", ",", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<N/m\>\""}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Prestress:\>\"", ",", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newbspr$comment", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<N\>\""}], "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Spring", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$bspr", "[", 
                 RowBox[{"[", "nw", "]"}], "]"}], "=", "temp$newbspr"}], ";", 
               RowBox[{
                RowBox[{"temp$bspr$comments", "[", 
                 RowBox[{"[", "nw", "]"}], "]"}], " ", "=", " ", 
                "temp$newbspr$comment"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "550"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Edit Body Springs\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.570257067213022*^9, 
   3.570257068086624*^9}, {3.570257105261489*^9, 3.57025710533949*^9}, {
   3.5702573125858536`*^9, 3.570257336999896*^9}, {3.570257458024909*^9, 
   3.5702574580717087`*^9}, {3.5702580709989862`*^9, 
   3.5702580875506153`*^9}, {3.5702582550335093`*^9, 3.5702582593079166`*^9}, 
   3.570258291365973*^9, 3.570258355528886*^9, {3.570304447263814*^9, 
   3.570304447391821*^9}, {3.5706390399486904`*^9, 3.5706391762724876`*^9}, {
   3.570639328539197*^9, 3.5706395632336206`*^9}, {3.5706396124144335`*^9, 
   3.570639663527357*^9}, {3.5706397247278576`*^9, 3.5706397343694086`*^9}, {
   3.5706398445457106`*^9, 3.5706398470598545`*^9}, {3.5706400506705003`*^9, 
   3.570640052520606*^9}, {3.5857164750984282`*^9, 3.585716526430364*^9}, {
   3.7183522876812696`*^9, 3.7183522989279337`*^9}, {3.718352359589047*^9, 
   3.7183524157620068`*^9}, 3.718352668215143*^9, {3.718352776832547*^9, 
   3.7183527773970957`*^9}, {3.718352873466457*^9, 3.71835287431635*^9}, {
   3.718352945420343*^9, 3.718352948489361*^9}, {3.718353012294263*^9, 
   3.718353034415903*^9}, {3.718387636720849*^9, 3.7183876711272078`*^9}, {
   3.915656301207374*^9, 3.9156563082290945`*^9}, 3.9156563483243637`*^9, {
   3.9157528921477795`*^9, 3.9157528925798635`*^9}, {3.9158521938987074`*^9, 
   3.915852202324572*^9}, 3.915852332822173*^9, {3.9167755406466293`*^9, 
   3.9167755561471825`*^9}, {3.9167755915589013`*^9, 3.916775622652296*^9}, {
   3.9167756815439005`*^9, 
   3.9167757487583523`*^9}},ExpressionUUID->"85c94835-0e4d-458f-9dd3-\
d0ea7b8b3c69"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Wire Spring Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.9156560657845736`*^9, 
  3.9156560684161034`*^9}},ExpressionUUID->"2028f3bd-414e-454e-bbde-\
4540f454d60d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcSprStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Input Resonant Frequency:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Frequency", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$vsprfreq", "=", "0."}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", "temp$vsprfreq", "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "10"}], "]"}], "]"}],
                    "/", "g"}], ")"}], "*", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$vsprfreq"}], 
                   ")"}], "^", "2"}]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "=", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "10"}], "]"}], 
                 "]"}]}], ";"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "200"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", 
      "\"\<Calculate Stiffness and Prestress\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5708944426245155`*^9, 3.5708944428045263`*^9}, {3.5708945682186995`*^9, 
   3.5708945769291973`*^9}},
 CellLabel->"In[61]:=",ExpressionUUID->"5a2376b1-4317-462d-8b04-8793257d0347"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Body Spring Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.9156560657845736`*^9, 
  3.9156560813682723`*^9}},ExpressionUUID->"976899fb-d5fc-4241-8e4d-\
01f912bd67c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcBSprStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Input Resonant Frequency:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Frequency", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$bsprfreq", "=", "0."}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", "temp$bsprfreq", "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"OpenerView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr$comment", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
                RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newbspr$comment", "[", 
                  RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "\"\<\>\""}], ",", 
               RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
              "]"}]}]}], "]"}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Check"}]}], " ", "List", " ", "for", " ", 
          RowBox[{"Calculation", "--"}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Supporting Masses:\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$bsprbodies", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "1", ",", 
             RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Checkbox", "[", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bsprbodies", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                ",", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Total Mass:\>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"temp$bsprbodies", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{"save$mass", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
            "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Initial"}]}], " ", 
          RowBox[{"Elongation", "--"}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$bsprInitialL", "=", 
         RowBox[{
          RowBox[{"save$initpos", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"temp$newbspr", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"save$initpos", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"temp$newbspr", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Calculator", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Projection:\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Black", ",", "Italic"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<K Constant: \>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Sum", "[", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$bsprbodies", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                  "]"}], "*", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$bsprfreq"}], 
                   ")"}], "^", "2"}]}], ")"}], "-", "g"}], ")"}], "/", 
             RowBox[{"N", "[", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "/", 
                   RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "6", "]"}], "]"}]}], ")"}], "^", "2"}]}], 
               ")"}], "]"}]}], "]"}], ",", "\"\<N/m\>\""}], "}"}], "}"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Q: \>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"temp$newbspr", "[", 
             RowBox[{"[", "6", "]"}], "]"}], "]"}]}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Preload: \>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"temp$bsprbodies", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", 
                  RowBox[{"save$mass", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
              "*", 
              RowBox[{"-", "g"}]}], "+", 
             RowBox[{"(", 
              RowBox[{"temp$bsprInitialL", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$bsprbodies", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}], "*", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$bsprfreq"}], 
                    ")"}], "^", "2"}]}], ")"}], "-", "g"}], ")"}], "/", 
                RowBox[{"N", "[", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", 
                    RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "6", "]"}], "]"}]}], ")"}], "^", "2"}]}], 
                  ")"}], "]"}]}]}], ")"}]}], "]"}], ",", "\"\<N\>\""}], "}"}],
          "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newbspr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$bsprbodies", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}], "*", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$bsprfreq"}], 
                    ")"}], "^", "2"}]}], ")"}], "-", "g"}], ")"}], "/", 
                 RowBox[{"N", "[", 
                  RowBox[{"(", 
                   RowBox[{"1", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", 
                    RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "6", "]"}], "]"}]}], ")"}], "^", "2"}]}], 
                   ")"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"temp$newbspr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Sum", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$bsprbodies", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                   "]"}], "*", 
                  RowBox[{"-", "g"}]}], "+", 
                 RowBox[{"(", 
                  RowBox[{"temp$bsprInitialL", "*", 
                   RowBox[{"temp$newbspr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}]}], ";"}], 
              "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "450"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", 
      "\"\<Calculate Stiffness and Prestress\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5708944426245155`*^9, 3.5708944428045263`*^9}, {3.5708945682186995`*^9, 
   3.5708945769291973`*^9}, 3.9156560906494303`*^9, {3.9156561707457376`*^9, 
   3.9156562128490057`*^9}, {3.9156565874160643`*^9, 3.915656587843341*^9}, {
   3.9156566469149446`*^9, 3.9156566473951554`*^9}, {3.91565676841698*^9, 
   3.9156568167282486`*^9}, {3.9156568888120155`*^9, 
   3.9156568931220446`*^9}, {3.915657042585457*^9, 3.9156570546671276`*^9}, {
   3.9156571188985577`*^9, 3.915657120313661*^9}, {3.9156575286139565`*^9, 
   3.915657564959795*^9}, {3.9156577309826775`*^9, 3.9156577969623566`*^9}, {
   3.9156580648839436`*^9, 3.9156580649968963`*^9}, {3.9156581147637105`*^9, 
   3.9156581578142967`*^9}, {3.9156583565427456`*^9, 3.915658441016223*^9}, {
   3.9156624408568473`*^9, 3.915662550230917*^9}, {3.9156627437120485`*^9, 
   3.91566277904755*^9}, {3.9156628118361464`*^9, 3.9156628266232576`*^9}, 
   3.9156628572542925`*^9, {3.9156629180221024`*^9, 3.9156630037209687`*^9}, {
   3.9156630388250957`*^9, 3.9156630414090843`*^9}, {3.9156631147909575`*^9, 
   3.9156631623729773`*^9}, {3.915663204538931*^9, 3.9156632046532536`*^9}, {
   3.9156632946537447`*^9, 3.9156633022795134`*^9}, {3.915663414091468*^9, 
   3.915663417269637*^9}, {3.9156634658827977`*^9, 3.9156634956473565`*^9}, {
   3.9156636957667212`*^9, 3.9156637213420706`*^9}, {3.91566375920175*^9, 
   3.9156637593000917`*^9}, {3.9156638329005246`*^9, 3.915663848982462*^9}, {
   3.9157550222967577`*^9, 3.9157550319764967`*^9}, {3.915756745413066*^9, 
   3.915756748477095*^9}, {3.9158503035933065`*^9, 3.9158503425534997`*^9}, {
   3.915850512649356*^9, 3.915850528249296*^9}, {3.9158507287314825`*^9, 
   3.9158508009513445`*^9}, {3.9158515636703854`*^9, 3.915851571558201*^9}, {
   3.9158517526301193`*^9, 3.915851754629899*^9}, {3.9158522298210044`*^9, 
   3.915852230198302*^9}, 3.915852464009728*^9, {3.915852545576479*^9, 
   3.9158525782209353`*^9}, {3.9158526133387575`*^9, 3.915852673479328*^9}, {
   3.9158528800568967`*^9, 3.91585289133985*^9}, {3.9158530835464954`*^9, 
   3.915853121283382*^9}, 3.9158531654531717`*^9, {3.915853266267126*^9, 
   3.915853269835416*^9}, {3.9158533124869113`*^9, 3.9158533157430134`*^9}, {
   3.9158535323079543`*^9, 3.915853536399662*^9}, {3.9158536077613964`*^9, 
   3.9158536105793962`*^9}},
 CellLabel->"In[62]:=",ExpressionUUID->"b3395ac4-890a-4f13-a34d-2a8be6c56673"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2-3 Define Inverted Pendulum", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570215637850922*^9, 3.5702156458273783`*^9}, {
   3.5710350529959507`*^9, 3.5710350559881215`*^9}, 
   3.718415121572781*^9},ExpressionUUID->"6c2330de-2d9e-4905-b56f-\
d1138430cd9d"],

Cell[CellGroupData[{

Cell["Define Inverted Pendulum", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
   3.570194453170987*^9, 3.570194456945203*^9}, {3.5710350690668697`*^9, 
   3.5710350719820366`*^9}, 
   3.718415122926577*^9},ExpressionUUID->"3c70cc0e-c564-4c20-aa6d-\
0e973b7de3cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DefineIP", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been", 
        " ", "set", " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Define bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**"}], "*", "Version", " ", "1.1"}], "**"}], "**"}], 
                  "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
           "**"}], "**"}], "**"}], "**"}], "**", "**", "**"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "IP", " ", "Version", " ", "1.0", " ", "Compliance", " ", "Check"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "3"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "0"}], "]"}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "3"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "1000"}], "]"}]}], 
          "]"}], ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
        "*", "Version", " ", 
        RowBox[{
        "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
          "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TextCell", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Define Inverted Pendulum\>\"", ",", "\[IndentingNewLine]", 
              "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "New"}]}], " ", "Wire", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Button", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Create New IP\>\"", ",", "Bold", ",", "White"}], 
             "]"}], ",", "mod$NewIP", ",", "\[IndentingNewLine]", 
            RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
            RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Load"}]}], " ", 
             RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", 
             RowBox[{"temp$IP", "=", "save$IP"}], ",", 
             RowBox[{"temp$IP", "=", 
              RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ValueQ", "[", "save$IP$comments", "]"}], ",", 
             RowBox[{"temp$IP$comments", "=", "save$IP$comments"}], ",", 
             RowBox[{"temp$IP$comments", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"save$IP", "/.", 
                 RowBox[{
                  RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
                  "\"\<\>\""}]}], "/.", 
                RowBox[{"True", "\[Rule]", "\"\<\>\""}]}], "/.", 
               RowBox[{"False", "\[Rule]", "\"\<\>\""}]}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Input"}]}], " ", "Field", " ", 
              RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"TableForm", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$IP", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$IP", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                    RowBox[{"temp$IP$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$IP$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$IP", ",", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$IP$comments", ",", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"mod$EditIP", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", "Name", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{"Base", ",", " ", "Top"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "IP"}]}], " ", 
                    RowBox[{"Position", "--"}]}], "-"}], "*)"}], 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "1", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "1", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "3", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "3", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "3", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "3", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "3", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "3", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
                    RowBox[{"Q", "--"}]}], "-"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "4"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "4"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "4"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "4"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "4"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "4"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "IP"}]}], " ", 
                    RowBox[{"Length", "--"}]}], "-"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Load"}]}], " ", 
                    RowBox[{"Mass", "--"}]}], "-"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Center"}]}], " ", "of", " ", 
                    RowBox[{"Percussion", "--"}]}], "-"}], "*)"}], 
                  RowBox[{"OpenerView", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Checkbox", "[", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "11"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Checkbox", "[", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "temp$IP", "]"}]}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"TableHeadings", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"None", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", 
                   "\"\<Edit\>\"", ",", "\"\<Name\>\"", ",", "\"\<Base\>\"", 
                   ",", "\"\<Top\>\"", ",", "\"\<Leg 1\\nX Pos\\n[m]\>\"", 
                   ",", "\"\<Leg 1\\nZ Pos\\n[m]\>\"", ",", 
                   "\"\<Leg 2\\nX Pos\\n[m]\>\"", ",", 
                   "\"\<Leg 2\\nZ Pos\\n[m]\>\"", ",", 
                   "\"\<Leg 3\\nX Pos\\n[m]\>\"", ",", 
                   "\"\<Leg 3\\nZ Pos\\n[m]\>\"", ",", 
                   "\"\<Leg 1\\nStiffness\\n[N/m]\>\"", ",", 
                   "\"\<Leg 1\\nQ\>\"", ",", 
                   "\"\<Leg 2\\nStiffness\\n[N/m]\>\"", ",", 
                   "\"\<Leg 2\\nQ\>\"", ",", 
                   "\"\<Leg 3\\nStiffness\\n[N/m]\>\"", ",", 
                   "\"\<Leg 3\\nQ\>\"", ",", 
                   "\"\<Torsional\\nStiffness\\n[N.m/rad]\>\"", ",", 
                   "\"\<Torsional\\nQ\>\"", ",", "\"\<L\\n[m]\>\"", ",", 
                   "\"\<CoP\\n[dB]\>\"", ",", " ", "\"\<CoP\\nEnabled?\>\"", 
                   ",", "\"\<m\\n[kg]\>\"", ",", 
                   "\"\<Over-\\ncompensated?\>\""}], "}"}]}], "}"}]}]}], 
             "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{"{", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                RowBox[{"DialogReturn", "[", 
                 RowBox[{
                  RowBox[{"save$IP", "=", "temp$IP"}], ";", 
                  RowBox[{"save$IP$comments", "=", "temp$IP$comments"}]}], 
                 "]"}]}], "]"}], ",", 
              RowBox[{"(*", 
               RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{"\"\<Cancel\>\"", ",", 
                RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
           "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
           RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"WindowElements", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
           ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"WindowSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"800", ",", "500"}], "}"}]}], ",", 
        RowBox[{
        "WindowTitle", "\[Rule]", "\"\<2-3 Define Inverted Pendulum\>\""}]}], 
       "]"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570639937864048*^9, 3.570639940941224*^9}, {
   3.5706399846197224`*^9, 3.570640066998434*^9}, {3.571035062835513*^9, 
   3.571035081401575*^9}, {3.571045391606285*^9, 3.5710454254622216`*^9}, {
   3.5710454688907056`*^9, 3.5710454744880257`*^9}, 3.571045802349778*^9, {
   3.5710473240858164`*^9, 3.571047330661193*^9}, {3.571056270684533*^9, 
   3.5710562854593782`*^9}, {3.5710565989893107`*^9, 
   3.5710565992563257`*^9}, {3.5710566496692095`*^9, 
   3.5710566812840176`*^9}, {3.57105699148076*^9, 3.571057098058856*^9}, {
   3.5710571303557034`*^9, 3.571057135050972*^9}, 3.571057222135953*^9, {
   3.571068309269725*^9, 3.5710683095757427`*^9}, {3.5710685449712067`*^9, 
   3.5710685453672295`*^9}, {3.5856292398592105`*^9, 3.585629276548309*^9}, {
   3.716935910078233*^9, 3.7169359785265093`*^9}, {3.7169360640732737`*^9, 
   3.716936145422262*^9}, {3.716936190829439*^9, 3.716936208065063*^9}, {
   3.716936249262907*^9, 3.7169364344713163`*^9}, {3.716936552234325*^9, 
   3.716936566972351*^9}, {3.716936713727077*^9, 3.716936756225165*^9}, {
   3.716936794171389*^9, 3.716936801426347*^9}, {3.716937022274173*^9, 
   3.71693703073621*^9}, {3.7169370615722733`*^9, 3.716937142278813*^9}, {
   3.716937267529606*^9, 3.7169372925787983`*^9}, {3.716937365725295*^9, 
   3.716937371871583*^9}, {3.7169374338774557`*^9, 3.71693760598099*^9}, {
   3.716937644884798*^9, 3.716937715332445*^9}, {3.716937803141472*^9, 
   3.7169378252833242`*^9}, {3.7169378563305387`*^9, 
   3.7169378594855747`*^9}, {3.716937892390489*^9, 3.716937906331505*^9}, {
   3.7169384100769367`*^9, 3.716938440832755*^9}, {3.716938506025577*^9, 
   3.7169385316337442`*^9}, {3.716944087888425*^9, 3.716944306471389*^9}, {
   3.7169443708274193`*^9, 3.7169443848804207`*^9}, {3.716944466574996*^9, 
   3.716944518883934*^9}, {3.716944607879992*^9, 3.716944618045618*^9}, {
   3.7169448843862762`*^9, 3.716944932413034*^9}, {3.716944983076655*^9, 
   3.716945002743085*^9}, {3.716945054569809*^9, 3.716945133448414*^9}, 
   3.7169531284094553`*^9, {3.7169571131937*^9, 3.7169571406260366`*^9}, 
   3.7169571765901423`*^9, 3.716957215236801*^9, {3.716957495426263*^9, 
   3.7169574988707857`*^9}, 3.7169582894107533`*^9, {3.7169583212327833`*^9, 
   3.7169583576588583`*^9}, 3.718388605172275*^9, {3.71838872312506*^9, 
   3.718388741771146*^9}, {3.7183888109909678`*^9, 3.718388880999427*^9}, 
   3.7183889266619864`*^9, {3.7183893516268787`*^9, 3.71838935361627*^9}, 
   3.718414569497984*^9, {3.718415123921999*^9, 3.7184151336537733`*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"0109c600-7926-432c-8814-1be7a00009e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New Inverted Pendulum", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5710454850606303`*^9, 
  3.5710454894878836`*^9}},ExpressionUUID->"c510a6bd-07d4-4dc0-a185-\
08bd957ba6f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewIP", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Define New Inverted Pendulum\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "IP", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newIP", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0.6", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "0.3"}], ",", 
               RowBox[{"-", "0.5196"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "0.3"}], ",", "0.5196"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"200.", ",", "200.", ",", "200.", ",", "200"}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"10", ",", "10", ",", "10", ",", "1000"}], "}"}], ",", 
           "\"\<IP\>\"", ",", "0.5", ",", 
           RowBox[{"-", "80"}], ",", "False", ",", "0", ",", "True"}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newIP$comment", "=", 
         RowBox[{"{", 
          RowBox[{"\"\<\>\"", ",", "\"\<\>\"", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\""}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\""}], 
            "}"}], ",", "\"\<IP\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
           "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<IP Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"OpenerView", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP$comment", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP$comment", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
             "\"\<\>\""}], ",", 
            RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
           "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose Base and Top Bodies\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Base:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Top:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Position of IPs in Horizontal Plane\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "\[IndentingNewLine]", "mod$CalcIPPosition",
          ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<x [mm]\>\"", ",", "\"\<z [mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Length", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Length of IP Legs\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", "mm"}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
                 "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "]"}], "\[NotEqual]", 
                 "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", "\"\<mm\>\""}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Load"}]}], " ", 
          RowBox[{"Mass", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Load Mass\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Suspended Bodies\>\"", ",", "Bold", ",", 
           "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPLoad", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "]"}], "\[NotEqual]", 
                 "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Q", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Effective Stiffness and Quality Factor\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate stiffness from Resonant Frequency\>\"", ",", "Bold", 
           ",", "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [N/m]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Additional yaw stiffness due to Rigidity of flexures\>\"", ",", 
          "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], "]"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<Torsion\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [Nm/rad]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", 
          RowBox[{"Percussion", "--"}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Level\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "11", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Enabled", "\[Rule]", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", "11", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "8", "]"}], "]"}], "]"}], "\[NotEqual]", 
                 "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", "\"\<dB\>\""}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Overcompensated\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$IP", ",", "temp$newIP"}], "]"}], ";", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$IP$comments", ",", "temp$newIP$comment"}], 
                "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Inverted Pendulum\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.5706401048015966`*^9, 
   3.5706401766677065`*^9}, {3.5710455010475445`*^9, 3.571045504552745*^9}, {
   3.571045537467628*^9, 3.571045632391057*^9}, {3.5710457065923014`*^9, 
   3.5710457432123957`*^9}, {3.5710457896870537`*^9, 
   3.5710458175426474`*^9}, {3.571045915252236*^9, 3.571045915634258*^9}, {
   3.571046012502798*^9, 3.5710460188541613`*^9}, {3.5710461035330048`*^9, 
   3.571046514466509*^9}, {3.571046593708041*^9, 3.571046701472205*^9}, {
   3.571046765961894*^9, 3.571046817363834*^9}, {3.571047211076353*^9, 
   3.5710472312935095`*^9}, {3.5710473842602587`*^9, 
   3.5710474876071696`*^9}, {3.5710566211845803`*^9, 3.571056622034629*^9}, {
   3.571056705057378*^9, 3.571056853447865*^9}, {3.571056912616249*^9, 
   3.5710569541276236`*^9}, {3.5710571978635645`*^9, 3.57105720214981*^9}, {
   3.571057256293906*^9, 3.571057269396656*^9}, {3.571057355683591*^9, 
   3.5710573571766768`*^9}, {3.571059003708853*^9, 3.571059019032729*^9}, {
   3.5710590654043818`*^9, 3.571059095044077*^9}, {3.5710666867139206`*^9, 
   3.57106682150163*^9}, {3.5710668572016716`*^9, 3.5710669047093887`*^9}, {
   3.571066985215994*^9, 3.571066985458008*^9}, {3.571068136920868*^9, 
   3.5710681379319253`*^9}, {3.5710682432339487`*^9, 
   3.5710682450170507`*^9}, {3.5787834301089115`*^9, 
   3.5787835401172037`*^9}, {3.5787836620111756`*^9, 3.5787836628782253`*^9}, 
   3.578784074909792*^9, {3.5787841199163666`*^9, 3.57878412120444*^9}, {
   3.578784620979026*^9, 3.578784622122091*^9}, {3.585629184398038*^9, 
   3.585629196382724*^9}, 3.585629228257547*^9, {3.716942923626069*^9, 
   3.716942926576014*^9}, {3.716951766915238*^9, 3.7169517855641937`*^9}, {
   3.716951835751203*^9, 3.716951852398788*^9}, {3.716952282704323*^9, 
   3.7169524584062157`*^9}, {3.7169528106872387`*^9, 3.716952832886814*^9}, {
   3.716952870148205*^9, 3.716952958140565*^9}, 3.7169530200355473`*^9, {
   3.71695323274151*^9, 3.716953269492182*^9}, {3.7169536239144783`*^9, 
   3.716953682199395*^9}, {3.716953785686572*^9, 3.716953865635577*^9}, {
   3.716958025024138*^9, 3.716958028490527*^9}, {3.7183894239556713`*^9, 
   3.718389485635429*^9}, {3.718389537373478*^9, 3.718389543982774*^9}, 
   3.7184145702123337`*^9},
 CellLabel->"In[64]:=",ExpressionUUID->"12dc3dfc-7bda-4118-89bb-2f5b663a9554"]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Inverted Pendulum", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5710454850606303`*^9, 3.5710454894878836`*^9}, {
  3.571066926284623*^9, 
  3.5710669278997154`*^9}},ExpressionUUID->"72ce328e-aaca-404c-a4fe-\
3d1a6b69b4ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditIP", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Edit Inverted Pendulum\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "IP", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newIP", "=", 
         RowBox[{"temp$IP", "[", 
          RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$newIP$comment", "=", 
         RowBox[{"temp$IP$comments", "[", 
          RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<IP Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"OpenerView", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP$comment", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP$comment", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
             "\"\<\>\""}], ",", 
            RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
           "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose Base and Top Bodies\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Base:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Top:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Position of IPs in Horizontal Plane\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "\[IndentingNewLine]", "mod$CalcIPPosition",
          ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<x [mm]\>\"", ",", "\"\<z [mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Length", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Length of IP Legs\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"OpenerView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", "mm"}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
                "Number", ",", 
                RowBox[{"FieldSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
              RowBox[{"InputField", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newIP$comment", "[", 
                  RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "String", ",", 
                RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newIP$comment", "[", 
                  RowBox[{"[", "7", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "\"\<\>\""}], ",", 
               RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
              "]"}]}]}], "]"}], ",", "\"\<mm\>\""}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Load"}]}], " ", 
          RowBox[{"Mass", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Load Mass\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Suspended Bodies\>\"", ",", "Bold", ",", 
           "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPLoad", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "]"}], "\[NotEqual]", 
                 "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Q", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Effective Stiffness and Quality Factor\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate stiffness from Resonant Frequency\>\"", ",", "Bold", 
           ",", "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [N/m]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Additional yaw stiffness due to Rigidity of flexures\>\"", ",", 
          "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], "]"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"OpenerView", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                "}"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newIP$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                   "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                 "]"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<Torsion\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [Nm/rad]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", 
          RowBox[{"Percussion", "--"}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Level\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "11", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"OpenerView", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Enabled", "\[Rule]", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", "11", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP$comment", "[", 
                   RowBox[{"[", "8", "]"}], "]"}], "]"}], "\[NotEqual]", 
                 "\"\<\>\""}], ",", 
                RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
               "]"}]}]}], "]"}], ",", "\"\<dB\>\""}], "}"}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Overcompensated\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<OK\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$IP", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "=", "temp$newIP"}], ";", 
               RowBox[{
                RowBox[{"temp$IP$comments", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "=", 
                "temp$newIP$comment"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Edit Inverted Pendulum\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.5706401048015966`*^9, 
   3.5706401766677065`*^9}, {3.5710455010475445`*^9, 3.571045504552745*^9}, {
   3.571045537467628*^9, 3.571045632391057*^9}, {3.5710457065923014`*^9, 
   3.5710457432123957`*^9}, {3.5710457896870537`*^9, 
   3.5710458175426474`*^9}, {3.571045915252236*^9, 3.571045915634258*^9}, {
   3.571046012502798*^9, 3.5710460188541613`*^9}, {3.5710461035330048`*^9, 
   3.571046514466509*^9}, {3.571046593708041*^9, 3.571046701472205*^9}, {
   3.571046765961894*^9, 3.571046817363834*^9}, {3.571047211076353*^9, 
   3.5710472312935095`*^9}, {3.5710473842602587`*^9, 
   3.5710474876071696`*^9}, {3.5710566211845803`*^9, 3.571056622034629*^9}, {
   3.571056705057378*^9, 3.571056853447865*^9}, {3.571056912616249*^9, 
   3.5710569541276236`*^9}, {3.5710571978635645`*^9, 3.57105720214981*^9}, {
   3.571057256293906*^9, 3.571057269396656*^9}, {3.571057355683591*^9, 
   3.5710573571766768`*^9}, {3.571059003708853*^9, 3.571059019032729*^9}, {
   3.5710590654043818`*^9, 3.571059095044077*^9}, {3.5710666867139206`*^9, 
   3.57106682150163*^9}, {3.5710668572016716`*^9, 3.5710669605405827`*^9}, {
   3.5710669926974216`*^9, 3.571067001900948*^9}, {3.5710672927315826`*^9, 
   3.571067294191666*^9}, {3.5710685773790607`*^9, 3.5710685854395213`*^9}, {
   3.5787841342511864`*^9, 3.5787841378533926`*^9}, {3.5856291448397756`*^9, 
   3.5856291676760817`*^9}, {3.716951700750017*^9, 3.716951743398347*^9}, 
   3.716952709208112*^9, 3.716957081478323*^9, 3.71695740030136*^9, {
   3.7169574349335117`*^9, 3.716957452598297*^9}, {3.716958044474367*^9, 
   3.716958048844591*^9}, {3.71695843822682*^9, 3.716958473680751*^9}, {
   3.718389568784514*^9, 3.718389582695009*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"3d19274f-4c29-4993-9743-023c30e91004"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate IP Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.57106795077122*^9, 
  3.571067950930229*^9}},ExpressionUUID->"4808038a-0a26-4acc-aca3-\
9a912f7223c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcIPPosition", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$IPpos", "=", 
         RowBox[{"{", 
          RowBox[{"0.6", ",", "0."}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<Radial Distance from Base Body's CoM:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$IPpos", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "/", "mm"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<mm\>\""}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Rotation Angle in Horizontal Plane from x-axis:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$IPpos", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "/", "deg"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "deg"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<deg\>\""}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newIP", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Delete", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"mod$SP3wire", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", "2"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "300"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Calculate IP Position\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.57028983359796*^9, 3.5702898337029657`*^9}, {
   3.570289895278488*^9, 3.5702898978016324`*^9}, {3.5702928826503563`*^9, 
   3.570292894817052*^9}, {3.5702929952027936`*^9, 3.570292995829829*^9}, {
   3.5702930771094785`*^9, 3.5702931366238823`*^9}, {3.5710670353478613`*^9, 
   3.571067194359956*^9}, {3.57106723498728*^9, 3.5710672534473352`*^9}, {
   3.571067350858907*^9, 3.5710673791475253`*^9}, 3.57106817122783*^9},
 CellLabel->"In[66]:=",ExpressionUUID->"d784b7b8-1b19-4083-8673-86a85ba6d18a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate IP Load", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.5702906018649025`*^9, 
  3.5702906054931097`*^9}, {3.5702938468065023`*^9, 3.570293848911623*^9}, {
  3.571067954591439*^9, 
  3.5710679642949944`*^9}},ExpressionUUID->"79951334-a5c5-4c93-9b40-\
5d66c39a0a27"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcIPLoad", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Check the masses suspended by IPs:\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Logic"}]}], " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$IPload", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Check"}]}], " ", "List", " ", "for", " ", 
           RowBox[{"Calculation", "--"}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Checkbox", "[", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IPload", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                ",", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Calculator", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Total Mass:\>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"temp$IPload", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{"save$mass", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
            "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newIP", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"temp$IPload", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                "]"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "200"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Calculate IP Stiffness\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5710674652244487`*^9, 3.5710676733223515`*^9}},
 CellLabel->"In[67]:=",ExpressionUUID->"4cf28cd7-b46e-4a4b-92e8-190cf3d83ccd"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate IP Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.5710676894092712`*^9, 
  3.5710676910523653`*^9}},ExpressionUUID->"292da8bc-00d0-47ca-a9b9-\
9739d23d772a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcIPStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$IPstiff", "=", "0."}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<Resonant Frequency:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", "temp$IPstiff", "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
              RowBox[{"Do", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newIP", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                 RowBox[{
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$IPstiff"}], 
                    ")"}], "^", "2"}], "/", "3"}]}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "]"}]}], "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "300"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Calculate IP Position\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.57028983359796*^9, 3.5702898337029657`*^9}, {
   3.570289895278488*^9, 3.5702898978016324`*^9}, {3.5702928826503563`*^9, 
   3.570292894817052*^9}, {3.5702929952027936`*^9, 3.570292995829829*^9}, {
   3.5702930771094785`*^9, 3.5702931366238823`*^9}, {3.5710670353478613`*^9, 
   3.571067194359956*^9}, {3.57106723498728*^9, 3.5710672534473352`*^9}, {
   3.571067350858907*^9, 3.5710673791475253`*^9}, {3.571067693567509*^9, 
   3.571067777735323*^9}, {3.57106780862109*^9, 3.57106783293548*^9}, {
   3.5710680604704947`*^9, 3.5710680805236416`*^9}, {3.5710711951317873`*^9, 
   3.5710711955498114`*^9}},
 CellLabel->"In[68]:=",ExpressionUUID->"8a4a1cd1-fdf0-4bb9-b50e-37dc95bbce35"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["(2-3 Define Horizontal Flexure)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570215637850922*^9, 3.5702156458273783`*^9}, {
   3.5710454597991858`*^9, 3.5710454618743043`*^9}, 
   3.718415145723289*^9},ExpressionUUID->"a4784a0f-be68-4058-853b-\
0f6696dcd3e1"],

Cell[CellGroupData[{

Cell["Define Horizontal Flexures", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
   3.570194453170987*^9, 3.570194456945203*^9}, {3.716950807245875*^9, 
   3.716950814059416*^9}, 
   3.718415147056552*^9},ExpressionUUID->"2e7e5a90-3fdd-4938-89f9-\
ac948c1e649c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DefineHorizFlex", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been", 
        " ", "set", " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Define bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Not", "[", 
             RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
            RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", 
              RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"TextCell", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Define Horizontal Flexure\>\"", ",", "\[IndentingNewLine]", 
              "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "Wire", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Create New Flexure\>\"", ",", "Bold", ",", "White"}],
             "]"}], ",", "mod$NewHorizFlex", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$hflex", "]"}], ",", 
            RowBox[{"temp$hflex", "=", "save$hflex"}], ",", 
            RowBox[{"temp$hflex", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$hflex$comments", "]"}], ",", 
            RowBox[{"temp$hflex$comments", "=", "save$hflex$comments"}], ",", 
            RowBox[{"temp$hflex$comments", "=", 
             RowBox[{"save$hflex", "/.", 
              RowBox[{
               RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
               "\"\<\>\""}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$hflex", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$hflex", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$hflex", ",", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$hflex", "]"}]}], "}"}]}], "]"}],
              ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", 
                  "\"\<Name\>\"", ",", "\"\<Base\>\"", ",", 
                  "\"\<Follower\>\"", ",", "\"\<Stiffness [Nm/rad]\>\"", ",", 
                  "\"\<Material\>\"", ",", "\[IndentingNewLine]", 
                  "\"\<Follower's CoM H[mm]\>\"", ",", 
                  "\"\<Position in Base [mm]\>\""}], "}"}]}], "}"}]}]}], 
            "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{
                 RowBox[{"save$hflex", "=", "temp$hflex"}], ";", 
                 RowBox[{
                 "save$hflex$comments", "=", "temp$hflex$comments"}]}], 
                "]"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{
       "WindowTitle", "\[Rule]", "\"\<2-3 Define Horizontal Flexures\>\""}]}],
       "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570639937864048*^9, 3.570639940941224*^9}, {
   3.5706399846197224`*^9, 3.570640066998434*^9}, {3.716950779138234*^9, 
   3.716950781786387*^9}, {3.716950825009912*^9, 3.716950896256731*^9}, {
   3.716950929301095*^9, 3.716950957914192*^9}, 3.718414570945511*^9, {
   3.7184151490380583`*^9, 3.7184151586421022`*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"8bbf6d50-9573-4bdd-adad-f5f7adbf2438"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New Flexure", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}},ExpressionUUID->"05335743-9668-4fc1-bd41-\
390fe8c20104"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewHorizFlex", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Horizontal Flexure\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newhflex", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "0.", ",", "0.02", ",", 
           RowBox[{"{", 
            RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", "\"\<\>\"", ",",
            "1"}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Flexure Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InputField", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newhflex", "[", 
           RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
         RowBox[{"FieldSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose rigid bodies where the flexure is attached.\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Base:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Follower:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Material", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Material of Flexure\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.85"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newhflex", "[", 
           RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"m", "\[Rule]", 
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", 
             RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], "]"}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate flexure stiffness from resonant frequency\>\"", ",", 
           "Bold", ",", "Black", ",", "Small"}], "]"}], ",", 
         "\[IndentingNewLine]", "mod$CalcFlexStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Stiffness:\>\"", ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<Nm/rad\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Position"}]}], " ", "of", " ", 
          RowBox[{"Follower", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Height of Follower's CoM from Flexure\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate CoM Position from CoP Level\>\"", ",", "Bold", ",", 
           "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcFlexStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newhflex", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "/", "mm"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newhflex", "[", 
                   RowBox[{"[", "4", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
             "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<mm\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Position"}]}], " ", "of", " ", 
          RowBox[{"Base", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Position of Flexure in Base Body\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate Flexure Position\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcFlexPosition", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"m", "=", "m"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$newhflex", "[", 
                   RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$newhflex", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
              "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$hflex", ",", "temp$newhflex"}], "]"}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Horizontal Flexure\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.5706401048015966`*^9, 3.5706401766677065`*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"4b859813-3105-442d-ba89-edf58bed608c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calculate Flexure Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 
  3.5702891137357864`*^9}},ExpressionUUID->"28fc26de-c532-4076-a1d1-\
94b6eac39f23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcFlexPosition", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate Flexure Position:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$hflexpos", "=", 
         RowBox[{"{", 
          RowBox[{"0.6", ",", "0.", ",", "0.01"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<Radial Distance from Base Body's CoM:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "/", "mm"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$hflexpos", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<mm\>\""}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Rotation Angle in Horizontal Plane from x-axis:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "/", "deg"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$hflexpos", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "deg"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<deg\>\""}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Height from Base Body's CoM:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "/", "mm"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$hflexpos", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<mm\>\""}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newhflex", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], ",", 
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "300"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", "\"\<Calculate Flexure Position\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.57028983359796*^9, 3.5702898337029657`*^9}, {
   3.570289895278488*^9, 3.5702898978016324`*^9}, {3.5702928826503563`*^9, 
   3.570292894817052*^9}, {3.5702929952027936`*^9, 3.570292995829829*^9}, {
   3.5702930771094785`*^9, 3.5702931366238823`*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"e3e42d24-67d3-4579-92ee-6fdf4d6b8363"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calculate Stiffness & Follower's Height", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.5702906018649025`*^9, 
  3.5702906054931097`*^9}, {3.5702938468065023`*^9, 
  3.570293848911623*^9}},ExpressionUUID->"246a5d3c-4c69-4b9d-ac5e-\
9775719716a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcFlexStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate Flexure Stiffness & Follower's CoM Height:\>\"", ",",
            "\[IndentingNewLine]", "Bold", ",", "White", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$hflexStiff", "=", 
         RowBox[{"{", 
          RowBox[{"0.", ",", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "2", ",", "1", ",", "1"}],
              "]"}], "]"}], ",", "0.5", ",", "0.03", ",", 
           RowBox[{"-", "80"}], ",", "False"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Logic"}]}], " ", 
           RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"temp$hflexLogic", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"temp$hflexLegNum", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Load"}]}], " ", 
           RowBox[{"Caocluation", "--"}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Check", " ", "List"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Calculate Load on IP (exclude leg):\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{".7", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"Partition", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Checkbox", "[", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$hflexLogic", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
               ",", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ",",
           "6", ",", "6", ",", "1", ",", 
          RowBox[{"{", "}"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", "Calculator", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<How many legs?\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$hflexLegNum", "]"}], ",", "Number",
              ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"2.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Calculate from body's mass\>\"", ",", "Black", ",", 
               "Small", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"temp$hflexStiff", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"temp$hflexLogic", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}],
                "/", "temp$hflexLegNum"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$hflexStiff", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Leg", "'"}]}]}], "s", " ", "Mass"}], ",", " ", 
         RowBox[{
          RowBox[{"MoI", " ", "and", " ", 
           RowBox[{"Length", "--"}]}], "-"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Leg's Mass, MoI and Length:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".7", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Mass:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<kg\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<MoI:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<kg*m2\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Length:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "4", "]"}], "]"}], "/", "mm"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$hflexStiff", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<mm\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Resonant"}]}], " ", "Frequency", " ", "and", " ", 
          "CoP", " ", 
          RowBox[{"Effect", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Resonant Freqeuncy & CoP Effect:\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".7"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Frequency:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<CoP Level:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<dB\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$hflexStiff", "[", 
              RowBox[{"[", "7", "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Over compensated?\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "White", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Calculate\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "m", ",", "mI", ",", "M", ",", "y", ",", "B", ",", "L", ",", 
                 "w"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"L", "=", 
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "4", "]"}], "]"}]}], ";", 
                RowBox[{"m", "=", 
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ";", 
                RowBox[{"M", "=", 
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"w", "=", 
                 RowBox[{"2", "*", 
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{"temp$hflexStiff", "[", 
                   RowBox[{"[", "5", "]"}], "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"mI", "=", 
                 RowBox[{
                  RowBox[{"temp$hflexStiff", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "/", 
                  RowBox[{"L", "^", "2"}]}]}], ";", 
                RowBox[{"B", "=", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$hflexStiff", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "]"}], "*", 
                  RowBox[{"10", "^", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$hflexStiff", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "/", "20"}], ")"}]}]}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"m", "^", "2"}], "-", 
                    RowBox[{"4", "*", "m", "*", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"B", "*", "M"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", "mI"}]}], ")"}]}]}], 
                    ")"}], ">", "0"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", 
                   RowBox[{
                    RowBox[{"y", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"m", "-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"m", "^", "2"}], "-", 
                    RowBox[{"4", "*", "m", "*", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"B", "*", "M"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", "mI"}]}], ")"}]}]}], 
                    "]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", "m", "*", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}]}], ")"}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$newhflex", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "=", 
                    RowBox[{"y", "*", "L"}]}], ";", 
                    RowBox[{
                    RowBox[{"temp$newhflex", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"M", "+", 
                    RowBox[{"y", "*", "m"}]}], ")"}], "*", 
                    RowBox[{"g", "/", "L"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"M", "+", 
                    RowBox[{"m", "*", 
                    RowBox[{"y", "^", "2"}]}], "+", "mI"}], ")"}], "*", 
                    RowBox[{"w", "^", "2"}]}]}], ")"}], "*", 
                    RowBox[{"L", "^", "2"}]}]}], ";"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Beep", "[", "]"}], ";", 
                   RowBox[{"CreateDialog", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Too large CoP Effect.\>\"", ",", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}]}]}], "]"}]}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "500"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", "\"\<Calculate Flexure Information\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.5702898403523464`*^9, 
   3.5702899046100216`*^9}, {3.570291749638551*^9, 3.5702918059407716`*^9}, {
   3.5702918585427804`*^9, 3.570291964580845*^9}, {3.570292002971041*^9, 
   3.5702923223533087`*^9}, {3.5702923595004334`*^9, 3.570292384041837*^9}, {
   3.5702924709588084`*^9, 3.5702925207426558`*^9}, {3.5702926102747765`*^9, 
   3.5702927920941763`*^9}, {3.570293113048534*^9, 3.5702931207839766`*^9}, 
   3.570293305802559*^9, {3.5702934026821003`*^9, 3.570293613340149*^9}, {
   3.570293725762579*^9, 3.5702937359461613`*^9}, {3.570293856587062*^9, 
   3.5702938633414483`*^9}, {3.570293900540576*^9, 3.5702939048978252`*^9}, {
   3.570293940257848*^9, 3.5702939625791245`*^9}, {3.570294035011267*^9, 
   3.570294170294005*^9}, {3.5702942460763397`*^9, 3.570294247886443*^9}, {
   3.570294284830556*^9, 3.5702943021185446`*^9}, {3.570294342036828*^9, 
   3.5702944399204264`*^9}, {3.570294480296736*^9, 3.5702945702088785`*^9}, {
   3.5702946607560577`*^9, 3.5702947571425705`*^9}, {3.570294788867385*^9, 
   3.57029480905654*^9}, {3.570294845301613*^9, 3.5702948858199306`*^9}, {
   3.570294953343793*^9, 3.5702949972463036`*^9}, {3.5702959004469643`*^9, 
   3.570296005817991*^9}, {3.570296868339324*^9, 3.5702968960399084`*^9}, {
   3.57029694065146*^9, 3.5702969502360086`*^9}, {3.5702972372534246`*^9, 
   3.5702973033122034`*^9}, {3.570902059136155*^9, 3.570902100605527*^9}, {
   3.570902159260882*^9, 3.570902159962922*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"0f6d5b3b-984d-4210-9bf1-881d3a8e8b14"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-4 Define Heat Links", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703791032406363`*^9, 3.5703791118081264`*^9}, 
   3.718415166138418*^9},ExpressionUUID->"fc724c7e-3f74-4690-8a5a-\
72e097d9a14d"],

Cell[CellGroupData[{

Cell["Define HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
   3.570194453170987*^9, 3.570194456945203*^9}, {3.570463211578166*^9, 
   3.570463211922186*^9}, 
   3.718415167303948*^9},ExpressionUUID->"c30033f0-42c3-4be9-8f7e-\
c6f1aa508e65"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DefineHeatLinks", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$shape", "]"}], "]"}]}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "bodies", " ", "have", " ", "not", " ", "been", " ", "set", 
        " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Registrate bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Define Heat Links\>\"", ",", "\[IndentingNewLine]", "Bold", 
             ",", "Italic", ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "HL", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Create New Heat Link\>\"", ",", "Bold", ",", "White"}], 
            "]"}], ",", "mod$NewHeatLinks", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$HL", "]"}], ",", 
            RowBox[{"temp$HL", "=", "save$HL"}], ",", 
            RowBox[{"temp$HL", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$HL$comments", "]"}], ",", 
            RowBox[{"temp$HL$comments", "=", "save$HL$comments"}], ",", 
            RowBox[{"temp$HL$comments", "=", 
             RowBox[{
              RowBox[{"save$HL", "/.", 
               RowBox[{
                RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
                "\"\<\>\""}]}], "/.", 
              RowBox[{
               RowBox[{"x_", "?", "StringQ"}], "\[Rule]", "\"\<\>\""}]}]}]}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$HL", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$HL", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                    RowBox[{"temp$HL$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$HL$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$HL", ",", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$HL$comments", ",", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditHeatLinks", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"OpenerView", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"OpenerView", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"OpenerView", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"OpenerView", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$HL", "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Edit\>\"", 
                  ",", "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                  "\"\<Body2\>\"", ",", 
                  "\"\<Attachment Point in Body1 [mm]\>\"", ",", 
                  "\[IndentingNewLine]", 
                  "\"\<Attachment Point in Body2 [mm]\>\"", ",", 
                  "\"\<Geo-x [mm]\>\"", ",", "\"\<Geo-y [mm]\>\"", ",", 
                  "\"\<Geo-z [mm]\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{
                 RowBox[{"save$HL", "=", "temp$HL"}], ";", 
                 RowBox[{"save$HL$comments", "=", "temp$HL$comments"}]}], 
                "]"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{"WindowTitle", "\[Rule]", "\"\<2-4 Define Heat Links\>\""}]}], 
      "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570379132066285*^9, 3.570379177379877*^9}, {
   3.5703792463608227`*^9, 3.5703792641828413`*^9}, {3.5703793326957607`*^9, 
   3.570379349889744*^9}, {3.5704632234888473`*^9, 3.5704632237538624`*^9}, {
   3.5704670111594896`*^9, 3.57046702900751*^9}, {3.570554565202813*^9, 
   3.570554678762308*^9}, {3.5705547488923197`*^9, 3.5705548366673403`*^9}, {
   3.5705548715923376`*^9, 3.57055509508012*^9}, {3.570555137961573*^9, 
   3.5705551490792093`*^9}, {3.570555198976063*^9, 3.5705552305728703`*^9}, {
   3.5705556839738035`*^9, 3.5705557458073397`*^9}, {3.5705564254792147`*^9, 
   3.5705564266442814`*^9}, {3.5705567227412176`*^9, 
   3.5705567372760487`*^9}, {3.716951008917849*^9, 3.716951106043404*^9}, 
   3.718394414595892*^9, {3.718394587144126*^9, 3.718394605538824*^9}, {
   3.718411701108263*^9, 3.718411741137291*^9}, {3.7184117983752604`*^9, 
   3.718411805715013*^9}, {3.718411867572083*^9, 3.718411906362865*^9}, {
   3.7184119512905073`*^9, 3.718412384195588*^9}, {3.7184124288347063`*^9, 
   3.7184124337609253`*^9}, 3.718412486160844*^9, {3.718415168060254*^9, 
   3.718415176823889*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"758a7b61-a04d-438d-896f-b18b8fe9fab2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 
  3.570379478921124*^9}},ExpressionUUID->"31175af3-10fa-4719-83f1-\
01be0367f974"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$NewHeatLinks", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<New Heat Link\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newHL", "=", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.6", ",", "0.3", ",", "0."}], "}"}], ",", "1", ",", 
            "100.", ",", "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}], ",", "\"\<\>\""}], "}"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"temp$newHL$comments", "=", 
          RowBox[{
           RowBox[{"temp$newHL", "/.", 
            RowBox[{
             RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
             "\"\<\>\""}]}], "/.", 
           RowBox[{
            RowBox[{"x", "?", "StringQ"}], "\[Rule]", "\"\<\>\""}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"OpenerView", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL$comments", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL$comments", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "]"}], "\[NotEqual]", 
              "\"\<\>\""}], ",", 
             RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
            "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Select Attached Bodies\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Clamp Position and Heat Link Geometry\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x-Distance\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y-Depth\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z-Distance\>\"", ",", "Small"}], "]"}]}], 
                "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Geometry\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"Graphics3D", "[", 
                RowBox[{"mod$DrawHeatLinks", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                   RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Stiffness Matrix for Each Wire\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Number of Wires:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Q-factor:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Import\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"mod$ImportkHL", "[", 
                    RowBox[{"m", ",", "l"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "]"}],
                    ",", "\[IndentingNewLine]", 
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}]}], "}"}],
                  ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}]}], "}"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"temp$HL", ",", "temp$newHL"}], "]"}], ";", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"temp$HL$comments", ",", "temp$newHL$comments"}], 
                 "]"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<New Heat Links\>\""}]}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.570556497216318*^9, 3.570556522296753*^9}, {3.570556591024684*^9, 
   3.570556596014969*^9}, 3.718394437552289*^9, {3.7183946488360167`*^9, 
   3.718394703209716*^9}, {3.71839481413686*^9, 3.718394823852889*^9}, {
   3.718412549534487*^9, 3.718412588206019*^9}, {3.718412652151444*^9, 
   3.7184126928687696`*^9}, {3.718412771284114*^9, 3.718412988326343*^9}, {
   3.718413027066231*^9, 3.718413053250596*^9}, {3.7184131108438187`*^9, 
   3.7184133119247313`*^9}, {3.718414236309968*^9, 3.71841423731698*^9}, {
   3.718414296311549*^9, 3.7184142971540117`*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"5889cb9b-36d7-4c4b-aa00-e56729e5ed43"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Edit HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}, {
  3.570556451723716*^9, 
  3.570556453000789*^9}},ExpressionUUID->"2fc59a54-aaba-4a79-bdb0-\
eaff929b77a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$EditHeatLinks", "[", "n_", "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Edit Heat Link\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newHL", "=", 
          RowBox[{"temp$HL", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"temp$newHL$comments", "=", 
          RowBox[{"temp$HL$comments", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"OpenerView", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL$comments", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL$comments", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "]"}], "\[NotEqual]", 
              "\"\<\>\""}], ",", 
             RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
            "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Select Attached Bodies\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Clamp Position and Heat Link Geometry\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x-Distance\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y-Depth\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z-Distance\>\"", ",", "Small"}], "]"}]}], 
                "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Geometry\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"Graphics3D", "[", 
                RowBox[{"mod$DrawHeatLinks", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                   RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Stiffness Matrix for Each Wire\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Number of Wires:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Q-factor:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "]"}], "\[NotEqual]", 
                  "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Import\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"mod$ImportkHL", "[", 
                    RowBox[{"m", ",", "l"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "]"}],
                    ",", "\[IndentingNewLine]", 
                   RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}], ",", 
                    RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}]}], "}"}],
                  ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}]}], "}"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$HL", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "=", "temp$newHL"}], ";", 
                RowBox[{
                 RowBox[{"temp$HL$comments", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "=", 
                 "temp$newHL$comments"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Edit Heat Link\>\""}]}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.57055646123526*^9, 3.570556489622884*^9}, {3.570556527429046*^9, 
   3.570556529227149*^9}, {3.5705566412025537`*^9, 3.5705566419665976`*^9}, {
   3.570556775050209*^9, 3.570556784609756*^9}, 3.718394491685611*^9, {
   3.718394840911017*^9, 3.7183948486607437`*^9}, {3.718394937533633*^9, 
   3.718394955736871*^9}, {3.7184134726914682`*^9, 3.7184136399936867`*^9}, {
   3.718413688067905*^9, 3.7184138334367323`*^9}, {3.7184138924144993`*^9, 
   3.718413921882869*^9}, 3.7184139540803957`*^9, {3.718413998497477*^9, 
   3.718414021723037*^9}, {3.7184140898295794`*^9, 3.718414098430665*^9}, {
   3.718414145969734*^9, 3.718414153996552*^9}, {3.7184143047452927`*^9, 
   3.718414305443609*^9}, {3.718415962364683*^9, 3.718415965360779*^9}},
 CellLabel->"In[75]:=",ExpressionUUID->"768788c6-e534-4d42-88ff-316ae86760ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Draw HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5705377785762105`*^9, 
  3.570537783763507*^9}},ExpressionUUID->"27b42655-7ac8-4ed8-be15-\
21956e771cd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DrawHeatLinks", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rCM", "=", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Line", "[", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"temp$newHL", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "+", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"temp$newHL", "[", 
               RowBox[{"[", 
                RowBox[{"5", ",", "1"}], "]"}], "]"}], ",", "0", ",", 
              RowBox[{"temp$newHL", "[", 
               RowBox[{"[", 
                RowBox[{"5", ",", "3"}], "]"}], "]"}]}], "}"}], "/", "2"}], 
           "-", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "1"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}], ",", 
              RowBox[{"2", "*", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "2"}], "]"}], "]"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "3"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}]}], "}"}], "/", "2"}]}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "20"}], "}"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Opacity", "[", "0.5", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"mod$Create3DShape", "[", 
        RowBox[{
         RowBox[{"rCM", "-", 
          RowBox[{"temp$newHL", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ",", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"mod$Create3DShape", "[", 
        RowBox[{
         RowBox[{"rCM", "-", 
          RowBox[{"temp$newHL", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "1"}], "]"}], "]"}], ",", "0", ",", 
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "3"}], "]"}], "]"}]}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
        "]"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5705377849465747`*^9, 3.5705377988583703`*^9}, {
  3.570538008234346*^9, 3.5705380404471884`*^9}, {3.570538216409253*^9, 
  3.5705382176403236`*^9}, {3.5705383014531174`*^9, 3.5705386205193667`*^9}, {
  3.570538651034112*^9, 3.5705388810152664`*^9}, {3.5705533374645905`*^9, 
  3.570553378123916*^9}, {3.570553447706896*^9, 3.5705534478339033`*^9}, {
  3.5705534957046413`*^9, 3.5705535196400104`*^9}, {3.570553573933116*^9, 
  3.570553574068124*^9}, {3.570553634242565*^9, 3.570553635956663*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"077d452a-ba87-4cbc-95e8-cb521593b457"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"steadyplot", "[", 
     RowBox[{"sub_", ",", "opt___"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wireplot", "[", "sub", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"bodyplot", "[", "sub", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"heatlinkplot", "[", "sub", "]"}], ",", "\[IndentingNewLine]", 
      "opt"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570900142979557*^9, 3.570900195909585*^9}, {
  3.571157599115424*^9, 3.5711576029316425`*^9}},
 CellLabel->"In[77]:=",ExpressionUUID->"962e1c8a-cbae-4e1a-9b54-cd4c1755dc35"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"heatlinkplot", "[", "sub_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"save$HL", "[", 
       RowBox[{"[", "0", "]"}], "]"}], "=!=", "List"}], ",", 
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Graphics3D", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Line", "[", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"b2s", "[", 
                RowBox[{
                 RowBox[{"save$bodypos", "[", 
                  RowBox[{"[", 
                   RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "]"}], ",", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}]}], "]"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"N", "[", "Pi", "]"}], "*", 
                    RowBox[{"i", "/", "20"}]}], "]"}]}], ")"}], "/", "2"}]}], 
              "+", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"b2s", "[", 
                RowBox[{
                 RowBox[{"save$bodypos", "[", 
                  RowBox[{"[", 
                   RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "]"}], ",", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "4"}], "]"}], "]"}]}], "]"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"N", "[", "Pi", "]"}], "*", 
                    RowBox[{"i", "/", "20"}]}], "]"}]}], ")"}], "/", "2"}]}], 
              "-", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], ",", 
                 "0"}], "}"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", "20"}], "}"}]}], "]"}], "]"}], "/.",
           "subdefparams"}], "/.", "sub"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708991302576327`*^9, 3.570899157353183*^9}, {
   3.5708991908360977`*^9, 3.570899224358015*^9}, {3.57089957445704*^9, 
   3.570899707831668*^9}, {3.570899742060626*^9, 3.5708998179379663`*^9}, {
   3.570899907765104*^9, 3.5709000153692584`*^9}, 3.570900105544416*^9, {
   3.5709006629953003`*^9, 3.5709006633903227`*^9}, {3.570900935289875*^9, 
   3.5709009357269*^9}},
 CellLabel->"In[78]:=",ExpressionUUID->"bec01b2e-e5f3-4f90-bf0a-20494b8b2798"]
}, Closed]],

Cell[CellGroupData[{

Cell["Import kHL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703648112755613`*^9, 3.5703648131296673`*^9}, {
  3.570536537486224*^9, 
  3.5705365394333353`*^9}},ExpressionUUID->"ab84128c-165e-4591-92d9-\
95c6f7662ba1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$ImportkHL", "[", 
    RowBox[{"m_", ",", "l_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$impkHL", "=", 
         RowBox[{"temp$newHL", "[", 
          RowBox[{"[", 
           RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Load Frequency Dependence of Heat Link Stiffness\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$impkHL", "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"20.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "=", 
               "temp$impkHL"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Clear\>\"", ",", "Bold", ",", "Black"}], "]"}], 
             ",", 
             RowBox[{"temp$impkHL", "=", "\"\<\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "}"}], 
         "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<HeatLink\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$impkHL", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<HeatLink\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                 ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<HeatLink\>\"", "}"}], ",", "3"}], "]"}],
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
              ",", "3", ",", "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"500", ",", "200"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"550", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
     "WindowTitle", "\[Rule]", 
      "\"\<Load Frequency Dependence of Heat Link Stiffness\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.5703648187229877`*^9, 
   3.570364842461345*^9}, {3.5703650147151976`*^9, 3.570365221167006*^9}, {
   3.570536542498511*^9, 3.570536625289246*^9}, {3.570536686231732*^9, 
   3.570536794872946*^9}, {3.570536877157652*^9, 3.57053688026583*^9}, {
   3.5705369980505667`*^9, 3.570536998680603*^9}, {3.5705371311661806`*^9, 
   3.5705371640520616`*^9}, {3.5705566657969604`*^9, 3.570556666219984*^9}, {
   3.5706406530399537`*^9, 3.570640655884116*^9}, {3.571237781888692*^9, 
   3.571237806502099*^9}, {3.5712391277366695`*^9, 3.571239130123806*^9}, {
   3.5793187480992956`*^9, 3.579318761135041*^9}, {3.5912608917692747`*^9, 
   3.5912608989416847`*^9}},
 CellLabel->"In[79]:=",ExpressionUUID->"ee10ccee-4ca6-4173-8d81-2d05d06e2180"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-5 Define Damper", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570640931730894*^9, 3.570640944970651*^9}, 
   3.718415185049041*^9},ExpressionUUID->"65cc9748-d347-496e-847c-\
3f1121719151"],

Cell[CellGroupData[{

Cell["Define Damper", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
   3.570194453170987*^9, 3.570194456945203*^9}, {3.570463211578166*^9, 
   3.570463211922186*^9}, {3.570640964984796*^9, 3.5706409663218727`*^9}, 
   3.718415186039323*^9},ExpressionUUID->"b550f403-3ffd-4f30-8918-\
95c0da4d06d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DefineDamper", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "bodies", " ", "have", " ", "not", " ", "been", " ", "set", 
        " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Define bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Define Damper\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
             "Italic", ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "HL", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Create New Damper\>\"", ",", "Bold", ",", "White"}], 
            "]"}], ",", "mod$NewDamper", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$damp", "]"}], ",", 
            RowBox[{"temp$damp", "=", "save$damp"}], ",", 
            RowBox[{"temp$damp", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$damp$comments", "]"}], ",", 
            RowBox[{"temp$damp$comments", "=", "save$damp$comments"}], ",", 
            RowBox[{"temp$damp$comments", "=", 
             RowBox[{
              RowBox[{"save$damp", "/.", 
               RowBox[{
                RowBox[{"x_", "?", "NumericQ"}], "\[RuleDelayed]", 
                "\"\<\>\""}]}], "/.", 
              RowBox[{
               RowBox[{"x_", "?", "StringQ"}], "\[RuleDelayed]", 
               "\"\<\>\""}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$damp", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$damp", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
                    RowBox[{"temp$damp$comments", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$damp$comments", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Duplicate\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$damp", ",", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ";", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$damp$comments", ",", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditDamper", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"OpenerView", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", " ", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"OpenerView", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", " ", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp$comments", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                     "]"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$damp", "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Delete\>\"", ",", "\"\<Duplicate\>\"", ",", 
                  "\"\<Edit\>\"", ",", "\"\<Name\>\"", ",", "\"\<Body1\>\"", 
                  ",", "\"\<Body2\>\"", ",", 
                  "\"\<Damping Point in Body1 [mm]\>\"", ",", 
                  "\[IndentingNewLine]", 
                  "\"\<Damping Point in Body2 [mm]\>\""}], "}"}]}], "}"}]}]}],
             "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{
                 RowBox[{"save$damp", "=", "temp$damp"}], ";", 
                 RowBox[{"save$damp$comments", "=", "temp$damp$comments"}]}], 
                "]"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{"WindowTitle", "\[Rule]", "\"\<2-5 Define Damper\>\""}]}], 
      "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570379132066285*^9, 3.570379177379877*^9}, {
   3.5703792463608227`*^9, 3.5703792641828413`*^9}, {3.5703793326957607`*^9, 
   3.570379349889744*^9}, {3.5704632234888473`*^9, 3.5704632237538624`*^9}, {
   3.5704670111594896`*^9, 3.57046702900751*^9}, {3.570554565202813*^9, 
   3.570554678762308*^9}, {3.5705547488923197`*^9, 3.5705548366673403`*^9}, {
   3.5705548715923376`*^9, 3.57055509508012*^9}, {3.570555137961573*^9, 
   3.5705551490792093`*^9}, {3.570555198976063*^9, 3.5705552305728703`*^9}, {
   3.5705556839738035`*^9, 3.5705557458073397`*^9}, {3.5705564254792147`*^9, 
   3.5705564266442814`*^9}, {3.5705567227412176`*^9, 
   3.5705567372760487`*^9}, {3.5706409718181868`*^9, 
   3.5706410807024145`*^9}, {3.570641807709997*^9, 3.570641873310749*^9}, {
   3.570642052996027*^9, 3.5706420557851863`*^9}, 3.570983893867327*^9, {
   3.5709839496155157`*^9, 3.5709839502785535`*^9}, {3.571134068286942*^9, 
   3.5711340688669753`*^9}, {3.716951158371315*^9, 3.716951239377527*^9}, {
   3.716951277410503*^9, 3.716951282138701*^9}, {3.717791053853611*^9, 
   3.7177910550406933`*^9}, {3.7182461574372807`*^9, 
   3.7182461787490597`*^9}, {3.718246269499625*^9, 3.718246371248658*^9}, {
   3.7182464106025057`*^9, 3.718246422505207*^9}, {3.718246475890501*^9, 
   3.718246514856615*^9}, {3.718246575741441*^9, 3.718246580402164*^9}, {
   3.718246629600865*^9, 3.718246637850329*^9}, {3.718246686486274*^9, 
   3.7182467190178003`*^9}, {3.718246794164466*^9, 3.7182468269726562`*^9}, 
   3.7182469207726383`*^9, 3.7182475593348083`*^9, {3.7182477904990997`*^9, 
   3.7182477924639997`*^9}, {3.7182621556049623`*^9, 3.718262175454172*^9}, {
   3.718262355708349*^9, 3.7182624104121637`*^9}, {3.718262442626326*^9, 
   3.718262490878497*^9}, 3.7184145718192787`*^9, {3.718415188993473*^9, 
   3.718415197341488*^9}},
 CellLabel->"In[80]:=",ExpressionUUID->"cd7fd083-b5e4-4b6f-9f8c-035ced64abca"]
}, Open  ]],

Cell[CellGroupData[{

Cell["New Damper", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}, {
  3.570641133505435*^9, 
  3.5706411346715016`*^9}},ExpressionUUID->"d9972d85-6065-436e-88be-\
8b474994db19"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$NewDamper", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<New Damper\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newdamp", "=", 
          RowBox[{"{", 
           RowBox[{"\"\<\>\"", ",", "1", ",", "2", ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"temp$newdamp$comment", " ", "=", " ", 
          RowBox[{"{", 
           RowBox[{"\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\""}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\""}], "}"}], 
            ",", 
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"OpenerView", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp$comment", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp$comment", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
              "\"\<\>\""}], ",", 
             RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
            "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Between:\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Position of Damper\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Strength Matrix\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                   "]"}], ",", "Number", ",", "\[IndentingNewLine]", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                   "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                   "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"temp$damp", ",", "temp$newdamp"}], "]"}], ";", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"temp$damp$comments", ",", "temp$newdamp$comment"}], 
                 "]"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<New Damper\>\""}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.570556497216318*^9, 3.570556522296753*^9}, {3.570556591024684*^9, 
   3.570556596014969*^9}, {3.570641142195932*^9, 3.5706412688181744`*^9}, {
   3.5706413104835577`*^9, 3.570641414668516*^9}, {3.570641461152175*^9, 
   3.5706415630410028`*^9}, {3.716951368043047*^9, 3.716951376969746*^9}, {
   3.716951484466508*^9, 3.716951537161607*^9}, {3.7178353585406113`*^9, 
   3.717835359429042*^9}, {3.718248339216672*^9, 3.718248417891814*^9}, {
   3.718248448848689*^9, 3.7182485865797777`*^9}, {3.718248662073485*^9, 
   3.7182486982523203`*^9}, {3.718248751027109*^9, 3.7182489072079887`*^9}, {
   3.718262287069893*^9, 3.7182623073569813`*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"e68fde39-3e33-401b-bc16-b1ab4caadbdb"]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Damper", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}, {
  3.570641133505435*^9, 3.5706411346715016`*^9}, {3.5706418898026924`*^9, 
  3.57064189028572*^9}},ExpressionUUID->"f59199bc-f109-498d-8dd2-\
16f5babf584c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$EditDamper", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Edit Damper\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$editdamp", "=", 
          RowBox[{"temp$damp", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"temp$editdamp$comment", "=", 
          RowBox[{"temp$damp$comments", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"OpenerView", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$editdamp", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$editdamp$comment", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "String", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"80", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$editdamp$comment", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
              "\"\<\>\""}], ",", 
             RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
            "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Between:\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$editdamp", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$editdamp", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Position of Damper\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$editdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$editdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"OpenerView", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$editdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$editdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "\[NotEqual]", "\"\<\>\""}], ",", 
                    RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}],
                    "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Strength Matrix\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"OpenerView", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                   "]"}], ",", "Number", ",", "\[IndentingNewLine]", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                   "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                  RowBox[{"FieldSize", "\[Rule]", "Large"}]}], "]"}]}], "}"}],
               ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$editdamp$comment", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                   "]"}], "\[NotEqual]", "\"\<\>\""}], ",", 
                 RowBox[{"Lighter", "[", "Blue", "]"}], ",", "Automatic"}], 
                "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$damp", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "=", "temp$editdamp"}], ";", 
                RowBox[{
                 RowBox[{"temp$damp$comments", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "=", 
                 "temp$editdamp$comment"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Edit Damper\>\""}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.570556497216318*^9, 3.570556522296753*^9}, {3.570556591024684*^9, 
   3.570556596014969*^9}, {3.570641142195932*^9, 3.5706412688181744`*^9}, {
   3.5706413104835577`*^9, 3.570641414668516*^9}, {3.570641461152175*^9, 
   3.5706415630410028`*^9}, {3.57064190828975*^9, 3.570641967089113*^9}, {
   3.716951596695567*^9, 3.716951643211781*^9}, {3.717791133336726*^9, 
   3.717791133962291*^9}, {3.717835288762273*^9, 3.7178353093520403`*^9}, 
   3.718249270455858*^9, 3.718249301816773*^9, 3.718249348167383*^9, {
   3.718253195252494*^9, 3.718253221471122*^9}, {3.7182581344605303`*^9, 
   3.718258161546832*^9}, {3.718258224757423*^9, 3.718258298336231*^9}, {
   3.71825837790335*^9, 3.718258378142838*^9}},
 CellLabel->"In[82]:=",ExpressionUUID->"aef44178-c1b6-4a7a-8601-474c4c21bf58"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-L Show Connection List", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701244725708427`*^9, 3.570124479552242*^9}, {
  3.570127979301416*^9, 3.57012797972544*^9}, {3.570642256285654*^9, 
  3.570642256423662*^9}, {3.57064229362879*^9, 
  3.5706423008012004`*^9}},ExpressionUUID->"051c1b6d-b4d8-4c97-93ea-\
4435b2d2878b"],

Cell[CellGroupData[{

Cell["Show Connection List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570124483440464*^9, 3.570124486847659*^9}, {
  3.570642296714967*^9, 
  3.570642299024099*^9}},ExpressionUUID->"6bca2504-f342-497b-81ad-\
e10e1ab8316b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ShowConnectionList", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", 
    RowBox[{"Pane", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"wire", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Wire:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$wire", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$wire", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "13"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$mat", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "1"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "/", "meter"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "/", "mm"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", "\"\<Body2\>\"",
                     ",", "\"\<Material\>\"", ",", "\"\<L [m]\>\"", ",", 
                    "\"\<D [mm]\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$wire", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"spring", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Vertical Spring:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$vspr", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$vspr", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "8"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "13"}], "]"}],
                   "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "9"}], "]"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Wire\>\"", ",", 
                    "\"\<k [N/m]\>\"", ",", "\"\<fp [N]\>\"", ",", 
                    "\"\<Q\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$vspr", ";", "\"\<No Wire Springs\>\""}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$bspr", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$bspr", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$bspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$bspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "6"}], "]"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$bspr", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", "\"\<Body2\>\"",
                     ",", "\"\<k [N/m]\>\"", ",", "\"\<fp [N]\>\"", ",", 
                    "\"\<Q\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$bspr", ";", "\"\<No Body Springs\>\""}]}], "]"}], 
         ",", "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"IP", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Inverted Pendulum:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$IP", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$IP", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$IP", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "6"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                    "\"\<Body2\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$IP", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"HL", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Heat Link:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$HL", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$HL", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "10"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "/", 
                  "mm"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "/", 
                  "mm"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "/", 
                  "mm"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", "\"\<Body2\>\"",
                     ",", "\"\<x [mm]\>\"", ",", "\"\<y [mm]\>\"", ",", 
                    "\"\<z [mm]\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$HL", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Damper", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Damper:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$damp", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$damp", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$damp", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$damp", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                    "\"\<Body2\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$damp", ";", "\"\<No Data\>\""}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"640", ",", "300"}], "}"}]}], ",", 
      RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570124607279547*^9, 3.5701248533626223`*^9}, {
   3.570124932636157*^9, 3.5701249490330944`*^9}, {3.5701249931596184`*^9, 
   3.570124993260624*^9}, {3.5701251802793207`*^9, 3.570125180449331*^9}, {
   3.5701252256019135`*^9, 3.570125414348709*^9}, {3.570125502359743*^9, 
   3.570125581251255*^9}, {3.5701256477780604`*^9, 3.5701256987319746`*^9}, {
   3.5701258681076627`*^9, 3.5701258931200933`*^9}, {3.570125931080264*^9, 
   3.570125949249304*^9}, {3.5701260903273726`*^9, 3.570126279358185*^9}, {
   3.5701266306462774`*^9, 3.57012664223394*^9}, {3.570126673900751*^9, 
   3.5701266954029813`*^9}, {3.570126744356781*^9, 3.5701267601396837`*^9}, {
   3.5701271403124285`*^9, 3.5701271640047836`*^9}, {3.57012734559617*^9, 
   3.570127356596799*^9}, {3.5701274226545773`*^9, 3.5701274579525967`*^9}, {
   3.570127559323395*^9, 3.5701275629146*^9}, {3.5701282222933145`*^9, 
   3.570128256759286*^9}, {3.570128287303033*^9, 3.5701283763201237`*^9}, {
   3.570132307535977*^9, 3.5701323298222513`*^9}, {3.5701323706175847`*^9, 
   3.570132422177534*^9}, {3.5701325647556887`*^9, 3.5701325881600275`*^9}, {
   3.5706423055824738`*^9, 3.570642308119619*^9}, {3.5706423476738815`*^9, 
   3.5706425332664967`*^9}, {3.570642590814788*^9, 3.5706426678211927`*^9}, {
   3.5706427012671056`*^9, 3.5706428491555643`*^9}, {3.5706429069198685`*^9, 
   3.570643085524084*^9}, {3.5706431408502483`*^9, 3.5706432094711733`*^9}, {
   3.570643262441203*^9, 3.5706433270318975`*^9}, {3.570643358882719*^9, 
   3.5706433791838803`*^9}, {3.570643438261259*^9, 3.570643513057537*^9}, {
   3.5706435432442636`*^9, 3.570643582524511*^9}, {3.570643666643322*^9, 
   3.5706436757798443`*^9}, {3.5706437062885895`*^9, 
   3.5706437297479315`*^9}, {3.5706437633468533`*^9, 
   3.5706438971855087`*^9}, {3.5706439427211127`*^9, 3.570644079499936*^9}, {
   3.5706441096006575`*^9, 3.570644316454489*^9}, {3.5706443591869335`*^9, 
   3.570644470197283*^9}, {3.570644526895526*^9, 3.570644556611225*^9}, {
   3.57068534941401*^9, 3.570685351579134*^9}, {3.5707068568309216`*^9, 
   3.5707068603621235`*^9}, {3.571058209281414*^9, 3.5710582361589518`*^9}, {
   3.5710582964193983`*^9, 3.571058385704505*^9}, {3.5710683755395155`*^9, 
   3.5710684306556683`*^9}, {3.5711433504058485`*^9, 
   3.5711433525309706`*^9}, {3.585632612537116*^9, 3.585632613344163*^9}, {
   3.5856943894702024`*^9, 3.5856943908212795`*^9}, {3.915666198331478*^9, 
   3.915666230060315*^9}, {3.9156662637613826`*^9, 3.9156663734888916`*^9}, 
   3.9162563123608365`*^9},ExpressionUUID->"cc90b571-6fa9-4388-85c4-\
7a68240099e3"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3. Start Calculation", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571490350229124*^9, 
  3.5714903529702806`*^9}},ExpressionUUID->"0408e833-256e-42a9-82fe-\
4e3a499022d9"],

Cell[CellGroupData[{

Cell["Start Calc", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.57077107372034*^9, 3.570771080451725*^9}, {
  3.5714903912014675`*^9, 
  3.5714903915454874`*^9}},ExpressionUUID->"800fb029-4fa4-4ad3-9ad3-\
b699c07713a7"],

Cell[CellGroupData[{

Cell["Start Calc", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570771084461954*^9, 
  3.5707710862820587`*^9}},ExpressionUUID->"fbe147e8-4068-4d60-bb0c-\
ee071e804664"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$StartCalc", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"mod$OpenStatus", ";", "\[IndentingNewLine]", 
     RowBox[{"mod$WriteStatus", "[", "\"\<Compliance check...\>\"", "]"}], 
     ";", "\[IndentingNewLine]", "mod$CheckModel", ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"calc$sflag", "\[Equal]", "0"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"mod$WriteStatus", "[", "\"\<Stop Calculation\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$StartSUMCON", ";"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Compliance check: OK.\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Model construction starts...\>\"", "]"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"mod$WriteStatus", "[", "\"\<Setting variables...\>\"", "]"}],
         ";", "\[IndentingNewLine]", "mod$SetVars", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Variables have been set.\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Setting body positions...\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$SetBodyPos", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Body positions have been set.\>\"", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Generating necessary lists...\>\"", 
         "]"}], ";", "\[IndentingNewLine]", "mod$SetList", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", 
         "\"\<Bodylist, wirelist, damperlist have been set.\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Calculating energy terms...\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$CalcEnergy", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Energy terms have been set.\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", 
         "\"\<Setting initial values of variables...\>\"", "]"}], ";", 
        "\[IndentingNewLine]", "mod$SetInitVal", ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Initial conditions have been set.\>\"", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Finding equilibrium position...\>\"", 
         "]"}], ";", "\[IndentingNewLine]", "mod$FindEquilibrium", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Equilibrium position has been set.\>\"", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"mod$WriteStatus", "[", "\"\<Start linearization:\>\"", "]"}],
         ";", "\[IndentingNewLine]", "mod$CalcMatrices", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Matrices have been set.\>\"", "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Calculating eigen modes...\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$EigenCalc", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Eigen modes have been set.\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "mod$WriteStatus", "[", "\"\<Now opening calculation menu...\>\"", 
           "]"}], ";", "\[IndentingNewLine]", "mod$CalcMenu", ";"}], "*)"}], 
        "\[IndentingNewLine]", "mod$CloseStatus", ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.57077108770614*^9, 3.57077132251457*^9}, {
   3.570771420613181*^9, 3.570771424352395*^9}, {3.570771456895256*^9, 
   3.570771458405343*^9}, {3.570771505896059*^9, 3.570771515024581*^9}, {
   3.570771562748311*^9, 3.5707715659784956`*^9}, {3.5707716225497313`*^9, 
   3.5707717401314564`*^9}, {3.570772287865785*^9, 3.5707722881338005`*^9}, {
   3.5707723643241587`*^9, 3.5707724569524565`*^9}, 3.5707724891612988`*^9, {
   3.5707730659162874`*^9, 3.5707730901236715`*^9}, {3.5707736141956472`*^9, 
   3.5707736692797976`*^9}, {3.570784815391319*^9, 3.570784829628133*^9}, {
   3.5708708949422817`*^9, 3.5708709531186094`*^9}, {3.5708710025184345`*^9, 
   3.570871004396542*^9}, {3.570871082717022*^9, 3.570871085437177*^9}, {
   3.5708950041256313`*^9, 3.5708950111180315`*^9}, {3.5708957818831167`*^9, 
   3.5708957883234854`*^9}, {3.570898179719265*^9, 3.570898188455765*^9}, {
   3.5712202995157566`*^9, 3.5712203067271695`*^9}, {3.571329482224295*^9, 
   3.571329485473481*^9}, {3.5713387873135157`*^9, 3.5713387913097444`*^9}, {
   3.571419742610602*^9, 3.5714197497780123`*^9}, {3.5714197805777736`*^9, 
   3.5714198888459663`*^9}, {3.5714199445471525`*^9, 3.571419988660675*^9}, {
   3.5714200396385913`*^9, 3.5714200440888453`*^9}, {3.57142028317352*^9, 
   3.5714202880077972`*^9}, {3.5714241012899046`*^9, 3.571424519607831*^9}, {
   3.5714247863140855`*^9, 3.5714248676447372`*^9}, {3.57142544097253*^9, 
   3.5714256007506685`*^9}, {3.571425670690669*^9, 3.5714256741488667`*^9}, {
   3.571425831636874*^9, 3.571425836921177*^9}, {3.585634121932449*^9, 
   3.5856341325980587`*^9}, {3.5856341937455564`*^9, 
   3.5856341941335783`*^9}, {3.639787877455512*^9, 3.6397879169507713`*^9}, {
   3.915673044063938*^9, 3.915673049496289*^9}, {3.9157439609322233`*^9, 
   3.9157439676160593`*^9}, {3.9161841852927694`*^9, 
   3.9161841861659184`*^9}, {3.916184892787761*^9, 
   3.9161848932511673`*^9}},ExpressionUUID->"d081db04-ad29-4987-bc24-\
ff75dd7a62b2"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check Model", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714200516522784`*^9, 
  3.571420058220654*^9}},ExpressionUUID->"d7b69d56-ac6e-44db-b925-\
bf2d9c57cde8"],

Cell[CellGroupData[{

Cell["Check Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714200606427927`*^9, 
  3.571420062613905*^9}},ExpressionUUID->"b8519047-4bc4-4037-9c38-\
67a746348301"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CheckModel", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bdnt", ",", "bdnc", ",", "GNDbod"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"calc$sflag", "=", "0"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Body", " ", "Name"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$bdn", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$bdn", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", "\"\<Bodies are not registered yet.\>\"", 
            "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"And", "@@", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "1", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
             ",", "True"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", 
            "\"\<You need at least one 'ground' body.\>\"", "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"And", "@@", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "1", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
             ",", "False"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", 
            "\"\<You need at least one non-ground body.\>\"", "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bdnt", "=", 
         RowBox[{
          RowBox[{"Tally", "[", 
           RowBox[{"save$bdn", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bdnc", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"bdnt", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "1"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "bdnt", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"bdnc", ",", "False"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", "\"\<Duplicated body names found.\>\"", 
            "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", "Mass", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"save$mass", "[", 
          RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
        RowBox[{"save$mass", "===", 
         RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Mass and moment of inertia are not registered yet.\>\"", "]"}], 
        ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], ">", 
        RowBox[{"Length", "[", "save$mass", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Mass and moment of inertia are not registered completely.\>\"", 
         "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Body", " ", "Shape"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"save$mass", "[", 
          RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
        RowBox[{"save$mass", "===", 
         RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", "\"\<Body shapes are not registered yet.\>\"", 
         "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], ">", 
        RowBox[{"Length", "[", "save$shape", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Body shapes are not registered completely.\>\"", "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Body", " ", "Position"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"save$initpos", "[", 
          RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
        RowBox[{"save$initpos", "===", 
         RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Body initial positions are not registered yet.\>\"", "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], ">", 
        RowBox[{"Length", "[", "save$initpos", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Body initial positions are not registered completely.\>\"", 
         "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", "Wires", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "wire1", ",", "wire2", ",", "wirec", ",", "spt", ",", "spc", ",", 
         "ip1", ",", "ip2", ",", "hl1", ",", "hl2", ",", "GNDbod", ",", 
         "con"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"GNDbod", " ", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"And", "@@", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", "n", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "1", ",", 
              RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$wire", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteStatus", "[", "\"\<No wires registered.\>\"", "]"}], ";", 
           RowBox[{"wire1", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"wire2", "=", 
            RowBox[{"{", "}"}]}], ";"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"wire1", "=", 
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
           RowBox[{"wire2", "=", 
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"wire1", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", 
                RowBox[{"wire2", "[", 
                 RowBox[{"[", "n", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Wire \>\"", "<>", 
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "<>", 
                  "\"\< attached to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wirec", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "14"}], "]"}], "]"}], ">", "0"}], "&&", 
               RowBox[{
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "15"}], "]"}], "]"}], ">", "0"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}]}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{"wirec", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Wire \>\"", "<>", 
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "<>", 
                  "\"\< has 0 or negative stiffness.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "Springs", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$vspr", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$vspr", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "mod$WriteStatus", "[", "\"\<No vertical springs registered.\>\"", 
           "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$vspr", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ">", 
                RowBox[{"Length", "[", "save$wire", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Spring \>\"", "<>", 
                  RowBox[{"save$vspr", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "<>", 
                  "\"\< is not connected to a wire.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}], ">", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Spring \>\"", "<>", 
                  RowBox[{"save$vspr", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "<>", 
                  "\"\< has 0 or negative stiffness.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"spt", "=", 
            RowBox[{
             RowBox[{"Tally", "[", 
              RowBox[{"save$vspr", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "8"}], "]"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"spc", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"spt", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "1"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "spt", "]"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{"spc", ",", "False"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "mod$WriteError", "[", "\"\<Duplicated spring names found.\>\"",
                "]"}], ";", 
              RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "IP", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$IP", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$IP", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteStatus", "[", 
            "\"\<No inverted pendulums registered.\>\"", "]"}], ";", 
           RowBox[{"ip1", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"ip2", "=", 
            RowBox[{"{", "}"}]}], ";"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ip1", "=", 
            RowBox[{"save$IP", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
           RowBox[{"ip2", "=", 
            RowBox[{"save$IP", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$IP", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"save$IP", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Iniverted pendulum \>\"", "<>", 
                  RowBox[{"save$IP", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "<>", 
                  "\"\< attached to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**"}], "*", "Version", " ", "1.1"}], "**"}], "**"}], 
                    "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
              "**"}], "**"}], "**"}], "**"}], "**", "**", "**"}], " ", "*)"}],
         "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "IP", " ", "Version", " ", "1.0", " ", "Compriance", " ", "Check"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}], "\[Equal]", 
              "3"}], ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "0"}], "]"}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}], "\[Equal]", 
              "3"}], ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "1000"}], 
              "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
          "*", "Version", " ", 
          RowBox[{
          "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
            "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "HL", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$HL", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$HL", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteStatus", "[", "\"\<No heat links registered.\>\"", "]"}],
            ";", 
           RowBox[{"hl1", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"hl2", "=", 
            RowBox[{"{", "}"}]}], ";"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"hl1", "=", 
            RowBox[{"save$HL", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
           RowBox[{"hl2", "=", 
            RowBox[{"save$HL", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$HL", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"save$HL", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Heat link \>\"", "<>", 
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "<>", 
                  "\"\< attached to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "damper", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$damp", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$damp", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "mod$WriteStatus", "[", "\"\<No dampers registered.\>\"", "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$damp", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"save$damp", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "3"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Damper \>\"", "<>", 
                  RowBox[{"save$damp", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "<>", 
                  "\"\< affects to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$damp", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"con", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
             "GNDbod", ",", "wire1", ",", "wire2", ",", "ip1", ",", "ip2", 
              ",", "hl1", ",", "hl2"}], "]"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"Floating", " ", "bodies", " ", "check"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{"MemberQ", "[", 
                 RowBox[{"con", ",", "n"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Body \>\"", "<>", 
                  RowBox[{"save$bdn", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "<>", 
                  "\"\< is floating.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
        ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5714200638099737`*^9, 3.571420430009919*^9}, {
   3.5714205030660973`*^9, 3.5714205296026154`*^9}, {3.5714206197497716`*^9, 
   3.571420637482786*^9}, {3.571420676493017*^9, 3.5714208223683605`*^9}, {
   3.5714211179232655`*^9, 3.5714211472949457`*^9}, {3.57142148165907*^9, 
   3.571422014240532*^9}, {3.5714220626413*^9, 3.5714221097819967`*^9}, {
   3.5714221436279325`*^9, 3.571422212207855*^9}, {3.5714222536472254`*^9, 
   3.571422529481002*^9}, {3.571422562296879*^9, 3.571422711018385*^9}, {
   3.571422754620879*^9, 3.5714229088647013`*^9}, {3.5714229531882367`*^9, 
   3.571423188167677*^9}, {3.571423218772427*^9, 3.5714232342003098`*^9}, {
   3.571423276114707*^9, 3.5714233730182495`*^9}, {3.5714234086382866`*^9, 
   3.5714237270975018`*^9}, {3.571423758416293*^9, 3.5714237879019794`*^9}, {
   3.57142385102359*^9, 3.5714240745773764`*^9}, {3.5714249498374386`*^9, 
   3.5714249499914474`*^9}, {3.57142515337008*^9, 3.5714251820657215`*^9}, {
   3.571425252241735*^9, 3.5714252565229797`*^9}, {3.5714253126231885`*^9, 
   3.5714254209143825`*^9}, {3.5714260157514052`*^9, 
   3.5714260166644573`*^9}, {3.5856289055420885`*^9, 
   3.5856290898076277`*^9}, {3.5953085763744345`*^9, 3.5953085864440107`*^9}, 
   3.9157434502880826`*^9, {3.915743491033712*^9, 3.9157434994897366`*^9}, {
   3.9162568669126444`*^9, 3.916256867328257*^9}, {3.9162569121525764`*^9, 
   3.916256971215954*^9}},ExpressionUUID->"bfcfbbae-628e-47d0-bfcf-\
5d7d30638b12"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Setting", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570774312107565*^9, 3.570774312490587*^9}, {
  3.5713414721620803`*^9, 3.571341474019187*^9}, {3.571490369490226*^9, 
  3.571490372099375*^9}},ExpressionUUID->"31fe543b-c67a-434d-a485-\
008f27ece34e"],

Cell[CellGroupData[{

Cell["Set Variables", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570771931900425*^9, 
  3.5707719378307643`*^9}},ExpressionUUID->"7759f317-534d-4ddc-9e5a-\
2f15375ad9d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetVars", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nlist", ",", "tv"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "State"}]}], " ", 
        RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tv", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"allparams", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"allvars", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"IPDofs", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<yaw\>\""}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"NormalDofs", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{
        "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", "\"\<pitch\>\"",
          ",", "\"\<yaw\>\"", ",", "\"\<roll\>\""}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$IP", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], ",", "  ", 
               RowBox[{"(*", " ", 
                RowBox[{
                "This", " ", "clause", " ", "runs", " ", "only", " ", "for", 
                 " ", "IPs"}], " ", "*)"}], "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"allparams", ",", 
                  RowBox[{"ToExpression", "[", 
                   RowBox[{
                    RowBox[{"IPDofs", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "<>", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
                ";"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"allvars", ",", 
                  RowBox[{"ToExpression", "[", 
                   RowBox[{
                    RowBox[{"IPDofs", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "<>", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
                ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"m", ",", 
               RowBox[{"Length", "[", "IPDofs", "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"allparams", ",", 
                  RowBox[{"ToExpression", "[", 
                   RowBox[{
                    RowBox[{"NormalDofs", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "<>", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
                ";"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"allvars", ",", 
                  RowBox[{"ToExpression", "[", 
                   RowBox[{
                    RowBox[{"NormalDofs", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "<>", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
                ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"m", ",", 
               RowBox[{"Length", "[", "NormalDofs", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      RowBox[{"allvars", "=", 
       RowBox[{"Flatten", "[", "allvars", "]"}]}], ";", 
      RowBox[{"allparams", "=", 
       RowBox[{"Flatten", "[", "allparams", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Float"}]}], " ", 
         RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tv", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$vspr", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"tv", ",", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"\"\<h\>\"", "<>", 
              RowBox[{"save$vspr", "[", 
               RowBox[{"[", 
                RowBox[{"n", ",", "8"}], "]"}], "]"}]}], "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}]}], 
       "]"}], ";", 
      RowBox[{"allfloats", "=", "tv"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Velocity", "--"}]}]}], "-"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"velvars", "=", 
       RowBox[{"makevel", "[", "allvars", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"velparams", "=", 
       RowBox[{"makevel", "[", "allparams", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"velfloats", "=", 
       RowBox[{"makevel", "[", "allfloats", "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0FtMEnAUBnDwFimF6yHRmJkLa+Rak8rmi1k81UaNOR+0zbywEiGtNcJm
tdllNTEVHBBCWxI1tJRZiJhaUbmhxnQrq1HOlAhvS7SkhrX+3//h7Pfyfeds
Z1tplUQaxWAwhGTgQt37qpvGuby0Mz/OQnkRsxmmMBM0cEr2Wgc1d9xm+Lvs
9APYH7VvGOrdV300J47MwGqhbB7qVKpFujcwuAKVzI5V6E/PjsCg1Bt9i8jz
yFhwNfbCZlh+3cCDYzq9GO4+Zs6HJ0U1hfCA3FIMhyxOKXSXdlbAFZVMQXOn
hOfhaO49A4yWRMXpiBfrM7fC+JdrBXDBVFIM1d+VVfBcwEllpwSazMRJ78Zm
2FYzyL5LXNrvTYT/7Iq1p0T+US31kDdjvYN4LcHGgezkka+wdlIShiyLn9OD
u1/MibBrRiGA07l9QpiyWFLzjRiOF1yBQcVH4xKxcD5CzfnragvhfwODFmhQ
p2mXiYzyN9TaD8t2USvpMQUOyD3OcjQSO27/6YGVXDlfnbmYl68OU99lt0ig
Z6q6EKrbmxRQUPSLmnMi1AwnfP0mmJq18yHMKN7zGL5ojHRD/64bfTDOnni/
gZgsElvho72xDqp1A7VbWW3sJH4+mGqGlTaNFZYeZtmg5XmMq4vIuxTzDPpm
y15BY2vJKJwOB8ehQJA0CzM49S12YuCJVA+dceuGeok7uFYPvMyVTUB1On8B
thsqQnDTeOMqHDaNbHcRjzSoMmG6I5LUR8zqrdsCC95qB/zEnyaXG9bOfRqD
QXGQ+h+8braY
  "],
 CellLabel->"In[86]:=",ExpressionUUID->"d2c36ac4-50ae-4081-9897-b8786bb95b54"]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Init Value", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708950246658063`*^9, 
  3.5708950298101006`*^9}},ExpressionUUID->"84a468a6-2a9e-4214-b2db-\
24d40146f3a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetInitVal", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "nlist", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "Setup", " ", "rule", " ", "where", " ", "all", " ", "parameters"}], 
       " ", "->", " ", "0"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"subdefparams", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"save$bdn", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"subdefparams", ",", 
               RowBox[{"makesub", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], "}"}], 
                 ",", 
                 RowBox[{"{", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"m", "<=", 
                    RowBox[{"Length", "[", 
                    RowBox[{"save$initpos", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"save$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "m"}], "]"}], "]"}], ",", "0"}], "]"}], 
                  "}"}]}], "]"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"subdefparams", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", "subdefparams", "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Setup", " ", "rule", " ", "where", " ", "all", " ", "variables"}], 
        " ", "->", " ", "0"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"subinitvars", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$IP", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Not", "[", 
             RowBox[{"save$bdn", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"subinitvars", ",", 
              RowBox[{"makesub", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "5"}], "]"}], "]"}]}], "}"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"save$initpos", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"save$initpos", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", "0"}], 
                 "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ",",
           " ", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Case", " ", "to", " ", "run", " ", "for", " ", "IP", " ", 
            "variables"}], " ", "*)"}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"Not", "[", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"subinitvars", ",", 
                 RowBox[{"makesub", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"bodylist", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "m"}], "]"}], "]"}], "}"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"m", "<=", 
                    RowBox[{"Length", "[", 
                    RowBox[{"save$initpos", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"save$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "m"}], "]"}], "]"}], ",", "0"}], "]"}], 
                    "}"}]}], "]"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
          "]"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"subinitvars", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"subinitvars", ",", "1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Setup", " ", "rule", " ", "where", " ", "all", " ", "float", " ", 
         "variables"}], " ", "->", " ", "0"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"subinitfloats", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "allfloats", "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"makesub", "[", 
          RowBox[{"allfloats", ",", 
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{"Length", "[", "allfloats", "]"}], "}"}]}], "]"}]}], 
          "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708950323402452`*^9, 3.5708953948929825`*^9}, {
   3.5708954402705774`*^9, 3.570895578131463*^9}, {3.5708956142555294`*^9, 
   3.5708957352824516`*^9}, {3.5710663274043694`*^9, 3.571066332365653*^9}, {
   3.5710663871217847`*^9, 3.5710664208597145`*^9}, {3.571493292963439*^9, 
   3.571493331861664*^9}, {3.915744463617088*^9, 3.9157445174356146`*^9}, {
   3.9157445639770207`*^9, 3.915744676848863*^9}, {3.9157447081046457`*^9, 
   3.915744768798384*^9}, {3.915748963713146*^9, 3.91574897880927*^9}, 
   3.915749043665096*^9, {3.9157491875909643`*^9, 3.915749188496179*^9}, {
   3.915749381773425*^9, 3.9157494255842314`*^9}, {3.9157496224073963`*^9, 
   3.9157496349171953`*^9}, {3.9157498071893063`*^9, 
   3.9157498199570265`*^9}, {3.9157499286179695`*^9, 
   3.9157499906964464`*^9}, {3.915750047323191*^9, 3.9157500940161905`*^9}, {
   3.9157578916682744`*^9, 3.9157579142080593`*^9}, {3.915758050603481*^9, 
   3.915758051112869*^9}, {3.9157627500702133`*^9, 3.9157627578768315`*^9}, {
   3.915762834031862*^9, 3.9157628553871174`*^9}, 3.9157629416252656`*^9, {
   3.915763211761591*^9, 3.9157632119756823`*^9}, {3.9157639459333277`*^9, 
   3.915763947603994*^9}},
 CellLabel->"In[87]:=",ExpressionUUID->"cc72ccaa-461b-4a54-99f5-305098defc11"]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Body Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570773681498496*^9, 
  3.5707736850527*^9}},ExpressionUUID->"54947013-b980-47d3-9e51-11b12e4e0d38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetBodyPos", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nlist", ",", "logic"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "State"}]}], " ", 
        RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$IP", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"save$bodypos", "=", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<x\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"ToExpression", "[", 
               RowBox[{"\"\<y\>\"", "<>", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "2"}], "]"}], "]"}]}], "]"}], "+", 
              "\[IndentingNewLine]", 
              RowBox[{"save$IP", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Position", "[", 
                   RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "7"}], "]"}], 
               "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<z\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<pitch\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$IP", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                   "]"}], ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<yaw\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<roll\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$IP", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                   "]"}], ",", "2"}], "]"}], "]"}]}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Flatten", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"ToExpression", "[", 
               RowBox[{"m", "<>", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
                  "\"\<pitch\>\"", ",", "\"\<yaw\>\"", ",", "\"\<roll\>\""}], 
                 "}"}]}], "}"}]}], "]"}], "]"}]}], "\[IndentingNewLine]", 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}], 
      ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.57077369222611*^9, 3.570773706759941*^9}, {
   3.570773974150235*^9, 3.5707739963635054`*^9}, {3.57077402931439*^9, 
   3.570774128698075*^9}, {3.5707744630681996`*^9, 3.570774515979226*^9}, {
   3.5707747982243695`*^9, 3.570774823479814*^9}, {3.5707748607879477`*^9, 
   3.570774875261776*^9}, {3.5707749850570555`*^9, 3.570775003632118*^9}, {
   3.5707750758262477`*^9, 3.570775216426289*^9}, {3.570775265808114*^9, 
   3.5707753524640703`*^9}, {3.5707754181798286`*^9, 3.570775457379071*^9}, {
   3.5707759226986856`*^9, 3.570776032007938*^9}, {3.5707760806747217`*^9, 
   3.570776101539915*^9}, 3.5707761335107436`*^9, {3.570776391468498*^9, 
   3.5707763915855045`*^9}, {3.5707764223752656`*^9, 3.570776424310376*^9}, {
   3.570776465213716*^9, 3.570776614126233*^9}, {3.5710664488333144`*^9, 
   3.5710665006772795`*^9}, {3.5710665733814383`*^9, 
   3.5710666081964293`*^9}, {3.5710690235775814`*^9, 3.571069032325082*^9}, {
   3.571071817003356*^9, 3.57107182179163*^9}, {3.5710729004063234`*^9, 
   3.5710729294189825`*^9}, {3.5712199102764935`*^9, 3.571219917571911*^9}, {
   3.9156735058195314`*^9, 3.915673553329613*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"8f0ef270-1168-4cde-9843-e4a52ea1eaa3"]
}, Closed]],

Cell[CellGroupData[{

Cell["Set List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570783935417987*^9, 3.5707839392542067`*^9}, {
  3.570784466116341*^9, 
  3.570784467717433*^9}},ExpressionUUID->"088276b3-c07d-4fc5-a6f1-\
9b3bfa54a030"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetList", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "nlist", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$vspr", "]"}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$vspr", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"bodylist", "=", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"save$bodypos", "[", 
            RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ValueQ", "[", "save$IP", "]"}], "&&", 
         RowBox[{"Not", "[", 
          RowBox[{"save$IP", "===", 
           RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"bodylist", ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"b2s", "[", 
                 RowBox[{
                  RowBox[{"save$bodypos", "[", 
                   RowBox[{"[", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], "-", "\[IndentingNewLine]", 
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}]}], ")"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "/", 
                   RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}]}], ",", "0", ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], "-", "\[IndentingNewLine]", 
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}]}], ")"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}], "]"}], ",", 
              "\[IndentingNewLine]", "0", ",", 
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"{", "6", "}"}], ",", 
                RowBox[{"{", "6", "}"}]}], "]"}], ",", 
              "\"\<DoubleCylinder[y]\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"0.15", ",", "0.2", ",", 
                RowBox[{"save$IP", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "7"}], "]"}], "]"}], ",", "0.2", ",", 
                "0.15"}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
           "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"wirelist", "=", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"save$bodypos", "[", 
            RowBox[{"[", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "2"}], "]"}], "]"}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}], "*", 
             "\[IndentingNewLine]", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "11"}], "]"}], "]"}]}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<h\>\"", "<>", 
                   RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "8"}], "]"}], 
                    "]"}]}], "]"}], "*", "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "7"}], "]"}], 
                  "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$bodypos", "[", 
            RowBox[{"[", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "4"}], "]"}], "]"}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}], "*", 
             "\[IndentingNewLine]", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "12"}], "]"}], "]"}]}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<h\>\"", "<>", 
                   RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "8"}], "]"}], 
                    "]"}]}], "]"}], "*", "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "7"}], "]"}], 
                  "]"}], "*", 
                 RowBox[{"(", 
                  RowBox[{"-", "1"}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "6"}], "]"}], "]"}], "-", 
            RowBox[{"2", "*", 
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$wire", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "14"}], "]"}], "]"}], ",", 
           RowBox[{"save$wire", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "15"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"save$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
             "]"}], "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
               "]"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"save$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
             "]"}], "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
               "]"}], ")"}]}], "*", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}], "/", 
             "\[IndentingNewLine]", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "6"}], "]"}], "]"}]}]}], 
           RowBox[{"(*", 
            RowBox[{"/", "2"}], "*)"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"save$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
             "]"}], "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
               "]"}], ")"}]}]}]}], "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ValueQ", "[", "save$vspr", "]"}], "&&", 
         RowBox[{"Not", "[", 
          RowBox[{"save$vspr", "===", 
           RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"bodylist", ",", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}], "\[Equal]", "1"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"b2s", "[", 
                   RowBox[{
                    RowBox[{"wirelist", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", 
                    RowBox[{"wirelist", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"wirelist", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1", ",", 
                    RowBox[{"4", ";;", "6"}]}], "]"}], "]"}]}], "]"}]}], 
               "]"}], ",", "\[IndentingNewLine]", "0", ",", 
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"{", "6", "}"}], ",", 
                RowBox[{"{", "6", "}"}]}], "]"}], ",", "\"\<Cylinder[y]\>\"", 
              ",", 
              RowBox[{"{", 
               RowBox[{"0.1", ",", "0.03", ",", "0.0", ",", "0", ",", "0"}], 
               "}"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]",
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"damperlist", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"save$damp", "[", 
           RowBox[{"[", "0", "]"}], "]"}], "=!=", "List"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"save$bodypos", "[", 
              RowBox[{"[", 
               RowBox[{"save$damp", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "]"}], ",", 
             RowBox[{"save$damp", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"save$bodypos", "[", 
              RowBox[{"[", 
               RowBox[{"save$damp", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}], "]"}], ",", 
             RowBox[{"save$damp", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", 
             RowBox[{"save$damp", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "6"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$damp", "]"}]}], "}"}]}], "]"}]}], 
        "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5707841738916273`*^9, 3.570784335591876*^9}, {
   3.5707843669036665`*^9, 3.57078437184995*^9}, {3.570784831433236*^9, 
   3.570785319451149*^9}, {3.5707853579763527`*^9, 3.5707854094772987`*^9}, {
   3.5707854425911922`*^9, 3.5707856571314635`*^9}, {3.5707857055252314`*^9, 
   3.5707858151345005`*^9}, {3.570785999172027*^9, 3.570786012128768*^9}, {
   3.570788992809534*^9, 3.5707890623245106`*^9}, {3.5707891346876493`*^9, 
   3.5707891433571453`*^9}, {3.5707891816073327`*^9, 3.570789188790744*^9}, {
   3.570789224897809*^9, 3.5707892267809167`*^9}, {3.570789349942961*^9, 
   3.5707894128775606`*^9}, {3.5707895041887836`*^9, 3.57078950517984*^9}, {
   3.5707896653680024`*^9, 3.5707896906074457`*^9}, {3.570789725939467*^9, 
   3.5707897314407816`*^9}, {3.570790006057489*^9, 3.5707900152600155`*^9}, {
   3.570894056376424*^9, 3.5708941150687804`*^9}, {3.57098182282387*^9, 
   3.5709818371706905`*^9}, {3.570981943359764*^9, 3.570981971714386*^9}, {
   3.5710693851902647`*^9, 3.5710694910213175`*^9}, {3.571069523003147*^9, 
   3.571069791520505*^9}, {3.5710698662377787`*^9, 3.571069872364129*^9}, {
   3.5710699050309973`*^9, 3.571070028564063*^9}, {3.5710701023092813`*^9, 
   3.571070216050787*^9}, {3.571071566204011*^9, 3.57107161688791*^9}, {
   3.5710717351026716`*^9, 3.5710717364077463`*^9}, {3.5710719521550865`*^9, 
   3.5710719581494293`*^9}, {3.5710720453404164`*^9, 3.571072047644548*^9}, {
   3.5710721359606*^9, 3.5710722027804213`*^9}, {3.571073167721613*^9, 
   3.571073175956084*^9}, {3.571073342892632*^9, 3.5710733785466714`*^9}, 
   3.5710734162738295`*^9, {3.5710734786573973`*^9, 3.571073480246488*^9}, {
   3.571131092825755*^9, 3.5711311045914283`*^9}, {3.5711312270584326`*^9, 
   3.571131227985486*^9}, 3.571131278690386*^9, {3.5711317757328153`*^9, 
   3.5711317789730005`*^9}, {3.571131830870969*^9, 3.571131832773078*^9}, {
   3.5711319758712626`*^9, 3.571131978192395*^9}, {3.5712202721961946`*^9, 
   3.5712202757894*^9}, {3.5714293225785446`*^9, 3.5714293558624487`*^9}, {
   3.590644977327157*^9, 3.590644985138604*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"e9597900-eea4-4e5d-8031-2334a5a51a0f"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Energy Calculation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714903942226405`*^9, 
  3.5714904064843416`*^9}},ExpressionUUID->"c02aba2d-4b57-40a1-98f5-\
05c2485ef992"],

Cell[CellGroupData[{

Cell["Calculate Energy", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708941280235214`*^9, 3.5708941354829483`*^9}, {
  3.5708947442697687`*^9, 
  3.570894744954808*^9}},ExpressionUUID->"63249716-d17a-4363-bc78-\
2019e0e84f15"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcEnergy", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"e$kin", "=", 
       RowBox[{
        RowBox[{"makekinetic", "[", "bodylist", "]"}], "+", 
        RowBox[{"makekineticvspr", "[", "save$vspr", "]"}], "+", 
        RowBox[{"makekineticIP", "[", "save$IP", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"e$pot", "=", 
       RowBox[{
        RowBox[{"makegravpot", "[", "bodylist", "]"}], "+", 
        RowBox[{"makewirepot", "[", "wirelist", "]"}], "+", 
        RowBox[{"maketorsionpot", "[", "wirelist", "]"}], "+", 
        "\[IndentingNewLine]", 
        RowBox[{"makevsprpot", "[", "save$vspr", "]"}], "+", 
        RowBox[{"makeIPpot", "[", "save$IP", "]"}], "+", 
        RowBox[{"makebsprpot", "[", "save$bspr", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"e$potc", "=", 
       RowBox[{
        RowBox[{"makegravpot", "[", "bodylist", "]"}], "+", 
        RowBox[{"makewirepotc2", "[", "wirelist", "]"}], "+", 
        RowBox[{"maketorsionpotc", "[", "wirelist", "]"}], "+", 
        "\[IndentingNewLine]", 
        RowBox[{"makevsprpotc", "[", "save$vspr", "]"}], "+", 
        RowBox[{"makeIPpotc", "[", "save$IP", "]"}], "+", 
        RowBox[{"makeHLpotc", "[", "save$HL", "]"}], "+", 
        RowBox[{"makebsprpotc", "[", "save$bspr", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"e$damp", "=", 
       RowBox[{"makedamping", "[", "damperlist", "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708941812795677`*^9, 3.5708941821076145`*^9}, 
   3.570895406170627*^9, {3.5708965076256266`*^9, 3.5708965299429035`*^9}, {
   3.571069051905202*^9, 3.571069054806368*^9}, {3.571069142349375*^9, 
   3.571069145780571*^9}, {3.57107231028057*^9, 3.5710723181430197`*^9}, {
   3.915667454427929*^9, 3.915667474909854*^9}, {3.9157616307700777`*^9, 
   3.9157616491291084`*^9}, {3.9157639687287874`*^9, 3.9157639862724237`*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"e4086c72-386f-407b-87a1-abec62764769"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Find Eq", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490420571147*^9, 
  3.571490421751215*^9}},ExpressionUUID->"29b30d6e-3b61-481f-9d10-\
6fe3e7c9b9e1"],

Cell[CellGroupData[{

Cell["Find Equilibrium", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570895768458349*^9, 
  3.570895771669533*^9}},ExpressionUUID->"28558f91-c82f-4835-9dae-\
e988f209284b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FindEquilibrium", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"e$pot0", "=", 
      RowBox[{"e$pot", "/.", "subdefparams"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"subminvars", "=", 
      RowBox[{
       RowBox[{"FindMinimum", "[", "\[IndentingNewLine]", 
        RowBox[{"e$pot0", ",", "\[IndentingNewLine]", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"comb", "[", 
            RowBox[{"allvars", ",", 
             RowBox[{"allvars", "/.", "subinitvars"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"comb", "[", 
            RowBox[{"allfloats", ",", 
             RowBox[{"allfloats", "/.", "subinitfloats"}]}], "]"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Method", "\[Rule]", "\"\<Newton\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"MaxIterations", "\[Rule]", "100000"}]}], 
        "\[IndentingNewLine]", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"EulerLagrange", "[", 
       RowBox[{"variable_", ",", "Lagrangian_"}], "]"}], " ", ":=", " ", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"D", "[", 
           RowBox[{"Lagrangian", ",", " ", 
            RowBox[{"D", "[", 
             RowBox[{"variable", ",", "t"}], "]"}]}], "]"}], " ", ")"}], ",", 
         "t"}], "]"}], "-", " ", 
       RowBox[{"D", "[", 
        RowBox[{"Lagrangian", ",", " ", "variable"}], "]"}]}]}], ";"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570895796480952*^9, 3.5708958093856897`*^9}, {
   3.570895858474498*^9, 3.5708958669189806`*^9}, {3.570895930233602*^9, 
   3.5708959371019945`*^9}, {3.5708959771672864`*^9, 
   3.5708960135313663`*^9}, {3.570896349135562*^9, 3.5708964123731785`*^9}, {
   3.5708972981808443`*^9, 3.5708973250833826`*^9}, {3.5708973799475207`*^9, 
   3.5708973815666137`*^9}, {3.5708978894976654`*^9, 3.5708978963350563`*^9}, 
   3.5708981302494354`*^9, 3.5708983339310856`*^9, 3.915755961318746*^9, {
   3.915757435015616*^9, 3.915757446079373*^9}, 3.915758066703497*^9},
 CellLabel->"In[91]:=",ExpressionUUID->"874d12c6-89a6-4fd5-86d8-6f0251f0db5a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calculate Matrices", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708983167771044`*^9, 3.570898319081236*^9}, {
  3.915750357948015*^9, 
  3.915750362531461*^9}},ExpressionUUID->"4c77b806-86cc-4927-969f-\
9ed215b90554"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$CalcMatrices", ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "mod$WriteStatus", "[", "\"\<Calculating Mass Matrix 'M'...\>\"", "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"matMvv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$kin", ",", "velvars", ",", "velvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matMpv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$kin", ",", "velvars", ",", "velparams"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
      "mod$WriteStatus", "[", 
       "\"\<Calculating real part of Stiffness Matrix 'K'...\>\"", "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"matKvv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$pot", ",", "allvars", ",", "allvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matKpv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$pot", ",", "allvars", ",", "allparams"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "allfloats", "]"}], "\[GreaterEqual]", "1"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"matKfv", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$pot", ",", "allvars", ",", "allfloats"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"matKfp", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$pot", ",", "allparams", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKff", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$pot", ",", "allfloats", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKvv", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfv", ".", 
             RowBox[{"Inverse", "[", "matKff", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfv", "]"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"matKpv", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfv", ".", 
             RowBox[{"Inverse", "[", "matKff", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfp", "]"}]}], "]"}]}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
      "mod$WriteStatus", "[", 
       "\"\<Calculating complex Stiffness Matrix 'Kc'...\>\"", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matKvvc", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$potc", ",", "allvars", ",", "allvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matKpvc", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$potc", ",", "allvars", ",", "allparams"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "allfloats", "]"}], "\[GreaterEqual]", "1"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"matKfvc", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$potc", ",", "allvars", ",", "allfloats"}], "]"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"matKfpc", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$potc", ",", "allparams", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKffc", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$potc", ",", "allfloats", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKvvc", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfvc", ".", 
             RowBox[{"Inverse", "[", "matKffc", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfvc", "]"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"matKpvc", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfvc", ".", 
             RowBox[{"Inverse", "[", "matKffc", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfpc", "]"}]}], "]"}]}]}], ";"}]}],
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
      "mod$WriteStatus", "[", "\"\<Calculating Damping Matrix 'G'...\>\"", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"matGvv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$damp", ",", "velvars", ",", "velvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matGpv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$damp", ",", "velvars", ",", "velparams"}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708983207423315`*^9, 3.5708983246435547`*^9}, {
  3.5708984964593816`*^9, 3.5708986388375254`*^9}, {3.5714245498475604`*^9, 
  3.5714246568956833`*^9}, {3.5714246878434534`*^9, 3.5714247785686426`*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"9feca8c1-1581-4af0-80a6-db8aa716b4c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Eigen calc", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571329434817584*^9, 
  3.571329436095657*^9}},ExpressionUUID->"ccdfd1ab-7df0-452e-a750-\
2b932f6b9a90"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EigenCalc", ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"eigen", "=", 
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Inverse", "[", "matMvv", "]"}], ".", 
         RowBox[{"Re", "[", "matKvv", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"eigenf", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"Abs", "[", 
           RowBox[{"eigen", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", 
           RowBox[{"N", "[", "Pi", "]"}]}], ")"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"eigenv", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{"eigen", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$eigenP", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "eigenf", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"temp$eigenP", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "eigenf", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Converting", " ", "Variables", " ", "and", " ", "Parameters", " ", 
        "to", " ", "time", " ", "varying", " ", "variables"}], " ", "*)"}], 
      "\n", "\t", 
      RowBox[{"ParametersAsTimeBased", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"allparams", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], "<>", "\"\<[t]\>\""}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{
       "To", " ", "avoid", " ", "output", " ", "and", " ", "input", " ", 
        "name", " ", "doubles"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"VariablesAsTimeBased", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], "<>", "\"\<[t]\>\""}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\n", "\t", 
      RowBox[{"DrivingForceTerms", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"\"\<F\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"VariablesAsTimeBased", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "VariablesAsTimeBased", "]"}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Reforming", " ", "the", " ", "equations", " ", "of", " ", "motion"}], 
       " ", "*)"}], "\n", "\t", 
      RowBox[{"SpringForceTerms", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"matKpvc", ".", "ParametersAsTimeBased"}], ")"}], " ", "+", 
        " ", 
        RowBox[{"(", 
         RowBox[{"matKvvc", ".", "VariablesAsTimeBased"}], ")"}]}]}], ";", 
      "\n", "\t", 
      RowBox[{"DampingForceTerms", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"matGpv", ".", 
          RowBox[{"D", "[", 
           RowBox[{"ParametersAsTimeBased", ",", "t"}], "]"}]}], ")"}], " ", 
        "+", " ", 
        RowBox[{"(", 
         RowBox[{"matGvv", ".", 
          RowBox[{"D", "[", 
           RowBox[{"VariablesAsTimeBased", ",", "t"}], "]"}]}], ")"}]}]}], 
      ";", "\n", "\t", 
      RowBox[{"InertialForceTerms", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"matMpv", ".", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{"ParametersAsTimeBased", ",", "t"}], "]"}], ",", "t"}], 
           "]"}]}], ")"}], " ", "+", " ", 
        RowBox[{"(", 
         RowBox[{"matMvv", ".", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{"VariablesAsTimeBased", ",", "t"}], "]"}], ",", "t"}], 
           "]"}]}], ")"}]}]}], ";", "\n", "\t", 
      RowBox[{"LHSEquationsOfMotion", " ", "=", " ", 
       RowBox[{
       "InertialForceTerms", "+", "DampingForceTerms", "+", 
        "SpringForceTerms"}]}], ";", "\n", "\t", 
      RowBox[{"RHSEquationsOfMotion", " ", "=", " ", "DrivingForceTerms"}], 
      ";", "\n", "\t", 
      RowBox[{"EquationsOfMotion", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"LHSEquationsOfMotion", "[", 
            RowBox[{"[", "n", "]"}], "]"}], "-", 
           RowBox[{"RHSEquationsOfMotion", "[", 
            RowBox[{"[", "n", "]"}], "]"}]}], " ", "==", " ", "0"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "LHSEquationsOfMotion", "]"}]}], "}"}]}], 
        "]"}]}], ";", "\n", "\t", 
      RowBox[{"(*", " ", "Solving", " ", "*)"}], " ", "\[IndentingNewLine]", 
      RowBox[{"AllEquationsSolEq", " ", "=", " ", 
       RowBox[{"Equal", "@@@", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Solve", "[", 
          RowBox[{"EquationsOfMotion", ",", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"D", "[", 
              RowBox[{"VariablesAsTimeBased", ",", "t"}], "]"}], ",", "t"}], 
            "]"}]}], "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Defining"}], " ", "all", " ", "states", " ", "to",
          " ", "keep", " ", "within", " ", "the", " ", "system"}], " ", "-"}],
        " ", "*)"}], "\n", "\t", 
      RowBox[{"AllFactors", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", "VariablesAsTimeBased", "}"}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Defining"}], " ", "the", " ", "driving", " ", 
         "terms"}], " ", "-"}], " ", "*)"}], "\n", "\t", 
      RowBox[{"InputVariables", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
         "ParametersAsTimeBased", " ", ",", " ", "DrivingForceTerms"}], "}"}],
         "]"}]}], ";", "\n", "\t", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Defining"}], " ", "the", " ", "output", " ", 
         "coordinates"}], " ", "-"}], " ", "*)"}], "\n", "\t", 
      RowBox[{"OutputVariables", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{"ParametersAsTimeBased", " ", ",", "VariablesAsTimeBased"}],
           "}"}], "]"}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Generating"}], " ", "the", " ", "statespace", " ",
          "model"}], " ", "-"}], " ", "*)"}], "\n", "\t", 
      RowBox[{"SystemStateSpace", " ", "=", 
       RowBox[{"StateSpaceModel", "[", 
        RowBox[{
        "AllEquationsSolEq", ",", "AllFactors", ",", "InputVariables", ",", 
         "OutputVariables", ",", "t"}], " ", "]"}]}], ";", "\n", "\t", 
      RowBox[{"eigenc", " ", "=", " ", 
       RowBox[{"Eigensystem", "[", " ", 
        RowBox[{"N", "[", 
         RowBox[{"SystemStateSpace", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"temp$ComplexFreqResults", " ", "=", " ", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"eigenc", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"2", "*", 
          RowBox[{"N", "[", "Pi", "]"}]}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"temp$ModeQs", " ", "=", " ", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"eigenc", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "/", 
        RowBox[{"Abs", "[", 
         RowBox[{"2", "*", 
          RowBox[{"Re", "[", 
           RowBox[{"eigenc", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CorrectedModeQ", " ", "=", " ", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"temp$ModeQs", "[", 
           RowBox[{"[", "n", "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "1", ",", 
            RowBox[{"Length", "[", "temp$ModeQs", "]"}], ",", "2"}], "}"}]}], 
         "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBmIQ/aJP8w2zxitHxzKNbyDaxit8LQuQ9nsUsg5EFyz/
IMQKpLturxQG0e9275QF0RU9unIg2u2EaxyIjgqPjAfR7kcS+HqAtNxdWxEQ
7cL6YMdPIP0m2XAniI4r/mtydPYrx3smBeYg+tRGaeMIudeOC2unmoLodcmT
mrfqvHV0ucXaAqIDXvl+fAKk54iEgembXO1fQXSRzSUw/X97yZJ23beOvga/
l4LodbULt4PosBe9O0B0m8z2IyB62guJoyC6qzXwIohuLW28AqKZry54CKL9
9h4E0xKLozw7gTTL/g5fEL3WuKAGRP80WN8EogFPmZT5
  "],ExpressionUUID->"9ecde21a-ecc3-4c84-8291-abe801554927"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4. Frequency Domain Plot", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5714906643970933`*^9, 
  3.5714906722365417`*^9}},ExpressionUUID->"bfd0cb85-028e-43ef-81bf-\
fed3228f16b0"],

Cell[CellGroupData[{

Cell["Base", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571167767161003*^9, 3.5711677673760157`*^9}, {
  3.5713414902011127`*^9, 3.5713414910931635`*^9}, {3.571490706387495*^9, 
  3.57149072324846*^9}, {3.5714907985727677`*^9, 
  3.5714908037900662`*^9}},ExpressionUUID->"328cea57-80d8-42f2-b4fe-\
663fdbcec5d0"],

Cell[CellGroupData[{

Cell["Plot Base Option", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490767383984*^9, 
  3.5714907957736073`*^9}},ExpressionUUID->"c3b28930-973f-4c81-b320-\
0523bdf392fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"baseoptmag", "=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontSize", "\[Rule]", "15"}], ",", "Bold"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", "\"\<Magnitude\>\""}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"GridLinesStyle", "\[Rule]", "Dashed"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "mygrids2"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ImageSize", "\[Rule]", "480"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "0.6"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571490779917701*^9, 3.5714907856460285`*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"4da89b0d-e357-48de-89be-a3d639b8ba3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"baseoptphs", "=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontSize", "\[Rule]", "15"}], ",", "Bold"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Frequency [Hz]\>\"", ",", "\"\<Phase [deg]\>\""}], 
        "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"GridLinesStyle", "\[Rule]", "Dashed"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "180"}], ",", 
             RowBox[{"-", "90"}], ",", "0", ",", "90", ",", "180"}], "}"}], 
           ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "180"}], ",", 
           RowBox[{"-", "90"}], ",", "0", ",", "90", ",", "180"}], "}"}]}], 
        "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"ImageSize", "\[Rule]", "480"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "0.2"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.571490787015107*^9},
 CellLabel->"In[95]:=",ExpressionUUID->"c78d4adb-fb92-41aa-9d82-a6bcbd51a006"],

Cell[BoxData[
 RowBox[{
  RowBox[{"baseoptpsd", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontSize", "\[Rule]", "15"}], ",", "Bold"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Frequency [Hz]\>\"", ",", 
        RowBox[{"Dynamic", "[", "amplabel", "]"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GridLinesStyle", "\[Rule]", "Dashed"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GridLines", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "mygrids2"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ImageSize", "\[Rule]", "480"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.8"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellLabel->"In[96]:=",ExpressionUUID->"02d3a0df-9aae-4774-9db2-a5de535e9af1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5711677559033594`*^9, 
  3.5711677568084106`*^9}},ExpressionUUID->"d3fe0d64-f685-4ebc-9026-\
e787ac462100"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"takemag", "[", 
    RowBox[{"tf_List", ",", "show_List"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "tf", "]"}], "\[Equal]", "0"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"show", ",", "True"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.01", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"100", ",", "1"}], "}"}]}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tf", "[", 
          RowBox[{"[", 
           RowBox[{"n", ",", "m", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"Abs", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"show", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "tf", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"takephs", "[", 
    RowBox[{"tf_List", ",", "show_List"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "tf", "]"}], "\[Equal]", "0"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"show", ",", "True"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.01", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"100", ",", "0"}], "}"}]}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tf", "[", 
          RowBox[{"[", 
           RowBox[{"n", ",", "m", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Arg", "[", 
           RowBox[{"tf", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "m", ",", "2"}], "]"}], "]"}], "]"}], "*", 
          RowBox[{"180", "/", 
           RowBox[{"N", "[", "Pi", "]"}]}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"show", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "tf", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"takepsd", "[", 
    RowBox[{"tf_List", ",", "show_List"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "tf", "]"}], "\[Equal]", "0"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"show", ",", "True"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.01", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"100", ",", "1"}], "}"}]}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"show", "[", 
          RowBox[{"[", "n", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tf", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "m", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"tf", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "m", ",", "2"}], "]"}], "]"}]}], "}"}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"show", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "tf", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571167770375187*^9, 3.5711678918541355`*^9}, {
   3.5711679526256113`*^9, 3.571167959037978*^9}, {3.571210142750823*^9, 
   3.571210196124876*^9}, {3.5712105160751762`*^9, 3.5712105226225505`*^9}, {
   3.571213223971059*^9, 3.5712132623762555`*^9}, {3.5712134110897617`*^9, 
   3.5712134131688805`*^9}, {3.571218435402136*^9, 3.5712184400133996`*^9}, {
   3.5712205568144736`*^9, 3.5712205661880093`*^9}, {3.571227577728047*^9, 
   3.5712275836543856`*^9}, {3.571239332159362*^9, 3.571239376202881*^9}, 
   3.57123943457822*^9, {3.571239580276553*^9, 3.5712395851068296`*^9}, {
   3.571239804669388*^9, 3.5712398088716283`*^9}, {3.5712398886361904`*^9, 
   3.5712399390550747`*^9}, {3.57124012151451*^9, 3.571240214320819*^9}, {
   3.5712403711257877`*^9, 3.571240373512924*^9}, {3.571240559870583*^9, 
   3.571240580405758*^9}, 3.571240619316983*^9, {3.5712406506927776`*^9, 
   3.5712407587899604`*^9}, {3.5712412682501*^9, 3.5712413660086913`*^9}, {
   3.5712508068316755`*^9, 3.5712508904104557`*^9}, {3.571250938878228*^9, 
   3.5712509680838985`*^9}, {3.571251969446173*^9, 3.571251975209503*^9}, {
   3.5712964006244917`*^9, 3.571296438874679*^9}, {3.571296475513775*^9, 
   3.571296478828964*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"96fb7d52-d5b9-4cd1-8950-dfebc46277be"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate TFs", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490810592455*^9, 
  3.57149081365063*^9}},ExpressionUUID->"d410bfa3-8eed-4e53-841b-\
bcdaf280c96d"],

Cell[CellGroupData[{

Cell["Calculation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571214833029092*^9, 3.571214833400113*^9}, {
  3.571490695337863*^9, 3.571490696105907*^9}, {3.571490819869986*^9, 
  3.5714908201450014`*^9}},ExpressionUUID->"78c1a415-e005-4db1-ac26-\
73b3d2607aba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcFreqPlot", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"mod$OpenStatus", ";", "\[IndentingNewLine]", 
     RowBox[{"mod$WriteStatus", "[", "\"\<Set frequency list.\>\"", "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"fgridtype", ",", "\[IndentingNewLine]", 
       RowBox[{"freq", "=", 
        RowBox[{"makefreqlist", "[", 
         RowBox[{"fmin", ",", "fmax", ",", "ngrid"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"freq", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"fmin", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"n", "-", "1"}], ")"}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"ngrid", "-", "1"}], ")"}]}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "ngrid"}], "}"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"calc$xrange", "=", 
        RowBox[{"{", 
         RowBox[{"fmin", ",", "fmax"}], "}"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
     "mod$WriteStatus", "[", "\"\<Load heat link stiffness.\>\"", "]"}], ";", 
     "\[IndentingNewLine]", "mod$LoadkHL", ";", "\[IndentingNewLine]", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[Equal]", "1"}], ",", "mod$CalcTFf", ",", 
       RowBox[{"calc$tfk", "\[Equal]", "2"}], ",", "mod$CalcTFs", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"calc$tfk", "\[Equal]", "3"}], ",", "mod$CalcSN", ",", 
       RowBox[{"calc$tfk", "\[Equal]", "4"}], ",", "mod$CalcTN"}], "]"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"mod$WriteStatus", "[", "\"\<Calculation finished!!\>\"", "]"}], 
     ";", "\[IndentingNewLine]", "mod$CloseStatus", ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712148356822433`*^9, 3.571214914110729*^9}, {
   3.571215286378022*^9, 3.571215332173641*^9}, {3.5712169711223836`*^9, 
   3.571216976178673*^9}, {3.571237209888975*^9, 3.571237219717537*^9}, {
   3.571302942035639*^9, 3.5713029753775454`*^9}, 3.5714162573212547`*^9, {
   3.571427133943362*^9, 3.571427199380105*^9}, {3.5714273838146544`*^9, 
   3.571427403435776*^9}, {3.590781456561695*^9, 3.590781460982948*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"f18b522e-b4bc-4796-87ec-c5c5e4ac6bda"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Load kHL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571215828806047*^9, 3.5712158321002355`*^9}, {
  3.571215908031578*^9, 
  3.571215909236647*^9}},ExpressionUUID->"34cef96f-305c-4b52-aaf1-\
1d95353e3e90"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$LoadkHL", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"data", ",", "kHL", ",", "int"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"subkHL", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "freq", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$HL", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Not", "[", 
             RowBox[{
              RowBox[{"save$HL", "[", 
               RowBox[{"[", 
                RowBox[{"n", ",", "9", ",", "m", ",", "l"}], "]"}], "]"}], 
              "\[Equal]", "\"\<\>\""}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"data", "=", 
              RowBox[{"Import", "[", 
               RowBox[{
                RowBox[{"\"\<HeatLink/\>\"", "<>", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "9", ",", "m", ",", "l"}], "]"}], "]"}], 
                 "<>", "\"\<.txt\>\""}], ",", "\"\<Table\>\""}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"kHL", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"data", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"data", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "+", 
                   RowBox[{"I", " ", 
                    RowBox[{"data", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}]}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"int", "=", 
              RowBox[{"Interpolation", "[", "kHL", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Do", "[", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{
                 RowBox[{"subkHL", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"ToExpression", "[", 
                   RowBox[{"\"\<kHL$\>\"", "<>", 
                    RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9", ",", "m", ",", "l"}], "]"}], 
                    "]"}]}], "]"}], "\[Rule]", 
                  RowBox[{"int", "[", 
                   RowBox[{"freq", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", 
                 RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "6"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"l", ",", "6"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712159034833183`*^9, 3.571216081050474*^9}, {
   3.5712162972618413`*^9, 3.571216333209897*^9}, {3.5712163797515593`*^9, 
   3.5712164412280755`*^9}, {3.571216474243964*^9, 3.5712164772761374`*^9}, {
   3.571216507427862*^9, 3.571216681160799*^9}, {3.5712167134606466`*^9, 
   3.571216865748357*^9}, 3.5712170726281896`*^9, {3.571217638899578*^9, 
   3.571217640932695*^9}, {3.5712321708177567`*^9, 3.571232191399934*^9}, {
   3.571232279553976*^9, 3.5712323122928486`*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"cdb6128e-ac87-4c1c-b56e-1117a8ac78a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Set Seism", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571232520143737*^9, 
  3.571232521622822*^9}},ExpressionUUID->"9a174bbc-0917-4b33-93e0-\
40994d7443ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetSeism", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "calc$seism", "]"}], "&&", 
            RowBox[{
             RowBox[{"Length", "[", "calc$seism", "]"}], "\[Equal]", 
             RowBox[{"Length", "[", "allparams", "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"temp$seism", "=", "calc$seism"}], ",", 
           RowBox[{"temp$seism", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"temp$sCB", "=", 
          RowBox[{"Table", "[", 
           RowBox[{"False", ",", 
            RowBox[{"{", 
             RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Load Seismic Injection\>\"", ",", "\[IndentingNewLine]", 
             "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Style", "[", 
         RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Checkbox", "[", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$sCB", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"allparams", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$seism", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"15.", ",", "1."}], "}"}]}], ",", 
                   RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"Pane", "[", 
              RowBox[{
               RowBox[{"TableForm", "[", 
                RowBox[{
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<Seismic\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$sCB", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$seism", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "=", 
                    "\[IndentingNewLine]", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<Seismic\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$sCB", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "=", "False"}]}]}], "]"}],
                     ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<Seismic\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "2", 
                   ",", "2", ",", "1", ",", 
                   RowBox[{"{", "}"}]}], "]"}], ",", 
                 RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",",
                "\[IndentingNewLine]", 
               RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"320", ",", "300"}], "}"}]}], ",", 
               RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
             "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
          "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"calc$seism", "=", "temp$seism"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
              RowBox[{"DialogReturn", "[", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "}"}], 
          "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"600", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowMargins", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Seismic Injection\>\""}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571232524381979*^9, 3.571232535614622*^9}, {
   3.571232573980816*^9, 3.5712326047605767`*^9}, {3.5712326433767853`*^9, 
   3.5712326487080903`*^9}, {3.5712356963004026`*^9, 
   3.5712357280142164`*^9}, {3.571235831278123*^9, 3.5712358419447327`*^9}, {
   3.5712362077086535`*^9, 3.571236552929399*^9}, {3.5712365883724265`*^9, 
   3.57123663022682*^9}, {3.5712366603725443`*^9, 3.5712368010105886`*^9}, {
   3.5712374747601247`*^9, 3.5712375921758404`*^9}, {3.571237633495204*^9, 
   3.571237647171986*^9}, 3.571492541966484*^9, {3.571748098589508*^9, 
   3.5717481295872817`*^9}, {3.5793187691745014`*^9, 3.5793187806301565`*^9}},
 CellLabel->
  "In[102]:=",ExpressionUUID->"9e989ea4-2f97-4a92-b299-62a0b083626a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calc TFf", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571214922075185*^9, 
  3.5712149260164104`*^9}},ExpressionUUID->"0d56eccf-26db-4901-af77-\
8b07c6e08cad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcTFf", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tflist", ",", "name", ",", 
       RowBox[{"inlist", "=", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"outlist", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"calc$tfFi", "[", 
           RowBox[{"[", "n", "]"}], "]"}], ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"inlist", ",", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"calc$tfFo", "[", 
           RowBox[{"[", "n", "]"}], "]"}], ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"outlist", ",", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$combif", "&&", 
         RowBox[{
          RowBox[{"calc$combin", "[", 
           RowBox[{"[", "0", "]"}], "]"}], "\[Equal]", "List"}]}], ",", 
        RowBox[{"inlist", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"inlist", ",", "calc$combin"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$combif2", "&&", 
         RowBox[{
          RowBox[{"calc$combout", "[", 
           RowBox[{"[", "0", "]"}], "]"}], "\[Equal]", "List"}]}], ",", 
        RowBox[{"outlist", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"outlist", ",", "calc$combout"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"name", "=", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"outlist", "[", 
             RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", "\"\< / \>\"", "<>", 
           RowBox[{"subforce", "[", 
            RowBox[{"ToString", "[", 
             RowBox[{"inlist", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"mod$WriteStatus", "[", 
          RowBox[{
          "\"\<Calculating TF:\>\"", "<>", "name", "<>", "\"\< ...\>\""}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"tflist", "=", 
          RowBox[{"tfcalcfFD1", "[", 
           RowBox[{
            RowBox[{"inlist", "[", 
             RowBox[{"[", "n", "]"}], "]"}], ",", 
            RowBox[{"outlist", "[", 
             RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", "subkHL"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"calc$tfplot", ",", 
           RowBox[{"comb", "[", 
            RowBox[{"freq", ",", "tflist"}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"calc$tfname", ",", "name"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"calc$tfline", ",", 
           RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "inlist", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "outlist", "]"}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$combif", "=", "False"}], ";", 
      RowBox[{"calc$combif2", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$tfFi", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfFo", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571214930013639*^9, 3.571214937679077*^9}, {
   3.571215015034502*^9, 3.5712150350526466`*^9}, {3.571215138214547*^9, 
   3.571215141215719*^9}, {3.571215183998166*^9, 3.5712152356301193`*^9}, {
   3.5712152777225266`*^9, 3.571215278506572*^9}, {3.571215350952715*^9, 
   3.5712153770492077`*^9}, {3.5712154112631645`*^9, 3.571215525312688*^9}, {
   3.5712156937743235`*^9, 3.571215737500825*^9}, {3.571216935889368*^9, 
   3.5712169593327093`*^9}, {3.5712170846198754`*^9, 
   3.5712171180317864`*^9}, {3.5712171507766595`*^9, 
   3.5712171634983873`*^9}, {3.5712172167424326`*^9, 3.5712172608519554`*^9}, 
   3.5712177903792424`*^9, {3.5712178572860694`*^9, 3.5712178644194775`*^9}, {
   3.5712181201001015`*^9, 3.571218121238167*^9}, {3.571219511500685*^9, 
   3.57121954638068*^9}, {3.5712196071411552`*^9, 3.571219659180132*^9}, {
   3.5712391532661295`*^9, 3.5712391632397003`*^9}, {3.5712606609262977`*^9, 
   3.57126066568957*^9}, {3.5712620586092405`*^9, 3.571262058831253*^9}, {
   3.571427230842904*^9, 3.5714272651668673`*^9}, {3.5714622428224726`*^9, 
   3.571462270477054*^9}, {3.571463840033828*^9, 3.571463857519828*^9}, {
   3.571463892017801*^9, 3.5714638924128237`*^9}, {3.571469730730756*^9, 
   3.571469909744995*^9}, {3.5714701133116384`*^9, 3.571470160772353*^9}, {
   3.5952204824715652`*^9, 3.5952204827645817`*^9}, {3.5952942547982874`*^9, 
   3.5952947113674016`*^9}, {3.595294742056157*^9, 3.5952948210936775`*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"8e3a999c-9835-4557-a09e-a27792835a38"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Cacl TFs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712323487129316`*^9, 
  3.5712323511910734`*^9}},ExpressionUUID->"69f20a0d-6b8e-4672-a143-\
c2f97d92e150"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcTFs", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tflist", ",", "name"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"calc$tfGi", "[", 
            RowBox[{"[", "n", "]"}], "]"}], "&&", 
           RowBox[{"calc$tfGo", "[", 
            RowBox[{"[", "m", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"name", "=", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", "\"\</\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"allparams", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$WriteStatus", "[", 
            RowBox[{
            "\"\<Calculating TF:\>\"", "<>", "name", "<>", "\"\< ...\>\""}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"tflist", "=", 
            RowBox[{"tfcalcFD1", "[", 
             RowBox[{
              RowBox[{"allparams", "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", "subkHL"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfplot", ",", 
             RowBox[{"comb", "[", 
              RowBox[{"freq", ",", "tflist"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfname", ",", "name"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfline", ",", 
             RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "allparams", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfGi", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfGo", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712319607507415`*^9, 3.571231967580132*^9}, {
   3.5712323538322244`*^9, 3.571232355976347*^9}, {3.5712324458844895`*^9, 
   3.571232482472582*^9}, {3.571238032495025*^9, 3.5712380334950824`*^9}, {
   3.5712389965341654`*^9, 3.5712390656921206`*^9}, {3.571252312437791*^9, 
   3.5712523131758337`*^9}, {3.571252612294942*^9, 3.571252642412665*^9}, 
   3.5713030745352173`*^9, {3.5714272854740295`*^9, 3.571427290527318*^9}, {
   3.571467694965317*^9, 3.5714676951573277`*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"a4a94fa7-2672-4698-b80a-65150348fa66"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calc Seism", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571232493681223*^9, 
  3.571232500891636*^9}},ExpressionUUID->"3080689a-9ef5-4d00-861a-\
44eba06f7962"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcSN", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tflist", ",", "name", ",", "data", ",", "int", ",", "seism", ",", 
       "sn"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "&&", 
            RowBox[{
             RowBox[{"calc$seism", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ",",
          "True"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Beep", "[", "]"}], ";", 
        RowBox[{"CreateDialog", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Set seismic injection.\>\"", ",", 
            RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
          RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mod$WriteStatus", "[", 
              RowBox[{"\"\<Loading seismic injection data: \>\"", "<>", 
               RowBox[{"calc$seism", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\< ...\>\""}], "]"}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"data", "=", 
              RowBox[{"Import", "[", 
               RowBox[{
                RowBox[{"\"\<seismic/\>\"", "<>", 
                 RowBox[{"calc$seism", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\<.txt\>\""}], 
                ",", "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"int", "=", 
              RowBox[{"Interpolation", "[", "data", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"seism", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"int", "[", 
                 RowBox[{"freq", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{"freq", ",", "seism"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdname", ",", 
                 RowBox[{"\"\<Seismic \>\"", "<>", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"calc$sno", "[", 
                  RowBox[{"[", "m", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"name", "=", 
                   RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", 
                    "\"\< from \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"mod$WriteStatus", "[", 
                   RowBox[{
                   "\"\<Calculating seismic noise: \>\"", "<>", "name", "<>", 
                    "\"\< ...\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"tflist", "=", 
                   RowBox[{"tfcalcFD1", "[", 
                    RowBox[{
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", 
                    "subkHL"}], "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"sn", "=", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"seism", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "*", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"tflist", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], 
                  ";", "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdplot", ",", 
                    RowBox[{"comb", "[", 
                    RowBox[{"freq", ",", "sn"}], "]"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdname", ",", "name"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
                "\[IndentingNewLine]", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"calc$sni", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"calc$sno", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], 
        ";"}]}], "\[IndentingNewLine]", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712319607507415`*^9, 3.571231967580132*^9}, {
   3.5712323538322244`*^9, 3.571232355976347*^9}, {3.5712324458844895`*^9, 
   3.571232482472582*^9}, {3.571238032495025*^9, 3.5712380334950824`*^9}, {
   3.5712389965341654`*^9, 3.5712390656921206`*^9}, {3.571252245409958*^9, 
   3.5712522465170207`*^9}, {3.5712522887444363`*^9, 3.571252302361215*^9}, {
   3.571252344165606*^9, 3.571252518410572*^9}, {3.5712526370223565`*^9, 
   3.5712527872399483`*^9}, {3.571252891880934*^9, 3.5712528986253195`*^9}, {
   3.5712529331072917`*^9, 3.5712529771918135`*^9}, {3.5712530344420877`*^9, 
   3.571253044889685*^9}, {3.571253286088481*^9, 3.571253286988532*^9}, {
   3.571253332469134*^9, 3.5712533566715183`*^9}, {3.5712534090535145`*^9, 
   3.571253415656892*^9}, {3.5712534467386694`*^9, 3.5712535908149104`*^9}, {
   3.5712536509563503`*^9, 3.5712537947445745`*^9}, {3.5712538247872925`*^9, 
   3.5712538356209126`*^9}, {3.571253910745209*^9, 3.571253911039226*^9}, {
   3.571261170881465*^9, 3.571261171370493*^9}, {3.571261460107008*^9, 
   3.5712614788790817`*^9}, {3.5712617478684673`*^9, 3.571261752095709*^9}, {
   3.571261935763214*^9, 3.5712619391234064`*^9}, {3.57129414418443*^9, 
   3.5712942106272306`*^9}, {3.5712942651073465`*^9, 
   3.5712943204225106`*^9}, {3.571294511036413*^9, 3.5712945132325387`*^9}, {
   3.5714273110894947`*^9, 3.5714273270784087`*^9}, {3.5714274883526335`*^9, 
   3.5714275131650524`*^9}, {3.5714677050878963`*^9, 3.5714677110122347`*^9}, 
   3.58665155943995*^9},
 CellLabel->
  "In[105]:=",ExpressionUUID->"3a6d6752-f868-428a-8158-2be8a5123ff1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Calc Thermal noise", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571214922075185*^9, 3.5712149260164104`*^9}, {
  3.5714273433133373`*^9, 
  3.571427346309509*^9}},ExpressionUUID->"103506ef-4fa0-4f67-83d5-\
57152de36ef3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcTN", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tflist", ",", "name", ",", "tn"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"calc$tnb", "[", 
           RowBox[{"[", "m", "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"name", "=", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", 
             "\"\< Thermal Noise \>\"", "<>", 
             RowBox[{"ToString", "[", "calc$tnT", "]"}], "<>", 
             "\"\< K\>\""}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"mod$WriteStatus", "[", 
            RowBox[{
            "\"\<Calculating thermal noise:\>\"", "<>", "name", "<>", 
             "\"\< ...\>\""}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"tflist", "=", 
            RowBox[{"tfcalcfFD1", "[", 
             RowBox[{
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", "subkHL"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"tn", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{"-", "4"}], "*", "kB", "*", "calc$tnT", "*", 
                RowBox[{
                 RowBox[{"Im", "[", 
                  RowBox[{"tflist", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"2", "*", 
                   RowBox[{"N", "[", "Pi", "]"}], "*", 
                   RowBox[{"freq", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ")"}]}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdplot", ",", 
             RowBox[{"comb", "[", 
              RowBox[{"freq", ",", "tn"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdname", ",", "name"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdline", ",", 
             RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tnb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571214930013639*^9, 3.571214937679077*^9}, {
   3.571215015034502*^9, 3.5712150350526466`*^9}, {3.571215138214547*^9, 
   3.571215141215719*^9}, {3.571215183998166*^9, 3.5712152356301193`*^9}, {
   3.5712152777225266`*^9, 3.571215278506572*^9}, {3.571215350952715*^9, 
   3.5712153770492077`*^9}, {3.5712154112631645`*^9, 3.571215525312688*^9}, {
   3.5712156937743235`*^9, 3.571215737500825*^9}, {3.571216935889368*^9, 
   3.5712169593327093`*^9}, {3.5712170846198754`*^9, 
   3.5712171180317864`*^9}, {3.5712171507766595`*^9, 
   3.5712171634983873`*^9}, {3.5712172167424326`*^9, 3.5712172608519554`*^9}, 
   3.5712177903792424`*^9, {3.5712178572860694`*^9, 3.5712178644194775`*^9}, {
   3.5712181201001015`*^9, 3.571218121238167*^9}, {3.571219511500685*^9, 
   3.57121954638068*^9}, {3.5712196071411552`*^9, 3.571219659180132*^9}, {
   3.5712391532661295`*^9, 3.5712391632397003`*^9}, {3.5712606609262977`*^9, 
   3.57126066568957*^9}, {3.5712620586092405`*^9, 3.571262058831253*^9}, {
   3.571293856071951*^9, 3.5712939523964605`*^9}, {3.57129402546364*^9, 
   3.571294078138653*^9}, {3.57129423946988*^9, 3.571294244497168*^9}, {
   3.571294306910738*^9, 3.57129433334525*^9}, {3.5714273506057544`*^9, 
   3.5714273684707766`*^9}, {3.5714294626405563`*^9, 3.571429464425658*^9}, {
   3.5714677173155956`*^9, 3.5714677174796047`*^9}},
 CellLabel->
  "In[106]:=",ExpressionUUID->"9b4e87bf-2f3e-4320-8c01-d8fc117ccd1b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Add Seism Plot", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712323487129316`*^9, 3.5712323511910734`*^9}, {
  3.58665136118061*^9, 
  3.5866513658338766`*^9}},ExpressionUUID->"1f34d7a2-09a6-4ffb-8a9d-\
e6c5067b86c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$AddSeismPlot", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"data", ",", "int", ",", "seism"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "&&", 
            RowBox[{
             RowBox[{"calc$seism", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ",",
          "True"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Beep", "[", "]"}], ";", 
        RowBox[{"CreateDialog", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Set seismic injection.\>\"", ",", 
            RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
          RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"fgridtype", ",", "\[IndentingNewLine]", 
          RowBox[{"freq", "=", 
           RowBox[{"makefreqlist", "[", 
            RowBox[{"fmin", ",", "fmax", ",", "ngrid"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"freq", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"fmin", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"n", "-", "1"}], ")"}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{"ngrid", "-", "1"}], ")"}]}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "ngrid"}], "}"}]}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mod$WriteStatus", "[", 
              RowBox[{"\"\<Loading seismic injection data: \>\"", "<>", 
               RowBox[{"calc$seism", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\< ...\>\""}], "]"}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"data", "=", 
              RowBox[{"Import", "[", 
               RowBox[{
                RowBox[{"\"\<seismic/\>\"", "<>", 
                 RowBox[{"calc$seism", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\<.txt\>\""}], 
                ",", "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"int", "=", 
              RowBox[{"Interpolation", "[", "data", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"seism", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"int", "[", 
                 RowBox[{"freq", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdplot", ",", 
               RowBox[{"comb", "[", 
                RowBox[{"freq", ",", "seism"}], "]"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdname", ",", 
               RowBox[{"\"\<Seismic \>\"", "<>", 
                RowBox[{"ToString", "[", 
                 RowBox[{"allparams", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdline", ",", 
               RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"calc$sni", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], 
        ";"}]}], "\[IndentingNewLine]", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwdzGkog3EAx/G1A2HIVqMczTxTXrjCC7keSVOOYtkbSUyUtZEXFCJHuTLU
yrFcQ1JLmowi8cILRwl51jCseDEv1DLtjeP/+7/49nn3lTcYqpr4PB4vngQl
AVELpgUP2z7lpZpWci5hbn4f9aj8kIPa+MpHWMCFz8wS7Vwq1S2bDp4jOpls
CayPsw4sEQ3j11TdjWwESowXo3C9TGSELYqrNcjYl21w09p8Bs1pPbdwka++
g596iwPWKJQuaGIq3mB5l/kd3t+dCpeJYavPVEZgDIbSXpMYavfkUlgk8lFT
LFwUPJY4k6Fuvi4DTt5qimF/erQKDrk6SuGJg6uCGvaV+p1Z67Lg/9BKNesG
+WvENvmjEPacdythaIQgCRbq/HnQ623Mh853kd9GLIlU83aJDQZFIMwaFofB
suRXBvrakpQw8cn980WsHnD/wTNViNRHjFExMhh6nWAPMnvYHO0LdSP2Y+t3
38PqX0Z2YKS4c/vpwMNOFI5R/wGbfAj+
  "],
 CellLabel->
  "In[107]:=",ExpressionUUID->"926264c8-9965-4295-bb45-5c35cbfc60b1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Manipulate Plots", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714908311186295`*^9, 
  3.5714908416642323`*^9}},ExpressionUUID->"beb3bddd-bc32-442a-b2cd-\
b32a1d347c3d"],

Cell[CellGroupData[{

Cell["Module SUM", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570254213586`*^9, 3.571257026355412*^9}, {
  3.571259238563943*^9, 
  3.571259239840016*^9}},ExpressionUUID->"a66e3d31-7493-4ba9-b087-\
b8774858b064"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPSum", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fr", "=", 
        RowBox[{"{", "}"}]}], ",", "qfr", ",", 
       RowBox[{"tf", "=", 
        RowBox[{"{", "}"}]}], ",", "ncheck", ",", 
       RowBox[{"name", "=", "\"\<\>\""}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ncheck", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$tfsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$psdsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}]}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ncheck", "\[GreaterEqual]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"qfr", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"fr", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", 
               RowBox[{"fr", "[", 
                RowBox[{"[", "m", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}]}], "]"}], ",", 
            "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"qfr", ",", "False"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Sum", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], ",", 
                    "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< + \>\"", "<>", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Sqrt", "[", 
                   RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], "^", 
                    "2"}], ",", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                    "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< + \>\"", "<>", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$tfsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
                 "]"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$psdsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
                 "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}],
       ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570294915915`*^9, 3.571257624202607*^9}, {
  3.5712576544433365`*^9, 3.5712582867135005`*^9}, {3.5712583223895407`*^9, 
  3.5712587654998856`*^9}, {3.5712588344558296`*^9, 3.571258868120755*^9}, {
  3.5712589016436725`*^9, 3.5712590792588315`*^9}, {3.571259143162486*^9, 
  3.5712591850938845`*^9}, {3.571259256970996*^9, 3.5712592636033754`*^9}, {
  3.5712593422788754`*^9, 3.5712593753827686`*^9}, {3.571259933710703*^9, 
  3.5712599392090178`*^9}, {3.571262072949061*^9, 3.5712620807995095`*^9}, {
  3.5714677361586733`*^9, 3.5714677429300604`*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"90f96ce7-f49e-4480-ac03-9218c1123d2f"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Factor", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712592447522974`*^9, 3.571259247135433*^9}, {
  3.5712630724402285`*^9, 
  3.5712630756224103`*^9}},ExpressionUUID->"0b142c0c-b1bb-4cfb-ae3d-\
e974579404db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPFactor", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"CreateDialog", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\"\<Input a number to multiply\>\"", ",", 
              RowBox[{
               RowBox[{"temp$tffact", "=", "1."}], ";", "\[IndentingNewLine]", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", "temp$tffact", "]"}], ",", "Number", 
                 ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<OK\>\"", ",", 
                    RowBox[{"DialogReturn", "[", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumberQ", "[", "temp$tffact", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfplot", ",", 
                    RowBox[{"comb", "[", 
                    RowBox[{
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$tffact", "*", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfname", ",", 
                    RowBox[{
                    RowBox[{"ToString", "[", "temp$tffact", "]"}], "<>", 
                    "\"\< times \>\"", "<>", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"calc$tfsel", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
                    "]"}]}]}]}], "\[IndentingNewLine]", "]"}], "]"}]}], "]"}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<Cancel\>\"", ",", 
                    RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], 
                "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{
            "WindowTitle", "\[Rule]", "\"\<Constant Multiplier\>\""}]}], 
           "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"CreateDialog", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\"\<Input a number to multiply\>\"", ",", 
              RowBox[{
               RowBox[{"temp$tffact", "=", "1."}], ";", "\[IndentingNewLine]", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", "temp$tffact", "]"}], ",", "Number", 
                 ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<OK\>\"", ",", 
                    RowBox[{"DialogReturn", "[", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumberQ", "[", "temp$tffact", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdplot", ",", 
                    RowBox[{"comb", "[", 
                    RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$tffact", "*", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdname", ",", 
                    RowBox[{
                    RowBox[{"ToString", "[", "temp$tffact", "]"}], "<>", 
                    "\"\< times \>\"", "<>", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"calc$psdsel", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
                    "]"}]}]}]}], "\[IndentingNewLine]", "]"}], "]"}]}], "]"}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<Cancel\>\"", ",", 
                    RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], 
                "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{
            "WindowTitle", "\[Rule]", "\"\<Constant Multiplier\>\""}]}], 
           "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
  3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
  3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
  3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
  3.571261369106803*^9}, {3.5712622770797367`*^9, 3.5712628595520515`*^9}, {
  3.571262916547312*^9, 3.571262964722067*^9}, {3.5712629986970105`*^9, 
  3.57126299887302*^9}, {3.5712630778295364`*^9, 3.5712630787005863`*^9}, {
  3.5712631263463116`*^9, 3.5712632048498015`*^9}, {3.571263269385493*^9, 
  3.571263284812375*^9}, {3.571467754201705*^9, 3.5714677602250495`*^9}},
 CellLabel->
  "In[109]:=",ExpressionUUID->"a0210011-be44-4093-84fd-b249ef3c133a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Delete", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571262208209797*^9, 3.571262209085847*^9}, {
  3.5712630625876646`*^9, 3.5712630651808133`*^9}, {3.5712960235439234`*^9, 
  3.5712960246459866`*^9}},ExpressionUUID->"041b2851-1313-4d7b-8e37-\
377836ddba86"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPDelete", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"calc$tfplot", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfplot", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfname", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfname", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfsel", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfsel", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfshow", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfshow", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfline", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfline", ",", "list"}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"calc$psdplot", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdplot", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdname", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdname", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdsel", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdsel", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdshow", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdshow", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdline", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdline", ",", "list"}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
   3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
   3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
   3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
   3.571261369106803*^9}, {3.5712622136741095`*^9, 3.571262237665482*^9}, {
   3.5712630075075145`*^9, 3.5712630171580667`*^9}, {3.571263057718386*^9, 
   3.571263061223587*^9}, {3.5714677671154437`*^9, 3.5714677695515833`*^9}, {
   3.5714678975609045`*^9, 3.571467916654997*^9}, 3.571507289592078*^9},
 CellLabel->
  "In[110]:=",ExpressionUUID->"1128a765-c309-423b-831b-0c818a8ce42c"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Multiply", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570254213586`*^9, 3.571257026355412*^9}, {
  3.571259238563943*^9, 3.571259239840016*^9}, {3.571294640092795*^9, 
  3.5712946430809655`*^9}},ExpressionUUID->"58e050c2-5976-4133-82f6-\
3bfd804b0254"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPMultiply", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fr", "=", 
        RowBox[{"{", "}"}]}], ",", "qfr", ",", 
       RowBox[{"tf", "=", 
        RowBox[{"{", "}"}]}], ",", "ncheck", ",", 
       RowBox[{"name", "=", "\"\<\>\""}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ncheck", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$tfsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$psdsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}]}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ncheck", "\[GreaterEqual]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"qfr", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"fr", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", 
               RowBox[{"fr", "[", 
                RowBox[{"[", "m", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}]}], "]"}], ",", 
            "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"qfr", ",", "False"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Product", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], ",", 
                    "1"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< * \>\"", "<>", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Product", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], ",", 
                    "1"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< * \>\"", "<>", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$tfsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
                 "]"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$psdsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
                 "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}],
       ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570294915915`*^9, 3.571257624202607*^9}, {
  3.5712576544433365`*^9, 3.5712582867135005`*^9}, {3.5712583223895407`*^9, 
  3.5712587654998856`*^9}, {3.5712588344558296`*^9, 3.571258868120755*^9}, {
  3.5712589016436725`*^9, 3.5712590792588315`*^9}, {3.571259143162486*^9, 
  3.5712591850938845`*^9}, {3.571259256970996*^9, 3.5712592636033754`*^9}, {
  3.5712593422788754`*^9, 3.5712593753827686`*^9}, {3.571259933710703*^9, 
  3.5712599392090178`*^9}, {3.571262072949061*^9, 3.5712620807995095`*^9}, {
  3.571294647912242*^9, 3.571294650923414*^9}, {3.571294871071006*^9, 
  3.571294908800164*^9}, {3.5712950233117137`*^9, 3.571295025913862*^9}, {
  3.5714677802001925`*^9, 3.571467788043641*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"7eaaf157-a6dc-4b66-9491-6906e3850914"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Inverse", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712592447522974`*^9, 3.571259247135433*^9}, {
  3.5712630724402285`*^9, 3.5712630756224103`*^9}, {3.5712951082365713`*^9, 
  3.5712951090016146`*^9}},ExpressionUUID->"17a5fdeb-cc1b-413e-8d0f-\
f2f7608ac7ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPInverse", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfplot", ",", 
                  RowBox[{"comb", "[", 
                   RowBox[{
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "/", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                   "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfname", ",", 
                  RowBox[{"\"\<Inverse \>\"", "<>", 
                   RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfline", ",", 
                  RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"calc$tfsel", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"False", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
             "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdplot", ",", 
                  RowBox[{"comb", "[", 
                   RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "/", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                   "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdname", ",", 
                  RowBox[{"\"\<Inverse \>\"", "<>", 
                   RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdline", ",", 
                  RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"calc$psdsel", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"False", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
             "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
  3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
  3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
  3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
  3.571261369106803*^9}, {3.5712622770797367`*^9, 3.5712628595520515`*^9}, {
  3.571262916547312*^9, 3.571262964722067*^9}, {3.5712629986970105`*^9, 
  3.57126299887302*^9}, {3.5712630778295364`*^9, 3.5712630787005863`*^9}, {
  3.5712631263463116`*^9, 3.5712632048498015`*^9}, {3.571263269385493*^9, 
  3.571263284812375*^9}, {3.571295112780831*^9, 3.571295115159967*^9}, {
  3.5712951584594436`*^9, 3.57129529563929*^9}, {3.5714678027484818`*^9, 
  3.57146781023391*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"491b8ed0-662b-48f7-8928-7f2334adbaf6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module RMS", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712592447522974`*^9, 3.571259247135433*^9}, {
  3.5712630724402285`*^9, 3.5712630756224103`*^9}, {3.5712951082365713`*^9, 
  3.5712951090016146`*^9}, {3.571295832140976*^9, 
  3.571295832494996*^9}},ExpressionUUID->"e3286813-9a43-418f-91eb-\
8b29936b538b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPRMS", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "rms"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[GreaterEqual]", "3"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"rms", "=", 
                 RowBox[{"makerms", "[", 
                  RowBox[{
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdplot", ",", 
                  RowBox[{"comb", "[", 
                   RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    "rms"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdname", ",", 
                  RowBox[{"\"\<RMS \>\"", "<>", 
                   RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdline", ",", 
                  RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"calc$psdsel", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"False", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
             "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
  3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
  3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
  3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
  3.571261369106803*^9}, {3.5712622770797367`*^9, 3.5712628595520515`*^9}, {
  3.571262916547312*^9, 3.571262964722067*^9}, {3.5712629986970105`*^9, 
  3.57126299887302*^9}, {3.5712630778295364`*^9, 3.5712630787005863`*^9}, {
  3.5712631263463116`*^9, 3.5712632048498015`*^9}, {3.571263269385493*^9, 
  3.571263284812375*^9}, {3.571295112780831*^9, 3.571295115159967*^9}, {
  3.5712951584594436`*^9, 3.57129529563929*^9}, {3.571295847401849*^9, 
  3.571295906922253*^9}, {3.5712959378560224`*^9, 3.5712959755361776`*^9}, {
  3.5714678159442368`*^9, 3.5714678161092463`*^9}},
 CellLabel->
  "In[113]:=",ExpressionUUID->"b023b1db-346e-431f-80a3-9b169fd7cbc0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Hide", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 
  3.5712960058879137`*^9}},ExpressionUUID->"c405c81b-8ed9-4520-8561-\
781baa2bfaf8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPHide", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$tfsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$tfshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$psdsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$psdshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571296040627901*^9, 3.571296050705477*^9}, {
  3.5712960887766547`*^9, 3.57129620601236*^9}, {3.5712965808317986`*^9, 
  3.571296599400861*^9}},
 CellLabel->
  "In[114]:=",ExpressionUUID->"c0b637c2-42fb-4f93-bc8b-5abf38d20226"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Show", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 
  3.571296215567907*^9}},ExpressionUUID->"af78f337-1e26-49d0-b261-\
6107c88fab57"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPShow", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$tfsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$tfshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "True"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$psdsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$psdshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "True"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571296040627901*^9, 3.571296050705477*^9}, {
  3.5712960887766547`*^9, 3.5712962253404655`*^9}, {3.5712966029820657`*^9, 
  3.571296617552899*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"e52bcc53-d5ef-4e62-9f12-c02f609a8317"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Save", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}},ExpressionUUID->"40d8442d-2bb1-4a92-886f-\
c443d18cbae7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPSave", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "ns"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$tfsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}],
             ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ns", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$tfsaveQ", "=", "False"}], ";", 
                 RowBox[{"temp$tfname", "=", 
                  RowBox[{"calc$tfname", "[", 
                   RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Save Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                    ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptmag", ",", 
                    RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"ListLogLinearPlot", "[", 
                    RowBox[{
                    RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptphs", ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    ",", 
                    RowBox[{
                    "\"\<plot/tf\>\"", "<>", "sepchar", "<>", "temp$tfname", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$tfsaveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}]}], "]"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$tfsaveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$tfsaveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "800"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowTitle", "\[Rule]", "\"\<Save Model\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$psdsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
             "]"}], ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ns", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$tfsaveQ", "=", "False"}], ";", 
                 RowBox[{"temp$tfname", "=", 
                  RowBox[{"calc$psdname", "[", 
                   RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Save Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                    ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"ListLogLogPlot", "[", 
                 RowBox[{
                  RowBox[{"takepsd", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                  ",", 
                  RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     ",", 
                    RowBox[{
                    "\"\<plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$tfsaveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}]}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$tfsaveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$tfsaveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "]"}]}], "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "800"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowTitle", "\[Rule]", "\"\<Save Model\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
          "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0DlIggEABWCRCCyhLK1/qEQIJe36G7LSSCUpEQLFEispiqClGrqLDBoi
QjK0QQyXaCi7SLyGcpIgl8guMTAc7LCipRokpP85PL7l8YbHG5rQjtBpNFoZ
FRgqZSc92ym50tbzDPtixDskksI/yBkbEHkpDadkDcwYrtbhanfSDD+cb5uw
suTLCovSG3Z4f8PYg8HWjAdyJnO88MUZDkBTVfAW/rp3onD0Yi4JfW7dJ+z/
VmegR7HL9FFGFIdZHXwhC1azprPy2UYu9KWrSHisvzLA0MP+ICQTr3l+7EnJ
fJgoFBXB2mYlB96OdZXDa11nBVxg2PmwQF8sgHY1sxFqcqViGF3RtkGzWKXK
9saVGuhYaxiFEml4BkZObLPQKvtZgnmuFhO0uBZl9APql954O5zqePQ3+VPy
IwE3AIetxDl8+rKE4byu7hpuMSVRSNzxYsuXKflZvTEO/wHpL/GM
  "],
 CellLabel->
  "In[116]:=",ExpressionUUID->"81d1ea4d-e2e7-427e-abdc-de8563ef315c"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Load", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}, {3.5713013970082684`*^9, 
  3.5713013973902903`*^9}},ExpressionUUID->"2683e11d-2250-4bfd-b3b8-\
d9047e57544f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPLoad", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"temp$tfname", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Load Plot\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
                 "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ListLogLogPlot", "[", 
                  RowBox[{
                   RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", "savetf$plot", "}"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptmag",
                    ",", 
                   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"ListLogLinearPlot", "[", 
                  RowBox[{
                   RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", "savetf$plot", "}"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptphs",
                    ",", 
                   RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}], ",", 
                   RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", "temp$tfname", "]"}], 
                    "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfname", ",", "savetf$name"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Get", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "800"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Model\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Load Plot\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
                 "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"ListLogLogPlot", "[", 
               RowBox[{
                RowBox[{"takepsd", "[", 
                 RowBox[{
                  RowBox[{"{", "savetf$plot", "}"}], ",", 
                  RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                ",", 
                RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], "]"}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}], ",", 
                   RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", "temp$tfname", "]"}], 
                    "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdname", ",", "savetf$name"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Get", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "]"}]}], "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "800"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Model\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0W0o4wEcB/DlFsfJ4+ZWQsIfG+52neeJyWryUJaH5iEitTduVxcn5SFP
yVPyUMtDNNKdx2iGaPOwFqNk5uH2ysrODHnjqaXl//2/+PXpW9++b36B5VJR
pQONRgshD2o+M8yKEStfMJD/HxYZWbeQZWa/QWZVKWeFVLzEjYR28VEnbM8z
d8O7sZs+GOzz0A+9bL0yeHbi/AeqkuwKyPxFX4HXY7o12BCuMsDnZfkFlGhr
zVC5nHsPix8z7FCROuWqJNWnzlEOE2xPGOFZTUkwSgKg0hbOhQsFR2KoOf9b
Brkmi8sq9njcT9DkwfGCUfECJjRUZfvB41yhP6xzlhHQvcA7FMoyXGNgjiMv
Fl40i5Jhd2x6OtX7IciBwx3fJDCRp6uB+sWB37A/5akeuswkNMAJkagFOhKT
XXCR+NIHA4Ku5bDjZWkdbvaYKA+aw9QwIVC+A7e+V+zBDad/b7DVg/5hjbTN
V0Opm5lnwKQrux/UV2t1H0fJv/CMh9D22itwmLXyf1qShfCrtNEYt2rlu8Uf
X0J6ms924z6ZbdG7ULidaYCSrPFTOKj2vWwiZUmHTHC6stACnyPZ9/Ad1GVC
zg==
  "],
 CellLabel->
  "In[117]:=",ExpressionUUID->"fa3ed344-7914-403e-a0f4-b111cdecfb80"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Export", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}, {3.585722145642765*^9, 
  3.5857221464488106`*^9}},ExpressionUUID->"9b41b686-80f4-48cb-a0c4-\
5c3c5802e674"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPExport", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "tfd"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$tfsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}],
             ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"CreateDialog", "[", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"nsexport", "=", 
                 RowBox[{"list", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"temp$saveQ", "=", "False"}], ";", 
                RowBox[{"temp$exname", "=", 
                 RowBox[{"calc$tfname", "[", 
                  RowBox[{"[", "nsexport", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"TextCell", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                   "\"\<Export Plot Data\>\"", ",", "\[IndentingNewLine]", 
                    "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
                  RowBox[{"Background", "\[Rule]", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"ListLogLogPlot", "[", 
                   RowBox[{
                    RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], "}"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptmag", ",", 
                    RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"ListLogLinearPlot", "[", 
                   RowBox[{
                    RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], "}"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptphs", ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                   "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$exname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"30.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], ",", 
                    RowBox[{
                    "\"\<plot/data\>\"", "<>", "sepchar", "<>", "temp$exname",
                     "<>", "\"\<.dat\>\""}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$saveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"tfd", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"export$tf", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Arg", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "/", 
                    "deg"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "tfd", "]"}]}], "}"}]}], "]"}]}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", "export$tf", 
                    ",", "\"\<Table\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                  "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"PaneSelector", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"tfd", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"export$tf", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Arg", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "/", 
                    "deg"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "tfd", "]"}]}], "}"}]}], "]"}]}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", "export$tf", 
                    ",", "\"\<Table\>\""}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$saveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                  "temp$saveQ", ",", 
                  RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"Pane", "[", 
                 RowBox[{
                  RowBox[{"TableForm", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$exname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                  RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
                "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"WindowElements", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<VerticalScrollBar\>\"", ",", 
                "\"\<HorizontalScrollBar\>\"", ",", 
                "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"WindowSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"550", ",", "800"}], "}"}]}], ",", 
             RowBox[{"WindowMargins", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"WindowTitle", "\[Rule]", "\"\<Export Plot Data\>\""}]}],
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
        ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$psdsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
             "]"}], ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"nsexport", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$saveQ", "=", "False"}], ";", 
                 RowBox[{"temp$exname", "=", 
                  RowBox[{"calc$psdname", "[", 
                   RowBox[{"[", "nsexport", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export Plot Data\>\"", ",", "\[IndentingNewLine]", 
                    "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"ListLogLogPlot", "[", 
                 RowBox[{
                  RowBox[{"takepsd", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], "}"}]}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                  ",", 
                  RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$exname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], ",", 
                    RowBox[{
                    "\"\<plot/data\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.dat\>\""}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$saveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], ",", 
                    "\"\<Table\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "nsexport", "]"}], "]"}], ",", 
                    "\"\<Table\>\""}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$saveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$saveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$exname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "800"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
              "WindowTitle", "\[Rule]", "\"\<Export Plot Data\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
          "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0H0s1AEYB3DsusJt3LnjqnGxm3flmghHd8pbVpvbD8kViaWM1pT0wm1q
3nZFd5Q0i5jplJbO0Vaauoyrzch0y7w1hzvFrLzM2dXv+/vj2eef7/N8t8c9
87Ik28bKyiqMHKh1YRvUT0ziaGXyPEz7wV2CXIPvNuTkpft1k6a+FgRAS+pw
FSxLMsjhr0ZjDeQ7rygga+t+PRz/ZtsO+yIsasgpoHXDhUZdLyzx6RuD613P
9DBnoMgANV3Ebyj9m2CB6qhWhoZ0NOoFZYOnLxP6M69RerLP8KBmy0cAO1OG
U6H2+/MMKJhdtOvBPaHAHs46+rHg/tBoDhzLO+kKR4g4N3jTtt4TOqQ4ecH6
BEYwTKQLQ6C+VHIEykPi46lcfnQibKg4mAPDhbpCOPpKeR0qRGvF0E4VVgKr
VbdENh3kX05PHYNXYyd6DveYxC+9eL3wvIL7Hk6vVOvgDeLACKxlhOshy2Vy
DgatuRrgHlmHEcqqmlbhxa60DciTzVIGJ574By1tm9ahpN5JRjrU78y1h2XN
zk5QKDVyIL+CuRfu6ztKOWE2uMOzzfPe0GH6nhjaDwQcp/YlCxkwZnv5HBx0
1GbD6bblXNibRrsCH1aKiiG7VlgKuwvMd2BhIb0BKgYXW6i+p6faYdsu1UeY
9ZgYhbeFfD2cWcifhJWS/hlYF9lihFPKmm1oWQ6yDiON/HBhB2TSVp2gR+c6
pfxtOa+c9Ke/mnLsQTgfWmhSSkIznyQbMonnuHeT4Xg6IYVfI+SZkNe6UQM7
s3yVkJgRPIKxgSGU5v4/W038JfFmlM4M36gO0ZtJPwWaGJAWusGBde8+74ZD
oktukKVleMCiOLYXdP6y5AP/A2CY6D4=
  "],
 CellLabel->
  "In[118]:=",ExpressionUUID->"05958b55-60ac-495b-a44b-37bc81e4b5ec"]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Import", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}, {3.5713013970082684`*^9, 3.5713013973902903`*^9}, {
  3.5905589543018*^9, 
  3.590558955067844*^9}},ExpressionUUID->"9deb0de7-b915-4123-b1b1-\
6e7e9d615ccd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPImport", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "dummy"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"temp$tfname", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Import Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                 ",", "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ListLogLogPlot", "[", 
                  RowBox[{
                   RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", "savetf$plot", "}"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptmag",
                    ",", 
                   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"ListLogLinearPlot", "[", 
                  RowBox[{
                   RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", "savetf$plot", "}"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptphs",
                    ",", 
                   RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}], ",", 
                   RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", "temp$tfname", "]"}], 
                    "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfname", ",", "temp$tfname"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"dummy", "=", 
                    RowBox[{"Import", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$tfname", "<>", "\"\<.dat\>\""}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Which", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "3"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}], "*", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"I", "*", 
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "3"}], "]"}], "]"}], "deg"}], "]"}]}]}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "dummy", "]"}]}], "}"}]}], "]"}]}],
                     ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"Beep", "[", "]"}], ";", 
                    RowBox[{"temp$tfname", "=", "\"\<\>\""}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"CreateDialog", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Not TF data.\>\"", ",", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}], ";"}], ",", "\[IndentingNewLine]", "True", ",", 
                    RowBox[{
                    RowBox[{"Beep", "[", "]"}], ";", 
                    RowBox[{"temp$tfname", "=", "\"\<\>\""}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"CreateDialog", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<No Proper data.\>\"", ",", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "800"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Import Plot\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Import Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                 ",", "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"ListLogLogPlot", "[", 
               RowBox[{
                RowBox[{"takepsd", "[", 
                 RowBox[{
                  RowBox[{"{", "savetf$plot", "}"}], ",", 
                  RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                ",", 
                RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], "]"}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}], ",", 
                   RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", "temp$tfname", "]"}], 
                    "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdname", ",", "temp$tfname"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"dummy", "=", 
                    RowBox[{"Import", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$tfname", "<>", "\"\<.dat\>\""}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Which", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", "dummy"}], ";"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"dummy", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "3"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"Beep", "[", "]"}], ";", 
                    RowBox[{"temp$tfname", "=", "\"\<\>\""}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"CreateDialog", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Not spectrum data.\>\"", ",", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}], ";"}], ",", "\[IndentingNewLine]", "True", ",", 
                    RowBox[{
                    RowBox[{"Beep", "[", "]"}], ";", 
                    RowBox[{"temp$tfname", "=", "\"\<\>\""}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"CreateDialog", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<No Proper data.\>\"", ",", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "300"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "800"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Import Plot\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571296040627901*^9, 3.571296050705477*^9}, {
   3.5712960887766547`*^9, 3.5712962253404655`*^9}, {3.5712966029820657`*^9, 
   3.571296617552899*^9}, {3.5712973664797354`*^9, 3.57129738316669*^9}, {
   3.5712974153005276`*^9, 3.5712974314714527`*^9}, {3.571297476468026*^9, 
   3.571297600307109*^9}, {3.571297703945037*^9, 3.571297704139048*^9}, {
   3.571297734331775*^9, 3.571297957942565*^9}, {3.571297989084346*^9, 
   3.5712980917742195`*^9}, {3.5712981546468153`*^9, 3.571298290373579*^9}, {
   3.5712984051331425`*^9, 3.571298405383157*^9}, {3.571298441317212*^9, 
   3.571298443658346*^9}, {3.5712985549087095`*^9, 3.5712986973118544`*^9}, {
   3.571299022479453*^9, 3.5712990773075886`*^9}, {3.571300439277489*^9, 
   3.571300441538618*^9}, {3.5713004973458104`*^9, 3.57130052216323*^9}, {
   3.5713005864509068`*^9, 3.5713005942603536`*^9}, {3.571300660751157*^9, 
   3.5713006646043773`*^9}, {3.5713007843842278`*^9, 3.571300793875771*^9}, {
   3.571300858578472*^9, 3.5713009382880306`*^9}, {3.571301002169685*^9, 
   3.571301185579175*^9}, {3.5713013023198524`*^9, 3.5713013086152124`*^9}, {
   3.571301359664132*^9, 3.5713013618332567`*^9}, {3.571301402572586*^9, 
   3.5713014690983915`*^9}, {3.571301505473472*^9, 3.5713016552230372`*^9}, {
   3.571301837561466*^9, 3.5713018390485516`*^9}, {3.571301881265966*^9, 
   3.571301909066556*^9}, {3.571301955100189*^9, 3.5713023747821937`*^9}, {
   3.571302424127016*^9, 3.5713024301283593`*^9}, {3.5713025654270983`*^9, 
   3.571302639965361*^9}, {3.5714678622018824`*^9, 3.571467878819833*^9}, {
   3.5793188284678926`*^9, 3.5793188499971237`*^9}, {3.5857220679823227`*^9, 
   3.5857221185382147`*^9}, {3.59055910675852*^9, 3.5905591241625156`*^9}, {
   3.5905591918933897`*^9, 3.590559251150779*^9}, {3.5905593161504965`*^9, 
   3.590559351389512*^9}, {3.5905597293051276`*^9, 3.5905597679403377`*^9}, {
   3.5905598546862993`*^9, 3.5905598550053177`*^9}, {3.590559912958632*^9, 
   3.5905599170568666`*^9}, {3.5953047021828437`*^9, 3.595304715705617*^9}, {
   3.595304747771451*^9, 3.595304753362771*^9}, {3.595304929557849*^9, 
   3.595304931993988*^9}, {3.595304976997562*^9, 3.595305035408903*^9}, {
   3.595305128176209*^9, 3.595305274647587*^9}, {3.5953053178800592`*^9, 
   3.595305395778515*^9}, {3.595305463052363*^9, 3.595305486847724*^9}, {
   3.595305634794186*^9, 3.5953056417605844`*^9}, 3.5953056752454996`*^9, {
   3.5953057224642005`*^9, 3.5953057710749807`*^9}, {3.5953058785721292`*^9, 
   3.5953059322932014`*^9}, {3.595305980791976*^9, 3.5953060125167904`*^9}, {
   3.5953060645707674`*^9, 3.5953061124275045`*^9}, {3.595306313539008*^9, 
   3.595306383880031*^9}, {3.595306440037243*^9, 3.5953064982275715`*^9}, {
   3.595306616524338*^9, 3.595306622489679*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"6998b850-53ec-47ec-a776-d02fb2038c26"]
}, Closed]],

Cell[CellGroupData[{

Cell["Line Style", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571465366897159*^9, 
  3.5714653713604145`*^9}},ExpressionUUID->"37d62b33-efb0-40a9-bfea-\
cc010e52ddc4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$FPLineStyle", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$lc", "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"temp$lt", "=", "2"}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$ls", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Line Style Setting\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Set RGB Color:\>\"", ",", "Bold"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$lc", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{"1", ",", ".8", ",", ".8"}], "}"}], "]"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$lc", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{".8", ",", "1", ",", ".8"}], "}"}], "]"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$lc", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{".8", ",", ".8", ",", "1"}], "}"}], "]"}]}]}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{".5", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", ".5", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", ".5"}], "}"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Set Thickness:\>\"", ",", "Bold"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$lt", "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1", ",", "1"}], "}"}], "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Line Style:\>\"", ",", "Bold"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$ls", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<Solid\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Dashed\>\""}], ",", 
               RowBox[{"3", "\[Rule]", "\"\<Dotdashed\>\""}]}], "}"}]}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Graphics", "[", 
         RowBox[{
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$ls", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
              RowBox[{"RGBColor", "[", "temp$lc", "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"temp$ls", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
              RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", "Dashed"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"temp$ls", "\[Equal]", "3"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
              RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", "DotDashed"}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<OK\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"(*", 
               RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$tfk", "\[LessEqual]", "2"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"temp$ls", "\[Equal]", "1"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}]}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "2"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "Dashed"}], "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "3"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "DotDashed"}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"temp$ls", "\[Equal]", "1"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}]}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "2"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "Dashed"}], "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "3"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "DotDashed"}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
               "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], 
      RowBox[{"(*", 
       RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"WindowSize", "\[Rule]", "400"}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Line Style Setting\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571465375568655*^9, 3.571465539966058*^9}, {
  3.57146560049352*^9, 3.5714657543553205`*^9}, {3.5714659486294327`*^9, 
  3.5714659865396004`*^9}, {3.5714660242947598`*^9, 3.5714661555082655`*^9}, {
  3.5714662438713193`*^9, 3.571466752277398*^9}, {3.571466911477504*^9, 
  3.57146691228555*^9}, {3.5714670027447243`*^9, 3.571467055324732*^9}, {
  3.5714671280898933`*^9, 3.5714671685032053`*^9}, {3.57146720058604*^9, 
  3.571467267626875*^9}, {3.571467301356804*^9, 3.5714673030799026`*^9}, {
  3.5714673390289583`*^9, 3.5714675592185526`*^9}, {3.571468020233921*^9, 
  3.5714680281463737`*^9}, {3.595295385049934*^9, 3.595295499778496*^9}, {
  3.595295606949626*^9, 3.5952956179172535`*^9}, {3.5953061636484346`*^9, 
  3.595306165114518*^9}},
 CellLabel->
  "In[120]:=",ExpressionUUID->"0f0e6656-0fab-4756-a68e-3ddef92cc3c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$CButton", "[", "c_List", "]"}], ":=", 
   RowBox[{"Button", "[", 
    RowBox[{"\"\<     \>\"", ",", 
     RowBox[{"temp$lc", "=", "c"}], ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
     RowBox[{"Background", "\[Rule]", 
      RowBox[{"RGBColor", "[", "c", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5714657572034836`*^9, 3.5714659432271233`*^9}, {
  3.571466880307721*^9, 3.571466882676857*^9}, {3.5714669634504766`*^9, 
  3.571466974909132*^9}, {3.571467272429149*^9, 3.57146727262016*^9}},
 CellLabel->
  "In[121]:=",ExpressionUUID->"535d1108-2b75-47e9-afaa-0f87666da9c5"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["5. Eigen Plot", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571329340391183*^9, 3.5713293410172186`*^9}, {
  3.5714908557360373`*^9, 
  3.571490857915162*^9}},ExpressionUUID->"d1debf44-af26-4c2f-b43c-\
0e796878b43c"],

Cell[CellGroupData[{

Cell["eigen view", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5713415191377673`*^9, 
  3.5713415209908733`*^9}},ExpressionUUID->"82c1b17d-f7c0-40bd-a1f1-\
046faeebcd18"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"optp", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ViewPoint", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Infinity", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"ViewVertical", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"optr", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ViewPoint", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "Infinity"}], "}"}]}], ",", 
     RowBox[{"ViewVertical", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"viewQ", "[", "s_", "]"}], ":=", 
   RowBox[{
    RowBox[{"StringMatchQ", "[", 
     RowBox[{"s", ",", "\"\<x*\>\""}], "]"}], "||", 
    RowBox[{"StringMatchQ", "[", 
     RowBox[{"s", ",", "\"\<r*\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 InitializationCell->True,
 CellLabel->
  "In[122]:=",ExpressionUUID->"cb663351-0e67-45d4-9b9d-3570a3b31b76"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["6. Export", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5787900163706245`*^9, 
  3.578790019341794*^9}},ExpressionUUID->"675c19ba-1410-4074-9610-\
e0749adadd7c"],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Export"
}], "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857318694289336`*^9, 
  3.585731875859301*^9}},ExpressionUUID->"7e664826-34c5-4e22-bf48-\
8d4dd4f192b9"],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Export"
}], "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.57879020161222*^9, 3.5787902026772804`*^9}, {
  3.585728754662779*^9, 
  3.585728756669894*^9}},ExpressionUUID->"8917b9c4-8645-4716-975a-\
ff10b41a587a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ExportModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$saveQ", "=", "False"}], ";", 
        RowBox[{"temp$type", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Export Suspension Model in Mathematica Format\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Saved Parameters:\>\"", ",", "Bold", ",", "Italic"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<matKpvc\>\"", ",", "\"\<matKvvc\>\"", ",", "\"\<matMvv\>\"", 
             ",", "\"\<matMpv\>\"", ",", "\"\<matGpv\>\"", ",", 
             "\"\<matGvv\>\"", ",", "\"\<allvars\>\"", ",", 
             "\"\<allparams\>\""}], "}"}], ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Export Type:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "temp$type", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "\[Rule]", "\"\<All\>\""}], ",", 
           RowBox[{"2", "\[Rule]", "\"\<Z,Pitch\>\""}], ",", 
           RowBox[{"3", "\[Rule]", "\"\<X,Roll\>\""}], ",", 
           RowBox[{"4", "\[Rule]", "\"\<Y\>\""}], ",", 
           RowBox[{"5", "\[Rule]", "\"\<Yaw\>\""}]}], "}"}]}], "]"}], ",", 
       "\"\<\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$FileName", "]"}], ",", "String", 
             ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"StringLength", "[", "temp$FileName", "]"}], 
                 "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                   ",", 
                   RowBox[{
                   "\"\<matrix\>\"", "<>", "sepchar", "<>", "temp$FileName", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"temp$saveQ", "=", "True"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Module", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "nv", ",", "np", ",", "allvars2", ",", "allparams2", ",", 
                    "matKpvc2", ",", "matKvvc2", ",", "matMvv2", ",", 
                    "matMpv2", ",", "matGpv2", ",", "matGvv2"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Which", "[", 
                    RowBox[{
                    RowBox[{"temp$type", "\[Equal]", "1"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], 
                    "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}]}], ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "2"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allparams", "]"}]}], 
                    ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "3"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allparams", "]"}]}], ";"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "4"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeY", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeY", "[", "allparams", "]"}]}], ";"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "5"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allparams", "]"}]}], ";"}]}],
                     "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars2", "=", "allvars"}], ";", 
                    RowBox[{"allparams2", "=", "allparams"}], ";", 
                    RowBox[{"matMvv2", "=", "matMvv"}], ";", 
                    RowBox[{"matMpv2", "=", "matMpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc2", "=", "matKvvc"}], ";", 
                    RowBox[{"matKpvc2", "=", "matKpvc"}], ";", 
                    RowBox[{"matGvv2", "=", "matGvv"}], ";", 
                    RowBox[{"matGpv2", "=", "matGpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", 
                    RowBox[{"allvars2", "[", 
                    RowBox[{"[", "nv", "]"}], "]"}]}], ";", 
                    RowBox[{"allparams", "=", 
                    RowBox[{"allparams2", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", 
                    RowBox[{"matKvvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matKpvc", "=", 
                    RowBox[{"matKpvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matMvv", "=", 
                    RowBox[{"matMvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matMpv", "=", 
                    RowBox[{"matMpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matGvv", "=", 
                    RowBox[{"matGvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matGpv", "=", 
                    RowBox[{"matGpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matrix\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<matKpvc\>\"", ",", "\"\<matKvvc\>\"", ",", 
                    "\"\<matMvv\>\"", ",", "\"\<matMpv\>\"", ",", 
                    "\"\<matGpv\>\"", ",", "\"\<matGvv\>\"", ",", 
                    "\"\<allvars\>\"", ",", "\"\<allparams\>\""}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", "allvars2"}], ";", 
                    RowBox[{"allparams", "=", "allparams2"}], ";", 
                    RowBox[{"matMvv", "=", "matMvv2"}], ";", 
                    RowBox[{"matMpv", "=", "matMpv2"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", "matKvvc2"}], ";", 
                    RowBox[{"matKpvc", "=", "matKpvc2"}], ";", 
                    RowBox[{"matGvv", "=", "matGvv2"}], ";", 
                    RowBox[{"matGpv", "=", "matGpv2"}], ";"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"PaneSelector", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<Do you really want to overwrite?\>\"", ",", "Red", ",",
                    "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matrix\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "nv", ",", "np", ",", "allvars2", ",", "allparams2", ",", 
                    "matKpvc2", ",", "matKvvc2", ",", "matMvv2", ",", 
                    "matMpv2", ",", "matGpv2", ",", "matGvv2"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Which", "[", 
                    RowBox[{
                    RowBox[{"temp$type", "\[Equal]", "1"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], 
                    "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}]}], ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "2"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allparams", "]"}]}], 
                    ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "3"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allparams", "]"}]}], ";"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "4"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeY", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeY", "[", "allparams", "]"}]}], ";"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "5"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allparams", "]"}]}], ";"}]}],
                     "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars2", "=", "allvars"}], ";", 
                    RowBox[{"allparams2", "=", "allparams"}], ";", 
                    RowBox[{"matMvv2", "=", "matMvv"}], ";", 
                    RowBox[{"matMpv2", "=", "matMpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc2", "=", "matKvvc"}], ";", 
                    RowBox[{"matKpvc2", "=", "matKpvc"}], ";", 
                    RowBox[{"matGvv2", "=", "matGvv"}], ";", 
                    RowBox[{"matGpv2", "=", "matGpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", 
                    RowBox[{"allvars2", "[", 
                    RowBox[{"[", "nv", "]"}], "]"}]}], ";", 
                    RowBox[{"allparams", "=", 
                    RowBox[{"allparams2", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", 
                    RowBox[{"matKvvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matKpvc", "=", 
                    RowBox[{"matKpvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matMvv", "=", 
                    RowBox[{"matMvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matMpv", "=", 
                    RowBox[{"matMpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matGvv", "=", 
                    RowBox[{"matGvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matGpv", "=", 
                    RowBox[{"matGpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matrix\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<matKpvc\>\"", ",", "\"\<matKvvc\>\"", ",", 
                    "\"\<matMvv\>\"", ",", "\"\<matMpv\>\"", ",", 
                    "\"\<matGpv\>\"", ",", "\"\<matGvv\>\"", ",", 
                    "\"\<allvars\>\"", ",", "\"\<allparams\>\""}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", "allvars2"}], ";", 
                    RowBox[{"allparams", "=", "allparams2"}], ";", 
                    RowBox[{"matMvv", "=", "matMvv2"}], ";", 
                    RowBox[{"matMpv", "=", "matMpv2"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", "matKvvc2"}], ";", 
                    RowBox[{"matKpvc", "=", "matKpvc2"}], ";", 
                    RowBox[{"matGvv", "=", "matGvv2"}], ";", 
                    RowBox[{"matGpv", "=", "matGpv2"}], ";"}]}], "]"}], ";"}],
                     "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                   RowBox[{"temp$saveQ", "=", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
            RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", "temp$saveQ", 
          ",", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", "=", "n"}], "}"}], ",", 
                RowBox[{"Button", "[", 
                 RowBox[{
                  RowBox[{"StringDrop", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$FileName", "=", 
                   RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], ",", 
                  RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}], "]"}], 
              "\[IndentingNewLine]", ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"FileNames", "[", 
                  RowBox[{"\"\<*.m\>\"", ",", 
                   RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                 "]"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"650", ",", "300"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "600"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Export Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.5787902436766253`*^9, 3.5787902658128915`*^9}, {3.5787903547369776`*^9, 
   3.5787904264820814`*^9}, {3.578790459612976*^9, 3.5787905160222025`*^9}, {
   3.5787907047679987`*^9, 3.5787907076121607`*^9}, {3.5787907590391026`*^9, 
   3.578790854695574*^9}, 3.5787908945598536`*^9, {3.5787910433383636`*^9, 
   3.5787910545650053`*^9}, 3.5788748266424856`*^9, {3.5788749247060947`*^9, 
   3.5788749261751785`*^9}, {3.579318855301427*^9, 3.579318871026327*^9}, {
   3.5857288163333063`*^9, 3.5857288346983566`*^9}, {3.585728874304622*^9, 
   3.585728920231249*^9}, {3.5857289892501965`*^9, 3.5857291668643556`*^9}, {
   3.5857292018953595`*^9, 3.585729251991225*^9}, {3.585730505333912*^9, 
   3.5857309915687227`*^9}, {3.585731023893572*^9, 3.585731237672799*^9}, 
   3.5857312761730013`*^9, {3.585731411926766*^9, 3.5857314192201834`*^9}, {
   3.585731900074686*^9, 3.58573192811629*^9}, {3.585732235315861*^9, 
   3.5857322528208623`*^9}, {3.5857379064782333`*^9, 3.585737945148445*^9}, {
   3.5953071483617573`*^9, 3.595307166400789*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"a90c256d-4b88-430e-a446-8fd161d2425e"]
}, Closed]],

Cell[CellGroupData[{

Cell["Take Part", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857292607697268`*^9, 
  3.5857292671510916`*^9}},ExpressionUUID->"dff223e6-35fe-400b-8fd8-\
5f9a78dda63d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeZPitch", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "vc", ",", "vex"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"v1", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<z\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"v2", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<p\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vc", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"v1", ",", "v2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585729353437027*^9, 3.585729485546583*^9}, {
  3.5857300745512724`*^9, 3.5857301563869534`*^9}, {3.5857302196485715`*^9, 
  3.5857302375225935`*^9}, {3.5857302716795473`*^9, 3.5857302742826967`*^9}, {
  3.5857316330104113`*^9, 3.5857316337974563`*^9}, {3.585731727352807*^9, 
  3.5857317302059703`*^9}},
 CellLabel->
  "In[126]:=",ExpressionUUID->"6b09567e-a6dd-4b6e-aa43-fa7050dae4b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeXRoll", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "vc", ",", "vex"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"v1", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<x\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"v2", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<r\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vc", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"v1", ",", "v2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585729353437027*^9, 3.585729485546583*^9}, {
  3.5857300745512724`*^9, 3.5857301563869534`*^9}, {3.5857302196485715`*^9, 
  3.5857302375225935`*^9}, {3.5857302716795473`*^9, 3.5857302742826967`*^9}, {
  3.5857303177991858`*^9, 3.5857303330250564`*^9}, {3.585731629736224*^9, 
  3.585731630037241*^9}, {3.5857317327891183`*^9, 3.5857317333801517`*^9}},
 CellLabel->
  "In[127]:=",ExpressionUUID->"29eccc78-1895-46ff-ae32-8bc7bcc86c73"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeY", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vc", ",", "vex"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vc", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Characters", "[", "#", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<y\>\""}], "&&", 
           RowBox[{"Not", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Characters", "[", "#", "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "\"\<a\>\""}], 
            "]"}]}], "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5857303474308805`*^9, 3.585730383015916*^9}, {
   3.5857316276431046`*^9, 3.585731628021126*^9}, 3.585731737804405*^9},
 CellLabel->
  "In[128]:=",ExpressionUUID->"fcc0ed97-510e-44a2-984c-57c0e7c87e12"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeYaw", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vc", ",", "vex"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vc", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "2"}], "]"}], "]"}], "\[Equal]", 
           RowBox[{"{", 
            RowBox[{"\"\<y\>\"", ",", "\"\<a\>\""}], "}"}]}], "&"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585730389443283*^9, 3.5857304302716184`*^9}, {
  3.585731622043784*^9, 3.5857316229638367`*^9}, {3.585731736714343*^9, 
  3.585731766847066*^9}},
 CellLabel->
  "In[129]:=",ExpressionUUID->"37903e96-ff2a-44fa-b270-430150000da5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeZ", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vc", ",", "vex"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vc", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<z\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6005565704400597`*^9, 3.600556589795167*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"239d99bb-568f-46ac-b254-0d3bf7fe99f1"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MATLAB Export", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.585731879736523*^9, 
  3.585731881796641*^9}},ExpressionUUID->"4a2037be-a2f0-4949-86d5-\
04daa007e1fe"],

Cell[CellGroupData[{

Cell["MATLAB Export", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857318861388893`*^9, 
  3.5857318880309973`*^9}},ExpressionUUID->"dd646bcf-e183-4361-a9b4-\
ad9685610a7f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$MATLABExport", ":=", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{
        RowBox[{"MatrixQ", "[", 
         RowBox[{"matKvvc", ",", "NumericQ"}], "]"}], "&&", 
        RowBox[{"MatrixQ", "[", 
         RowBox[{"matKpvc", ",", "NumericQ"}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Beep", ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<MATLAB Export is not used for a model with frequency-dependent \
spring rate of heat links.\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"temp$saveQ", "=", "False"}], ";", 
            RowBox[{"temp$type", "=", "1"}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"Not", "[", 
               RowBox[{"ValueQ", "[", "temp$FileName", "]"}], "]"}], ",", 
              RowBox[{"temp$FileName", "=", "\"\<\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ValueQ", "[", "save$viscous", "]"}], "&&", 
               RowBox[{
                RowBox[{"Length", "[", "save$viscous", "]"}], "\[Equal]", 
                RowBox[{"Length", "[", "allvars", "]"}]}]}], ",", 
              RowBox[{"temp$viscous", "=", "save$viscous"}], ",", 
              RowBox[{"temp$viscous", "=", 
               RowBox[{"Table", "[", 
                RowBox[{"1.", ",", 
                 RowBox[{"{", 
                  RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}]}],
              "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"sepchar", "=", 
             RowBox[{"StringTake", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"FileNames", "[", 
                 RowBox[{"\"\<*.m\>\"", ",", 
                  RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"TextCell", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<Export ABCD Matrices in MATLAB Format\>\"", ",", 
                "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
               "]"}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"RGBColor", "[", 
                RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Conversion Frequency [Hz] from Structure to Viscous Damping:\
\>\"", ",", "Bold", ",", "Italic"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Grid", "[", 
            RowBox[{
             RowBox[{"Partition", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"ToExpression", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$viscous", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "]"}]}], 
                   "}"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], 
               "\[IndentingNewLine]", ",", "6", ",", "6", ",", "1", ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", 
             RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Export Type:\>\"", ",", "Bold", ",", "Italic"}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$type", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<All\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Z,Pitch\>\""}], ",", 
               RowBox[{"3", "\[Rule]", "\"\<X,Roll\>\""}], ",", 
               RowBox[{"4", "\[Rule]", "\"\<Y\>\""}], ",", 
               RowBox[{"5", "\[Rule]", "\"\<Yaw\>\""}], ",", 
               RowBox[{"6", "\[Rule]", "\"\<Z ONLY\>\""}]}], "}"}]}], "]"}], 
           ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", "temp$FileName", "]"}], ",", 
                 "String", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", "temp$FileName", "]"}], 
                    "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                    ",", 
                    RowBox[{
                    "\"\<matlab\>\"", "<>", "sepchar", "<>", "temp$FileName", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$saveQ", "=", "True"}], ",", 
                    RowBox[{
                    RowBox[{"mod$SaveMATLAB", "[", "temp$type", "]"}], ";", 
                    RowBox[{"save$viscous", "=", "temp$viscous"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}]}], "]"}], 
                 ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                 ",", 
                 RowBox[{"Background", "\[Rule]", "Black"}], ",", 
                 RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                 RowBox[{"DialogReturn", "[", "]"}], ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                 ",", 
                 RowBox[{"Background", "\[Rule]", 
                  RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"PaneSelector", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matlab\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"mod$SaveMATLAB", "[", "temp$type", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"save$viscous", "=", "temp$viscous"}], ";"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$saveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
              "temp$saveQ", ",", 
              RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Pane", "[", 
             RowBox[{
              RowBox[{"TableForm", "[", 
               RowBox[{
                RowBox[{"Table", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$FileName", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]}], "]"}],
                   "\[IndentingNewLine]", ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", 
                RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"650", ",", "300"}], "}"}]}], ",", 
              RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"WindowElements", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
            ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WindowSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"700", ",", "500"}], "}"}]}], ",", 
         RowBox[{"WindowMargins", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Export Model\>\""}]}], 
        "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.5787902436766253`*^9, 3.5787902658128915`*^9}, {3.5787903547369776`*^9, 
   3.5787904264820814`*^9}, {3.578790459612976*^9, 3.5787905160222025`*^9}, {
   3.5787907047679987`*^9, 3.5787907076121607`*^9}, {3.5787907590391026`*^9, 
   3.578790854695574*^9}, 3.5787908945598536`*^9, {3.5787910433383636`*^9, 
   3.5787910545650053`*^9}, 3.5788748266424856`*^9, {3.5788749247060947`*^9, 
   3.5788749261751785`*^9}, {3.579318855301427*^9, 3.579318871026327*^9}, {
   3.5857288163333063`*^9, 3.5857288346983566`*^9}, {3.585728874304622*^9, 
   3.585728920231249*^9}, {3.5857289892501965`*^9, 3.5857291668643556`*^9}, {
   3.5857292018953595`*^9, 3.585729251991225*^9}, {3.585730505333912*^9, 
   3.5857309915687227`*^9}, {3.585731023893572*^9, 3.585731237672799*^9}, 
   3.5857312761730013`*^9, {3.585731411926766*^9, 3.5857314192201834`*^9}, {
   3.5857319310944605`*^9, 3.58573193195951*^9}, {3.585732115491008*^9, 
   3.585732179461666*^9}, {3.585732214283658*^9, 3.5857322161957674`*^9}, {
   3.5857322659826155`*^9, 3.585732292247117*^9}, {3.5857324938266473`*^9, 
   3.585732527345564*^9}, {3.5857326079671755`*^9, 3.5857326105933256`*^9}, {
   3.585732658289054*^9, 3.5857328006791983`*^9}, {3.5857328351611705`*^9, 
   3.5857328358512096`*^9}, {3.5857328909733624`*^9, 3.585732939287126*^9}, {
   3.58573618308366*^9, 3.585736189835047*^9}, {3.5857362310784054`*^9, 
   3.5857362533016768`*^9}, {3.5857378637907915`*^9, 
   3.5857378746334114`*^9}, {3.5911510766026883`*^9, 3.591151160273474*^9}, {
   3.591151211815422*^9, 3.5911512320185776`*^9}, {3.5911513247978845`*^9, 
   3.591151326551985*^9}, {3.595307266673524*^9, 3.5953072916629534`*^9}, {
   3.595307562088421*^9, 3.595307706809698*^9}, {3.595307757050572*^9, 
   3.595307762115862*^9}, {3.595307797699897*^9, 3.5953078311588106`*^9}, {
   3.5953079799203196`*^9, 3.5953080906206512`*^9}, {3.595308229488594*^9, 
   3.5953082436064014`*^9}, {3.5953082742621546`*^9, 3.595308299334589*^9}, {
   3.5953084176123543`*^9, 3.5953084426747875`*^9}, {3.600556290630056*^9, 
   3.600556298328496*^9}},
 CellLabel->
  "In[131]:=",ExpressionUUID->"2569a270-7e4d-425e-82e0-6f3277fb91d6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Save", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857323019276714`*^9, 
  3.585732302311693*^9}},ExpressionUUID->"f12f959b-28a7-4188-9cfe-\
7abe7d92f930"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SaveMATLAB", "[", "type_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "nv", ",", "np", ",", "ssA", ",", "ssB", ",", "ssC", ",", "ssD", ",", 
       "matFD", ",", "vars", ",", "params", ",", "viscous", ",", "Mvv", ",", 
       "Mpv", ",", "Kvvc", ",", "Kpvc", ",", "Gvv", ",", "Gpv", ",", "input", 
       ",", "output"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Which", "[", 
       RowBox[{
        RowBox[{"type", "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"Table", "[", 
           RowBox[{"n", ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}]}], 
         ";", 
         RowBox[{"np", "=", 
          RowBox[{"Table", "[", 
           RowBox[{"n", ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}]}], 
         ";"}], ",", "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "2"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeZPitch", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeZPitch", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "3"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeXRoll", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeXRoll", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "4"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeY", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeY", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "5"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeYaw", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeYaw", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "6"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeZ", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeZ", "[", "allparams", "]"}]}], ";"}]}], "]"}], ";",
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"viscous", "=", 
       RowBox[{"temp$viscous", "[", 
        RowBox[{"[", "nv", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vars", "=", 
       RowBox[{"allvars", "[", 
        RowBox[{"[", "nv", "]"}], "]"}]}], ";", 
      RowBox[{"params", "=", 
       RowBox[{"allparams", "[", 
        RowBox[{"[", "np", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Mvv", "=", 
       RowBox[{"matMvv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
      RowBox[{"Mpv", "=", 
       RowBox[{"matMpv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Gvv", "=", 
       RowBox[{"matGvv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
      RowBox[{"Gpv", "=", 
       RowBox[{"matGpv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Kvvc", "=", 
       RowBox[{"matKvvc", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
      RowBox[{"Kpvc", "=", 
       RowBox[{"matKpvc", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"matFD", "=", 
       RowBox[{"DiagonalMatrix", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"1", "/", "2"}], "/", 
            RowBox[{"N", "[", "Pi", "]"}]}], "/", 
           RowBox[{"viscous", "[", 
            RowBox[{"[", "n", "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ssA", "=", "\[IndentingNewLine]", 
       RowBox[{"ArrayFlatten", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"IdentityMatrix", "[", 
             RowBox[{"Length", "[", "params", "]"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"IdentityMatrix", "[", 
             RowBox[{"Length", "[", "vars", "]"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", 
              RowBox[{"Re", "[", "Kpvc", "]"}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", "Gpv"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", 
              RowBox[{"Re", "[", "Kvvc", "]"}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{
               RowBox[{"Inverse", "[", "Mvv", "]"}], ".", "Gvv"}]}], "-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", 
              RowBox[{"Im", "[", "Kvvc", "]"}], ".", "matFD"}]}]}], 
           "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "}"}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"ssB", "=", "\[IndentingNewLine]", 
       RowBox[{"ArrayFlatten", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"IdentityMatrix", "[", 
             RowBox[{"Length", "[", "params", "]"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", "Mpv"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Inverse", "[", "Mvv", "]"}]}], "\[IndentingNewLine]", 
           "}"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ssC", "=", 
       RowBox[{"IdentityMatrix", "[", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "params", "]"}], "+", 
           RowBox[{"Length", "[", "vars", "]"}]}], ")"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ssD", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"2", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", "params", "]"}], "+", 
             RowBox[{"Length", "[", "vars", "]"}]}], ")"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", "params", "]"}], "+", 
           RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"input", "=", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<a\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"params", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "params", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<F\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"vars", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"output", "=", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"params", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "params", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<v\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"params", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "params", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"vars", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<v\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"vars", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"matlabexport", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Directory", "[", "]"}], "<>", "\"\</matlab\>\"", "<>", 
         "sepchar", "<>", "temp$FileName", "<>", "\"\<.m\>\""}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\"\<ssA\>\"", ",", "ssA"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<ssB\>\"", ",", "ssB"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<ssC\>\"", ",", "ssC"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<ssD\>\"", ",", "ssD"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<varinput\>\"", ",", "input"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<varoutput\>\"", ",", "output"}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585732305660885*^9, 3.5857323281581717`*^9}, {
   3.585733047161296*^9, 3.5857330553987675`*^9}, {3.585733470034483*^9, 
   3.585733597330764*^9}, {3.585733682500635*^9, 3.585733988385131*^9}, {
   3.5857343817776318`*^9, 3.5857344784521613`*^9}, {3.5857345277489805`*^9, 
   3.5857346169760847`*^9}, {3.585734659577521*^9, 3.585734660751588*^9}, {
   3.585734702876998*^9, 3.5857349012343426`*^9}, {3.5857349908504686`*^9, 
   3.585735404451125*^9}, {3.58573555629081*^9, 3.585735629043971*^9}, {
   3.5857358198128824`*^9, 3.5857358241341295`*^9}, {3.585735928775115*^9, 
   3.585735936185539*^9}, {3.5857365359478436`*^9, 3.585736536958901*^9}, {
   3.585737832081978*^9, 3.585737836476229*^9}, {3.5857380851044497`*^9, 
   3.585738087062562*^9}, 3.589153632221701*^9, {3.591265680267161*^9, 
   3.591265691568807*^9}, {3.6005564802138996`*^9, 3.6005565155269194`*^9}},
 CellLabel->
  "In[132]:=",ExpressionUUID->"d1adcdb1-2abe-4c98-9621-5e9e1746b027"]
}, Closed]],

Cell[CellGroupData[{

Cell["Perry\[CloseCurlyQuote]s MATLAB Export", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857318861388893`*^9, 3.5857318880309973`*^9}, {
  3.9167949970720077`*^9, 
  3.91679499876*^9}},ExpressionUUID->"a26d8c2e-499b-4b7d-8704-1bee267568fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$PerryMATLABExport", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"temp$LastSaveStamp", " ", "=", " ", "\"\<No Record\>\""}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"ValueQ", "[", "temp$savedir", "]"}], "]"}], ",", 
           RowBox[{
           "temp$savedir", "=", " ", 
            "\"\<--Please Choose A Directory--\>\""}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"ValueQ", "[", "temp$saveName", "]"}], "]"}], ",", 
           RowBox[{"temp$saveName", "=", "\"\<NewModel\>\""}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<MATLAB Export - Perry's Version\>\"", ",", 
             "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
            "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"0", "/", "255"}], ",", 
              RowBox[{"150", "/", "255"}], ",", 
              RowBox[{"240", "/", "255"}]}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Model Token:\>\"", ",", "Black", ",", "Bold"}], 
             "]"}], ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", "temp$saveName", "]"}], ",", "String", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Select Target Directory For Files to Save to:\>\"", ",", 
              "Black", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Choose directory\>\"", ",", 
              RowBox[{"temp$savedir", "=", 
               RowBox[{"SystemDialogInput", "[", "\"\<Directory\>\"", "]"}]}],
               ",", 
              RowBox[{"Method", "->", "\"\<Queued\>\""}]}], "]"}]}], "}"}], 
          "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Target Save Location:\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<Target Directory: \>\"", ",", 
            RowBox[{"Dynamic", "[", "temp$savedir", "]"}]}], "}"}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<Files Will Take the Form: \>\"", ",", 
            RowBox[{"Dynamic", "[", 
             RowBox[{
             "\"\<SUMCONSS_\>\"", "<>", "temp$saveName", "<>", 
              "\"\<_[Matrix]_[Re/Im].dat\>\""}], "]"}]}], "}"}], "}"}], "]"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\< Save \>\"", ",", "Bold", ",", "Small", ",", "White"}], 
              "]"}], ",", "mod$PerrySaveMATLAB", ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}], 
          "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<Last Save: \>\"", ",", 
            RowBox[{"Dynamic", "[", "temp$LastSaveStamp", "]"}]}], "}"}], 
          "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"500", ",", "300"}], "}"}]}], ",", 
      RowBox[{"WindowMargins", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Export Model\>\""}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.5787902436766253`*^9, 3.5787902658128915`*^9}, {3.5787903547369776`*^9, 
   3.5787904264820814`*^9}, {3.578790459612976*^9, 3.5787905160222025`*^9}, {
   3.5787907047679987`*^9, 3.5787907076121607`*^9}, {3.5787907590391026`*^9, 
   3.578790854695574*^9}, 3.5787908945598536`*^9, {3.5787910433383636`*^9, 
   3.5787910545650053`*^9}, 3.5788748266424856`*^9, {3.5788749247060947`*^9, 
   3.5788749261751785`*^9}, {3.579318855301427*^9, 3.579318871026327*^9}, {
   3.5857288163333063`*^9, 3.5857288346983566`*^9}, {3.585728874304622*^9, 
   3.585728920231249*^9}, {3.5857289892501965`*^9, 3.5857291668643556`*^9}, {
   3.5857292018953595`*^9, 3.585729251991225*^9}, {3.585730505333912*^9, 
   3.5857309915687227`*^9}, {3.585731023893572*^9, 3.585731237672799*^9}, 
   3.5857312761730013`*^9, {3.585731411926766*^9, 3.5857314192201834`*^9}, {
   3.5857319310944605`*^9, 3.58573193195951*^9}, {3.585732115491008*^9, 
   3.585732179461666*^9}, {3.585732214283658*^9, 3.5857322161957674`*^9}, {
   3.5857322659826155`*^9, 3.585732292247117*^9}, {3.5857324938266473`*^9, 
   3.585732527345564*^9}, {3.5857326079671755`*^9, 3.5857326105933256`*^9}, {
   3.585732658289054*^9, 3.5857328006791983`*^9}, {3.5857328351611705`*^9, 
   3.5857328358512096`*^9}, {3.5857328909733624`*^9, 3.585732939287126*^9}, {
   3.58573618308366*^9, 3.585736189835047*^9}, {3.5857362310784054`*^9, 
   3.5857362533016768`*^9}, {3.5857378637907915`*^9, 
   3.5857378746334114`*^9}, {3.5911510766026883`*^9, 3.591151160273474*^9}, {
   3.591151211815422*^9, 3.5911512320185776`*^9}, {3.5911513247978845`*^9, 
   3.591151326551985*^9}, {3.595307266673524*^9, 3.5953072916629534`*^9}, {
   3.595307562088421*^9, 3.595307706809698*^9}, {3.595307757050572*^9, 
   3.595307762115862*^9}, {3.595307797699897*^9, 3.5953078311588106`*^9}, {
   3.5953079799203196`*^9, 3.5953080906206512`*^9}, {3.595308229488594*^9, 
   3.5953082436064014`*^9}, {3.5953082742621546`*^9, 3.595308299334589*^9}, {
   3.5953084176123543`*^9, 3.5953084426747875`*^9}, {3.600556290630056*^9, 
   3.600556298328496*^9}, {3.9167950586526093`*^9, 3.9167950722755966`*^9}, {
   3.916795169571623*^9, 3.9167951702832346`*^9}, {3.9167956386517773`*^9, 
   3.916795725307643*^9}, {3.9167957669521666`*^9, 3.9167957840063868`*^9}, {
   3.9167959102429028`*^9, 3.9167959141527853`*^9}, {3.916796017541252*^9, 
   3.916796019390565*^9}, {3.9167962202559757`*^9, 3.9167962254518533`*^9}, {
   3.9167963162033987`*^9, 3.916796377383544*^9}, {3.9167964091168623`*^9, 
   3.916796451144563*^9}, 3.9167964999282255`*^9, 3.916796551036182*^9, {
   3.916800318726429*^9, 3.91680035000818*^9}, {3.9168003803409777`*^9, 
   3.9168004255161214`*^9}, {3.916800501819065*^9, 3.916800504851329*^9}, {
   3.916800536543708*^9, 3.916800573239244*^9}, {3.916800757870671*^9, 
   3.9168008205215425`*^9}, {3.9168008617245746`*^9, 3.916800899740054*^9}, {
   3.916800937907281*^9, 3.9168009631060915`*^9}, {3.9168010037953887`*^9, 
   3.91680108534488*^9}, {3.9168011347841635`*^9, 3.9168011518480043`*^9}, {
   3.9168011863350754`*^9, 3.9168011911348505`*^9}, {3.9168012775750275`*^9, 
   3.916801347036107*^9}, {3.9168013802675548`*^9, 3.9168014283466387`*^9}, {
   3.916801743654805*^9, 3.916801802749953*^9}, {3.91680184706948*^9, 
   3.91680193176112*^9}, {3.916801962892227*^9, 3.9168019722442303`*^9}, {
   3.9180025275362844`*^9, 3.9180025297840357`*^9}, {3.918003664983537*^9, 
   3.918003692610653*^9}, {3.918003771663495*^9, 
   3.9180037818235483`*^9}},ExpressionUUID->"fe4dd2d3-f33f-4ff3-964d-\
036e017ebbf9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Perry\[CloseCurlyQuote]s MATLAB Save", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857323019276714`*^9, 3.585732302311693*^9}, {
  3.9167951563357654`*^9, 3.916795163135812*^9}, {3.9180059786305275`*^9, 
  3.9180059791672754`*^9}},ExpressionUUID->"f8829dca-6386-43b3-8c93-\
5362a3d4d196"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$PerrySaveMATLAB", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ssA", ",", "ssB", ",", "ssC", ",", "ssD", ",", "Mvv", ",", "Mpv", ",", 
       "Kvvc", ",", "Kpvc", ",", "Gvv", ",", "Gpv"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"OldParametersAsTimeBased", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"allparams", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], "<>", "\"\<[t]\>\""}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}]}], ";",
       "\n", 
      RowBox[{"SharedGroundVariables", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xGND", "[", "t", "]"}], ",", 
         RowBox[{"yGND", "[", "t", "]"}], ",", 
         RowBox[{"zGND", "[", "t", "]"}], ",", 
         RowBox[{"pitchGND", "[", "t", "]"}], ",", 
         RowBox[{"yawGND", "[", "t", "]"}], ",", 
         RowBox[{"rollGND", "[", "t", "]"}]}], "}"}]}], ";", " ", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Merging", " ", "Ground", " ", "Sources"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"AllCoordinates", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"bodylist", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "bodylist", "]"}]}], "}"}]}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"AllCoordinatesInTime", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"AllCoordinates", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], "<>", "\"\<[t]\>\""}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "AllCoordinates", "]"}]}], "}"}]}], "]"}]}],
       ";", "\n", 
      RowBox[{"AllSecondOrderGrounds", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"SharedGroundVariables", "/.", 
         RowBox[{"(", 
          RowBox[{"n_", "->", 
           RowBox[{"n", "*", "SharedGroundVariables"}]}], ")"}]}], "]"}]}], 
      ";", "\n", 
      RowBox[{"AllSecondGNDtoZero", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AllSecondOrderGrounds", " ", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "->", " ", "0"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "AllSecondOrderGrounds", " ", "]"}]}], 
          "}"}]}], "]"}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Determining", " ", "how", " ", "the", " ", "ground", " ", "would", 
        " ", "move", " ", "with", " ", "the", " ", "initial", " ", 
        "placement", " ", "of", " ", "each", " ", "body"}], " ", "*)"}], "\n", 
      RowBox[{"InitialInGround", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Expand", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Flatten", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"xGND", "[", "t", "]"}], ",", 
                    RowBox[{"yGND", "[", "t", "]"}], ",", 
                    RowBox[{"zGND", "[", "t", "]"}]}], "}"}], "+", 
                   RowBox[{
                    RowBox[{"rotXYZ", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"pitchGND", "[", "t", "]"}], ",", 
                    RowBox[{"yawGND", "[", "t", "]"}], ",", 
                    RowBox[{"rollGND", "[", "t", "]"}]}], "}"}], "]"}], ".", 
                    RowBox[{"save$initpos", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"pitchGND", "[", "t", "]"}], ",", 
                    RowBox[{"yawGND", "[", "t", "]"}], ",", 
                    RowBox[{"rollGND", "[", "t", "]"}]}], "}"}]}], "}"}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$initpos", "]"}]}], "}"}]}], 
              "]"}], "/.", 
             RowBox[{"TrigAngleApprox", "[", "1", "]"}]}], "]"}], "/.", 
           RowBox[{"Flatten", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"RuleAllDiffAboveOrder", "[", 
               RowBox[{
                RowBox[{"SharedGroundVariables", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", "1"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "SharedGroundVariables", "]"}]}], 
               "}"}]}], "]"}], "]"}]}], ")"}], "/.", "AllSecondGNDtoZero"}], 
        " ", "]"}]}], ";", "\n", 
      RowBox[{"AddingInGroundFirstOrder", " ", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AllCoordinatesInTime", "[", 
           RowBox[{"[", "m", "]"}], "]"}], "->", " ", 
          RowBox[{
           RowBox[{"AllCoordinatesInTime", "[", 
            RowBox[{"[", "m", "]"}], "]"}], "+", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"IsGroundVector", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"Flatten", "[", "InitialInGround", "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", "0"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "IsGroundVector", "]"}]}], "}"}]}], 
             "]"}], "[", 
            RowBox[{"[", "m", "]"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"Length", "[", "AllCoordinatesInTime", "]"}]}], "}"}]}], 
        "]"}]}], ";", "\n", 
      RowBox[{"AddingInGroundRule", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"AddingInGroundFirstOrder", ",", 
          RowBox[{"D", "[", 
           RowBox[{"AddingInGroundFirstOrder", ",", "t"}], "]"}]}], "}"}], 
        "]"}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Determining", " ", "how", " ", "to", " ", "project", " ", "back", " ",
         "from", " ", "the", " ", "variables", " ", "to", " ", "the", " ", 
        "outputs", " ", "of", " ", "interest"}], " ", "*)"}], "\n", 
      RowBox[{"MotionInInertial", " ", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToExpression", "[", 
           RowBox[{"\"\<O\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"AllCoordinatesInTime", "[", 
              RowBox[{"[", "m", "]"}], "]"}], "]"}]}], "]"}], "==", " ", 
          RowBox[{
           RowBox[{"AllCoordinatesInTime", "[", 
            RowBox[{"[", "m", "]"}], "]"}], "+", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"IsGroundVector", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"Flatten", "[", "InitialInGround", "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", "0"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "IsGroundVector", "]"}]}], "}"}]}], 
             "]"}], "[", 
            RowBox[{"[", "m", "]"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"Length", "[", "AllCoordinatesInTime", "]"}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "To", " ", "avoid", " ", "output", " ", "and", " ", "input", " ", 
        "name", " ", "doubles"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"VariablesAsTimeBased", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"allvars", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], "<>", "\"\<[t]\>\""}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\n", 
      RowBox[{"DrivingForceTerms", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"\"\<F\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"VariablesAsTimeBased", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "VariablesAsTimeBased", "]"}]}], "}"}]}], 
        "]"}]}], ";", "\n", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Reforming", " ", "the", " ", "equations", " ", "of", " ", "motion"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"SpringForceTerms", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"matKpvc", ".", "OldParametersAsTimeBased"}], ")"}], " ", 
        "+", " ", 
        RowBox[{"(", 
         RowBox[{"matKvvc", ".", "VariablesAsTimeBased"}], ")"}]}]}], ";", 
      "\n", 
      RowBox[{"DampingForceTerms", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"matGpv", ".", 
          RowBox[{"D", "[", 
           RowBox[{"OldParametersAsTimeBased", ",", "t"}], "]"}]}], ")"}], 
        " ", "+", " ", 
        RowBox[{"(", 
         RowBox[{"matGvv", ".", 
          RowBox[{"D", "[", 
           RowBox[{"VariablesAsTimeBased", ",", "t"}], "]"}]}], ")"}]}]}], 
      ";", "\n", 
      RowBox[{"InertialForceTerms", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"matMpv", ".", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{"OldParametersAsTimeBased", ",", "t"}], "]"}], ",", 
            "t"}], "]"}]}], ")"}], " ", "+", " ", 
        RowBox[{"(", 
         RowBox[{"matMvv", ".", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{"VariablesAsTimeBased", ",", "t"}], "]"}], ",", "t"}], 
           "]"}]}], ")"}]}]}], ";", "\n", 
      RowBox[{"LHSEquationsOfMotion", " ", "=", " ", 
       RowBox[{
       "InertialForceTerms", "+", "DampingForceTerms", "+", 
        "SpringForceTerms"}]}], ";", "\n", 
      RowBox[{"RHSEquationsOfMotion", " ", "=", " ", "DrivingForceTerms"}], 
      ";", "\n", 
      RowBox[{"EquationsOfMotion", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"LHSEquationsOfMotion", "[", 
            RowBox[{"[", "n", "]"}], "]"}], "-", 
           RowBox[{"RHSEquationsOfMotion", "[", 
            RowBox[{"[", "n", "]"}], "]"}]}], " ", "==", " ", "0"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", "LHSEquationsOfMotion", "]"}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\n", 
      RowBox[{"(*", " ", "Solving", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Share", "[", "]"}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{"Just", " ", "to", " ", "speed", " ", "things", " ", "up"}], 
       " ", "*)"}], "\n", 
      RowBox[{"AllEquationsSolEq", " ", "=", " ", 
       RowBox[{"Equal", "@@@", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Solve", "[", 
          RowBox[{"EquationsOfMotion", ",", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"D", "[", 
              RowBox[{"VariablesAsTimeBased", ",", "t"}], "]"}], ",", "t"}], 
            "]"}]}], "]"}], "]"}]}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Defining"}], " ", "all", " ", "states", " ", "to",
          " ", "keep", " ", "within", " ", "the", " ", "system"}], " ", "-"}],
        " ", "*)"}], "\n", 
      RowBox[{"AllFactors", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", "VariablesAsTimeBased", "}"}], "]"}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Defining"}], " ", "the", " ", "driving", " ", 
         "terms"}], " ", "-"}], " ", "*)"}], "\n", 
      RowBox[{"InputVariables", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"SharedGroundVariables", ",", " ", "DrivingForceTerms"}], 
         "}"}], "]"}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Defining"}], " ", "the", " ", "output", " ", 
         "coordinates"}], " ", "-"}], " ", "*)"}], "\n", 
      RowBox[{"OutputVariables", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", "MotionInInertial", "}"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Generating"}], " ", "the", " ", "statespace", " ",
          "model"}], " ", "-"}], " ", "*)"}], "\n", 
      RowBox[{"SystemStateSpace", " ", "=", 
       RowBox[{"StateSpaceModel", "[", 
        RowBox[{
         RowBox[{"Expand", "[", 
          RowBox[{"AllEquationsSolEq", "/.", "AddingInGroundRule"}], "]"}], 
         ",", "AllFactors", ",", "InputVariables", ",", "OutputVariables", 
         ",", "t"}], " ", "]"}]}], ";", "\n", 
      RowBox[{"ssA", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"SystemStateSpace", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"ssB", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"SystemStateSpace", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"ssC", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"SystemStateSpace", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"ssD", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"SystemStateSpace", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\n", 
      RowBox[{"(*", 
       RowBox[{"Determining", " ", "State", " ", "Names"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"StateNames", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"SystemStateSpace", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}], ">", "1"}], ",", 
           RowBox[{"StringDrop", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"SystemStateSpace", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             RowBox[{"-", "3"}]}], "]"}], ",", 
           RowBox[{"StringDrop", "[", 
            RowBox[{
             RowBox[{"\"\<D\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"SystemStateSpace", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"n", "-", "1"}], "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
             RowBox[{"-", "3"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"SystemStateSpace", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
      "\n", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", " ", "Exporting"}], " ", "System", " ", "Files"}], " ", 
        "-"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"OutputFileNamingToken", " ", "=", " ", 
       RowBox[{"ToString", "[", "temp$saveName", "]"}]}], ";", "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_A_Re.dat\>\""}], ",", 
        RowBox[{"Re", "[", "ssA", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_A_Im.dat\>\""}], ",", 
        RowBox[{"Im", "[", "ssA", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_B_Re.dat\>\""}], ",", 
        RowBox[{"Re", "[", "ssB", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_B_Im.dat\>\""}], ",", 
        RowBox[{"Im", "[", "ssB", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_C_Re.dat\>\""}], ",", 
        RowBox[{"Re", "[", "ssC", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_C_Im.dat\>\""}], ",", 
        RowBox[{"Im", "[", "ssC", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_D_Re.dat\>\""}], ",", 
        RowBox[{"Re", "[", "ssD", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_D_Im.dat\>\""}], ",", 
        RowBox[{"Im", "[", "ssD", "]"}], ",", "\"\<Table\>\""}], "]"}], ";", 
      "\n", "\[IndentingNewLine]", 
      RowBox[{"AltOutputVariables", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", "AllCoordinatesInTime", "}"}], "]"}], "]"}]}], ";", 
      "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_OutputVars.txt\>\""}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"StringDrop", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"AltOutputVariables", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
            RowBox[{"-", "3"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "OutputVariables", "]"}]}], "}"}]}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AltInputVariables", " ", "=", " ", 
       RowBox[{"N", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{"SharedGroundVariables", ",", "DrivingForceTerms"}], "}"}], 
         "]"}], "]"}]}], ";", "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_InputVars.txt\>\""}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"StringDrop", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"AltInputVariables", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
            RowBox[{"-", "3"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "AltInputVariables", "]"}]}], "}"}]}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"AltStateNames", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"\"\<s\>\"", "<>", 
          RowBox[{"StateNames", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "StateNames", "]"}]}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<SUMCONSS_\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<_StateVars.txt\>\""}], ",", "AltStateNames"}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Generating", " ", "a", " ", "Matlab", " ", "Function", " ", "in", " ",
         "the", " ", "same", " ", "file", " ", "to", " ", "directly", " ", 
        "load", " ", "the", " ", "State", " ", "Space"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", "temp$savedir", "]"}], "<>", 
         "\"\<LoadSUMCONModel.m\>\""}], ",", 
        RowBox[{
        "\"\<function[SSModel]=LoadSUMCONModel(SUMCONModelName)\n\
%[SSModel]=LoadSUMCONModel(ModelToken)\n% Loads the matlab file exported by \
SUMCON associated with the given model token.% Function returns a standard \
Matlab SS for use in other systems with the naming\n% convention used in the \
SUMCON model.%% Authorship\n%{Author:Perry William Fox Forsyth \
Contact:u5024171@anu.edu.au Date:2024_02_27 (YYYY_MM_DD) Version:2.0-Now \
autogenerated by the SUMCON script %}\[IndentingNewLine]\nif nargin<1\n\
SUMCONModelName='\>\"", "<>", "OutputFileNamingToken", "<>", 
         "\"\<';\nend\[IndentingNewLine]\n\
MatrixElementList={'A','B','C','D'};\nFileNames={};\nfor \
i=1:length(MatrixElementList)\n\
FileNames{end+1}=['SUMCONSS_',SUMCONModelName,'_',MatrixElementList{i},'_Re.\
dat'];\nFileNames{end+1}=['SUMCONSS_',SUMCONModelName,'_',MatrixElementList{i}\
,'_Im.dat'];\nend\[IndentingNewLine]\n\
BarSS.InputVar=readcell(['SUMCONSS_',SUMCONModelName,'_InputVars.txt']);\n\
BarSS.OutputVar=readcell(['SUMCONSS_',SUMCONModelName,'_OutputVars.txt']);\n\
BarSS.StateNames=readcell(['SUMCONSS_',SUMCONModelName,'_StateVars.txt']);\
\[IndentingNewLine]\n%% Sectioning out data\nfor i=1:length(FileNames)\n% \
Loading the file\nFileName=FileNames{i};\nData=dlmread(FileName);\
\[IndentingNewLine]\n% Checking if real or imaginary\nif \
isempty(strfind(FileName,'Re'))==false\nReal=1;\nelseif \
isempty(strfind(FileName,'Im'))==false\nReal=0;\nelse\nerror('Unrecognized \
Identity Name:Not sure if Real or Imaginary')\nend\[IndentingNewLine]\n% \
Determining Matrix\nif isempty(strfind(FileName,'_A_'))==false\n\
MatrixName='A';\nelseif isempty(strfind(FileName,'_B_'))==false\n\
MatrixName='B';\nelseif isempty(strfind(FileName,'_C_'))==false\n\
MatrixName='C';\nelseif isempty(strfind(FileName,'_D_'))==false\n\
MatrixName='D';\nelse\nerror('Unrecognized Matrix Name:Not sure position in \
statespace')\nend\[IndentingNewLine]\n% Applying all fields\nif \
max(strcmp(fields(BarSS),MatrixName))\n\
BarSS.(MatrixName)=BarSS.(MatrixName)+Real*Data+(1-Real)*1i.*Data;\nelse\n\
BarSS.(MatrixName)=Real*Data+(1-Real)*1i.*Data;\nend\nend\[IndentingNewLine]\n\
%% Making Statespace models\n\
SSModel=ss(BarSS.A,BarSS.B,BarSS.C,BarSS.D,'InputName',BarSS.InputVar,'\
OutputName',BarSS.OutputVar,'StateName',BarSS.StateNames);\nend\>\""}], ",", 
        "\"\<Table\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"temp$LastSaveStamp", " ", "=", " ", 
       RowBox[{
       "\"\<[\>\"", "<>", "OutputFileNamingToken", "<>", "\"\<]    \>\"", "<>",
         " ", 
        RowBox[{"DateString", "[", "Now", "]"}]}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585732305660885*^9, 3.5857323281581717`*^9}, {
   3.585733047161296*^9, 3.5857330553987675`*^9}, {3.585733470034483*^9, 
   3.585733597330764*^9}, {3.585733682500635*^9, 3.585733988385131*^9}, {
   3.5857343817776318`*^9, 3.5857344784521613`*^9}, {3.5857345277489805`*^9, 
   3.5857346169760847`*^9}, {3.585734659577521*^9, 3.585734660751588*^9}, {
   3.585734702876998*^9, 3.5857349012343426`*^9}, {3.5857349908504686`*^9, 
   3.585735404451125*^9}, {3.58573555629081*^9, 3.585735629043971*^9}, {
   3.5857358198128824`*^9, 3.5857358241341295`*^9}, {3.585735928775115*^9, 
   3.585735936185539*^9}, {3.5857365359478436`*^9, 3.585736536958901*^9}, {
   3.585737832081978*^9, 3.585737836476229*^9}, {3.5857380851044497`*^9, 
   3.585738087062562*^9}, 3.589153632221701*^9, {3.591265680267161*^9, 
   3.591265691568807*^9}, {3.6005564802138996`*^9, 3.6005565155269194`*^9}, {
   3.916795165403637*^9, 3.9167951660596914`*^9}, {3.9168003759122014`*^9, 
   3.916800386007828*^9}, {3.9168004473027816`*^9, 3.9168004492615747`*^9}, 
   3.917998576158928*^9, {3.9179986069430733`*^9, 3.917998633131*^9}, {
   3.917998675056178*^9, 3.9179988571511545`*^9}, {3.9179989590107756`*^9, 
   3.917999022200452*^9}, {3.9180011435627666`*^9, 3.9180011728618007`*^9}, {
   3.9180014165550117`*^9, 3.918001422883552*^9}, {3.9180014712553453`*^9, 
   3.9180015054343033`*^9}, {3.918001557595591*^9, 3.9180015677676945`*^9}, 
   3.9180016393640876`*^9, {3.9180018385538535`*^9, 3.91800183893878*^9}, {
   3.9180019316108866`*^9, 3.91800197228979*^9}, 3.9180020026104107`*^9, 
   3.9180020929539557`*^9, {3.918002131603365*^9, 3.9180021722740297`*^9}, {
   3.9180022757947235`*^9, 3.918002328136521*^9}, {3.918003054919786*^9, 
   3.918003081264103*^9}, 3.9180031676937447`*^9, {3.9180033201837463`*^9, 
   3.9180033267402105`*^9}, {3.9180034560516725`*^9, 3.91800345756732*^9}, {
   3.9180036137913184`*^9, 3.918003638106516*^9}, 3.9180038535876064`*^9, {
   3.9180039356811113`*^9, 3.9180039559796095`*^9}, {3.9180040347126136`*^9, 
   3.9180040353156853`*^9}, {3.918016158679819*^9, 3.91801625055552*^9}, {
   3.918016292719781*^9, 3.9180162932990384`*^9}, {3.918016325349697*^9, 
   3.9180163569454155`*^9}},ExpressionUUID->"38092dd8-d130-4e70-a740-\
ac6374fa6d6c"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{701.625, 697.875},
WindowMargins->{{Automatic, 281.25}, {8.625, Automatic}},
ShowSelection->True,
Magnification->0.75,
FrontEndVersion->"13.1 for Microsoft Windows (64-bit) (August 22, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"8bf3dc67-35e0-42f2-802d-8d2a2ad7d72e"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 314, 9, 87, "Subtitle",ExpressionUUID->"3091ae98-696a-4d43-b3ae-dd0105fcabd5",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[906, 35, 184, 4, 50, "Section",ExpressionUUID->"4a1c4c0b-40f3-417f-b036-6a9c25f71c8f",
 InitializationCell->True],
Cell[1093, 41, 751, 13, 33, "Input",ExpressionUUID->"af1266f6-03d1-4d9f-83db-4451ba460049",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1869, 58, 185, 4, 41, "Subsection",ExpressionUUID->"e25414ee-49e9-48a6-9349-4f1595638a7b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2079, 66, 291, 5, 34, "Subsubsection",ExpressionUUID->"d70b95e9-5651-4766-89e9-158e57d3972e",
 InitializationCell->True],
Cell[2373, 73, 13945, 228, 329, "Input",ExpressionUUID->"6626af03-fc37-4b7a-ac37-aa60372d7bbc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16355, 306, 187, 4, 29, "Subsubsection",ExpressionUUID->"93520f58-7c71-448d-be15-c39584e21063",
 InitializationCell->True],
Cell[16545, 312, 3127, 68, 213, "Input",ExpressionUUID->"5e418d84-8508-4740-a4e7-e5d5f6674531",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19709, 385, 191, 4, 29, "Subsubsection",ExpressionUUID->"206ae7b7-99ae-476a-a502-648eb983c387",
 InitializationCell->True],
Cell[19903, 391, 2109, 46, 194, "Input",ExpressionUUID->"c59bf594-c53d-43c0-8cff-d684991f7f0d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22049, 442, 257, 5, 29, "Subsubsection",ExpressionUUID->"9b918f18-5fc7-455b-96d9-26424a7a006d",
 InitializationCell->True],
Cell[22309, 449, 15354, 333, 1074, "Input",ExpressionUUID->"0d5ae563-c5b0-409b-898a-4d3c377c037c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[37700, 787, 256, 5, 29, "Subsubsection",ExpressionUUID->"24623df1-9f9f-447b-8194-51e73ec03a4c",
 InitializationCell->True],
Cell[37959, 794, 13131, 261, 1048, "Input",ExpressionUUID->"d30b85a7-0425-4d11-b481-695b9fa35cf0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[51127, 1060, 255, 5, 29, "Subsubsection",ExpressionUUID->"952d402e-c454-4062-9fae-805020da3547",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[51407, 1069, 240, 5, 27, "Text",ExpressionUUID->"b895e37e-fc6b-40f0-92ec-431cea6f4ad5",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True],
Cell[51650, 1076, 9360, 237, 604, "Input",ExpressionUUID->"d15393bc-cbcd-4c1a-99cf-dda03c612b60",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[61047, 1318, 233, 5, 27, "Text",ExpressionUUID->"9487aa2b-1486-40b0-91cf-04683bd3a040",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[61283, 1325, 2590, 57, 207, "Input",ExpressionUUID->"4f9cdc59-c138-44a1-8e7f-4d0bd2508622",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[63910, 1387, 231, 5, 27, "Text",ExpressionUUID->"9b965755-cc41-4302-a366-34f0d21e4942",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True],
Cell[64144, 1394, 9018, 197, 978, "Input",ExpressionUUID->"dc09617a-f2eb-4a65-b085-eeeb276a9e46",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[73199, 1596, 253, 5, 25, "Text",ExpressionUUID->"886ee2e8-e58f-4a8c-9a49-2a061fd7913a",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True],
Cell[73455, 1603, 8915, 195, 918, "Input",ExpressionUUID->"c8b53d9c-214e-4e0e-b6b8-ac087d7e4018",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[82407, 1803, 239, 5, 25, "Text",ExpressionUUID->"c60b2f94-6a12-47ba-b6a8-56451c48c61b",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True],
Cell[82649, 1810, 1340, 30, 168, "Input",ExpressionUUID->"2ce67c05-12a5-4b22-89a7-2d752d41c0e6",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[84026, 1845, 246, 5, 25, "Text",ExpressionUUID->"7c8a91dd-8c1e-4e94-ab50-c95df67bc41d",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True],
Cell[84275, 1852, 1582, 36, 228, "Input",ExpressionUUID->"bdb5fa4a-20b0-4775-92a6-27638244e2a3",
 CellGroupingRules->{GroupTogetherGrouping, 10005.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[85894, 1893, 251, 5, 25, "Text",ExpressionUUID->"e86c9e54-9244-4e2e-b5c3-e644c41ef717",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True],
Cell[86148, 1900, 1928, 40, 318, "Input",ExpressionUUID->"3e52d33f-5d99-4246-acfd-cb354ea5746c",
 CellGroupingRules->{GroupTogetherGrouping, 10006.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[88113, 1945, 256, 5, 25, "Text",ExpressionUUID->"7c0f3251-3764-4716-a17c-65732f0136d4",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True],
Cell[88372, 1952, 7001, 156, 738, "Input",ExpressionUUID->"184d3d0e-9165-492b-8016-87038b301f72",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[95410, 2113, 257, 5, 25, "Text",ExpressionUUID->"f30d3b9b-abfe-47dc-9485-324dee2335b4",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[95670, 2120, 4775, 108, 498, "Input",ExpressionUUID->"b34ca7b9-1f03-40cf-8d37-d168c3a687f0",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[100482, 2233, 257, 5, 25, "Text",ExpressionUUID->"d67c3afb-f4fd-4f0c-b924-de685df1aa67",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True],
Cell[100742, 2240, 1276, 26, 258, "Input",ExpressionUUID->"217e6b93-9655-4e78-855c-5213628b750a",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True],
Cell[102021, 2268, 1228, 26, 258, "Input",ExpressionUUID->"858bd446-4207-434e-801d-88015ef6f499",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[103286, 2299, 262, 5, 25, "Text",ExpressionUUID->"fe397cd6-afa3-43b5-912b-59df0f36d0ac",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[103551, 2306, 3103, 65, 468, "Input",ExpressionUUID->"ed92d9de-87b6-44de-91f0-3439a52ffb81",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[106691, 2376, 257, 5, 25, "Text",ExpressionUUID->"730df074-201b-47aa-90e8-610abd49a6fa",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True],
Cell[106951, 2383, 5840, 126, 435, "Input",ExpressionUUID->"5dc4c4a9-93dd-41a3-b5c6-5ab5e789bb62",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[112828, 2514, 262, 5, 27, "Text",ExpressionUUID->"31342342-a441-4ffa-aa97-3ed0ec469199",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True],
Cell[113093, 2521, 14427, 300, 1698, "Input",ExpressionUUID->"710f0388-645e-499d-a16c-f6b9d0f03677",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[127569, 2827, 208, 4, 29, "Subsubsection",ExpressionUUID->"42b3dde6-7c84-4c45-b05c-1a0a1cf3f79a",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[127802, 2835, 262, 5, 27, "Text",ExpressionUUID->"ec1b9afb-5ef6-433a-b94e-e3880b98b0a8",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True],
Cell[128067, 2842, 3426, 84, 227, "Input",ExpressionUUID->"68c09324-c99c-4edb-9b4a-aee9db2d15c8",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[131530, 2931, 239, 5, 25, "Text",ExpressionUUID->"6a05f918-94da-4252-b215-c9b6752283ab",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[131772, 2938, 2016, 44, 194, "Input",ExpressionUUID->"df60c679-d797-4aa7-a763-4c7a1786908f",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[133825, 2987, 241, 5, 27, "Text",ExpressionUUID->"cabc9598-60cc-4fc2-9111-a4b60bf75369",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True],
Cell[134069, 2994, 3093, 68, 211, "Input",ExpressionUUID->"f471a6b2-0818-4080-b259-31320afc4db6",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[137199, 3067, 295, 6, 27, "Text",ExpressionUUID->"3dfb8762-abc8-485e-bbf1-f46a488a929c",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True],
Cell[137497, 3075, 4444, 99, 290, "Input",ExpressionUUID->"0cebfc10-4113-4c32-becb-93bff39aef64",
 CellGroupingRules->{GroupTogetherGrouping, 10003.},
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[141978, 3179, 240, 5, 27, "Text",ExpressionUUID->"a3ca49e7-0963-4a00-be32-49da56d5e8d3",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True],
Cell[142221, 3186, 5835, 123, 406, "Input",ExpressionUUID->"8b0e5c4c-59df-40f1-9d9b-65ad280970f8",
 CellGroupingRules->{GroupTogetherGrouping, 10004.},
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[148105, 3315, 249, 5, 29, "Subsubsection",ExpressionUUID->"100f9dad-4e44-473f-ae8b-9aba65ad6b24",
 InitializationCell->True],
Cell[148357, 3322, 8635, 186, 638, "Input",ExpressionUUID->"7bef3e00-d441-4280-b61c-806b5e4421ad",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[157041, 3514, 188, 4, 41, "Subsection",ExpressionUUID->"e137d486-9575-4deb-bc44-dcc0d21e8680",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[157254, 3522, 192, 4, 34, "Subsubsection",ExpressionUUID->"3a317e72-680f-4c81-a08f-b4f3057aed0d",
 InitializationCell->True],
Cell[157449, 3528, 2610, 52, 298, "Input",ExpressionUUID->"6f2b6b02-770f-4257-957d-f580af4659cd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[160096, 3585, 243, 5, 29, "Subsubsection",ExpressionUUID->"809f4596-440f-4c5a-af75-eb1652a3a62a",
 InitializationCell->True],
Cell[160342, 3592, 7985, 153, 690, "Input",ExpressionUUID->"7ec23a9a-c194-44cd-85f1-8ed5f3cf8a2c",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[168376, 3751, 194, 4, 41, "Subsection",ExpressionUUID->"fed2f8e8-19ce-4826-9f79-5a3ce5539492",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[168595, 3759, 189, 4, 34, "Subsubsection",ExpressionUUID->"ee86c526-10cd-4c51-bc72-287bbb6455a8",
 InitializationCell->True],
Cell[168787, 3765, 790, 20, 34, "Input",ExpressionUUID->"9f306d74-928b-4766-beeb-5312409194f7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[169614, 3790, 190, 4, 29, "Subsubsection",ExpressionUUID->"9ad011ea-d59a-4792-9e2e-0f97faa99447",
 InitializationCell->True],
Cell[169807, 3796, 16255, 320, 791, "Input",ExpressionUUID->"27202074-1c1b-4109-8628-8016c3a69048",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[186099, 4121, 192, 4, 29, "Subsubsection",ExpressionUUID->"7f8b2047-7d08-4645-a215-176611d8e5d2",
 InitializationCell->True],
Cell[186294, 4127, 10027, 204, 451, "Input",ExpressionUUID->"a486a8ae-3691-4b00-8ec3-75db62dcae3f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[196358, 4336, 244, 5, 29, "Subsubsection",ExpressionUUID->"1eafc14e-a176-4669-a1a5-cba07cb73d4e",
 InitializationCell->True],
Cell[196605, 4343, 1644, 36, 117, "Input",ExpressionUUID->"f8b9fb38-9924-46d0-8fa3-4516271d672e",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[198310, 4386, 388, 7, 50, "Section",ExpressionUUID->"0e05e1df-5b81-4450-9d95-409df2d61901",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[198723, 4397, 271, 5, 41, "Subsection",ExpressionUUID->"34f3ef9d-567b-48bd-bc3d-8cf1704c7eae",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[199019, 4406, 323, 6, 34, "Subsubsection",ExpressionUUID->"3a027f48-a2b0-4d6b-9671-3632abbac7bc",
 InitializationCell->True],
Cell[199345, 4414, 24311, 482, 767, "Input",ExpressionUUID->"1a04c0a7-3582-43cb-a90d-531bea18f599",
 InitializationCell->True],
Cell[223659, 4898, 94, 0, 21, "Input",ExpressionUUID->"79962ed3-4d99-48c4-b01d-3886f311e1aa"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[223802, 4904, 197, 4, 30, "Subsection",ExpressionUUID->"a5516b51-b213-42b0-a003-c0a0d911b599",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[224024, 4912, 512, 8, 34, "Subsubsection",ExpressionUUID->"1617e38a-c4d8-4279-95d9-6c24464e07a8",
 InitializationCell->True],
Cell[224539, 4922, 43969, 913, 1597, "Input",ExpressionUUID->"6fc46225-0ec4-44c0-80a4-188d7d7520ed",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[268557, 5841, 196, 4, 30, "Subsection",ExpressionUUID->"7bc459f1-20d7-44df-8b14-bc4c95fc8960",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[268778, 5849, 263, 5, 34, "Subsubsection",ExpressionUUID->"307e9add-a288-45ef-80cb-f198a7950362",
 InitializationCell->True],
Cell[269044, 5856, 2623, 71, 385, "Input",ExpressionUUID->"c31a30f9-aa56-4e76-9610-f526eb0ec3b1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[271704, 5932, 195, 4, 29, "Subsubsection",ExpressionUUID->"9ced4761-9fcb-4e09-b808-4f4d34d50293",
 InitializationCell->True],
Cell[271902, 5938, 27116, 536, 907, "Input",ExpressionUUID->"4b7ddd5e-d124-454b-bbbe-ce71f66da179",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[299067, 6480, 201, 4, 30, "Subsection",ExpressionUUID->"b8f79e62-f1a2-4b8a-bf67-b5c4dceb7e85",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[299293, 6488, 248, 5, 34, "Subsubsection",ExpressionUUID->"90c15b69-5d16-4402-832f-40f7b9076839",
 InitializationCell->True],
Cell[299544, 6495, 25816, 530, 840, "Input",ExpressionUUID->"687ca59c-a81b-4bdd-97ec-5eb42024c07a",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[325409, 7031, 243, 5, 30, "Subsection",ExpressionUUID->"de9c977e-ac99-4ba1-91ff-9ffb162c0640",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[325677, 7040, 192, 4, 34, "Subsubsection",ExpressionUUID->"340cf913-40a3-449e-8d4d-0ad8f1dddc18",
 InitializationCell->True],
Cell[325872, 7046, 6448, 139, 323, "Input",ExpressionUUID->"9c0c258b-2cbf-4dde-9cfe-5d7679996d48",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[332381, 7192, 213, 4, 50, "Section",ExpressionUUID->"31572cfd-9fc3-4af3-b8c0-0d1384782b0a",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[332619, 7200, 193, 4, 41, "Subsection",ExpressionUUID->"bc30de0f-ba08-40cd-a8bb-eb2c20965266",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[332837, 7208, 193, 4, 34, "Subsubsection",ExpressionUUID->"b580b1ff-dc6e-4fa9-afcb-d187ef509033",
 InitializationCell->True],
Cell[333033, 7214, 2105, 47, 271, "Input",ExpressionUUID->"515c91a6-57a1-4a25-a637-d0c0afee3ed5",
 InitializationCell->True],
Cell[335141, 7263, 565, 12, 106, "Text",ExpressionUUID->"2db7c11b-36f3-4490-bb03-3d88593e4735",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[335743, 7280, 254, 5, 29, "Subsubsection",ExpressionUUID->"15f05588-adf9-4abd-a5e3-f8510e09b17f",
 InitializationCell->True],
Cell[336000, 7287, 16285, 330, 600, "Input",ExpressionUUID->"db5a891d-31f0-4a13-8966-535086849e00",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[352334, 7623, 216, 4, 41, "Subsection",ExpressionUUID->"4c0ab940-b2b2-4c24-91e2-46f38e9cbd17",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[352575, 7631, 215, 4, 34, "Subsubsection",ExpressionUUID->"bcd64e29-898c-47f0-b108-514a121f3008",
 InitializationCell->True],
Cell[352793, 7637, 82604, 1721, 3422, "Input",ExpressionUUID->"4ce7f721-03f0-4ad9-88a8-cb726c190668",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[435434, 9363, 266, 5, 34, "Subsubsection",ExpressionUUID->"33b9d309-61af-4510-a4d3-4cbd01849526",
 InitializationCell->True],
Cell[435703, 9370, 33129, 734, 1441, "Input",ExpressionUUID->"783aa336-3919-4928-9852-bab4f8c7d6cb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[468869, 10109, 188, 4, 29, "Subsubsection",ExpressionUUID->"c5f82d4f-032d-4d76-a924-9323e8238e5c",
 InitializationCell->True],
Cell[469060, 10115, 33934, 757, 1443, "Input",ExpressionUUID->"179656ea-065b-46d7-bf4c-50181f17bdbc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[503031, 10877, 201, 4, 29, "Subsubsection",ExpressionUUID->"19fc63c2-deaa-4d9c-990c-e66c22f86862",
 InitializationCell->True],
Cell[503235, 10883, 5716, 151, 214, "Input",ExpressionUUID->"47c08da7-c900-4009-ade6-351d57c7df13",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[508988, 11039, 208, 4, 29, "Subsubsection",ExpressionUUID->"82d03065-f27e-4a31-bb77-9ee0b843ae85",
 InitializationCell->True],
Cell[509199, 11045, 3032, 58, 699, "Input",ExpressionUUID->"6863ae44-55e8-4ad5-992e-f6263adea802",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[512268, 11108, 190, 4, 29, "Subsubsection",ExpressionUUID->"417b9bfc-d183-4451-a618-b6bf0706ada0",
 InitializationCell->True],
Cell[512461, 11114, 7871, 187, 375, "Input",ExpressionUUID->"9afc08ab-0f9c-4da2-be01-6ec87bfd4457",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[520369, 11306, 439, 7, 29, "Subsubsection",ExpressionUUID->"acb86d86-35a2-463c-811e-2cdc74525ff9",
 InitializationCell->True],
Cell[520811, 11315, 27419, 602, 1110, "Input",ExpressionUUID->"86865263-2b19-4ff5-abcc-eb58db9bff1b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[548267, 11922, 261, 5, 29, "Subsubsection",ExpressionUUID->"b7f5a1ce-dc5d-4dad-a3af-b57c97b11560",
 InitializationCell->True],
Cell[548531, 11929, 29950, 633, 1204, "Input",ExpressionUUID->"d4c95ded-b7f6-4f2e-9028-0412809beafe",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[578518, 12567, 298, 5, 29, "Subsubsection",ExpressionUUID->"5cc7aace-6a0b-4187-b9aa-0de9c035ad89",
 InitializationCell->True],
Cell[578819, 12574, 19637, 459, 1440, "Input",ExpressionUUID->"fb18e3d7-da4f-4924-be42-2a0c3b956159",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[598493, 13038, 211, 4, 29, "Subsubsection",ExpressionUUID->"9549b122-60ab-4177-8b5e-7764b54dbdeb",
 InitializationCell->True],
Cell[598707, 13044, 367, 9, 70, "Input",ExpressionUUID->"a611256e-dc25-444f-b692-7eb03fad556d",
 InitializationCell->True],
Cell[599077, 13055, 591, 17, 70, "Input",ExpressionUUID->"d6b71f48-2798-430b-b7b9-21771aa044e1",
 InitializationCell->True],
Cell[599671, 13074, 2370, 69, 157, "Input",ExpressionUUID->"817d396c-6c79-4d85-969c-e759a662b860",
 InitializationCell->True],
Cell[602044, 13145, 915, 27, 100, "Input",ExpressionUUID->"464f0559-f9e9-40b4-a1d5-ec98b405f9c9",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[603008, 13178, 229, 4, 30, "Subsection",ExpressionUUID->"049cd18d-8eb5-42db-923a-3e1694ee681c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[603262, 13186, 276, 5, 34, "Subsubsection",ExpressionUUID->"34b4be68-a521-4f8d-be89-cd40d2eca1fc",
 InitializationCell->True],
Cell[603541, 13193, 48522, 1018, 1534, "Input",ExpressionUUID->"1d8bc925-a8c2-4dc3-bc09-099f97106cbd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[652100, 14216, 295, 5, 29, "Subsubsection",ExpressionUUID->"ccd3e479-5f09-4242-aee2-d4255070c90e",
 InitializationCell->True],
Cell[652398, 14223, 27660, 580, 1032, "Input",ExpressionUUID->"ac1ab41c-b09a-4ff0-8b7c-bc03d8c7efb3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[680095, 14808, 292, 5, 29, "Subsubsection",ExpressionUUID->"1e0265c9-7f1d-4b15-a2ef-11a1269b45f7",
 InitializationCell->True],
Cell[680390, 14815, 22722, 457, 786, "Input",ExpressionUUID->"ec75003a-ec58-4c01-9c49-ae6fceb3fce5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[703149, 15277, 345, 6, 29, "Subsubsection",ExpressionUUID->"1ecdc448-7f42-4b9d-a844-32b9fcbad528",
 InitializationCell->True],
Cell[703497, 15285, 21137, 438, 806, "Input",ExpressionUUID->"a17d2261-5b03-4aec-948f-998420cbdc71",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[724671, 15728, 343, 6, 29, "Subsubsection",ExpressionUUID->"50edf168-8498-4568-9cd8-ec380f89f5bc",
 InitializationCell->True],
Cell[725017, 15736, 21367, 436, 786, "Input",ExpressionUUID->"85c94835-0e4d-458f-9dd3-d0ea7b8b3c69",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[746421, 16177, 262, 5, 29, "Subsubsection",ExpressionUUID->"2028f3bd-414e-454e-bbde-4540f454d60d",
 InitializationCell->True],
Cell[746686, 16184, 4582, 112, 263, "Input",ExpressionUUID->"5a2376b1-4317-462d-8b04-8793257d0347",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[751305, 16301, 262, 5, 29, "Subsubsection",ExpressionUUID->"976899fb-d5fc-4241-8e4d-01f912bd67c7",
 InitializationCell->True],
Cell[751570, 16308, 18853, 438, 748, "Input",ExpressionUUID->"b3395ac4-890a-4f13-a34d-2a8be6c56673",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[770472, 16752, 282, 5, 41, "Subsection",ExpressionUUID->"6c2330de-2d9e-4905-b56f-d1138430cd9d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[770779, 16761, 331, 6, 34, "Subsubsection",ExpressionUUID->"3c70cc0e-c564-4c20-aa6d-0e973b7de3cd",
 InitializationCell->True],
Cell[771113, 16769, 64170, 1349, 1774, "Input",ExpressionUUID->"0109c600-7926-432c-8814-1be7a00009e0",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[835320, 18123, 353, 6, 34, "Subsubsection",ExpressionUUID->"c510a6bd-07d4-4dc0-a185-08bd957ba6f7",
 InitializationCell->True],
Cell[835676, 18131, 43837, 941, 1494, "Input",ExpressionUUID->"12dc3dfc-7bda-4118-89bb-2f5b663a9554",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[879550, 19077, 405, 7, 29, "Subsubsection",ExpressionUUID->"72ce328e-aaca-404c-a4fe-3d1a6b69b4ea",
 InitializationCell->True],
Cell[879958, 19086, 41807, 897, 1464, "Input",ExpressionUUID->"3d19274f-4c29-4993-9743-023c30e91004",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[921802, 19988, 297, 5, 29, "Subsubsection",ExpressionUUID->"4808038a-0a26-4acc-aca3-9a912f7223c5",
 InitializationCell->True],
Cell[922102, 19995, 6310, 146, 345, "Input",ExpressionUUID->"d784b7b8-1b19-4083-8673-86a85ba6d18a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[928449, 20146, 400, 7, 29, "Subsubsection",ExpressionUUID->"79951334-a5c5-4c93-9b40-5d66c39a0a27",
 InitializationCell->True],
Cell[928852, 20155, 5857, 148, 359, "Input",ExpressionUUID->"4cf28cd7-b46e-4a4b-92e8-190cf3d83ccd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[934746, 20308, 303, 5, 29, "Subsubsection",ExpressionUUID->"292da8bc-00d0-47ca-a9b9-9739d23d772a",
 InitializationCell->True],
Cell[935052, 20315, 4834, 109, 263, "Input",ExpressionUUID->"8a4a1cd1-fdf0-4bb9-b50e-37dc95bbce35",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[939935, 20430, 285, 5, 30, "Subsection",ExpressionUUID->"a4784a0f-be68-4058-853b-0f6696dcd3e1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[940245, 20439, 329, 6, 34, "Subsubsection",ExpressionUUID->"2e7e5a90-3fdd-4938-89f9-ac948c1e649c",
 InitializationCell->True],
Cell[940577, 20447, 21418, 435, 724, "Input",ExpressionUUID->"8bbf6d50-9573-4bdd-adad-f5f7adbf2438",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[962032, 20887, 290, 5, 34, "Subsubsection",ExpressionUUID->"05335743-9668-4fc1-bd41-390fe8c20104",
 InitializationCell->True],
Cell[962325, 20894, 21434, 446, 824, "Input",ExpressionUUID->"4b859813-3105-442d-ba89-edf58bed608c",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[983796, 21345, 257, 5, 34, "Subsubsection",ExpressionUUID->"28fc26de-c532-4076-a1d1-94b6eac39f23",
 InitializationCell->True],
Cell[984056, 21352, 7001, 165, 394, "Input",ExpressionUUID->"e3e42d24-67d3-4579-92ee-6fdf4d6b8363",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[991094, 21522, 371, 6, 34, "Subsubsection",ExpressionUUID->"246a5d3c-4c69-4b9d-ac5e-9775719716a7",
 InitializationCell->True],
Cell[991468, 21530, 20050, 463, 866, "Input",ExpressionUUID->"0f6d5b3b-984d-4210-9bf1-881d3a8e8b14",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1011567, 21999, 223, 4, 30, "Subsection",ExpressionUUID->"fc724c7e-3f74-4690-8a5a-72e097d9a14d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1011815, 22007, 312, 6, 34, "Subsubsection",ExpressionUUID->"c30033f0-42c3-4be9-8f7e-c6f1aa508e65",
 InitializationCell->True],
Cell[1012130, 22015, 34315, 711, 887, "Input",ExpressionUUID->"758a7b61-a04d-438d-896f-b18b8fe9fab2",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1046482, 22731, 336, 6, 34, "Subsubsection",ExpressionUUID->"31175af3-10fa-4719-83f1-01be0367f974",
 InitializationCell->True],
Cell[1046821, 22739, 41506, 854, 1262, "Input",ExpressionUUID->"5889cb9b-36d7-4c4b-aa00-e56729e5ed43",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1088364, 23598, 386, 7, 34, "Subsubsection",ExpressionUUID->"2fc59a54-aaba-4a79-bdb0-eaff929b77a9",
 InitializationCell->True],
Cell[1088753, 23607, 40397, 827, 1248, "Input",ExpressionUUID->"768788c6-e534-4d42-88ff-316ae86760ef",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1129187, 24439, 187, 4, 34, "Subsubsection",ExpressionUUID->"27b42655-7ac8-4ed8-be15-21956e771cd9",
 InitializationCell->True],
Cell[1129377, 24445, 4543, 111, 378, "Input",ExpressionUUID->"077d452a-ba87-4cbc-95e8-cb521593b457",
 InitializationCell->True],
Cell[1133923, 24558, 757, 16, 258, "Input",ExpressionUUID->"962e1c8a-cbae-4e1a-9b54-cd4c1755dc35",
 InitializationCell->True],
Cell[1134683, 24576, 3516, 83, 318, "Input",ExpressionUUID->"bec01b2e-e5f3-4f90-bf0a-20494b8b2798",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1138236, 24664, 243, 5, 29, "Subsubsection",ExpressionUUID->"ab84128c-165e-4591-92d9-95c6f7662ba1",
 InitializationCell->True],
Cell[1138482, 24671, 9215, 186, 798, "Input",ExpressionUUID->"ee10ccee-4ca6-4173-8d81-2d05d06e2180",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1147746, 24863, 215, 4, 30, "Subsection",ExpressionUUID->"65cc9748-d347-496e-847c-3f1121719151",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1147986, 24871, 364, 6, 34, "Subsubsection",ExpressionUUID->"b550f403-3ffd-4f30-8918-95c0da4d06d7",
 InitializationCell->True],
Cell[1148353, 24879, 27182, 547, 903, "Input",ExpressionUUID->"cd7fd083-b5e4-4b6f-9f8c-035ced64abca",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1175572, 25431, 391, 7, 34, "Subsubsection",ExpressionUUID->"d9972d85-6065-436e-88be-8b474994db19",
 InitializationCell->True],
Cell[1175966, 25440, 29381, 593, 973, "Input",ExpressionUUID->"e68fde39-3e33-401b-bc16-b1ab4caadbdb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1205384, 26038, 439, 7, 29, "Subsubsection",ExpressionUUID->"f59199bc-f109-498d-8dd2-16f5babf584c",
 InitializationCell->True],
Cell[1205826, 26047, 28757, 577, 973, "Input",ExpressionUUID->"aef44178-c1b6-4a7a-8601-474c4c21bf58",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1234632, 26630, 345, 6, 30, "Subsection",ExpressionUUID->"051c1b6d-b4d8-4c97-93ea-4435b2d2878b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1235002, 26640, 247, 5, 34, "Subsubsection",ExpressionUUID->"6bca2504-f342-497b-81ad-e10e1ab8316b",
 InitializationCell->True],
Cell[1235252, 26647, 22135, 483, 1428, "Input",ExpressionUUID->"cc90b571-6fa9-4388-85c4-7a68240099e3",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1257448, 27137, 194, 4, 50, "Section",ExpressionUUID->"0408e833-256e-42a9-82fe-4e3a499022d9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1257667, 27145, 237, 5, 41, "Subsection",ExpressionUUID->"800fb029-4fa4-4ad3-9ad3-b699c07713a7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1257929, 27154, 190, 4, 34, "Subsubsection",ExpressionUUID->"fbe147e8-4068-4d60-bb0c-ee071e804664",
 InitializationCell->True],
Cell[1258122, 27160, 5940, 114, 583, "Input",ExpressionUUID->"d081db04-ad29-4987-bc24-ff75dd7a62b2",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1264111, 27280, 188, 4, 41, "Subsection",ExpressionUUID->"d7b69d56-ac6e-44db-b925-bf2d9c57cde8",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1264324, 27288, 191, 4, 34, "Subsubsection",ExpressionUUID->"b8519047-4bc4-4037-9c38-67a746348301",
 InitializationCell->True],
Cell[1264518, 27294, 27407, 656, 2017, "Input",ExpressionUUID->"bfcfbbae-628e-47d0-bfcf-5d7d30638b12",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1291974, 27956, 279, 5, 30, "Subsection",ExpressionUUID->"31fe543b-c67a-434d-a485-008f27ece34e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1292278, 27965, 193, 4, 34, "Subsubsection",ExpressionUUID->"7759f317-534d-4ddc-9e5a-2f15375ad9d0",
 InitializationCell->True],
Cell[1292474, 27971, 7979, 189, 510, "Input",ExpressionUUID->"d2c36ac4-50ae-4081-9897-b8786bb95b54",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1300490, 28165, 196, 4, 29, "Subsubsection",ExpressionUUID->"84a468a6-2a9e-4214-b2db-24d40146f3a7",
 InitializationCell->True],
Cell[1300689, 28171, 8596, 200, 485, "Input",ExpressionUUID->"cc72ccaa-461b-4a54-99f5-305098defc11",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1309322, 28376, 191, 3, 29, "Subsubsection",ExpressionUUID->"54947013-b980-47d3-9e51-11b12e4e0d38",
 InitializationCell->True],
Cell[1309516, 28381, 6577, 147, 292, "Input",ExpressionUUID->"8f0ef270-1168-4cde-9843-e4a52ea1eaa3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1316130, 28533, 237, 5, 29, "Subsubsection",ExpressionUUID->"088276b3-c07d-4fc5-a6f1-9b3bfa54a030",
 InitializationCell->True],
Cell[1316370, 28540, 29082, 672, 1120, "Input",ExpressionUUID->"e9597900-eea4-4e5d-8031-2334a5a51a0f",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1345501, 29218, 197, 4, 41, "Subsection",ExpressionUUID->"c02aba2d-4b57-40a1-98f5-05c2485ef992",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1345723, 29226, 249, 5, 34, "Subsubsection",ExpressionUUID->"63249716-d17a-4363-bc78-2019e0e84f15",
 InitializationCell->True],
Cell[1345975, 29233, 2162, 44, 143, "Input",ExpressionUUID->"e4086c72-386f-407b-87a1-abec62764769",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1348186, 29283, 182, 4, 30, "Subsection",ExpressionUUID->"29b30d6e-3b61-481f-9d10-6fe3e7c9b9e1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1348393, 29291, 194, 4, 34, "Subsubsection",ExpressionUUID->"28558f91-c82f-4835-9dae-e988f209284b",
 InitializationCell->True],
Cell[1348590, 29297, 2351, 50, 213, "Input",ExpressionUUID->"874d12c6-89a6-4fd5-86d8-6f0251f0db5a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1350978, 29352, 247, 5, 34, "Subsubsection",ExpressionUUID->"4c77b806-86cc-4927-969f-9ed215b90554",
 InitializationCell->True],
Cell[1351228, 29359, 5190, 121, 487, "Input",ExpressionUUID->"9feca8c1-1581-4af0-80a6-db8aa716b4c9",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1356455, 29485, 188, 4, 34, "Subsubsection",ExpressionUUID->"ccdfd1ab-7df0-452e-a750-2b932f6b9a90",
 InitializationCell->True],
Cell[1356646, 29491, 9783, 243, 624, "Input",ExpressionUUID->"9ecde21a-ecc3-4c84-8291-abe801554927",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1366490, 29741, 200, 4, 50, "Section",ExpressionUUID->"bfd0cb85-028e-43ef-81bf-fed3228f16b0",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1366715, 29749, 332, 6, 41, "Subsection",ExpressionUUID->"328cea57-80d8-42f2-b4fe-663fdbcec5d0",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1367072, 29759, 196, 4, 34, "Subsubsection",ExpressionUUID->"c3b28930-973f-4c81-b320-0523bdf392fc",
 InitializationCell->True],
Cell[1367271, 29765, 1163, 28, 134, "Input",ExpressionUUID->"4da89b0d-e357-48de-89be-a3d639b8ba3f",
 InitializationCell->True],
Cell[1368437, 29795, 1751, 45, 148, "Input",ExpressionUUID->"c78d4adb-fb92-41aa-9d82-a6bcbd51a006",
 InitializationCell->True],
Cell[1370191, 29842, 1083, 26, 119, "Input",ExpressionUUID->"02d3a0df-9aae-4774-9db2-a5de535e9af1",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1371311, 29873, 190, 4, 34, "Subsubsection",ExpressionUUID->"d3fe0d64-f685-4ebc-9026-e787ac462100",
 InitializationCell->True],
Cell[1371504, 29879, 6871, 184, 193, "Input",ExpressionUUID->"96fb7d52-d5b9-4cd1-8950-dfebc46277be",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1378424, 30069, 187, 4, 30, "Subsection",ExpressionUUID->"d410bfa3-8eed-4e53-841b-bcdaf280c96d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1378636, 30077, 286, 5, 34, "Subsubsection",ExpressionUUID->"78c1a415-e005-4db1-ac26-73b3d2607aba",
 InitializationCell->True],
Cell[1378925, 30084, 2532, 56, 227, "Input",ExpressionUUID->"f18b522e-b4bc-4796-87ec-c5c5e4ac6bda",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1381494, 30145, 237, 5, 34, "Subsubsection",ExpressionUUID->"34cef96f-305c-4b52-aaf1-1d95353e3e90",
 InitializationCell->True],
Cell[1381734, 30152, 4223, 99, 208, "Input",ExpressionUUID->"cdb6128e-ac87-4c1c-b56e-1117a8ac78a7",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1385994, 30256, 187, 4, 34, "Subsubsection",ExpressionUUID->"9a174bbc-0917-4b33-93e0-40994d7443ea",
 InitializationCell->True],
Cell[1386184, 30262, 9969, 215, 614, "Input",ExpressionUUID->"9e989ea4-2f97-4a92-b299-62a0b083626a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1396190, 30482, 188, 4, 34, "Subsubsection",ExpressionUUID->"0d56eccf-26db-4901-af77-8b07c6e08cad",
 InitializationCell->True],
Cell[1396381, 30488, 6439, 147, 373, "Input",ExpressionUUID->"8e3a999c-9835-4557-a09e-a27792835a38",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1402857, 30640, 190, 4, 34, "Subsubsection",ExpressionUUID->"69f20a0d-6b8e-4672-a143-c2f97d92e150",
 InitializationCell->True],
Cell[1403050, 30646, 3656, 85, 253, "Input",ExpressionUUID->"a4a94fa7-2672-4698-b80a-65150348fa66",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1406743, 30736, 188, 4, 34, "Subsubsection",ExpressionUUID->"3080689a-9ef5-4d00-861a-44eba06f7962",
 InitializationCell->True],
Cell[1406934, 30742, 9220, 194, 479, "Input",ExpressionUUID->"3a6d6752-f868-428a-8158-2be8a5123ff1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1416191, 30941, 249, 5, 29, "Subsubsection",ExpressionUUID->"103506ef-4fa0-4f67-83d5-57152de36ef3",
 InitializationCell->True],
Cell[1416443, 30948, 4868, 104, 514, "Input",ExpressionUUID->"9b4e87bf-2f3e-4320-8c01-d8fc117ccd1b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1421348, 31057, 246, 5, 29, "Subsubsection",ExpressionUUID->"1f34d7a2-09a6-4ffb-8a9d-e6c5067b86c3",
 InitializationCell->True],
Cell[1421597, 31064, 5608, 132, 618, "Input",ExpressionUUID->"926264c8-9965-4295-bb45-5c35cbfc60b1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1427254, 31202, 195, 4, 30, "Subsection",ExpressionUUID->"beb3bddd-bc32-442a-b2cd-b32a1d347c3d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1427474, 31210, 239, 5, 34, "Subsubsection",ExpressionUUID->"a66e3d31-7493-4ba9-b087-b8774858b064",
 InitializationCell->True],
Cell[1427716, 31217, 12034, 278, 1128, "Input",ExpressionUUID->"90f96ce7-f49e-4480-ac03-9218c1123d2f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1439787, 31500, 246, 5, 29, "Subsubsection",ExpressionUUID->"0b142c0c-b1bb-4cfb-ae3d-e974579404db",
 InitializationCell->True],
Cell[1440036, 31507, 10572, 227, 1188, "Input",ExpressionUUID->"a0210011-be44-4093-84fd-b249ef3c133a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1450645, 31739, 294, 5, 29, "Subsubsection",ExpressionUUID->"041b2851-1313-4d7b-8e37-377836ddba86",
 InitializationCell->True],
Cell[1450942, 31746, 4493, 104, 648, "Input",ExpressionUUID->"1128a765-c309-423b-831b-0c818a8ce42c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1455472, 31855, 292, 5, 29, "Subsubsection",ExpressionUUID->"58e050c2-5976-4133-82f6-3bfd804b0254",
 InitializationCell->True],
Cell[1455767, 31862, 12100, 278, 1128, "Input",ExpressionUUID->"7eaaf157-a6dc-4b66-9491-6906e3850914",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1467904, 32145, 297, 5, 29, "Subsubsection",ExpressionUUID->"17a5fdeb-cc1b-413e-8d0f-f2f7608ac7ed",
 InitializationCell->True],
Cell[1468204, 32152, 7006, 157, 877, "Input",ExpressionUUID->"491b8ed0-662b-48f7-8928-7f2334adbaf6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1475247, 32314, 342, 6, 29, "Subsubsection",ExpressionUUID->"e3286813-9a43-418f-91eb-8b29936b538b",
 InitializationCell->True],
Cell[1475592, 32322, 4506, 98, 468, "Input",ExpressionUUID->"b023b1db-346e-431f-80a3-9b169fd7cbc0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1480135, 32425, 191, 4, 29, "Subsubsection",ExpressionUUID->"c405c81b-8ed9-4520-8561-781baa2bfaf8",
 InitializationCell->True],
Cell[1480329, 32431, 3079, 80, 318, "Input",ExpressionUUID->"c0b637c2-42fb-4f93-bc8b-5abf38d20226",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1483445, 32516, 240, 5, 29, "Subsubsection",ExpressionUUID->"af78f337-1e26-49d0-b261-6107c88fab57",
 InitializationCell->True],
Cell[1483688, 32523, 3080, 80, 182, "Input",ExpressionUUID->"e52bcc53-d5ef-4e62-9f12-c02f609a8317",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1486805, 32608, 288, 5, 29, "Subsubsection",ExpressionUUID->"40d8442d-2bb1-4a92-886f-c443d18cbae7",
 InitializationCell->True],
Cell[1487096, 32615, 27961, 582, 2838, "Input",ExpressionUUID->"81d1ea4d-e2e7-427e-abdc-de8563ef315c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1515094, 33202, 341, 6, 29, "Subsubsection",ExpressionUUID->"2683e11d-2250-4bfd-b3b8-d9047e57544f",
 InitializationCell->True],
Cell[1515438, 33210, 19330, 409, 2298, "Input",ExpressionUUID->"fa3ed344-7914-403e-a0f4-b111cdecfb80",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1534805, 33624, 341, 6, 29, "Subsubsection",ExpressionUUID->"9b41b686-80f4-48cb-a0c4-5c3c5802e674",
 InitializationCell->True],
Cell[1535149, 33632, 29767, 624, 2898, "Input",ExpressionUUID->"05958b55-60ac-495b-a44b-37bc81e4b5ec",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1564953, 34261, 390, 7, 29, "Subsubsection",ExpressionUUID->"9deb0de7-b915-4123-b1b1-6e7e9d615ccd",
 InitializationCell->True],
Cell[1565346, 34270, 26399, 533, 2838, "Input",ExpressionUUID->"6998b850-53ec-47ec-a776-d02fb2038c26",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1591782, 34808, 190, 4, 29, "Subsubsection",ExpressionUUID->"37d62b33-efb0-40a9-bfea-cc010e52ddc4",
 InitializationCell->True],
Cell[1591975, 34814, 14314, 319, 1878, "Input",ExpressionUUID->"0f0e6656-0fab-4756-a68e-3ddef92cc3c0",
 InitializationCell->True],
Cell[1606292, 35135, 701, 15, 46, "Input",ExpressionUUID->"535d1108-2b75-47e9-afaa-0f87666da9c5",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1607054, 35157, 238, 5, 50, "Section",ExpressionUUID->"d1debf44-af26-4c2f-b43c-0e796878b43c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1607317, 35166, 192, 4, 34, "Subsubsection",ExpressionUUID->"82c1b17d-f7c0-40bd-a1f1-046faeebcd18",
 InitializationCell->True],
Cell[1607512, 35172, 1103, 34, 77, "Input",ExpressionUUID->"cb663351-0e67-45d4-9b9d-3570a3b31b76",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1608664, 35212, 183, 4, 50, "Section",ExpressionUUID->"675c19ba-1410-4074-9610-e0749adadd7c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1608872, 35220, 248, 8, 41, "Subsection",ExpressionUUID->"7e664826-34c5-4e22-bf48-8d4dd4f192b9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1609145, 35232, 299, 9, 34, "Subsubsection",ExpressionUUID->"8917b9c4-8645-4716-975a-ff10b41a587a",
 InitializationCell->True],
Cell[1609447, 35243, 26219, 519, 2095, "Input",ExpressionUUID->"a90c256d-4b88-430e-a446-8fd161d2425e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1635703, 35767, 191, 4, 29, "Subsubsection",ExpressionUUID->"dff223e6-35fe-400b-8fd8-5f9a78dda63d",
 InitializationCell->True],
Cell[1635897, 35773, 2954, 78, 228, "Input",ExpressionUUID->"6b09567e-a6dd-4b6e-aa43-fa7050dae4b0",
 InitializationCell->True],
Cell[1638854, 35853, 3001, 78, 228, "Input",ExpressionUUID->"29eccc78-1895-46ff-ae32-8bc7bcc86c73",
 InitializationCell->True],
Cell[1641858, 35933, 2229, 60, 168, "Input",ExpressionUUID->"fcc0ed97-510e-44a2-984c-57c0e7c87e12",
 InitializationCell->True],
Cell[1644090, 35995, 2115, 58, 168, "Input",ExpressionUUID->"37903e96-ff2a-44fa-b270-430150000da5",
 InitializationCell->True],
Cell[1646208, 36055, 1907, 53, 168, "Input",ExpressionUUID->"239d99bb-568f-46ac-b254-0d3bf7fe99f1",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1648164, 36114, 188, 4, 41, "Subsection",ExpressionUUID->"4a2037be-a2f0-4949-86d5-04daa007e1fe",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1648377, 36122, 195, 4, 34, "Subsubsection",ExpressionUUID->"dd646bcf-e183-4361-a9b4-ad9685610a7f",
 InitializationCell->True],
Cell[1648575, 36128, 18702, 366, 879, "Input",ExpressionUUID->"2569a270-7e4d-425e-82e0-6f3277fb91d6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1667314, 36499, 184, 4, 29, "Subsubsection",ExpressionUUID->"f12f959b-28a7-4188-9cfe-7abe7d92f930",
 InitializationCell->True],
Cell[1667501, 36505, 17169, 406, 1330, "Input",ExpressionUUID->"d1adcdb1-2abe-4c98-9621-5e9e1746b027",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1684707, 36916, 265, 4, 29, "Subsubsection",ExpressionUUID->"a26d8c2e-499b-4b7d-8704-1bee267568fd",
 InitializationCell->True],
Cell[1684975, 36922, 10896, 204, 439, "Input",ExpressionUUID->"fe4dd2d3-f33f-4ff3-964d-036e017ebbf9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1695908, 37131, 317, 5, 29, "Subsubsection",ExpressionUUID->"f8829dca-6386-43b3-8c93-5362a3d4d196",
 InitializationCell->True],
Cell[1696228, 37138, 27993, 635, 2389, "Input",ExpressionUUID->"38092dd8-d130-4e70-a740-ac6374fa6d6c",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

