(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1347891,      29668]
NotebookOptionsPosition[   1327296,      28975]
NotebookOutlinePosition[   1327708,      28993]
CellTagsIndexPosition[   1327665,      28990]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\

SUMCON
User Interface Package\
\>", "Subtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.5714901739760427`*^9, 3.5714901855827065`*^9}, {
  3.5714910854841785`*^9, 3.5714910877443075`*^9}}],

Cell[CellGroupData[{

Cell["Start Menu", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5714902042837763`*^9, 3.571490206002875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$VersionSUMCON", "=", "\"\<1.2\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570165804528378*^9, 3.5701658306448717`*^9}, {
  3.5856286838974113`*^9, 3.5856286840574207`*^9}, {3.58781367579626*^9, 
  3.5878136784074097`*^9}, {3.590664268677844*^9, 3.5906642688048515`*^9}}],

Cell[CellGroupData[{

Cell["Start Menu", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570195631828402*^9, 3.570195636265656*^9}}],

Cell[CellGroupData[{

Cell["Start Menu", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5672676051910734`*^9, 3.567267617056752*^9}, {
  3.5672679600253687`*^9, 3.5672679608244143`*^9}, {3.5701102435079865`*^9, 
  3.570110244602049*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$StartSUMCON", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Define"}]}], " ", 
          RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"titleSUMCON", "=", 
          RowBox[{"Import", "[", "\"\<SUMCON.PNG\>\"", "]"}]}], ";", 
         RowBox[{"(*", 
          RowBox[{"Import", " ", "Title"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"tabviewctrl", "=", "1"}], ";", 
         RowBox[{"(*", 
          RowBox[{"Tabview", " ", "Control", " ", "Number"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"ValueQ", "[", "calcdone", "]"}], "]"}], ",", 
           RowBox[{"calcdone", "=", "False"}]}], "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"Calculated", " ", "or", " ", "not"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Top"}]}], " ", 
            RowBox[{"Frame", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Image", "[", 
              RowBox[{"titleSUMCON", ",", 
               RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Title", " ", "Image"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                   RowBox[{
                   "\"\<SUMCON Version:\>\"", "<>", "$VersionSUMCON"}], ",", 
                   "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
                 RowBox[{"(*", "Version", "*)"}], "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<About SUMCON\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$AboutSUMCON", ",", 
                    RowBox[{"(*", 
                    RowBox[{"About", " ", "SUMCON"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Version Info\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$VersionInfo", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Version", " ", "Info"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Cyan"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Reflesh\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "mod$StartSUMCON", "]"}], 
                    ",", 
                    RowBox[{"(*", 
                    RowBox[{"Quit", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Red"}]}], "]"}]}], 
                    "}"}], "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Load"}]}], " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<New Model\>\"", ",", "Bold", ",", "Black"}], 
               "]"}], ",", "mod$NewModel", ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Load Model\>\"", ",", "Bold", ",", "White"}], 
               "]"}], ",", "mod$LoadModel", ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Save Model\>\"", ",", "Bold", ",", "Black"}], 
               "]"}], ",", "mod$SaveModel", ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", "Yellow"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ValueQ", "[", "save$FileName", "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Style", "[", 
                RowBox[{
                 RowBox[{"save$FileName", "<>", "\"\<.m\>\""}], ",", 
                 "Black"}], "]"}], ",", 
               RowBox[{"save$FileName", ";", "\"\<\>\""}]}], "]"}], "]"}]}], 
           "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"TabView", "[", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", " ", 
               RowBox[{"**", "**", "**", "**", "**", " ", "Model"}]}]}], " ", 
             RowBox[{"Construction", " ", "**", "**", "**", "**", "**", " ", 
              RowBox[{"--", "-"}]}]}], "*)"}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Model Construction\>\"", ",", "Bold"}], "]"}], 
             "\[Rule]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"--", 
                   RowBox[{"-", "1."}]}], " ", "Registrate", " ", "Rigid", 
                  " ", 
                  RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Item", "[", 
                 RowBox[{
                  RowBox[{"Pane", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Step 1. Registrate Rigid Bodies\>\"", ",", 
                    "\[IndentingNewLine]", "Bold", ",", "Italic", ",", 
                    "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Background", "\[Rule]", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.3"}], "]"}]}]}], "]"}], 
                ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<1-1 \\nSet Body Names\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetBodyNames", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Set", " ", "Mass"}], " ", "&"}], " ", "MoI"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<1-2 \\nSet Mass & MoI\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetMassMoI", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Shapes"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<1-3 \\nSet Body Shapes\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetBodyShapes", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Initial", " ", "Position"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<1-4 \\nSet Initial Position\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetInitPos", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.6", ",", "0.7"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "}"}],
                     "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]",
                     "mod$ShowBodyList"}], "\[IndentingNewLine]", "}"}], 
                   "}"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], 
                ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"--", 
                    RowBox[{"-", "2."}]}], " ", "Set", " ", 
                   RowBox[{"Connection", "--"}]}], "-"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"Item", "[", 
                 RowBox[{
                  RowBox[{"Pane", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Step 2. Set Connection\>\"", ",", 
                    "\[IndentingNewLine]", "Bold", ",", "Italic", ",", 
                    "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Background", "\[Rule]", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0.3", ",", "0"}], "]"}]}]}], "]"}], 
                ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Material"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Set Material Properties\>\"", ",", "Bold", ",", 
                    "White", ",", "Small"}], "]"}], ",", "mod$SetMaterial", 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Wires"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<2-1 \\nSet Wires\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$SetWires", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "1", ",", "0.6"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<2-2 \\nSet Vertical Springs\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetVertSprings", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Mass", " ", "%", " ", "MoI"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.9", ",", "0.6"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<2-3 \\nSet Inverted Pendulum\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetIP", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Shapes"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<2-4 \\nSet Heat Links\>\"", ",", "Bold", ",", 
                    "Black"}], "]"}], ",", "mod$SetHeatLinks", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Shapes"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<2-5 \\nSet Damper\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$SetDamper", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Shapes"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "}"}],
                     "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]",
                     "mod$ShowConnectionList"}], "\[IndentingNewLine]", "}"}],
                    "}"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], 
                ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"--", 
                    RowBox[{"-", "3."}]}], " ", "Start", " ", 
                   RowBox[{"Calculation", " ", "--"}]}], "-"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"Item", "[", 
                 RowBox[{
                  RowBox[{"Pane", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Step 3. Start Calculation\>\"", ",", 
                    "\[IndentingNewLine]", "Bold", ",", "Italic", ",", 
                    "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"580", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Background", "\[Rule]", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.3", ",", "0", ",", "0"}], "]"}]}]}], "]"}], 
                ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Construct Model\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"mod$StartCalc", ";", 
                    RowBox[{"calcdone", "=", "True"}], ";", 
                    RowBox[{"tabviewctrl", "=", "2"}], ";"}], ")"}], ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}],
                "\[IndentingNewLine]", "}"}], "]"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", " ", 
                RowBox[{
                "**", "**", "**", "**", "**", " ", "Calculation"}]}]}], " ", 
              RowBox[{"Result", " ", "**", "**", "**", "**", "**", " ", 
               RowBox[{"--", "-"}]}]}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Calculation Result\>\"", ",", "Bold"}], "]"}], 
             "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"Not", "[", "calcdone", "]"}], ",", 
                RowBox[{"calcdone", ";", "\"\<\>\""}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"calcdone", ";", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Basic"}]}], " ", 
                    RowBox[{"Info", "--"}]}], "-"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Item", "[", 
                    RowBox[{
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Model Basic Information\>\"", ",", 
                    "\[IndentingNewLine]", "Bold", ",", "Italic", ",", 
                    "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.5", ",", "0", ",", "0"}], "]"}]}]}], "]"}], 
                    ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Degrees of Freedom:\>\"", ",", "Bold"}], 
                    "]"}], "}"}], "}"}], "]"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "allvars", "]"}], ",", 
                    "\"\<State Variables\>\""}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "allparams", "]"}], ",", 
                    "\"\<Input Variables\>\""}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "allfloats", "]"}], ",", 
                    "\"\<Float Variables\>\""}], "}"}]}], "}"}], "]"}], "}"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"{", "\"\<\>\"", "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Ground Position:\>\"", ",", "Bold"}], "]"}], 
                    "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"Pane", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"makesub", "[", 
                    RowBox[{"allparams", ",", "\[IndentingNewLine]", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"allparams", "/.", "subdefparams"}], ",", 
                    "0.0001"}], "]"}]}], "]"}], ",", "6", ",", "6", ",", "1", 
                    ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], "]"}], 
                    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", "\"\<\>\"", "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Equilibrium Point:\>\"", ",", "Bold"}], 
                    "]"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"Pane", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"makesub", "[", 
                    RowBox[{
                    RowBox[{"Join", "[", 
                    RowBox[{"allvars", ",", "allfloats"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Join", "[", 
                    RowBox[{"allvars", ",", "allfloats"}], "]"}], "/.", 
                    "subminvars"}], ",", "0.0001"}], "]"}]}], "]"}], ",", "6",
                     ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], "]"}], 
                    "\[IndentingNewLine]", "}"}]}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"steadyplot", "[", 
                    RowBox[{"subminvars", ",", 
                    RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                    RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"200", ",", "400"}], "}"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}], 
                    ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Freq"}]}], " ", "Plot", " ", 
                    RowBox[{"Tool", "--"}]}], "-"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"symbol", " ", "setting"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tfk", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfk", "=", "1"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"calc$tfFi", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}],
                     ";", 
                    RowBox[{"calc$tfFo", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}],
                     ";", "\[IndentingNewLine]", 
                    RowBox[{"calc$tfGi", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], 
                    "]"}]}], ";", 
                    RowBox[{"calc$tfGo", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}],
                     ";", "\[IndentingNewLine]", 
                    RowBox[{"calc$sni", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], 
                    "]"}]}], ";", 
                    RowBox[{"calc$sno", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}],
                     ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tnT", "]"}], "]"}], ",", 
                    RowBox[{"calc$tnT", "=", "300"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"calc$tnb", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}],
                     ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "fmin", "]"}], "]"}], ",", 
                    RowBox[{"fmin", "=", "0.01"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "fmax", "]"}], "]"}], ",", 
                    RowBox[{"fmax", "=", "100."}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "ngrid", "]"}], "]"}], ",", 
                    RowBox[{"ngrid", "=", "1001"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "fgridtype", "]"}], "]"}], ",", 
                    RowBox[{"fgridtype", "=", "True"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tfplot", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfplot", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$psdplot", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdplot", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tfname", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfname", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$psdname", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdname", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tfsel", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfsel", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$psdsel", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdsel", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tfshow", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfshow", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$psdshow", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdshow", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$tfline", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfline", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$psdline", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdline", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]",
                     "\[IndentingNewLine]", 
                    RowBox[{"(*", "title", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Item", "[", 
                    RowBox[{
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Frequency Domain Plot Tool\>\"", ",", 
                    "\[IndentingNewLine]", "Bold", ",", "Italic", ",", 
                    "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0.5", ",", "0"}], "]"}]}]}], "]"}]}], 
                    ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"choose", " ", "mode"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$tfk", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    "1", "\[Rule]", 
                    "\"\<Frequency Responce to External Force/Torque\>\""}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "2", "\[Rule]", 
                    "\"\<Frequency Responce to Ground Motion\>\""}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", "\"\<Seismic Noise Plot\>\""}], 
                    ",", 
                    RowBox[{"4", "\[Rule]", "\"\<Thermal Noise Plot\>\""}]}], 
                    "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Set Seismic Spectrum\>\"", ",", "Bold", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "]"}], ",", 
                    "mod$SetSeism", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfk", "\[Equal]", "3"}], ",", 
                    RowBox[{"GrayLevel", "[", "0.1", "]"}], ",", 
                    RowBox[{"GrayLevel", "[", "0.7", "]"}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"calc$tfk", "\[Equal]", "3"}]}]}], "]"}], "]"}]}],
                     "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "850"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"calc$combif", "=", "False"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$combin", "]"}], "]"}], ",", 
                    RowBox[{"calc$combin", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "+", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}]}]}], "]"}], ";",
                     "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Select", " ", "Input", " ", "or", " ", "temp"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Input:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfFi", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                     ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"Dynamic", "[", "calc$combif", "]"}], "]"}], ",", 
                    RowBox[{"Style", "[", "\"\<Combined Input:\>\"", "]"}]}], 
                    "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$combin", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "3."}], "}"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "]"}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
                    "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Input:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfGi", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "6", ",", "6", ",", 
                    "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Input:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$sni", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "6", ",", "6", ",", 
                    "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Add Seismic Spectrum Plot\>\"", ",", "Bold", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                    "mod$AddSeismPlot", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "1.", "]"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableAlignments", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"4", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Temperature:\>\"", ",", "Bold"}], "]"}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$tnT", "]"}], ",", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<K\>\""}], "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}]}]}], 
                    "}"}], ",", "calc$tfk", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                    ",", 
                    RowBox[{"ImageSize", "\[Rule]", "850"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Select", " ", "output"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfFo", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                     ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfGo", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                     ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$sno", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                     ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"4", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Output:\>\"", ",", "Bold"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tnb", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}],
                     ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], 
                    "]"}]}]}], "\[IndentingNewLine]", "}"}], ",", "calc$tfk", 
                    ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                    ",", 
                    RowBox[{"ImageSize", "\[Rule]", "850"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Frequency", " ", "setup"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Panel", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Frequency:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "fmin", "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<-\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "fmax", "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<Hz\>\""}], "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Step:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "ngrid", "]"}], ",", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"Dynamic", "[", "fgridtype", "]"}], "]"}], ",", 
                    "\"\<Logarithmic\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", "fgridtype", "]"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"fgridtype", "=", 
                    RowBox[{"Not", "[", "#", "]"}]}], ")"}], "&"}]}], "]"}], 
                    "]"}], ",", "\"\<Linear\>\""}], "\[IndentingNewLine]", 
                    "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "542"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "5"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "Set", " ", "symbol", " ", "and", " ", "options"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$xrange", "]"}], "]"}], ",", 
                    RowBox[{"calc$xrange", "=", "Automatic"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$yrange", "]"}], "]"}], ",", 
                    RowBox[{"calc$yrange", "=", "Automatic"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"amplabel", "=", "\"\<Amplitude\>\""}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$lgndpos", "]"}], "]"}], ",", 
                    RowBox[{"calc$lgndpos", "=", 
                    RowBox[{"{", 
                    RowBox[{"0.35", ",", "0.3"}], "}"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$legend", "]"}], "]"}], ",", 
                    RowBox[{"calc$legend", "=", "True"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Plot", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"More", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Open New Window\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"CreateDocument", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"ExpressionCell", "[", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takemag", "[", 
                    RowBox[{"calc$tfplot", ",", "calc$tfshow"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$legend", "&&", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "calc$tfname", "]"}], "\[Equal]", 
                    "0"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotLegend", "\[Rule]", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}], ",", "Null"}], "]"}]}], ",", 
                    RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"LegendTextSpace", "\[Rule]", "2.5"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    RowBox[{"LegendPosition", "\[Rule]", "calc$lgndpos"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"LegendSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"0.2", "+", 
                    RowBox[{"0.023", "*", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}], "]"}]}]}], ",", 
                    RowBox[{"0.08", "*", 
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}]}]}], "}"}]}]}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    "baseoptmag", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"calc$xrange", ",", "calc$yrange"}], "}"}]}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "calc$tfline", "]"}], "\[Equal]", 
                    "0"}], ",", "Thick", ",", "calc$tfline"}], "]"}]}]}], 
                    "}"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"ListLogLinearPlot", "[", 
                    RowBox[{
                    RowBox[{"takephs", "[", 
                    RowBox[{"calc$tfplot", ",", "calc$tfshow"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", 
                    RowBox[{"baseoptphs", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"calc$xrange", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "calc$tfline", "]"}], "\[Equal]", 
                    "0"}], ",", "Thick", ",", "calc$tfline"}], "]"}]}]}], 
                    "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
                    "]"}], "\[IndentingNewLine]", "]"}], "}"}], 
                    "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takemag", "[", 
                    RowBox[{"calc$tfplot", ",", "calc$tfshow"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$legend", "&&", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "calc$tfname", "]"}], "\[Equal]", 
                    "0"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotLegend", "\[Rule]", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}], ",", "Null"}], "]"}]}], ",", 
                    RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"LegendTextSpace", "\[Rule]", "2.5"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    RowBox[{"LegendPosition", "\[Rule]", "calc$lgndpos"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"LegendSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"0.2", "+", 
                    RowBox[{"0.023", "*", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}], "]"}]}]}], ",", 
                    RowBox[{"0.08", "*", 
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfname", "]"}]}], "}"}]}], 
                    "]"}]}]}], "}"}]}]}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    "baseoptmag", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"calc$xrange", ",", "calc$yrange"}], "}"}]}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "calc$tfline", "]"}], "\[Equal]", 
                    "0"}], ",", "Thick", ",", "calc$tfline"}], "]"}]}]}], 
                    "}"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"ListLogLinearPlot", "[", 
                    RowBox[{
                    RowBox[{"takephs", "[", 
                    RowBox[{"calc$tfplot", ",", "calc$tfshow"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", 
                    RowBox[{"baseoptphs", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"calc$xrange", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "calc$tfline", "]"}], "\[Equal]", 
                    "0"}], ",", "Thick", ",", "calc$tfline"}], "]"}]}]}], 
                    "}"}]}], "]"}]}], "]"}]}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"False", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"More", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Open New Window\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"CreateDocument", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"ExpressionCell", "[", "\[IndentingNewLine]", 
                    RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takepsd", "[", 
                    RowBox[{"calc$psdplot", ",", "calc$psdshow"}], "]"}], ",", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$legend", "&&", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "calc$psdname", "]"}], "\[Equal]", 
                    "0"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotLegend", "\[Rule]", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}], ",", "Null"}], "]"}]}], ",", 
                    RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"LegendTextSpace", "\[Rule]", "2.5"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    RowBox[{"LegendPosition", "\[Rule]", "calc$lgndpos"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"LegendSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"0.2", "+", 
                    RowBox[{"0.023", "*", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}], "]"}]}]}], ",", 
                    RowBox[{"0.08", "*", 
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}]}]}], "}"}]}]}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    "baseoptpsd", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"calc$xrange", ",", "calc$yrange"}], "}"}]}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "calc$psdline", "]"}], "\[Equal]", 
                    "0"}], ",", "Thick", ",", "calc$psdline"}], "]"}]}]}], 
                    "}"}]}], "]"}]}], "]"}], "\[IndentingNewLine]", "]"}], 
                    "}"}], "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takepsd", "[", 
                    RowBox[{"calc$psdplot", ",", "calc$psdshow"}], "]"}], ",", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$legend", "&&", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "calc$psdname", "]"}], "\[Equal]", 
                    "0"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotLegend", "\[Rule]", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}], ",", "Null"}], "]"}]}], ",", 
                    RowBox[{"LegendShadow", "\[Rule]", "None"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"LegendTextSpace", "\[Rule]", "2.5"}], ",", 
                    RowBox[{"LegendSpacing", "\[Rule]", "0"}], ",", 
                    RowBox[{"LegendPosition", "\[Rule]", "calc$lgndpos"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"LegendSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"0.2", "+", 
                    RowBox[{"0.023", "*", 
                    RowBox[{"Max", "[", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"StringLength", "[", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}], "]"}]}]}], ",", 
                    RowBox[{"0.08", "*", 
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdname", "]"}]}], "}"}]}], 
                    "]"}]}]}], "}"}]}]}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    "baseoptpsd", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"calc$xrange", ",", "calc$yrange"}], "}"}]}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "calc$psdline", "]"}], "\[Equal]", 
                    "0"}], ",", "Thick", ",", "calc$psdline"}], "]"}]}]}], 
                    "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
                    "]"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{
                    RowBox[{"calc$tfk", "\[Equal]", "1"}], "||", 
                    RowBox[{"calc$tfk", "\[Equal]", "2"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                    ",", 
                    RowBox[{"ImageSize", "\[Rule]", "510"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "temp", " ", "symbol"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "temp$xrange", "]"}], "]"}], ",", 
                    RowBox[{"temp$xrange", "=", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "100."}], "}"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "temp$yrange", "]"}], "]"}], ",", 
                    RowBox[{"temp$yrange", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1.", "*", 
                    RowBox[{"10", "^", 
                    RowBox[{"(", 
                    RowBox[{"-", "10"}], ")"}]}]}], ",", 
                    RowBox[{"1.", "*", 
                    RowBox[{"10", "^", 
                    RowBox[{"(", "2", ")"}]}]}]}], "}"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Add", " ", "and", " ", "clear", " ", "button"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Add Plot\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$CalcFreqPlot", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Clear Plot\>\"", ",", "Bold", ",", "White"}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"calc$tfk", "\[Equal]", "1"}], "||", 
                    RowBox[{"calc$tfk", "\[Equal]", "2"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"calc$tfplot", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$tfname", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$tfsel", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$tfshow", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$tfline", "=", 
                    RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"calc$psdplot", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$psdname", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$psdsel", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$psdshow", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"calc$psdline", "=", 
                    RowBox[{"{", "}"}]}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Red"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}], "}"}], "]"}], 
                    ",", 
                    RowBox[{"ImageSize", "\[Rule]", "332"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Apearance", " ", "setting"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"Dynamic", "[", "calc$legend", "]"}], "]"}], ",", 
                    "\"\<Show Legend\>\""}], "\[IndentingNewLine]", "}"}], 
                    "}"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Set x-range\>\"", ",", "Bold", ",", "White", ",", 
                    "Small"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "temp$xrange", "]"}], "\[Equal]", 
                    "2"}], "&&", 
                    RowBox[{
                    RowBox[{"temp$xrange", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "<", 
                    RowBox[{"temp$xrange", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"calc$xrange", "=", "temp$xrange"}]}], "]"}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0.2", ",", "0"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$xrange", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"18.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Auto\>\"", ",", "Bold", ",", "Black", ",", "Small"}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"calc$xrange", "=", "Automatic"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Set y-range\>\"", ",", "Bold", ",", "White", ",", 
                    "Small"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "[", "temp$yrange", "]"}], "\[Equal]", 
                    "2"}], "&&", 
                    RowBox[{
                    RowBox[{"temp$yrange", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "<", 
                    RowBox[{"temp$yrange", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"calc$yrange", "=", "temp$yrange"}]}], "]"}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.2"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$yrange", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"18.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Auto\>\"", ",", "Bold", ",", "Black", ",", "Small"}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"calc$yrange", "=", "Automatic"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
                    "}"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", "}"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "332"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"graph", " ", "name", " ", "list"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"18.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "White", ",", 
                    "Gray"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Line Style\>\"", ",", "Bold", ",", "Black", ",", 
                    "Small"}], "]"}], ",", 
                    RowBox[{"mod$FPLineStyle", "[", "n", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", "None"}]}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"False", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    "String", ",", "\[IndentingNewLine]", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"18.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "White", ",", 
                    "Gray"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Line Style\>\"", ",", "Bold", ",", "Black", ",", 
                    "Small"}], "]"}], ",", 
                    RowBox[{"mod$FPLineStyle", "[", "n", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}]}], "]"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", "None"}]}], "]"}]}]}],
                     "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{
                    RowBox[{"calc$tfk", "\[Equal]", "1"}], "||", 
                    RowBox[{"calc$tfk", "\[Equal]", "2"}]}]}], "]"}], 
                    "\[IndentingNewLine]", ",", 
                    RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"310", ",", "230"}], "}"}]}], ",", 
                    RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Sum\>\"", ",", "Bold", ",", "Black"}], "]"}],
                     ",", "mod$FPSum", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.7", ",", "1", ",", "0.7"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<x Factor\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$FPFactor", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0.7", ",", "0.7"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Inverse\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$FPInverse", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.7", ",", "0.7", ",", "1"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Multiply\>\"", ",", "Bold", ",", "Black"}], 
                    "]"}], ",", "mod$FPMultiply", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0.5", ",", "1"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<RMS\>\"", ",", "Bold", ",", "Black"}], "]"}],
                     ",", "mod$FPRMS", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "1", ",", "0.7"}], "]"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Hide\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPHide", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.2", "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Show\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPShow", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0.5", ",", "0"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPDelete", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Red"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPSave", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Blue"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPLoad", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Export\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPExport", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.2", ",", "0", ",", "0.5"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Import\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "mod$FPImport", ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", 
                    "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.5", ",", "0", ",", "0.2"}], "]"}]}]}], "]"}]}],
                     "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "332"}]}], "]"}], "]"}]}],
                     "\[IndentingNewLine]", "}"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], 
                    "]"}]}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
                    "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Eigen"}]}], " ", 
                    RowBox[{"Plot", "--"}]}], "-"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$eigenTA", "]"}], "]"}], ",", 
                    RowBox[{"calc$eigenTA", "=", "0.2"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$eigenPA", "]"}], "]"}], ",", 
                    RowBox[{"calc$eigenPA", "=", "0.5"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$eigenIS", "]"}], "]"}], ",", 
                    RowBox[{"calc$eigenIS", "=", "150"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$eigenP", "]"}], "]"}], "||", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "calc$eigenP", "]"}], "\[Equal]", 
                    RowBox[{"Length", "[", "eigenf", "]"}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"calc$eigenP", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "eigenf", "]"}], "}"}]}], 
                    "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "temp$eigenP", "]"}], "]"}], "||", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "temp$eigenP", "]"}], "\[Equal]", 
                    RowBox[{"Length", "[", "eigenf", "]"}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$eigenP", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "eigenf", "]"}], "}"}]}], 
                    "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$maxx", "]"}], "]"}], ",", 
                    RowBox[{"calc$maxx", "=", "2.5"}]}], "]"}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$maxz", "]"}], "]"}], ",", 
                    RowBox[{"calc$maxz", "=", "2.5"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$ytop", "]"}], "]"}], ",", 
                    RowBox[{"calc$ytop", "=", "1.0"}]}], "]"}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "calc$ybottom", "]"}], "]"}], ",", 
                    RowBox[{"calc$ybottom", "=", 
                    RowBox[{"-", "2.5"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Item", "[", 
                    RowBox[{
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Eigen Modes\>\"", ",", "\[IndentingNewLine]", "Bold",
                     ",", "Italic", ",", "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.5"}], "]"}]}]}], "]"}]}], 
                    ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Eigen Mode List\>\"", ",", "Bold", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.3"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "\"\<(Threshold Amplitude:\>\"", 
                    ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$eigenTA", "]"}], ",", 
                    "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<)\>\""}], "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"eigenmodetable", "[", 
                    RowBox[{"eigenf", ",", "eigenv", ",", "calc$eigenTA"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"832", ",", "150"}], "}"}]}], ",", 
                    RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], 
                    "\[IndentingNewLine]", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Eigen Mode 3D Plot\>\"", ",", "Bold", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.3", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Show\>\"", ",", "Small", ",", "Bold", ",", "White"}],
                     "]"}], ",", 
                    RowBox[{"calc$eigenP", "=", "temp$eigenP"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.1", "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$eigenP", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", 
                    RowBox[{"ToString", "[", "n", "]"}]}], "}"}], "}"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "eigenf", "]"}]}], "}"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "6", ",", "6", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "450"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Amplitude:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$eigenPA", "]"}], ",", 
                    "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Image Size:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$eigenIS", "]"}], ",", 
                    "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
                    "}"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Marker Position:\>\"", ",", "Bold"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<x:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$maxx", "]"}], ",", "Number",
                     ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<z:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$maxz", "]"}], ",", "Number",
                     ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<y+:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$ytop", "]"}], ",", "Number",
                     ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<y-:\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "calc$ybottom", "]"}], ",", 
                    "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
                    "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "392"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", "Top"}]}], "]"}], ",",
                     "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
                    RowBox[{"Panel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$eigenP", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"l", ",", 
                    RowBox[{"Length", "[", "eigenf", "]"}]}], "}"}]}], "]"}], 
                    ",", "0"}], "]"}], "===", 
                    RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                    RowBox[{"Partition", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"eigenf", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "0.001"}], "]"}], 
                    "]"}], "<>", "\"\<Hz\>\""}], ",", "15"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<More\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"CreateDocument", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"ExpressionCell", "[", 
                    RowBox[{"eigenplot", "[", 
                    RowBox[{"eigenv", ",", "calc$eigenPA", ",", "n", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "calc$eigenIS"}]}], "]"}],
                     "]"}], "}"}], "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", "0.8", "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], 
                    "]"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"eigenplot", "[", 
                    RowBox[{"eigenv", ",", "calc$eigenPA", ",", "n", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "calc$eigenIS"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"viewQ", "[", 
                    RowBox[{
                    RowBox[{"important", "[", 
                    RowBox[{"eigenv", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "optr", ",", 
                    "optp"}], "]"}]}], "]"}]}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$eigenP", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"l", ",", 
                    RowBox[{"Length", "[", "eigenf", "]"}]}], "}"}]}], "]"}], 
                    ",", "0"}], "]"}]}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"IntegerPart", "[", 
                    RowBox[{"840", "/", 
                    RowBox[{"(", 
                    RowBox[{"calc$eigenIS", "+", "10"}], ")"}]}], "]"}], ",", 
                    RowBox[{"IntegerPart", "[", 
                    RowBox[{"840", "/", 
                    RowBox[{"(", 
                    RowBox[{"calc$eigenIS", "+", "10"}], ")"}]}], "]"}], ",", 
                    "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], "\[IndentingNewLine]", "]"}],
                     ",", "\"\<3D plots are shown here.\>\""}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "850"}]}], 
                    "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
                    "]"}], ",", "\"\<\>\""}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "}"}], "]"}]}]}], "]"}], "]"}]}], 
            ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", " ", 
                RowBox[{"**", "**", "**", "**", "**", " ", "Export"}]}]}], 
              " ", 
              RowBox[{"Model", " ", "**", "**", "**", "**", "**", " ", 
               RowBox[{"--", "-"}]}]}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Export Model\>\"", ",", "Bold"}], "]"}], "\[Rule]",
              "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"Not", "[", "calcdone", "]"}], ",", 
                RowBox[{"calcdone", ";", "\"\<\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"calcdone", ";", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", 
                    RowBox[{"Export", "--"}]}]}], "-"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Item", "[", 
                    RowBox[{
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Mathematica Export\>\"", ",", "\[IndentingNewLine]", 
                    "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.2", ",", "0.1", ",", "0.1"}], "]"}]}]}], "]"}],
                     ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export matrices and variables in Mathematica Format:\
\>\"", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export Suspension Model\>\"", ",", "Bold", ",", 
                    "White"}], "]"}], ",", "\[IndentingNewLine]", 
                    "mod$ExportModel", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.2", ",", "0", ",", "0"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}],
                     ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Item", "[", 
                    RowBox[{
                    RowBox[{"Pane", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<MATLAB Export\>\"", ",", "\[IndentingNewLine]", 
                    "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"870", ",", "30"}], "}"}]}], ",", 
                    RowBox[{"Alignment", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Left", ",", "Center"}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.1", ",", "0.2", ",", "0.1"}], "]"}]}]}], "]"}],
                     ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export ABCD matrices in a format that can be read in \
MATLAB:\>\"", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export Suspension Model\>\"", ",", "Bold", ",", 
                    "White"}], "]"}], ",", "\[IndentingNewLine]", 
                    "mod$MATLABExport", ",", 
                    RowBox[{"(*", 
                    RowBox[{"Set", " ", "Body", " ", "Names"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0.2", ",", "0"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
                    RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                    "\[IndentingNewLine]", "}"}], "}"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}]}], 
               "\[IndentingNewLine]", "]"}], "]"}]}]}], "\[IndentingNewLine]",
            "\[IndentingNewLine]", "}"}], ",", 
          RowBox[{"Dynamic", "[", "tabviewctrl", "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowFrameElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<CloseBox\>\"", ",", "\"\<ResizeArea\>\"", ",", "\"\<ZoomBox\>\"",
          ",", "\"\<MinimizeBox\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"920", ",", "600"}], "}"}]}], ",", 
      RowBox[{"WindowMargins", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowTitle", "\[Rule]", 
       RowBox[{"\"\<SUMCON Version:\>\"", "<>", "$VersionSUMCON"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570036512226287*^9, 3.570036657274584*^9}, {
   3.5700366987219543`*^9, 3.570036738090206*^9}, {3.570036976132821*^9, 
   3.5700369833612347`*^9}, {3.5700372655043726`*^9, 
   3.5700372783071046`*^9}, {3.5700374187501373`*^9, 3.570037425862544*^9}, {
   3.570037626914044*^9, 3.5700376359455605`*^9}, {3.570037758407565*^9, 
   3.5700377773906507`*^9}, {3.5700379119943495`*^9, 3.57003791498252*^9}, {
   3.57003800221751*^9, 3.570038010925008*^9}, {3.5700381252195454`*^9, 
   3.570038133155999*^9}, {3.570038188556168*^9, 3.5700381957775807`*^9}, {
   3.570039028310199*^9, 3.570039041663963*^9}, {3.5700394139692574`*^9, 
   3.570039440255761*^9}, {3.5700394754037714`*^9, 3.5700395220214376`*^9}, {
   3.5700395901343336`*^9, 3.570039650021759*^9}, {3.570039692436185*^9, 
   3.5700396948093204`*^9}, {3.570039788723692*^9, 3.5700397898287554`*^9}, {
   3.570039836044399*^9, 3.570039838636547*^9}, {3.570039886998313*^9, 
   3.570039915842963*^9}, {3.5700401578588057`*^9, 3.570040171062561*^9}, {
   3.570040332470793*^9, 3.5700403332968397`*^9}, {3.570040368451851*^9, 
   3.5700404599950867`*^9}, {3.570079899670907*^9, 3.5700799285065565`*^9}, {
   3.5700800007106867`*^9, 3.570080019535763*^9}, {3.5700801101749473`*^9, 
   3.5700801311381464`*^9}, {3.5700808025455484`*^9, 3.570080802675556*^9}, {
   3.570080869802396*^9, 3.570080897482979*^9}, {3.5700810292705164`*^9, 
   3.5700810796844*^9}, {3.5700811464402184`*^9, 3.5700811561097713`*^9}, {
   3.5700951724649725`*^9, 3.5700951879488583`*^9}, {3.5700952379437175`*^9, 
   3.5700952639792066`*^9}, {3.570095310806885*^9, 3.57009531230097*^9}, {
   3.5700954082284575`*^9, 3.5700955198828435`*^9}, {3.5700956025845737`*^9, 
   3.570095607752869*^9}, {3.5700956493892508`*^9, 3.57009572770373*^9}, {
   3.5700960804929085`*^9, 3.570096101434106*^9}, {3.570096184883879*^9, 
   3.5700961927273283`*^9}, {3.5700962525577497`*^9, 
   3.5700962526547556`*^9}, {3.570096318802539*^9, 3.570096377371889*^9}, {
   3.570096526672428*^9, 3.570096652646634*^9}, {3.5700976923150997`*^9, 
   3.570097739454796*^9}, {3.5700977840243444`*^9, 3.5700978048465357`*^9}, {
   3.570098100943472*^9, 3.570098105546735*^9}, {3.5700981706534586`*^9, 
   3.5700984628281703`*^9}, {3.5700984958090568`*^9, 3.570098496936121*^9}, {
   3.5700985300050125`*^9, 3.5700985347792854`*^9}, {3.57009856668311*^9, 
   3.570098580609907*^9}, 3.5700986692889795`*^9, {3.5700987976613216`*^9, 
   3.570098877944914*^9}, {3.5700989222474475`*^9, 3.570098994220564*^9}, {
   3.5700990371190176`*^9, 3.570099052566901*^9}, {3.5700992229796486`*^9, 
   3.5700993755763764`*^9}, {3.570099457238047*^9, 3.5700994613332815`*^9}, {
   3.5700995291121583`*^9, 3.5700995428249426`*^9}, {3.570099636924325*^9, 
   3.5700997415133066`*^9}, 3.57009979629244*^9, {3.5700999711254396`*^9, 
   3.5700999976639576`*^9}, {3.570100081112731*^9, 3.5701003240076237`*^9}, {
   3.5701003620037966`*^9, 3.57010051154035*^9}, {3.5701005783801727`*^9, 
   3.570100579641245*^9}, {3.5701007380683064`*^9, 3.570100895047285*^9}, {
   3.570100929940281*^9, 3.5701010305340347`*^9}, {3.570101149048813*^9, 
   3.570101169779999*^9}, {3.5701012186927967`*^9, 3.5701012259992146`*^9}, {
   3.570103104226643*^9, 3.570103204319368*^9}, {3.570103250997038*^9, 
   3.570103334620821*^9}, {3.5701034165855093`*^9, 3.5701034331534567`*^9}, {
   3.5701034728927298`*^9, 3.570103550493168*^9}, {3.5701036020401163`*^9, 
   3.57010361626693*^9}, {3.5701036825177193`*^9, 3.5701036849118567`*^9}, {
   3.570103715233591*^9, 3.570103774715993*^9}, {3.5701038119811244`*^9, 
   3.570103844738998*^9}, {3.5701039208723526`*^9, 3.5701039527761774`*^9}, {
   3.570104099933594*^9, 3.5701041858625093`*^9}, {3.5701042188913984`*^9, 
   3.5701042484780903`*^9}, {3.570104282611043*^9, 3.5701042890954137`*^9}, 
   3.570104337690193*^9, {3.570104370287058*^9, 3.5701044936041107`*^9}, {
   3.5701045369535904`*^9, 3.570104634927194*^9}, {3.5701046731683817`*^9, 
   3.5701047158728237`*^9}, {3.5701047710229783`*^9, 3.570104786372856*^9}, {
   3.5701048208558283`*^9, 3.5701048272921968`*^9}, {3.5701048803272305`*^9, 
   3.570104894764056*^9}, {3.5701049266738815`*^9, 3.5701049289620123`*^9}, {
   3.5701049807249727`*^9, 3.5701050326129403`*^9}, {3.5701050765964565`*^9, 
   3.5701051366558914`*^9}, {3.5701051780262575`*^9, 
   3.5701052555976944`*^9}, {3.570105291819766*^9, 3.5701053132979946`*^9}, {
   3.5701053634398627`*^9, 3.5701053741384745`*^9}, {3.5701085977728558`*^9, 
   3.570108600979039*^9}, {3.5701114479068747`*^9, 3.5701114507310357`*^9}, {
   3.5701213140211835`*^9, 3.5701213523063736`*^9}, {3.5701330306493363`*^9, 
   3.570133031141365*^9}, {3.5701330673244343`*^9, 3.5701330819462705`*^9}, {
   3.5701659950642757`*^9, 3.5701660376707134`*^9}, {3.5701708875171084`*^9, 
   3.570170918592886*^9}, {3.5701709586371765`*^9, 3.5701710170755186`*^9}, {
   3.570171176928662*^9, 3.5701711787997684`*^9}, {3.5701955847747107`*^9, 
   3.5701955873978605`*^9}, {3.5702550526218824`*^9, 
   3.5702550586278925`*^9}, {3.5702882173845177`*^9, 3.570288220478695*^9}, {
   3.5702973360960784`*^9, 3.570297396495533*^9}, {3.5702974316585445`*^9, 
   3.570297523077773*^9}, {3.570297559620863*^9, 3.5702975912356715`*^9}, {
   3.5702976406284966`*^9, 3.570297661246676*^9}, {3.570363860191163*^9, 
   3.570363948461211*^9}, {3.5703640003881817`*^9, 3.5703640123258643`*^9}, {
   3.570364294631011*^9, 3.5703642983982267`*^9}, {3.570379090506908*^9, 
   3.5703790932100625`*^9}, {3.5706407604510975`*^9, 3.570640781376294*^9}, {
   3.5706410999515157`*^9, 3.570641101679614*^9}, {3.570642330433895*^9, 
   3.570642330920923*^9}, {3.570708842253481*^9, 3.5707088453076563`*^9}, {
   3.5707117032931232`*^9, 3.570711714009736*^9}, {3.5707257460649676`*^9, 
   3.570725799733037*^9}, {3.570770527482097*^9, 3.5707705346935096`*^9}, {
   3.570770649361068*^9, 3.570770680912873*^9}, 3.5707709595548105`*^9, 
   3.5707710609836116`*^9, {3.570855899583596*^9, 3.570855925378072*^9}, {
   3.5708594859987273`*^9, 3.5708594862287407`*^9}, {3.571057532280692*^9, 
   3.571057539673115*^9}, 3.571231779270361*^9, {3.571231811454202*^9, 
   3.5712318182035885`*^9}, {3.571300104816359*^9, 3.571300134310046*^9}, 
   3.5713381000092044`*^9, {3.571338156261422*^9, 3.57133816147572*^9}, {
   3.5713385548302183`*^9, 3.5713385551952395`*^9}, {3.5713398012515097`*^9, 
   3.5713398264889536`*^9}, {3.571339974083395*^9, 3.571339978171629*^9}, {
   3.5713401598110185`*^9, 3.5713401647443004`*^9}, 3.5713403738622613`*^9, {
   3.5713405189285583`*^9, 3.571340539946761*^9}, 3.5713413761495886`*^9, {
   3.571430334696435*^9, 3.5714303426848917`*^9}, {3.5714707828259325`*^9, 
   3.5714708095614614`*^9}, {3.571470883872712*^9, 3.5714708841557283`*^9}, {
   3.585630716095646*^9, 3.585630722859033*^9}, {3.585630755567904*^9, 
   3.5856309066395445`*^9}, {3.5856309606096315`*^9, 
   3.5856309607806416`*^9}, {3.585631030023602*^9, 3.585631052809905*^9}, {
   3.585631187117587*^9, 3.585631191119816*^9}, {3.585631483026512*^9, 
   3.5856315104260793`*^9}, {3.5856315940168605`*^9, 
   3.5856316721933317`*^9}, {3.5856317246003294`*^9, 
   3.5856318075440736`*^9}, {3.5856318623202066`*^9, 
   3.5856320113377295`*^9}, {3.585632163504433*^9, 3.585632174160043*^9}, {
   3.5856324053672667`*^9, 3.58563244633461*^9}, {3.5856324973715296`*^9, 
   3.5856325164366198`*^9}, {3.5856325470233693`*^9, 3.585632575929023*^9}, {
   3.585632752559125*^9, 3.585632803580044*^9}, {3.58563286786172*^9, 
   3.585632867964726*^9}, {3.5856329315633636`*^9, 3.585632976142914*^9}, {
   3.585633033182176*^9, 3.5856330775167117`*^9}, {3.585633112208696*^9, 
   3.585633116685952*^9}, {3.5856331779024534`*^9, 3.5856332746389866`*^9}, {
   3.585633356102646*^9, 3.585633369423408*^9}, {3.5856334103327475`*^9, 
   3.585633450372038*^9}, {3.585633484939015*^9, 3.585633547663603*^9}, {
   3.5856338305047803`*^9, 3.5856339446583095`*^9}, {3.585634025895956*^9, 
   3.585634027380041*^9}, {3.5856342191740108`*^9, 3.585634247556634*^9}, {
   3.585634287421914*^9, 3.585634415745254*^9}, {3.585634472446497*^9, 
   3.5856344726545095`*^9}, {3.5856946746435137`*^9, 3.585694689725376*^9}, {
   3.5856957812928104`*^9, 3.5856957835859413`*^9}, {3.585695838423078*^9, 
   3.5856958401781783`*^9}, {3.5856960320401525`*^9, 3.5856961015121255`*^9}, 
   3.585696813270836*^9, 3.5857185312740345`*^9, {3.585718623370302*^9, 
   3.585718623579314*^9}, {3.5857186794925127`*^9, 3.585718703870907*^9}, {
   3.585718761167184*^9, 3.585718909147648*^9}, {3.585718983331891*^9, 
   3.5857190061531963`*^9}, {3.5857192204184513`*^9, 3.585719221982541*^9}, {
   3.585719297821879*^9, 3.5857194839645257`*^9}, {3.585719601728261*^9, 
   3.585719791159096*^9}, {3.5857198365156903`*^9, 3.585719882997349*^9}, {
   3.5857199364544067`*^9, 3.5857199756526484`*^9}, {3.5857217065006475`*^9, 
   3.585721724236662*^9}, {3.5857281788348436`*^9, 3.58572840291266*^9}, {
   3.5857284699254932`*^9, 3.585728646207576*^9}, {3.5857320625669804`*^9, 
   3.5857320701334133`*^9}, {3.5857383444792852`*^9, 
   3.5857383463223906`*^9}, {3.5857388804379406`*^9, 
   3.5857389081555257`*^9}, {3.585738974701332*^9, 3.5857389930853834`*^9}, {
   3.5857391074999275`*^9, 3.5857391079529533`*^9}, {3.585886767102229*^9, 
   3.585886770646432*^9}, {3.585886801582201*^9, 3.5858868346290913`*^9}, {
   3.586650985084099*^9, 3.5866509885212955`*^9}, {3.586651021910205*^9, 
   3.586651083320718*^9}, {3.5866511377508307`*^9, 3.586651260840871*^9}, {
   3.586651631845091*^9, 3.586651659866694*^9}, {3.586651711449644*^9, 
   3.586651870728755*^9}, {3.5905594202514505`*^9, 3.590559512677737*^9}, {
   3.5905595707540593`*^9, 3.5905595724401555`*^9}, {3.5906526624477215`*^9, 
   3.590652740916209*^9}, {3.590779831747761*^9, 3.590779878153415*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Information", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714902577508345`*^9, 3.571490266956361*^9}}],

Cell[CellGroupData[{

Cell["About SUMCON", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571340636932308*^9, 3.5713406389914255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$AboutSUMCON", ":=", 
   RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"titleSUMCON", "=", 
        RowBox[{"Import", "[", "\"\<SUMCON.PNG\>\"", "]"}]}], ";", 
       RowBox[{"(*", 
        RowBox[{"Import", " ", "Title"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Top"}]}], " ", 
          RowBox[{"Frame", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Image", "[", 
            RowBox[{"titleSUMCON", ",", 
             RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
           "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           "\"\<(You need Wolfram Mathematica later than version 7.0)\>\"", 
           ",", "\[IndentingNewLine]", "\"\<Suspension Model Constructor\>\"",
            ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<Version:\>\"", "<>", "$VersionSUMCON"}], ",", 
           "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
           "\"\<Programmed by Takanori Sekiguchi\>\"", ",", 
           "\[IndentingNewLine]", "\"\<Contact: tseki@icrr.u-tokyo.ac.jp\>\"",
            ",", "\[IndentingNewLine]", "\"\<\>\"", ",", 
           "\[IndentingNewLine]", "\"\<Last Update: 28/08/2013\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
     ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<SUMCON\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571340646772871*^9, 3.5713406547983303`*^9}, {
  3.5713406966577244`*^9, 3.571340883031384*^9}, {3.571340917273343*^9, 
  3.5713410114387283`*^9}, {3.585888318763979*^9, 3.5858884514305673`*^9}, {
  3.586652223415927*^9, 3.5866522817792654`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Version Info", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571340636932308*^9, 3.5713406389914255`*^9}, {
  3.571341091232292*^9, 3.5713410961005707`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$VersionInfo", ":=", 
   RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"titleSUMCON", "=", 
        RowBox[{"Import", "[", "\"\<SUMCON.PNG\>\"", "]"}]}], ";", 
       RowBox[{"(*", 
        RowBox[{"Import", " ", "Title"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Top"}]}], " ", 
          RowBox[{"Frame", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Image", "[", 
            RowBox[{"titleSUMCON", ",", 
             RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Pane", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TableForm", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.2 Release (13/10/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Fix bugs for newly introduced functions in v1.1.\>\"",
                  ",", "\[IndentingNewLine]", 
                 "\"\<* Introduce 'Import' button to the 'Frequency Domain \
Plot Tools'\>\"", ",", "\[IndentingNewLine]", "\"\<\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.1 Release (16/08/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Introduce the Tab-View interface.\>\"", ",", 
                 "\[IndentingNewLine]", 
                 "\"\<* Add 'Export' button to the 'Frequency Domain Plot \
Tools'\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Add 'Export Model' section for other \
applications.\>\"", ",", "\[IndentingNewLine]", 
                 "\"\<* Fix bugs for Macintosh users.\>\"", ",", 
                 "\[IndentingNewLine]", "\"\<\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<v1.0 Release (22/03/2013)\>\"", ",", "Bold", ",", 
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.4", ",", "0", ",", "0"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", "\"\<* Beta version released.\>\""}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"TableAlignments", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"Left", ",", "Top"}], "}"}]}]}], "]"}], ",", 
             RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
     ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Version Information\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571340646772871*^9, 3.5713406547983303`*^9}, {
  3.5713406966577244`*^9, 3.571340883031384*^9}, {3.571340917273343*^9, 
  3.5713410114387283`*^9}, {3.571341138128975*^9, 3.5713413552183914`*^9}, {
  3.585628476822567*^9, 3.58562849644969*^9}, {3.585632212000207*^9, 
  3.5856322772349386`*^9}, {3.585699323742427*^9, 3.5856996897233596`*^9}, {
  3.585699732123785*^9, 3.5856997375750966`*^9}, {3.5858879965135474`*^9, 
  3.585888122161734*^9}, {3.5858881652581987`*^9, 3.5858881879974995`*^9}, {
  3.5858882247176*^9, 3.5858882535152473`*^9}, {3.590619733720417*^9, 
  3.590619900825635*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Save & Load Model", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490282922274*^9, 3.5714902867994957`*^9}}],

Cell[CellGroupData[{

Cell["Save Function", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5856372418869*^9, 3.585637244038023*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$ListSave", "[", 
    RowBox[{"file_", ",", "list_"}], "]"}], ":=", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{"Save", "[", 
      RowBox[{"file", ",", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"list", "[", 
         RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585637244627057*^9, 3.5856372851143723`*^9}, {
  3.585637349972082*^9, 3.5856374107665596`*^9}, {3.5856377033182926`*^9, 
  3.5856377093436375`*^9}, {3.585637755012249*^9, 3.5856377573783846`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Save Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5702971671724167`*^9, 3.570297169398544*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SaveModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$saveQ", "=", "False"}], ";", "\[IndentingNewLine]", 
        RowBox[{"saveparamnames", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Names", "[", "\"\<save$*\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<calc$*\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<matK@\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<matG@\>\"", "]"}], ",", 
           RowBox[{"Names", "[", "\"\<matM@\>\"", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<allvars\>\"", ",", "\"\<allparams\>\"", ",", 
             "\"\<allfloats\>\"", ",", "\"\<subdefparams\>\"", ",", 
             "\"\<subminvars\>\"", ",", "\"\<eigenf\>\"", ",", 
             "\"\<eigenv\>\"", ",", "\"\<bodylist\>\"", ",", 
             "\"\<wirelist\>\"", ",", "\"\<calcdone\>\""}], "}"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Save Model\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Saved Parameters:\>\"", ",", "Bold", ",", "Italic"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"saveparamnames", ",", "7", ",", "7", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$FileName", "]"}], ",", "String", 
             ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"30.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"StringLength", "[", "temp$FileName", "]"}], 
                 "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                   ",", 
                   RowBox[{
                   "\"\<save\>\"", "<>", "sepchar", "<>", "temp$FileName", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"temp$saveQ", "=", "True"}], ",", 
                 RowBox[{
                  RowBox[{"save$FileName", "=", "temp$FileName"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamlist"}], "]"}], ";"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"mod$ListSave", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamnames"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"PaneSelector", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<Do you really want to overwrite?\>\"", ",", "Red", ",",
                    "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"save$FileName", "=", "temp$FileName"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamlist"}], "]"}], "]"}], ","}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"mod$ListSave", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                     "sepchar", "<>", "save$FileName", "<>", "\"\<.m\>\""}], 
                    ",", "saveparamnames"}], "]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                   RowBox[{"temp$saveQ", "=", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
            RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", "temp$saveQ", 
          ",", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$FileName", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "]"}],
                 "\[IndentingNewLine]", ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                   "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
              ",", "3", ",", "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"650", ",", "200"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "650"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Save Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.579318697254388*^9, 3.5793187226368394`*^9}, {3.585629975834306*^9, 
   3.585630077335111*^9}, {3.585630263322749*^9, 3.5856302650288467`*^9}, {
   3.5856347455931206`*^9, 3.585634746358164*^9}, {3.5856353565610657`*^9, 
   3.5856355069106655`*^9}, {3.5856355566455097`*^9, 
   3.5856355660450478`*^9}, {3.585635610080566*^9, 3.585635658069311*^9}, {
   3.5856357377588687`*^9, 3.585635817647438*^9}, {3.58563590002215*^9, 
   3.5856359428636003`*^9}, {3.5856359867011075`*^9, 
   3.5856360252073097`*^9}, {3.5856360552850304`*^9, 
   3.5856361583309245`*^9}, {3.585636317472027*^9, 3.5856363238123894`*^9}, {
   3.5856364294044285`*^9, 3.585636439427002*^9}, 3.585636492519039*^9, {
   3.585636950592239*^9, 3.58563700270922*^9}, {3.585637094659479*^9, 
   3.585637144719342*^9}, 3.585637196055279*^9, {3.585637449364767*^9, 
   3.5856374776803865`*^9}, {3.5856375144344893`*^9, 3.585637561091158*^9}, {
   3.585637860668292*^9, 3.585637863355446*^9}, {3.5856380848111124`*^9, 
   3.5856380884463205`*^9}, {3.5856384303908787`*^9, 3.585638439748414*^9}, {
   3.585638581349513*^9, 3.585638740808634*^9}, {3.5856388057633486`*^9, 
   3.5856388302697506`*^9}, 3.58563889827264*^9, {3.585638963856391*^9, 
   3.5856389724948854`*^9}, {3.585639055678643*^9, 3.5856390565096903`*^9}, {
   3.585720099535734*^9, 3.585720101754861*^9}, {3.585720135956817*^9, 
   3.5857201360708237`*^9}, {3.5857201760161085`*^9, 3.5857201880968*^9}, {
   3.585720245394077*^9, 3.5857202455090837`*^9}, {3.585721771782381*^9, 
   3.5857217758776155`*^9}, {3.5857249762436657`*^9, 3.58572498051191*^9}, {
   3.585725308349661*^9, 3.5857253088116875`*^9}, {3.585727970873949*^9, 
   3.5857280054689274`*^9}, {3.585773203829859*^9, 3.5857732212408547`*^9}, {
   3.585773341354725*^9, 3.585773342283778*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Load Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703648112755613`*^9, 3.5703648131296673`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$LoadModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
        "*", "Version", " ", 
        RowBox[{
        "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
          "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
          "*", "Version", " ", 
          RowBox[{
          "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
            "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Load Model\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$Load", "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"30.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"Not", "[", 
                 RowBox[{
                  RowBox[{"StringLength", "[", "temp$Load", "]"}], "\[Equal]",
                   "0"}], "]"}], ",", 
                RowBox[{"Get", "[", 
                 RowBox[{
                  RowBox[{"Directory", "[", "]"}], "<>", "\"\</save\>\"", "<>",
                   "sepchar", "<>", "temp$Load", "<>", "\"\<.m\>\""}], 
                 "]"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "}"}], 
         "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$Load", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "5"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "]"}],
                 "\[IndentingNewLine]", ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], 
                   "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
              ",", "3", ",", "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"650", ",", "200"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.5703648187229877`*^9, 
   3.570364842461345*^9}, {3.5703650147151976`*^9, 3.570365221167006*^9}, {
   3.571491889628173*^9, 3.5714919173387575`*^9}, {3.579318727822136*^9, 
   3.579318738045721*^9}, {3.5856378415101967`*^9, 3.585637880435423*^9}, {
   3.585637912451254*^9, 3.585637917376536*^9}, {3.5856935124470396`*^9, 
   3.5856935130710754`*^9}, {3.585720252369476*^9, 3.585720256195695*^9}, {
   3.5857203031763816`*^9, 3.585720327810791*^9}, {3.5857203659619727`*^9, 
   3.5857203671100388`*^9}, {3.585720445584527*^9, 3.585720452507923*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703648112755613`*^9, 3.5703648131296673`*^9}, {
  3.5858856211936865`*^9, 3.5858856216377125`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewModel", ":=", 
   RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Do you want to clear all the setting and start a new model?\>\"", 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<OK\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"calcdone", "=", "False"}], ";", 
                RowBox[{"Clear", "[", 
                 RowBox[{"\"\<save$*\>\"", ",", "\"\<calc$*\>\""}], "]"}], 
                ";"}], ")"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Model\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571340646772871*^9, 3.5713406547983303`*^9}, {
  3.5713406966577244`*^9, 3.571340883031384*^9}, {3.571340917273343*^9, 
  3.5713410114387283`*^9}, {3.585886997498407*^9, 3.585887124057646*^9}, {
  3.5858871885563345`*^9, 3.585887198684914*^9}, {3.5858872351259985`*^9, 
  3.585887318957793*^9}, {3.5858873639403667`*^9, 3.5858873869406815`*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1. Registrate Bodies", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.567267260762373*^9, 3.5672672628784943`*^9}, {
   3.567267513410824*^9, 3.567267558324393*^9}, 3.571490196526333*^9, {
   3.5714902918937874`*^9, 3.5714903042524943`*^9}}],

Cell[CellGroupData[{

Cell["1-1 Set Body Names", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701196462297916`*^9, 3.570119669842142*^9}}],

Cell[CellGroupData[{

Cell["Set Body Names", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567054229706352*^9, 3.5670542365717444`*^9}, {
  3.5701196762995114`*^9, 3.570119679530696*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetBodyNames", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Registrate Body Names\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Load"}]}], " ", 
           RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"nMax", "=", "30"}], ",", "len"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ValueQ", "[", "save$bdn", "]"}], ",", 
             RowBox[{
              RowBox[{"len", "=", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"len", "<", "nMax"}], ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                  ",", " ", 
                  RowBox[{"load", " ", "it"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"temp$bdn", "=", 
                 RowBox[{"Join", "[", 
                  RowBox[{"save$bdn", ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"False", ",", "\"\<\>\""}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"nMax", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"temp$bdn", "=", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ";;", "nMax"}], "]"}], "]"}]}]}], "]"}]}], 
             ",", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"If", " ", "not"}], ",", " ", 
               RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"temp$bdn", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"True", ",", "\"\<g\>\""}], "}"}], "}"}], ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"False", ",", "\"\<\>\""}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"nMax", "-", "1"}], "}"}]}], "]"}]}], "]"}]}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Input"}]}], " ", "Field", " ", 
              RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Partition", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Table", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",",
                    "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", "nMax"}], "}"}]}], "]"}], ",", "1"}], 
                "]"}], ",", "10", ",", "10", ",", "1", ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", 
             RowBox[{"TableAlignments", "\[Rule]", "Center"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<GND\>\"", ",", "\"\<Name\>\""}], "}"}], ",", 
                    RowBox[{"{", "5", "}"}]}], "]"}], ",", "1"}], "]"}]}], 
               "}"}]}]}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"(*", 
                RowBox[{"Save", " ", "Button"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"save$bdn", "=", 
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                  RowBox[{"DeleteCases", "[", 
                   RowBox[{"temp$bdn", ",", 
                    RowBox[{"{", 
                    RowBox[{"False", ",", "\"\<\>\""}], "}"}]}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"True", ",", "\"\<\>\""}], "}"}]}], "]"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", 
      RowBox[{"(*", 
       RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<1-1 Set Body Names\>\""}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566889731755993*^9, 3.5668897823058844`*^9}, {
   3.566889828859547*^9, 3.566889886714856*^9}, {3.5668899175776215`*^9, 
   3.5668901655738063`*^9}, {3.566890196972602*^9, 3.566890199961773*^9}, {
   3.5668903236848497`*^9, 3.5668903462531404`*^9}, {3.5668904168021755`*^9, 
   3.566890551243865*^9}, {3.566890625559116*^9, 3.566890628851304*^9}, {
   3.5668906610411453`*^9, 3.5668906778621073`*^9}, {3.566890768100269*^9, 
   3.566890784114185*^9}, {3.5668908451256742`*^9, 3.5668908877861147`*^9}, 
   3.566891015361411*^9, 3.566891047194232*^9, {3.566891183957054*^9, 
   3.5668912099195395`*^9}, {3.5668912400952654`*^9, 3.566891244621524*^9}, {
   3.5668915432576056`*^9, 3.5668915449367013`*^9}, {3.566891715968484*^9, 
   3.5668918358523407`*^9}, {3.5668918709093456`*^9, 
   3.5668919456306195`*^9}, {3.5668919801025915`*^9, 
   3.5668920205259037`*^9}, {3.5668921640831146`*^9, 
   3.5668921784709373`*^9}, {3.5669005192484193`*^9, 
   3.5669005275928965`*^9}, {3.566900766911585*^9, 3.5669007676166253`*^9}, {
   3.566900884500311*^9, 3.5669008846533194`*^9}, {3.5669009277877865`*^9, 
   3.5669009420656033`*^9}, {3.566900976717585*^9, 3.566900990180355*^9}, {
   3.5669011295833282`*^9, 3.566901154485753*^9}, {3.5669013452236624`*^9, 
   3.566901441446166*^9}, {3.5669015126182365`*^9, 3.566901578348996*^9}, {
   3.56690206340174*^9, 3.5669021167747927`*^9}, {3.5670472309350452`*^9, 
   3.5670472422206907`*^9}, {3.567049068330138*^9, 3.567049128459577*^9}, {
   3.567049167883832*^9, 3.5670491697939415`*^9}, {3.567049214166479*^9, 
   3.5670492154155507`*^9}, {3.567049277939127*^9, 3.567049311335037*^9}, {
   3.5670493673282394`*^9, 3.5670494751234055`*^9}, {3.5670495188559065`*^9, 
   3.5670495276194077`*^9}, {3.5670499046279716`*^9, 
   3.5670499125794263`*^9}, {3.5670500075978613`*^9, 3.567050082795162*^9}, {
   3.567050121957402*^9, 3.567050142257563*^9}, {3.5670502103874598`*^9, 
   3.567050320436754*^9}, {3.5670503781780567`*^9, 3.5670503853374662`*^9}, 
   3.567050423894672*^9, {3.5670506654214864`*^9, 3.5670506813283963`*^9}, {
   3.56705071234017*^9, 3.5670507706615057`*^9}, {3.567050872177312*^9, 
   3.567050989024996*^9}, {3.5670512359771204`*^9, 3.567051292753368*^9}, {
   3.567051650941855*^9, 3.5670516674888015`*^9}, {3.5670524229500113`*^9, 
   3.567052430582448*^9}, {3.5670524819683867`*^9, 3.567052544048938*^9}, {
   3.5670526884181952`*^9, 3.567052698854792*^9}, {3.567052773789078*^9, 
   3.5670528319914074`*^9}, 3.567052865848344*^9, {3.567053705189351*^9, 
   3.5670537075144844`*^9}, {3.567054056444442*^9, 3.567054063632853*^9}, {
   3.5670541466215997`*^9, 3.567054200316671*^9}, {3.567054378205846*^9, 
   3.5670546294832177`*^9}, {3.567054679642087*^9, 3.567054696184033*^9}, {
   3.5670547766336346`*^9, 3.5670547894463673`*^9}, {3.5670548916962156`*^9, 
   3.5670549191477857`*^9}, {3.5670563032379513`*^9, 3.567056423484829*^9}, {
   3.5670564615200043`*^9, 3.567056466460287*^9}, {3.567056530281937*^9, 
   3.5670566018970337`*^9}, {3.5670569741953278`*^9, 
   3.5670570850906706`*^9}, {3.567059166334711*^9, 3.5670592158985453`*^9}, {
   3.5670592793491745`*^9, 3.567059317689368*^9}, {3.567063087771004*^9, 
   3.5670630892320876`*^9}, {3.5670695474044743`*^9, 
   3.5670695492815814`*^9}, {3.5670988132317157`*^9, 3.5670988150248184`*^9}, 
   3.5672318299772635`*^9, {3.5675807247684803`*^9, 3.5675807249994936`*^9}, {
   3.5675809545326223`*^9, 3.567580954762635*^9}, {3.567583195411793*^9, 
   3.567583198890992*^9}, {3.5677724913907447`*^9, 3.5677724953469715`*^9}, {
   3.5699565775988846`*^9, 3.569956584503279*^9}, {3.569956662001712*^9, 
   3.5699566621487207`*^9}, {3.5699568606800756`*^9, 3.569956868180505*^9}, {
   3.569956970692368*^9, 3.569956971515415*^9}, {3.569957391410432*^9, 
   3.5699573941355877`*^9}, {3.570108567824143*^9, 3.570108571947379*^9}, {
   3.5701086204881554`*^9, 3.5701086333298893`*^9}, {3.570108671639081*^9, 
   3.570108769759693*^9}, {3.5701088095399685`*^9, 3.570108919817276*^9}, {
   3.5701089890182343`*^9, 3.570109147034272*^9}, {3.5701092402196016`*^9, 
   3.5701096738074017`*^9}, {3.5701097936652575`*^9, 
   3.5701099566595798`*^9}, {3.570110027697643*^9, 3.570110118155817*^9}, {
   3.5701101625923586`*^9, 3.5701102234848413`*^9}, {3.5701104149297915`*^9, 
   3.5701104659137077`*^9}, {3.5701104982435565`*^9, 
   3.5701105330135455`*^9}, {3.570110563092266*^9, 3.5701105957101316`*^9}, {
   3.57011071282583*^9, 3.5701107517620573`*^9}, {3.5701107860690193`*^9, 
   3.5701107892742023`*^9}, {3.5701108256222816`*^9, 
   3.5701109027606936`*^9}, {3.5701109455571413`*^9, 3.570110986883505*^9}, {
   3.570111044172782*^9, 3.570111048875051*^9}, {3.570117373417794*^9, 
   3.5701173736888094`*^9}, 3.5702570696466265`*^9, {3.57025710547989*^9, 
   3.570257131344735*^9}, 3.5702574571669073`*^9, {3.570257683322505*^9, 
   3.5702576836657057`*^9}, {3.5702578161879377`*^9, 
   3.5702578271391573`*^9}, {3.570258174272167*^9, 3.5702581759413705`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1-2 Set Mass and MoI", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570119686677105*^9, 3.5701196953676023`*^9}}],

Cell[CellGroupData[{

Cell["Set Mass and Moment of Inertia", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567054972779853*^9, 3.567054976693077*^9}, {
  3.567055022497697*^9, 3.567055048023157*^9}, {3.5670553367586718`*^9, 
  3.5670553505304594`*^9}, {3.5670554993419704`*^9, 3.567055508455492*^9}, {
  3.5670555953084598`*^9, 3.5670555993806925`*^9}, {3.5670558599685974`*^9, 
  3.5670558686600947`*^9}, {3.5670569156809807`*^9, 3.567056916226012*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetMassMoI", ":=", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"--", 
        RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
       RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been",
          " ", "set", " ", "yet"}], ",", " ", 
        RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Beep", "[", "]"}], ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Set Body Name First.\>\"", ",", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", 
              RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TextCell", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Set Mass and Moment of Inertia\>\"", ",", 
               "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
              "]"}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Load"}]}], " ", 
              RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"len0", "=", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], ",", "len"}], 
              "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                RowBox[{
                 RowBox[{"len", "=", 
                  RowBox[{"Length", "[", "save$mass", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"len", "<", "len0"}], ",", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$mass", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"save$mass", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"temp$mass", "=", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
                ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"If", " ", "not"}], ",", " ", 
                  RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"temp$mass", "=", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", "len0", "}"}]}], "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Logic"}]}], " ", "List", " ", "for", " ", 
                 RowBox[{"Opener", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"temp$massopn", "=", 
               RowBox[{"Table", "[", 
                RowBox[{"False", ",", 
                 RowBox[{"{", "len0", "}"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                 RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Copy", " ", "&"}], " ", "Past"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$masscopy", "=", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Paste\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "temp$masscopy", "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", "temp$masscopy"}]}], 
                    "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Mass", " ", "&"}], " ", "Diagonal", " ", "MoI"}],
                     "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", 
                    ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"MoI", " ", "Off"}], "-", 
                    RowBox[{"Diangonal", " ", "Part"}]}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Opener", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$massopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", 
                    RowBox[{"PaneSelector", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"False", "\[Rule]", "\"\<Off-Diag\>\""}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"True", "\[Rule]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m", ",", "l"}], "]"}], "]"}],
                     "]"}]}], "]"}], ",", "Number", ",", 
                    RowBox[{"ImageSize", "\[Rule]", "70."}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"Not", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}]}], "]"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"l", ",", "3"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}],
                     "}"}]}], "}"}]}]}], "]"}]}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$massopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}]}], 
                   "}"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                RowBox[{"TableHeadings", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{
                    "\"\<Copy\>\"", ",", "\"\<Paste\>\"", ",", "\"\<Mass\>\"",
                     ",", "\"\<Ixx\>\"", ",", "\"\<Iyy\>\"", ",", 
                    "\"\<Izz\>\"", ",", "\"\<\>\"", ",", "\"\<I Matrix\>\""}],
                     "}"}]}], "}"}]}]}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"--", 
                RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
              RowBox[{"Button", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"If", " ", "mass"}], " ", "&"}], " ", "MoI", " ", 
                    "diagonals", " ", "are", " ", "not", " ", "positive", " ",
                     "number"}], ",", " ", 
                   RowBox[{"return", " ", "Error"}]}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "||", 
                    RowBox[{"(", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
                    "False"}], "]"}], "&&", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                     "]"}], ",", "False"}], "]"}], "&&", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                     "]"}], ",", "False"}], "]"}], "&&", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}], ",", 
                    RowBox[{"Positive", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                     "]"}], ",", "False"}], "]"}], "&&", 
                    "\[IndentingNewLine]", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "2"}], "]"}], "]"}],
                     "]"}], "&&", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "3"}], "]"}], "]"}],
                     "]"}], "&&", "\[IndentingNewLine]", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "1"}], "]"}], "]"}],
                     "]"}], "&&", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "3"}], "]"}], "]"}],
                     "]"}], "&&", "\[IndentingNewLine]", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "1"}], "]"}], "]"}],
                     "]"}], "&&", 
                    RowBox[{"NumericQ", "[", 
                    RowBox[{"temp$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "2"}], "]"}], "]"}],
                     "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$mass", "]"}]}], "}"}]}], 
                    "]"}], ",", "False"}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Beep", "[", "]"}], ";", 
                    RowBox[{"CreateDialog", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Mass and diagnal parts of MoI matrices should be \
positive number.\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}], ";"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", 
                    RowBox[{"save$mass", "=", "temp$mass"}], "]"}]}], "]"}]}],
                 "]"}], ",", 
               RowBox[{"(*", 
                RowBox[{"Save", " ", "Button"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{"\"\<Cancel\>\"", ",", 
                 RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
            "]"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
            RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"WindowElements", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
            ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WindowSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"700", ",", "500"}], "}"}]}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<1-2 Set Mass & MoI\>\""}]}], 
        "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567055520333172*^9, 3.5670555248434296`*^9}, {
   3.5670558779396257`*^9, 3.567055932130725*^9}, {3.567056182813063*^9, 
   3.567056187139311*^9}, 3.5670566443634624`*^9, {3.5670581487965107`*^9, 
   3.5670587302207665`*^9}, {3.567058803921982*^9, 3.5670588119104385`*^9}, {
   3.5670588537588325`*^9, 3.5670589617560096`*^9}, {3.567059001927307*^9, 
   3.567059019322302*^9}, {3.5670590584755416`*^9, 3.567059058761558*^9}, {
   3.5670593830151043`*^9, 3.567059434116027*^9}, {3.5670595428712473`*^9, 
   3.567059603217699*^9}, {3.567059707460662*^9, 3.5670597122009325`*^9}, {
   3.567060226661358*^9, 3.567060227207389*^9}, {3.5670606357247553`*^9, 
   3.5670606437432137`*^9}, 3.5670609417812605`*^9, 3.567061001332667*^9, {
   3.567061150497198*^9, 3.567061150770214*^9}, {3.5670613553849173`*^9, 
   3.567061355524925*^9}, {3.567061387575759*^9, 3.567061424517872*^9}, {
   3.5670633500420055`*^9, 3.5670633775415783`*^9}, 3.5670636045785637`*^9, {
   3.5670636804029007`*^9, 3.5670638187628145`*^9}, {3.5670638497815886`*^9, 
   3.567063928781107*^9}, 3.56706395907484*^9, {3.567063999954178*^9, 
   3.5670640061345315`*^9}, {3.5670640580745025`*^9, 3.5670641192009983`*^9}, 
   3.5670641706839433`*^9, {3.5670642353536425`*^9, 3.56706423967789*^9}, {
   3.567064314740183*^9, 3.56706433112612*^9}, {3.567064548991581*^9, 
   3.567064565017498*^9}, {3.567064611320146*^9, 3.567064612807231*^9}, {
   3.567064902398795*^9, 3.567065019369485*^9}, {3.567065596597501*^9, 
   3.5670656689066367`*^9}, {3.567065711905096*^9, 3.5670657416497974`*^9}, {
   3.5670657824121284`*^9, 3.5670658866440907`*^9}, {3.567065916858819*^9, 
   3.5670659470505457`*^9}, {3.5670659975034313`*^9, 3.567066003233759*^9}, {
   3.5670661904354663`*^9, 3.5670661955657597`*^9}, {3.5670663202768927`*^9, 
   3.567066324293123*^9}, {3.5670675069927692`*^9, 3.567067598707015*^9}, {
   3.5670676669759197`*^9, 3.56706801769998*^9}, {3.567068108545176*^9, 
   3.567068111212329*^9}, {3.5670682431428747`*^9, 3.5670683206973104`*^9}, {
   3.567068414414671*^9, 3.56706847541916*^9}, 3.5670686101768675`*^9, {
   3.5670686645959806`*^9, 3.567068669089237*^9}, {3.5670688623632917`*^9, 
   3.567068895080163*^9}, {3.5670689271639986`*^9, 3.5670691770242896`*^9}, {
   3.5670692500364656`*^9, 3.567069271147673*^9}, {3.5670693073207417`*^9, 
   3.567069469048992*^9}, {3.567069539006994*^9, 3.567069543327241*^9}, {
   3.567090487899534*^9, 3.5670905052035236`*^9}, {3.567091483629486*^9, 
   3.567091491153917*^9}, {3.5670987037624545`*^9, 3.5670987249196644`*^9}, {
   3.5670988066163373`*^9, 3.5670988275795364`*^9}, 3.5672318360226088`*^9, {
   3.5672318756848774`*^9, 3.5672318763709164`*^9}, {3.5672682685640163`*^9, 
   3.5672682806397066`*^9}, {3.56757862480637*^9, 3.5675786315697565`*^9}, {
   3.569956662215724*^9, 3.569956662775756*^9}, {3.570111098880911*^9, 
   3.570111229019355*^9}, {3.5701112930080147`*^9, 3.570111333427326*^9}, {
   3.5701115179308796`*^9, 3.5701115697008405`*^9}, {3.570111609715129*^9, 
   3.570111613905369*^9}, {3.570111682311281*^9, 3.570111960362185*^9}, {
   3.570111993455078*^9, 3.5701130609221334`*^9}, {3.570113098172264*^9, 
   3.5701131684722853`*^9}, {3.57011323098186*^9, 3.5701134073899508`*^9}, {
   3.570113438781746*^9, 3.570113472016647*^9}, 3.5701135733714437`*^9, {
   3.570117346523256*^9, 3.570117370587632*^9}, {3.5701174590056896`*^9, 
   3.57011751600895*^9}, {3.5701176756260796`*^9, 3.570117720781662*^9}, {
   3.570117785852384*^9, 3.5701180329145155`*^9}, {3.570118099153304*^9, 
   3.5701182520800505`*^9}, {3.5701182901072254`*^9, 3.570118367001624*^9}, {
   3.5701184361575794`*^9, 3.570118507201643*^9}, {3.570118616106872*^9, 
   3.570118869096342*^9}, {3.5701189181261463`*^9, 3.5701189631647224`*^9}, {
   3.5701190263013334`*^9, 3.5701191941779356`*^9}, {3.5701193124386997`*^9, 
   3.5701193450215635`*^9}, {3.5701193937343493`*^9, 
   3.5701193938583565`*^9}, {3.570123091038823*^9, 3.5701230918458695`*^9}, {
   3.5702570698650274`*^9, 3.570257070738629*^9}, {3.57025710549549*^9, 
   3.57025710560469*^9}, {3.570257152716773*^9, 3.5702571668971977`*^9}, {
   3.5702574571981077`*^9, 3.5702574573229074`*^9}, {3.5702578898494673`*^9, 
   3.570257900847487*^9}, {3.570258150747326*^9, 3.570258195675405*^9}, {
   3.5702865435847816`*^9, 3.570286623331343*^9}, {3.570286655882205*^9, 
   3.570286785118597*^9}, {3.5702870349238853`*^9, 3.5702870361549554`*^9}, {
   3.570287128345228*^9, 3.570287130766367*^9}, {3.5702875797850494`*^9, 
   3.570287581864168*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1-3 Set Body Shapes", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701197012959414`*^9, 3.570119715169735*^9}}],

Cell[CellGroupData[{

Cell["Create 3D shapes in the module", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701199716324034`*^9, 3.5701199995960026`*^9}, {
  3.5701200842258434`*^9, 3.570120086864994*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$Create3DShapeEx", "[", 
     RowBox[{"shp_", ",", "dim_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"mod$Create3DShape", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "shp", ",", "dim"}], 
       "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"+", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "0.0"}], ",", 
         RowBox[{"+", "0.0"}], ",", 
         RowBox[{"+", "0.0"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", 
     "}"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567101580216978*^9, 3.5671017881248703`*^9}, 
   3.570120003405221*^9, {3.5701200422844443`*^9, 3.570120043509515*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Body Shapes", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567268075509974*^9, 3.5672680797332153`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetBodyShapes", ":=", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"--", 
        RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
       RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been",
          " ", "set", " ", "yet"}], ",", " ", 
        RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Beep", "[", "]"}], ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Set Body Name First.\>\"", ",", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", 
              RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TextCell", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Set Appearance of Bodies\>\"", ",", "\[IndentingNewLine]", 
               "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Load"}]}], " ", 
              RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"len0", "=", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], ",", "len"}], 
              "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"ValueQ", "[", "save$shape", "]"}], ",", 
                RowBox[{
                 RowBox[{"len", "=", 
                  RowBox[{"Length", "[", "save$shape", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"len", "<", "len0"}], ",", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"temp$shape", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"save$shape", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Cuboid\>\"", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0.2", ",", 
                    RowBox[{"{", "5", "}"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"temp$shape", "=", 
                    RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
                ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"If", " ", "not"}], ",", " ", 
                  RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"temp$shape", "=", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\"\<Cuboid\>\"", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0.2", ",", 
                    RowBox[{"{", "5", "}"}]}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", "len0", "}"}]}], "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Logic"}]}], " ", "List", " ", "for", " ", 
                 RowBox[{"Opener", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"temp$shapeopn", "=", 
               RowBox[{"Table", "[", 
                RowBox[{"False", ",", 
                 RowBox[{"{", "len0", "}"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"--", 
                  RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                 RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Copy", " ", "&"}], " ", "Past"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$shapecopy", "=", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Paste\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "temp$shapecopy", "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", "temp$shapecopy"}]}],
                     "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Select", " ", "Menu"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "list$BodyShape"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Dimension", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"list$ShapeDimNote", "[", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", "Small"}], "]"}], 
                    "]"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "5"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "5"}], "}"}]}], "]"}]}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Opener", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Opener", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shapeopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Show", " ", "Image"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PaneSelector", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"False", "\[Rule]", "\"\<Show Image\>\""}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"True", "\[Rule]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Show", "[", 
                    RowBox[{
                    RowBox[{"Graphics3D", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"mod$Create3DShapeEx", "[", 
                    RowBox[{
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                    RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}]}],
                     "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$shapeopn", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}]}], 
                   "}"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                RowBox[{"TableHeadings", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{
                    "\"\<Copy\>\"", ",", "\"\<Paste\>\"", ",", 
                    "\"\<Select Shape\>\"", ",", "\"\<Dimension\>\"", ",", 
                    "\"\<\>\"", ",", "\"\<Appearance\>\""}], "}"}]}], 
                  "}"}]}]}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"--", 
                RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
              RowBox[{"Button", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"DialogReturn", "[", 
                  RowBox[{"save$shape", "=", "temp$shape"}], "]"}]}], "]"}], 
               ",", 
               RowBox[{"(*", 
                RowBox[{"Save", " ", "Button"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"Button", "[", 
                RowBox[{"\"\<Cancel\>\"", ",", 
                 RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
            "]"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
            RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"WindowElements", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
            ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WindowSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"700", ",", "500"}], "}"}]}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<1-3 Set Body Shapes\>\""}]}], 
        "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567055520333172*^9, 3.5670555248434296`*^9}, {
   3.5670558779396257`*^9, 3.567055932130725*^9}, {3.567056182813063*^9, 
   3.567056187139311*^9}, 3.5670566443634624`*^9, {3.5670581487965107`*^9, 
   3.5670587302207665`*^9}, {3.567058803921982*^9, 3.5670588119104385`*^9}, {
   3.5670588537588325`*^9, 3.5670589617560096`*^9}, {3.567059001927307*^9, 
   3.567059019322302*^9}, {3.5670590584755416`*^9, 3.567059058761558*^9}, {
   3.5670593830151043`*^9, 3.567059434116027*^9}, {3.5670595428712473`*^9, 
   3.567059603217699*^9}, {3.567059707460662*^9, 3.5670597122009325`*^9}, {
   3.567060226661358*^9, 3.567060227207389*^9}, {3.5670606357247553`*^9, 
   3.5670606437432137`*^9}, 3.5670609417812605`*^9, 3.567061001332667*^9, {
   3.567061150497198*^9, 3.567061150770214*^9}, {3.5670613553849173`*^9, 
   3.567061355524925*^9}, {3.567061387575759*^9, 3.567061424517872*^9}, {
   3.5670633500420055`*^9, 3.5670633775415783`*^9}, 3.5670636045785637`*^9, {
   3.5670636804029007`*^9, 3.5670638187628145`*^9}, {3.5670638497815886`*^9, 
   3.567063928781107*^9}, 3.56706395907484*^9, {3.567063999954178*^9, 
   3.5670640061345315`*^9}, {3.5670640580745025`*^9, 3.5670641192009983`*^9}, 
   3.5670641706839433`*^9, {3.5670642353536425`*^9, 3.56706423967789*^9}, {
   3.567064314740183*^9, 3.56706433112612*^9}, {3.567064548991581*^9, 
   3.567064565017498*^9}, {3.567064611320146*^9, 3.567064612807231*^9}, {
   3.567064902398795*^9, 3.567065019369485*^9}, {3.567065596597501*^9, 
   3.5670656689066367`*^9}, {3.567065711905096*^9, 3.5670657416497974`*^9}, {
   3.5670657824121284`*^9, 3.5670658866440907`*^9}, {3.567065916858819*^9, 
   3.5670659470505457`*^9}, {3.5670659975034313`*^9, 3.567066003233759*^9}, {
   3.5670661904354663`*^9, 3.5670661955657597`*^9}, {3.5670663202768927`*^9, 
   3.567066324293123*^9}, {3.5670675069927692`*^9, 3.567067598707015*^9}, {
   3.5670676669759197`*^9, 3.56706801769998*^9}, {3.567068108545176*^9, 
   3.567068111212329*^9}, {3.5670682431428747`*^9, 3.5670683206973104`*^9}, {
   3.567068414414671*^9, 3.56706847541916*^9}, 3.5670686101768675`*^9, {
   3.5670686645959806`*^9, 3.567068669089237*^9}, {3.5670688623632917`*^9, 
   3.567068895080163*^9}, {3.5670689271639986`*^9, 3.5670691770242896`*^9}, {
   3.5670692500364656`*^9, 3.567069271147673*^9}, {3.5670693073207417`*^9, 
   3.567069469048992*^9}, {3.567069539006994*^9, 3.567069543327241*^9}, {
   3.567090444980079*^9, 3.5670904649422207`*^9}, {3.5670905333541336`*^9, 
   3.567090563293846*^9}, {3.5670914503725843`*^9, 3.5670914592450914`*^9}, {
   3.5670915105160246`*^9, 3.567091618231185*^9}, {3.5670917137466483`*^9, 
   3.567091789984009*^9}, {3.5670918421489925`*^9, 3.5670918458102016`*^9}, {
   3.567092176110094*^9, 3.567092186929713*^9}, {3.5670922182145023`*^9, 
   3.567092241057809*^9}, {3.567092996697029*^9, 3.567093119393047*^9}, 
   3.5670931894590545`*^9, {3.5670932797072163`*^9, 3.5670935092773466`*^9}, {
   3.567093654951679*^9, 3.567093755084406*^9}, {3.5670937974358287`*^9, 
   3.567093799099924*^9}, {3.567093950472582*^9, 3.5670939796342497`*^9}, {
   3.5670941232434635`*^9, 3.5670941821438327`*^9}, 3.5670942179358797`*^9, {
   3.5670942556630373`*^9, 3.5670942593822503`*^9}, {3.5670942899519987`*^9, 
   3.567094307139982*^9}, {3.5670944897134247`*^9, 3.567094490188452*^9}, {
   3.567094547893752*^9, 3.5670946682946386`*^9}, {3.567095293093375*^9, 
   3.5670953103213606`*^9}, {3.567095348912568*^9, 3.5670954705565257`*^9}, {
   3.5670955036294174`*^9, 3.567095656592166*^9}, {3.5670957176716595`*^9, 
   3.567095773636861*^9}, {3.567095938562294*^9, 3.567096032784683*^9}, 
   3.567096063686451*^9, {3.567096100428552*^9, 3.5670962011343126`*^9}, {
   3.567096253801325*^9, 3.567096278110715*^9}, {3.567096358340304*^9, 
   3.5670963617594995`*^9}, {3.567096410583292*^9, 3.567096444675242*^9}, {
   3.567096610764742*^9, 3.5670966134628963`*^9}, {3.5670967938452134`*^9, 
   3.567096802363701*^9}, {3.567096909543831*^9, 3.567096918315333*^9}, {
   3.5670969603037343`*^9, 3.5670969632779045`*^9}, {3.567097011998691*^9, 
   3.5670970244844055`*^9}, {3.567097072088128*^9, 3.5670970914532356`*^9}, {
   3.5670976252167654`*^9, 3.5670976353923473`*^9}, {3.567097667903207*^9, 
   3.567097698838976*^9}, {3.567097759654454*^9, 3.5670978055200777`*^9}, {
   3.5670978510326815`*^9, 3.5670978549879074`*^9}, {3.5670980200573487`*^9, 
   3.5670980317550178`*^9}, {3.5670981970864744`*^9, 3.567098278614137*^9}, {
   3.5670983616778884`*^9, 3.567098363352984*^9}, {3.5670984308388443`*^9, 
   3.567098433270983*^9}, {3.5670985192048984`*^9, 3.5670985229391117`*^9}, 
   3.5670987370393577`*^9, {3.5670987972067995`*^9, 3.5670988009340124`*^9}, {
   3.5671003597491713`*^9, 3.567100380722371*^9}, {3.5671004184245276`*^9, 
   3.567100615730813*^9}, 3.567100651384852*^9, {3.567100687743932*^9, 
   3.567100745723248*^9}, {3.567101093120118*^9, 3.5671011546336365`*^9}, 
   3.5671011984991455`*^9, {3.5671012407245607`*^9, 3.5671012607477055`*^9}, {
   3.567101315767853*^9, 3.567101321784197*^9}, {3.567101520685573*^9, 
   3.5671015418017807`*^9}, {3.5671017771772437`*^9, 3.567101865103273*^9}, {
   3.567102415409748*^9, 3.5671024156377616`*^9}, {3.5671025468692675`*^9, 
   3.5671025910957975`*^9}, {3.567102639850586*^9, 3.5671026434807935`*^9}, {
   3.5671555645104213`*^9, 3.567155577049138*^9}, {3.567231564016051*^9, 
   3.5672316306178603`*^9}, {3.5672317404441423`*^9, 
   3.5672317876028395`*^9}, {3.567268316896781*^9, 3.567268327166368*^9}, {
   3.5699566628167586`*^9, 3.569956663219782*^9}, {3.570120195685219*^9, 
   3.5701207812767124`*^9}, {3.5701208136185627`*^9, 
   3.5701209070399055`*^9}, {3.570120967830383*^9, 3.5701210718123302`*^9}, {
   3.5701211230252595`*^9, 3.570121286418605*^9}, {3.570121451235032*^9, 
   3.5701214534801607`*^9}, {3.570121492571396*^9, 3.570121570347845*^9}, {
   3.570121610599147*^9, 3.570121615753442*^9}, {3.5701217066816425`*^9, 
   3.5701217151381264`*^9}, {3.5701218090534983`*^9, 
   3.5701218100085526`*^9}, {3.570122014081225*^9, 3.570122018817496*^9}, {
   3.5701220536414876`*^9, 3.570122068144317*^9}, {3.5701221195712585`*^9, 
   3.5701221461527786`*^9}, {3.570122181055775*^9, 3.5701222088593655`*^9}, {
   3.5701222496186967`*^9, 3.570122283015607*^9}, {3.570122349175391*^9, 
   3.5701223495274115`*^9}, {3.570122401672394*^9, 3.5701224179603252`*^9}, {
   3.57012247381752*^9, 3.570122500845066*^9}, {3.5701226102173223`*^9, 
   3.570122638198922*^9}, {3.5701227110780907`*^9, 3.5701227164043956`*^9}, {
   3.5701227529174843`*^9, 3.5701228089966917`*^9}, {3.570122867955064*^9, 
   3.57012286806607*^9}, {3.570122909389434*^9, 3.570122932557759*^9}, {
   3.570122969553875*^9, 3.570123010224201*^9}, {3.570123042501047*^9, 
   3.57012308380641*^9}, {3.570123188256384*^9, 3.57012354590584*^9}, {
   3.5701236827696686`*^9, 3.5701236929092484`*^9}, {3.570123780318248*^9, 
   3.570123793807019*^9}, {3.5701238574616604`*^9, 3.570123888868457*^9}, {
   3.5701239434995813`*^9, 3.5701239443786316`*^9}, {3.570123974630362*^9, 
   3.5701239880831313`*^9}, {3.570124055978015*^9, 3.5701240634244404`*^9}, {
   3.5701241075829663`*^9, 3.57012419121775*^9}, {3.570124242944709*^9, 
   3.5701242432127237`*^9}, {3.5701243902621346`*^9, 
   3.5701243903801413`*^9}, {3.570124426178189*^9, 3.570124427172246*^9}, 
   3.5701840374442415`*^9, {3.5702570709726295`*^9, 3.5702571045594883`*^9}, 
   3.570257457354108*^9, {3.570257506930995*^9, 3.5702575077733965`*^9}, 
   3.5702579193491197`*^9, 3.5702582835503592`*^9, {3.5702869473978786`*^9, 
   3.5702869745134296`*^9}, {3.57028705545706*^9, 3.5702870622254467`*^9}, {
   3.5702871481053586`*^9, 3.57028714987846*^9}, {3.5702875105590897`*^9, 
   3.570287513202241*^9}, {3.5702875878495107`*^9, 3.570287589608611*^9}, {
   3.570288479908533*^9, 3.5702884853008423`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1-4 Set Initial Position", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570855048759932*^9, 3.5708550551202955`*^9}}],

Cell[CellGroupData[{

Cell["set position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708550606736135`*^9, 3.570855062665727*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetInitPos", ":=", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"--", 
        RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
       RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been",
          " ", "set", " ", "yet"}], ",", " ", 
        RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Beep", "[", "]"}], ";", 
       RowBox[{"CreateDialog", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<Set Body Name First.\>\"", ",", 
           RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
         RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TextCell", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Set Initial Position of Rigid Bodies\>\"", ",", 
              "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
             "]"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Load"}]}], " ", 
             RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"len0", "=", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], ",", "len"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ValueQ", "[", "save$initpos", "]"}], ",", 
               RowBox[{
                RowBox[{"len", "=", 
                 RowBox[{"Length", "[", "save$initpos", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"len", "<", "len0"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"If", " ", "saved", " ", "list", " ", "exists"}], 
                    ",", " ", 
                    RowBox[{"load", " ", "it"}]}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$initpos", "=", 
                   RowBox[{"Join", "[", 
                    RowBox[{"save$initpos", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"len0", "-", "len"}], "}"}], ",", 
                    RowBox[{"{", "3", "}"}]}], "]"}]}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$initpos", "=", 
                   RowBox[{"save$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", "len0"}], "]"}], "]"}]}]}], "]"}]}], 
               ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"If", " ", "not"}], ",", " ", 
                 RowBox[{"create", " ", "new", " ", "one"}]}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"temp$initpos", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"{", "len0", "}"}], ",", 
                  RowBox[{"{", "3", "}"}]}], "]"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{
                RowBox[{"--", 
                 RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", "len0"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableAlignments", "\[Rule]", "Center"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"None", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Name\>\"", ",", "\"\<x [mm]\>\"", ",", 
                    "\"\<y [mm]\>\"", ",", "\"\<z [mm]\>\""}], "}"}]}], 
                    "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"Graphics3D", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"mod$Create3DShape", "[", 
                    RowBox[{
                    RowBox[{"temp$initpos", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$initpos", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                    RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"150", ",", "350"}], "}"}]}]}], "]"}], "]"}]}], 
                 "}"}], "}"}], "\[IndentingNewLine]", ",", 
               RowBox[{"TableAlignments", "\[Rule]", "Top"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{"{", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                RowBox[{"DialogReturn", "[", 
                 RowBox[{"(*", 
                  RowBox[{"Save", " ", "Button"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$initpos", "=", "temp$initpos"}], "]"}]}], 
               "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{"\"\<Cancel\>\"", ",", 
                RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
           "]"}]}], "}"}], ",", 
        RowBox[{"(*", 
         RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
           RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"WindowElements", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
           ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"WindowSize", "\[Rule]", "Automatic"}], ",", 
        RowBox[{
        "WindowTitle", "\[Rule]", "\"\<1-4 Set Initial Position\>\""}]}], 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566889731755993*^9, 3.5668897823058844`*^9}, {
   3.566889828859547*^9, 3.566889886714856*^9}, {3.5668899175776215`*^9, 
   3.5668901655738063`*^9}, {3.566890196972602*^9, 3.566890199961773*^9}, {
   3.5668903236848497`*^9, 3.5668903462531404`*^9}, {3.5668904168021755`*^9, 
   3.566890551243865*^9}, {3.566890625559116*^9, 3.566890628851304*^9}, {
   3.5668906610411453`*^9, 3.5668906778621073`*^9}, {3.566890768100269*^9, 
   3.566890784114185*^9}, {3.5668908451256742`*^9, 3.5668908877861147`*^9}, 
   3.566891015361411*^9, 3.566891047194232*^9, {3.566891183957054*^9, 
   3.5668912099195395`*^9}, {3.5668912400952654`*^9, 3.566891244621524*^9}, {
   3.5668915432576056`*^9, 3.5668915449367013`*^9}, {3.566891715968484*^9, 
   3.5668918358523407`*^9}, {3.5668918709093456`*^9, 
   3.5668919456306195`*^9}, {3.5668919801025915`*^9, 
   3.5668920205259037`*^9}, {3.5668921640831146`*^9, 
   3.5668921784709373`*^9}, {3.5669005192484193`*^9, 
   3.5669005275928965`*^9}, {3.566900766911585*^9, 3.5669007676166253`*^9}, {
   3.566900884500311*^9, 3.5669008846533194`*^9}, {3.5669009277877865`*^9, 
   3.5669009420656033`*^9}, {3.566900976717585*^9, 3.566900990180355*^9}, {
   3.5669011295833282`*^9, 3.566901154485753*^9}, {3.5669013452236624`*^9, 
   3.566901441446166*^9}, {3.5669015126182365`*^9, 3.566901578348996*^9}, {
   3.56690206340174*^9, 3.5669021167747927`*^9}, {3.5670472309350452`*^9, 
   3.5670472422206907`*^9}, {3.567049068330138*^9, 3.567049128459577*^9}, {
   3.567049167883832*^9, 3.5670491697939415`*^9}, {3.567049214166479*^9, 
   3.5670492154155507`*^9}, {3.567049277939127*^9, 3.567049311335037*^9}, {
   3.5670493673282394`*^9, 3.5670494751234055`*^9}, {3.5670495188559065`*^9, 
   3.5670495276194077`*^9}, {3.5670499046279716`*^9, 
   3.5670499125794263`*^9}, {3.5670500075978613`*^9, 3.567050082795162*^9}, {
   3.567050121957402*^9, 3.567050142257563*^9}, {3.5670502103874598`*^9, 
   3.567050320436754*^9}, {3.5670503781780567`*^9, 3.5670503853374662`*^9}, 
   3.567050423894672*^9, {3.5670506654214864`*^9, 3.5670506813283963`*^9}, {
   3.56705071234017*^9, 3.5670507706615057`*^9}, {3.567050872177312*^9, 
   3.567050989024996*^9}, {3.5670512359771204`*^9, 3.567051292753368*^9}, {
   3.567051650941855*^9, 3.5670516674888015`*^9}, {3.5670524229500113`*^9, 
   3.567052430582448*^9}, {3.5670524819683867`*^9, 3.567052544048938*^9}, {
   3.5670526884181952`*^9, 3.567052698854792*^9}, {3.567052773789078*^9, 
   3.5670528319914074`*^9}, 3.567052865848344*^9, {3.567053705189351*^9, 
   3.5670537075144844`*^9}, {3.567054056444442*^9, 3.567054063632853*^9}, {
   3.5670541466215997`*^9, 3.567054200316671*^9}, {3.567054378205846*^9, 
   3.5670546294832177`*^9}, {3.567054679642087*^9, 3.567054696184033*^9}, {
   3.5670547766336346`*^9, 3.5670547894463673`*^9}, {3.5670548916962156`*^9, 
   3.5670549191477857`*^9}, {3.5670563032379513`*^9, 3.567056423484829*^9}, {
   3.5670564615200043`*^9, 3.567056466460287*^9}, {3.567056530281937*^9, 
   3.5670566018970337`*^9}, {3.5670569741953278`*^9, 
   3.5670570850906706`*^9}, {3.567059166334711*^9, 3.5670592158985453`*^9}, {
   3.5670592793491745`*^9, 3.567059317689368*^9}, {3.567063087771004*^9, 
   3.5670630892320876`*^9}, {3.5670695474044743`*^9, 
   3.5670695492815814`*^9}, {3.5670988132317157`*^9, 3.5670988150248184`*^9}, 
   3.5672318299772635`*^9, {3.5675807247684803`*^9, 3.5675807249994936`*^9}, {
   3.5675809545326223`*^9, 3.567580954762635*^9}, {3.567583195411793*^9, 
   3.567583198890992*^9}, {3.5677724913907447`*^9, 3.5677724953469715`*^9}, {
   3.5699565775988846`*^9, 3.569956584503279*^9}, {3.569956662001712*^9, 
   3.5699566621487207`*^9}, {3.5699568606800756`*^9, 3.569956868180505*^9}, {
   3.569956970692368*^9, 3.569956971515415*^9}, {3.569957391410432*^9, 
   3.5699573941355877`*^9}, {3.570108567824143*^9, 3.570108571947379*^9}, {
   3.5701086204881554`*^9, 3.5701086333298893`*^9}, {3.570108671639081*^9, 
   3.570108769759693*^9}, {3.5701088095399685`*^9, 3.570108919817276*^9}, {
   3.5701089890182343`*^9, 3.570109147034272*^9}, {3.5701092402196016`*^9, 
   3.5701096738074017`*^9}, {3.5701097936652575`*^9, 
   3.5701099566595798`*^9}, {3.570110027697643*^9, 3.570110118155817*^9}, {
   3.5701101625923586`*^9, 3.5701102234848413`*^9}, {3.5701104149297915`*^9, 
   3.5701104659137077`*^9}, {3.5701104982435565`*^9, 
   3.5701105330135455`*^9}, {3.570110563092266*^9, 3.5701105957101316`*^9}, {
   3.57011071282583*^9, 3.5701107517620573`*^9}, {3.5701107860690193`*^9, 
   3.5701107892742023`*^9}, {3.5701108256222816`*^9, 
   3.5701109027606936`*^9}, {3.5701109455571413`*^9, 3.570110986883505*^9}, {
   3.570111044172782*^9, 3.570111048875051*^9}, {3.570117373417794*^9, 
   3.5701173736888094`*^9}, 3.5702570696466265`*^9, {3.57025710547989*^9, 
   3.570257131344735*^9}, 3.5702574571669073`*^9, {3.570257683322505*^9, 
   3.5702576836657057`*^9}, {3.5702578161879377`*^9, 
   3.5702578271391573`*^9}, {3.570258174272167*^9, 3.5702581759413705`*^9}, {
   3.5708550866380987`*^9, 3.5708551138786564`*^9}, {3.570855166882688*^9, 
   3.570855499589718*^9}, {3.570855561307248*^9, 3.570855683934262*^9}, {
   3.5708557194402924`*^9, 3.5708558090084157`*^9}, {3.5708559609121037`*^9, 
   3.5708559618801594`*^9}, {3.5708560326702085`*^9, 
   3.5708560507162404`*^9}, {3.5708560929396553`*^9, 
   3.5708561001480675`*^9}, {3.5708561439325724`*^9, 
   3.5708562367258797`*^9}, {3.5708588794250336`*^9, 
   3.5708588877475095`*^9}, {3.5708590995616245`*^9, 
   3.5708591056989756`*^9}, {3.5708592453199615`*^9, 
   3.5708592707004128`*^9}, {3.5708594662465973`*^9, 
   3.5708594683887205`*^9}, {3.570859593586881*^9, 3.5708596692262077`*^9}, {
   3.570859776865364*^9, 3.570859813602465*^9}, {3.5708598579119997`*^9, 
   3.570859874768964*^9}, {3.571748437943918*^9, 3.5717485503903503`*^9}, {
   3.5856953080847445`*^9, 3.585695312837016*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["1-L Show Body List", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701244725708427`*^9, 3.570124479552242*^9}, {
  3.570127979301416*^9, 3.57012797972544*^9}}],

Cell[CellGroupData[{

Cell["Show Body List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570124483440464*^9, 3.570124486847659*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ShowBodyList", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", 
    RowBox[{"Pane", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Body:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ValueQ", "[", "save$bdn", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "\"\<O\>\"", 
                   ",", "\"\<\>\""}], "]"}], ",", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}],
                    ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}],
                    ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "3", ",", "3"}], "]"}], "]"}],
                    ",", 
                   RowBox[{"save$mass", ";", "\"\<\>\""}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"ValueQ", "[", "save$shape", "]"}], ",", 
                   RowBox[{"save$shape", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"save$shape", ";", "\"\<\>\""}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Min", "[", 
                  RowBox[{
                   RowBox[{"Length", "[", "save$bdn", "]"}], ",", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$mass", "]"}], ",", 
                    RowBox[{"Length", "[", "save$mass", "]"}], ",", "30"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$shape", "]"}], ",", 
                    RowBox[{"Length", "[", "save$shape", "]"}], ",", "30"}], 
                    "]"}]}], "]"}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<GND\>\"", ",", "\"\<Name\>\"", ",", "\"\<M [kg]\>\"", 
                    ",", "\"\<Ixx [kgm2]\>\"", ",", "\"\<Iyy [kgm2]\>\"", 
                    ",", "\"\<Izz [kgm2]\>\"", ",", "\"\<Shape\>\""}], 
                   "}"}]}], "]"}]}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$bdn", ";", "\"\<No Data\>\""}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"640", ",", "200"}], "}"}]}], ",", 
      RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwdxVsoQwEABuClhSbRlBZSE7YoxpJLGgc1zQkhM/etEC02CYc9yCIeXIbC
SKRc5pJItjxY4QGRGB7J3aEwl9gL59/D18dX1eVUuLBYrCAG9rQ/PjSP0oTR
uOBKMVcWDXnjAK8pLh7xD+Fhd7nQefRbVyR+Lu91fpUijsGTwgMSs/UHcpzO
mVPiy7ufapyvlmvwr1bfgY8uprtwp0HVg0nHbB8+p2RTOLnx2Ywzl223WKOT
3uPPk0Qax9+9vGBrjccHljWzv3DNX3dwC7NI0CbApz5iCXbwBpMwabdJ8WKr
hMTJCroAV6WVKPCZam8Bc0neCq5ffVrDDRLOFraEak065uushCVMbOeu4uLl
XTM2RozsY3tgxyF23amdHzbSRA7fZsLqvpIKzjhN+Fv8KnESf0iNv1tfG3C/
2zuFx8yRLViTEduO4wyEc2vUWZjnBk2YpLHh+MZACcOZ2UpRGNbpmyLw6/qf
CMuO21JxQt58JrZuZSvwQPVTId7fPC7FDt+ZMjwhWanDt9SFFv8DnmAZPQ==

  "]]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2. Set Connection", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571490330353987*^9, 3.571490337102373*^9}}],

Cell[CellGroupData[{

Cell["2-0 Set Material", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570170752819404*^9, 3.5701707579336967`*^9}}],

Cell[CellGroupData[{

Cell["Material List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567573964046789*^9, 3.5675739700521326`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"list$Material", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Maraging Steel\>\"", ",", "8.0", ",", "195", ",", "0.3", ",", "1.",
        ",", 
       RowBox[{"-", "3"}], ",", "\"\<Virgo Data\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<C-70 Steel\>\"", ",", "7.8", ",", "200", ",", "0.3", ",", "3.", 
       ",", 
       RowBox[{"-", "4"}], ",", "\"\<LIGO-G050087-00\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Tungsten\>\"", ",", "19.3", ",", "411", ",", "0.28", ",", "1.", 
       ",", 
       RowBox[{"-", "4"}], ",", "\"\<Wikipedia\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Copper Beryllium\>\"", ",", "8.4", ",", "134", ",", "0.3", ",", 
       "5.", ",", 
       RowBox[{"-", "6"}], ",", "\"\<www.alb-copperalloys.com\>\""}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Sapphire\>\"", ",", "3.98", ",", "345", ",", "0.3", ",", "2.", ",", 
       RowBox[{"-", "7"}], ",", "\"\<www.crystalsystems.com\>\""}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Bolfur\>\"", ",", "7.6", ",", "157", ",", "0.3", ",", "1.", ",", 
       RowBox[{"-", "3"}], ",", "\"\<www.alb-copperalloys.com\>\""}], "}"}]}],
     "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5675739843249493`*^9, 3.5675740997565517`*^9}, {
   3.5675747052121816`*^9, 3.5675747080793457`*^9}, 3.567575071324122*^9, {
   3.5675777611419706`*^9, 3.5675778356582327`*^9}, {3.567577886800158*^9, 
   3.567577947608636*^9}, {3.5675786941133337`*^9, 3.5675787759100122`*^9}, {
   3.5675788174383874`*^9, 3.5675788491312003`*^9}, {3.5675788882594385`*^9, 
   3.5675790742260747`*^9}, {3.567616802799167*^9, 3.5676168088525133`*^9}, {
   3.5702873722531796`*^9, 3.5702873906102295`*^9}}],

Cell["\<\
** Poisson Ratio of the Maraging Steel Wire **
I adopt an abnormal PoissonR = 0.9 because it fits Virgo' s cables \
(assembled). The value is abnormal, maybe it 
depend on electrical cabling, but it fits the measurements and the lowest \
freq change is relevant for yaw.
We can decide to adopt standard 0.3 but expecting such a change once \
assembled.                    by E. Majorana\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.567574838073781*^9, 3.5675748721867323`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Material Parameters", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.5675792567965174`*^9, 3.567579291544505*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetMaterial", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Set Material Properties\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "Material", " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Button", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Resistrate New Material\>\"", ",", "White", ",", "Bold"}], 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"temp$mat", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\>\"", ",", "1.", ",", "100", ",", "0.3", ",", "1", ",", 
              RowBox[{"-", "3"}], ",", "\"\<\>\""}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Import"}]}], " ", 
           RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ValueQ", "[", "save$mat", "]"}], ",", 
           RowBox[{"temp$mat", "=", "save$mat"}], ",", 
           RowBox[{"temp$mat", "=", "list$Material"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ValueQ", "[", "save$wire", "]"}], ",", 
           RowBox[{"temp$wire", "=", "save$wire"}], ",", 
           RowBox[{"temp$wire", "=", 
            RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Main"}]}], " ", "Input", " ", 
            RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$mat", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$mat", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$mat", ",", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"15.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"2.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\"\<E\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"2.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
                  "}"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                  ",", "String", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"30.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "temp$mat", "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"TableHeadings", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"None", ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Name\>\"", ",", 
                 "\"\<Dens[g/cm3]\>\"", ",", "\"\<E [GPa]\>\"", ",", 
                 "\"\<Poisson\>\"", ",", "\"\<Loss\>\"", ",", 
                 "\"\<MEMO\>\""}], "}"}]}], "}"}]}]}], "]"}], 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
           RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"save$mat", "=", "temp$mat"}], "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", 
      RowBox[{"(*", 
       RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Set Material\>\""}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.5675792721453953`*^9, 3.5675794350997157`*^9}, 
   3.5675794753400173`*^9, {3.5675795142242413`*^9, 3.5675796910273542`*^9}, {
   3.5675797717049685`*^9, 3.567579856487818*^9}, {3.56758002367538*^9, 
   3.567580026804559*^9}, {3.567580104688014*^9, 3.567580112764476*^9}, {
   3.5675801536498146`*^9, 3.56758017332294*^9}, {3.5675802519094343`*^9, 
   3.567580256169678*^9}, {3.5675803848410378`*^9, 3.567580388537249*^9}, {
   3.567580462695491*^9, 3.5675804642105775`*^9}, {3.567580633812278*^9, 
   3.5675806558315372`*^9}, {3.567580993376844*^9, 3.5675811181659813`*^9}, {
   3.5675811663287363`*^9, 3.5675811984375725`*^9}, {3.5675812373267975`*^9, 
   3.567581244840227*^9}, {3.567581335587417*^9, 3.567581341198738*^9}, {
   3.567581394187769*^9, 3.567581437810264*^9}, {3.56758176153078*^9, 
   3.5675817626978464`*^9}, {3.5675817992679386`*^9, 3.567581819547098*^9}, {
   3.567582484090108*^9, 3.5675825735412245`*^9}, {3.5675826180937724`*^9, 
   3.5675826200208826`*^9}, {3.567583092284895*^9, 3.567583096783152*^9}, {
   3.567583213499828*^9, 3.5675832931993866`*^9}, {3.5675833260542655`*^9, 
   3.567583364409459*^9}, {3.567583426525012*^9, 3.5675834639271517`*^9}, {
   3.5675835994159007`*^9, 3.5675835995829105`*^9}, 3.5675836382421217`*^9, {
   3.5699566632557836`*^9, 3.5699566634797964`*^9}, {3.5701327414847975`*^9, 
   3.570132746904107*^9}, {3.5701328218923965`*^9, 3.570132825665612*^9}, {
   3.5701712102365665`*^9, 3.570171251187909*^9}, {3.5701713221899705`*^9, 
   3.5701713935300508`*^9}, {3.5701714284570484`*^9, 
   3.5701715055774593`*^9}, {3.5701715377903023`*^9, 
   3.5701715763345065`*^9}, {3.5701717276001587`*^9, 
   3.5701719152758927`*^9}, {3.5701719925633135`*^9, 
   3.5701719948924465`*^9}, {3.570172098504373*^9, 3.5701721000264597`*^9}, {
   3.570172133854395*^9, 3.570172173845682*^9}, {3.570172222452462*^9, 
   3.570172227882773*^9}, {3.5701722675450416`*^9, 3.5701723822065997`*^9}, {
   3.5701724458952427`*^9, 3.5701724698236113`*^9}, {3.570172566338132*^9, 
   3.5701725975879188`*^9}, {3.570172633431969*^9, 3.5701726363571367`*^9}, {
   3.57017272785737*^9, 3.5701727320406094`*^9}, {3.5701729609917045`*^9, 
   3.570172986997192*^9}, {3.5701730251143723`*^9, 3.5701730519509068`*^9}, {
   3.5702570625486145`*^9, 3.5702570638746166`*^9}, {3.570257104606288*^9, 
   3.5702571047154884`*^9}, {3.570257187411234*^9, 3.5702572188452888`*^9}, {
   3.570257457369708*^9, 3.5702574574165077`*^9}, {3.5702579329055433`*^9, 
   3.570257950221574*^9}, {3.5702582112286325`*^9, 3.5702582234278536`*^9}, {
   3.5702583286500387`*^9, 3.570258336356452*^9}, {3.5702872099448957`*^9, 
   3.5702872270088716`*^9}, {3.5702872696663113`*^9, 
   3.5702873403273535`*^9}, {3.5702875968200235`*^9, 3.5702875983371105`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-1 Set Wires", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701197337367964`*^9, 3.570119744717425*^9}}],

Cell[CellGroupData[{

Cell["Set Wires", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetWires", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "&&", 
       RowBox[{"ValueQ", "[", "save$shape", "]"}]}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been", 
        " ", "set", " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Registrate Bodies First.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
       "*", "Version", " ", 
       RowBox[{
       "1.2", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "Wire", " ", "Version", " ", "1.2", " ", "Compriance", " ", "Check"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"save$wire2", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "5"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"save$wire2", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "0."}], "]"}]}], 
          "]"}], ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$wire2", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
        "*", "Version", " ", 
        RowBox[{
        "1.2", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
          "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tabviewwire", "=", "1"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", 
               RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"TextCell", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Set Wires\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
               "Italic", ",", "Black"}], "]"}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"0.6", ",", "1.0", ",", "0.6"}], "]"}]}]}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "New"}]}], " ", "Wire", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Create New Wires\>\"", ",", "Bold", ",", "White"}], 
                 "]"}], ",", "mod$NewWires", ",", "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<Set Material Properties\>\"", ",", "Bold", ",", "Black",
                   ",", "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], 
                ",", 
                RowBox[{"Background", "\[Rule]", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"TabView", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Edit Each Wire\>\"", ",", "Bold"}], "]"}], 
               "\[Rule]", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Load"}]}], " ", 
                    RowBox[{"Lists", "--"}]}], "-"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Not", "[", 
                    RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
                    RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$wire", "]"}], ",", 
                    RowBox[{"temp$wire", "=", "save$wire"}], ",", 
                    RowBox[{"temp$wire", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Input"}]}], " ", "Field", " ", 
                    RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Delete", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$wire", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$wire", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$wire", ",", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Name", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "SP"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "SP"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Material", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "4"}], "]"}], 
                    "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    "\"\<E\>\"", ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
                    "]"}], "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Length", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Diameter", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Neck", " ", "L"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Neck", " ", "D"}], "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Tension", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "Clamp", " ", "Vector"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "11", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "Clamp", " ", "Vector"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "12", ",", "m"}], "]"}], "]"}], "]"}]}],
                     "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Longitudinal", " ", "Stiffness"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "14"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Torsional", " ", "Stiffness"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "15"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$wire", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"None", ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Name\>\"", 
                    ",", "\"\<U Body\>\"", ",", "\"\<U Clamp Pos [mm]\>\"", 
                    ",", "\"\<L Body\>\"", ",", "\"\<L Clamp Pos [mm]\>\"", 
                    ",", "\"\<Mat\>\"", ",", "\[IndentingNewLine]", 
                    "\"\<E [GPa]\>\"", ",", "\"\<Poission R\>\"", ",", 
                    "\"\<Loss [rad]\>\"", ",", "\"\<L [m]\>\"", ",", 
                    "\"\<D [mm]\>\"", ",", "\"\<NL [mm]\>\"", ",", 
                    "\"\<ND [mm]\>\"", ",", "\"\<T [N]\>\"", ",", 
                    "\[IndentingNewLine]", "\"\<Upper Clamp Direction\>\"", 
                    ",", "\"\<Lower Clamp Direction\>\"", ",", 
                    "\"\<ks [N/m]\>\"", ",", "\"\<kt [Nm/rad]\>\""}], "}"}]}],
                     "}"}]}]}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
                    RowBox[{"Button", "--"}]}], "-"}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"TableForm", "[", 
                   RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"save$wire", "=", "temp$wire"}], ";", 
                    RowBox[{"save$wire2", "=", "temp$wire2"}], ";"}], ")"}], 
                    "]"}]}], "]"}], ",", 
                    RowBox[{"(*", 
                    RowBox[{"Save", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", 
                    RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], 
                    "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
              ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"WIRE", " ", "LIST", " ", "2"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Edit Wire Connection\>\"", ",", "Bold"}], "]"}], 
               "\[Rule]", "\[IndentingNewLine]", 
               RowBox[{"TableForm", "[", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"--", 
                    RowBox[{"-", "Load"}]}], " ", 
                    RowBox[{"Lists", "--"}]}], "-"}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ValueQ", "[", "save$wire2", "]"}], ",", 
                    RowBox[{"temp$wire2", "=", "save$wire2"}], ",", 
                    RowBox[{"temp$wire2", "=", 
                    RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]",
                    "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Delete", " ", "Button"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$wire2", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$wire2", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$wire2", ",", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditWires", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Wire", " ", "Number"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Upper", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Lower", " ", "Body"}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{"Suspension", " ", "Point", " ", "Parameters"}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}]}]}], ")"}], "&"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "6"}], "}"}]}], "]"}], "}"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Material", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", "Length", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "1"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Diameter", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "2"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Tension", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wire2", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "temp$wire2", "]"}]}], "}"}]}], 
                    "]"}], ",", 
                    RowBox[{"TableHeadings", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"None", ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Edit\>\"", 
                    ",", "\"\<Num\>\"", ",", "\"\<U Body\>\"", ",", 
                    "\"\<L Body\>\"", ",", 
                    "\"\<Clamp Position Parameters [mm]\>\"", ",", 
                    "\"\<Material\>\"", ",", "\[IndentingNewLine]", 
                    "\"\<L [m]\>\"", ",", "\"\<D [mm]\>\"", ",", 
                    "\"\<T [N]\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}], 
                  ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"TableForm", "[", 
                   RowBox[{"{", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Reflect Changes to Wire List\>\"", ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"(", 
                    RowBox[{"mod$ReflectWires", ";", 
                    RowBox[{"tabviewwire", "=", "1"}], ";"}], ")"}]}], "]"}], 
                    "}"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "}"}], "]"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{"Dynamic", "[", "tabviewwire", "]"}]}], "]"}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
           RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"WindowElements", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
           ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
        RowBox[{"WindowSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"800", ",", "500"}], "}"}]}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<2-1 Set Wires\>\""}]}], 
       "]"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701955273954287`*^9, 
   3.5701955277364483`*^9}, {3.570216424314905*^9, 3.570216442094922*^9}, {
   3.5702566636907125`*^9, 3.570256665968316*^9}, {3.5702570641086173`*^9, 
   3.57025706566862*^9}, {3.5702571047466884`*^9, 3.5702571049494886`*^9}, {
   3.5702572278309045`*^9, 3.570257263773368*^9}, {3.5702574574633083`*^9, 
   3.5702574577129087`*^9}, {3.5702579587703886`*^9, 3.570257998924859*^9}, {
   3.5702582260174584`*^9, 3.570258233255871*^9}, {3.5702583058115983`*^9, 
   3.570258307948802*^9}, 3.570258349242075*^9, {3.5702875373536224`*^9, 
   3.5702875654512296`*^9}, {3.5702876290248656`*^9, 3.570287645410803*^9}, {
   3.5702879106109715`*^9, 3.570287971276441*^9}, {3.5702880162440133`*^9, 
   3.5702880371722107`*^9}, {3.570302318259042*^9, 3.570302383474772*^9}, {
   3.570302423439058*^9, 3.570302543292913*^9}, {3.5703037621316266`*^9, 
   3.5703037641937447`*^9}, {3.5709809514120283`*^9, 
   3.5709810215690413`*^9}, {3.571491709991898*^9, 3.5714917125750456`*^9}, {
   3.585713407444968*^9, 3.5857139025842886`*^9}, {3.585713991655383*^9, 
   3.5857141381857643`*^9}, {3.585714200102306*^9, 3.585714246440956*^9}, {
   3.5857142942306895`*^9, 3.585714340970363*^9}, {3.5857143984616513`*^9, 
   3.585714471482828*^9}, {3.5857145056757836`*^9, 3.585714558619812*^9}, {
   3.585714699360862*^9, 3.5857147096874523`*^9}, {3.585714903828557*^9, 
   3.585714910281926*^9}, {3.5857149624689107`*^9, 3.585714976281701*^9}, {
   3.5857150109826856`*^9, 3.5857150882961073`*^9}, {3.5857157845339303`*^9, 
   3.5857157919533544`*^9}, {3.5857158434823017`*^9, 3.585715889940959*^9}, 
   3.5857160224865403`*^9, {3.5857161840357804`*^9, 3.5857161928262835`*^9}, {
   3.585716318953497*^9, 3.5857163270899625`*^9}, {3.585887815347185*^9, 
   3.585887826895846*^9}, {3.585887861317815*^9, 3.585887865136033*^9}, {
   3.5878137175816503`*^9, 3.5878137249660726`*^9}, 3.5878160707982464`*^9, 
   3.5894240365879784`*^9, {3.5907767113102818`*^9, 3.5907767372627664`*^9}, {
   3.590776772709794*^9, 3.5907767872526255`*^9}, {3.5907768389905853`*^9, 
   3.590776870939412*^9}, {3.5907770667226105`*^9, 3.590777079637349*^9}, {
   3.590777790893031*^9, 3.5907777926771326`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit wire", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.585715102063895*^9, 3.5857151025759244`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditWires", "[", "nw_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Wires\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Import"}]}], " ", "Material", " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
          RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "wire", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"temp$newwire", "=", 
         RowBox[{"temp$wire2", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Number"}]}], " ", "of", " ", 
           RowBox[{"Wires", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<How many wires for suspension?\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Attached"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set attaching bodies\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Upper body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Lower body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Clamp"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set clamp position\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "1", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"Version", " ", "1.2"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TableForm", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ")"}], "&"}]}], 
                    "]"}]}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Enabled", "\[Rule]", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}], 
                    "]"}], "]"}]}], "]"}]}]}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"3", "D", " ", "Graphics"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
               "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "Infinity", ",", "0"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Select"}]}], " ", 
          RowBox[{"Material", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Select Material\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set Material Properties\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"PopupMenu", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"n", "\[Rule]", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
              "]"}], ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "4"}], "]"}], "]"}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "5"}], "]"}], "]"}], 
                  "]"}], ",", "\"\<E\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "6"}], "]"}], "]"}], 
                  "]"}]}], "}"}], "}"}], "]"}]}], "}"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Material\>\"", ",", "\"\<Young [GPa]\>\"", ",", 
               "\"\<Poisson\>\"", ",", "\"\<Loss [rad]\>\""}], "}"}]}], 
            "}"}]}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Dimension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Wire Dimension\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Variable Thickness\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "6"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Wire Length with Tension\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", "meter"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "meter"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], ",", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Length [m]\>\"", ",", "\"\<Diam [mm]\>\"", ",", 
              "\"\<Neck L[mm]\>\"", ",", "\"\<Neck D[mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Stiffness", "--"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Wire Dimension\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireStiff", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "\"\<Longitudinal Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Torsional Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Nm/rad\>\""}], "\[IndentingNewLine]", "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Tension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Tension on Each Wire\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate From Suspended Mass\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireTension", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<N\>\"", 
           ",", "\[IndentingNewLine]", "\"\<(\>\"", ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "7", "]"}], "]"}], "/", "g"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "g"}]}], ")"}], "&"}]}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kgw)\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Wire", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Finish\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$wire2", "[", 
                RowBox[{"[", "nw", "]"}], "]"}], "=", "temp$newwire"}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"800", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Wire Registration\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.57019536883836*^9, 
   3.5701953742146673`*^9}, {3.5701954808607674`*^9, 
   3.5701954946425557`*^9}, {3.5702570659338207`*^9, 
   3.5702570660898204`*^9}, {3.570257104996289*^9, 3.570257105136689*^9}, {
   3.5702572681569757`*^9, 3.5702572939282207`*^9}, {3.5702574577909083`*^9, 
   3.5702574579313087`*^9}, {3.57025800494647*^9, 3.5702580258193064`*^9}, {
   3.57025823832588*^9, 3.5702582468278947`*^9}, 3.5702583104604063`*^9, {
   3.5702877658946943`*^9, 3.570287780072505*^9}, {3.570287843959159*^9, 
   3.5702878457942643`*^9}, {3.5702884671558037`*^9, 
   3.5702884672758107`*^9}, {3.5703042639543295`*^9, 3.570304319841526*^9}, {
   3.5709795615205307`*^9, 3.5709797878724775`*^9}, {3.5709798430276327`*^9, 
   3.570979885228046*^9}, {3.5709804815281525`*^9, 3.570980483118243*^9}, {
   3.5857151050440655`*^9, 3.585715189546899*^9}, {3.5907769788735857`*^9, 
   3.5907769917693233`*^9}, {3.5907771163234477`*^9, 3.5907771215517464`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New wire", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewWires", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Wires\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Import"}]}], " ", "Material", " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
          RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "wire", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"temp$newwire", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "2", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "5."}], "mm"}], ",", 
             RowBox[{"5.", "mm"}], ",", 
             RowBox[{"200.", "mm"}], ",", 
             RowBox[{"50.", "mm"}], ",", "0.", ",", 
             RowBox[{"0.", "mm"}]}], "}"}], ",", "1", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1.", "meter"}], ",", 
             RowBox[{"1.", "mm"}], ",", 
             RowBox[{"20.", "mm"}], ",", 
             RowBox[{"1.", "mm"}], ",", "False", ",", "True"}], "}"}], ",", 
           "0.", ",", 
           RowBox[{"{", 
            RowBox[{"0.", ",", "0."}], "}"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Number"}]}], " ", "of", " ", 
           RowBox[{"Wires", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<How many wires for suspension?\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Attached"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set attaching bodies\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Upper body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Lower body:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Clamp"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set clamp position\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "1", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"Version", " ", "1.2"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TableForm", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"InputField", "[", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "n"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "mm", ",", "mm", ",", "mm", ",", "mm", ",", "deg", ",", 
                    "mm"}], "}"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], ")"}], "&"}]}], 
                    "]"}]}], "]"}], ",", "Number", ",", 
                  RowBox[{"FieldSize", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"4.", ",", "1."}], "}"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Enabled", "\[Rule]", 
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"Not", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"mod$SPNoteList", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}], 
                    "]"}], "]"}]}], "]"}]}]}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"3", "D", " ", "Graphics"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
               "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"Graphics3D", "[", 
               RowBox[{"mod$DrawWires", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ViewPoint", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "Infinity", ",", "0"}], "}"}]}], ",", 
                  RowBox[{"ViewVertical", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}], "]"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Select"}]}], " ", 
          RowBox[{"Material", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Select Material\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.8", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Set Material Properties\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "mod$SetMaterial", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"PopupMenu", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"n", "\[Rule]", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
              "]"}], ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", "5", "]"}], "]"}], ",", "4"}], "]"}], "]"}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "5"}], "]"}], "]"}], 
                  "]"}], ",", "\"\<E\>\"", ",", "\[IndentingNewLine]", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"save$mat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], ",", "6"}], "]"}], "]"}], 
                  "]"}]}], "}"}], "}"}], "]"}]}], "}"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Material\>\"", ",", "\"\<Young [GPa]\>\"", ",", 
               "\"\<Poisson\>\"", ",", "\"\<Loss [rad]\>\""}], "}"}]}], 
            "}"}]}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Dimension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Wire Dimension\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Variable Thickness\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newwire", "[", 
              RowBox[{"[", 
               RowBox[{"6", ",", "6"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Wire Length with Tension\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", "meter"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "meter"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], "/", "mm"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Enabled", "\[Rule]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "5"}], "]"}], "]"}], "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], ",", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"None", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Length [m]\>\"", ",", "\"\<Diam [mm]\>\"", ",", 
              "\"\<Neck L[mm]\>\"", ",", "\"\<Neck D[mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Stiffness", "--"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Wire Dimension\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireStiff", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "\"\<Longitudinal Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Torsional Stiffness:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}], "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"7.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Nm/rad\>\""}], "\[IndentingNewLine]", "}"}]}], "}"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Tension", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Tension on Each Wire\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate From Suspended Mass\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "mod$CalcWireTension", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<N\>\"", 
           ",", "\[IndentingNewLine]", "\"\<(\>\"", ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", "7", "]"}], "]"}], "/", "g"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "g"}]}], ")"}], "&"}]}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kgw)\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Wire", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "mod$CreateWires", "]"}]}], "]"}], 
           ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"800", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Wire Registration\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.57019536883836*^9, 
   3.5701953742146673`*^9}, {3.5701954808607674`*^9, 
   3.5701954946425557`*^9}, {3.5702570659338207`*^9, 
   3.5702570660898204`*^9}, {3.570257104996289*^9, 3.570257105136689*^9}, {
   3.5702572681569757`*^9, 3.5702572939282207`*^9}, {3.5702574577909083`*^9, 
   3.5702574579313087`*^9}, {3.57025800494647*^9, 3.5702580258193064`*^9}, {
   3.57025823832588*^9, 3.5702582468278947`*^9}, 3.5702583104604063`*^9, {
   3.5702877658946943`*^9, 3.570287780072505*^9}, {3.570287843959159*^9, 
   3.5702878457942643`*^9}, {3.5702884671558037`*^9, 
   3.5702884672758107`*^9}, {3.5703042639543295`*^9, 3.570304319841526*^9}, {
   3.5709795615205307`*^9, 3.5709797878724775`*^9}, {3.5709798430276327`*^9, 
   3.570979885228046*^9}, {3.5709804815281525`*^9, 3.570980483118243*^9}, 
   3.590777229882943*^9, {3.5907773249873824`*^9, 3.5907773271805077`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Wire Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570979796106949*^9, 3.57097980067021*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcWireStiff", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"temp$newwire", "[", 
       RowBox[{"[", 
        RowBox[{"8", ",", "1"}], "]"}], "]"}], "=", 
      RowBox[{
       RowBox[{"save$mat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
       RowBox[{"GPa", "/", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", 
            RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
               RowBox[{"2", "*", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "3"}], "]"}], "]"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"N", "[", "Pi", "]"}], "*", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "2"}], "/", 
                "4"}]}], ")"}]}], "+", "\[IndentingNewLine]", 
            RowBox[{"2", "*", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", 
                RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"N", "[", "Pi", "]"}], "*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "^", "2"}], "/", 
                 "4"}]}], ")"}]}]}]}], ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", 
              RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"N", "[", "Pi", "]"}], "*", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "2"}], "/", 
               "4"}]}], ")"}]}], ")"}]}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"temp$newwire", "[", 
       RowBox[{"[", 
        RowBox[{"8", ",", "2"}], "]"}], "]"}], "=", 
      RowBox[{
       RowBox[{"save$mat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "5", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
       RowBox[{
        RowBox[{
         RowBox[{"GPa", "/", "2"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"save$mat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "5", "]"}], "]"}], ",", "4"}], "]"}], "]"}]}], 
          ")"}]}], "/", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", 
            RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
               RowBox[{"2", "*", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "3"}], "]"}], "]"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"N", "[", "Pi", "]"}], "*", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "4"}], "/", 
                "32"}]}], ")"}]}], "+", "\[IndentingNewLine]", 
            RowBox[{"2", "*", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", 
                RowBox[{"6", ",", "3"}], "]"}], "]"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"N", "[", "Pi", "]"}], "*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], "^", "4"}], "/", 
                 "32"}]}], ")"}]}]}]}], ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", 
              RowBox[{"6", ",", "1"}], "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"N", "[", "Pi", "]"}], "*", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"6", ",", "2"}], "]"}], "]"}], "^", "4"}], "/", 
               "32"}]}], ")"}]}], ")"}]}], "]"}]}]}]}], ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5709798033593636`*^9, 3.5709798038553915`*^9}, {
  3.5709799682387943`*^9, 3.570980099580306*^9}, {3.570980154143427*^9, 
  3.5709803245071716`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Suspension Point Note List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701741454214497`*^9, 3.5701741607833285`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$SPNoteList", "[", "num_", "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"num", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", "\"\<\>\"", ",", "\"\<\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"num", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", 
        "\"\<X-distance between upper SP & upper body's COM [mm]\>\"", ",", 
        "\[IndentingNewLine]", 
        "\"\<X-distance between lower SP & lower body's COM [mm]\>\"", ",", 
        "\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"num", "\[Equal]", "3"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", 
        "\"\<Horizontal radial distance from body's COM [mm]\>\"", ",", 
        "\"\<\>\"", ",", "\[IndentingNewLine]", 
        "\"\<Rotation angle in the horizontal plane [deg]\>\"", ",", 
        "\"\<\>\""}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"num", "\[Equal]", "4"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Vertical position of upper SP wrt upper body's CoM [mm]\>\"", ",",
         "\[IndentingNewLine]", 
        "\"\<Vertical position of lower SP wrt lower body's CoM [mm]\>\"", 
        ",", "\[IndentingNewLine]", "\"\<X-distance from body's COM [mm]\>\"",
         ",", "\[IndentingNewLine]", 
        "\"\<Z-distance from body's COM [mm]\>\"", ",", "\"\<\>\"", ",", 
        "\[IndentingNewLine]", 
        "\"\<Upper SP Z-translation from COM [mm]\>\""}], "}"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570174101156918*^9, 3.570174116435792*^9}, {
   3.570174188575918*^9, 3.5701745819814196`*^9}, {3.570174618259495*^9, 
   3.5701747329990573`*^9}, 3.5701797121388483`*^9, {3.5701828840252695`*^9, 
   3.570182940029473*^9}, {3.5907771515694637`*^9, 3.5907771962380185`*^9}, {
   3.590777903683482*^9, 3.590777910876893*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Wire Tension", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570182016943675*^9, 3.570182019214805*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcWireTension", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Check the masses suspended below the wires:\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Logic"}]}], " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$wten", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Check"}]}], " ", "List", " ", "for", " ", 
           RowBox[{"Calculation", "--"}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Checkbox", "[", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$wten", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                ",", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Calculator", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Total Mass:\>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"temp$wten", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{"save$mass", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
            "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"N", "[", 
                 RowBox[{"Sum", "[", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$wten", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                  "]"}], "]"}], "*", 
                RowBox[{
                 RowBox[{"g", "/", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "/", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                   "1"}], "]"}]}]}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "200"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Set Material\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567619871576691*^9, 3.5676198722027273`*^9}, {
  3.567619997598899*^9, 3.5676203137319813`*^9}, {3.5676203764675694`*^9, 
  3.5676206381485367`*^9}, {3.5676208095553403`*^9, 3.567620820959993*^9}, {
  3.567621207597107*^9, 3.5676212144885015`*^9}, {3.5676230352136407`*^9, 
  3.567623041119979*^9}, {3.567623212578786*^9, 3.5676232129498067`*^9}, {
  3.5676236755552664`*^9, 3.567623675748277*^9}, {3.5699566678150444`*^9, 
  3.5699566678410463`*^9}, {3.5701820424861364`*^9, 3.570182046428362*^9}, {
  3.570182090922907*^9, 3.570182221552378*^9}, {3.570182279862713*^9, 
  3.570182436566676*^9}, {3.57018247439384*^9, 3.57018257824578*^9}, {
  3.5701826349120207`*^9, 3.5701826645597167`*^9}, {3.5701826995467176`*^9, 
  3.5701827056060643`*^9}, {3.5703039054448233`*^9, 3.5703039907997055`*^9}, {
  3.570304040115526*^9, 3.5703041123386574`*^9}, {3.5703042363787518`*^9, 
  3.570304236488758*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Create Wire", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567099102884283*^9, 3.567099110037692*^9}, {
  3.5670992402151375`*^9, 3.56709925476797*^9}, {3.567573948274887*^9, 
  3.5675739511100492`*^9}, {3.567579173882775*^9, 3.567579176994953*^9}, {
  3.5675792201244197`*^9, 3.567579224485669*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CreateWires", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP1wire", "[", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP1wire", "[", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP2wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP2wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"normalize", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "]"}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"-", 
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}]}], ",", "0"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"normalize", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"+", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "]"}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}], ",", "0"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newwire", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"mod$SP4wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{"Version", " ", "1.2"}], "*)"}], "+", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "6"}], "]"}], "]"}]}], "}"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"mod$SP4wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", "7", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                "<>", "\"\<-\>\"", "<>", 
                RowBox[{"ToString", "[", "n", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"temp$newwire", "[", 
                RowBox[{"[", 
                 RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           ";"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "4"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"temp$wire2", ",", "temp$newwire"}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567618157334642*^9, 3.567618258146408*^9}, {
   3.567618355662986*^9, 3.567618461073015*^9}, {3.567618491184737*^9, 
   3.5676185795717926`*^9}, {3.567618624034336*^9, 3.5676186266424847`*^9}, {
   3.5676187344916534`*^9, 3.5676187401169753`*^9}, {3.567618896051894*^9, 
   3.567618972341258*^9}, {3.5676191966360865`*^9, 3.5676195070508413`*^9}, 
   3.567619592230714*^9, {3.5676198814002533`*^9, 3.567619987000293*^9}, {
   3.567621351097315*^9, 3.567621408168579*^9}, {3.567623199136017*^9, 
   3.5676232109566927`*^9}, {3.5699566678530464`*^9, 3.569956669069116*^9}, {
   3.5701903245018406`*^9, 3.570190480182745*^9}, {3.570190589032971*^9, 
   3.5701907067267027`*^9}, {3.570190747578039*^9, 3.57019079549678*^9}, {
   3.5701908712851143`*^9, 3.570190932990644*^9}, {3.5701915114917326`*^9, 
   3.5701915852189493`*^9}, {3.570191853197277*^9, 3.570191870340257*^9}, {
   3.570192092464962*^9, 3.5701921016844893`*^9}, {3.5701921626209745`*^9, 
   3.570192223443454*^9}, {3.570302578468925*^9, 3.57030262682069*^9}, {
   3.5703027102984653`*^9, 3.5703027446594305`*^9}, {3.5703029463839684`*^9, 
   3.5703030484998093`*^9}, 3.570303087227024*^9, {3.570303123898122*^9, 
   3.570303130546502*^9}, {3.5703032863314123`*^9, 3.5703033136609755`*^9}, {
   3.5703035871816196`*^9, 3.5703036585237007`*^9}, {3.5709805445897593`*^9, 
   3.57098071541553*^9}, {3.570981455965887*^9, 3.57098146003712*^9}, {
   3.57098150251355*^9, 3.5709815068317966`*^9}, {3.5857146194552917`*^9, 
   3.585714662110731*^9}, 3.5857160733314486`*^9, {3.590777616816074*^9, 
   3.590777618712182*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Reflect Changes to Wire List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857147485516753`*^9, 3.5857147508178053`*^9}, {
  3.585714873905845*^9, 3.5857148802872105`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ReflectWires", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "temp$newwire", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"temp$wire", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"temp$newwire", "=", 
          RowBox[{"temp$wire2", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP1wire", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP1wire", "[", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                  RowBox[{
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", 
                   RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], 
               "\[IndentingNewLine]", "]"}], ";"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP2wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP2wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"normalize", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "]"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}]}], ",", "0"}], "}"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"normalize", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"n", "\[Equal]", "1"}], ",", 
                    RowBox[{"+", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "]"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "^", "2"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], "-", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], ")"}], "^", 
                    "2"}]}], "]"}], ",", "0"}], "}"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", 
                   RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
              ";"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP3wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP3wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", 
                   RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
              ";"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$newwire", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$wire", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"mod$SP4wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{"Version", " ", "1.2"}], "*)"}], "+", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "6"}], "]"}], "]"}]}], "}"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"mod$SP4wire", "[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "6"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], "/", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}]}]}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "3"}], "]"}], "]"}], ",", "0"}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "5"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "4"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"6", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", "\[IndentingNewLine]", 
                   RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}], 
                   "<>", "\"\<-\>\"", "<>", 
                   RowBox[{"ToString", "[", "n", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"8", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], 
              ";"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "4"}], "}"}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "temp$wire2", "]"}]}], "}"}]}], "]"}], 
      ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567618157334642*^9, 3.567618258146408*^9}, {
   3.567618355662986*^9, 3.567618461073015*^9}, {3.567618491184737*^9, 
   3.5676185795717926`*^9}, {3.567618624034336*^9, 3.5676186266424847`*^9}, {
   3.5676187344916534`*^9, 3.5676187401169753`*^9}, {3.567618896051894*^9, 
   3.567618972341258*^9}, {3.5676191966360865`*^9, 3.5676195070508413`*^9}, 
   3.567619592230714*^9, {3.5676198814002533`*^9, 3.567619987000293*^9}, {
   3.567621351097315*^9, 3.567621408168579*^9}, {3.567623199136017*^9, 
   3.5676232109566927`*^9}, {3.5699566678530464`*^9, 3.569956669069116*^9}, {
   3.5701903245018406`*^9, 3.570190480182745*^9}, {3.570190589032971*^9, 
   3.5701907067267027`*^9}, {3.570190747578039*^9, 3.57019079549678*^9}, {
   3.5701908712851143`*^9, 3.570190932990644*^9}, {3.5701915114917326`*^9, 
   3.5701915852189493`*^9}, {3.570191853197277*^9, 3.570191870340257*^9}, {
   3.570192092464962*^9, 3.5701921016844893`*^9}, {3.5701921626209745`*^9, 
   3.570192223443454*^9}, {3.570302578468925*^9, 3.57030262682069*^9}, {
   3.5703027102984653`*^9, 3.5703027446594305`*^9}, {3.5703029463839684`*^9, 
   3.5703030484998093`*^9}, 3.570303087227024*^9, {3.570303123898122*^9, 
   3.570303130546502*^9}, {3.5703032863314123`*^9, 3.5703033136609755`*^9}, {
   3.5703035871816196`*^9, 3.5703036585237007`*^9}, {3.5709805445897593`*^9, 
   3.57098071541553*^9}, {3.570981455965887*^9, 3.57098146003712*^9}, {
   3.57098150251355*^9, 3.5709815068317966`*^9}, {3.5857146194552917`*^9, 
   3.585714662110731*^9}, {3.5857147583892384`*^9, 3.585714849666459*^9}, {
   3.5907775604958525`*^9, 3.5907775993070726`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Create 3D shapes Wires", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567099102884283*^9, 3.567099110037692*^9}, {
  3.5670992402151375`*^9, 3.56709925476797*^9}, {3.567573948274887*^9, 
  3.5675739511100492`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DrawWires", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ru", "=", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           RowBox[{"temp$newwire", "[", 
            RowBox[{"[", 
             RowBox[{"4", ",", "6"}], "]"}], "]"}]}]}], "}"}]}], ",", 
       RowBox[{"rl", "=", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           RowBox[{"temp$newwire", "[", 
            RowBox[{"[", 
             RowBox[{"6", ",", "1"}], "]"}], "]"}]}], ",", "0"}], "}"}]}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Join", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Wire"}]}], " ", 
         RowBox[{"Drawing", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP1wire", "[", 
                RowBox[{"temp$newwire", "[", 
                 RowBox[{"[", 
                  RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP1wire", "[", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP2wire", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP2wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP3wire", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"mod$SP4wire", "[", 
                RowBox[{
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"temp$newwire", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"mod$SP4wire", "[", 
                 RowBox[{
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}]}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "4"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Suspenpension"}]}], " ", "Point", " ", 
          RowBox[{"Drawing", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP1wire", "[", 
                  RowBox[{"temp$newwire", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP1wire", "[", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1"}], "}"}]}], "]"}], ",", "1"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP2wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP2wire", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "2"}], "}"}]}], "]"}], ",", "1"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP3wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP3wire", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "5"}], "]"}], "]"}]}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", "1"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"temp$newwire", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "4"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{"mod$SP4wire", "[", 
                  RowBox[{
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Point", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"mod$SP4wire", "[", 
                   RowBox[{
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$newwire", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "4"}], "]"}], "]"}]}], "]"}], "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "+", "rl"}], "]"}]}], "}"}],
              ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "4"}], "}"}]}], "]"}], ",", "1"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"+", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"+", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}], ",", 
             RowBox[{"-", "1.0"}]}], "}"}], "]"}], ","}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Point", "[", "ru", "]"}], ",", 
         RowBox[{"Point", "[", "rl", "]"}]}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"Opacity", "[", "0.5", "]"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"mod$Create3DShape", "[", 
          RowBox[{"ru", ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"mod$Create3DShape", "[", 
          RowBox[{"rl", ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newwire", "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
          "]"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5670991129788604`*^9, 3.56709914532271*^9}, {
   3.5670991824098315`*^9, 3.5670994584046173`*^9}, {3.567100100357335*^9, 
   3.5671001871372986`*^9}, {3.5671002327669086`*^9, 
   3.5671003436832523`*^9}, {3.567358412979867*^9, 3.5673584563383474`*^9}, {
   3.5673585771762586`*^9, 3.5673587813949394`*^9}, {3.5673588334849186`*^9, 
   3.5673589541708217`*^9}, {3.5673589955221868`*^9, 
   3.5673592005639143`*^9}, {3.5673592357089243`*^9, 
   3.5673592860628047`*^9}, {3.5673593208547945`*^9, 3.567359388902687*^9}, {
   3.5673594206105003`*^9, 3.5673594879573526`*^9}, {3.567359542009444*^9, 
   3.567359619516877*^9}, {3.567359666829583*^9, 3.5673596943671584`*^9}, {
   3.5673598561764135`*^9, 3.5673599255453806`*^9}, {3.5673599780753856`*^9, 
   3.5673599964554367`*^9}, {3.567360366902625*^9, 3.5673603752471027`*^9}, {
   3.5673609025692635`*^9, 3.567360924802535*^9}, {3.5673615750917296`*^9, 
   3.5673615910466423`*^9}, {3.567361622292429*^9, 3.56736185413769*^9}, {
   3.567361908312789*^9, 3.5673619143141317`*^9}, {3.567615885943726*^9, 
   3.567615996490049*^9}, {3.567616115560859*^9, 3.567616123887336*^9}, {
   3.5676162928860016`*^9, 3.567616296561212*^9}, 3.567616366495212*^9, {
   3.5676164922614055`*^9, 3.5676165110284786`*^9}, {3.567617953036957*^9, 
   3.567617957035186*^9}, {3.5701761038494654`*^9, 3.5701762142167783`*^9}, {
   3.570176260174407*^9, 3.5701763478424215`*^9}, {3.5701841544039307`*^9, 
   3.570184158814183*^9}, {3.570184286507487*^9, 3.5701843130960073`*^9}, {
   3.5701847888162174`*^9, 3.5701851710230784`*^9}, {3.570185205428046*^9, 
   3.5701853772298727`*^9}, {3.5701854096137247`*^9, 
   3.5701854097907352`*^9}, {3.5701855016609898`*^9, 
   3.5701855109815226`*^9}, {3.5701857359003873`*^9, 3.570185755336499*^9}, {
   3.5701860232788243`*^9, 3.5701861074326377`*^9}, {3.570187229231801*^9, 
   3.5701872368282356`*^9}, {3.5857153483809834`*^9, 
   3.5857153852550926`*^9}, {3.585715415438819*^9, 3.585715415600828*^9}, {
   3.5857154595893445`*^9, 3.585715533480571*^9}, {3.5857155913368797`*^9, 
   3.5857155913968835`*^9}, {3.59077729504467*^9, 3.590777306319315*^9}, {
   3.5907774130534196`*^9, 3.590777416049591*^9}, {3.5907779690122185`*^9, 
   3.590777969232231*^9}, {3.590778367455008*^9, 3.5907783705531855`*^9}, {
   3.590778417785887*^9, 3.590778450623765*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Wire Suspension Point Generator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570184461728509*^9, 3.5701844669178057`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP1wire", "[", "dy_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "dy", ",", "0"}], "}"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570184319186356*^9, 3.570184402754136*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP2wire", "[", 
    RowBox[{"dy_", ",", "dx_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "dx"}], ",", "dy", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dx"}], ",", "dy", ",", "0"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701844066083565`*^9, 3.570184430823741*^9}, {
  3.5701846199525585`*^9, 3.5701846230667367`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP3wire", "[", 
    RowBox[{"dy_", ",", "dr_", ",", "th_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "dr"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"th", "+", 
          RowBox[{"0", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}], ",", "dy",
        ",", 
       RowBox[{
        RowBox[{"-", "dr"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"th", "+", 
          RowBox[{"0", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "dr"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"th", "+", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}], ",", "dy",
        ",", 
       RowBox[{
        RowBox[{"-", "dr"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"th", "+", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "dr"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"th", "+", 
          RowBox[{"4", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}], ",", "dy",
        ",", 
       RowBox[{
        RowBox[{"-", "dr"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"th", "+", 
          RowBox[{"4", "*", 
           RowBox[{
            RowBox[{"N", "[", "Pi", "]"}], "/", "3"}]}]}], "]"}]}]}], "}"}]}],
     "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567359702105601*^9, 3.567359729621175*^9}, {
  3.567359803294389*^9, 3.5673598456598115`*^9}, {3.567360005560958*^9, 
  3.5673600216548777`*^9}, {3.5676161036421776`*^9, 3.567616109404507*^9}, {
  3.5701844339569206`*^9, 3.5701844438014836`*^9}, {3.5701846389646463`*^9, 
  3.570184649443246*^9}, {3.570185080158881*^9, 3.5701850810519323`*^9}, {
  3.5702896902927637`*^9, 3.570289693676957*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SP4wire", "[", 
    RowBox[{"dx_", ",", "dy_", ",", "dz_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dx"}], ",", "dy", ",", 
       RowBox[{"-", "dz"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dx"}], ",", "dy", ",", 
       RowBox[{"+", "dz"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "dx"}], ",", "dy", ",", 
       RowBox[{"+", "dz"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "dx"}], ",", "dy", ",", 
       RowBox[{"-", "dz"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567359946716592*^9, 3.567359969746909*^9}, {
  3.5701844453525724`*^9, 3.570184455162133*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2-2 Set Vertical Springs", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570194431878769*^9, 3.5701944384821463`*^9}}],

Cell[CellGroupData[{

Cell["Set Vertical Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.570194453170987*^9, 3.570194456945203*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetVertSprings", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$wire", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "wires", " ", "have", " ", "not", " ", "been", " ", "set", 
        " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Set wires first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Set Vertical Springs\>\"", ",", "\[IndentingNewLine]", 
             "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.6", ",", "0.9", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "Wire", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Create New Springs\>\"", ",", "Bold", ",", "White"}],
             "]"}], ",", "mod$NewVertSprings", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$vspr", "]"}], ",", 
            RowBox[{"temp$vspr", "=", "save$vspr"}], ",", 
            RowBox[{"temp$vspr", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$vspr", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$vspr", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$vspr", ",", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditVertSprings", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "13"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"PopupMenu", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "\[Rule]", "\"\<Upper SP\>\""}], ",", 
                    RowBox[{"2", "\[Rule]", "\"\<Lower SP\>\""}]}], "}"}]}], 
                    "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Enabled", "\[Rule]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}]}], "]"}]}]}],
                     "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",",
                  "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7", ",", "m"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$vspr", "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Edit\>\"", 
                  ",", "\"\<Name\>\"", ",", "\"\<Position\>\"", ",", 
                  "\"\<k [N/m]\>\"", ",", "\"\<fp [N]\>\"", ",", "\"\<Q\>\"", 
                  ",", "\"\<CoP [dB]\>\"", ",", "\"\<Direction\>\""}], 
                 "}"}]}], "}"}]}]}], "]"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{"save$vspr", "=", "temp$vspr"}], "]"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{
       "WindowTitle", "\[Rule]", "\"\<2-2 Set Vertical Springs\>\""}]}], 
      "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702162782515507`*^9, 
   3.5702163782442703`*^9}, {3.570216470777563*^9, 3.5702164805631227`*^9}, {
   3.5702165658460007`*^9, 3.5702165893283434`*^9}, {3.5702570661210203`*^9, 
   3.570257066994622*^9}, {3.570257105167889*^9, 3.5702571052302895`*^9}, {
   3.5702572996222305`*^9, 3.570257307718645*^9}, {3.570257457962509*^9, 
   3.570257458009309*^9}, {3.570258035319723*^9, 3.570258059655766*^9}, {
   3.5702582488402987`*^9, 3.5702582525687046`*^9}, 3.570258288557968*^9, 
   3.5702583537504826`*^9, {3.5702883642379174`*^9, 3.5702884028931284`*^9}, {
   3.57030447482839*^9, 3.570304474942397*^9}, {3.5703045983484554`*^9, 
   3.5703046211247582`*^9}, {3.570553900822813*^9, 3.5705539016648607`*^9}, {
   3.57063896965767*^9, 3.5706389827284174`*^9}, {3.5857164149669886`*^9, 
   3.585716452993164*^9}, {3.5857164843139553`*^9, 3.5857164872691245`*^9}, {
   3.5857180469773345`*^9, 3.5857180558798437`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewVertSprings", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Vertical Springs\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "spring", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newvspr", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0.", ",", "0.", ",", "True", ",", 
           RowBox[{"-", "60"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "\"\<\>\"", ",", 
           "1000."}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Spring Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InputField", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newvspr", "[", 
           RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
         RowBox[{"FieldSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"SP", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose wire suspension point where spring is inserted.\>\"", 
           ",", "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "13"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], 
              "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<Upper SP\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Lower SP\>\""}]}], "}"}]}], 
            "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Prestress", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness & Prestress\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from wire tension & resonant frequency\>\"", ",", 
           "Bold", ",", "Black", ",", "Small"}], "]"}], ",", 
         "\[IndentingNewLine]", "mod$CalcSprStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Stiffness:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Prestress:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"InputField", "[", 
           RowBox[{
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], ",", "Number", ",", 
            RowBox[{"FieldSize", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], "}"}], "}"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", "Percussion", " ", 
          RowBox[{"Effect", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Effect\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.7", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "5", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
           "\"\<dB\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Working"}]}], " ", 
          RowBox[{"Direction", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Working Direction\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"m", "=", "m"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", 
                  RowBox[{"7", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], ",", 
             "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Spring", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$vspr", ",", "temp$newvspr"}], "]"}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Vertical Springs\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.570257067213022*^9, 
   3.570257068086624*^9}, {3.570257105261489*^9, 3.57025710533949*^9}, {
   3.5702573125858536`*^9, 3.570257336999896*^9}, {3.570257458024909*^9, 
   3.5702574580717087`*^9}, {3.5702580709989862`*^9, 
   3.5702580875506153`*^9}, {3.5702582550335093`*^9, 3.5702582593079166`*^9}, 
   3.570258291365973*^9, 3.570258355528886*^9, {3.570304447263814*^9, 
   3.570304447391821*^9}, {3.5706390399486904`*^9, 3.5706391762724876`*^9}, {
   3.570639328539197*^9, 3.5706395632336206`*^9}, {3.5706396124144335`*^9, 
   3.570639663527357*^9}, {3.5706397247278576`*^9, 3.5706397343694086`*^9}, {
   3.5706398445457106`*^9, 3.5706398470598545`*^9}, {3.5706400506705003`*^9, 
   3.570640052520606*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.585716469899131*^9, 
  3.585716470346156*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditVertSprings", "[", "nw_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Vertical Springs\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "spring", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newvspr", "=", 
         RowBox[{"temp$vspr", "[", 
          RowBox[{"[", "nw", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Spring Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InputField", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newvspr", "[", 
           RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "String", ",", 
         RowBox[{"FieldSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"SP", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose wire suspension point where spring is inserted.\>\"", 
           ",", "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "13"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], 
              "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<Upper SP\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Lower SP\>\""}]}], "}"}]}], 
            "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Prestress", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness & Prestress\>\"", ",", "\[IndentingNewLine]", "Bold",
            ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.8", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from wire tension & resonant frequency\>\"", ",", 
           "Bold", ",", "Black", ",", "Small"}], "]"}], ",", 
         "\[IndentingNewLine]", "mod$CalcSprStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Stiffness:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N/m\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Prestress:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "4", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<N\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Quality"}]}], " ", 
          RowBox[{"Factor", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Quality Factor\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.75", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"InputField", "[", 
           RowBox[{
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], ",", "Number", ",", 
            RowBox[{"FieldSize", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], "}"}], "}"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", "Percussion", " ", 
          RowBox[{"Effect", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Effect\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.7", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newvspr", "[", 
              RowBox[{"[", "5", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newvspr", "[", 
               RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newvspr", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
           "\"\<dB\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Working"}]}], " ", 
          RowBox[{"Direction", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Working Direction\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"m", "=", "m"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", 
                  RowBox[{"7", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], ",", 
             "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Spring", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$vspr", "[", 
                RowBox[{"[", "nw", "]"}], "]"}], "=", "temp$newvspr"}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Vertical Springs\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.570257067213022*^9, 
   3.570257068086624*^9}, {3.570257105261489*^9, 3.57025710533949*^9}, {
   3.5702573125858536`*^9, 3.570257336999896*^9}, {3.570257458024909*^9, 
   3.5702574580717087`*^9}, {3.5702580709989862`*^9, 
   3.5702580875506153`*^9}, {3.5702582550335093`*^9, 3.5702582593079166`*^9}, 
   3.570258291365973*^9, 3.570258355528886*^9, {3.570304447263814*^9, 
   3.570304447391821*^9}, {3.5706390399486904`*^9, 3.5706391762724876`*^9}, {
   3.570639328539197*^9, 3.5706395632336206`*^9}, {3.5706396124144335`*^9, 
   3.570639663527357*^9}, {3.5706397247278576`*^9, 3.5706397343694086`*^9}, {
   3.5706398445457106`*^9, 3.5706398470598545`*^9}, {3.5706400506705003`*^9, 
   3.570640052520606*^9}, {3.5857164750984282`*^9, 3.585716526430364*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcSprStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Input Resonant Frequency:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Frequency", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$vsprfreq", "=", "0."}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", "temp$vsprfreq", "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "10"}], "]"}], "]"}],
                    "/", "g"}], ")"}], "*", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$vsprfreq"}], 
                   ")"}], "^", "2"}]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"temp$newvspr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "=", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"temp$newvspr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "10"}], "]"}], 
                 "]"}]}], ";"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "200"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", 
      "\"\<Calculate Stiffness and Prestress\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5708944426245155`*^9, 3.5708944428045263`*^9}, {3.5708945682186995`*^9, 
   3.5708945769291973`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2-3 Set Inverted Pendulum", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570215637850922*^9, 3.5702156458273783`*^9}, {
  3.5710350529959507`*^9, 3.5710350559881215`*^9}}],

Cell[CellGroupData[{

Cell["Set Inverted Pendulum", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.570194453170987*^9, 3.570194456945203*^9}, {3.5710350690668697`*^9, 
  3.5710350719820366`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetIP", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been", 
        " ", "set", " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Registrate bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**"}], "*", "Version", " ", "1.1"}], "**"}], "**"}], 
                  "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
           "**"}], "**"}], "**"}], "**"}], "**", "**", "**"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "IP", " ", "Version", " ", "1.0", " ", "Compriance", " ", "Check"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "3"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "0"}], "]"}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "3"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"save$IP", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "1000"}], "]"}]}], 
          "]"}], ";"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
        "*", "Version", " ", 
        RowBox[{
        "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
          "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Main"}]}], " ", 
         RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TextCell", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Set Inverted Pendulum\>\"", ",", "\[IndentingNewLine]", 
              "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "New"}]}], " ", "Wire", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Button", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Create New IPs\>\"", ",", "Bold", ",", "White"}], 
             "]"}], ",", "mod$NewIP", ",", "\[IndentingNewLine]", 
            RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
            RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Load"}]}], " ", 
             RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", 
             RowBox[{"temp$IP", "=", "save$IP"}], ",", 
             RowBox[{"temp$IP", "=", 
              RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Input"}]}], " ", "Field", " ", 
              RowBox[{"Module", "--"}]}], "-"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"TableForm", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$IP", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$IP", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$IP", ",", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"mod$EditIP", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "temp$IP", "]"}]}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"TableHeadings", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"None", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Edit\>\"", 
                   ",", "\"\<Name\>\"", ",", "\"\<Base\>\"", ",", 
                   "\"\<Top\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"--", 
               RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
             RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TableForm", "[", 
           RowBox[{"{", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Button", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
                RowBox[{"DialogReturn", "[", 
                 RowBox[{"save$IP", "=", "temp$IP"}], "]"}]}], "]"}], ",", 
              RowBox[{"(*", 
               RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"Button", "[", 
               RowBox[{"\"\<Cancel\>\"", ",", 
                RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
           "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
           RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"WindowElements", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
           ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"WindowSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"800", ",", "500"}], "}"}]}], ",", 
        RowBox[{
        "WindowTitle", "\[Rule]", "\"\<2-3 Set Inverted Pendulum\>\""}]}], 
       "]"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570639937864048*^9, 3.570639940941224*^9}, {
   3.5706399846197224`*^9, 3.570640066998434*^9}, {3.571035062835513*^9, 
   3.571035081401575*^9}, {3.571045391606285*^9, 3.5710454254622216`*^9}, {
   3.5710454688907056`*^9, 3.5710454744880257`*^9}, 3.571045802349778*^9, {
   3.5710473240858164`*^9, 3.571047330661193*^9}, {3.571056270684533*^9, 
   3.5710562854593782`*^9}, {3.5710565989893107`*^9, 
   3.5710565992563257`*^9}, {3.5710566496692095`*^9, 
   3.5710566812840176`*^9}, {3.57105699148076*^9, 3.571057098058856*^9}, {
   3.5710571303557034`*^9, 3.571057135050972*^9}, 3.571057222135953*^9, {
   3.571068309269725*^9, 3.5710683095757427`*^9}, {3.5710685449712067`*^9, 
   3.5710685453672295`*^9}, {3.5856292398592105`*^9, 3.585629276548309*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New Inverted Pendulum", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5710454850606303`*^9, 3.5710454894878836`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewIP", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Inverted Pendulum\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "IP", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newIP", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0.6", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "0.3"}], ",", 
               RowBox[{"-", "0.5196"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "0.3"}], ",", "0.5196"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"200.", ",", "200.", ",", "200.", ",", "200"}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"10", ",", "10", ",", "10", ",", "1000"}], "}"}], ",", 
           "\"\<IP\>\"", ",", "0.5", ",", 
           RowBox[{"-", "80"}], ",", "False", ",", "0", ",", "True"}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<IP Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InputField", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newIP", "[", 
           RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
         RowBox[{"FieldSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose Base and Top Bodies\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Base:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Top:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Position of IPs in Horizontal Plane\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "\[IndentingNewLine]", "mod$CalcIPPosition",
          ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<x [mm]\>\"", ",", "\"\<z [mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Length", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Length of IP Legs\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newIP", "[", 
                 RowBox[{"[", "7", "]"}], "]"}], "/", "mm"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
             "\[IndentingNewLine]", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<mm\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Load"}]}], " ", 
          RowBox[{"Mass", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Load Mass\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Suspended Bodies\>\"", ",", "Bold", ",", 
           "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPLoad", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Q", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Effective Stiffness and Quality Factor\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate stiffness from Resonant Frequency\>\"", ",", "Bold", 
           ",", "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [N/m]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Additional yaw stiffness due to Rigidity of flexures\>\"", ",", 
          "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], "]"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<Torsion\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [Nm/rad]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", 
          RowBox[{"Percussion", "--"}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Level\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "11", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newIP", "[", 
                RowBox[{"[", "11", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
           "\"\<dB\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Overcompensated\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$IP", ",", "temp$newIP"}], "]"}], "]"}]}], "]"}], 
           ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Horizontal Flexure\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.5706401048015966`*^9, 
   3.5706401766677065`*^9}, {3.5710455010475445`*^9, 3.571045504552745*^9}, {
   3.571045537467628*^9, 3.571045632391057*^9}, {3.5710457065923014`*^9, 
   3.5710457432123957`*^9}, {3.5710457896870537`*^9, 
   3.5710458175426474`*^9}, {3.571045915252236*^9, 3.571045915634258*^9}, {
   3.571046012502798*^9, 3.5710460188541613`*^9}, {3.5710461035330048`*^9, 
   3.571046514466509*^9}, {3.571046593708041*^9, 3.571046701472205*^9}, {
   3.571046765961894*^9, 3.571046817363834*^9}, {3.571047211076353*^9, 
   3.5710472312935095`*^9}, {3.5710473842602587`*^9, 
   3.5710474876071696`*^9}, {3.5710566211845803`*^9, 3.571056622034629*^9}, {
   3.571056705057378*^9, 3.571056853447865*^9}, {3.571056912616249*^9, 
   3.5710569541276236`*^9}, {3.5710571978635645`*^9, 3.57105720214981*^9}, {
   3.571057256293906*^9, 3.571057269396656*^9}, {3.571057355683591*^9, 
   3.5710573571766768`*^9}, {3.571059003708853*^9, 3.571059019032729*^9}, {
   3.5710590654043818`*^9, 3.571059095044077*^9}, {3.5710666867139206`*^9, 
   3.57106682150163*^9}, {3.5710668572016716`*^9, 3.5710669047093887`*^9}, {
   3.571066985215994*^9, 3.571066985458008*^9}, {3.571068136920868*^9, 
   3.5710681379319253`*^9}, {3.5710682432339487`*^9, 
   3.5710682450170507`*^9}, {3.5787834301089115`*^9, 
   3.5787835401172037`*^9}, {3.5787836620111756`*^9, 3.5787836628782253`*^9}, 
   3.578784074909792*^9, {3.5787841199163666`*^9, 3.57878412120444*^9}, {
   3.578784620979026*^9, 3.578784622122091*^9}, {3.585629184398038*^9, 
   3.585629196382724*^9}, 3.585629228257547*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Inverted Pendulum", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5710454850606303`*^9, 3.5710454894878836`*^9}, {
  3.571066926284623*^9, 3.5710669278997154`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EditIP", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Edit Inverted Pendulum\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "IP", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newIP", "=", 
         RowBox[{"temp$IP", "[", 
          RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<IP Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InputField", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newIP", "[", 
           RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
         RowBox[{"FieldSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose Base and Top Bodies\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Base:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Top:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Position", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Position of IPs in Horizontal Plane\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position\>\"", ",", "Bold", ",", "Black", ",", 
           "Small"}], "]"}], ",", "\[IndentingNewLine]", "mod$CalcIPPosition",
          ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newIP", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                "]"}], ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<x [mm]\>\"", ",", "\"\<z [mm]\>\""}], "}"}]}], 
           "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "IP"}]}], " ", 
          RowBox[{"Length", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Length of IP Legs\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newIP", "[", 
                 RowBox[{"[", "7", "]"}], "]"}], "/", "mm"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "7", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
             "\[IndentingNewLine]", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<mm\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Load"}]}], " ", 
          RowBox[{"Mass", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Load Mass\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate from Suspended Bodies\>\"", ",", "Bold", ",", 
           "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPLoad", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Stiffness"}]}], " ", "&"}], " ", 
          RowBox[{"Q", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Effective Stiffness and Quality Factor\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate stiffness from Resonant Frequency\>\"", ",", "Bold", 
           ",", "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcIPStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<Leg1\>\"", ",", "\"\<Leg2\>\"", ",", "\"\<Leg3\>\""}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [N/m]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Additional yaw stiffness due to Rigidity of flexures\>\"", ",", 
          "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], "]"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", "=", "m"}], "}"}], ",", 
                 RowBox[{"Dynamic", "[", 
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "]"}]}], "]"}], 
               ",", "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TableHeadings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<Torsion\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Stiffness [Nm/rad]\>\"", ",", "\"\<Q-factor\>\""}], 
             "}"}]}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Center"}]}], " ", "of", " ", 
          RowBox[{"Percussion", "--"}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Center of Percussion Level\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "11", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newIP", "[", 
               RowBox[{"[", "8", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Enabled", "\[Rule]", 
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newIP", "[", 
                RowBox[{"[", "11", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
           "\"\<dB\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$newIP", "[", 
              RowBox[{"[", "9", "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Overcompensated\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<OK\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$IP", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "=", "temp$newIP"}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Horizontal Flexure\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.5706401048015966`*^9, 
   3.5706401766677065`*^9}, {3.5710455010475445`*^9, 3.571045504552745*^9}, {
   3.571045537467628*^9, 3.571045632391057*^9}, {3.5710457065923014`*^9, 
   3.5710457432123957`*^9}, {3.5710457896870537`*^9, 
   3.5710458175426474`*^9}, {3.571045915252236*^9, 3.571045915634258*^9}, {
   3.571046012502798*^9, 3.5710460188541613`*^9}, {3.5710461035330048`*^9, 
   3.571046514466509*^9}, {3.571046593708041*^9, 3.571046701472205*^9}, {
   3.571046765961894*^9, 3.571046817363834*^9}, {3.571047211076353*^9, 
   3.5710472312935095`*^9}, {3.5710473842602587`*^9, 
   3.5710474876071696`*^9}, {3.5710566211845803`*^9, 3.571056622034629*^9}, {
   3.571056705057378*^9, 3.571056853447865*^9}, {3.571056912616249*^9, 
   3.5710569541276236`*^9}, {3.5710571978635645`*^9, 3.57105720214981*^9}, {
   3.571057256293906*^9, 3.571057269396656*^9}, {3.571057355683591*^9, 
   3.5710573571766768`*^9}, {3.571059003708853*^9, 3.571059019032729*^9}, {
   3.5710590654043818`*^9, 3.571059095044077*^9}, {3.5710666867139206`*^9, 
   3.57106682150163*^9}, {3.5710668572016716`*^9, 3.5710669605405827`*^9}, {
   3.5710669926974216`*^9, 3.571067001900948*^9}, {3.5710672927315826`*^9, 
   3.571067294191666*^9}, {3.5710685773790607`*^9, 3.5710685854395213`*^9}, {
   3.5787841342511864`*^9, 3.5787841378533926`*^9}, {3.5856291448397756`*^9, 
   3.5856291676760817`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate IP Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.57106795077122*^9, 
  3.571067950930229*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcIPPosition", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$IPpos", "=", 
         RowBox[{"{", 
          RowBox[{"0.6", ",", "0."}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<Radial Distance from Base Body's CoM:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$IPpos", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "/", "mm"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<mm\>\""}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Rotation Angle in Horizontal Plane from x-axis:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$IPpos", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "/", "deg"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "deg"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<deg\>\""}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newIP", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Delete", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"mod$SP3wire", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"temp$IPpos", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", "2"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "300"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Calculate IP Position\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.57028983359796*^9, 3.5702898337029657`*^9}, {
   3.570289895278488*^9, 3.5702898978016324`*^9}, {3.5702928826503563`*^9, 
   3.570292894817052*^9}, {3.5702929952027936`*^9, 3.570292995829829*^9}, {
   3.5702930771094785`*^9, 3.5702931366238823`*^9}, {3.5710670353478613`*^9, 
   3.571067194359956*^9}, {3.57106723498728*^9, 3.5710672534473352`*^9}, {
   3.571067350858907*^9, 3.5710673791475253`*^9}, 3.57106817122783*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate IP Load", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.5702906018649025`*^9, 
  3.5702906054931097`*^9}, {3.5702938468065023`*^9, 3.570293848911623*^9}, {
  3.571067954591439*^9, 3.5710679642949944`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcIPLoad", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Check the masses suspended by IPs:\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Logic"}]}], " ", 
          RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$IPload", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Check"}]}], " ", "List", " ", "for", " ", 
           RowBox[{"Calculation", "--"}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Checkbox", "[", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$IPload", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                ",", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Calculator", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Total Mass:\>\"", ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"temp$IPload", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{"save$mass", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
            "]"}], ",", "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newIP", "[", 
                RowBox[{"[", "10", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"temp$IPload", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                "]"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"400", ",", "200"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Calculate IP Stiffness\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5710674652244487`*^9, 3.5710676733223515`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate IP Stiffness", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.5710676894092712`*^9, 
  3.5710676910523653`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcIPStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate IP Position:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$IPstiff", "=", "0."}], ";", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<Resonant Frequency:\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", "temp$IPstiff", "]"}], ",", "Number", 
              ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
              RowBox[{"Do", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$newIP", "[", 
                  RowBox[{"[", 
                   RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                 RowBox[{
                  RowBox[{"temp$newIP", "[", 
                   RowBox[{"[", "10", "]"}], "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"N", "[", "Pi", "]"}], "*", "temp$IPstiff"}], 
                    ")"}], "^", "2"}], "/", "3"}]}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "]"}]}], "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "300"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Calculate IP Position\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.57028983359796*^9, 3.5702898337029657`*^9}, {
   3.570289895278488*^9, 3.5702898978016324`*^9}, {3.5702928826503563`*^9, 
   3.570292894817052*^9}, {3.5702929952027936`*^9, 3.570292995829829*^9}, {
   3.5702930771094785`*^9, 3.5702931366238823`*^9}, {3.5710670353478613`*^9, 
   3.571067194359956*^9}, {3.57106723498728*^9, 3.5710672534473352`*^9}, {
   3.571067350858907*^9, 3.5710673791475253`*^9}, {3.571067693567509*^9, 
   3.571067777735323*^9}, {3.57106780862109*^9, 3.57106783293548*^9}, {
   3.5710680604704947`*^9, 3.5710680805236416`*^9}, {3.5710711951317873`*^9, 
   3.5710711955498114`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["(2-3 Set Horizontal Flexure)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570215637850922*^9, 3.5702156458273783`*^9}, {
  3.5710454597991858`*^9, 3.5710454618743043`*^9}}],

Cell[CellGroupData[{

Cell["Set Vertical Springs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.570194453170987*^9, 3.570194456945203*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetHorizFlex", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "body", " ", "names", " ", "have", " ", "not", " ", "been", 
        " ", "set", " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Registrate bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Not", "[", 
             RowBox[{"ValueQ", "[", "save$mat", "]"}], "]"}], ",", 
            RowBox[{"save$mat", "=", "list$Material"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", 
              RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"TextCell", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Set Horizontal Flexure\>\"", ",", "\[IndentingNewLine]", 
              "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"RGBColor", "[", 
              RowBox[{"0.6", ",", "0.8", ",", "0.6"}], "]"}]}]}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "Wire", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Create New Flexure\>\"", ",", "Bold", ",", "White"}],
             "]"}], ",", "mod$NewHorizFlex", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$hflex", "]"}], ",", 
            RowBox[{"temp$hflex", "=", "save$hflex"}], ",", 
            RowBox[{"temp$hflex", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$hflex", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$hflex", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$hflex", ",", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$mat", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "/", "mm"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$hflex", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$hflex", "]"}]}], "}"}]}], "]"}],
              ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Name\>\"", 
                  ",", "\"\<Base\>\"", ",", "\"\<Follower\>\"", ",", 
                  "\"\<Stiffness [Nm/rad]\>\"", ",", "\"\<Material\>\"", ",", 
                  "\[IndentingNewLine]", "\"\<Follower's CoM H[mm]\>\"", ",", 
                  "\"\<Position in Base [mm]\>\""}], "}"}]}], "}"}]}]}], 
            "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{"save$hflex", "=", "temp$hflex"}], "]"}]}], "]"}], 
             ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{
       "WindowTitle", "\[Rule]", "\"\<2-3 Set Horizontal Flexures\>\""}]}], 
      "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570639937864048*^9, 3.570639940941224*^9}, {
   3.5706399846197224`*^9, 3.570640066998434*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New Flexure", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$NewHorizFlex", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Registrate New Horizontal Flexure\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
          RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$newhflex", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "0.", ",", "0.02", ",", 
           RowBox[{"{", 
            RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", "\"\<\>\"", ",",
            "1"}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Flexure Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InputField", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newhflex", "[", 
           RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "String", ",", 
         RowBox[{"FieldSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Choose"}]}], " ", 
          RowBox[{"Bodies", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Choose rigid bodies where the flexure is attached.\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.9"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Base:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}], ",", "\[IndentingNewLine]", "\"\<Follower:\>\"", ",", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"m", "\[Rule]", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}],
             "]"}]}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Material", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Material of Flexure\>\"", ",", "\[IndentingNewLine]", "Bold", 
           ",", "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.85"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"temp$newhflex", "[", 
           RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"m", "\[Rule]", 
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", 
             RowBox[{"Length", "[", "save$mat", "]"}]}], "}"}]}], "]"}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Stiffness\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "Italic", ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate flexure stiffness from resonant frequency\>\"", ",", 
           "Bold", ",", "Black", ",", "Small"}], "]"}], ",", 
         "\[IndentingNewLine]", "mod$CalcFlexStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<Stiffness:\>\"", ",", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<Nm/rad\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Position"}]}], " ", "of", " ", 
          RowBox[{"Follower", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Height of Follower's CoM from Flexure\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate CoM Position from CoP Level\>\"", ",", "Bold", ",", 
           "Black", ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcFlexStiff", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"temp$newhflex", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "/", "mm"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"temp$newhflex", "[", 
                   RowBox[{"[", "4", "]"}], "]"}], "=", 
                  RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
             "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<mm\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Position"}]}], " ", "of", " ", 
          RowBox[{"Base", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Position of Flexure in Base Body\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Button", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate Flexure Position\>\"", ",", "Bold", ",", "Black", 
           ",", "Small"}], "]"}], ",", "\[IndentingNewLine]", 
         "mod$CalcFlexPosition", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".8", ",", ".8", ",", ".8"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"m", "=", "m"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$newhflex", "[", 
                   RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$newhflex", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
              "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Create"}]}], " ", 
          RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
            ",", "Black"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"temp$hflex", ",", "temp$newhflex"}], "]"}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"(*", 
            RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<New Horizontal Flexure\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.5706401048015966`*^9, 3.5706401766677065`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Flexure Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcFlexPosition", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate Flexure Position:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$hflexpos", "=", 
         RowBox[{"{", 
          RowBox[{"0.6", ",", "0.", ",", "0.01"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<Radial Distance from Base Body's CoM:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "/", "mm"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$hflexpos", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<mm\>\""}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Rotation Angle in Horizontal Plane from x-axis:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "/", "deg"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$hflexpos", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "deg"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<deg\>\""}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Height from Base Body's CoM:\>\"", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "/", "mm"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"temp$hflexpos", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
               "Number", ",", 
               RowBox[{"FieldSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
             "\"\<mm\>\""}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"\"\<OK\>\"", ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newhflex", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "=", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$SP3wire", "[", 
                 RowBox[{
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], ",", 
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"temp$hflexpos", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "300"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", "\"\<Calculate Flexure Position\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.57028983359796*^9, 3.5702898337029657`*^9}, {
   3.570289895278488*^9, 3.5702898978016324`*^9}, {3.5702928826503563`*^9, 
   3.570292894817052*^9}, {3.5702929952027936`*^9, 3.570292995829829*^9}, {
   3.5702930771094785`*^9, 3.5702931366238823`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate Stiffness & Follower's Height", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570196692409064*^9, 3.570196695110218*^9}, {
  3.5702891096975555`*^9, 3.5702891137357864`*^9}, {3.5702906018649025`*^9, 
  3.5702906054931097`*^9}, {3.5702938468065023`*^9, 3.570293848911623*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcFlexStiff", ":=", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate Flexure Stiffness & Follower's CoM Height:\>\"", ",",
            "\[IndentingNewLine]", "Bold", ",", "White", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Input"}]}], " ", "Field", " ", 
          RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp$hflexStiff", "=", 
         RowBox[{"{", 
          RowBox[{"0.", ",", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"temp$newhflex", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "2", ",", "1", ",", "1"}],
              "]"}], "]"}], ",", "0.5", ",", "0.03", ",", 
           RowBox[{"-", "80"}], ",", "False"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Logic"}]}], " ", 
           RowBox[{"List", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"temp$hflexLogic", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "save$bdn", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"temp$hflexLegNum", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Load"}]}], " ", 
           RowBox[{"Caocluation", "--"}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Check", " ", "List"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Calculate Load on IP (exclude leg):\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{".7", ",", ".6", ",", ".6"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"Partition", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Checkbox", "[", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Dynamic", "[", 
                   RowBox[{"temp$hflexLogic", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
               ",", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ",",
           "6", ",", "6", ",", "1", ",", 
          RowBox[{"{", "}"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", "Calculator", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"\"\<How many legs?\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$hflexLegNum", "]"}], ",", "Number",
              ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"2.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Calculate from body's mass\>\"", ",", "Black", ",", 
               "Small", ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"temp$hflexStiff", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"Sum", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"temp$hflexLogic", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                   RowBox[{"save$mass", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "0"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}],
                "/", "temp$hflexLegNum"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$hflexStiff", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "Number", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\"\<kg\>\""}], "}"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Leg", "'"}]}]}], "s", " ", "Mass"}], ",", " ", 
         RowBox[{
          RowBox[{"MoI", " ", "and", " ", 
           RowBox[{"Length", "--"}]}], "-"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Leg's Mass, MoI and Length:\>\"", ",", "\[IndentingNewLine]", 
           "Bold", ",", "Black", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".7", ",", ".6"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Mass:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<kg\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<MoI:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<kg*m2\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Length:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "4", "]"}], "]"}], "/", "mm"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"temp$hflexStiff", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "=", 
                   RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}], ",", 
              "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<mm\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Resonant"}]}], " ", "Frequency", " ", "and", " ", 
          "CoP", " ", 
          RowBox[{"Effect", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Resonant Freqeuncy & CoP Effect:\>\"", ",", 
           "\[IndentingNewLine]", "Bold", ",", "Black", ",", "Italic"}], 
          "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{".6", ",", ".6", ",", ".7"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Frequency:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "5", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<Hz\>\""}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<CoP Level:\>\"", ",", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$hflexStiff", "[", 
                RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\"\<dB\>\""}], "}"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Checkbox", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"temp$hflexStiff", "[", 
              RowBox[{"[", "7", "]"}], "]"}], "]"}], "]"}], ",", 
           "\"\<Over compensated?\>\""}], "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "OK"}]}], " ", "&"}], " ", "Cancel", " ", 
          RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TextCell", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Calculate\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
           "White", ",", "Italic"}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"RGBColor", "[", 
           RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Calculate\>\"", ",", "Bold"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "m", ",", "mI", ",", "M", ",", "y", ",", "B", ",", "L", ",", 
                 "w"}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"L", "=", 
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "4", "]"}], "]"}]}], ";", 
                RowBox[{"m", "=", 
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ";", 
                RowBox[{"M", "=", 
                 RowBox[{"temp$hflexStiff", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"w", "=", 
                 RowBox[{"2", "*", 
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{"temp$hflexStiff", "[", 
                   RowBox[{"[", "5", "]"}], "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"mI", "=", 
                 RowBox[{
                  RowBox[{"temp$hflexStiff", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "/", 
                  RowBox[{"L", "^", "2"}]}]}], ";", 
                RowBox[{"B", "=", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"temp$hflexStiff", "[", 
                    RowBox[{"[", "7", "]"}], "]"}], ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "]"}], "*", 
                  RowBox[{"10", "^", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$hflexStiff", "[", 
                    RowBox[{"[", "6", "]"}], "]"}], "/", "20"}], ")"}]}]}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"m", "^", "2"}], "-", 
                    RowBox[{"4", "*", "m", "*", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"B", "*", "M"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", "mI"}]}], ")"}]}]}], 
                    ")"}], ">", "0"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", 
                   RowBox[{
                    RowBox[{"y", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"m", "-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"m", "^", "2"}], "-", 
                    RowBox[{"4", "*", "m", "*", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"B", "*", "M"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}], "*", "mI"}]}], ")"}]}]}], 
                    "]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", "m", "*", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", "B"}], ")"}]}], ")"}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$newhflex", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "=", 
                    RowBox[{"y", "*", "L"}]}], ";", 
                    RowBox[{
                    RowBox[{"temp$newhflex", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"M", "+", 
                    RowBox[{"y", "*", "m"}]}], ")"}], "*", 
                    RowBox[{"g", "/", "L"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"M", "+", 
                    RowBox[{"m", "*", 
                    RowBox[{"y", "^", "2"}]}], "+", "mI"}], ")"}], "*", 
                    RowBox[{"w", "^", "2"}]}]}], ")"}], "*", 
                    RowBox[{"L", "^", "2"}]}]}], ";"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Beep", "[", "]"}], ";", 
                   RowBox[{"CreateDialog", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Too large CoP Effect.\>\"", ",", 
                    RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], 
                    "]"}]}]}], "]"}]}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
        RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"500", ",", "500"}], "}"}]}], ",", 
     RowBox[{
     "WindowTitle", "\[Rule]", "\"\<Calculate Flexure Information\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5701967301072197`*^9, 3.570197131264165*^9}, {
   3.570197302145939*^9, 3.570197305532132*^9}, 3.570257068305024*^9, 
   3.5702571053550897`*^9, {3.570257346640713*^9, 3.5702573471399145`*^9}, 
   3.5702574580717087`*^9, 3.57025809605263*^9, 3.57025826130472*^9, {
   3.5702891173419924`*^9, 3.5702894820788546`*^9}, {3.570289717040293*^9, 
   3.5702897792478514`*^9}, {3.5702898403523464`*^9, 
   3.5702899046100216`*^9}, {3.570291749638551*^9, 3.5702918059407716`*^9}, {
   3.5702918585427804`*^9, 3.570291964580845*^9}, {3.570292002971041*^9, 
   3.5702923223533087`*^9}, {3.5702923595004334`*^9, 3.570292384041837*^9}, {
   3.5702924709588084`*^9, 3.5702925207426558`*^9}, {3.5702926102747765`*^9, 
   3.5702927920941763`*^9}, {3.570293113048534*^9, 3.5702931207839766`*^9}, 
   3.570293305802559*^9, {3.5702934026821003`*^9, 3.570293613340149*^9}, {
   3.570293725762579*^9, 3.5702937359461613`*^9}, {3.570293856587062*^9, 
   3.5702938633414483`*^9}, {3.570293900540576*^9, 3.5702939048978252`*^9}, {
   3.570293940257848*^9, 3.5702939625791245`*^9}, {3.570294035011267*^9, 
   3.570294170294005*^9}, {3.5702942460763397`*^9, 3.570294247886443*^9}, {
   3.570294284830556*^9, 3.5702943021185446`*^9}, {3.570294342036828*^9, 
   3.5702944399204264`*^9}, {3.570294480296736*^9, 3.5702945702088785`*^9}, {
   3.5702946607560577`*^9, 3.5702947571425705`*^9}, {3.570294788867385*^9, 
   3.57029480905654*^9}, {3.570294845301613*^9, 3.5702948858199306`*^9}, {
   3.570294953343793*^9, 3.5702949972463036`*^9}, {3.5702959004469643`*^9, 
   3.570296005817991*^9}, {3.570296868339324*^9, 3.5702968960399084`*^9}, {
   3.57029694065146*^9, 3.5702969502360086`*^9}, {3.5702972372534246`*^9, 
   3.5702973033122034`*^9}, {3.570902059136155*^9, 3.570902100605527*^9}, {
   3.570902159260882*^9, 3.570902159962922*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-4 Set Heat Links", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703791032406363`*^9, 3.5703791118081264`*^9}}],

Cell[CellGroupData[{

Cell["Set HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.570194453170987*^9, 3.570194456945203*^9}, {3.570463211578166*^9, 
  3.570463211922186*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetHeatLinks", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"ValueQ", "[", "save$shape", "]"}], "]"}]}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "bodies", " ", "have", " ", "not", " ", "been", " ", "set", 
        " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Registrate bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Set Heat Links\>\"", ",", "\[IndentingNewLine]", "Bold", ",",
              "Italic", ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "HL", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Create New Heat Links\>\"", ",", "Bold", ",", "White"}], 
            "]"}], ",", "mod$NewHeatLinks", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$HL", "]"}], ",", 
            RowBox[{"temp$HL", "=", "save$HL"}], ",", 
            RowBox[{"temp$HL", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$HL", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$HL", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$HL", ",", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditHeatLinks", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$HL", "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Edit\>\"", 
                  ",", "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                  "\"\<Body2\>\"", ",", 
                  "\"\<Attachment Point in Body1 [mm]\>\"", ",", 
                  "\[IndentingNewLine]", 
                  "\"\<Attachment Point in Body2 [mm]\>\"", ",", 
                  "\"\<Geo-x [mm]\>\"", ",", "\"\<Geo-y [mm]\>\"", ",", 
                  "\"\<Geo-z [mm]\>\""}], "}"}]}], "}"}]}]}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{"save$HL", "=", "temp$HL"}], "]"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{"WindowTitle", "\[Rule]", "\"\<2-4 Set Heat Links\>\""}]}], 
      "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570379132066285*^9, 3.570379177379877*^9}, {
   3.5703792463608227`*^9, 3.5703792641828413`*^9}, {3.5703793326957607`*^9, 
   3.570379349889744*^9}, {3.5704632234888473`*^9, 3.5704632237538624`*^9}, {
   3.5704670111594896`*^9, 3.57046702900751*^9}, {3.570554565202813*^9, 
   3.570554678762308*^9}, {3.5705547488923197`*^9, 3.5705548366673403`*^9}, {
   3.5705548715923376`*^9, 3.57055509508012*^9}, {3.570555137961573*^9, 
   3.5705551490792093`*^9}, {3.570555198976063*^9, 3.5705552305728703`*^9}, {
   3.5705556839738035`*^9, 3.5705557458073397`*^9}, {3.5705564254792147`*^9, 
   3.5705564266442814`*^9}, {3.5705567227412176`*^9, 3.5705567372760487`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$NewHeatLinks", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<New Heat Links\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newHL", "=", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.6", ",", "0.3", ",", "0."}], "}"}], ",", "1", ",", 
            "100.", ",", "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}], ",", "\"\<\>\""}], "}"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", 
           RowBox[{"temp$newHL", "[", 
            RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
          RowBox[{"FieldSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Select Attached Bodies\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Clamp Position and Heat Link Geometry\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x-Distance\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y-Depth\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z-Distance\>\"", ",", "Small"}], "]"}]}], 
                "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Geometry\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"Graphics3D", "[", 
                RowBox[{"mod$DrawHeatLinks", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                   RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Stiffness Matrix for Each Wire\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Number of Wires:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<\>\"", 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Q-factor:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Import\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"mod$ImportkHL", "[", 
                    RowBox[{"m", ",", "l"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "]"}],
                    ",", "\[IndentingNewLine]", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
                 "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                  "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"10.", ",", "1."}], "}"}]}], ",", 
                 RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}]}], "}"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$HL", ",", "temp$newHL"}], "]"}], "]"}]}], "]"}],
             ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<New Heat Links\>\""}]}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.570556497216318*^9, 3.570556522296753*^9}, {3.570556591024684*^9, 
   3.570556596014969*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}, {
  3.570556451723716*^9, 3.570556453000789*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$EditHeatLinks", "[", "n_", "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Edit Heat Links\>\"", ",", "\[IndentingNewLine]", "Bold", ",",
             "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newHL", "=", 
          RowBox[{"temp$HL", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", 
           RowBox[{"temp$newHL", "[", 
            RowBox[{"[", "10", "]"}], "]"}], "]"}], ",", "String", ",", 
          RowBox[{"FieldSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Select Attached Bodies\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Clamp Position and Heat Link Geometry\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<x-Distance\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<y-Depth\>\"", ",", "Small"}], "]"}], ",", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<z-Distance\>\"", ",", "Small"}], "]"}]}], 
                "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<Geometry\>\"", "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"Graphics3D", "[", 
                RowBox[{"mod$DrawHeatLinks", ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"ViewPoint", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"10", ",", "10", ",", "50"}], "}"}]}], ",", 
                   RowBox[{"ViewVertical", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Stiffness Matrix for Each Wire\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "Black"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Number of Wires:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "6", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", "\"\<\>\"", 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Q-factor:\>\"", ",", "Bold"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", "7", "]"}], "]"}], "]"}], ",", "Number", ",", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"TableForm", "[", 
                RowBox[{"{", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Import\>\"", ",", "Small", ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"mod$ImportkHL", "[", 
                    RowBox[{"m", ",", "l"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "]"}],
                    ",", "\[IndentingNewLine]", 
                   RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"8", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "}"}], 
                 "}"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"m", "=", "m"}], ",", 
                    RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$newHL", "[", 
                    RowBox[{"[", 
                    RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
                  "]"}], ",", "String", ",", "\[IndentingNewLine]", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"10.", ",", "1."}], "}"}]}], ",", 
                 RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}]}], "}"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{
                RowBox[{"temp$HL", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "=", "temp$newHL"}], "]"}]}],
              "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Edit Heat Links\>\""}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.57055646123526*^9, 3.570556489622884*^9}, {3.570556527429046*^9, 
   3.570556529227149*^9}, {3.5705566412025537`*^9, 3.5705566419665976`*^9}, {
   3.570556775050209*^9, 3.570556784609756*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Draw HL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5705377785762105`*^9, 3.570537783763507*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$DrawHeatLinks", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rCM", "=", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Line", "[", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"temp$newHL", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "+", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"temp$newHL", "[", 
               RowBox[{"[", 
                RowBox[{"5", ",", "1"}], "]"}], "]"}], ",", "0", ",", 
              RowBox[{"temp$newHL", "[", 
               RowBox[{"[", 
                RowBox[{"5", ",", "3"}], "]"}], "]"}]}], "}"}], "/", "2"}], 
           "-", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "1"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}], ",", 
              RowBox[{"2", "*", 
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "2"}], "]"}], "]"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "3"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}]}], "}"}], "/", "2"}]}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", "20"}], "}"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Opacity", "[", "0.5", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"mod$Create3DShape", "[", 
        RowBox[{
         RowBox[{"rCM", "-", 
          RowBox[{"temp$newHL", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ",", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"mod$Create3DShape", "[", 
        RowBox[{
         RowBox[{"rCM", "-", 
          RowBox[{"temp$newHL", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "1"}], "]"}], "]"}], ",", "0", ",", 
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "3"}], "]"}], "]"}]}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"save$shape", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"temp$newHL", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
        "]"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5705377849465747`*^9, 3.5705377988583703`*^9}, {
  3.570538008234346*^9, 3.5705380404471884`*^9}, {3.570538216409253*^9, 
  3.5705382176403236`*^9}, {3.5705383014531174`*^9, 3.5705386205193667`*^9}, {
  3.570538651034112*^9, 3.5705388810152664`*^9}, {3.5705533374645905`*^9, 
  3.570553378123916*^9}, {3.570553447706896*^9, 3.5705534478339033`*^9}, {
  3.5705534957046413`*^9, 3.5705535196400104`*^9}, {3.570553573933116*^9, 
  3.570553574068124*^9}, {3.570553634242565*^9, 3.570553635956663*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"steadyplot", "[", 
     RowBox[{"sub_", ",", "opt___"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wireplot", "[", "sub", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"bodyplot", "[", "sub", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"heatlinkplot", "[", "sub", "]"}], ",", "\[IndentingNewLine]", 
      "opt"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570900142979557*^9, 3.570900195909585*^9}, {
  3.571157599115424*^9, 3.5711576029316425`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"heatlinkplot", "[", "sub_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"save$HL", "[", 
       RowBox[{"[", "0", "]"}], "]"}], "=!=", "List"}], ",", 
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Graphics3D", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Line", "[", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"b2s", "[", 
                RowBox[{
                 RowBox[{"save$bodypos", "[", 
                  RowBox[{"[", 
                   RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "]"}], ",", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}]}], "]"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"N", "[", "Pi", "]"}], "*", 
                    RowBox[{"i", "/", "20"}]}], "]"}]}], ")"}], "/", "2"}]}], 
              "+", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"b2s", "[", 
                RowBox[{
                 RowBox[{"save$bodypos", "[", 
                  RowBox[{"[", 
                   RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "]"}], ",", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "4"}], "]"}], "]"}]}], "]"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"N", "[", "Pi", "]"}], "*", 
                    RowBox[{"i", "/", "20"}]}], "]"}]}], ")"}], "/", "2"}]}], 
              "-", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], ",", 
                 "0"}], "}"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"N", "[", "Pi", "]"}], "*", 
                 RowBox[{"i", "/", "20"}]}], "]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", "20"}], "}"}]}], "]"}], "]"}], "/.",
           "subdefparams"}], "/.", "sub"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708991302576327`*^9, 3.570899157353183*^9}, {
   3.5708991908360977`*^9, 3.570899224358015*^9}, {3.57089957445704*^9, 
   3.570899707831668*^9}, {3.570899742060626*^9, 3.5708998179379663`*^9}, {
   3.570899907765104*^9, 3.5709000153692584`*^9}, 3.570900105544416*^9, {
   3.5709006629953003`*^9, 3.5709006633903227`*^9}, {3.570900935289875*^9, 
   3.5709009357269*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Import kHL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5703648112755613`*^9, 3.5703648131296673`*^9}, {
  3.570536537486224*^9, 3.5705365394333353`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$ImportkHL", "[", 
    RowBox[{"m_", ",", "l_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$impkHL", "=", 
         RowBox[{"temp$newHL", "[", 
          RowBox[{"[", 
           RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Load Frequency Dependence of Heat Link Stiffness\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$impkHL", "]"}], ",", "String", ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"20.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{
               RowBox[{"temp$newHL", "[", 
                RowBox[{"[", 
                 RowBox[{"9", ",", "m", ",", "l"}], "]"}], "]"}], "=", 
               "temp$impkHL"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Clear\>\"", ",", "Bold", ",", "Black"}], "]"}], 
             ",", 
             RowBox[{"temp$impkHL", "=", "\"\<\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "}"}], 
         "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<HeatLink\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$impkHL", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<HeatLink\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                 ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<HeatLink\>\"", "}"}], ",", "3"}], "]"}],
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
              ",", "3", ",", "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"500", ",", "200"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"550", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
     "WindowTitle", "\[Rule]", 
      "\"\<Load Frequency Dependence of Heat Link Stiffness\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.5703648187229877`*^9, 
   3.570364842461345*^9}, {3.5703650147151976`*^9, 3.570365221167006*^9}, {
   3.570536542498511*^9, 3.570536625289246*^9}, {3.570536686231732*^9, 
   3.570536794872946*^9}, {3.570536877157652*^9, 3.57053688026583*^9}, {
   3.5705369980505667`*^9, 3.570536998680603*^9}, {3.5705371311661806`*^9, 
   3.5705371640520616`*^9}, {3.5705566657969604`*^9, 3.570556666219984*^9}, {
   3.5706406530399537`*^9, 3.570640655884116*^9}, {3.571237781888692*^9, 
   3.571237806502099*^9}, {3.5712391277366695`*^9, 3.571239130123806*^9}, {
   3.5793187480992956`*^9, 3.579318761135041*^9}, {3.5912608917692747`*^9, 
   3.5912608989416847`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2-5 Set Damper", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570640931730894*^9, 3.570640944970651*^9}}],

Cell[CellGroupData[{

Cell["Set Damper", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567090269778058*^9, 3.5670902851869392`*^9}, {
  3.570194453170987*^9, 3.570194456945203*^9}, {3.570463211578166*^9, 
  3.570463211922186*^9}, {3.570640964984796*^9, 3.5706409663218727`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetDamper", ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"--", 
       RowBox[{"-", "Check"}]}], " ", "Previous", " ", 
      RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"ValueQ", "[", "save$bdn", "]"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "If", " ", "bodies", " ", "have", " ", "not", " ", "been", " ", "set", 
        " ", "yet"}], ",", " ", 
       RowBox[{"return", " ", "error"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Beep", "[", "]"}], ";", 
      RowBox[{"CreateDialog", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<Registrate bodies first.\>\"", ",", 
          RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
        RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "Main"}]}], " ", 
        RowBox[{"Dialog", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"CreateDialog", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Set Damper\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
             "Italic", ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.6", ",", "0.7", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "New"}]}], " ", "HL", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Create New Damper\>\"", ",", "Bold", ",", "White"}], 
            "]"}], ",", "mod$NewDamper", ",", "\[IndentingNewLine]", 
           RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{"--", 
             RowBox[{"-", "Load"}]}], " ", 
            RowBox[{"Lists", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ValueQ", "[", "save$damp", "]"}], ",", 
            RowBox[{"temp$damp", "=", "save$damp"}], ",", 
            RowBox[{"temp$damp", "=", 
             RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Input"}]}], " ", "Field", " ", 
             RowBox[{"Module", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Delete\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$damp", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"temp$damp", ",", 
                    RowBox[{"{", "n", "}"}]}], "]"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Copy\>\"", ",", "Small"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"temp$damp", ",", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                   RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Edit\>\"", ",", "Small"}], "]"}], ",", 
                    RowBox[{"mod$EditDamper", "[", "n", "]"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"PopupMenu", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Rule]", 
                    RowBox[{"save$bdn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"TableForm", "[", 
                  RowBox[{"{", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"n", "=", "n"}], ",", 
                    RowBox[{"m", "=", "m"}]}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "/", 
                    "mm"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                    "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "3"}], "}"}]}], "]"}], "}"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "temp$damp", "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Del\>\"", ",", "\"\<Copy\>\"", ",", "\"\<Edit\>\"", 
                  ",", "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                  "\"\<Body2\>\"", ",", "\"\<Damping Point in Body1 [mm]\>\"",
                   ",", "\[IndentingNewLine]", 
                  "\"\<Damping Point in Body2 [mm]\>\""}], "}"}]}], "}"}]}]}],
             "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"--", 
              RowBox[{"-", "Save"}]}], " ", "&"}], " ", "Cancel", " ", 
            RowBox[{"Button", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TableForm", "[", 
          RowBox[{"{", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<Save\>\"", ",", "Bold"}], "]"}], ",", 
               RowBox[{"DialogReturn", "[", 
                RowBox[{"save$damp", "=", "temp$damp"}], "]"}]}], "]"}], ",", 
             RowBox[{"(*", 
              RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Button", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", 
               RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
          RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WindowElements", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
          ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
       RowBox[{"WindowSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"800", ",", "500"}], "}"}]}], ",", 
       RowBox[{"WindowTitle", "\[Rule]", "\"\<2-5 Set Damper\>\""}]}], 
      "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.567090289078162*^9, 3.5670903067361717`*^9}, {
   3.567090365687544*^9, 3.5670903665405927`*^9}, {3.567155589649859*^9, 
   3.5671556278810453`*^9}, {3.5671656067648053`*^9, 3.567165632933302*^9}, {
   3.567165665979192*^9, 3.567165742941594*^9}, {3.5671657799887133`*^9, 
   3.5671659026437283`*^9}, {3.567177562374033*^9, 3.567177586771428*^9}, {
   3.5671776462458305`*^9, 3.567177649960043*^9}, 3.567177777776353*^9, {
   3.5671778544427385`*^9, 3.5671778954130816`*^9}, {3.567177929535033*^9, 
   3.567177936806449*^9}, {3.5671780073014812`*^9, 3.567178007519494*^9}, 
   3.56717809644658*^9, {3.5671781410301304`*^9, 3.567178263704147*^9}, {
   3.567178304802498*^9, 3.5671784408932815`*^9}, {3.567178518006692*^9, 
   3.5671785431341295`*^9}, {3.56717859962236*^9, 3.567178670195397*^9}, 
   3.5671788107774377`*^9, {3.5671789212027535`*^9, 3.567178957342821*^9}, {
   3.5671792975102773`*^9, 3.5671793377115765`*^9}, {3.5671793795879717`*^9, 
   3.5671793878684454`*^9}, {3.5671794237664986`*^9, 3.567179489629266*^9}, {
   3.5671795234421997`*^9, 3.567179550235732*^9}, {3.5671795933161964`*^9, 
   3.567179604652845*^9}, {3.5671797016303916`*^9, 3.567180033549376*^9}, {
   3.5672461621106453`*^9, 3.567246409538798*^9}, {3.5672464456878653`*^9, 
   3.5672464636228914`*^9}, {3.567246499549946*^9, 3.567246512287675*^9}, {
   3.5672465453445654`*^9, 3.5672467605618753`*^9}, {3.567246843531621*^9, 
   3.567246858570481*^9}, {3.5673556064393425`*^9, 3.5673556248813972`*^9}, {
   3.5673556915182085`*^9, 3.567355700154702*^9}, {3.567572892000472*^9, 
   3.5675728980608187`*^9}, {3.567614484291556*^9, 3.5676145453320475`*^9}, 
   3.567616673801789*^9, {3.567618139302611*^9, 3.5676181401056566`*^9}, {
   3.56762164421208*^9, 3.5676216852464275`*^9}, {3.5676217446198235`*^9, 
   3.5676218514359326`*^9}, {3.5676219178527317`*^9, 
   3.5676220568706827`*^9}, {3.5676221918164015`*^9, 
   3.5676222071522784`*^9}, {3.567622298932528*^9, 3.5676226059840903`*^9}, {
   3.567622653268795*^9, 3.567622762087019*^9}, {3.5676228279907885`*^9, 
   3.5676228287248306`*^9}, {3.5676229684518223`*^9, 
   3.5676229750672007`*^9}, {3.5676232357591114`*^9, 3.567623360141226*^9}, {
   3.567623416435446*^9, 3.5676234246159134`*^9}, {3.5676235691631813`*^9, 
   3.5676235919434843`*^9}, {3.567623740592986*^9, 3.567623794581074*^9}, {
   3.5676239398383827`*^9, 3.5676239413994713`*^9}, {3.5676239858240128`*^9, 
   3.567624020625003*^9}, 3.5676241403928537`*^9, {3.5676241899046855`*^9, 
   3.567624226606785*^9}, {3.567624388524046*^9, 3.5676244142165155`*^9}, {
   3.567624529660118*^9, 3.5676245479871664`*^9}, {3.5676251435982337`*^9, 
   3.5676251759730854`*^9}, {3.569956663518799*^9, 3.5699566640068264`*^9}, {
   3.5701328358991976`*^9, 3.5701328404004545`*^9}, {3.570132928971521*^9, 
   3.570132993781228*^9}, {3.570133130402042*^9, 3.57013330292691*^9}, {
   3.570133370274762*^9, 3.5701336159098115`*^9}, {3.5701337328565006`*^9, 
   3.570133740900961*^9}, {3.570133793500969*^9, 3.570133866837164*^9}, {
   3.570133922837367*^9, 3.570133959483463*^9}, {3.5701340024389195`*^9, 
   3.570134004176019*^9}, {3.5701340390380135`*^9, 3.570134399964657*^9}, {
   3.5701345150742407`*^9, 3.570134521897631*^9}, {3.5701708280167055`*^9, 
   3.5701708368292093`*^9}, {3.570172706417144*^9, 3.570172716406715*^9}, {
   3.5701909999904757`*^9, 3.5701910606849475`*^9}, {3.5701910907006645`*^9, 
   3.5701913324944944`*^9}, {3.5701913642633114`*^9, 3.570191446531017*^9}, {
   3.570191895849716*^9, 3.5701919160478716`*^9}, {3.5701919619784985`*^9, 
   3.5701919866799116`*^9}, {3.5701920187137437`*^9, 3.570192068846611*^9}, {
   3.5701922918473663`*^9, 3.570192294489517*^9}, {3.5701944827046757`*^9, 
   3.5701945184357195`*^9}, {3.5701945832414265`*^9, 3.570194647521103*^9}, {
   3.5701948890339165`*^9, 3.5701949443150787`*^9}, {3.5701957814819617`*^9, 
   3.570195787255292*^9}, {3.5701973331037097`*^9, 3.5701973880548525`*^9}, {
   3.5702144225754123`*^9, 3.570214477450551*^9}, {3.570214542962298*^9, 
   3.570214550933754*^9}, {3.5702145822395444`*^9, 3.5702146113182077`*^9}, {
   3.5702148685819225`*^9, 3.5702149912309375`*^9}, {3.5702150312962294`*^9, 
   3.570215260036312*^9}, {3.5702153479443407`*^9, 3.570215358169925*^9}, {
   3.5702153951000376`*^9, 3.5702154855302095`*^9}, {3.5702156961372557`*^9, 
   3.5702157696294594`*^9}, {3.570253694455166*^9, 3.5702537367545853`*^9}, {
   3.5702545698614345`*^9, 3.570254571546237*^9}, {3.5702546071767*^9, 
   3.5702546845372353`*^9}, {3.570254726376509*^9, 3.570254856075137*^9}, {
   3.570255019939825*^9, 3.570255031405845*^9}, {3.570255129765018*^9, 
   3.5702551311534204`*^9}, {3.570255169747888*^9, 3.5702551730238943`*^9}, {
   3.570255530592122*^9, 3.5702555347105293`*^9}, {3.5702559490326567`*^9, 
   3.570255949141857*^9}, {3.5702570683362246`*^9, 3.5702570687574253`*^9}, {
   3.5702571053862896`*^9, 3.5702571054174895`*^9}, {3.570257351476722*^9, 
   3.5702573605403376`*^9}, {3.570257458087309*^9, 3.570257458102909*^9}, {
   3.5702581019962406`*^9, 3.570258106286248*^9}, {3.5702582635355244`*^9, 
   3.570258266171929*^9}, 3.570258358492891*^9, {3.5702587780616283`*^9, 
   3.5702588431761427`*^9}, {3.570258916621072*^9, 3.570258917291873*^9}, {
   3.5702884243813577`*^9, 3.5702884417093487`*^9}, {3.570288777747569*^9, 
   3.5702888033730345`*^9}, {3.570288849397667*^9, 3.5702888597082567`*^9}, {
   3.5702889228348675`*^9, 3.570288947391272*^9}, {3.5702890061826344`*^9, 
   3.5702890062736397`*^9}, {3.570290644094318*^9, 3.570290718801591*^9}, {
   3.570296382123514*^9, 3.5702964183635874`*^9}, {3.570296517987285*^9, 
   3.5702965183553066`*^9}, {3.570379132066285*^9, 3.570379177379877*^9}, {
   3.5703792463608227`*^9, 3.5703792641828413`*^9}, {3.5703793326957607`*^9, 
   3.570379349889744*^9}, {3.5704632234888473`*^9, 3.5704632237538624`*^9}, {
   3.5704670111594896`*^9, 3.57046702900751*^9}, {3.570554565202813*^9, 
   3.570554678762308*^9}, {3.5705547488923197`*^9, 3.5705548366673403`*^9}, {
   3.5705548715923376`*^9, 3.57055509508012*^9}, {3.570555137961573*^9, 
   3.5705551490792093`*^9}, {3.570555198976063*^9, 3.5705552305728703`*^9}, {
   3.5705556839738035`*^9, 3.5705557458073397`*^9}, {3.5705564254792147`*^9, 
   3.5705564266442814`*^9}, {3.5705567227412176`*^9, 
   3.5705567372760487`*^9}, {3.5706409718181868`*^9, 
   3.5706410807024145`*^9}, {3.570641807709997*^9, 3.570641873310749*^9}, {
   3.570642052996027*^9, 3.5706420557851863`*^9}, 3.570983893867327*^9, {
   3.5709839496155157`*^9, 3.5709839502785535`*^9}, {3.571134068286942*^9, 
   3.5711340688669753`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New Damper", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}, {
  3.570641133505435*^9, 3.5706411346715016`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$NewDamper", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<New Damper\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newdamp", "=", 
          RowBox[{"{", 
           RowBox[{"\"\<\>\"", ",", "1", ",", "2", ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "6", "}"}], ",", 
              RowBox[{"{", "6", "}"}]}], "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", 
           RowBox[{"temp$newdamp", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "String", ",", 
          RowBox[{"FieldSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Between:\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Position of Damper\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Strength Matrix\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"m", "=", "m"}], ",", 
                  RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newdamp", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
               "]"}], ",", "Number", ",", "\[IndentingNewLine]", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"temp$damp", ",", "temp$newdamp"}], "]"}], "]"}]}], 
             "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<New Heat Links\>\""}]}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.570556497216318*^9, 3.570556522296753*^9}, {3.570556591024684*^9, 
   3.570556596014969*^9}, {3.570641142195932*^9, 3.5706412688181744`*^9}, {
   3.5706413104835577`*^9, 3.570641414668516*^9}, {3.570641461152175*^9, 
   3.5706415630410028`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Edit Damper", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.567624134284504*^9, 3.5676241367076426`*^9}, {
  3.570195341515797*^9, 3.570195342285841*^9}, {3.5702537535235443`*^9, 
  3.5702537544065948`*^9}, {3.5703794785801044`*^9, 3.570379478921124*^9}, {
  3.570641133505435*^9, 3.5706411346715016`*^9}, {3.5706418898026924`*^9, 
  3.57064189028572*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mod$EditDamper", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", 
           RowBox[{"Title", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<New Damper\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "New"}]}], " ", "flexure", " ", "temporary", " ", 
           RowBox[{"list", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp$newdamp", "=", 
          RowBox[{"temp$damp", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Name", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Name\>\"", ",", "\[IndentingNewLine]", "Bold", ",", "Italic",
              ",", "Black"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"1", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{
          RowBox[{"Dynamic", "[", 
           RowBox[{"temp$newdamp", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "String", ",", 
          RowBox[{"FieldSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"8.", ",", "1."}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Bodies", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Between:\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<Body1:\>\"", ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", "\"\<Body2:\>\"", 
            ",", 
            RowBox[{"PopupMenu", "[", 
             RowBox[{
              RowBox[{"Dynamic", "[", 
               RowBox[{"temp$newdamp", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"m", "\[Rule]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "2"}], "]"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], 
               "]"}]}], "]"}]}], "}"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Geometry", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Position of Damper\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.9", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body1:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"4", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<x\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<y\>\"", ",", "Small"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<z\>\"", ",", "Small"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "\"\<Body2:\>\"", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"With", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", "=", "m"}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Dynamic", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "/", "mm"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"temp$newdamp", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "m"}], "]"}], "]"}], "=", 
                    RowBox[{"#", "*", "mm"}]}], ")"}], "&"}]}], "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", "Number", ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"Stiffness", "--"}]}]}], "-"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Damping Strength Matrix\>\"", ",", "\[IndentingNewLine]", 
            "Bold", ",", "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.8"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InputField", "[", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"m", "=", "m"}], ",", 
                  RowBox[{"l", "=", "l"}]}], "}"}], ",", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"temp$newdamp", "[", 
                  RowBox[{"[", 
                   RowBox[{"6", ",", "m", ",", "l"}], "]"}], "]"}], "]"}]}], 
               "]"}], ",", "Number", ",", "\[IndentingNewLine]", 
              RowBox[{"FieldSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"l", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "6"}], "}"}]}], "]"}], ",", 
          RowBox[{"TableHeadings", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
               "\"\<Pitch\>\"", ",", "\"\<Yaw\>\"", ",", "\"\<Roll\>\""}], 
              "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", "Create"}]}], " ", 
           RowBox[{"Flexure", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Finish\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
            "Italic", ",", "Black"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0.6", ",", "0.6"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Create\>\"", ",", "Bold"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{
                RowBox[{"temp$damp", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "=", "temp$newdamp"}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"(*", 
             RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{"\"\<Cancel\>\"", ",", 
              RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Dialog"}]}], " ", "Window", " ", 
         RowBox[{"Setting", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<New Heat Links\>\""}]}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5673557095952425`*^9, 3.5673557254521494`*^9}, {
   3.567355760692165*^9, 3.5673557767730846`*^9}, {3.567355840367722*^9, 
   3.5673559150809956`*^9}, {3.567355956898387*^9, 3.567356021582087*^9}, {
   3.5673560817015257`*^9, 3.5673562259767776`*^9}, {3.5673562599137187`*^9, 
   3.5673564363988132`*^9}, {3.5673564715948267`*^9, 3.567356526573971*^9}, {
   3.567356590527629*^9, 3.5673568068640027`*^9}, {3.5673568442861433`*^9, 
   3.567356947052021*^9}, {3.56735705438916*^9, 3.567357068099944*^9}, {
   3.567357163760416*^9, 3.5673573743474607`*^9}, {3.5673574285405607`*^9, 
   3.5673575809932804`*^9}, {3.5673576288290167`*^9, 
   3.5673576739755983`*^9}, {3.567357707626523*^9, 3.5673577783385677`*^9}, {
   3.567357955538703*^9, 3.567357968395438*^9}, {3.567358024945673*^9, 
   3.567358200673724*^9}, {3.567358263125296*^9, 3.567358352868429*^9}, 
   3.567360128917013*^9, {3.5673604609160023`*^9, 3.567360521506468*^9}, {
   3.5673606045272164`*^9, 3.567360636633053*^9}, {3.5673607816493473`*^9, 
   3.567360806102746*^9}, {3.567361081559501*^9, 3.567361090368005*^9}, {
   3.567361135353578*^9, 3.5673611594159546`*^9}, {3.5673612824149895`*^9, 
   3.567361283492051*^9}, {3.5675717209854937`*^9, 3.5675718118906927`*^9}, {
   3.5675718854809017`*^9, 3.567572206948289*^9}, {3.5675723199277515`*^9, 
   3.567572328780257*^9}, {3.5675725269755936`*^9, 3.567572557038313*^9}, {
   3.5675735368273535`*^9, 3.567573602216094*^9}, {3.567573632781842*^9, 
   3.567573719172783*^9}, {3.567573779095211*^9, 3.5675739252585707`*^9}, {
   3.567614561219956*^9, 3.567614565680211*^9}, {3.56761468735017*^9, 
   3.567614868528533*^9}, {3.56761492530278*^9, 3.5676149576396303`*^9}, {
   3.567615003669263*^9, 3.5676150063754177`*^9}, {3.5676151462834196`*^9, 
   3.567615152737789*^9}, {3.567615216103413*^9, 3.567615313045958*^9}, {
   3.567615403180114*^9, 3.5676154250343637`*^9}, {3.5676154700079355`*^9, 
   3.567615481306582*^9}, {3.567615532727523*^9, 3.5676156294660563`*^9}, {
   3.567615693427715*^9, 3.5676157480618396`*^9}, {3.5676158067601967`*^9, 
   3.567615874627079*^9}, {3.5676161542980747`*^9, 3.5676162608521695`*^9}, {
   3.5676165888319287`*^9, 3.567616630735326*^9}, 3.567616686308504*^9, {
   3.5676167398575673`*^9, 3.567616745486889*^9}, {3.567617220025031*^9, 
   3.567617229075549*^9}, {3.5676173677664814`*^9, 3.567617423499669*^9}, {
   3.5676174904264975`*^9, 3.567617551741004*^9}, {3.5676176413891315`*^9, 
   3.5676176886918373`*^9}, {3.5676177232608147`*^9, 
   3.5676178774656343`*^9}, {3.567617991979184*^9, 3.567617997603506*^9}, {
   3.5676181310791407`*^9, 3.5676181333052673`*^9}, {3.567618273263273*^9, 
   3.567618352327795*^9}, {3.567618610577566*^9, 3.5676186139367585`*^9}, {
   3.567619626336664*^9, 3.5676198639712563`*^9}, 3.5676207461377134`*^9, {
   3.5676211510618734`*^9, 3.567621179730513*^9}, {3.5676234956569767`*^9, 
   3.5676235008262725`*^9}, {3.567624098344448*^9, 3.567624119153639*^9}, {
   3.56995666406383*^9, 3.5699566677910433`*^9}, 3.57010974231432*^9, {
   3.570172770940834*^9, 3.570172872675653*^9}, {3.5701729070276175`*^9, 
   3.570172940582537*^9}, {3.5701730710359983`*^9, 3.5701732768877726`*^9}, {
   3.5701733079895515`*^9, 3.570173365529843*^9}, {3.5701734031899967`*^9, 
   3.570173480038392*^9}, {3.570173546560197*^9, 3.5701735651612606`*^9}, 
   3.570173681354907*^9, {3.570173748126726*^9, 3.5701740290927963`*^9}, {
   3.5701751972226095`*^9, 3.5701751984156775`*^9}, {3.570175278565262*^9, 
   3.570175500971983*^9}, {3.570175542515359*^9, 3.570175606312008*^9}, {
   3.570175658387987*^9, 3.5701758774175143`*^9}, {3.5701759196089277`*^9, 
   3.5701760144953547`*^9}, 3.570176051699483*^9, 3.570179192427122*^9, {
   3.570179256876808*^9, 3.5701793196954017`*^9}, {3.5701793824469905`*^9, 
   3.5701794037802105`*^9}, {3.570179436876104*^9, 3.5701795064690847`*^9}, {
   3.5701796541095285`*^9, 3.57017965622465*^9}, {3.5701797854850435`*^9, 
   3.5701798566981163`*^9}, {3.5701798927631793`*^9, 3.570179893281209*^9}, {
   3.5701799853334737`*^9, 3.570180070671355*^9}, {3.570180106704416*^9, 
   3.570180110369625*^9}, {3.5701802471984515`*^9, 3.570180405314495*^9}, {
   3.570180437319326*^9, 3.5701805047601833`*^9}, {3.5701805352259254`*^9, 
   3.5701805594053087`*^9}, {3.5701806008436785`*^9, 
   3.5701808375452175`*^9}, {3.570180948377557*^9, 3.5701810242338953`*^9}, {
   3.570181118531289*^9, 3.5701811367703323`*^9}, {3.5701811689291716`*^9, 
   3.5701812486537313`*^9}, {3.570181565128833*^9, 3.5701818277408533`*^9}, {
   3.570181861004756*^9, 3.570181910006559*^9}, {3.570182232883026*^9, 
   3.570182255435316*^9}, {3.570182593644661*^9, 3.5701826047802973`*^9}, {
   3.570182781702417*^9, 3.5701827884238014`*^9}, {3.5701830522688923`*^9, 
   3.570183161916164*^9}, {3.5701832363974237`*^9, 3.570183246428998*^9}, {
   3.5701832805829515`*^9, 3.570183280754961*^9}, {3.5701834054700947`*^9, 
   3.5701835719706173`*^9}, {3.570185479006694*^9, 3.5701854834459476`*^9}, {
   3.5701865680499835`*^9, 3.570186586255025*^9}, {3.570186638926038*^9, 
   3.570186785976448*^9}, {3.5701873657816114`*^9, 3.570187484283389*^9}, {
   3.570187737900895*^9, 3.570187744477271*^9}, {3.5701949692625055`*^9, 
   3.5701952046029663`*^9}, {3.570195684120393*^9, 3.5701957755506225`*^9}, {
   3.5701960962749667`*^9, 3.570196178281657*^9}, {3.5701962097524576`*^9, 
   3.5701962898100367`*^9}, {3.57019637064666*^9, 3.570196512142753*^9}, {
   3.570196600066782*^9, 3.570196682683508*^9}, {3.5701967408028316`*^9, 
   3.570196750234371*^9}, 3.5701971828111134`*^9, {3.5701972400693884`*^9, 
   3.5701972457017107`*^9}, {3.5701974403368425`*^9, 3.570197523721612*^9}, {
   3.570197562522832*^9, 3.5701976483387403`*^9}, {3.570213991780772*^9, 
   3.570214100561994*^9}, {3.570214216280613*^9, 3.5702142290023403`*^9}, {
   3.570214634854554*^9, 3.5702147571465483`*^9}, {3.5702150024455786`*^9, 
   3.5702150078548884`*^9}, {3.5702152714019623`*^9, 3.570215272027998*^9}, {
   3.5702160956451063`*^9, 3.57021625953948*^9}, {3.5702537567197275`*^9, 
   3.570253775732815*^9}, {3.570253840738533*^9, 3.5702539074963512`*^9}, {
   3.5702539412882843`*^9, 3.5702540639452996`*^9}, {3.570254099898356*^9, 
   3.570254161905118*^9}, {3.570254224258427*^9, 3.5702542396556544`*^9}, {
   3.5702543241142025`*^9, 3.5702545623422213`*^9}, {3.5702547803838043`*^9, 
   3.570254780727005*^9}, {3.570254876043172*^9, 3.570254929192466*^9}, {
   3.5702549764605484`*^9, 3.5702550066642017`*^9}, {3.5702551090939817`*^9, 
   3.5702551135555897`*^9}, 3.5702551786867037`*^9, {3.570255224784785*^9, 
   3.5702552785424795`*^9}, {3.570255396151086*^9, 3.570255399707892*^9}, {
   3.57025544981518*^9, 3.570255690211602*^9}, {3.5702559214508085`*^9, 
   3.570255943463447*^9}, {3.5702570689914255`*^9, 3.5702570694126263`*^9}, {
   3.5702571054330893`*^9, 3.5702571054642897`*^9}, {3.5702573655479465`*^9, 
   3.5702573743619623`*^9}, {3.5702574581185093`*^9, 3.570257458149709*^9}, {
   3.570258112276658*^9, 3.5702581202804728`*^9}, {3.5702582682623324`*^9, 
   3.570258270602337*^9}, 3.5702583607548947`*^9, {3.5702885689536266`*^9, 
   3.5702887500649853`*^9}, {3.5702890028184423`*^9, 3.570289002936449*^9}, {
   3.5702890802778726`*^9, 3.5702890933546205`*^9}, {3.570290620218952*^9, 
   3.5702906368169017`*^9}, {3.570290731691328*^9, 3.57029074379002*^9}, {
   3.5702928264971437`*^9, 3.57029282782022*^9}, {3.5702937660998864`*^9, 
   3.5702937679819937`*^9}, {3.570379488205655*^9, 3.570379498294232*^9}, {
   3.570379545444929*^9, 3.570379612227749*^9}, {3.5703796615355687`*^9, 
   3.5703796662068357`*^9}, {3.5703797093993063`*^9, 
   3.5703797116984377`*^9}, {3.570379806653869*^9, 3.5703802050316553`*^9}, {
   3.570463494072324*^9, 3.5704635015887537`*^9}, {3.5704637311128817`*^9, 
   3.570463731695915*^9}, {3.57046377094716*^9, 3.5704638185248814`*^9}, {
   3.570463930025259*^9, 3.57046420680509*^9}, {3.570464251957672*^9, 
   3.5704643207626076`*^9}, {3.570464374669691*^9, 3.5704644181991806`*^9}, {
   3.570464529711559*^9, 3.570464533542778*^9}, {3.57046463061233*^9, 
   3.570464744114822*^9}, {3.5704647927266026`*^9, 3.570465206500269*^9}, 
   3.570465252779916*^9, {3.5704653072630324`*^9, 3.57046537226175*^9}, {
   3.5704654876333485`*^9, 3.5704655402003555`*^9}, {3.5704655737422743`*^9, 
   3.570465670166789*^9}, {3.570465701638589*^9, 3.570465710945122*^9}, {
   3.570465744539043*^9, 3.5704657582908297`*^9}, 3.57046584535981*^9, {
   3.570465875602539*^9, 3.5704659126846604`*^9}, {3.5704659738601594`*^9, 
   3.5704659844567657`*^9}, {3.5704660322594995`*^9, 3.570466124348767*^9}, {
   3.5704661572316475`*^9, 3.5704661987940245`*^9}, {3.570466370992874*^9, 
   3.570466442185946*^9}, {3.570466612572692*^9, 3.5704667279352903`*^9}, {
   3.570466891173627*^9, 3.5704668993720956`*^9}, {3.5705364046346254`*^9, 
   3.570536404994646*^9}, {3.5705368114198923`*^9, 3.5705368167741985`*^9}, {
   3.57053724881691*^9, 3.5705372593335114`*^9}, {3.5705373726109905`*^9, 
   3.570537404268801*^9}, {3.5705374354795866`*^9, 3.57053744026686*^9}, {
   3.5705381821992965`*^9, 3.570538196055089*^9}, {3.570553693079931*^9, 
   3.5705537003453465`*^9}, {3.5705560233542147`*^9, 
   3.5705561751768985`*^9}, {3.570556348236797*^9, 3.5705563933023744`*^9}, {
   3.570556497216318*^9, 3.570556522296753*^9}, {3.570556591024684*^9, 
   3.570556596014969*^9}, {3.570641142195932*^9, 3.5706412688181744`*^9}, {
   3.5706413104835577`*^9, 3.570641414668516*^9}, {3.570641461152175*^9, 
   3.5706415630410028`*^9}, {3.57064190828975*^9, 3.570641967089113*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2-L Show Connection List", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5701244725708427`*^9, 3.570124479552242*^9}, {
  3.570127979301416*^9, 3.57012797972544*^9}, {3.570642256285654*^9, 
  3.570642256423662*^9}, {3.57064229362879*^9, 3.5706423008012004`*^9}}],

Cell[CellGroupData[{

Cell["Show Connection List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570124483440464*^9, 3.570124486847659*^9}, {
  3.570642296714967*^9, 3.570642299024099*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ShowConnectionList", ":=", "\[IndentingNewLine]", 
   RowBox[{"Dynamic", "[", 
    RowBox[{"Pane", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TableForm", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"--", 
           RowBox[{"-", 
            RowBox[{"wire", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Wire:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$wire", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$wire", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "13"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$mat", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "1"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "/", "meter"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}], "/", "mm"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", "\"\<Body2\>\"",
                     ",", "\"\<Material\>\"", ",", "\"\<L [m]\>\"", ",", 
                    "\"\<D [mm]\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$wire", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"spring", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Vertical Spring:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$vspr", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$vspr", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "8"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "2"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "2"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "9"}], "]"}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", "\"\<Body2\>\"",
                     ",", "\"\<k [N/m]\>\"", ",", "\"\<fp [N]\>\"", ",", 
                    "\"\<Q\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$vspr", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"IP", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Inverted Pendulum:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$IP", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$IP", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$IP", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "6"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                    "\"\<Body2\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$IP", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"HL", "--"}]}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Heat Link:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$HL", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$HL", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "10"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "1"}], "]"}], "]"}], "/", 
                  "mm"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "2"}], "]"}], "]"}], "/", 
                  "mm"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5", ",", "3"}], "]"}], "]"}], "/", 
                  "mm"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", "\"\<Body2\>\"",
                     ",", "\"\<x [mm]\>\"", ",", "\"\<y [mm]\>\"", ",", 
                    "\"\<z [mm]\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$HL", ";", "\"\<No Data\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"--", 
            RowBox[{"-", 
             RowBox[{"Damper", "--"}]}]}], "-"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Damper:\>\"", ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.6", ",", "0", ",", "0"}], "]"}], ",", "Bold"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "save$damp", "]"}], "&&", 
            RowBox[{"Not", "[", 
             RowBox[{"save$damp", "===", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TableForm", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"save$damp", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"save$damp", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "save$damp", "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TableHeadings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"None", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Style", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0.6"}], "]"}]}], "]"}], 
                    ")"}], "&"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Name\>\"", ",", "\"\<Body1\>\"", ",", 
                    "\"\<Body2\>\""}], "}"}]}], "]"}]}], "}"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"save$HL", ";", "\"\<No Data\>\""}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"640", ",", "300"}], "}"}]}], ",", 
      RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0FtMkgEABWAya02HGWyNLnPRUGhdcDLoMuJSNor9w1aNS+AqNm2hm9jS
kHhoI4oiL2QxwxedD7FIY1pmPVitKA2zCxQbs5UuNJGNItoKavaf/+Hs29l5
O2xjw6GaPBqNxicD6elvc5abCbnX61/eQlqrv14M16/sZcCudaUsuELDo6z4
7uTDheNtlF/2CISwhxciYL49pIH7C3wn4Of471NQXa8xwz+NdgecjPY54UW3
sRUS2Vvt8GOLshfKmhdGoGog8hWabYpZmHkvTsCd8WQSPjEV/oRKS/4vaFq8
zLGSlnPPc2GYKZDALKtTCol0RAHvnJMQUKZLaOHJymod/GAc90MGwQrA04Pz
Q/CMpOAxfFjWeNtGOlO1qx/Knx0ehIaB4Aj0but6BdMljtewp68i0OQl/wrb
Kc0dTfch55JvAo4yYmEoUlg/QfZV3zQ0ZjkZ2NFQnYNEMLCqmVQs7GbBGJPP
huqSSS5ULZvmU7t0SgB1MzUiqhvGdkNtlK2Aee/mlDA09rYKsjxHjkJbxqKH
G8QHjsGi1HYjrF9TVwsDqdKzUM+M2qB1MdUKPTuG3HCrq80PDbl4AHIOvhiF
Zb6pIOS1d47Da9L+e1dIK51pynnPWuEN0gseF6V2yabnsu6EfONqx0s4XEd/
A1UuUYzqe3882kcqzkWewuG/E2oT/FesgUXl7i30B+R/S/2Us4V31ZtJk4oY
5X8lf4ww
  "]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3. Start Calculation", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571490350229124*^9, 3.5714903529702806`*^9}}],

Cell[CellGroupData[{

Cell["Start Calc", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.57077107372034*^9, 3.570771080451725*^9}, {
  3.5714903912014675`*^9, 3.5714903915454874`*^9}}],

Cell[CellGroupData[{

Cell["Start Calc", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570771084461954*^9, 3.5707710862820587`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$StartCalc", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"mod$OpenStatus", ";", "\[IndentingNewLine]", 
     RowBox[{"mod$WriteStatus", "[", "\"\<Compliance check...\>\"", "]"}], 
     ";", "\[IndentingNewLine]", "mod$CheckModel", ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"calc$sflag", "\[Equal]", "0"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"mod$WriteStatus", "[", "\"\<Stop Calculation\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$StartSUMCON", ";"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Compliance check: OK.\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Model construction starts...\>\"", "]"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"mod$WriteStatus", "[", "\"\<Setting variables...\>\"", "]"}],
         ";", "\[IndentingNewLine]", "mod$SetVars", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Variables have been set.\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Setting body positions...\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$SetBodyPos", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Body positions have been set.\>\"", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Generating necessary lists...\>\"", 
         "]"}], ";", "\[IndentingNewLine]", "mod$SetList", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", 
         "\"\<Bodylist, wirelist, damperlist have been set.\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Calculating energy terms...\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$CalcEnergy", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Energy terms have been set.\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", 
         "\"\<Setting initial values of variables...\>\"", "]"}], ";", 
        "\[IndentingNewLine]", "mod$SetInitVal", ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Initial conditions have been set.\>\"", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Finding equilibrium position...\>\"", 
         "]"}], ";", "\[IndentingNewLine]", "mod$FindEquilibrium", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Equilibrium position has been set.\>\"", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"mod$WriteStatus", "[", "\"\<Start linearization:\>\"", "]"}],
         ";", "\[IndentingNewLine]", "mod$CalcMatrices", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Matrices have been set.\>\"", "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Calculating eigen modes...\>\"", "]"}], 
        ";", "\[IndentingNewLine]", "mod$EigenCalc", ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "mod$WriteStatus", "[", "\"\<Eigen modes have been set.\>\"", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "mod$WriteStatus", "[", "\"\<Now opening calculation menu...\>\"", 
           "]"}], ";", "\[IndentingNewLine]", "mod$CalcMenu", ";"}], "*)"}], 
        "\[IndentingNewLine]", "mod$CloseStatus", ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.57077108770614*^9, 3.57077132251457*^9}, {
   3.570771420613181*^9, 3.570771424352395*^9}, {3.570771456895256*^9, 
   3.570771458405343*^9}, {3.570771505896059*^9, 3.570771515024581*^9}, {
   3.570771562748311*^9, 3.5707715659784956`*^9}, {3.5707716225497313`*^9, 
   3.5707717401314564`*^9}, {3.570772287865785*^9, 3.5707722881338005`*^9}, {
   3.5707723643241587`*^9, 3.5707724569524565`*^9}, 3.5707724891612988`*^9, {
   3.5707730659162874`*^9, 3.5707730901236715`*^9}, {3.5707736141956472`*^9, 
   3.5707736692797976`*^9}, {3.570784815391319*^9, 3.570784829628133*^9}, {
   3.5708708949422817`*^9, 3.5708709531186094`*^9}, {3.5708710025184345`*^9, 
   3.570871004396542*^9}, {3.570871082717022*^9, 3.570871085437177*^9}, {
   3.5708950041256313`*^9, 3.5708950111180315`*^9}, {3.5708957818831167`*^9, 
   3.5708957883234854`*^9}, {3.570898179719265*^9, 3.570898188455765*^9}, {
   3.5712202995157566`*^9, 3.5712203067271695`*^9}, {3.571329482224295*^9, 
   3.571329485473481*^9}, {3.5713387873135157`*^9, 3.5713387913097444`*^9}, {
   3.571419742610602*^9, 3.5714197497780123`*^9}, {3.5714197805777736`*^9, 
   3.5714198888459663`*^9}, {3.5714199445471525`*^9, 3.571419988660675*^9}, {
   3.5714200396385913`*^9, 3.5714200440888453`*^9}, {3.57142028317352*^9, 
   3.5714202880077972`*^9}, {3.5714241012899046`*^9, 3.571424519607831*^9}, {
   3.5714247863140855`*^9, 3.5714248676447372`*^9}, {3.57142544097253*^9, 
   3.5714256007506685`*^9}, {3.571425670690669*^9, 3.5714256741488667`*^9}, {
   3.571425831636874*^9, 3.571425836921177*^9}, {3.585634121932449*^9, 
   3.5856341325980587`*^9}, {3.5856341937455564`*^9, 3.5856341941335783`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check Model", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714200516522784`*^9, 3.571420058220654*^9}}],

Cell[CellGroupData[{

Cell["Check Model", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714200606427927`*^9, 3.571420062613905*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CheckModel", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bdnt", ",", "bdnc"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"calc$sflag", "=", "0"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Body", " ", "Name"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$bdn", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$bdn", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", "\"\<Bodies are not registered yet.\>\"", 
            "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"save$bdn", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", "True"}], "]"}], 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", 
            "\"\<You need at least one 'ground' body.\>\"", "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"save$bdn", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", "False"}], "]"}],
            "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", 
            "\"\<You need at least one non-ground body.\>\"", "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bdnt", "=", 
         RowBox[{
          RowBox[{"Tally", "[", 
           RowBox[{"save$bdn", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bdnc", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"bdnt", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "1"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "bdnt", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"bdnc", ",", "False"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteError", "[", "\"\<Duplicated body names found.\>\"", 
            "]"}], ";", 
           RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", "Mass", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"save$mass", "[", 
          RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
        RowBox[{"save$mass", "===", 
         RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Mass and moment of inertia are not registered yet.\>\"", "]"}], 
        ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], ">", 
        RowBox[{"Length", "[", "save$mass", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Mass and moment of inertia are not registered completely.\>\"", 
         "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Body", " ", "Shape"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"save$mass", "[", 
          RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
        RowBox[{"save$mass", "===", 
         RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", "\"\<Body shapes are not registered yet.\>\"", 
         "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], ">", 
        RowBox[{"Length", "[", "save$shape", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Body shapes are not registered completely.\>\"", "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Body", " ", "Position"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"save$initpos", "[", 
          RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
        RowBox[{"save$initpos", "===", 
         RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Body initial positions are not registered yet.\>\"", "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "save$bdn", "]"}], ">", 
        RowBox[{"Length", "[", "save$initpos", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "mod$WriteError", "[", 
         "\"\<Body initial positions are not registered completely.\>\"", 
         "]"}], ";", 
        RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", "Wires", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "wire1", ",", "wire2", ",", "wirec", ",", "spt", ",", "spc", ",", 
         "ip1", ",", "ip2", ",", "hl1", ",", "hl2", ",", "con"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$wire", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteStatus", "[", "\"\<No wires registered.\>\"", "]"}], ";", 
           RowBox[{"wire1", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"wire2", "=", 
            RowBox[{"{", "}"}]}], ";"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"wire1", "=", 
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
           RowBox[{"wire2", "=", 
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"wire1", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", 
                RowBox[{"wire2", "[", 
                 RowBox[{"[", "n", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Wire \>\"", "<>", 
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "<>", 
                  "\"\< attached to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wirec", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "14"}], "]"}], "]"}], ">", "0"}], "&&", 
               RowBox[{
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "15"}], "]"}], "]"}], ">", "0"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}]}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{"wirec", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Wire \>\"", "<>", 
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "13"}], "]"}], "]"}], "<>", 
                  "\"\< has 0 or negative stiffness.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "Springs", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$vspr", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$vspr", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "mod$WriteStatus", "[", "\"\<No vertical springs registered.\>\"", 
           "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$vspr", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ">", 
                RowBox[{"Length", "[", "save$wire", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Spring \>\"", "<>", 
                  RowBox[{"save$vspr", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "<>", 
                  "\"\< is not connected to a wire.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "3"}], "]"}], "]"}], ">", "0"}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Spring \>\"", "<>", 
                  RowBox[{"save$vspr", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "8"}], "]"}], "]"}], "<>", 
                  "\"\< has 0 or negative stiffness.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Abort", "[", "]"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"spt", "=", 
            RowBox[{
             RowBox[{"Tally", "[", 
              RowBox[{"save$vspr", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "8"}], "]"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"spc", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"spt", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "1"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "spt", "]"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{"spc", ",", "False"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "mod$WriteError", "[", "\"\<Duplicated spring names found.\>\"",
                "]"}], ";", 
              RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "IP", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$IP", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$IP", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteStatus", "[", 
            "\"\<No inverted pendulums registered.\>\"", "]"}], ";", 
           RowBox[{"ip1", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"ip2", "=", 
            RowBox[{"{", "}"}]}], ";"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ip1", "=", 
            RowBox[{"save$IP", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
           RowBox[{"ip2", "=", 
            RowBox[{"save$IP", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$IP", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"save$IP", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Iniverted pendulum \>\"", "<>", 
                  RowBox[{"save$IP", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "6"}], "]"}], "]"}], "<>", 
                  "\"\< attached to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**"}], "*", "Version", " ", "1.1"}], "**"}], "**"}], 
                    "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], 
              "**"}], "**"}], "**"}], "**"}], "**", "**", "**"}], " ", "*)"}],
         "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "IP", " ", "Version", " ", "1.0", " ", "Compriance", " ", "Check"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "4"}], "]"}], "]"}], "]"}], "\[Equal]", 
              "3"}], ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", "0"}], "]"}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], "]"}], "\[Equal]", 
              "3"}], ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{
               RowBox[{"save$IP", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "1000"}], 
              "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
          "*", "Version", " ", 
          RowBox[{
          "1.1", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
            "**", "**", "**", "**", "**"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", "HL", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$HL", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$HL", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "mod$WriteStatus", "[", "\"\<No heat links registered.\>\"", "]"}],
            ";", 
           RowBox[{"hl1", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"hl2", "=", 
            RowBox[{"{", "}"}]}], ";"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"hl1", "=", 
            RowBox[{"save$HL", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
           RowBox[{"hl2", "=", 
            RowBox[{"save$HL", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$HL", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"save$HL", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Heat link \>\"", "<>", 
                  RowBox[{"save$HL", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "10"}], "]"}], "]"}], "<>", 
                  "\"\< attached to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "damper", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"save$damp", "[", 
             RowBox[{"[", "0", "]"}], "]"}], "===", "Symbol"}], "||", 
           RowBox[{"save$damp", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "mod$WriteStatus", "[", "\"\<No dampers registered.\>\"", "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"save$damp", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "2"}], "]"}], "]"}], "\[Equal]", 
                RowBox[{"save$damp", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "3"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Damper \>\"", "<>", 
                  RowBox[{"save$damp", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "<>", 
                  "\"\< affects to the same bodies.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$damp", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"con", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
             "wire1", ",", "wire2", ",", "ip1", ",", "ip2", ",", "hl1", ",", 
              "hl2"}], "]"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"Floating", " ", "bodies", " ", "check"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{"MemberQ", "[", 
                 RowBox[{"con", ",", "n"}], "]"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mod$WriteError", "[", 
                 RowBox[{"\"\<Body \>\"", "<>", 
                  RowBox[{"save$bdn", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "<>", 
                  "\"\< is floating.\>\""}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"calc$sflag", "=", "1"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
        ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQB2IQ7ff6Z/HH2a8cnQIPLATRFbKPVoHoBR7G60C04r/y
nSD6T9H63SD6zLH+AyB6zsnTl0B0Svfe7yDaqCDzN4iWEjdV/QSkCzYdTwfR
Ha1XckG0HNvOYhDNJvGlHEQfWNbWAKKFtm1pBdFxKforQDRHg+caED1n2oN9
INruXvAREL1o9ezrIJqTTe0uWD629ReI3rk94h+I/pDhxvAZSK9b3cwKohum
LhAE0TdyRMRA9B65x7Yg2i3orCOIZrlb4wqiHQ4m+ILoe5VBmSDa58yuayD6
w879YHrTde0PIDpF6tBnEO29p/0PWN8egb8gWvOjMMsXID3faa4giG7m/hEN
om2cRWNA9KkIw1ju7a8cxW5YloBoAMFW2vo=
  "]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Setting", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570774312107565*^9, 3.570774312490587*^9}, {
  3.5713414721620803`*^9, 3.571341474019187*^9}, {3.571490369490226*^9, 
  3.571490372099375*^9}}],

Cell[CellGroupData[{

Cell["Set Variables", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570771931900425*^9, 3.5707719378307643`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetVars", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nlist", ",", "tv"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "State"}]}], " ", 
        RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tv", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$IP", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"save$bdn", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"MemberQ", "[", 
             RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<x\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<z\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<yaw\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<x\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<y\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<z\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<pitch\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<yaw\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"tv", ",", 
               RowBox[{"ToExpression", "[", 
                RowBox[{"\"\<roll\>\"", "<>", 
                 RowBox[{"save$bdn", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
             ";"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      RowBox[{"allvars", "=", "tv"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Input"}]}], " ", 
         RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tv", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"save$bdn", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"tv", ",", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<x\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"tv", ",", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<y\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"tv", ",", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<z\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"tv", ",", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<pitch\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"tv", ",", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<yaw\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"tv", ",", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<roll\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], "]"}], 
           ";"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      RowBox[{"allparams", "=", "tv"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"--", 
          RowBox[{"-", "Float"}]}], " ", 
         RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tv", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$vspr", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"tv", ",", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"\"\<h\>\"", "<>", 
              RowBox[{"save$vspr", "[", 
               RowBox[{"[", 
                RowBox[{"n", ",", "8"}], "]"}], "]"}]}], "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}]}], 
       "]"}], ";", 
      RowBox[{"allfloats", "=", "tv"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", 
          RowBox[{"Velocity", "--"}]}]}], "-"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"velvars", "=", 
       RowBox[{"makevel", "[", "allvars", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"velparams", "=", 
       RowBox[{"makevel", "[", "allparams", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"velfloats", "=", 
       RowBox[{"makevel", "[", "allfloats", "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0E0ow3EYB/BtotmWOYklRnFYclleclm0m0JLDnOYt4W1GdJsWikvRZaX
qZkxZSulFTvYRKwslJeWiyhZ2MyyLUxtNOT3/R+ePpfv93nqKepQS+QMGo1W
QAZGx67VU5bXWn7f2wBUttIXII/ONsIHxbEJGpe9VvjV2bMBDxgV53DJO35H
5RpSAdgvVESgSauNUXtDnk+ooTsSMFhclYJhuS9tmph/pmDCRPpwDuyaNOfD
K9NSAyxvtDbDNrFOCquVdhk8te/Kobdjqxd+ahUqKtctHIKXonUzTJMwMkzE
kZmyQsg6+mmB0dV2GTS8aNRwMLRLyeGF5q1Evy9rAdp0Hs4a8b3Slw3/nKqf
HWJJ/SJlna8000WcYG9yISfv4hHq/ZIkZNqDXDfu3luz4XZAJYBPon0h5MXa
dc/EJEswCsOqW8s7URpJUdb87tk+8L9Djx2aDfzFOJHWdUKpv4k7xSukRxe4
YG4T0zVHdMx+u+E/qwQLWg==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Init Value", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708950246658063`*^9, 3.5708950298101006`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetInitVal", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "nlist", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"subdefparams", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"save$bdn", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"subdefparams", ",", 
            RowBox[{"makesub", "[", 
             RowBox[{
              RowBox[{"bodylist", "[", 
               RowBox[{"[", 
                RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"save$initpos", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], "]"}]}],
            "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"subdefparams", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"subdefparams", ",", "1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"subinitvars", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$IP", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{"save$bdn", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"MemberQ", "[", 
             RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"subinitvars", ",", 
              RowBox[{"makesub", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "3"}], "]"}], "]"}], ",", 
                  RowBox[{"bodylist", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1", ",", "5"}], "]"}], "]"}]}], "}"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"save$initpos", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{"save$initpos", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}], ",", "0"}], 
                 "}"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"subinitvars", ",", 
              RowBox[{"makesub", "[", 
               RowBox[{
                RowBox[{"bodylist", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"save$initpos", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], 
               "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"subinitvars", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"subinitvars", ",", "1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"subinitfloats", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "allfloats", "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"makesub", "[", 
          RowBox[{"allfloats", ",", 
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{"Length", "[", "allfloats", "]"}], "}"}]}], "]"}]}], 
          "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708950323402452`*^9, 3.5708953948929825`*^9}, {
  3.5708954402705774`*^9, 3.570895578131463*^9}, {3.5708956142555294`*^9, 
  3.5708957352824516`*^9}, {3.5710663274043694`*^9, 3.571066332365653*^9}, {
  3.5710663871217847`*^9, 3.5710664208597145`*^9}, {3.571493292963439*^9, 
  3.571493331861664*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Body Position", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570773681498496*^9, 3.5707736850527*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetBodyPos", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nlist", ",", "logic"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"--", 
         RowBox[{"-", "State"}]}], " ", 
        RowBox[{"Variables", "--"}]}], "-"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$IP", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$IP", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"save$bodypos", "=", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<x\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"ToExpression", "[", 
               RowBox[{"\"\<y\>\"", "<>", 
                RowBox[{"save$bdn", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "2"}], "]"}], "]"}]}], "]"}], "+", 
              "\[IndentingNewLine]", 
              RowBox[{"save$IP", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Position", "[", 
                   RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "7"}], "]"}], 
               "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<z\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<pitch\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$IP", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                   "]"}], ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<yaw\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<roll\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$IP", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                   "]"}], ",", "2"}], "]"}], "]"}]}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<x\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<y\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<z\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<pitch\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<yaw\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"\"\<roll\>\"", "<>", 
               RowBox[{"save$bdn", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}], 
      ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.57077369222611*^9, 3.570773706759941*^9}, {
   3.570773974150235*^9, 3.5707739963635054`*^9}, {3.57077402931439*^9, 
   3.570774128698075*^9}, {3.5707744630681996`*^9, 3.570774515979226*^9}, {
   3.5707747982243695`*^9, 3.570774823479814*^9}, {3.5707748607879477`*^9, 
   3.570774875261776*^9}, {3.5707749850570555`*^9, 3.570775003632118*^9}, {
   3.5707750758262477`*^9, 3.570775216426289*^9}, {3.570775265808114*^9, 
   3.5707753524640703`*^9}, {3.5707754181798286`*^9, 3.570775457379071*^9}, {
   3.5707759226986856`*^9, 3.570776032007938*^9}, {3.5707760806747217`*^9, 
   3.570776101539915*^9}, 3.5707761335107436`*^9, {3.570776391468498*^9, 
   3.5707763915855045`*^9}, {3.5707764223752656`*^9, 3.570776424310376*^9}, {
   3.570776465213716*^9, 3.570776614126233*^9}, {3.5710664488333144`*^9, 
   3.5710665006772795`*^9}, {3.5710665733814383`*^9, 
   3.5710666081964293`*^9}, {3.5710690235775814`*^9, 3.571069032325082*^9}, {
   3.571071817003356*^9, 3.57107182179163*^9}, {3.5710729004063234`*^9, 
   3.5710729294189825`*^9}, {3.5712199102764935`*^9, 3.571219917571911*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Set List", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570783935417987*^9, 3.5707839392542067`*^9}, {
  3.570784466116341*^9, 3.570784467717433*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$SetList", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "nlist", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$vspr", "]"}], ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"save$vspr", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"nlist", "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"bodylist", "=", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"save$bodypos", "[", 
            RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$mass", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$shape", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "save$bdn", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ValueQ", "[", "save$IP", "]"}], "&&", 
         RowBox[{"Not", "[", 
          RowBox[{"save$IP", "===", 
           RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"bodylist", ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"b2s", "[", 
                 RowBox[{
                  RowBox[{"save$bodypos", "[", 
                   RowBox[{"[", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], "-", "\[IndentingNewLine]", 
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}]}], ")"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "/", 
                   RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}]}], ",", "0", ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], "-", "\[IndentingNewLine]", 
                    RowBox[{"b2s", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "3"}], "]"}], 
                    "]"}], ",", "\[IndentingNewLine]", "0", ",", 
                    RowBox[{"save$bodypos", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], ",", "5"}], "]"}], 
                    "]"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "1"}], "]"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3", ",", "m", ",", "2"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}]}], ")"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"save$IP", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "7"}], "]"}], "]"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}], "]"}], ",", 
              "\[IndentingNewLine]", "0", ",", 
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"{", "6", "}"}], ",", 
                RowBox[{"{", "6", "}"}]}], "]"}], ",", 
              "\"\<DoubleCylinder[y]\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"0.15", ",", "0.2", ",", 
                RowBox[{"save$IP", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "7"}], "]"}], "]"}], ",", "0.2", ",", 
                "0.15"}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
           "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$IP", "]"}]}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"wirelist", "=", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"save$bodypos", "[", 
            RowBox[{"[", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "2"}], "]"}], "]"}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}], "*", 
             "\[IndentingNewLine]", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "11"}], "]"}], "]"}]}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<h\>\"", "<>", 
                   RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "8"}], "]"}], 
                    "]"}]}], "]"}], "*", "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "7"}], "]"}], 
                  "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$bodypos", "[", 
            RowBox[{"[", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "4"}], "]"}], "]"}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}], "*", 
             "\[IndentingNewLine]", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "12"}], "]"}], "]"}]}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"nlist", ",", "n"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                  "]"}], "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<h\>\"", "<>", 
                   RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "8"}], "]"}], 
                    "]"}]}], "]"}], "*", "\[IndentingNewLine]", 
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"nlist", ",", "n"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "7"}], "]"}], 
                  "]"}], "*", 
                 RowBox[{"(", 
                  RowBox[{"-", "1"}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$wire", "[", 
             RowBox[{"[", 
              RowBox[{"n", ",", "6"}], "]"}], "]"}], "-", 
            RowBox[{"2", "*", 
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"save$wire", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "14"}], "]"}], "]"}], ",", 
           RowBox[{"save$wire", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "15"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"save$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
             "]"}], "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
               "]"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"save$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
             "]"}], "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
               "]"}], ")"}]}], "*", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"save$mat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"save$wire", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "3"}], "]"}], 
                "]"}], "GPa", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"N", "[", "Pi", "]"}], "*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"save$wire", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9"}], "]"}], "]"}], "^", "4"}], "/", 
                   "64"}]}], ")"}], "/", 
                RowBox[{"save$wire", "[", 
                 RowBox[{"[", 
                  RowBox[{"n", ",", "10"}], "]"}], "]"}]}]}], "]"}], "/", 
             "\[IndentingNewLine]", 
             RowBox[{"save$wire", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "6"}], "]"}], "]"}]}]}], 
           RowBox[{"(*", 
            RowBox[{"/", "2"}], "*)"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"save$mat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"save$wire", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "5"}], "]"}], 
             "]"}], "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"save$mat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"save$wire", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", "6"}], "]"}], 
               "]"}], ")"}]}]}]}], "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "save$wire", "]"}]}], "}"}]}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ValueQ", "[", "save$vspr", "]"}], "&&", 
         RowBox[{"Not", "[", 
          RowBox[{"save$vspr", "===", 
           RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"bodylist", ",", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"save$vspr", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "2"}], "]"}], "]"}], "\[Equal]", "1"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"b2s", "[", 
                   RowBox[{
                    RowBox[{"wirelist", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
                    "]"}], ",", 
                    RowBox[{"wirelist", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "2"}], "]"}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"wirelist", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"save$vspr", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", "1", ",", 
                    RowBox[{"4", ";;", "6"}]}], "]"}], "]"}]}], "]"}]}], 
               "]"}], ",", "\[IndentingNewLine]", "0", ",", 
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"{", "6", "}"}], ",", 
                RowBox[{"{", "6", "}"}]}], "]"}], ",", "\"\<Cylinder[y]\>\"", 
              ",", 
              RowBox[{"{", 
               RowBox[{"0.1", ",", "0.03", ",", "0.0", ",", "0", ",", "0"}], 
               "}"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]",
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$vspr", "]"}]}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"damperlist", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"save$damp", "[", 
           RowBox[{"[", "0", "]"}], "]"}], "=!=", "List"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"save$bodypos", "[", 
              RowBox[{"[", 
               RowBox[{"save$damp", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "]"}], ",", 
             RowBox[{"save$damp", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "4"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"save$bodypos", "[", 
              RowBox[{"[", 
               RowBox[{"save$damp", "[", 
                RowBox[{"[", 
                 RowBox[{"n", ",", "3"}], "]"}], "]"}], "]"}], "]"}], ",", 
             RowBox[{"save$damp", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "5"}], "]"}], "]"}], ",", 
             RowBox[{"save$damp", "[", 
              RowBox[{"[", 
               RowBox[{"n", ",", "6"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "save$damp", "]"}]}], "}"}]}], "]"}]}], 
        "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5707841738916273`*^9, 3.570784335591876*^9}, {
   3.5707843669036665`*^9, 3.57078437184995*^9}, {3.570784831433236*^9, 
   3.570785319451149*^9}, {3.5707853579763527`*^9, 3.5707854094772987`*^9}, {
   3.5707854425911922`*^9, 3.5707856571314635`*^9}, {3.5707857055252314`*^9, 
   3.5707858151345005`*^9}, {3.570785999172027*^9, 3.570786012128768*^9}, {
   3.570788992809534*^9, 3.5707890623245106`*^9}, {3.5707891346876493`*^9, 
   3.5707891433571453`*^9}, {3.5707891816073327`*^9, 3.570789188790744*^9}, {
   3.570789224897809*^9, 3.5707892267809167`*^9}, {3.570789349942961*^9, 
   3.5707894128775606`*^9}, {3.5707895041887836`*^9, 3.57078950517984*^9}, {
   3.5707896653680024`*^9, 3.5707896906074457`*^9}, {3.570789725939467*^9, 
   3.5707897314407816`*^9}, {3.570790006057489*^9, 3.5707900152600155`*^9}, {
   3.570894056376424*^9, 3.5708941150687804`*^9}, {3.57098182282387*^9, 
   3.5709818371706905`*^9}, {3.570981943359764*^9, 3.570981971714386*^9}, {
   3.5710693851902647`*^9, 3.5710694910213175`*^9}, {3.571069523003147*^9, 
   3.571069791520505*^9}, {3.5710698662377787`*^9, 3.571069872364129*^9}, {
   3.5710699050309973`*^9, 3.571070028564063*^9}, {3.5710701023092813`*^9, 
   3.571070216050787*^9}, {3.571071566204011*^9, 3.57107161688791*^9}, {
   3.5710717351026716`*^9, 3.5710717364077463`*^9}, {3.5710719521550865`*^9, 
   3.5710719581494293`*^9}, {3.5710720453404164`*^9, 3.571072047644548*^9}, {
   3.5710721359606*^9, 3.5710722027804213`*^9}, {3.571073167721613*^9, 
   3.571073175956084*^9}, {3.571073342892632*^9, 3.5710733785466714`*^9}, 
   3.5710734162738295`*^9, {3.5710734786573973`*^9, 3.571073480246488*^9}, {
   3.571131092825755*^9, 3.5711311045914283`*^9}, {3.5711312270584326`*^9, 
   3.571131227985486*^9}, 3.571131278690386*^9, {3.5711317757328153`*^9, 
   3.5711317789730005`*^9}, {3.571131830870969*^9, 3.571131832773078*^9}, {
   3.5711319758712626`*^9, 3.571131978192395*^9}, {3.5712202721961946`*^9, 
   3.5712202757894*^9}, {3.5714293225785446`*^9, 3.5714293558624487`*^9}, {
   3.590644977327157*^9, 3.590644985138604*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Energy Calculation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714903942226405`*^9, 3.5714904064843416`*^9}}],

Cell[CellGroupData[{

Cell["Calculate Energy", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708941280235214`*^9, 3.5708941354829483`*^9}, {
  3.5708947442697687`*^9, 3.570894744954808*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcEnergy", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"e$kin", "=", 
       RowBox[{
        RowBox[{"makekinetic", "[", "bodylist", "]"}], "+", 
        RowBox[{"makekineticvspr", "[", "save$vspr", "]"}], "+", 
        RowBox[{"makekineticIP", "[", "save$IP", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"e$pot", "=", 
       RowBox[{
        RowBox[{"makegravpot", "[", "bodylist", "]"}], "+", 
        RowBox[{"makewirepot", "[", "wirelist", "]"}], "+", 
        RowBox[{"maketorsionpot", "[", "wirelist", "]"}], "+", 
        "\[IndentingNewLine]", 
        RowBox[{"makevsprpot", "[", "save$vspr", "]"}], "+", 
        RowBox[{"makeIPpot", "[", "save$IP", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"e$potc", "=", 
       RowBox[{
        RowBox[{"makegravpot", "[", "bodylist", "]"}], "+", 
        RowBox[{"makewirepotc2", "[", "wirelist", "]"}], "+", 
        RowBox[{"maketorsionpotc", "[", "wirelist", "]"}], "+", 
        "\[IndentingNewLine]", 
        RowBox[{"makevsprpotc", "[", "save$vspr", "]"}], "+", 
        RowBox[{"makeIPpotc", "[", "save$IP", "]"}], "+", 
        RowBox[{"makeHLpotc", "[", "save$HL", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"e$damp", "=", 
       RowBox[{"makedamping", "[", "damperlist", "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708941812795677`*^9, 3.5708941821076145`*^9}, 
   3.570895406170627*^9, {3.5708965076256266`*^9, 3.5708965299429035`*^9}, {
   3.571069051905202*^9, 3.571069054806368*^9}, {3.571069142349375*^9, 
   3.571069145780571*^9}, {3.57107231028057*^9, 3.5710723181430197`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Find Eq", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490420571147*^9, 3.571490421751215*^9}}],

Cell[CellGroupData[{

Cell["Find Equilibrium", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570895768458349*^9, 3.570895771669533*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FindEquilibrium", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"e$pot0", "=", 
      RowBox[{"e$pot", "/.", "subdefparams"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"subminvars", "=", 
      RowBox[{
       RowBox[{"FindMinimum", "[", "\[IndentingNewLine]", 
        RowBox[{"e$pot0", ",", "\[IndentingNewLine]", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"comb", "[", 
            RowBox[{"allvars", ",", 
             RowBox[{"allvars", "/.", "subinitvars"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"comb", "[", 
            RowBox[{"allfloats", ",", 
             RowBox[{"allfloats", "/.", "subinitfloats"}]}], "]"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Method", "\[Rule]", "\"\<Newton\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"MaxIterations", "\[Rule]", "100000"}]}], 
        "\[IndentingNewLine]", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570895796480952*^9, 3.5708958093856897`*^9}, {
   3.570895858474498*^9, 3.5708958669189806`*^9}, {3.570895930233602*^9, 
   3.5708959371019945`*^9}, {3.5708959771672864`*^9, 
   3.5708960135313663`*^9}, {3.570896349135562*^9, 3.5708964123731785`*^9}, {
   3.5708972981808443`*^9, 3.5708973250833826`*^9}, {3.5708973799475207`*^9, 
   3.5708973815666137`*^9}, {3.5708978894976654`*^9, 3.5708978963350563`*^9}, 
   3.5708981302494354`*^9, 3.5708983339310856`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calc Matirces", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5708983167771044`*^9, 3.570898319081236*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$CalcMatrices", ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "mod$WriteStatus", "[", "\"\<Calculating Mass Matrix 'M'...\>\"", "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"matMvv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$kin", ",", "velvars", ",", "velvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matMpv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$kin", ",", "velvars", ",", "velparams"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
      "mod$WriteStatus", "[", 
       "\"\<Calculating real part of Stiffness Matrix 'K'...\>\"", "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"matKvv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$pot", ",", "allvars", ",", "allvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matKpv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$pot", ",", "allvars", ",", "allparams"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "allfloats", "]"}], "\[GreaterEqual]", "1"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"matKfv", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$pot", ",", "allvars", ",", "allfloats"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"matKfp", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$pot", ",", "allparams", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKff", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$pot", ",", "allfloats", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKvv", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfv", ".", 
             RowBox[{"Inverse", "[", "matKff", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfv", "]"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"matKpv", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfv", ".", 
             RowBox[{"Inverse", "[", "matKff", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfp", "]"}]}], "]"}]}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
      "mod$WriteStatus", "[", 
       "\"\<Calculating complex Stiffness Matrix 'Kc'...\>\"", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matKvvc", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$potc", ",", "allvars", ",", "allvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matKpvc", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$potc", ",", "allvars", ",", "allparams"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "allfloats", "]"}], "\[GreaterEqual]", "1"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"matKfvc", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$potc", ",", "allvars", ",", "allfloats"}], "]"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"matKfpc", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$potc", ",", "allparams", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKffc", "=", 
          RowBox[{"makemat", "[", 
           RowBox[{"e$potc", ",", "allfloats", ",", "allfloats"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"matKvvc", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfvc", ".", 
             RowBox[{"Inverse", "[", "matKffc", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfvc", "]"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"matKpvc", "+=", 
          RowBox[{"-", 
           RowBox[{"Chop", "[", 
            RowBox[{"matKfvc", ".", 
             RowBox[{"Inverse", "[", "matKffc", "]"}], ".", 
             RowBox[{"Transpose", "[", "matKfpc", "]"}]}], "]"}]}]}], ";"}]}],
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
      "mod$WriteStatus", "[", "\"\<Calculating Damping Matrix 'G'...\>\"", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"matGvv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$damp", ",", "velvars", ",", "velvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"matGpv", "=", 
       RowBox[{"makemat", "[", 
        RowBox[{"e$damp", ",", "velvars", ",", "velparams"}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5708983207423315`*^9, 3.5708983246435547`*^9}, {
  3.5708984964593816`*^9, 3.5708986388375254`*^9}, {3.5714245498475604`*^9, 
  3.5714246568956833`*^9}, {3.5714246878434534`*^9, 3.5714247785686426`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Eigen calc", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571329434817584*^9, 3.571329436095657*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$EigenCalc", ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"eigen", "=", 
       RowBox[{"Eigensystem", "[", 
        RowBox[{
         RowBox[{"Inverse", "[", "matMvv", "]"}], ".", 
         RowBox[{"Re", "[", "matKvv", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"eigenf", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"eigen", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", 
           RowBox[{"N", "[", "Pi", "]"}]}], ")"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"eigenv", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{"eigen", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5106404812986946`*^9, 3.5106405612644353`*^9}, {
  3.510642026727812*^9, 3.510642034652625*^9}, {3.510642839520439*^9, 
  3.510642845308049*^9}, {3.5106429258041906`*^9, 3.510642929423397*^9}, {
  3.5106434421806974`*^9, 3.510643450791913*^9}, {3.5109192830239596`*^9, 
  3.510919329933242*^9}, {3.511143879000643*^9, 3.5111438815434475`*^9}, {
  3.571329447920333*^9, 3.5713294675064535`*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4. Frequency Domain Plot", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5714906643970933`*^9, 3.5714906722365417`*^9}}],

Cell[CellGroupData[{

Cell["Base", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571167767161003*^9, 3.5711677673760157`*^9}, {
  3.5713414902011127`*^9, 3.5713414910931635`*^9}, {3.571490706387495*^9, 
  3.57149072324846*^9}, {3.5714907985727677`*^9, 3.5714908037900662`*^9}}],

Cell[CellGroupData[{

Cell["Plot Base Option", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490767383984*^9, 3.5714907957736073`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"baseoptmag", "=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontSize", "\[Rule]", "15"}], ",", "Bold"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", "\"\<Magnitude\>\""}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"GridLinesStyle", "\[Rule]", "Dashed"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "mygrids2"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ImageSize", "\[Rule]", "480"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "0.6"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571490779917701*^9, 3.5714907856460285`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"baseoptphs", "=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontSize", "\[Rule]", "15"}], ",", "Bold"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Frequency [Hz]\>\"", ",", "\"\<Phase [deg]\>\""}], 
        "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"GridLinesStyle", "\[Rule]", "Dashed"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "180"}], ",", 
             RowBox[{"-", "90"}], ",", "0", ",", "90", ",", "180"}], "}"}], 
           ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "180"}], ",", 
           RowBox[{"-", "90"}], ",", "0", ",", "90", ",", "180"}], "}"}]}], 
        "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"ImageSize", "\[Rule]", "480"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "0.2"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.571490787015107*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"baseoptpsd", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontSize", "\[Rule]", "15"}], ",", "Bold"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Frequency [Hz]\>\"", ",", 
        RowBox[{"Dynamic", "[", "amplabel", "]"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GridLinesStyle", "\[Rule]", "Dashed"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GridLines", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "mygrids2"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ImageSize", "\[Rule]", "480"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.8"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Function", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5711677559033594`*^9, 3.5711677568084106`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"takemag", "[", 
    RowBox[{"tf_List", ",", "show_List"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "tf", "]"}], "\[Equal]", "0"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"show", ",", "True"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.01", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"100", ",", "1"}], "}"}]}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tf", "[", 
          RowBox[{"[", 
           RowBox[{"n", ",", "m", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"Abs", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "m", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"show", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "tf", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"takephs", "[", 
    RowBox[{"tf_List", ",", "show_List"}], "]"}], ":=", "\[IndentingNewLine]",
    
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "tf", "]"}], "\[Equal]", "0"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"show", ",", "True"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.01", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"100", ",", "0"}], "}"}]}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tf", "[", 
          RowBox[{"[", 
           RowBox[{"n", ",", "m", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Arg", "[", 
           RowBox[{"tf", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "m", ",", "2"}], "]"}], "]"}], "]"}], "*", 
          RowBox[{"180", "/", 
           RowBox[{"N", "[", "Pi", "]"}]}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"show", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "tf", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"takepsd", "[", 
    RowBox[{"tf_List", ",", "show_List"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "tf", "]"}], "\[Equal]", "0"}], "||", 
      RowBox[{"Not", "[", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"show", ",", "True"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.01", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"100", ",", "1"}], "}"}]}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"show", "[", 
          RowBox[{"[", "n", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tf", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "m", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"tf", "[", 
            RowBox[{"[", 
             RowBox[{"n", ",", "m", ",", "2"}], "]"}], "]"}]}], "}"}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"show", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "tf", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"tf", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571167770375187*^9, 3.5711678918541355`*^9}, {
   3.5711679526256113`*^9, 3.571167959037978*^9}, {3.571210142750823*^9, 
   3.571210196124876*^9}, {3.5712105160751762`*^9, 3.5712105226225505`*^9}, {
   3.571213223971059*^9, 3.5712132623762555`*^9}, {3.5712134110897617`*^9, 
   3.5712134131688805`*^9}, {3.571218435402136*^9, 3.5712184400133996`*^9}, {
   3.5712205568144736`*^9, 3.5712205661880093`*^9}, {3.571227577728047*^9, 
   3.5712275836543856`*^9}, {3.571239332159362*^9, 3.571239376202881*^9}, 
   3.57123943457822*^9, {3.571239580276553*^9, 3.5712395851068296`*^9}, {
   3.571239804669388*^9, 3.5712398088716283`*^9}, {3.5712398886361904`*^9, 
   3.5712399390550747`*^9}, {3.57124012151451*^9, 3.571240214320819*^9}, {
   3.5712403711257877`*^9, 3.571240373512924*^9}, {3.571240559870583*^9, 
   3.571240580405758*^9}, 3.571240619316983*^9, {3.5712406506927776`*^9, 
   3.5712407587899604`*^9}, {3.5712412682501*^9, 3.5712413660086913`*^9}, {
   3.5712508068316755`*^9, 3.5712508904104557`*^9}, {3.571250938878228*^9, 
   3.5712509680838985`*^9}, {3.571251969446173*^9, 3.571251975209503*^9}, {
   3.5712964006244917`*^9, 3.571296438874679*^9}, {3.571296475513775*^9, 
   3.571296478828964*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculate TFs", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571490810592455*^9, 3.57149081365063*^9}}],

Cell[CellGroupData[{

Cell["Calculation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571214833029092*^9, 3.571214833400113*^9}, {
  3.571490695337863*^9, 3.571490696105907*^9}, {3.571490819869986*^9, 
  3.5714908201450014`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcFreqPlot", ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"mod$OpenStatus", ";", "\[IndentingNewLine]", 
     RowBox[{"mod$WriteStatus", "[", "\"\<Set frequency list.\>\"", "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"fgridtype", ",", "\[IndentingNewLine]", 
       RowBox[{"freq", "=", 
        RowBox[{"makefreqlist", "[", 
         RowBox[{"fmin", ",", "fmax", ",", "ngrid"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"freq", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"fmin", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"n", "-", "1"}], ")"}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"ngrid", "-", "1"}], ")"}]}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "ngrid"}], "}"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"calc$xrange", "=", 
        RowBox[{"{", 
         RowBox[{"fmin", ",", "fmax"}], "}"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
     "mod$WriteStatus", "[", "\"\<Load heat link stiffness.\>\"", "]"}], ";", 
     "\[IndentingNewLine]", "mod$LoadkHL", ";", "\[IndentingNewLine]", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[Equal]", "1"}], ",", "mod$CalcTFf", ",", 
       RowBox[{"calc$tfk", "\[Equal]", "2"}], ",", "mod$CalcTFs", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"calc$tfk", "\[Equal]", "3"}], ",", "mod$CalcSN", ",", 
       RowBox[{"calc$tfk", "\[Equal]", "4"}], ",", "mod$CalcTN"}], "]"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"mod$WriteStatus", "[", "\"\<Calculation finished!!\>\"", "]"}], 
     ";", "\[IndentingNewLine]", "mod$CloseStatus", ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712148356822433`*^9, 3.571214914110729*^9}, {
   3.571215286378022*^9, 3.571215332173641*^9}, {3.5712169711223836`*^9, 
   3.571216976178673*^9}, {3.571237209888975*^9, 3.571237219717537*^9}, {
   3.571302942035639*^9, 3.5713029753775454`*^9}, 3.5714162573212547`*^9, {
   3.571427133943362*^9, 3.571427199380105*^9}, {3.5714273838146544`*^9, 
   3.571427403435776*^9}, {3.590781456561695*^9, 3.590781460982948*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Load kHL", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571215828806047*^9, 3.5712158321002355`*^9}, {
  3.571215908031578*^9, 3.571215909236647*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$LoadkHL", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"data", ",", "kHL", ",", "int"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"subkHL", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "freq", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ValueQ", "[", "save$HL", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Not", "[", 
             RowBox[{
              RowBox[{"save$HL", "[", 
               RowBox[{"[", 
                RowBox[{"n", ",", "9", ",", "m", ",", "l"}], "]"}], "]"}], 
              "\[Equal]", "\"\<\>\""}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"data", "=", 
              RowBox[{"Import", "[", 
               RowBox[{
                RowBox[{"\"\<HeatLink/\>\"", "<>", 
                 RowBox[{"save$HL", "[", 
                  RowBox[{"[", 
                   RowBox[{"n", ",", "9", ",", "m", ",", "l"}], "]"}], "]"}], 
                 "<>", "\"\<.txt\>\""}], ",", "\"\<Table\>\""}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"kHL", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"data", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"data", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "+", 
                   RowBox[{"I", " ", 
                    RowBox[{"data", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "3"}], "]"}], "]"}]}]}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"int", "=", 
              RowBox[{"Interpolation", "[", "kHL", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Do", "[", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{
                 RowBox[{"subkHL", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"ToExpression", "[", 
                   RowBox[{"\"\<kHL$\>\"", "<>", 
                    RowBox[{"save$HL", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "9", ",", "m", ",", "l"}], "]"}], 
                    "]"}]}], "]"}], "\[Rule]", 
                  RowBox[{"int", "[", 
                   RowBox[{"freq", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", 
                 RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "save$HL", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "6"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"l", ",", "6"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712159034833183`*^9, 3.571216081050474*^9}, {
   3.5712162972618413`*^9, 3.571216333209897*^9}, {3.5712163797515593`*^9, 
   3.5712164412280755`*^9}, {3.571216474243964*^9, 3.5712164772761374`*^9}, {
   3.571216507427862*^9, 3.571216681160799*^9}, {3.5712167134606466`*^9, 
   3.571216865748357*^9}, 3.5712170726281896`*^9, {3.571217638899578*^9, 
   3.571217640932695*^9}, {3.5712321708177567`*^9, 3.571232191399934*^9}, {
   3.571232279553976*^9, 3.5712323122928486`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Set Seism", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571232520143737*^9, 3.571232521622822*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SetSeism", ":=", "\[IndentingNewLine]", 
    RowBox[{"CreateDialog", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ValueQ", "[", "calc$seism", "]"}], "&&", 
            RowBox[{
             RowBox[{"Length", "[", "calc$seism", "]"}], "\[Equal]", 
             RowBox[{"Length", "[", "allparams", "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"temp$seism", "=", "calc$seism"}], ",", 
           RowBox[{"temp$seism", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"\"\<\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"temp$sCB", "=", 
          RowBox[{"Table", "[", 
           RowBox[{"False", ",", 
            RowBox[{"{", 
             RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Load Seismic Injection\>\"", ",", "\[IndentingNewLine]", 
             "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Style", "[", 
         RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Checkbox", "[", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$sCB", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"allparams", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$seism", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"15.", ",", "1."}], "}"}]}], ",", 
                   RowBox[{"Enabled", "\[Rule]", "False"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"Pane", "[", 
              RowBox[{
               RowBox[{"TableForm", "[", 
                RowBox[{
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<Seismic\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"temp$sCB", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"temp$seism", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "=", 
                    "\[IndentingNewLine]", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<Seismic\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$sCB", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "=", "False"}]}]}], "]"}],
                     ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.txt\>\"", ",", 
                    RowBox[{"{", "\"\<Seismic\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "2", 
                   ",", "2", ",", "1", ",", 
                   RowBox[{"{", "}"}]}], "]"}], ",", 
                 RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",",
                "\[IndentingNewLine]", 
               RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"320", ",", "300"}], "}"}]}], ",", 
               RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
             "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
          "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"DialogReturn", "[", 
               RowBox[{"calc$seism", "=", "temp$seism"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Button", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
              RowBox[{"DialogReturn", "[", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
              RowBox[{"Background", "\[Rule]", 
               RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], "}"}], 
          "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowElements", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
         "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"WindowSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"600", ",", "500"}], "}"}]}], ",", 
      RowBox[{"WindowMargins", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Seismic Injection\>\""}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571232524381979*^9, 3.571232535614622*^9}, {
   3.571232573980816*^9, 3.5712326047605767`*^9}, {3.5712326433767853`*^9, 
   3.5712326487080903`*^9}, {3.5712356963004026`*^9, 
   3.5712357280142164`*^9}, {3.571235831278123*^9, 3.5712358419447327`*^9}, {
   3.5712362077086535`*^9, 3.571236552929399*^9}, {3.5712365883724265`*^9, 
   3.57123663022682*^9}, {3.5712366603725443`*^9, 3.5712368010105886`*^9}, {
   3.5712374747601247`*^9, 3.5712375921758404`*^9}, {3.571237633495204*^9, 
   3.571237647171986*^9}, 3.571492541966484*^9, {3.571748098589508*^9, 
   3.5717481295872817`*^9}, {3.5793187691745014`*^9, 3.5793187806301565`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calc TFf", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571214922075185*^9, 3.5712149260164104`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcTFf", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tflist", ",", "name"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"calc$tfFi", "[", 
            RowBox[{"[", "n", "]"}], "]"}], "&&", 
           RowBox[{"calc$tfFo", "[", 
            RowBox[{"[", "m", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"name", "=", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", "\"\< / \>\"", "<>", 
             RowBox[{"subforce", "[", 
              RowBox[{"ToString", "[", 
               RowBox[{"allvars", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$WriteStatus", "[", 
            RowBox[{
            "\"\<Calculating TF:\>\"", "<>", "name", "<>", "\"\< ...\>\""}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"tflist", "=", 
            RowBox[{"tfcalcfFD1", "[", 
             RowBox[{
              RowBox[{"allvars", "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", "subkHL"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfplot", ",", 
             RowBox[{"comb", "[", 
              RowBox[{"freq", ",", "tflist"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfname", ",", "name"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfline", ",", 
             RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfFi", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$combif", "&&", 
         RowBox[{
          RowBox[{"calc$combin", "[", 
           RowBox[{"[", "0", "]"}], "]"}], "\[Equal]", "List"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$tfFo", "[", 
              RowBox[{"[", "m", "]"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"name", "=", 
               RowBox[{
                RowBox[{"ToString", "[", 
                 RowBox[{"allvars", "[", 
                  RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", "\"\< / \>\"", 
                "<>", 
                RowBox[{"subforce", "[", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"calc$combin", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "]"}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"mod$WriteStatus", "[", 
               RowBox[{
               "\"\<Calculating TF:\>\"", "<>", "name", "<>", 
                "\"\< ...\>\""}], "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"tflist", "=", 
               RowBox[{"tfcalcfFD1", "[", 
                RowBox[{
                 RowBox[{"calc$combin", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], ",", 
                 RowBox[{"allvars", "[", 
                  RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", 
                 "subkHL"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"tflist", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"calc$tfplot", ",", 
                   RowBox[{"comb", "[", 
                    RowBox[{"freq", ",", "tflist"}], "]"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"calc$tfname", ",", "name"}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"calc$tfline", ",", 
                   RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], "]"}], 
              ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$combin", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", 
             RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], 
         ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$combif", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"calc$tfFo", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571214930013639*^9, 3.571214937679077*^9}, {
   3.571215015034502*^9, 3.5712150350526466`*^9}, {3.571215138214547*^9, 
   3.571215141215719*^9}, {3.571215183998166*^9, 3.5712152356301193`*^9}, {
   3.5712152777225266`*^9, 3.571215278506572*^9}, {3.571215350952715*^9, 
   3.5712153770492077`*^9}, {3.5712154112631645`*^9, 3.571215525312688*^9}, {
   3.5712156937743235`*^9, 3.571215737500825*^9}, {3.571216935889368*^9, 
   3.5712169593327093`*^9}, {3.5712170846198754`*^9, 
   3.5712171180317864`*^9}, {3.5712171507766595`*^9, 
   3.5712171634983873`*^9}, {3.5712172167424326`*^9, 3.5712172608519554`*^9}, 
   3.5712177903792424`*^9, {3.5712178572860694`*^9, 3.5712178644194775`*^9}, {
   3.5712181201001015`*^9, 3.571218121238167*^9}, {3.571219511500685*^9, 
   3.57121954638068*^9}, {3.5712196071411552`*^9, 3.571219659180132*^9}, {
   3.5712391532661295`*^9, 3.5712391632397003`*^9}, {3.5712606609262977`*^9, 
   3.57126066568957*^9}, {3.5712620586092405`*^9, 3.571262058831253*^9}, {
   3.571427230842904*^9, 3.5714272651668673`*^9}, {3.5714622428224726`*^9, 
   3.571462270477054*^9}, {3.571463840033828*^9, 3.571463857519828*^9}, {
   3.571463892017801*^9, 3.5714638924128237`*^9}, {3.571469730730756*^9, 
   3.571469909744995*^9}, {3.5714701133116384`*^9, 3.571470160772353*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Cacl TFs", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712323487129316`*^9, 3.5712323511910734`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcTFs", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tflist", ",", "name"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"calc$tfGi", "[", 
            RowBox[{"[", "n", "]"}], "]"}], "&&", 
           RowBox[{"calc$tfGo", "[", 
            RowBox[{"[", "m", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"name", "=", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", "\"\</\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"allparams", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$WriteStatus", "[", 
            RowBox[{
            "\"\<Calculating TF:\>\"", "<>", "name", "<>", "\"\< ...\>\""}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"tflist", "=", 
            RowBox[{"tfcalcFD1", "[", 
             RowBox[{
              RowBox[{"allparams", "[", 
               RowBox[{"[", "n", "]"}], "]"}], ",", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", "subkHL"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfplot", ",", 
             RowBox[{"comb", "[", 
              RowBox[{"freq", ",", "tflist"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfname", ",", "name"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$tfline", ",", 
             RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"Length", "[", "allparams", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfGi", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tfGo", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712319607507415`*^9, 3.571231967580132*^9}, {
   3.5712323538322244`*^9, 3.571232355976347*^9}, {3.5712324458844895`*^9, 
   3.571232482472582*^9}, {3.571238032495025*^9, 3.5712380334950824`*^9}, {
   3.5712389965341654`*^9, 3.5712390656921206`*^9}, {3.571252312437791*^9, 
   3.5712523131758337`*^9}, {3.571252612294942*^9, 3.571252642412665*^9}, 
   3.5713030745352173`*^9, {3.5714272854740295`*^9, 3.571427290527318*^9}, {
   3.571467694965317*^9, 3.5714676951573277`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calc Seism", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571232493681223*^9, 3.571232500891636*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcSN", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tflist", ",", "name", ",", "data", ",", "int", ",", "seism", ",", 
       "sn"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "&&", 
            RowBox[{
             RowBox[{"calc$seism", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ",",
          "True"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Beep", "[", "]"}], ";", 
        RowBox[{"CreateDialog", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Set seismic injection.\>\"", ",", 
            RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
          RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mod$WriteStatus", "[", 
              RowBox[{"\"\<Loading seismic injection data: \>\"", "<>", 
               RowBox[{"calc$seism", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\< ...\>\""}], "]"}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"data", "=", 
              RowBox[{"Import", "[", 
               RowBox[{
                RowBox[{"\"\<seismic/\>\"", "<>", 
                 RowBox[{"calc$seism", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\<.txt\>\""}], 
                ",", "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"int", "=", 
              RowBox[{"Interpolation", "[", "data", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"seism", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"int", "[", 
                 RowBox[{"freq", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{"freq", ",", "seism"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdname", ",", 
                 RowBox[{"\"\<Seismic \>\"", "<>", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"calc$sno", "[", 
                  RowBox[{"[", "m", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"name", "=", 
                   RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", 
                    "\"\< from \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"mod$WriteStatus", "[", 
                   RowBox[{
                   "\"\<Calculating seismic noise: \>\"", "<>", "name", "<>", 
                    "\"\< ...\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"tflist", "=", 
                   RowBox[{"tfcalcFD1", "[", 
                    RowBox[{
                    RowBox[{"allparams", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    RowBox[{"allvars", "[", 
                    RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", 
                    "subkHL"}], "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"sn", "=", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"seism", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "*", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"tflist", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], 
                  ";", "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdplot", ",", 
                    RowBox[{"comb", "[", 
                    RowBox[{"freq", ",", "sn"}], "]"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdname", ",", "name"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
                "\[IndentingNewLine]", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"calc$sni", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"calc$sno", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], 
        ";"}]}], "\[IndentingNewLine]", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712319607507415`*^9, 3.571231967580132*^9}, {
   3.5712323538322244`*^9, 3.571232355976347*^9}, {3.5712324458844895`*^9, 
   3.571232482472582*^9}, {3.571238032495025*^9, 3.5712380334950824`*^9}, {
   3.5712389965341654`*^9, 3.5712390656921206`*^9}, {3.571252245409958*^9, 
   3.5712522465170207`*^9}, {3.5712522887444363`*^9, 3.571252302361215*^9}, {
   3.571252344165606*^9, 3.571252518410572*^9}, {3.5712526370223565`*^9, 
   3.5712527872399483`*^9}, {3.571252891880934*^9, 3.5712528986253195`*^9}, {
   3.5712529331072917`*^9, 3.5712529771918135`*^9}, {3.5712530344420877`*^9, 
   3.571253044889685*^9}, {3.571253286088481*^9, 3.571253286988532*^9}, {
   3.571253332469134*^9, 3.5712533566715183`*^9}, {3.5712534090535145`*^9, 
   3.571253415656892*^9}, {3.5712534467386694`*^9, 3.5712535908149104`*^9}, {
   3.5712536509563503`*^9, 3.5712537947445745`*^9}, {3.5712538247872925`*^9, 
   3.5712538356209126`*^9}, {3.571253910745209*^9, 3.571253911039226*^9}, {
   3.571261170881465*^9, 3.571261171370493*^9}, {3.571261460107008*^9, 
   3.5712614788790817`*^9}, {3.5712617478684673`*^9, 3.571261752095709*^9}, {
   3.571261935763214*^9, 3.5712619391234064`*^9}, {3.57129414418443*^9, 
   3.5712942106272306`*^9}, {3.5712942651073465`*^9, 
   3.5712943204225106`*^9}, {3.571294511036413*^9, 3.5712945132325387`*^9}, {
   3.5714273110894947`*^9, 3.5714273270784087`*^9}, {3.5714274883526335`*^9, 
   3.5714275131650524`*^9}, {3.5714677050878963`*^9, 3.5714677110122347`*^9}, 
   3.58665155943995*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calc Thermal noise", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571214922075185*^9, 3.5712149260164104`*^9}, {
  3.5714273433133373`*^9, 3.571427346309509*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$CalcTN", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tflist", ",", "name", ",", "tn"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"calc$tnb", "[", 
           RowBox[{"[", "m", "]"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"name", "=", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], "]"}], "<>", 
             "\"\< Thermal Noise \>\"", "<>", 
             RowBox[{"ToString", "[", "calc$tnT", "]"}], "<>", 
             "\"\< K\>\""}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"mod$WriteStatus", "[", 
            RowBox[{
            "\"\<Calculating thermal noise:\>\"", "<>", "name", "<>", 
             "\"\< ...\>\""}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"tflist", "=", 
            RowBox[{"tfcalcfFD1", "[", 
             RowBox[{
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", 
              RowBox[{"allvars", "[", 
               RowBox[{"[", "m", "]"}], "]"}], ",", "freq", ",", "subkHL"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"tn", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{"-", "4"}], "*", "kB", "*", "calc$tnT", "*", 
                RowBox[{
                 RowBox[{"Im", "[", 
                  RowBox[{"tflist", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"2", "*", 
                   RowBox[{"N", "[", "Pi", "]"}], "*", 
                   RowBox[{"freq", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}], ")"}]}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdplot", ",", 
             RowBox[{"comb", "[", 
              RowBox[{"freq", ",", "tn"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdname", ",", "name"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"calc$psdline", ",", 
             RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"calc$tnb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"False", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571214930013639*^9, 3.571214937679077*^9}, {
   3.571215015034502*^9, 3.5712150350526466`*^9}, {3.571215138214547*^9, 
   3.571215141215719*^9}, {3.571215183998166*^9, 3.5712152356301193`*^9}, {
   3.5712152777225266`*^9, 3.571215278506572*^9}, {3.571215350952715*^9, 
   3.5712153770492077`*^9}, {3.5712154112631645`*^9, 3.571215525312688*^9}, {
   3.5712156937743235`*^9, 3.571215737500825*^9}, {3.571216935889368*^9, 
   3.5712169593327093`*^9}, {3.5712170846198754`*^9, 
   3.5712171180317864`*^9}, {3.5712171507766595`*^9, 
   3.5712171634983873`*^9}, {3.5712172167424326`*^9, 3.5712172608519554`*^9}, 
   3.5712177903792424`*^9, {3.5712178572860694`*^9, 3.5712178644194775`*^9}, {
   3.5712181201001015`*^9, 3.571218121238167*^9}, {3.571219511500685*^9, 
   3.57121954638068*^9}, {3.5712196071411552`*^9, 3.571219659180132*^9}, {
   3.5712391532661295`*^9, 3.5712391632397003`*^9}, {3.5712606609262977`*^9, 
   3.57126066568957*^9}, {3.5712620586092405`*^9, 3.571262058831253*^9}, {
   3.571293856071951*^9, 3.5712939523964605`*^9}, {3.57129402546364*^9, 
   3.571294078138653*^9}, {3.57129423946988*^9, 3.571294244497168*^9}, {
   3.571294306910738*^9, 3.57129433334525*^9}, {3.5714273506057544`*^9, 
   3.5714273684707766`*^9}, {3.5714294626405563`*^9, 3.571429464425658*^9}, {
   3.5714677173155956`*^9, 3.5714677174796047`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Add Seism Plot", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712323487129316`*^9, 3.5712323511910734`*^9}, {
  3.58665136118061*^9, 3.5866513658338766`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$AddSeismPlot", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"data", ",", "int", ",", "seism"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "&&", 
            RowBox[{
             RowBox[{"calc$seism", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", "\"\<\>\""}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ",",
          "True"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Beep", "[", "]"}], ";", 
        RowBox[{"CreateDialog", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<Set seismic injection.\>\"", ",", 
            RowBox[{"DefaultButton", "[", "]"}]}], "}"}], ",", 
          RowBox[{"WindowTitle", "\[Rule]", "\"\<Error\>\""}]}], "]"}], ";"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"fgridtype", ",", "\[IndentingNewLine]", 
          RowBox[{"freq", "=", 
           RowBox[{"makefreqlist", "[", 
            RowBox[{"fmin", ",", "fmax", ",", "ngrid"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"freq", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"fmin", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"n", "-", "1"}], ")"}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{"ngrid", "-", "1"}], ")"}]}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "ngrid"}], "}"}]}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"calc$sni", "[", 
             RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mod$WriteStatus", "[", 
              RowBox[{"\"\<Loading seismic injection data: \>\"", "<>", 
               RowBox[{"calc$seism", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\< ...\>\""}], "]"}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"data", "=", 
              RowBox[{"Import", "[", 
               RowBox[{
                RowBox[{"\"\<seismic/\>\"", "<>", 
                 RowBox[{"calc$seism", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "<>", "\"\<.txt\>\""}], 
                ",", "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"int", "=", 
              RowBox[{"Interpolation", "[", "data", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"seism", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"int", "[", 
                 RowBox[{"freq", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", "freq", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdplot", ",", 
               RowBox[{"comb", "[", 
                RowBox[{"freq", ",", "seism"}], "]"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdname", ",", 
               RowBox[{"\"\<Seismic \>\"", "<>", 
                RowBox[{"ToString", "[", 
                 RowBox[{"allparams", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"calc$psdline", ",", 
               RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"calc$sni", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"False", ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "allparams", "]"}], "}"}]}], "]"}]}], 
        ";"}]}], "\[IndentingNewLine]", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwdzGkog3EAx/G1A2HIVqMczTxTXrjCC7keSVOOYtkbSUyUtZEXFCJHuTLU
yrFcQ1JLmowi8cILRwl51jCseDEv1DLtjeP/+7/49nn3lTcYqpr4PB4vngQl
AVELpgUP2z7lpZpWci5hbn4f9aj8kIPa+MpHWMCFz8wS7Vwq1S2bDp4jOpls
CayPsw4sEQ3j11TdjWwESowXo3C9TGSELYqrNcjYl21w09p8Bs1pPbdwka++
g596iwPWKJQuaGIq3mB5l/kd3t+dCpeJYavPVEZgDIbSXpMYavfkUlgk8lFT
LFwUPJY4k6Fuvi4DTt5qimF/erQKDrk6SuGJg6uCGvaV+p1Z67Lg/9BKNesG
+WvENvmjEPacdythaIQgCRbq/HnQ623Mh853kd9GLIlU83aJDQZFIMwaFofB
suRXBvrakpQw8cn980WsHnD/wTNViNRHjFExMhh6nWAPMnvYHO0LdSP2Y+t3
38PqX0Z2YKS4c/vpwMNOFI5R/wGbfAj+
  "]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Manipulate Plots", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5714908311186295`*^9, 3.5714908416642323`*^9}}],

Cell[CellGroupData[{

Cell["Module SUM", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570254213586`*^9, 3.571257026355412*^9}, {
  3.571259238563943*^9, 3.571259239840016*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPSum", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fr", "=", 
        RowBox[{"{", "}"}]}], ",", "qfr", ",", 
       RowBox[{"tf", "=", 
        RowBox[{"{", "}"}]}], ",", "ncheck", ",", 
       RowBox[{"name", "=", "\"\<\>\""}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ncheck", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$tfsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$psdsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}]}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ncheck", "\[GreaterEqual]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"qfr", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"fr", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", 
               RowBox[{"fr", "[", 
                RowBox[{"[", "m", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}]}], "]"}], ",", 
            "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"qfr", ",", "False"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Sum", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], ",", 
                    "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< + \>\"", "<>", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Sqrt", "[", 
                   RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], "^", 
                    "2"}], ",", "0"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                    "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< + \>\"", "<>", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$tfsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
                 "]"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$psdsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
                 "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}],
       ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570294915915`*^9, 3.571257624202607*^9}, {
  3.5712576544433365`*^9, 3.5712582867135005`*^9}, {3.5712583223895407`*^9, 
  3.5712587654998856`*^9}, {3.5712588344558296`*^9, 3.571258868120755*^9}, {
  3.5712589016436725`*^9, 3.5712590792588315`*^9}, {3.571259143162486*^9, 
  3.5712591850938845`*^9}, {3.571259256970996*^9, 3.5712592636033754`*^9}, {
  3.5712593422788754`*^9, 3.5712593753827686`*^9}, {3.571259933710703*^9, 
  3.5712599392090178`*^9}, {3.571262072949061*^9, 3.5712620807995095`*^9}, {
  3.5714677361586733`*^9, 3.5714677429300604`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Factor", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712592447522974`*^9, 3.571259247135433*^9}, {
  3.5712630724402285`*^9, 3.5712630756224103`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPFactor", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"CreateDialog", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\"\<Input a number to multiply\>\"", ",", 
              RowBox[{
               RowBox[{"temp$tffact", "=", "1."}], ";", "\[IndentingNewLine]", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", "temp$tffact", "]"}], ",", "Number", 
                 ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<OK\>\"", ",", 
                    RowBox[{"DialogReturn", "[", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumberQ", "[", "temp$tffact", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfplot", ",", 
                    RowBox[{"comb", "[", 
                    RowBox[{
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$tffact", "*", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfname", ",", 
                    RowBox[{
                    RowBox[{"ToString", "[", "temp$tffact", "]"}], "<>", 
                    "\"\< times \>\"", "<>", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"calc$tfsel", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
                    "]"}]}]}]}], "\[IndentingNewLine]", "]"}], "]"}]}], "]"}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<Cancel\>\"", ",", 
                    RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], 
                "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{
            "WindowTitle", "\[Rule]", "\"\<Constant Multiplier\>\""}]}], 
           "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"CreateDialog", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\"\<Input a number to multiply\>\"", ",", 
              RowBox[{
               RowBox[{"temp$tffact", "=", "1."}], ";", "\[IndentingNewLine]", 
               RowBox[{"InputField", "[", 
                RowBox[{
                 RowBox[{"Dynamic", "[", "temp$tffact", "]"}], ",", "Number", 
                 ",", 
                 RowBox[{"FieldSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<OK\>\"", ",", 
                    RowBox[{"DialogReturn", "[", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"NumberQ", "[", "temp$tffact", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdplot", ",", 
                    RowBox[{"comb", "[", 
                    RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"temp$tffact", "*", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdname", ",", 
                    RowBox[{
                    RowBox[{"ToString", "[", "temp$tffact", "]"}], "<>", 
                    "\"\< times \>\"", "<>", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"calc$psdsel", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"False", ",", 
                    RowBox[{"{", 
                    RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
                    "]"}]}]}]}], "\[IndentingNewLine]", "]"}], "]"}]}], "]"}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<Cancel\>\"", ",", 
                    RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], 
                "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
            RowBox[{
            "WindowTitle", "\[Rule]", "\"\<Constant Multiplier\>\""}]}], 
           "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
  3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
  3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
  3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
  3.571261369106803*^9}, {3.5712622770797367`*^9, 3.5712628595520515`*^9}, {
  3.571262916547312*^9, 3.571262964722067*^9}, {3.5712629986970105`*^9, 
  3.57126299887302*^9}, {3.5712630778295364`*^9, 3.5712630787005863`*^9}, {
  3.5712631263463116`*^9, 3.5712632048498015`*^9}, {3.571263269385493*^9, 
  3.571263284812375*^9}, {3.571467754201705*^9, 3.5714677602250495`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Delete", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571262208209797*^9, 3.571262209085847*^9}, {
  3.5712630625876646`*^9, 3.5712630651808133`*^9}, {3.5712960235439234`*^9, 
  3.5712960246459866`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPDelete", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"calc$tfplot", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfplot", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfname", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfname", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfsel", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfsel", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfshow", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfshow", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$tfline", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$tfline", ",", "list"}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"calc$psdplot", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdplot", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdname", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdname", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdsel", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdsel", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdshow", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdshow", ",", "list"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"calc$psdline", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{"calc$psdline", ",", "list"}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
   3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
   3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
   3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
   3.571261369106803*^9}, {3.5712622136741095`*^9, 3.571262237665482*^9}, {
   3.5712630075075145`*^9, 3.5712630171580667`*^9}, {3.571263057718386*^9, 
   3.571263061223587*^9}, {3.5714677671154437`*^9, 3.5714677695515833`*^9}, {
   3.5714678975609045`*^9, 3.571467916654997*^9}, 3.571507289592078*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Multiply", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570254213586`*^9, 3.571257026355412*^9}, {
  3.571259238563943*^9, 3.571259239840016*^9}, {3.571294640092795*^9, 
  3.5712946430809655`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPMultiply", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fr", "=", 
        RowBox[{"{", "}"}]}], ",", "qfr", ",", 
       RowBox[{"tf", "=", 
        RowBox[{"{", "}"}]}], ",", "ncheck", ",", 
       RowBox[{"name", "=", "\"\<\>\""}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ncheck", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$tfsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"calc$psdsel", "[", 
              RowBox[{"[", "n", "]"}], "]"}], ",", "1", ",", "0"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}]}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ncheck", "\[GreaterEqual]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "np", "]"}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"fr", ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "1"}], "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], "]"}]}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"np", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"qfr", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"fr", "[", 
                RowBox[{"[", "n", "]"}], "]"}], "\[Equal]", 
               RowBox[{"fr", "[", 
                RowBox[{"[", "m", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"n", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", 
                RowBox[{"Length", "[", "fr", "]"}]}], "}"}]}], "]"}], ",", 
            "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"qfr", ",", "False"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Product", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], ",", 
                    "1"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$tfsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< * \>\"", "<>", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], 
                "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tf", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Product", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"np", ",", "n", ",", "2"}], "]"}], "]"}], ",", 
                    "1"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"np", ",", 
                    RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ";", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"calc$psdsel", "[", 
                    RowBox[{"[", "np", "]"}], "]"}], ",", 
                   RowBox[{"name", "=", 
                    RowBox[{"name", "<>", "\"\< * \>\"", "<>", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"np", ",", 
                   RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
                "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$tfline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$tfsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
                 "]"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdplot", ",", 
                 RowBox[{"comb", "[", 
                  RowBox[{
                   RowBox[{"fr", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "tf"}], "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdname", ",", 
                 RowBox[{"StringDrop", "[", 
                  RowBox[{"name", ",", "3"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"calc$psdline", ",", 
                 RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"calc$psdsel", "=", 
                RowBox[{"Table", "[", 
                 RowBox[{"False", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
                 "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}],
       ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5712570294915915`*^9, 3.571257624202607*^9}, {
  3.5712576544433365`*^9, 3.5712582867135005`*^9}, {3.5712583223895407`*^9, 
  3.5712587654998856`*^9}, {3.5712588344558296`*^9, 3.571258868120755*^9}, {
  3.5712589016436725`*^9, 3.5712590792588315`*^9}, {3.571259143162486*^9, 
  3.5712591850938845`*^9}, {3.571259256970996*^9, 3.5712592636033754`*^9}, {
  3.5712593422788754`*^9, 3.5712593753827686`*^9}, {3.571259933710703*^9, 
  3.5712599392090178`*^9}, {3.571262072949061*^9, 3.5712620807995095`*^9}, {
  3.571294647912242*^9, 3.571294650923414*^9}, {3.571294871071006*^9, 
  3.571294908800164*^9}, {3.5712950233117137`*^9, 3.571295025913862*^9}, {
  3.5714677802001925`*^9, 3.571467788043641*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Inverse", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712592447522974`*^9, 3.571259247135433*^9}, {
  3.5712630724402285`*^9, 3.5712630756224103`*^9}, {3.5712951082365713`*^9, 
  3.5712951090016146`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPInverse", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfplot", ",", 
                  RowBox[{"comb", "[", 
                   RowBox[{
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "/", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                   "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfname", ",", 
                  RowBox[{"\"\<Inverse \>\"", "<>", 
                   RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$tfline", ",", 
                  RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"calc$tfsel", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"False", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "calc$tfsel", "]"}], "}"}]}], 
             "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdplot", ",", 
                  RowBox[{"comb", "[", 
                   RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "/", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}]}]}], 
                   "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdname", ",", 
                  RowBox[{"\"\<Inverse \>\"", "<>", 
                   RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdline", ",", 
                  RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"calc$psdsel", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"False", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
             "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
  3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
  3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
  3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
  3.571261369106803*^9}, {3.5712622770797367`*^9, 3.5712628595520515`*^9}, {
  3.571262916547312*^9, 3.571262964722067*^9}, {3.5712629986970105`*^9, 
  3.57126299887302*^9}, {3.5712630778295364`*^9, 3.5712630787005863`*^9}, {
  3.5712631263463116`*^9, 3.5712632048498015`*^9}, {3.571263269385493*^9, 
  3.571263284812375*^9}, {3.571295112780831*^9, 3.571295115159967*^9}, {
  3.5712951584594436`*^9, 3.57129529563929*^9}, {3.5714678027484818`*^9, 
  3.57146781023391*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module RMS", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5712592447522974`*^9, 3.571259247135433*^9}, {
  3.5712630724402285`*^9, 3.5712630756224103`*^9}, {3.5712951082365713`*^9, 
  3.5712951090016146`*^9}, {3.571295832140976*^9, 3.571295832494996*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPRMS", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "rms"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[GreaterEqual]", "3"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Do", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "n", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"rms", "=", 
                 RowBox[{"makerms", "[", 
                  RowBox[{
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
                   RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdplot", ",", 
                  RowBox[{"comb", "[", 
                   RowBox[{
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
                    "rms"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdname", ",", 
                  RowBox[{"\"\<RMS \>\"", "<>", 
                   RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "n", "]"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"calc$psdline", ",", 
                  RowBox[{"{", "Thick", "}"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"calc$psdsel", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"False", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "calc$psdsel", "]"}], "}"}]}], 
             "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571259381403113*^9, 3.571259667994505*^9}, {
  3.571260015518382*^9, 3.5712600162534246`*^9}, {3.57126015167417*^9, 
  3.571260156371439*^9}, {3.5712602823206425`*^9, 3.5712602830146823`*^9}, {
  3.5712612796206846`*^9, 3.571261280454733*^9}, {3.5712613685677724`*^9, 
  3.571261369106803*^9}, {3.5712622770797367`*^9, 3.5712628595520515`*^9}, {
  3.571262916547312*^9, 3.571262964722067*^9}, {3.5712629986970105`*^9, 
  3.57126299887302*^9}, {3.5712630778295364`*^9, 3.5712630787005863`*^9}, {
  3.5712631263463116`*^9, 3.5712632048498015`*^9}, {3.571263269385493*^9, 
  3.571263284812375*^9}, {3.571295112780831*^9, 3.571295115159967*^9}, {
  3.5712951584594436`*^9, 3.57129529563929*^9}, {3.571295847401849*^9, 
  3.571295906922253*^9}, {3.5712959378560224`*^9, 3.5712959755361776`*^9}, {
  3.5714678159442368`*^9, 3.5714678161092463`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Hide", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPHide", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$tfsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$tfshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$psdsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$psdshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571296040627901*^9, 3.571296050705477*^9}, {
  3.5712960887766547`*^9, 3.57129620601236*^9}, {3.5712965808317986`*^9, 
  3.571296599400861*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Show", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPShow", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$tfsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}], 
           ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$tfsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$tfshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "True"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"list", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"calc$psdsel", "[", 
                RowBox[{"[", "l", "]"}], "]"}], ",", 
               RowBox[{"{", "l", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], "]"}],
            ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "list", "]"}], "\[GreaterEqual]", "1"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"calc$psdsel", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "False"}], ";", 
             RowBox[{
              RowBox[{"calc$psdshow", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", "True"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571296040627901*^9, 3.571296050705477*^9}, {
  3.5712960887766547`*^9, 3.5712962253404655`*^9}, {3.5712966029820657`*^9, 
  3.571296617552899*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Save", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPSave", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "ns"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$tfsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}],
             ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ns", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$tfsaveQ", "=", "False"}], ";", 
                 RowBox[{"temp$tfname", "=", 
                  RowBox[{"calc$tfname", "[", 
                   RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Save Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                    ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptmag", ",", 
                    RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"ListLogLinearPlot", "[", 
                    RowBox[{
                    RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptphs", ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    ",", 
                    RowBox[{
                    "\"\<plot/tf\>\"", "<>", "sepchar", "<>", "temp$tfname", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$tfsaveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$tfname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}]}], "]"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$tfsaveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$tfsaveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
                    ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "600"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowTitle", "\[Rule]", "\"\<Save Model\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$psdsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
             "]"}], ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ns", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$tfsaveQ", "=", "False"}], ";", 
                 RowBox[{"temp$tfname", "=", 
                  RowBox[{"calc$psdname", "[", 
                   RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Save Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                    ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"ListLogLogPlot", "[", 
                 RowBox[{
                  RowBox[{"takepsd", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                  ",", 
                  RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     ",", 
                    RowBox[{
                    "\"\<plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$tfsaveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    RowBox[{"savetf$name", "=", 
                    RowBox[{"calc$psdname", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], ",", "\"\<savetf$*\>\""}], "]"}]}],
                     "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$tfsaveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$tfsaveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3",
                     ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "600"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowTitle", "\[Rule]", "\"\<Save Model\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
          "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0DlIggEABWCRCDShNC0hSoJQ1A7+hqw0UklKhECxxA6KInCxhu4ih4aI
kAxtEMMlGsouEq8lJ2lwEU1KCgqHv8MKl2qQkP7n8PiWxxte49ScYYZOo9Hq
qMBYLZcMHORUGtfwCxx94H9APin5gzzrhDRIab4iWmDRnNiBW0OkHX563/dg
U03eCTmFXTe8u2Ucw2hPMQB582VB+OqNR6BNHE3DX/9hBlpuVkgY8hu/4Ni3
rggD6iNWiDKlPivpEUrYsJm9WFLIHRfAUEFMwAtTwgxj9yeTkMi+McPYUxAV
MFsl5cDWLg0Ppq2D9TBpHGiAawy3EFaaqkXQrWN1QH25QgYzm4ZeaJdptaXe
rEYPPdvtFihXxJdg6tK1DJ3Knw3I9HXboMO3rqSfUr+MPPXBhf7HcGc4pzoX
CSJw2sm/hs95RxyuGtuScJ8lz8B/FDbolg==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Load", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}, {3.5713013970082684`*^9, 3.5713013973902903`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPLoad", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Load Plot\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
                 "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"TableForm", "[", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ListLogLogPlot", "[", 
                  RowBox[{
                   RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", "savetf$plot", "}"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptmag",
                    ",", 
                   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"ListLogLinearPlot", "[", 
                  RowBox[{
                   RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", "savetf$plot", "}"}], ",", 
                    RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptphs",
                    ",", 
                   RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfname", ",", "savetf$name"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$tfline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "8"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Get", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</plot/tf\>\"",
                     "<>", "sepchar", "<>", "temp$tfname", "<>", 
                    "\"\<.m\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/tf\>\"", "}"}], ",", "3"}], "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
                    ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "600"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Model\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Load Plot\>\"", ",", "\[IndentingNewLine]", "Bold", ",", 
                 "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"ListLogLogPlot", "[", 
               RowBox[{
                RowBox[{"takepsd", "[", 
                 RowBox[{
                  RowBox[{"{", "savetf$plot", "}"}], ",", 
                  RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                ",", 
                RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], "]"}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdname", ",", "savetf$name"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Get", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/psd\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.m\>\""}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<plot/psd\>\"", "}"}], ",", "3"}], "]"}],
                     "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3",
                     ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "600"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Load Model\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0VkowwEABvDFwpBzQ4m16O8+Jjm3Zmo1KbWFtRCR2stQcqRQruRqbS/L
URoPzJU1QzTSkkYtsxx7sjLHkBdXS8v/+z98/V6+vpeP09wubfWj0WgcMtAS
y3Qb5zxCkab2EdY5415hnDv9D7KUjRk7pPJtbhb0yW0TcKzGPQXfFl5UMDnm
Qw2jvDNaeH3FWIFmvs8IWZ30Hfi0YN2DA2lmB/w26G6h4rTXDU2G6ndY/1np
g8by5VATqb18nXKWSI+EmZFdlASzgQ1N3jQu3JTZ5NBys9oEua7n4F3s8bgh
0BWREQWzi0Us6FBWJcDLanEi7GNoCRgui06B2srQAigJ4BXC2yGpAE4VVlRQ
vTaRBM6O5ylgKc/aDe1bmh6oLvvqh8H6kgG4KJUOwwBiaRJuETkqyE560sHx
n+19eDjtojwfSj2CJRzdCTzObzmDB4F3f3Akgu6/Rzoab6G06jeYkP/gS4D2
rlNr0Dz5C895Ab2/MyK/NY+w41kghrntg86iXY8wrPjyHv4Drooe6w==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Export", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}, {3.585722145642765*^9, 3.5857221464488106`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPExport", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "ns", ",", "tfd"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$tfsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$tfplot", "]"}]}], "}"}]}], "]"}],
             ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ns", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$saveQ", "=", "False"}], ";", 
                 RowBox[{"temp$exname", "=", 
                  RowBox[{"calc$tfname", "[", 
                   RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export Plot Data\>\"", ",", "\[IndentingNewLine]", 
                    "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"ListLogLogPlot", "[", 
                    RowBox[{
                    RowBox[{"takemag", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptmag", ",", 
                    RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"ListLogLinearPlot", "[", 
                    RowBox[{
                    RowBox[{"takephs", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$tfshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
                    "baseoptphs", ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "180"}], ",", "180"}], "}"}]}], "}"}]}]}], 
                    "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$exname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"30.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], ",", 
                    RowBox[{
                    "\"\<plot/data\>\"", "<>", "sepchar", "<>", "temp$exname",
                     "<>", "\"\<.dat\>\""}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$saveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"tfd", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"export$tf", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Arg", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "/", 
                    "deg"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "tfd", "]"}]}], "}"}]}], "]"}]}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", "export$tf", 
                    ",", "\"\<Table\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"tfd", "=", 
                    RowBox[{"calc$tfplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"export$tf", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Arg", "[", 
                    RowBox[{"tfd", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", ",", "2"}], "]"}], "]"}], "]"}], "/", 
                    "deg"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "tfd", "]"}]}], "}"}]}], "]"}]}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", "export$tf", 
                    ",", "\"\<Table\>\""}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                    RowBox[{"temp$saveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", 
                    "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$saveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$exname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "3", ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "600"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
              "WindowTitle", "\[Rule]", "\"\<Export Plot Data\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"list", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$psdsel", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], ",", "l", ",", "0"}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"l", ",", 
                RowBox[{"Length", "[", "calc$psdplot", "]"}]}], "}"}]}], 
             "]"}], ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "list", "]"}], "\[Equal]", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ns", "=", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"CreateDialog", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp$saveQ", "=", "False"}], ";", 
                 RowBox[{"temp$exname", "=", 
                  RowBox[{"calc$psdname", "[", 
                   RowBox[{"[", "ns", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"TextCell", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Export Plot Data\>\"", ",", "\[IndentingNewLine]", 
                    "Bold", ",", "Italic", ",", "White"}], "]"}], ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"ListLogLogPlot", "[", 
                 RowBox[{
                  RowBox[{"takepsd", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"calc$psdshow", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], "}"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                  ",", 
                  RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"TableForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"InputField", "[", 
                    RowBox[{
                    RowBox[{"Dynamic", "[", "temp$exname", "]"}], ",", 
                    "String", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], ",", 
                    RowBox[{
                    "\"\<plot/data\>\"", "<>", "sepchar", "<>", "temp$tfname",
                     "<>", "\"\<.dat\>\""}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$saveQ", "=", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], ",", "\"\<Table\>\""}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                    RowBox[{"DialogReturn", "[", "]"}], ",", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                   "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"PaneSelector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
                    RowBox[{"TableForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Do you really want to overwrite?\>\"", ",", "Red", 
                    ",", "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Export", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$exname", "<>", "\"\<.dat\>\""}], ",", 
                    RowBox[{"calc$psdplot", "[", 
                    RowBox[{"[", "ns", "]"}], "]"}], ",", "\"\<Table\>\""}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<No\>\"", ",", "Bold", ",", "Small", ",", 
                    "Black"}], "]"}], ",", 
                    RowBox[{"temp$saveQ", "=", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    "Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
                    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
                    RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", 
                   "temp$saveQ", ",", 
                   RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Dynamic", "[", 
                 RowBox[{"Pane", "[", 
                  RowBox[{
                   RowBox[{"TableForm", "[", 
                    RowBox[{
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$exname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "3", ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                    RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                   RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}],
                  "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowElements", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<VerticalScrollBar\>\"", ",", 
                 "\"\<HorizontalScrollBar\>\"", ",", 
                 "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"WindowSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"550", ",", "600"}], "}"}]}], ",", 
              RowBox[{"WindowMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
              "WindowTitle", "\[Rule]", "\"\<Export Plot Data\>\""}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
          "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0GtIkwEUBmCVtdINdDcdhS1jzHuxEE23bLNWmRRszGxtlV0kQzTCWlcd
GHhjpU2LZUiZMWyW0djFfrQohsj+iDZqJDoXzTmriZAWOr763u/H4fnznvPC
yTh7SVWTEBcXJyYHetK4IfvjRbmi59g81H7l/4D8UE4M8upP5zpINW/E+ZDQ
THTC1sqQEf7sj3RDYeqSCbLX7pnh50+JQ9C9h7BDXiPNAcP93lHYnO32wVXb
Mz+sHbsegk6b+hfU/a4goL3sOdNJOlX2krJPlMOCeayrlCLuSQF0rmWL4UjV
hAZ6vryohuLgQpIL96RiBgym5LLhjmIFD/rqj6bDSfWhrfBmolkEk6s4mdBc
wSyESrq0CPpbVHuhsai8nMo1KJSwr31XLZRIvXo49brnGjTJVppgkrWkGXZZ
b8kShsm/nJjdD68cnHbtdi3KX2UKRuE5E/8dDCx1eeEN9c5J2MuU+CE7beY7
LFhJD8HNhuEINHQ+XYYXbdo/UGAIUhYqj/yDhOVvfDFpVmWEDv0b6xiwdSCV
A6W6CA8K21lb4Db3Psrp9VAGPDUwnwWTA3flkDGWf5jaV4Wr4YFY9AwcT/HU
wIAlWgdHtbTL8GGHrAlye6Ut0NG4fgfq9fQ+aBpfGKT6nhwfgpZN1o/w/CP1
FLwtFfrhXLhhBnaoPszBB6WDETjb0x2DRLQgvoS09P2FDZBFW+bA7SOrlMa3
bYI20m95dkrffYkQEjQd5X/j8p6+
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["Module Import", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571296002896743*^9, 3.5712960058879137`*^9}, {
  3.571296215118881*^9, 3.571296215567907*^9}, {3.571297220089362*^9, 
  3.5712972205983915`*^9}, {3.5713013970082684`*^9, 3.5713013973902903`*^9}, {
  3.5905589543018*^9, 3.590558955067844*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$FPImport", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "list", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sepchar", "=", 
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FileNames", "[", 
           RowBox[{"\"\<*.m\>\"", ",", 
            RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"calc$tfk", "\[LessEqual]", " ", "2"}], ",", 
        "\[IndentingNewLine]", "Null", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"savetf$plot", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.01", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"100", ",", "1"}], "}"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CreateDialog", "[", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"TextCell", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Import Plot\>\"", ",", "\[IndentingNewLine]", "Bold", 
                 ",", "Italic", ",", "White"}], "]"}], ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"ListLogLogPlot", "[", 
               RowBox[{
                RowBox[{"takepsd", "[", 
                 RowBox[{
                  RowBox[{"{", "savetf$plot", "}"}], ",", 
                  RowBox[{"{", "True", "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"ImageSize", "\[Rule]", "300"}], ",", "baseoptpsd", 
                ",", 
                RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], "]"}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], 
              "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"InputField", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "[", "temp$tfname", "]"}], ",", 
                   "String", ",", 
                   RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Load\>\"", ",", "Bold", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdplot", ",", "savetf$plot"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdname", ",", "temp$tfname"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdsel", ",", "False"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdshow", ",", "True"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"calc$psdline", ",", 
                    RowBox[{"{", "Thick", "}"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DialogReturn", "[", "]"}]}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
                   RowBox[{"DialogReturn", "[", "]"}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"TableForm", "[", 
                 RowBox[{
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", "=", "n"}], "}"}], ",", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"temp$tfname", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "10"}], "]"}], ",", 
                    RowBox[{"-", "4"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"savetf$plot", "=", 
                    RowBox[{"Import", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", 
                    "\"\</plot/data\>\"", "<>", "sepchar", "<>", 
                    "temp$tfname", "<>", "\"\<.dat\>\""}], "]"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "150"}]}], "]"}]}], "]"}],
                     "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.dat\>\"", ",", 
                    RowBox[{"{", "\"\<plot/data\>\"", "}"}], ",", "3"}], 
                    "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "3", ",", "3", ",", "1", ",", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                  RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
                RowBox[{"ImageSize", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"500", ",", "200"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowElements", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", 
              ",", "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"550", ",", "600"}], "}"}]}], ",", 
           RowBox[{"WindowMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"WindowTitle", "\[Rule]", "\"\<Import Plot\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJwd0VtIWgEABmBxUeu6alrBsIiNU+pWWdFthhkcKIJB4nLSRrEW9NKFogtB
BV1GdEMKQrpAuTG2ttYSs8uGi5KIU6y0uw+RkV2s0Us3RA6d/zz8fC8//8sf
+b5cUczlcDhRTKA5lOcwDDrlZF/eMcy3hZ3DMIfIDfmlBeIpRvWk5AWk1Wsd
8ONrRxe8GD7TwGchl70w2NWjhdsb3l+hKZ02QH6VxxQ8GaZmYKPQtAlv9Lpd
WLJU54BGvfI/fHuVQ0ND5mc/I6M18wfrACEKgs+DqlkJ3rsIaHQJJfCnak0N
zTvfCqHEfuozjT2pxBfaA8XBMCaV5MPN0lcCaFFmhcN6by0BH6keR0Ftjl8S
zPWUJsPdZoUMdiVnZ7O9MjIXDrTHl8CXUqoGWif6amFvxnUD9BlLa4QjCkUL
9CQ+dcIJIlYDI56e6GD77eQs/NNtZ11pjv4L0yJ1C3A+sWgZ/vbac8PWQI8H
M4xtT8ys1Ng4D6Yf0QJorV6iHg4xv0htq9B110NyvzvlFaeyLBhX3mRLmXbK
A1ItB3CVfPOrct4pVya06eGXfvccjNn4sAD311speFhz8Q8OLgppKAuluVWM
opstf6gRH7AKxsP50GYZZb0H52ZVMw==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["Line Style", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.571465366897159*^9, 3.5714653713604145`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$FPLineStyle", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$lc", "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"temp$lt", "=", "2"}], ";", "\[IndentingNewLine]", 
        RowBox[{"temp$ls", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Line Style Setting\>\"", ",", "\[IndentingNewLine]", "Bold", 
            ",", "Italic", ",", "White"}], "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Set RGB Color:\>\"", ",", "Bold"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$lc", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{"1", ",", ".8", ",", ".8"}], "}"}], "]"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$lc", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{".8", ",", "1", ",", ".8"}], "}"}], "]"}]}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", 
              RowBox[{"temp$lc", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{".8", ",", ".8", ",", "1"}], "}"}], "]"}]}]}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{".5", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", ".5", ",", "0"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"mod$CButton", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", ".5"}], "}"}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Set Thickness:\>\"", ",", "Bold"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$lt", "]"}], ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"3.", ",", "1."}], "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"RGBColor", "[", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1", ",", "1"}], "}"}], "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Line Style:\>\"", ",", "Bold"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PopupMenu", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$ls", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", "\"\<Solid\>\""}], ",", 
               RowBox[{"2", "\[Rule]", "\"\<Dashed\>\""}], ",", 
               RowBox[{"3", "\[Rule]", "\"\<Dotdashed\>\""}]}], "}"}]}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Graphics", "[", 
         RowBox[{
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"temp$ls", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
              RowBox[{"RGBColor", "[", "temp$lc", "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"temp$ls", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
              RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", "Dashed"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"temp$ls", "\[Equal]", "3"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
              RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", "DotDashed"}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<OK\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", 
              RowBox[{"(*", 
               RowBox[{"Save", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"calc$tfk", "\[LessEqual]", "2"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"temp$ls", "\[Equal]", "1"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}]}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "2"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "Dashed"}], "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "3"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$tfline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "DotDashed"}], "}"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"temp$ls", "\[Equal]", "1"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}]}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "2"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "Dashed"}], "}"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"temp$ls", "\[Equal]", "3"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"calc$psdline", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "=", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", "temp$lc", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "temp$lt", "]"}], ",", 
                    "DotDashed"}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
               "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{"\"\<Cancel\>\"", ",", 
             RowBox[{"DialogReturn", "[", "]"}]}], "]"}]}], "}"}], "}"}], 
        "]"}]}], 
      RowBox[{"(*", 
       RowBox[{"Cancel", " ", "Button"}], "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"WindowSize", "\[Rule]", "400"}], ",", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Line Style Setting\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.571465375568655*^9, 3.571465539966058*^9}, {
  3.57146560049352*^9, 3.5714657543553205`*^9}, {3.5714659486294327`*^9, 
  3.5714659865396004`*^9}, {3.5714660242947598`*^9, 3.5714661555082655`*^9}, {
  3.5714662438713193`*^9, 3.571466752277398*^9}, {3.571466911477504*^9, 
  3.57146691228555*^9}, {3.5714670027447243`*^9, 3.571467055324732*^9}, {
  3.5714671280898933`*^9, 3.5714671685032053`*^9}, {3.57146720058604*^9, 
  3.571467267626875*^9}, {3.571467301356804*^9, 3.5714673030799026`*^9}, {
  3.5714673390289583`*^9, 3.5714675592185526`*^9}, {3.571468020233921*^9, 
  3.5714680281463737`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$CButton", "[", "c_List", "]"}], ":=", 
   RowBox[{"Button", "[", 
    RowBox[{"\"\<     \>\"", ",", 
     RowBox[{"temp$lc", "=", "c"}], ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
     RowBox[{"Background", "\[Rule]", 
      RowBox[{"RGBColor", "[", "c", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5714657572034836`*^9, 3.5714659432271233`*^9}, {
  3.571466880307721*^9, 3.571466882676857*^9}, {3.5714669634504766`*^9, 
  3.571466974909132*^9}, {3.571467272429149*^9, 3.57146727262016*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["5. Eigen Plot", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.571329340391183*^9, 3.5713293410172186`*^9}, {
  3.5714908557360373`*^9, 3.571490857915162*^9}}],

Cell[CellGroupData[{

Cell["eigen view", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5713415191377673`*^9, 3.5713415209908733`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"optp", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ViewPoint", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Infinity", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"ViewVertical", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"optr", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ViewPoint", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "Infinity"}], "}"}]}], ",", 
     RowBox[{"ViewVertical", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"viewQ", "[", "s_", "]"}], ":=", 
   RowBox[{
    RowBox[{"StringMatchQ", "[", 
     RowBox[{"s", ",", "\"\<x*\>\""}], "]"}], "||", 
    RowBox[{"StringMatchQ", "[", 
     RowBox[{"s", ",", "\"\<r*\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["6. Export", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5787900163706245`*^9, 3.578790019341794*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Export"
}], "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857318694289336`*^9, 3.585731875859301*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Export"
}], "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.57879020161222*^9, 3.5787902026772804`*^9}, {
  3.585728754662779*^9, 3.585728756669894*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$ExportModel", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$saveQ", "=", "False"}], ";", 
        RowBox[{"temp$type", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Export Suspension Model in Mathematica Format\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Saved Parameters:\>\"", ",", "Bold", ",", "Italic"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<matKpvc\>\"", ",", "\"\<matKvvc\>\"", ",", "\"\<matMvv\>\"", 
             ",", "\"\<matMpv\>\"", ",", "\"\<matGpv\>\"", ",", 
             "\"\<matGvv\>\"", ",", "\"\<allvars\>\"", ",", 
             "\"\<allparams\>\""}], "}"}], ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Export Type:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "temp$type", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "\[Rule]", "\"\<All\>\""}], ",", 
           RowBox[{"2", "\[Rule]", "\"\<Z,Pitch\>\""}], ",", 
           RowBox[{"3", "\[Rule]", "\"\<X,Roll\>\""}], ",", 
           RowBox[{"4", "\[Rule]", "\"\<Y\>\""}], ",", 
           RowBox[{"5", "\[Rule]", "\"\<Yaw\>\""}]}], "}"}]}], "]"}], ",", 
       "\"\<\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$FileName", "]"}], ",", "String", 
             ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"StringLength", "[", "temp$FileName", "]"}], 
                 "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                   ",", 
                   RowBox[{
                   "\"\<matrix\>\"", "<>", "sepchar", "<>", "temp$FileName", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"temp$saveQ", "=", "True"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Module", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "nv", ",", "np", ",", "allvars2", ",", "allparams2", ",", 
                    "matKpvc2", ",", "matKvvc2", ",", "matMvv2", ",", 
                    "matMpv2", ",", "matGpv2", ",", "matGvv2"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Which", "[", 
                    RowBox[{
                    RowBox[{"temp$type", "\[Equal]", "1"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], 
                    "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}]}], ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "2"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allparams", "]"}]}], 
                    ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "3"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allparams", "]"}]}], ";"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "4"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeY", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeY", "[", "allparams", "]"}]}], ";"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "5"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allparams", "]"}]}], ";"}]}],
                     "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars2", "=", "allvars"}], ";", 
                    RowBox[{"allparams2", "=", "allparams"}], ";", 
                    RowBox[{"matMvv2", "=", "matMvv"}], ";", 
                    RowBox[{"matMpv2", "=", "matMpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc2", "=", "matKvvc"}], ";", 
                    RowBox[{"matKpvc2", "=", "matKpvc"}], ";", 
                    RowBox[{"matGvv2", "=", "matGvv"}], ";", 
                    RowBox[{"matGpv2", "=", "matGpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", 
                    RowBox[{"allvars2", "[", 
                    RowBox[{"[", "nv", "]"}], "]"}]}], ";", 
                    RowBox[{"allparams", "=", 
                    RowBox[{"allparams2", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", 
                    RowBox[{"matKvvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matKpvc", "=", 
                    RowBox[{"matKpvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matMvv", "=", 
                    RowBox[{"matMvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matMpv", "=", 
                    RowBox[{"matMpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matGvv", "=", 
                    RowBox[{"matGvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matGpv", "=", 
                    RowBox[{"matGpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matrix\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<matKpvc\>\"", ",", "\"\<matKvvc\>\"", ",", 
                    "\"\<matMvv\>\"", ",", "\"\<matMpv\>\"", ",", 
                    "\"\<matGpv\>\"", ",", "\"\<matGvv\>\"", ",", 
                    "\"\<allvars\>\"", ",", "\"\<allparams\>\""}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", "allvars2"}], ";", 
                    RowBox[{"allparams", "=", "allparams2"}], ";", 
                    RowBox[{"matMvv", "=", "matMvv2"}], ";", 
                    RowBox[{"matMpv", "=", "matMpv2"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", "matKvvc2"}], ";", 
                    RowBox[{"matKpvc", "=", "matKpvc2"}], ";", 
                    RowBox[{"matGvv", "=", "matGvv2"}], ";", 
                    RowBox[{"matGpv", "=", "matGpv2"}], ";"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"PaneSelector", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<Do you really want to overwrite?\>\"", ",", "Red", ",",
                    "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matrix\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "nv", ",", "np", ",", "allvars2", ",", "allparams2", ",", 
                    "matKpvc2", ",", "matKvvc2", ",", "matMvv2", ",", 
                    "matMpv2", ",", "matGpv2", ",", "matGvv2"}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Which", "[", 
                    RowBox[{
                    RowBox[{"temp$type", "\[Equal]", "1"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], 
                    "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{"n", ",", 
                    RowBox[{"{", 
                    RowBox[{"n", ",", 
                    RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], 
                    "]"}]}], ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "2"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeZPitch", "[", "allparams", "]"}]}], 
                    ";"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "3"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeXRoll", "[", "allparams", "]"}]}], ";"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "4"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeY", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeY", "[", "allparams", "]"}]}], ";"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"temp$type", "\[Equal]", "5"}], ",", 
                    RowBox[{
                    RowBox[{"nv", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allvars", "]"}]}], ";", 
                    RowBox[{"np", "=", 
                    RowBox[{"mod$TakeYaw", "[", "allparams", "]"}]}], ";"}]}],
                     "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars2", "=", "allvars"}], ";", 
                    RowBox[{"allparams2", "=", "allparams"}], ";", 
                    RowBox[{"matMvv2", "=", "matMvv"}], ";", 
                    RowBox[{"matMpv2", "=", "matMpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc2", "=", "matKvvc"}], ";", 
                    RowBox[{"matKpvc2", "=", "matKpvc"}], ";", 
                    RowBox[{"matGvv2", "=", "matGvv"}], ";", 
                    RowBox[{"matGpv2", "=", "matGpv"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", 
                    RowBox[{"allvars2", "[", 
                    RowBox[{"[", "nv", "]"}], "]"}]}], ";", 
                    RowBox[{"allparams", "=", 
                    RowBox[{"allparams2", "[", 
                    RowBox[{"[", "np", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", 
                    RowBox[{"matKvvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matKpvc", "=", 
                    RowBox[{"matKpvc2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matMvv", "=", 
                    RowBox[{"matMvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matMpv", "=", 
                    RowBox[{"matMpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matGvv", "=", 
                    RowBox[{"matGvv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
                    RowBox[{"matGpv", "=", 
                    RowBox[{"matGpv2", "[", 
                    RowBox[{"[", 
                    RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Save", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matrix\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<matKpvc\>\"", ",", "\"\<matKvvc\>\"", ",", 
                    "\"\<matMvv\>\"", ",", "\"\<matMpv\>\"", ",", 
                    "\"\<matGpv\>\"", ",", "\"\<matGvv\>\"", ",", 
                    "\"\<allvars\>\"", ",", "\"\<allparams\>\""}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"allvars", "=", "allvars2"}], ";", 
                    RowBox[{"allparams", "=", "allparams2"}], ";", 
                    RowBox[{"matMvv", "=", "matMvv2"}], ";", 
                    RowBox[{"matMpv", "=", "matMpv2"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"matKvvc", "=", "matKvvc2"}], ";", 
                    RowBox[{"matKpvc", "=", "matKpvc2"}], ";", 
                    RowBox[{"matGvv", "=", "matGvv2"}], ";", 
                    RowBox[{"matGpv", "=", "matGpv2"}], ";"}]}], "]"}], ";"}],
                     "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                   RowBox[{"temp$saveQ", "=", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
            RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", "temp$saveQ", 
          ",", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$FileName", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "]"}],
                 "\[IndentingNewLine]", ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matrix\>\"", "}"}], ",", "3"}], "]"}], 
                   "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
              ",", "3", ",", "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"650", ",", "200"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Export Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.5787902436766253`*^9, 3.5787902658128915`*^9}, {3.5787903547369776`*^9, 
   3.5787904264820814`*^9}, {3.578790459612976*^9, 3.5787905160222025`*^9}, {
   3.5787907047679987`*^9, 3.5787907076121607`*^9}, {3.5787907590391026`*^9, 
   3.578790854695574*^9}, 3.5787908945598536`*^9, {3.5787910433383636`*^9, 
   3.5787910545650053`*^9}, 3.5788748266424856`*^9, {3.5788749247060947`*^9, 
   3.5788749261751785`*^9}, {3.579318855301427*^9, 3.579318871026327*^9}, {
   3.5857288163333063`*^9, 3.5857288346983566`*^9}, {3.585728874304622*^9, 
   3.585728920231249*^9}, {3.5857289892501965`*^9, 3.5857291668643556`*^9}, {
   3.5857292018953595`*^9, 3.585729251991225*^9}, {3.585730505333912*^9, 
   3.5857309915687227`*^9}, {3.585731023893572*^9, 3.585731237672799*^9}, 
   3.5857312761730013`*^9, {3.585731411926766*^9, 3.5857314192201834`*^9}, {
   3.585731900074686*^9, 3.58573192811629*^9}, {3.585732235315861*^9, 
   3.5857322528208623`*^9}, {3.5857379064782333`*^9, 3.585737945148445*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Take Part", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857292607697268`*^9, 3.5857292671510916`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeZPitch", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "vc", ",", "vex"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"v1", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<z\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"v2", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<p\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vc", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"v1", ",", "v2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585729353437027*^9, 3.585729485546583*^9}, {
  3.5857300745512724`*^9, 3.5857301563869534`*^9}, {3.5857302196485715`*^9, 
  3.5857302375225935`*^9}, {3.5857302716795473`*^9, 3.5857302742826967`*^9}, {
  3.5857316330104113`*^9, 3.5857316337974563`*^9}, {3.585731727352807*^9, 
  3.5857317302059703`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeXRoll", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "vc", ",", "vex"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"v1", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<x\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"v2", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<r\>\""}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vc", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"v1", ",", "v2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585729353437027*^9, 3.585729485546583*^9}, {
  3.5857300745512724`*^9, 3.5857301563869534`*^9}, {3.5857302196485715`*^9, 
  3.5857302375225935`*^9}, {3.5857302716795473`*^9, 3.5857302742826967`*^9}, {
  3.5857303177991858`*^9, 3.5857303330250564`*^9}, {3.585731629736224*^9, 
  3.585731630037241*^9}, {3.5857317327891183`*^9, 3.5857317333801517`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeY", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vc", ",", "vex"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vc", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Characters", "[", "#", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<y\>\""}], "&&", 
           RowBox[{"Not", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Characters", "[", "#", "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "\"\<a\>\""}], 
            "]"}]}], "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5857303474308805`*^9, 3.585730383015916*^9}, {
   3.5857316276431046`*^9, 3.585731628021126*^9}, 3.585731737804405*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$TakeYaw", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vc", ",", "vex"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vc", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"list", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Characters", "[", "#", "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "2"}], "]"}], "]"}], "\[Equal]", 
           RowBox[{"{", 
            RowBox[{"\"\<y\>\"", ",", "\"\<a\>\""}], "}"}]}], "&"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vex", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"vc", "[", 
           RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vc", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sort", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"list", ",", 
            RowBox[{"vex", "[", 
             RowBox[{"[", "n", "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "vex", "]"}]}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585730389443283*^9, 3.5857304302716184`*^9}, {
  3.585731622043784*^9, 3.5857316229638367`*^9}, {3.585731736714343*^9, 
  3.585731766847066*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MATLAB Export", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.585731879736523*^9, 3.585731881796641*^9}}],

Cell[CellGroupData[{

Cell["MATLAB Export", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857318861388893`*^9, 3.5857318880309973`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mod$MATLABExport", ":=", "\[IndentingNewLine]", 
   RowBox[{"CreateDialog", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"temp$saveQ", "=", "False"}], ";", 
        RowBox[{"temp$type", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ValueQ", "[", "save$viscous", "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", "save$viscous", "]"}], "\[Equal]", 
            RowBox[{"Length", "[", "allvars", "]"}]}]}], ",", 
          RowBox[{"temp$viscous", "=", "save$viscous"}], ",", 
          RowBox[{"temp$viscous", "=", 
           RowBox[{"Table", "[", 
            RowBox[{"1.", ",", 
             RowBox[{"{", 
              RowBox[{"Length", "[", "allvars", "]"}], "}"}]}], "]"}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"sepchar", "=", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FileNames", "[", 
             RowBox[{"\"\<*.m\>\"", ",", 
              RowBox[{"{", "\"\<save\>\"", "}"}], ",", "3"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"TextCell", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Export ABCD Matrices in MATLAB Format\>\"", ",", 
            "\[IndentingNewLine]", "Bold", ",", "Italic", ",", "White"}], 
           "]"}], ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"0", ",", "0", ",", "0"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{
        "\"\<Conversion Frequency [Hz] from Structure to Viscous \
Damping:\>\"", ",", "Bold", ",", "Italic"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ToExpression", "[", 
                 RowBox[{"allvars", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"Dynamic", "[", 
                    RowBox[{"temp$viscous", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", "Number", ",", 
                    RowBox[{"FieldSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"5.", ",", "1."}], "}"}]}]}], "]"}]}], "]"}]}], 
               "}"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}], 
           "\[IndentingNewLine]", ",", "6", ",", "6", ",", "1", ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Export Type:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"PopupMenu", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", "temp$type", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "\[Rule]", "\"\<All\>\""}], ",", 
           RowBox[{"2", "\[Rule]", "\"\<Z,Pitch\>\""}], ",", 
           RowBox[{"3", "\[Rule]", "\"\<X,Roll\>\""}], ",", 
           RowBox[{"4", "\[Rule]", "\"\<Y\>\""}], ",", 
           RowBox[{"5", "\[Rule]", "\"\<Yaw\>\""}]}], "}"}]}], "]"}], ",", 
       "\"\<\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<File Name:\>\"", ",", "Bold", ",", "Italic"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"TableForm", "[", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InputField", "[", 
            RowBox[{
             RowBox[{"Dynamic", "[", "temp$FileName", "]"}], ",", "String", 
             ",", 
             RowBox[{"FieldSize", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"20.", ",", "1."}], "}"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Save\>\"", ",", "Bold", ",", "White"}], "]"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", 
                RowBox[{
                 RowBox[{"StringLength", "[", "temp$FileName", "]"}], 
                 "\[Equal]", "0"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                   ",", 
                   RowBox[{
                   "\"\<matlab\>\"", "<>", "sepchar", "<>", "temp$FileName", 
                    "<>", "\"\<.m\>\""}]}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"temp$saveQ", "=", "True"}], ",", 
                 RowBox[{
                  RowBox[{"mod$SaveMATLAB", "[", "temp$type", "]"}], ";", 
                  RowBox[{"save$viscous", "=", "temp$viscous"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"DialogReturn", "[", "]"}]}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}], ",", 
             RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Button", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Cancel\>\"", ",", "Bold"}], "]"}], ",", 
             RowBox[{"DialogReturn", "[", "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}], ",", 
             RowBox[{"Background", "\[Rule]", 
              RowBox[{"GrayLevel", "[", ".8", "]"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"PaneSelector", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"TableForm", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<Do you really want to overwrite?\>\"", ",", "Red", ",",
                    "Bold"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Yes\>\"", ",", "Bold", ",", "Small", ",", "White"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DialogReturn", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DeleteFile", "[", 
                    RowBox[{
                    RowBox[{"Directory", "[", "]"}], "<>", "\"\</matlab\>\"", 
                    "<>", "sepchar", "<>", "temp$FileName", "<>", 
                    "\"\<.m\>\""}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"mod$SaveMATLAB", "[", "temp$type", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"save$viscous", "=", "temp$viscous"}], ";"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], ",", 
                   RowBox[{"Method", "\[Rule]", "\"\<Queued\>\""}]}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Button", "[", 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<No\>\"", ",", "Bold", ",", "Small", ",", "Black"}], 
                    "]"}], ",", 
                   RowBox[{"temp$saveQ", "=", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<FramedPalette\>\""}],
                    ",", 
                   RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], "}"}], "]"}]}], ",", 
            RowBox[{"False", "\[Rule]", "Null"}]}], "}"}], ",", "temp$saveQ", 
          ",", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Pane", "[", 
         RowBox[{
          RowBox[{"TableForm", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Table", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", "n"}], "}"}], ",", 
                  RowBox[{"Button", "[", 
                   RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"temp$FileName", "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                    "[", 
                    RowBox[{"[", "n", "]"}], "]"}], ",", "7"}], "]"}], ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", "\"\<Frameless\>\""}], 
                    ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "]"}],
                 "\[IndentingNewLine]", ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{"FileNames", "[", 
                    RowBox[{"\"\<*.m\>\"", ",", 
                    RowBox[{"{", "\"\<matlab\>\"", "}"}], ",", "3"}], "]"}], 
                   "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "3", 
              ",", "3", ",", "1", ",", 
              RowBox[{"{", "}"}]}], "]"}], ",", 
            RowBox[{"TableAlignments", "\[Rule]", "Left"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Scrollbars", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"650", ",", "200"}], "}"}]}], ",", 
          RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowElements", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<VerticalScrollBar\>\"", ",", "\"\<HorizontalScrollBar\>\"", ",", 
        "\"\<MagnificationPopUp\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WindowSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"700", ",", "500"}], "}"}]}], ",", 
     RowBox[{"WindowMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Automatic"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "0"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WindowTitle", "\[Rule]", "\"\<Export Model\>\""}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5702977833776617`*^9, 3.5702977905570717`*^9}, {
   3.5703591805925045`*^9, 3.5703594243684483`*^9}, {3.570359484469886*^9, 
   3.570359509181299*^9}, {3.570359553843854*^9, 3.570359564336454*^9}, {
   3.5703596177655096`*^9, 3.5703596988271465`*^9}, {3.570359901473737*^9, 
   3.5703599266941795`*^9}, {3.570359974904937*^9, 3.570360010483972*^9}, {
   3.5703601849669523`*^9, 3.570360260360264*^9}, {3.5703603354415584`*^9, 
   3.5703604557814417`*^9}, {3.570360489654379*^9, 3.570360497921852*^9}, {
   3.5703605415123453`*^9, 3.5703605773553953`*^9}, {3.570360630030408*^9, 
   3.570360642559125*^9}, {3.5703606768510857`*^9, 3.570360694091072*^9}, {
   3.570360784015216*^9, 3.5703608310619063`*^9}, {3.570360875519449*^9, 
   3.570361073200756*^9}, {3.570361109604838*^9, 3.5703611853101683`*^9}, {
   3.5703612271215596`*^9, 3.5703616409562297`*^9}, {3.5703616768182807`*^9, 
   3.5703616996915894`*^9}, {3.5703617573468866`*^9, 3.570361819316431*^9}, {
   3.570361917096024*^9, 3.5703619228953557`*^9}, 3.570361976045396*^9, {
   3.570362476483019*^9, 3.570362537149489*^9}, {3.5703625734585657`*^9, 
   3.570362581452023*^9}, {3.5703626575123734`*^9, 3.570362677875538*^9}, {
   3.570362792112072*^9, 3.570362967979131*^9}, 3.570363022995278*^9, {
   3.5703630837347517`*^9, 3.570363094144347*^9}, {3.570363162470255*^9, 
   3.570363230586151*^9}, {3.5703632671562433`*^9, 3.570363287924431*^9}, {
   3.5703633465967865`*^9, 3.570363511715231*^9}, {3.5703635417239475`*^9, 
   3.5703635419689617`*^9}, {3.570363573252751*^9, 3.57036357551488*^9}, {
   3.570363616440221*^9, 3.5703636234836235`*^9}, {3.570363741830393*^9, 
   3.5703637614565153`*^9}, {3.5703640600675945`*^9, 3.570364186888849*^9}, {
   3.570364252268588*^9, 3.5703642556427813`*^9}, {3.570364861794451*^9, 
   3.5703648630975256`*^9}, {3.571491938574972*^9, 3.571491963204381*^9}, {
   3.5787902436766253`*^9, 3.5787902658128915`*^9}, {3.5787903547369776`*^9, 
   3.5787904264820814`*^9}, {3.578790459612976*^9, 3.5787905160222025`*^9}, {
   3.5787907047679987`*^9, 3.5787907076121607`*^9}, {3.5787907590391026`*^9, 
   3.578790854695574*^9}, 3.5787908945598536`*^9, {3.5787910433383636`*^9, 
   3.5787910545650053`*^9}, 3.5788748266424856`*^9, {3.5788749247060947`*^9, 
   3.5788749261751785`*^9}, {3.579318855301427*^9, 3.579318871026327*^9}, {
   3.5857288163333063`*^9, 3.5857288346983566`*^9}, {3.585728874304622*^9, 
   3.585728920231249*^9}, {3.5857289892501965`*^9, 3.5857291668643556`*^9}, {
   3.5857292018953595`*^9, 3.585729251991225*^9}, {3.585730505333912*^9, 
   3.5857309915687227`*^9}, {3.585731023893572*^9, 3.585731237672799*^9}, 
   3.5857312761730013`*^9, {3.585731411926766*^9, 3.5857314192201834`*^9}, {
   3.5857319310944605`*^9, 3.58573193195951*^9}, {3.585732115491008*^9, 
   3.585732179461666*^9}, {3.585732214283658*^9, 3.5857322161957674`*^9}, {
   3.5857322659826155`*^9, 3.585732292247117*^9}, {3.5857324938266473`*^9, 
   3.585732527345564*^9}, {3.5857326079671755`*^9, 3.5857326105933256`*^9}, {
   3.585732658289054*^9, 3.5857328006791983`*^9}, {3.5857328351611705`*^9, 
   3.5857328358512096`*^9}, {3.5857328909733624`*^9, 3.585732939287126*^9}, {
   3.58573618308366*^9, 3.585736189835047*^9}, {3.5857362310784054`*^9, 
   3.5857362533016768`*^9}, {3.5857378637907915`*^9, 
   3.5857378746334114`*^9}, {3.5911510766026883`*^9, 3.591151160273474*^9}, {
   3.591151211815422*^9, 3.5911512320185776`*^9}, {3.5911513247978845`*^9, 
   3.591151326551985*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Save", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5857323019276714`*^9, 3.585732302311693*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mod$SaveMATLAB", "[", "type_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "nv", ",", "np", ",", "ssA", ",", "ssB", ",", "ssC", ",", "ssD", ",", 
       "matFD", ",", "vars", ",", "params", ",", "viscous", ",", "Mvv", ",", 
       "Mpv", ",", "Kvvc", ",", "Kpvc", ",", "Gvv", ",", "Gpv", ",", "input", 
       ",", "output"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Which", "[", 
       RowBox[{
        RowBox[{"type", "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"Table", "[", 
           RowBox[{"n", ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "allvars", "]"}]}], "}"}]}], "]"}]}], 
         ";", 
         RowBox[{"np", "=", 
          RowBox[{"Table", "[", 
           RowBox[{"n", ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"Length", "[", "allparams", "]"}]}], "}"}]}], "]"}]}], 
         ";"}], ",", "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "2"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeZPitch", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeZPitch", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "3"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeXRoll", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeXRoll", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "4"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeY", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeY", "[", "allparams", "]"}]}], ";"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "\[Equal]", "5"}], ",", 
        RowBox[{
         RowBox[{"nv", "=", 
          RowBox[{"mod$TakeYaw", "[", "allvars", "]"}]}], ";", 
         RowBox[{"np", "=", 
          RowBox[{"mod$TakeYaw", "[", "allparams", "]"}]}], ";"}]}], "]"}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"viscous", "=", 
       RowBox[{"temp$viscous", "[", 
        RowBox[{"[", "nv", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vars", "=", 
       RowBox[{"allvars", "[", 
        RowBox[{"[", "nv", "]"}], "]"}]}], ";", 
      RowBox[{"params", "=", 
       RowBox[{"allparams", "[", 
        RowBox[{"[", "np", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Mvv", "=", 
       RowBox[{"matMvv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
      RowBox[{"Mpv", "=", 
       RowBox[{"matMpv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Gvv", "=", 
       RowBox[{"matGvv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
      RowBox[{"Gpv", "=", 
       RowBox[{"matGpv", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Kvvc", "=", 
       RowBox[{"matKvvc", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "nv"}], "]"}], "]"}]}], ";", 
      RowBox[{"Kpvc", "=", 
       RowBox[{"matKpvc", "[", 
        RowBox[{"[", 
         RowBox[{"nv", ",", "np"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"matFD", "=", 
       RowBox[{"DiagonalMatrix", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"1", "/", "2"}], "/", 
            RowBox[{"N", "[", "Pi", "]"}]}], "/", 
           RowBox[{"viscous", "[", 
            RowBox[{"[", "n", "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ssA", "=", "\[IndentingNewLine]", 
       RowBox[{"ArrayFlatten", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"IdentityMatrix", "[", 
             RowBox[{"Length", "[", "params", "]"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"IdentityMatrix", "[", 
             RowBox[{"Length", "[", "vars", "]"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", 
              RowBox[{"Re", "[", "Kpvc", "]"}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", "Gpv"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", 
              RowBox[{"Re", "[", "Kvvc", "]"}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{
               RowBox[{"Inverse", "[", "Mvv", "]"}], ".", "Gvv"}]}], "-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", 
              RowBox[{"Im", "[", "Kvvc", "]"}], ".", "matFD"}]}]}], 
           "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "}"}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"ssB", "=", "\[IndentingNewLine]", 
       RowBox[{"ArrayFlatten", "[", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"IdentityMatrix", "[", 
             RowBox[{"Length", "[", "params", "]"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "params", "]"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Length", "[", "vars", "]"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              RowBox[{"Inverse", "[", "Mvv", "]"}], ".", "Mpv"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Inverse", "[", "Mvv", "]"}]}], "\[IndentingNewLine]", 
           "}"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ssC", "=", 
       RowBox[{"IdentityMatrix", "[", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "params", "]"}], "+", 
           RowBox[{"Length", "[", "vars", "]"}]}], ")"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ssD", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"2", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", "params", "]"}], "+", 
             RowBox[{"Length", "[", "vars", "]"}]}], ")"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", "params", "]"}], "+", 
           RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"input", "=", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<a\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"params", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "params", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<F\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"vars", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"output", "=", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"params", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "params", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<v\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"params", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "params", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"vars", "[", 
             RowBox[{"[", "n", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<v\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"vars", "[", 
              RowBox[{"[", "n", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", 
             RowBox[{"Length", "[", "vars", "]"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"matlabexport", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Directory", "[", "]"}], "<>", "\"\</matlab\>\"", "<>", 
         "sepchar", "<>", "temp$FileName", "<>", "\"\<.m\>\""}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\"\<ssA\>\"", ",", "ssA"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<ssB\>\"", ",", "ssB"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<ssC\>\"", ",", "ssC"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<ssD\>\"", ",", "ssD"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<varinput\>\"", ",", "input"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<varoutput\>\"", ",", "output"}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.585732305660885*^9, 3.5857323281581717`*^9}, {
   3.585733047161296*^9, 3.5857330553987675`*^9}, {3.585733470034483*^9, 
   3.585733597330764*^9}, {3.585733682500635*^9, 3.585733988385131*^9}, {
   3.5857343817776318`*^9, 3.5857344784521613`*^9}, {3.5857345277489805`*^9, 
   3.5857346169760847`*^9}, {3.585734659577521*^9, 3.585734660751588*^9}, {
   3.585734702876998*^9, 3.5857349012343426`*^9}, {3.5857349908504686`*^9, 
   3.585735404451125*^9}, {3.58573555629081*^9, 3.585735629043971*^9}, {
   3.5857358198128824`*^9, 3.5857358241341295`*^9}, {3.585735928775115*^9, 
   3.585735936185539*^9}, {3.5857365359478436`*^9, 3.585736536958901*^9}, {
   3.585737832081978*^9, 3.585737836476229*^9}, {3.5857380851044497`*^9, 
   3.585738087062562*^9}, 3.589153632221701*^9, {3.591265680267161*^9, 
   3.591265691568807*^9}}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1117, 626},
WindowMargins->{{Automatic, 43}, {-16, Automatic}},
ShowSelection->True,
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (2008\:5e7412\:670810\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 208, 7, 105, "Subtitle",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[800, 33, 124, 2, 71, "Section",
 InitializationCell->True],
Cell[927, 37, 336, 6, 31, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1288, 47, 125, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1438, 53, 234, 4, 27, "Subsubsection",
 InitializationCell->True],
Cell[1675, 59, 153193, 3021, 11012, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[154917, 3086, 128, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[155070, 3092, 132, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[155205, 3096, 2085, 44, 312, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[157327, 3145, 183, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[157513, 3150, 4114, 84, 432, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[161676, 3240, 134, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[161835, 3246, 129, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[161967, 3250, 711, 19, 31, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[162715, 3274, 130, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[162848, 3278, 16154, 320, 932, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[179039, 3603, 132, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[179174, 3607, 9585, 196, 532, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[188796, 3808, 184, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[188983, 3813, 1565, 35, 112, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[190609, 3855, 260, 4, 71, "Section",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[190894, 3863, 135, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[191054, 3869, 185, 3, 27, "Subsubsection",
 InitializationCell->True],
Cell[191242, 3874, 13093, 262, 612, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[204384, 4142, 137, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[204546, 4148, 452, 6, 27, "Subsubsection",
 InitializationCell->True],
Cell[205001, 4156, 28356, 588, 1352, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[233406, 4750, 136, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[233567, 4756, 203, 3, 27, "Subsubsection",
 InitializationCell->True],
Cell[233773, 4761, 2544, 70, 252, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[236354, 4836, 135, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[236492, 4840, 23967, 472, 1072, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[260508, 5318, 141, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[260674, 5324, 132, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[260809, 5328, 18632, 378, 832, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[279490, 5712, 183, 3, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[279698, 5719, 132, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[279833, 5723, 6064, 132, 392, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[285958, 5862, 129, 2, 71, "Section",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[286112, 5868, 133, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[286270, 5874, 133, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[286406, 5878, 2026, 46, 189, "Input",
 InitializationCell->True],
Cell[288435, 5926, 505, 10, 91, "Text",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[288977, 5941, 194, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[289174, 5946, 16143, 331, 849, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[305366, 6283, 130, 2, 28, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[305521, 6289, 129, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[305653, 6293, 51890, 1083, 2972, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[357580, 7381, 180, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[357763, 7386, 32760, 728, 1732, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[390560, 8119, 128, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[390691, 8123, 33193, 741, 1732, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[423921, 8869, 141, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[424065, 8873, 5637, 150, 212, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[429739, 9028, 148, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[429890, 9032, 2813, 54, 472, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[432740, 9091, 130, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[432873, 9095, 7792, 186, 472, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[440702, 9286, 327, 5, 21, "Subsubsection",
 InitializationCell->True],
Cell[441032, 9293, 25748, 566, 1212, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[466817, 9864, 201, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[467021, 9869, 27284, 575, 1292, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[494342, 10449, 241, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[494586, 10455, 19512, 457, 972, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[514135, 10917, 151, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[514289, 10921, 288, 8, 31, "Input",
 InitializationCell->True],
Cell[514580, 10931, 512, 16, 31, "Input",
 InitializationCell->True],
Cell[515095, 10949, 2291, 68, 92, "Input",
 InitializationCell->True],
Cell[517389, 11019, 836, 26, 52, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[518274, 11051, 141, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[518440, 11057, 189, 3, 27, "Subsubsection",
 InitializationCell->True],
Cell[518632, 11062, 20809, 427, 912, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[539478, 11494, 180, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[539661, 11499, 19439, 405, 972, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[559137, 11909, 230, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[559370, 11915, 19369, 404, 972, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[578776, 12324, 137, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[578916, 12328, 4503, 111, 332, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[583468, 12445, 195, 3, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[583688, 12452, 243, 4, 27, "Subsubsection",
 InitializationCell->True],
Cell[583934, 12458, 19731, 408, 932, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[603702, 12871, 293, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[603998, 12877, 30633, 655, 1592, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[634668, 13537, 345, 5, 21, "Subsubsection",
 InitializationCell->True],
Cell[635016, 13544, 29704, 633, 1572, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[664757, 14182, 240, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[665000, 14188, 6231, 145, 475, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[671268, 14338, 340, 5, 21, "Subsubsection",
 InitializationCell->True],
Cell[671611, 14345, 5778, 147, 497, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[677426, 14497, 246, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[677675, 14503, 4755, 108, 365, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[682479, 14617, 198, 3, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[682702, 14624, 189, 3, 29, "Subsubsection",
 InitializationCell->True],
Cell[682894, 14629, 20495, 418, 981, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[703426, 15052, 233, 4, 23, "Subsubsection",
 InitializationCell->True],
Cell[703662, 15058, 21355, 445, 1179, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[725054, 15508, 197, 3, 23, "Subsubsection",
 InitializationCell->True],
Cell[725254, 15513, 6922, 164, 541, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[732213, 15682, 311, 4, 23, "Subsubsection",
 InitializationCell->True],
Cell[732527, 15688, 19971, 462, 1223, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[752547, 16156, 137, 2, 28, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[752709, 16162, 224, 4, 27, "Subsubsection",
 InitializationCell->True],
Cell[752936, 16168, 23511, 480, 952, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[776484, 16653, 276, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[776763, 16659, 29210, 590, 1352, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[806010, 17254, 326, 5, 21, "Subsubsection",
 InitializationCell->True],
Cell[806339, 17261, 28696, 578, 1465, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[835072, 17844, 127, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[835202, 17848, 4464, 110, 252, "Input",
 InitializationCell->True],
Cell[839669, 17960, 678, 15, 172, "Input",
 InitializationCell->True],
Cell[840350, 17977, 3437, 82, 212, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[843824, 18064, 183, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[844010, 18069, 9136, 185, 532, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[853195, 18260, 129, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[853349, 18266, 276, 4, 27, "Subsubsection",
 InitializationCell->True],
Cell[853628, 18272, 20203, 403, 915, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[873868, 18680, 331, 5, 21, "Subsubsection",
 InitializationCell->True],
Cell[874202, 18687, 22641, 449, 1069, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[896880, 19141, 382, 6, 21, "Subsubsection",
 InitializationCell->True],
Cell[897265, 19149, 22391, 442, 1069, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[919705, 19597, 285, 4, 28, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[920015, 19605, 187, 3, 27, "Subsubsection",
 InitializationCell->True],
Cell[920205, 19610, 17973, 410, 1572, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[938239, 20027, 134, 2, 71, "Section",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[938398, 20033, 177, 3, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[938600, 20040, 130, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[938733, 20044, 5621, 108, 792, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[944403, 20158, 128, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[944556, 20164, 131, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[944690, 20168, 25191, 616, 2512, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[969930, 20790, 222, 4, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[970177, 20798, 133, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[970313, 20802, 9893, 240, 752, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[980243, 21047, 136, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[980382, 21051, 5414, 133, 372, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[985833, 21189, 133, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[985969, 21193, 7418, 167, 452, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[993424, 21365, 177, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[993604, 21370, 29003, 671, 1392, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1022656, 22047, 137, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1022818, 22053, 189, 3, 27, "Subsubsection",
 InitializationCell->True],
Cell[1023010, 22058, 1804, 39, 172, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1024863, 22103, 122, 2, 28, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1025010, 22109, 134, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[1025147, 22113, 1584, 33, 192, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1026768, 22151, 133, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1026904, 22155, 5111, 120, 612, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1032052, 22280, 128, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1032183, 22284, 1372, 33, 132, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1033616, 22324, 140, 2, 71, "Section",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1033781, 22330, 272, 4, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1034078, 22338, 136, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[1034217, 22342, 1084, 27, 172, "Input",
 InitializationCell->True],
Cell[1035304, 22371, 1672, 44, 192, "Input",
 InitializationCell->True],
Cell[1036979, 22417, 1004, 25, 152, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1038020, 22447, 130, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1038153, 22451, 6796, 184, 312, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1044998, 22641, 127, 2, 28, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1045150, 22647, 229, 4, 27, "Subsubsection",
 InitializationCell->True],
Cell[1045382, 22653, 2449, 54, 292, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1047868, 22712, 177, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[1048048, 22717, 4140, 97, 255, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1052225, 22819, 127, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1052355, 22823, 9886, 213, 772, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1062278, 23041, 128, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1062409, 23045, 7574, 163, 717, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1070020, 23213, 130, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1070153, 23217, 3573, 83, 343, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1073763, 23305, 128, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1073894, 23309, 9137, 192, 612, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1083068, 23506, 189, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[1083260, 23511, 4785, 102, 343, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1088082, 23618, 186, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[1088271, 23623, 5525, 130, 412, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1093845, 23759, 135, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1094005, 23765, 179, 3, 27, "Subsubsection",
 InitializationCell->True],
Cell[1094187, 23770, 11951, 276, 827, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1106175, 24051, 186, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[1106364, 24056, 10489, 225, 792, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1116890, 24286, 237, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1117130, 24292, 4410, 102, 432, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1121577, 24399, 235, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1121815, 24405, 12017, 276, 752, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1133869, 24686, 240, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1134112, 24692, 6923, 155, 585, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1141072, 24852, 282, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1141357, 24858, 4423, 96, 312, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1145817, 24959, 131, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1145951, 24963, 2996, 78, 212, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1148984, 25046, 180, 3, 21, "Subsubsection",
 InitializationCell->True],
Cell[1149167, 25051, 2997, 78, 233, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1152201, 25134, 231, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1152435, 25140, 28272, 588, 1932, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1180744, 25733, 281, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1181028, 25739, 18788, 398, 1512, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1199853, 26142, 281, 4, 21, "Subsubsection",
 InitializationCell->True],
Cell[1200137, 26148, 29972, 628, 1992, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1230146, 26781, 330, 5, 21, "Subsubsection",
 InitializationCell->True],
Cell[1230479, 26788, 9789, 208, 772, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1240305, 27001, 130, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1240438, 27005, 14083, 315, 1252, "Input",
 InitializationCell->True],
Cell[1254524, 27322, 618, 13, 31, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1255203, 27342, 178, 3, 71, "Section",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1255406, 27349, 132, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[1255541, 27353, 1020, 32, 92, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1256610, 27391, 123, 2, 71, "Section",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1256758, 27397, 188, 6, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1256971, 27407, 239, 7, 27, "Subsubsection",
 InitializationCell->True],
Cell[1257213, 27416, 26328, 521, 1452, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1283578, 27942, 131, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1283712, 27946, 2871, 76, 152, "Input",
 InitializationCell->True],
Cell[1286586, 28024, 2918, 76, 152, "Input",
 InitializationCell->True],
Cell[1289507, 28102, 2146, 58, 112, "Input",
 InitializationCell->True],
Cell[1291656, 28162, 2032, 56, 112, "Input",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1293737, 28224, 128, 2, 36, "Subsection",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1293890, 28230, 135, 2, 27, "Subsubsection",
 InitializationCell->True],
Cell[1294028, 28234, 16305, 329, 952, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1310370, 28568, 124, 2, 21, "Subsubsection",
 InitializationCell->True],
Cell[1310497, 28572, 16747, 397, 1752, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
